﻿#EXECUTE THIS FIRST, THEN NEXT SQL: 'db_drops.sql'

SET SQL_MODE = "NO_AUTO_VALUE_ON_ZERO";
SET time_zone = "+00:00";

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;

DROP DATABASE IF EXISTS `cosmic`;
CREATE DATABASE `cosmic` DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci;
USE `cosmic`;

CREATE TABLE IF NOT EXISTS `accounts` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(13) NOT NULL DEFAULT '',
  `password` varchar(128) NOT NULL DEFAULT '',
  `pin` varchar(10) NOT NULL DEFAULT '',
  `pic` varchar(26) NOT NULL DEFAULT '',
  `loggedin` tinyint(4) NOT NULL DEFAULT '0',
  `lastlogin` timestamp NULL DEFAULT NULL,
  `createdat` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `birthday` date NOT NULL DEFAULT '2005-05-11',
  `banned` tinyint(1) NOT NULL DEFAULT '0',
  `banreason` text,
  `macs` tinytext,
  `nxCredit` int(11) DEFAULT NULL,
  `maplePoint` int(11) DEFAULT NULL,
  `nxPrepaid` int(11) DEFAULT NULL,
  `characterslots` tinyint(2) NOT NULL DEFAULT '3',
  `gender` tinyint(2) NOT NULL DEFAULT '10',
  `tempban` timestamp NOT NULL DEFAULT '2005-05-11 00:00:00',
  `greason` tinyint(4) NOT NULL DEFAULT '0',
  `tos` tinyint(1) NOT NULL DEFAULT '0',
  `sitelogged` text,
  `webadmin` int(1) DEFAULT '0',
  `nick` varchar(20) DEFAULT NULL,
  `mute` int(1) DEFAULT '0',
  `email` varchar(45) DEFAULT NULL,
  `ip` text,
  `rewardpoints` int(11) NOT NULL DEFAULT '0',
  `votepoints` int(11) NOT NULL DEFAULT '0',
  `hwid` varchar(12) NOT NULL DEFAULT '',
  `language` int(1) NOT NULL DEFAULT '2',
  PRIMARY KEY (`id`),
  UNIQUE KEY `name` (`name`),
  KEY `ranking1` (`id`,`banned`),
  INDEX (id, name),
  INDEX (id, nxCredit, maplePoint, nxPrepaid)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `alliance` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(13) NOT NULL,
  `capacity` int(10) unsigned NOT NULL DEFAULT '2',
  `notice` varchar(20) NOT NULL DEFAULT '',

  `rank1` varchar(11) NOT NULL DEFAULT 'Master',
  `rank2` varchar(11) NOT NULL DEFAULT 'Jr. Master',
  `rank3` varchar(11) NOT NULL DEFAULT 'Member',
  `rank4` varchar(11) NOT NULL DEFAULT 'Member',
  `rank5` varchar(11) NOT NULL DEFAULT 'Member',
  PRIMARY KEY (`id`),
  INDEX (name)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `allianceguilds` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `allianceid` int(10) NOT NULL DEFAULT '-1',
  `guildid` int(10) NOT NULL DEFAULT '-1',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `area_info` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `charid` int(11) NOT NULL,
  `area` int(11) NOT NULL,
  `info` varchar(200) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `bosslog_daily` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `characterid` int(11) NOT NULL,
  `bosstype` enum('ZAKUM','HORNTAIL','PINKBEAN','SCARGA','PAPULATUS') NOT NULL,
  `attempttime` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `bosslog_weekly` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `characterid` int(11) NOT NULL,
  `bosstype` enum('ZAKUM','HORNTAIL','PINKBEAN','SCARGA','PAPULATUS') NOT NULL,
  `attempttime` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `bbs_replies` (
  `replyid` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `threadid` int(10) unsigned NOT NULL,
  `postercid` int(10) unsigned NOT NULL,
  `timestamp` bigint(20) unsigned NOT NULL,
  `content` varchar(26) NOT NULL DEFAULT '',
  PRIMARY KEY (`replyid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `bbs_threads` (
  `threadid` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `postercid` int(10) unsigned NOT NULL,
  `name` varchar(26) NOT NULL DEFAULT '',
  `timestamp` bigint(20) unsigned NOT NULL,
  `icon` smallint(5) unsigned NOT NULL,
  `replycount` smallint(5) unsigned NOT NULL DEFAULT '0',
  `startpost` text NOT NULL,
  `guildid` int(10) unsigned NOT NULL,
  `localthreadid` int(10) unsigned NOT NULL,
  PRIMARY KEY (`threadid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `buddies` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `characterid` int(11) NOT NULL,
  `buddyid` int(11) NOT NULL,
  `pending` tinyint(4) NOT NULL DEFAULT '0',
  `group` varchar(17) DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `characters` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `accountid` int(11) NOT NULL DEFAULT '0',
  `world` int(11) NOT NULL DEFAULT '0',
  `name` varchar(13) NOT NULL DEFAULT '',
  `level` int(11) NOT NULL DEFAULT '1',
  `exp` int(11) NOT NULL DEFAULT '0',
  `gachaexp` int(11) NOT NULL DEFAULT '0',
  `str` int(11) NOT NULL DEFAULT '12',
  `dex` int(11) NOT NULL DEFAULT '5',
  `luk` int(11) NOT NULL DEFAULT '4',
  `int` int(11) NOT NULL DEFAULT '4',
  `hp` int(11) NOT NULL DEFAULT '50',
  `mp` int(11) NOT NULL DEFAULT '5',
  `maxhp` int(11) NOT NULL DEFAULT '50',
  `maxmp` int(11) NOT NULL DEFAULT '5',
  `meso` int(11) NOT NULL DEFAULT '0',
  `hpMpUsed` int(11) unsigned NOT NULL DEFAULT '0',
  `job` int(11) NOT NULL DEFAULT '0',
  `skincolor` int(11) NOT NULL DEFAULT '0',
  `gender` int(11) NOT NULL DEFAULT '0',
  `fame` int(11) NOT NULL DEFAULT '0',
  `fquest` int(11) NOT NULL DEFAULT '0',
  `hair` int(11) NOT NULL DEFAULT '0',
  `face` int(11) NOT NULL DEFAULT '0',
  `ap` int(11) NOT NULL DEFAULT '0',
  `sp` varchar(128) NOT NULL DEFAULT '0,0,0,0,0,0,0,0,0,0',
  `map` int(11) NOT NULL DEFAULT '0',
  `spawnpoint` int(11) NOT NULL DEFAULT '0',
  `gm` tinyint(1) NOT NULL DEFAULT '0',
  `party` int(11) NOT NULL DEFAULT '0',
  `buddyCapacity` int(11) NOT NULL DEFAULT '25',
  `createdate` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `rank` int(10) unsigned NOT NULL DEFAULT '1',
  `rankMove` int(11) NOT NULL DEFAULT '0',
  `jobRank` int(10) unsigned NOT NULL DEFAULT '1',
  `jobRankMove` int(11) NOT NULL DEFAULT '0',
  `guildid` int(10) unsigned NOT NULL DEFAULT '0',
  `guildrank` int(10) unsigned NOT NULL DEFAULT '5',
  `messengerid` int(10) unsigned NOT NULL DEFAULT '0',
  `messengerposition` int(10) unsigned NOT NULL DEFAULT '4',
  `mountlevel` int(9) NOT NULL DEFAULT '1',
  `mountexp` int(9) NOT NULL DEFAULT '0',
  `mounttiredness` int(9) NOT NULL DEFAULT '0',
  `omokwins` int(11) NOT NULL DEFAULT '0',
  `omoklosses` int(11) NOT NULL DEFAULT '0',
  `omokties` int(11) NOT NULL DEFAULT '0',
  `matchcardwins` int(11) NOT NULL DEFAULT '0',
  `matchcardlosses` int(11) NOT NULL DEFAULT '0',
  `matchcardties` int(11) NOT NULL DEFAULT '0',
  `MerchantMesos` int(11) DEFAULT '0',
  `HasMerchant` tinyint(1) DEFAULT '0',
  `equipslots` int(11) NOT NULL DEFAULT '24',
  `useslots` int(11) NOT NULL DEFAULT '24',
  `setupslots` int(11) NOT NULL DEFAULT '24',
  `etcslots` int(11) NOT NULL DEFAULT '24',
  `familyId` int(11) NOT NULL DEFAULT '-1',
  `monsterbookcover` int(11) NOT NULL DEFAULT '0',
  `allianceRank` int(10) NOT NULL DEFAULT '5',
  `vanquisherStage` int(11) unsigned NOT NULL DEFAULT '0',
  `ariantPoints` int(11) unsigned NOT NULL DEFAULT '0',
  `dojoPoints` int(11) unsigned NOT NULL DEFAULT '0',
  `lastDojoStage` int(10) unsigned NOT NULL DEFAULT '0',
  `finishedDojoTutorial` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `vanquisherKills` int(11) unsigned NOT NULL DEFAULT '0',
  `summonValue` int(11) unsigned NOT NULL DEFAULT '0',
  `partnerId` int(11) NOT NULL DEFAULT '0',
  `marriageItemId` int(11) NOT NULL DEFAULT '0',
  `reborns` int(5) NOT NULL DEFAULT '0',
  `PQPoints` int(11) NOT NULL DEFAULT '0',
  `dataString` varchar(64) NOT NULL DEFAULT '',
  `lastLogoutTime` timestamp NOT NULL DEFAULT '2015-01-01 05:00:00',
  `lastExpGainTime` timestamp NOT NULL DEFAULT '2015-01-01 05:00:00',
  `partySearch` tinyint(1) NOT NULL DEFAULT '1',
  `jailexpire` bigint(20) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `accountid` (`accountid`),
  KEY `party` (`party`),
  KEY `ranking1` (`level`,`exp`),
  KEY `ranking2` (`gm`,`job`),
  INDEX (id, accountid, world),
  INDEX (id, accountid, name)
) ENGINE=InnoDB  DEFAULT CHARSET=latin1 PACK_KEYS=0 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `cooldowns` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `charid` int(11) NOT NULL,
  `SkillID` int(11) NOT NULL,
  `length` bigint(20) unsigned NOT NULL,
  `StartTime` bigint(20) unsigned NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `temp_data` (
  `dropperid` int(11) NOT NULL,
  `itemid` int(11) NOT NULL DEFAULT '0',
  `minimum_quantity` int(11) NOT NULL DEFAULT '1',
  `maximum_quantity` int(11) NOT NULL DEFAULT '1',
  `questid` int(11) NOT NULL DEFAULT '0',
  `chance` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`dropperid`, `itemid`),
  KEY `mobid` (`dropperid`)
) ENGINE=InnoDB  DEFAULT CHARSET=latin1 AUTO_INCREMENT=0 ;

INSERT IGNORE INTO `temp_data` (`dropperid`, `itemid`, `minimum_quantity`, `maximum_quantity`, `questid`, `chance`) VALUES
(9400121, 4000138, 1, 1, 0, 600000),
(9400121, 4010006, 1, 1, 0, 45000),
(9400121, 2000006, 1, 1, 0, 999999),
(9400121, 2000011, 1, 1, 0, 100000),
(9400121, 2020016, 1, 1, 0, 100000),
(9400121, 2022024, 1, 1, 0, 100000),
(9400121, 2022026, 1, 1, 0, 100000),
(9400121, 2043705, 1, 1, 0, 1500),
(9400121, 2040716, 1, 1, 0, 1500),
(9400121, 2040908, 1, 1, 0, 1500),
(9400121, 2040510, 1, 1, 0, 1500),
(9400121, 1072239, 1, 1, 0, 4000),
(9400121, 1422013, 1, 1, 0, 3500),
(9400121, 1402016, 1, 1, 0, 3500),
(9400121, 1442020, 1, 1, 0, 3500),
(9400121, 1432011, 1, 1, 0, 2500),
(9400121, 1332022, 1, 1, 0, 2500),
(9400121, 1312015, 1, 1, 0, 3500),
(9400121, 1382010, 1, 1, 0, 3500),
(9400121, 1372009, 1, 1, 0, 3500),
(9400121, 1082085, 1, 1, 0, 5000),
(9400121, 1332022, 1, 1, 0, 2500),
(9400121, 1472033, 1, 1, 0, 2500),
(8810018, 4001094, 1, 1, 0, 999999),
(8810018, 2290125, 1, 1, 0, 100000),
(8800002, 1372049, 1, 1, 0, 999999),
(9400013, 4000225, 1, 1, 0, 600000),
(9400013, 2000006, 1, 1, 0, 20000),
(9400013, 2000004, 1, 1, 0, 20000),
(9400013, 2070013, 1, 1, 0, 1500),
(9400013, 2002005, 1, 1, 0, 20000),
(9400013, 2022018, 1, 1, 0, 20000),
(9400013, 2040306, 1, 1, 0, 300),
(9400013, 2043704, 1, 1, 0, 300),
(9400013, 2044605, 1, 1, 0, 300),
(9400013, 2041034, 1, 1, 0, 300),
(9400013, 1032019, 1, 1, 0, 1000),
(9400013, 1102013, 1, 1, 0, 1000),
(9400013, 1322026, 1, 1, 0, 700),
(9400013, 1092015, 1, 1, 0, 700),
(9400013, 1382016, 1, 1, 0, 700),
(9400013, 1002276, 1, 1, 0, 1500),
(9400013, 1002403, 1, 1, 0, 1500),
(9400013, 1472027, 1, 1, 0, 500),
(9400113, 4000140, 1, 1, 0, 600000),
(9400113, 2022027, 1, 1, 0, 200000),
(9400113, 2022027, 1, 1, 0, 200000),
(9400113, 2000004, 1, 1, 0, 999999),
(9400113, 2000004, 1, 1, 0, 999999),
(9400113, 2002008, 1, 1, 0, 200000),
(9400113, 2002008, 1, 1, 0, 200000),
(9400300, 4000141, 1, 1, 0, 600000),
(9400300, 2000004, 1, 1, 0, 999999),
(9400300, 2040813, 1, 1, 0, 3000),
(9400300, 2041030, 1, 1, 0, 3000),
(9400300, 2041040, 1, 1, 0, 3000),
(9400300, 1072238, 1, 1, 0, 8000),
(9400300, 1032026, 1, 1, 0, 10000),
(9400300, 1372011, 1, 1, 0, 7000),
(9400112, 4000139, 1, 1, 0, 600000),
(9400112, 2002011, 1, 1, 0, 200000),
(9400112, 2002011, 1, 1, 0, 200000),
(9400112, 2002011, 1, 1, 0, 200000),
(9400112, 2000004, 1, 1, 0, 999999),
(9400112, 2000004, 1, 1, 0, 999999),
(9400545, 4032024, 1, 1, 0, 50000),
(9400545, 4032025, 1, 1, 0, 600000),
(9400545, 4020006, 1, 1, 0, 9000),
(9400545, 4020008, 1, 1, 0, 9000),
(9400545, 4010001, 1, 1, 0, 9000),
(9400545, 4004001, 1, 1, 0, 10000),
(9400545, 2070006, 1, 1, 0, 200),
(9400545, 2044404, 1, 1, 0, 300),
(9400545, 2044702, 1, 1, 0, 300),
(9400545, 2044305, 1, 1, 0, 300),
(9400545, 1102029, 1, 1, 0, 1000),
(9400545, 1032023, 1, 1, 0, 1000),
(9400545, 1402004, 1, 1, 0, 700),
(9400545, 1072210, 1, 1, 0, 800),
(9400545, 1040104, 1, 1, 0, 800),
(9400545, 1060092, 1, 1, 0, 800),
(9400545, 1082129, 1, 1, 0, 1000),
(9400545, 1442008, 1, 1, 0, 700),
(9400545, 1072178, 1, 1, 0, 800),
(9400545, 1050092, 1, 1, 0, 700),
(9400545, 1002271, 1, 1, 0, 1500),
(9400545, 1051053, 1, 1, 0, 700),
(9400545, 1382008, 1, 1, 0, 700),
(9400545, 1002275, 1, 1, 0, 1500),
(9400545, 1051082, 1, 1, 0, 700),
(9400545, 1050064, 1, 1, 0, 700),
(9400545, 1472028, 1, 1, 0, 500),
(9400545, 1072193, 1, 1, 0, 800),
(9400545, 1072172, 1, 1, 0, 800),
(9400545, 1002285, 1, 1, 0, 1500),
(100100, 4000019, 1, 1, 0, 600000),
(100100, 2000000, 1, 1, 0, 20000),
(100100, 2040002, 1, 1, 0, 300),
(100100, 2041001, 1, 1, 0, 300),
(100100, 2060000, 1, 1, 0, 30000),
(100100, 4010000, 1, 1, 0, 9000),
(100100, 4020000, 1, 1, 0, 9000),
(100100, 2061000, 1, 1, 0, 30000),
(100100, 1002067, 1, 1, 0, 1500),
(100100, 2010009, 1, 1, 0, 20000),
(100101, 4000000, 1, 1, 0, 600000),
(100101, 2041006, 1, 1, 0, 300),
(100101, 2000000, 1, 1, 0, 20000),
(100101, 4020001, 1, 1, 0, 9000),
(100101, 2060000, 1, 1, 0, 30000),
(100101, 4010001, 1, 1, 0, 9000),
(100101, 2061000, 1, 1, 0, 30000),
(100101, 1040013, 1, 1, 0, 800),
(100101, 1041012, 1, 1, 0, 800),
(100101, 1060004, 1, 1, 0, 800),
(100101, 1040017, 1, 1, 0, 800),
(100101, 1060013, 1, 1, 0, 800),
(100101, 2010009, 1, 1, 0, 20000),
(1110100, 4000012, 1, 1, 0, 600000),
(1110100, 2000000, 1, 1, 0, 20000),
(1110100, 2043102, 1, 1, 0, 300),
(1110100, 2000003, 1, 1, 0, 20000),
(1110100, 4020003, 1, 1, 0, 9000),
(1110100, 1322000, 1, 1, 0, 700),
(1110100, 2060000, 1, 1, 0, 30000),
(1110100, 1041044, 1, 1, 0, 800),
(1110100, 1061037, 1, 1, 0, 800),
(1110100, 4010004, 1, 1, 0, 9000),
(1110100, 1092008, 1, 1, 0, 700),
(1110100, 1041017, 1, 1, 0, 800),
(1110100, 1061012, 1, 1, 0, 800),
(1110100, 1462002, 1, 1, 0, 500),
(1110100, 2061000, 1, 1, 0, 30000),
(1110100, 1041063, 1, 1, 0, 800),
(1110100, 1061059, 1, 1, 0, 800),
(1110100, 1452003, 1, 1, 0, 500),
(1110100, 2048000, 1, 1, 0, 300),
(1110100, 1002033, 1, 1, 0, 1500),
(1110100, 1302007, 1, 1, 0, 700),
(1110100, 4020002, 1, 1, 0, 9000),
(1110100, 1032001, 1, 1, 0, 1000),
(1110100, 1002010, 1, 1, 0, 1500),
(1110100, 2000001, 1, 1, 0, 20000),
(1110100, 1002143, 1, 1, 0, 1500),
(1110100, 1432005, 1, 1, 0, 500),
(1110100, 1412012, 1, 1, 0, 700),
(1110100, 1072285, 1, 1, 0, 800),
(1110100, 1482001, 1, 1, 0, 500),
(1110101, 4000005, 1, 1, 0, 600000),
(1110101, 2000000, 1, 1, 0, 20000),
(1110101, 2040802, 1, 1, 0, 300),
(1110101, 1092003, 1, 1, 0, 700),
(1110101, 1002039, 1, 1, 0, 1500),
(1110101, 1442000, 1, 1, 0, 700),
(1110101, 1041061, 1, 1, 0, 800),
(1110101, 1061057, 1, 1, 0, 800),
(1110101, 1041018, 1, 1, 0, 800),
(1110101, 1061013, 1, 1, 0, 800),
(1110101, 2060000, 1, 1, 0, 30000),
(1110101, 4010001, 1, 1, 0, 9000),
(1110101, 4020000, 1, 1, 0, 9000),
(1110101, 2061000, 1, 1, 0, 30000),
(1110101, 1032001, 1, 1, 0, 1000),
(1110101, 1382000, 1, 1, 0, 700),
(1110101, 1302006, 1, 1, 0, 700),
(1110101, 2000001, 1, 1, 0, 20000),
(1110101, 2000003, 1, 1, 0, 20000),
(1110101, 1482000, 1, 1, 0, 500),
(1110101, 1002613, 1, 1, 0, 1500),
(1120100, 4000006, 1, 1, 0, 600000),
(1120100, 2000000, 1, 1, 0, 20000),
(1120100, 2043002, 1, 1, 0, 300),
(1120100, 1032001, 1, 1, 0, 1000),
(1120100, 1422000, 1, 1, 0, 700),
(1120100, 1092000, 1, 1, 0, 700),
(1120100, 2060000, 1, 1, 0, 30000),
(1120100, 4010003, 1, 1, 0, 9000),
(1120100, 4020002, 1, 1, 0, 9000),
(1120100, 2000003, 1, 1, 0, 20000),
(1120100, 1041026, 1, 1, 0, 800),
(1120100, 1061022, 1, 1, 0, 800),
(1120100, 2061000, 1, 1, 0, 30000),
(1120100, 1040037, 1, 1, 0, 800),
(1120100, 1060027, 1, 1, 0, 800),
(1120100, 1482001, 1, 1, 0, 500),
(1130100, 4000018, 1, 1, 0, 600000),
(1130100, 2000000, 1, 1, 0, 20000),
(1130100, 2043202, 1, 1, 0, 300),
(1130100, 1372001, 1, 1, 0, 700),
(1130100, 2000003, 1, 1, 0, 20000),
(1130100, 1072008, 1, 1, 0, 800),
(1130100, 2060000, 1, 1, 0, 30000),
(1130100, 4010005, 1, 1, 0, 9000),
(1130100, 4020004, 1, 1, 0, 9000),
(1130100, 1312016, 1, 1, 0, 700),
(1130100, 1402001, 1, 1, 0, 700),
(1130100, 1032003, 1, 1, 0, 1000),
(1130100, 1092007, 1, 1, 0, 700),
(1130100, 1040019, 1, 1, 0, 800),
(1130100, 1060015, 1, 1, 0, 800),
(1130100, 1041045, 1, 1, 0, 800),
(1130100, 1061038, 1, 1, 0, 800),
(1130100, 2061000, 1, 1, 0, 30000),
(1130100, 1002118, 1, 1, 0, 1500),
(1130100, 1382004, 1, 1, 0, 700),
(1130100, 1402009, 1, 1, 0, 700),
(1130100, 1492001, 1, 1, 0, 500),
(1140100, 2000000, 1, 1, 0, 20000),
(1140100, 2000003, 1, 1, 0, 20000),
(1140100, 4000195, 1, 1, 0, 600000),
(1140100, 2060000, 1, 1, 0, 30000),
(1140100, 2061000, 1, 1, 0, 30000),
(1140100, 4010000, 1, 1, 0, 9000),
(1140100, 4020007, 1, 1, 0, 9000),
(1140100, 4010004, 1, 1, 0, 9000),
(1140100, 2040501, 1, 1, 0, 300),
(1140100, 2040801, 1, 1, 0, 300),
(1140100, 1041062, 1, 1, 0, 800),
(1140100, 1061058, 1, 1, 0, 800),
(1140100, 1050010, 1, 1, 0, 700),
(1140100, 2048001, 1, 1, 0, 300),
(1140100, 1041029, 1, 1, 0, 800),
(1140100, 1061027, 1, 1, 0, 800),
(1140100, 1072046, 1, 1, 0, 800),
(1140100, 1072066, 1, 1, 0, 800),
(1140100, 1082018, 1, 1, 0, 1000),
(1140100, 1002107, 1, 1, 0, 1500),
(1140100, 1002113, 1, 1, 0, 1500),
(1140100, 1050003, 1, 1, 0, 700),
(1140100, 1412012, 1, 1, 0, 700),
(1140100, 1082180, 1, 1, 0, 1000),
(1140100, 2044802, 1, 1, 0, 300),
(120100, 4000011, 1, 1, 0, 600000),
(120100, 2041007, 1, 1, 0, 300),
(120100, 2000000, 1, 1, 0, 20000),
(120100, 4020002, 1, 1, 0, 9000),
(120100, 4010002, 1, 1, 0, 9000),
(120100, 2060000, 1, 1, 0, 30000),
(120100, 1332006, 1, 1, 0, 500),
(120100, 2061000, 1, 1, 0, 30000),
(120100, 1062000, 1, 1, 0, 800),
(120100, 1060007, 1, 1, 0, 800),
(120100, 1061009, 1, 1, 0, 800),
(120100, 2010009, 1, 1, 0, 20000),
(120100, 1002610, 1, 1, 0, 1500),
(1210100, 4000017, 1, 1, 0, 40000),
(1210100, 2041021, 1, 1, 0, 300),
(1210100, 2000000, 1, 1, 0, 20000),
(1210100, 2040702, 1, 1, 0, 300),
(1210100, 1002008, 1, 1, 0, 1500),
(1210100, 1062002, 1, 1, 0, 800),
(1210100, 1422000, 1, 1, 0, 700),
(1210100, 2060000, 1, 1, 0, 30000),
(1210100, 4010006, 1, 1, 0, 9000),
(1210100, 4020006, 1, 1, 0, 9000),
(1210100, 1472000, 1, 1, 0, 500),
(1210100, 4000021, 1, 1, 0, 50000),
(1210100, 2061000, 1, 1, 0, 30000),
(1210100, 1061028, 1, 1, 0, 800),
(1210100, 1041014, 1, 1, 0, 800),
(1210100, 1040034, 1, 1, 0, 800),
(1210100, 2010009, 1, 1, 0, 20000),
(1210100, 1002610, 1, 1, 0, 1500),
(1210101, 4000002, 1, 1, 0, 600000),
(1210101, 2000000, 1, 1, 0, 20000),
(1210101, 4003004, 1, 1, 0, 200000),
(1210101, 2040902, 1, 1, 0, 300),
(1210101, 1040011, 1, 1, 0, 800),
(1210101, 1040034, 1, 1, 0, 800),
(1210101, 1060024, 1, 1, 0, 800),
(1210101, 2060000, 1, 1, 0, 30000),
(1210101, 4010002, 1, 1, 0, 9000),
(1210101, 4020001, 1, 1, 0, 9000),
(1210101, 4000021, 1, 1, 0, 50000),
(1210101, 2061000, 1, 1, 0, 30000),
(1210101, 1402018, 1, 1, 0, 700),
(1210101, 1032003, 1, 1, 0, 1000),
(1210101, 1041012, 1, 1, 0, 800),
(1210101, 1040014, 1, 1, 0, 800),
(1210101, 1492000, 1, 1, 0, 500),
(1210101, 1052098, 1, 1, 0, 700),
(1210101, 1072285, 1, 1, 0, 800),
(1210102, 4000001, 1, 1, 0, 600000),
(1210102, 2000000, 1, 1, 0, 20000),
(1210102, 2040705, 1, 1, 0, 300),
(1210102, 1072004, 1, 1, 0, 800),
(1210102, 1002043, 1, 1, 0, 1500),
(1210102, 1432000, 1, 1, 0, 500),
(1210102, 1312000, 1, 1, 0, 700),
(1210102, 2060000, 1, 1, 0, 30000),
(1210102, 4010000, 1, 1, 0, 9000),
(1210102, 4020007, 1, 1, 0, 9000),
(1210102, 2061000, 1, 1, 0, 30000),
(1210102, 1082012, 1, 1, 0, 1000),
(1210102, 1072015, 1, 1, 0, 800),
(1210102, 1072031, 1, 1, 0, 800),
(1210102, 1052095, 1, 1, 0, 700),
(1210102, 2330000, 1, 1, 0, 500),
(1210103, 2000000, 1, 1, 0, 20000),
(1210103, 2041015, 1, 1, 0, 300),
(1210103, 2043302, 1, 1, 0, 300),
(1210103, 2041004, 1, 1, 0, 300),
(1210103, 2000003, 1, 1, 0, 20000),
(1210103, 4020005, 1, 1, 0, 9000),
(1210103, 4010002, 1, 1, 0, 9000),
(1210103, 2060000, 1, 1, 0, 30000),
(1210103, 2061000, 1, 1, 0, 30000),
(1210103, 4000037, 1, 1, 0, 600000),
(1210103, 1002075, 1, 1, 0, 1500),
(1210103, 1432000, 1, 1, 0, 500),
(1210103, 1040035, 1, 1, 0, 800),
(1210103, 1060025, 1, 1, 0, 800),
(1210103, 1041062, 1, 1, 0, 800),
(1210103, 1061058, 1, 1, 0, 800),
(1210103, 1402018, 1, 1, 0, 700),
(1210103, 1072019, 1, 1, 0, 800),
(1210103, 1432008, 1, 1, 0, 500),
(1210103, 4006000, 1, 1, 0, 10000),
(1210103, 2048001, 1, 1, 0, 300),
(1210103, 1412012, 1, 1, 0, 700),
(1210103, 1082180, 1, 1, 0, 1000),
(1210103, 1492001, 1, 1, 0, 500),
(1210103, 2330000, 1, 1, 0, 500),
(130100, 4000003, 1, 1, 0, 600000),
(130100, 2041008, 1, 1, 0, 300),
(130100, 2000000, 1, 1, 0, 20000),
(130100, 2040402, 1, 1, 0, 300),
(130100, 4020003, 1, 1, 0, 9000),
(130100, 2060000, 1, 1, 0, 30000),
(130100, 4010003, 1, 1, 0, 9000),
(130100, 1332000, 1, 1, 0, 500),
(130100, 2061000, 1, 1, 0, 30000),
(130100, 1072007, 1, 1, 0, 800),
(130100, 1082003, 1, 1, 0, 1000),
(130100, 1452003, 1, 1, 0, 500),
(130100, 2010009, 1, 1, 0, 20000),
(130100, 1061014, 1, 1, 0, 800),
(130100, 1492000, 1, 1, 0, 500),
(130101, 4000016, 1, 1, 0, 600000),
(130101, 2041009, 1, 1, 0, 300),
(130101, 2000000, 1, 1, 0, 20000),
(130101, 2040502, 1, 1, 0, 300),
(130101, 1402001, 1, 1, 0, 700),
(130101, 1322007, 1, 1, 0, 700),
(130101, 2060000, 1, 1, 0, 30000),
(130101, 4010004, 1, 1, 0, 9000),
(130101, 4020004, 1, 1, 0, 9000),
(130101, 2061000, 1, 1, 0, 30000),
(130101, 1372002, 1, 1, 0, 700),
(130101, 1082029, 1, 1, 0, 1000),
(130101, 1072060, 1, 1, 0, 800),
(130101, 1032003, 1, 1, 0, 1000),
(130101, 1061029, 1, 1, 0, 800),
(130101, 2010009, 1, 1, 0, 20000),
(130101, 1052095, 1, 1, 0, 700),
(2100100, 2000001, 1, 1, 0, 20000),
(2100100, 2000003, 1, 1, 0, 20000),
(2100100, 2060000, 1, 1, 0, 30000),
(2100100, 2061000, 1, 1, 0, 30000),
(2100100, 4000324, 1, 1, 0, 600000),
(2100100, 4020006, 1, 1, 0, 9000),
(2100100, 4010001, 1, 1, 0, 9000),
(2100100, 2040601, 1, 1, 0, 300),
(2100100, 1382002, 1, 1, 0, 700),
(2100100, 1002119, 1, 1, 0, 1500),
(2100100, 1332010, 1, 1, 0, 500),
(2100100, 1050025, 1, 1, 0, 700),
(2100100, 1082002, 1, 1, 0, 1000),
(2100100, 1072007, 1, 1, 0, 800),
(2100100, 1032009, 1, 1, 0, 1000),
(2100100, 1050005, 1, 1, 0, 700),
(2100100, 4003004, 1, 1, 0, 200000),
(2100100, 4010007, 1, 1, 0, 9000),
(2100100, 1072288, 1, 1, 0, 800),
(2100100, 2040420, 1, 1, 0, 300),
(2100100, 2049000, 1, 1, 0, 150),
(2100101, 2000001, 1, 1, 0, 20000),
(2100101, 2000003, 1, 1, 0, 20000),
(2100101, 2060000, 1, 1, 0, 30000),
(2100101, 2061000, 1, 1, 0, 30000),
(2100101, 4000325, 1, 1, 0, 600000),
(2100101, 2002002, 1, 1, 0, 20000),
(2100101, 4010006, 1, 1, 0, 9000),
(2100101, 4020001, 1, 1, 0, 9000),
(2100101, 2044602, 1, 1, 0, 300),
(2100101, 1092021, 1, 1, 0, 700),
(2100101, 1472006, 1, 1, 0, 500),
(2100101, 1060017, 1, 1, 0, 800),
(2100101, 1061028, 1, 1, 0, 800),
(2100101, 1002129, 1, 1, 0, 1500),
(2100101, 1041027, 1, 1, 0, 800),
(2100101, 1061025, 1, 1, 0, 800),
(2100101, 4003004, 1, 1, 0, 200000),
(2100101, 4010007, 1, 1, 0, 9000),
(2100101, 1082183, 1, 1, 0, 1000),
(2100101, 2044210, 1, 1, 0, 300),
(2100102, 2000001, 1, 1, 0, 20000),
(2100102, 2000003, 1, 1, 0, 20000),
(2100102, 2060000, 1, 1, 0, 30000),
(2100102, 2061000, 1, 1, 0, 30000),
(2100102, 4000329, 1, 1, 0, 600000),
(2100102, 4010002, 1, 1, 0, 9000),
(2100102, 4020004, 1, 1, 0, 9000),
(2100102, 2040705, 1, 1, 0, 300),
(2100102, 2044102, 1, 1, 0, 300),
(2100102, 1051004, 1, 1, 0, 700),
(2100102, 1050024, 1, 1, 0, 700),
(2100102, 1032006, 1, 1, 0, 1000),
(2100102, 1002048, 1, 1, 0, 1500),
(2100102, 1072027, 1, 1, 0, 800),
(2100102, 1040044, 1, 1, 0, 800),
(2100102, 1060033, 1, 1, 0, 800),
(2100102, 1462003, 1, 1, 0, 500),
(2100102, 2022155, 1, 1, 0, 20000),
(2100102, 4010007, 1, 1, 0, 9000),
(2100102, 1082183, 1, 1, 0, 1000),
(2100102, 1082186, 1, 1, 0, 1000),
(2100102, 2044901, 1, 1, 0, 300),
(2100102, 2043212, 1, 1, 0, 300),
(2100103, 2000001, 1, 1, 0, 20000),
(2100103, 2000003, 1, 1, 0, 20000),
(2100103, 2060000, 1, 1, 0, 30000),
(2100103, 2061000, 1, 1, 0, 30000),
(2100103, 4000330, 1, 1, 0, 600000),
(2100103, 4010003, 1, 1, 0, 9000),
(2100103, 4020004, 1, 1, 0, 9000),
(2100103, 2040501, 1, 1, 0, 300),
(2100103, 1322009, 1, 1, 0, 700),
(2100103, 1092002, 1, 1, 0, 700),
(2100103, 1432002, 1, 1, 0, 500),
(2100103, 1072054, 1, 1, 0, 800),
(2100103, 1082016, 1, 1, 0, 1000),
(2100103, 1072078, 1, 1, 0, 800),
(2100103, 1061054, 1, 1, 0, 800),
(2100103, 1041058, 1, 1, 0, 800),
(2100103, 1002096, 1, 1, 0, 1500),
(2100103, 1050011, 1, 1, 0, 700),
(2100103, 2022155, 1, 1, 0, 20000),
(2100103, 4010007, 1, 1, 0, 9000),
(2100103, 1072291, 1, 1, 0, 800),
(2100103, 2044314, 1, 1, 0, 300),
(2100104, 2000001, 1, 1, 0, 20000),
(2100104, 2000003, 1, 1, 0, 20000),
(2100104, 2060000, 1, 1, 0, 30000),
(2100104, 2061000, 1, 1, 0, 30000),
(2100104, 4000331, 1, 1, 0, 600000),
(2100104, 2002003, 1, 1, 0, 20000),
(2100104, 4020006, 1, 1, 0, 9000),
(2100104, 4020005, 1, 1, 0, 9000),
(2100104, 4004001, 1, 1, 0, 10000),
(2100104, 2041002, 1, 1, 0, 300),
(2100104, 1442001, 1, 1, 0, 700),
(2100104, 1322003, 1, 1, 0, 700),
(2100104, 1092019, 1, 1, 0, 700),
(2100104, 1072087, 1, 1, 0, 800),
(2100104, 1040068, 1, 1, 0, 800),
(2100104, 1060057, 1, 1, 0, 800),
(2100104, 1082052, 1, 1, 0, 1000),
(2100104, 1002004, 1, 1, 0, 1500),
(2100104, 2022155, 1, 1, 0, 20000),
(2100104, 4010007, 1, 1, 0, 9000),
(2100104, 1082186, 1, 1, 0, 1000),
(2100104, 2043214, 1, 1, 0, 300),
(2100105, 2000001, 1, 1, 0, 20000),
(2100105, 2000003, 1, 1, 0, 20000),
(2100105, 2060000, 1, 1, 0, 30000),
(2100105, 2061000, 1, 1, 0, 30000),
(2100105, 4000328, 1, 1, 0, 600000),
(2100105, 4010004, 1, 1, 0, 9000),
(2100105, 4006001, 1, 1, 0, 10000),
(2100105, 2040902, 1, 1, 0, 300),
(2100105, 2044002, 1, 1, 0, 300),
(2100105, 1452003, 1, 1, 0, 500),
(2100105, 1302006, 1, 1, 0, 700),
(2100105, 1372004, 1, 1, 0, 700),
(2100105, 1002013, 1, 1, 0, 1500),
(2100105, 1072086, 1, 1, 0, 800),
(2100105, 1002119, 1, 1, 0, 1500),
(2100105, 1072007, 1, 1, 0, 800),
(2100105, 1082020, 1, 1, 0, 1000),
(2100105, 4010007, 1, 1, 0, 9000),
(2100105, 1052101, 1, 1, 0, 700),
(2100105, 1482003, 1, 1, 0, 500),
(2100105, 2330000, 1, 1, 0, 500),
(2100105, 2040316, 1, 1, 0, 300),
(2100105, 2040319, 1, 1, 0, 300),
(2100105, 2044412, 1, 1, 0, 300),
(2100106, 2000001, 1, 1, 0, 20000),
(2100106, 2000003, 1, 1, 0, 20000),
(2100106, 2060000, 1, 1, 0, 30000),
(2100106, 2061000, 1, 1, 0, 30000),
(2100106, 4000326, 1, 1, 0, 600000),
(2100106, 2002004, 1, 1, 0, 20000),
(2100106, 4020007, 1, 1, 0, 9000),
(2100106, 4020000, 1, 1, 0, 9000),
(2100106, 2044501, 1, 1, 0, 300),
(2100106, 1402002, 1, 1, 0, 700),
(2100106, 1032004, 1, 1, 0, 1000),
(2100106, 1050001, 1, 1, 0, 700),
(2100106, 1002055, 1, 1, 0, 1500),
(2100106, 1040049, 1, 1, 0, 800),
(2100106, 1060037, 1, 1, 0, 800),
(2100106, 1082068, 1, 1, 0, 1000),
(2100106, 1432001, 1, 1, 0, 500),
(2100106, 4010007, 1, 1, 0, 9000),
(2100106, 1492002, 1, 1, 0, 500),
(2100106, 2330000, 1, 1, 0, 500),
(2100106, 2040926, 1, 1, 0, 300),
(2100107, 2000001, 1, 1, 0, 20000),
(2100107, 2000003, 1, 1, 0, 20000),
(2100107, 2060000, 1, 1, 0, 30000),
(2100107, 2061000, 1, 1, 0, 30000),
(2100107, 4000327, 1, 1, 0, 600000),
(2100107, 4020003, 1, 1, 0, 9000),
(2100107, 4020002, 1, 1, 0, 9000),
(2100107, 2048001, 1, 1, 0, 300),
(2100107, 2070002, 1, 1, 0, 500),
(2100107, 1332004, 1, 1, 0, 500),
(2100107, 1382017, 1, 1, 0, 700),
(2100107, 1041054, 1, 1, 0, 800),
(2100107, 1061050, 1, 1, 0, 800),
(2100107, 1002141, 1, 1, 0, 1500),
(2100107, 1051011, 1, 1, 0, 700),
(2100107, 1040059, 1, 1, 0, 800),
(2100107, 1060045, 1, 1, 0, 800),
(2100107, 4010007, 1, 1, 0, 9000),
(2100107, 1492003, 1, 1, 0, 500),
(2100108, 2000001, 1, 1, 0, 20000),
(2100108, 2000003, 1, 1, 0, 20000),
(2100108, 2060000, 1, 1, 0, 30000),
(2100108, 2061000, 1, 1, 0, 30000),
(2100108, 4000333, 1, 1, 0, 600000),
(2100108, 2002005, 1, 1, 0, 20000),
(2100108, 4010002, 1, 1, 0, 9000),
(2100108, 4010001, 1, 1, 0, 9000),
(2100108, 4004002, 1, 1, 0, 10000),
(2100108, 2043002, 1, 1, 0, 300),
(2100108, 2043701, 1, 1, 0, 300),
(2100108, 1332009, 1, 1, 0, 500),
(2100108, 1412004, 1, 1, 0, 700),
(2100108, 1040062, 1, 1, 0, 800),
(2100108, 1060051, 1, 1, 0, 800),
(2100108, 1050029, 1, 1, 0, 700),
(2100108, 1002164, 1, 1, 0, 1500),
(2100108, 1082005, 1, 1, 0, 1000),
(2100108, 4003004, 1, 1, 0, 200000),
(2100108, 4010007, 1, 1, 0, 9000),
(2100108, 1482003, 1, 1, 0, 500),
(2100108, 2044801, 1, 1, 0, 300),
(2100108, 2044014, 1, 1, 0, 300),
(2100108, 2044214, 1, 1, 0, 300),
(210100, 4000004, 1, 1, 0, 600000),
(210100, 2041018, 1, 1, 0, 300),
(210100, 4000010, 1, 1, 0, 600000),
(210100, 2000000, 1, 1, 0, 20000),
(210100, 2040602, 1, 1, 0, 300),
(210100, 1002019, 1, 1, 0, 1500),
(210100, 1412001, 1, 1, 0, 700),
(210100, 2060000, 1, 1, 0, 30000),
(210100, 4010005, 1, 1, 0, 9000),
(210100, 4020005, 1, 1, 0, 9000),
(210100, 2061000, 1, 1, 0, 30000),
(210100, 1432001, 1, 1, 0, 500),
(210100, 1082019, 1, 1, 0, 1000),
(210100, 1072023, 1, 1, 0, 800),
(210100, 1322007, 1, 1, 0, 700),
(210100, 1412012, 1, 1, 0, 700),
(210100, 2010009, 1, 1, 0, 20000),
(210100, 1482000, 1, 1, 0, 500),
(2110200, 4000015, 1, 1, 0, 600000),
(2110200, 2000001, 1, 1, 0, 20000),
(2110200, 2002003, 1, 1, 0, 20000),
(2110200, 2044102, 1, 1, 0, 300),
(2110200, 1002005, 1, 1, 0, 1500),
(2110200, 1041008, 1, 1, 0, 800),
(2110200, 1061006, 1, 1, 0, 800),
(2110200, 1072073, 1, 1, 0, 800),
(2110200, 1050006, 1, 1, 0, 700),
(2110200, 2060000, 1, 1, 0, 30000),
(2110200, 4010000, 1, 1, 0, 9000),
(2110200, 4020006, 1, 1, 0, 9000),
(2110200, 2000003, 1, 1, 0, 20000),
(2110200, 1462004, 1, 1, 0, 500),
(2110200, 1040044, 1, 1, 0, 800),
(2110200, 1060033, 1, 1, 0, 800),
(2110200, 2061000, 1, 1, 0, 30000),
(2110200, 1060002, 1, 1, 0, 800),
(2110200, 1082000, 1, 1, 0, 1000),
(2110200, 1002038, 1, 1, 0, 1500),
(2110200, 1092000, 1, 1, 0, 700),
(2110200, 1302004, 1, 1, 0, 700),
(2110200, 1442001, 1, 1, 0, 700),
(2110200, 1492002, 1, 1, 0, 500),
(2110200, 1052104, 1, 1, 0, 700),
(2110200, 2330000, 1, 1, 0, 500),
(2110200, 2043214, 1, 1, 0, 300),
(2110300, 2000001, 1, 1, 0, 20000),
(2110300, 2000003, 1, 1, 0, 20000),
(2110300, 2060000, 1, 1, 0, 30000),
(2110300, 2061000, 1, 1, 0, 30000),
(2110300, 2002004, 1, 1, 0, 20000),
(2110300, 4020007, 1, 1, 0, 9000),
(2110300, 4020000, 1, 1, 0, 9000),
(2110300, 2044501, 1, 1, 0, 300),
(2110300, 1402002, 1, 1, 0, 700),
(2110300, 1032004, 1, 1, 0, 1000),
(2110300, 1050001, 1, 1, 0, 700),
(2110300, 1002055, 1, 1, 0, 1500),
(2110300, 1040049, 1, 1, 0, 800),
(2110300, 1060037, 1, 1, 0, 800),
(2110300, 1082068, 1, 1, 0, 1000),
(2110300, 1432001, 1, 1, 0, 500),
(2110300, 4010007, 1, 1, 0, 9000),
(2110300, 4000350, 1, 1, 0, 600000),
(2110300, 1002619, 1, 1, 0, 1500),
(2110300, 2043214, 1, 1, 0, 300),
(2110301, 2000001, 1, 1, 0, 20000),
(2110301, 2000003, 1, 1, 0, 20000),
(2110301, 2060000, 1, 1, 0, 30000),
(2110301, 2061000, 1, 1, 0, 30000),
(2110301, 2002005, 1, 1, 0, 20000),
(2110301, 4010002, 1, 1, 0, 9000),
(2110301, 4010001, 1, 1, 0, 9000),
(2110301, 4004002, 1, 1, 0, 10000),
(2110301, 2043002, 1, 1, 0, 300),
(2110301, 2043701, 1, 1, 0, 300),
(2110301, 1332009, 1, 1, 0, 500),
(2110301, 1412004, 1, 1, 0, 700),
(2110301, 1040062, 1, 1, 0, 800),
(2110301, 1060051, 1, 1, 0, 800),
(2110301, 1050029, 1, 1, 0, 700),
(2110301, 1002164, 1, 1, 0, 1500),
(2110301, 1082005, 1, 1, 0, 1000),
(2110301, 4010007, 1, 1, 0, 9000),
(2110301, 4000351, 1, 1, 0, 600000),
(2110301, 1492003, 1, 1, 0, 500),
(2110301, 2330001, 1, 1, 0, 500),
(2110301, 2043114, 1, 1, 0, 300),
(2130100, 4000018, 1, 1, 0, 600000),
(2130100, 2000001, 1, 1, 0, 20000),
(2130100, 2012002, 1, 1, 0, 6000),
(2130100, 2044202, 1, 1, 0, 300),
(2130100, 1051003, 1, 1, 0, 700),
(2130100, 1061006, 1, 1, 0, 800),
(2130100, 1041028, 1, 1, 0, 800),
(2130100, 1061026, 1, 1, 0, 800),
(2130100, 2060000, 1, 1, 0, 30000),
(2130100, 4010001, 1, 1, 0, 9000),
(2130100, 4020007, 1, 1, 0, 9000),
(2130100, 2000003, 1, 1, 0, 20000),
(2130100, 1472006, 1, 1, 0, 500),
(2130100, 1072085, 1, 1, 0, 800),
(2130100, 1002097, 1, 1, 0, 1500),
(2130100, 1472009, 1, 1, 0, 500),
(2130100, 1472012, 1, 1, 0, 500),
(2130100, 2061000, 1, 1, 0, 30000),
(2130100, 1051004, 1, 1, 0, 700),
(2130100, 1072087, 1, 1, 0, 800),
(2130100, 4006001, 1, 1, 0, 10000),
(2130100, 2070009, 1, 1, 0, 500),
(2130100, 4000215, 1, 1, 0, 600000),
(2130100, 1002616, 1, 1, 0, 1500),
(2130100, 2044012, 1, 1, 0, 300),
(2130100, 2044210, 1, 1, 0, 300),
(2130103, 4000034, 1, 1, 0, 600000),
(2130103, 2000001, 1, 1, 0, 20000),
(2130103, 2040902, 1, 1, 0, 300),
(2130103, 4010002, 1, 1, 0, 9000),
(2130103, 4020006, 1, 1, 0, 9000),
(2130103, 2010003, 1, 1, 0, 20000),
(2130103, 1332008, 1, 1, 0, 500),
(2130103, 1072069, 1, 1, 0, 800),
(2130103, 1002027, 1, 1, 0, 1500),
(2130103, 1050005, 1, 1, 0, 700),
(2130103, 1061028, 1, 1, 0, 800),
(2130103, 1041031, 1, 1, 0, 800),
(2130103, 1041021, 1, 1, 0, 800),
(2130103, 1061018, 1, 1, 0, 800),
(2130103, 2048003, 1, 1, 0, 300),
(2130103, 1482002, 1, 1, 0, 500),
(2130103, 2040617, 1, 1, 0, 300),
(2130103, 2049100, 1, 1, 0, 150),
(2220000, 4000000, 1, 1, 0, 600000),
(2220000, 4000000, 1, 1, 0, 600000),
(2220000, 4000000, 1, 1, 0, 600000),
(2220000, 4000016, 1, 1, 0, 600000),
(2220000, 4000016, 1, 1, 0, 600000),
(2220000, 4000016, 1, 1, 0, 600000),
(2220000, 4000019, 1, 1, 0, 600000),
(2220000, 4000019, 1, 1, 0, 600000),
(2220000, 4000019, 1, 1, 0, 600000),
(2220000, 4010000, 1, 1, 0, 90000),
(2220000, 4020000, 1, 1, 0, 90000),
(2220000, 2000000, 1, 1, 0, 200000),
(2220000, 2010009, 1, 1, 0, 200000),
(2220000, 2020014, 1, 1, 0, 200000),
(2220000, 2040001, 1, 1, 0, 3000),
(2220000, 2040301, 1, 1, 0, 3000),
(2220000, 2040401, 1, 1, 0, 3000),
(2220000, 2043201, 1, 1, 0, 3000),
(2220000, 2043701, 1, 1, 0, 3000),
(2220000, 2041016, 1, 1, 0, 3000),
(2220000, 2043801, 1, 1, 0, 3000),
(2220000, 2044001, 1, 1, 0, 3000),
(2220000, 2040501, 1, 1, 0, 3000),
(2220000, 2040601, 1, 1, 0, 3000),
(2220000, 2060000, 1, 1, 0, 300000),
(2220000, 2061000, 1, 1, 0, 300000),
(2220000, 2070000, 1, 1, 0, 5000),
(2220000, 1002049, 1, 1, 0, 15000),
(2220000, 1002073, 1, 1, 0, 15000),
(2220000, 1002159, 1, 1, 0, 15000),
(2220000, 1002150, 1, 1, 0, 15000),
(2220000, 1040041, 1, 1, 0, 8000),
(2220000, 1041024, 1, 1, 0, 8000),
(2220000, 1050025, 1, 1, 0, 7000),
(2220000, 1051005, 1, 1, 0, 7000),
(2220000, 1040023, 1, 1, 0, 8000),
(2220000, 1041033, 1, 1, 0, 8000),
(2220000, 1040050, 1, 1, 0, 8000),
(2220000, 1041060, 1, 1, 0, 8000),
(2220000, 1082001, 1, 1, 0, 10000),
(2220000, 1082028, 1, 1, 0, 10000),
(2220000, 1082018, 1, 1, 0, 10000),
(2220000, 1082039, 1, 1, 0, 10000),
(2220000, 1072052, 1, 1, 0, 8000),
(2220000, 1072074, 1, 1, 0, 8000),
(2220000, 1072069, 1, 1, 0, 8000),
(2220000, 1072087, 1, 1, 0, 8000),
(2220000, 2040002, 1, 1, 0, 3000),
(2220000, 2040302, 1, 1, 0, 3000),
(2220000, 2040402, 1, 1, 0, 3000),
(2220000, 2043302, 1, 1, 0, 3000),
(2220000, 2043702, 1, 1, 0, 3000),
(2220000, 2210006, 1, 1, 0, 999999),
(2220000, 1002619, 1, 1, 0, 15000),
(2220000, 1052104, 1, 1, 0, 7000),
(2220000, 1082186, 1, 1, 0, 10000),
(2220000, 1072291, 1, 1, 0, 8000),
(2220000, 2330000, 1, 1, 0, 5000),
(2220000, 2044801, 1, 1, 0, 3000),
(2220000, 2044902, 1, 1, 0, 3000),
(2220000, 2040418, 1, 1, 0, 3000),
(2220000, 2040928, 1, 1, 0, 3000),
(2220000, 2043114, 1, 1, 0, 3000),
(2220000, 2044414, 1, 1, 0, 3000),
(2220100, 4000009, 1, 1, 0, 600000),
(2220100, 2000001, 1, 1, 0, 20000),
(2220100, 2002002, 1, 1, 0, 20000),
(2220100, 2044002, 1, 1, 0, 300),
(2220100, 1332006, 1, 1, 0, 500),
(2220100, 1051000, 1, 1, 0, 700),
(2220100, 1002127, 1, 1, 0, 1500),
(2220100, 2060000, 1, 1, 0, 30000),
(2220100, 4010006, 1, 1, 0, 9000),
(2220100, 4020005, 1, 1, 0, 9000),
(2220100, 2000003, 1, 1, 0, 20000),
(2220100, 1442001, 1, 1, 0, 700),
(2220100, 1041027, 1, 1, 0, 800),
(2220100, 1061025, 1, 1, 0, 800),
(2220100, 1040012, 1, 1, 0, 800),
(2220100, 1060010, 1, 1, 0, 800),
(2220100, 2061000, 1, 1, 0, 30000),
(2220100, 1072020, 1, 1, 0, 800),
(2220100, 1432001, 1, 1, 0, 500),
(2220100, 4020006, 1, 1, 0, 9000),
(2220100, 2000002, 1, 1, 0, 20000),
(2220100, 1072011, 1, 1, 0, 800),
(2220100, 1332001, 1, 1, 0, 500),
(2220100, 1382002, 1, 1, 0, 700),
(2220100, 1002178, 1, 1, 0, 1500),
(2220100, 1412012, 1, 1, 0, 700),
(2220100, 1002613, 1, 1, 0, 1500),
(2220100, 1002616, 1, 1, 0, 1500),
(2220100, 1002619, 1, 1, 0, 1500),
(2230100, 4000007, 1, 1, 0, 600000),
(2230100, 2000001, 1, 1, 0, 20000),
(2230100, 2002001, 1, 1, 0, 20000),
(2230100, 2044402, 1, 1, 0, 300),
(2230100, 1032009, 1, 1, 0, 1000),
(2230100, 1041060, 1, 1, 0, 800),
(2230100, 1061056, 1, 1, 0, 800),
(2230100, 1002047, 1, 1, 0, 1500),
(2230100, 1032008, 1, 1, 0, 1000),
(2230100, 2060000, 1, 1, 0, 30000),
(2230100, 4010004, 1, 1, 0, 9000),
(2230100, 4020005, 1, 1, 0, 9000),
(2230100, 1302004, 1, 1, 0, 700),
(2230100, 1050026, 1, 1, 0, 700),
(2230100, 2000003, 1, 1, 0, 20000),
(2230100, 1051012, 1, 1, 0, 700),
(2230100, 2061000, 1, 1, 0, 30000),
(2230100, 1041032, 1, 1, 0, 800),
(2230100, 1062006, 1, 1, 0, 800),
(2230100, 1432002, 1, 1, 0, 500),
(2230100, 1040021, 1, 1, 0, 800),
(2230100, 4020007, 1, 1, 0, 9000),
(2230100, 2000002, 1, 1, 0, 20000),
(2230100, 1041007, 1, 1, 0, 800),
(2230100, 1422001, 1, 1, 0, 700),
(2230100, 1060071, 1, 1, 0, 800),
(2230100, 1482003, 1, 1, 0, 500),
(2230100, 2040823, 1, 1, 0, 300),
(2230100, 2044010, 1, 1, 0, 300),
(2230101, 4000008, 1, 1, 0, 600000),
(2230101, 2000001, 1, 1, 0, 20000),
(2230101, 2002000, 1, 1, 0, 20000),
(2230101, 2044302, 1, 1, 0, 300),
(2230101, 1032000, 1, 1, 0, 1000),
(2230101, 1032004, 1, 1, 0, 1000),
(2230101, 1452001, 1, 1, 0, 500),
(2230101, 1412002, 1, 1, 0, 700),
(2230101, 2060000, 1, 1, 0, 30000),
(2230101, 4010002, 1, 1, 0, 9000),
(2230101, 4020003, 1, 1, 0, 9000),
(2230101, 1002158, 1, 1, 0, 1500),
(2230101, 2000003, 1, 1, 0, 20000),
(2230101, 1040048, 1, 1, 0, 800),
(2230101, 2061000, 1, 1, 0, 30000),
(2230101, 1060038, 1, 1, 0, 800),
(2230101, 1372003, 1, 1, 0, 700),
(2230101, 1060018, 1, 1, 0, 800),
(2230101, 1040026, 1, 1, 0, 800),
(2230101, 1040009, 1, 1, 0, 800),
(2230101, 4010003, 1, 1, 0, 9000),
(2230101, 2000002, 1, 1, 0, 20000),
(2230101, 1050030, 1, 1, 0, 700),
(2230101, 1050031, 1, 1, 0, 700),
(2230101, 1432003, 1, 1, 0, 500),
(2230101, 1002035, 1, 1, 0, 1500),
(2230101, 1312007, 1, 1, 0, 700),
(2230101, 1040021, 1, 1, 0, 800),
(2230101, 1082183, 1, 1, 0, 1000),
(2230101, 1492003, 1, 1, 0, 500),
(2230101, 2049100, 1, 1, 0, 150),
(2230102, 4000020, 1, 1, 0, 600000),
(2230102, 2000001, 1, 1, 0, 20000),
(2230102, 2002004, 1, 1, 0, 20000),
(2230102, 2060000, 1, 1, 0, 30000),
(2230102, 4003004, 1, 1, 0, 200000),
(2230102, 1032000, 1, 1, 0, 1000),
(2230102, 1041013, 1, 1, 0, 800),
(2230102, 1061024, 1, 1, 0, 800),
(2230102, 1051005, 1, 1, 0, 700),
(2230102, 1032002, 1, 1, 0, 1000),
(2230102, 4010003, 1, 1, 0, 9000),
(2230102, 4020004, 1, 1, 0, 9000),
(2230102, 1002064, 1, 1, 0, 1500),
(2230102, 2000003, 1, 1, 0, 20000),
(2230102, 1072039, 1, 1, 0, 800),
(2230102, 1072033, 1, 1, 0, 800),
(2230102, 4000021, 1, 1, 0, 50000),
(2230102, 1432003, 1, 1, 0, 500),
(2230102, 1402006, 1, 1, 0, 700),
(2230102, 2061000, 1, 1, 0, 30000),
(2230102, 1382017, 1, 1, 0, 700),
(2230102, 1040079, 1, 1, 0, 800),
(2230102, 1060069, 1, 1, 0, 800),
(2230102, 1002151, 1, 1, 0, 1500),
(2230102, 1060050, 1, 1, 0, 800),
(2230102, 1452005, 1, 1, 0, 500),
(2230102, 1462004, 1, 1, 0, 500),
(2230102, 1002166, 1, 1, 0, 1500),
(2230102, 1412005, 1, 1, 0, 700),
(2230102, 1082186, 1, 1, 0, 1000),
(2230102, 2330001, 1, 1, 0, 500),
(2230103, 4000097, 1, 1, 0, 600000),
(2230103, 4131000, 1, 1, 0, 6000),
(2230103, 2060000, 1, 1, 0, 30000),
(2230103, 2061000, 1, 1, 0, 30000),
(2230103, 2002006, 1, 1, 0, 20000),
(2230103, 4010003, 1, 1, 0, 9000),
(2230103, 4004003, 1, 1, 0, 10000),
(2230103, 2000001, 1, 1, 0, 20000),
(2230103, 2000003, 1, 1, 0, 20000),
(2230103, 2040900, 1, 1, 0, 300),
(2230103, 1332020, 1, 1, 0, 500),
(2230103, 1402010, 1, 1, 0, 700),
(2230103, 1302003, 1, 1, 0, 700),
(2230103, 1312003, 1, 1, 0, 700),
(2230103, 1082017, 1, 1, 0, 1000),
(2230103, 1002020, 1, 1, 0, 1500),
(2230103, 1050023, 1, 1, 0, 700),
(2230103, 2070000, 1, 1, 0, 500),
(2230103, 1462003, 1, 1, 0, 500),
(2230103, 1072288, 1, 1, 0, 800),
(2230103, 1072291, 1, 1, 0, 800),
(2230103, 2044802, 1, 1, 0, 300),
(2230103, 2040319, 1, 1, 0, 300),
(2230103, 2044114, 1, 1, 0, 300),
(2230104, 4000098, 1, 1, 0, 600000),
(2230104, 4131010, 1, 1, 0, 6000),
(2230104, 2060000, 1, 1, 0, 30000),
(2230104, 2061000, 1, 1, 0, 30000),
(2230104, 2002007, 1, 1, 0, 20000),
(2230104, 4010001, 1, 1, 0, 9000),
(2230104, 4010002, 1, 1, 0, 9000),
(2230104, 4004002, 1, 1, 0, 10000),
(2230104, 2000002, 1, 1, 0, 20000),
(2230104, 2000003, 1, 1, 0, 20000),
(2230104, 2040601, 1, 1, 0, 300),
(2230104, 1332010, 1, 1, 0, 500),
(2230104, 1061034, 1, 1, 0, 800),
(2230104, 1041041, 1, 1, 0, 800),
(2230104, 1382002, 1, 1, 0, 700),
(2230104, 1082043, 1, 1, 0, 1000),
(2230104, 1002162, 1, 1, 0, 1500),
(2230104, 1050028, 1, 1, 0, 700),
(2230104, 2070002, 1, 1, 0, 500),
(2230104, 1082042, 1, 1, 0, 1000),
(2230104, 1052104, 1, 1, 0, 700),
(2230104, 2040929, 1, 1, 0, 300),
(2230104, 2043112, 1, 1, 0, 300),
(2230105, 4000161, 1, 1, 0, 600000),
(2230105, 4131000, 1, 1, 0, 6000),
(2230105, 2060000, 1, 1, 0, 30000),
(2230105, 2061000, 1, 1, 0, 30000),
(2230105, 2002004, 1, 1, 0, 20000),
(2230105, 4010001, 1, 1, 0, 9000),
(2230105, 4004003, 1, 1, 0, 10000),
(2230105, 2000001, 1, 1, 0, 20000),
(2230105, 2000003, 1, 1, 0, 20000),
(2230105, 2040900, 1, 1, 0, 300),
(2230105, 1312003, 1, 1, 0, 700),
(2230105, 1322004, 1, 1, 0, 700),
(2230105, 1041042, 1, 1, 0, 800),
(2230105, 1061035, 1, 1, 0, 800),
(2230105, 1072007, 1, 1, 0, 800),
(2230105, 1072046, 1, 1, 0, 800),
(2230105, 1050011, 1, 1, 0, 700),
(2230105, 1082016, 1, 1, 0, 1000),
(2230105, 2070000, 1, 1, 0, 500),
(2230105, 1032005, 1, 1, 0, 1000),
(2230105, 1492002, 1, 1, 0, 500),
(2230105, 2040617, 1, 1, 0, 300),
(2230105, 2043015, 1, 1, 0, 300),
(2230106, 4000163, 1, 1, 0, 600000),
(2230106, 2000001, 1, 1, 0, 20000),
(2230106, 2002001, 1, 1, 0, 20000),
(2230106, 2060000, 1, 1, 0, 30000),
(2230106, 2002005, 1, 1, 0, 20000),
(2230106, 2040001, 1, 1, 0, 300),
(2230106, 4010003, 1, 1, 0, 9000),
(2230106, 4020004, 1, 1, 0, 9000),
(2230106, 1332013, 1, 1, 0, 500),
(2230106, 1041040, 1, 1, 0, 800),
(2230106, 1061033, 1, 1, 0, 800),
(2230106, 2000003, 1, 1, 0, 20000),
(2230106, 1002146, 1, 1, 0, 1500),
(2230106, 1002158, 1, 1, 0, 1500),
(2230106, 2040401, 1, 1, 0, 300),
(2230106, 1041050, 1, 1, 0, 800),
(2230106, 1061046, 1, 1, 0, 800),
(2230106, 2061000, 1, 1, 0, 30000),
(2230106, 1332009, 1, 1, 0, 500),
(2230106, 1040040, 1, 1, 0, 800),
(2230106, 1060060, 1, 1, 0, 800),
(2230106, 1052104, 1, 1, 0, 700),
(2230106, 2040417, 1, 1, 0, 300),
(2230107, 4000162, 1, 1, 0, 600000),
(2230107, 2000001, 1, 1, 0, 20000),
(2230107, 2002000, 1, 1, 0, 20000),
(2230107, 2044302, 1, 1, 0, 300),
(2230107, 1402000, 1, 1, 0, 700),
(2230107, 1082026, 1, 1, 0, 1000),
(2230107, 2041004, 1, 1, 0, 300),
(2230107, 1041034, 1, 1, 0, 800),
(2230107, 1062006, 1, 1, 0, 800),
(2230107, 2060000, 1, 1, 0, 30000),
(2230107, 4010002, 1, 1, 0, 9000),
(2230107, 4020005, 1, 1, 0, 9000),
(2230107, 1072051, 1, 1, 0, 800),
(2230107, 2000003, 1, 1, 0, 20000),
(2230107, 1332004, 1, 1, 0, 500),
(2230107, 2061000, 1, 1, 0, 30000),
(2230107, 1041051, 1, 1, 0, 800),
(2230107, 1061047, 1, 1, 0, 800),
(2230107, 1061054, 1, 1, 0, 800),
(2230107, 1041058, 1, 1, 0, 800),
(2230107, 1072288, 1, 1, 0, 800),
(2230107, 2043110, 1, 1, 0, 300),
(2230108, 4000160, 1, 1, 0, 600000),
(2230108, 2000001, 1, 1, 0, 20000),
(2230108, 2002003, 1, 1, 0, 20000),
(2230108, 2044202, 1, 1, 0, 300),
(2230108, 1072065, 1, 1, 0, 800),
(2230108, 1041027, 1, 1, 0, 800),
(2230108, 1061025, 1, 1, 0, 800),
(2230108, 1002131, 1, 1, 0, 1500),
(2230108, 2060000, 1, 1, 0, 30000),
(2230108, 4010000, 1, 1, 0, 9000),
(2230108, 4020007, 1, 1, 0, 9000),
(2230108, 2000003, 1, 1, 0, 20000),
(2230108, 1072054, 1, 1, 0, 800),
(2230108, 1002119, 1, 1, 0, 1500),
(2230108, 2061000, 1, 1, 0, 30000),
(2230108, 1051005, 1, 1, 0, 700),
(2230108, 1050024, 1, 1, 0, 700),
(2230108, 4006001, 1, 1, 0, 10000),
(2230108, 1032004, 1, 1, 0, 1000),
(2230108, 1052101, 1, 1, 0, 700),
(2230108, 2040623, 1, 1, 0, 300),
(2230109, 4000164, 1, 1, 0, 600000),
(2230109, 4131010, 1, 1, 0, 6000),
(2230109, 2060000, 1, 1, 0, 30000),
(2230109, 2061000, 1, 1, 0, 30000),
(2230109, 2002002, 1, 1, 0, 20000),
(2230109, 4010004, 1, 1, 0, 9000),
(2230109, 4020003, 1, 1, 0, 9000),
(2230109, 1032007, 1, 1, 0, 1000),
(2230109, 4004002, 1, 1, 0, 10000),
(2230109, 2000002, 1, 1, 0, 20000),
(2230109, 2000003, 1, 1, 0, 20000),
(2230109, 2040701, 1, 1, 0, 300),
(2230109, 1002034, 1, 1, 0, 1500),
(2230109, 1372003, 1, 1, 0, 700),
(2230109, 1040041, 1, 1, 0, 800),
(2230109, 1060030, 1, 1, 0, 800),
(2230109, 1072054, 1, 1, 0, 800),
(2230109, 1072027, 1, 1, 0, 800),
(2230109, 1050021, 1, 1, 0, 700),
(2230109, 2070002, 1, 1, 0, 500),
(2230109, 1051007, 1, 1, 0, 700),
(2230109, 1002065, 1, 1, 0, 1500),
(2230109, 1002619, 1, 1, 0, 1500),
(2230110, 2060000, 1, 1, 0, 30000),
(2230110, 2061000, 1, 1, 0, 30000),
(2230110, 4000196, 1, 1, 0, 600000),
(2230110, 2000001, 1, 1, 0, 20000),
(2230110, 2000003, 1, 1, 0, 20000),
(2230110, 4020001, 1, 1, 0, 9000),
(2230110, 4020002, 1, 1, 0, 9000),
(2230110, 4010000, 1, 1, 0, 9000),
(2230110, 2002003, 1, 1, 0, 20000),
(2230110, 2041016, 1, 1, 0, 300),
(2230110, 1002121, 1, 1, 0, 1500),
(2230110, 1002058, 1, 1, 0, 1500),
(2230110, 2040901, 1, 1, 0, 300),
(2230110, 1002131, 1, 1, 0, 1500),
(2230110, 1040020, 1, 1, 0, 800),
(2230110, 1060014, 1, 1, 0, 800),
(2230110, 1072087, 1, 1, 0, 800),
(2230110, 1072053, 1, 1, 0, 800),
(2230110, 1082043, 1, 1, 0, 1000),
(2230110, 1332010, 1, 1, 0, 500),
(2230110, 1082006, 1, 1, 0, 1000),
(2230110, 1082026, 1, 1, 0, 1000),
(2230110, 1002616, 1, 1, 0, 1500),
(2230110, 2330000, 1, 1, 0, 500),
(2230110, 2044312, 1, 1, 0, 300),
(2230110, 2044805, 1, 1, 0, 300),
(2230111, 2000001, 1, 1, 0, 20000),
(2230111, 2000003, 1, 1, 0, 20000),
(2230111, 4000197, 1, 1, 0, 600000),
(2230111, 2002000, 1, 1, 0, 20000),
(2230111, 4010005, 1, 1, 0, 9000),
(2230111, 4010001, 1, 1, 0, 9000),
(2230111, 4020003, 1, 1, 0, 9000),
(2230111, 2060000, 1, 1, 0, 30000),
(2230111, 2061000, 1, 1, 0, 30000),
(2230111, 2040301, 1, 1, 0, 300),
(2230111, 2044301, 1, 1, 0, 300),
(2230111, 1302002, 1, 1, 0, 700),
(2230111, 1372004, 1, 1, 0, 700),
(2230111, 1040042, 1, 1, 0, 800),
(2230111, 1060031, 1, 1, 0, 800),
(2230111, 1041023, 1, 1, 0, 800),
(2230111, 1061019, 1, 1, 0, 800),
(2230111, 2043801, 1, 1, 0, 300),
(2230111, 1452005, 1, 1, 0, 500),
(2230111, 1082049, 1, 1, 0, 1000),
(2230111, 1082051, 1, 1, 0, 1000),
(2230111, 2049000, 1, 1, 0, 150),
(2230200, 4000165, 1, 1, 0, 600000),
(2230200, 2044601, 1, 1, 0, 300),
(2230200, 2000001, 1, 1, 0, 20000),
(2230200, 2000003, 1, 1, 0, 20000),
(2230200, 4010006, 1, 1, 0, 9000),
(2230200, 4020002, 1, 1, 0, 9000),
(2230200, 4004000, 1, 1, 0, 10000),
(2230200, 1040072, 1, 1, 0, 800),
(2230200, 1060061, 1, 1, 0, 800),
(2230200, 1422001, 1, 1, 0, 700),
(2230200, 1412000, 1, 1, 0, 700),
(2230200, 1072086, 1, 1, 0, 800),
(2230200, 1002160, 1, 1, 0, 1500),
(2230200, 1040062, 1, 1, 0, 800),
(2230200, 1060051, 1, 1, 0, 800),
(2230200, 2061000, 1, 1, 0, 30000),
(2230200, 2060000, 1, 1, 0, 30000),
(2230200, 2040501, 1, 1, 0, 300),
(2230200, 4006000, 1, 1, 0, 10000),
(2230200, 1412006, 1, 1, 0, 700),
(2230200, 1072291, 1, 1, 0, 800),
(2300100, 4000042, 1, 1, 0, 600000),
(2300100, 2060000, 1, 1, 0, 30000),
(2300100, 2061000, 1, 1, 0, 30000),
(2300100, 2000001, 1, 1, 0, 20000),
(2300100, 2000003, 1, 1, 0, 20000),
(2300100, 4010001, 1, 1, 0, 9000),
(2300100, 4020000, 1, 1, 0, 9000),
(2300100, 2010004, 1, 1, 0, 20000),
(2300100, 4003004, 1, 1, 0, 200000),
(2300100, 1040009, 1, 1, 0, 800),
(2300100, 1060009, 1, 1, 0, 800),
(2300100, 1040043, 1, 1, 0, 800),
(2300100, 1060032, 1, 1, 0, 800),
(2300100, 1041039, 1, 1, 0, 800),
(2300100, 1061041, 1, 1, 0, 800),
(2300100, 1082002, 1, 1, 0, 1000),
(2300100, 2048004, 1, 1, 0, 300),
(2300100, 2041002, 1, 1, 0, 300),
(2300100, 1002119, 1, 1, 0, 1500),
(2300100, 1452005, 1, 1, 0, 500),
(2300100, 1052098, 1, 1, 0, 700),
(2300100, 1052101, 1, 1, 0, 700),
(2300100, 2044801, 1, 1, 0, 300),
(2300100, 2040024, 1, 1, 0, 300),
(2300100, 2043112, 1, 1, 0, 300),
(3000000, 4000063, 1, 1, 0, 600000),
(3000000, 2041016, 1, 1, 0, 300),
(3000000, 2000001, 1, 1, 0, 20000),
(3000000, 2000003, 1, 1, 0, 20000),
(3000000, 4020004, 1, 1, 0, 9000),
(3000000, 4010002, 1, 1, 0, 9000),
(3000000, 4004000, 1, 1, 0, 10000),
(3000000, 1382018, 1, 1, 0, 700),
(3000000, 1312016, 1, 1, 0, 700),
(3000000, 1312005, 1, 1, 0, 700),
(3000000, 1040021, 1, 1, 0, 800),
(3000000, 1060017, 1, 1, 0, 800),
(3000000, 1002137, 1, 1, 0, 1500),
(3000000, 1032006, 1, 1, 0, 1000),
(3000000, 1060050, 1, 1, 0, 800),
(3000000, 1040061, 1, 1, 0, 800),
(3000000, 2061000, 1, 1, 0, 30000),
(3000000, 2060000, 1, 1, 0, 30000),
(3000000, 2041005, 1, 1, 0, 300),
(3000000, 4006000, 1, 1, 0, 10000),
(3000000, 1082037, 1, 1, 0, 1000),
(3000000, 1002622, 1, 1, 0, 1500),
(3000000, 2040316, 1, 1, 0, 300),
(3000000, 2040620, 1, 1, 0, 300),
(3000001, 4000068, 1, 1, 0, 600000),
(3000001, 2000001, 1, 1, 0, 20000),
(3000001, 2000003, 1, 1, 0, 20000),
(3000001, 4020004, 1, 1, 0, 9000),
(3000001, 4010002, 1, 1, 0, 9000),
(3000001, 2050000, 1, 1, 0, 50000),
(3000001, 2050001, 1, 1, 0, 50000),
(3000001, 2050002, 1, 1, 0, 50000),
(3000001, 2050003, 1, 1, 0, 50000),
(3000001, 2050004, 1, 1, 0, 50000),
(3000005, 4000106, 1, 1, 0, 600000),
(3000005, 4131003, 1, 1, 0, 6000),
(3000005, 2060000, 1, 1, 0, 30000),
(3000005, 2061000, 1, 1, 0, 30000),
(3000005, 4010001, 1, 1, 0, 9000),
(3000005, 4020000, 1, 1, 0, 9000),
(3000005, 4004001, 1, 1, 0, 10000),
(3000005, 2000002, 1, 1, 0, 20000),
(3000005, 2000003, 1, 1, 0, 20000),
(3000005, 2040701, 1, 1, 0, 300),
(3000005, 1462000, 1, 1, 0, 500),
(3000005, 1322014, 1, 1, 0, 700),
(3000005, 1050030, 1, 1, 0, 700),
(3000005, 1040058, 1, 1, 0, 800),
(3000005, 1060044, 1, 1, 0, 800),
(3000005, 1041058, 1, 1, 0, 800),
(3000005, 1061054, 1, 1, 0, 800),
(3000005, 1072101, 1, 1, 0, 800),
(3000005, 1002013, 1, 1, 0, 1500),
(3000005, 1052107, 1, 1, 0, 700),
(3000006, 4000166, 1, 1, 0, 600000),
(3000006, 4131003, 1, 1, 0, 6000),
(3000006, 2060000, 1, 1, 0, 30000),
(3000006, 2061000, 1, 1, 0, 30000),
(3000006, 4010005, 1, 1, 0, 9000),
(3000006, 4020001, 1, 1, 0, 9000),
(3000006, 4004001, 1, 1, 0, 10000),
(3000006, 2000002, 1, 1, 0, 20000),
(3000006, 2000003, 1, 1, 0, 20000),
(3000006, 2040601, 1, 1, 0, 300),
(3000006, 1082046, 1, 1, 0, 1000),
(3000006, 1382017, 1, 1, 0, 700),
(3000006, 1082005, 1, 1, 0, 1000),
(3000006, 1050002, 1, 1, 0, 700),
(3000006, 1072086, 1, 1, 0, 800),
(3000006, 1072103, 1, 1, 0, 800),
(3000006, 1462000, 1, 1, 0, 500),
(3000006, 1040040, 1, 1, 0, 800),
(3000006, 1060060, 1, 1, 0, 800),
(3000006, 1041052, 1, 1, 0, 800),
(3000006, 1061048, 1, 1, 0, 800),
(3000006, 1082189, 1, 1, 0, 1000),
(3000006, 2040422, 1, 1, 0, 300),
(3000006, 2040530, 1, 1, 0, 300),
(3100101, 2000003, 1, 1, 0, 20000),
(3100101, 2060000, 1, 1, 0, 30000),
(3100101, 2061000, 1, 1, 0, 30000),
(3100101, 2000002, 1, 1, 0, 20000),
(3100101, 4000334, 1, 1, 0, 600000),
(3100101, 4010005, 1, 1, 0, 9000),
(3100101, 4020000, 1, 1, 0, 9000),
(3100101, 4006000, 1, 1, 0, 10000),
(3100101, 2044701, 1, 1, 0, 300),
(3100101, 1332020, 1, 1, 0, 500),
(3100101, 1040000, 1, 1, 0, 800),
(3100101, 1060075, 1, 1, 0, 800),
(3100101, 1402010, 1, 1, 0, 700),
(3100101, 1032007, 1, 1, 0, 1000),
(3100101, 1072078, 1, 1, 0, 800),
(3100101, 1082046, 1, 1, 0, 1000),
(3100101, 1002156, 1, 1, 0, 1500),
(3100101, 4010007, 1, 1, 0, 9000),
(3100101, 1002622, 1, 1, 0, 1500),
(3100101, 4130005, 1, 1, 0, 6000),
(3100101, 4130009, 1, 1, 0, 6000),
(3100102, 2000003, 1, 1, 0, 20000),
(3100102, 2060000, 1, 1, 0, 30000),
(3100102, 2061000, 1, 1, 0, 30000),
(3100102, 2000002, 1, 1, 0, 20000),
(3100102, 4000335, 1, 1, 0, 600000),
(3100102, 4020002, 1, 1, 0, 9000),
(3100102, 4006000, 1, 1, 0, 10000),
(3100102, 2040401, 1, 1, 0, 300),
(3100102, 2041018, 1, 1, 0, 300),
(3100102, 1462004, 1, 1, 0, 500),
(3100102, 1472011, 1, 1, 0, 500),
(3100102, 1002181, 1, 1, 0, 1500),
(3100102, 1050022, 1, 1, 0, 700),
(3100102, 1061048, 1, 1, 0, 800),
(3100102, 1041052, 1, 1, 0, 800),
(3100102, 1082069, 1, 1, 0, 1000),
(3100102, 4003004, 1, 1, 0, 200000),
(3100102, 4010007, 1, 1, 0, 9000),
(3100102, 1072294, 1, 1, 0, 800),
(3110100, 2000002, 1, 1, 0, 20000),
(3110100, 2000003, 1, 1, 0, 20000),
(3110100, 4010002, 1, 1, 0, 9000),
(3110100, 4020002, 1, 1, 0, 9000),
(3110100, 1322009, 1, 1, 0, 700),
(3110100, 1332014, 1, 1, 0, 500),
(3110100, 4000032, 1, 1, 0, 600000),
(3110100, 2041002, 1, 1, 0, 300),
(3110100, 4006000, 1, 1, 0, 10000),
(3110100, 1051013, 1, 1, 0, 700),
(3110100, 1082049, 1, 1, 0, 1000),
(3110100, 1422001, 1, 1, 0, 700),
(3110100, 1041051, 1, 1, 0, 800),
(3110100, 1061047, 1, 1, 0, 800),
(3110100, 1082046, 1, 1, 0, 1000),
(3110100, 1072112, 1, 1, 0, 800),
(3110100, 1092012, 1, 1, 0, 700),
(3110100, 1432005, 1, 1, 0, 500),
(3110100, 1002622, 1, 1, 0, 1500),
(3110100, 2044802, 1, 1, 0, 300),
(3110100, 4130002, 1, 1, 0, 6000),
(3110100, 4130008, 1, 1, 0, 6000),
(3110100, 4130010, 1, 1, 0, 6000),
(3110101, 4000107, 1, 1, 0, 600000),
(3110101, 4131001, 1, 1, 0, 6000),
(3110101, 2002009, 1, 1, 0, 20000),
(3110101, 2060000, 1, 1, 0, 30000),
(3110101, 2061000, 1, 1, 0, 30000),
(3110101, 4020001, 1, 1, 0, 9000),
(3110101, 4004001, 1, 1, 0, 10000),
(3110101, 2000002, 1, 1, 0, 20000),
(3110101, 2000003, 1, 1, 0, 20000),
(3110101, 2041017, 1, 1, 0, 300),
(3110101, 1092007, 1, 1, 0, 700),
(3110101, 1041055, 1, 1, 0, 800),
(3110101, 1061051, 1, 1, 0, 800),
(3110101, 1082007, 1, 1, 0, 1000),
(3110101, 1072077, 1, 1, 0, 800),
(3110101, 1462004, 1, 1, 0, 500),
(3110101, 1050002, 1, 1, 0, 700),
(3110101, 1040062, 1, 1, 0, 800),
(3110101, 1060051, 1, 1, 0, 800),
(3110101, 1082035, 1, 1, 0, 1000),
(3110101, 1072090, 1, 1, 0, 800),
(3110101, 1472014, 1, 1, 0, 500),
(3110101, 1082189, 1, 1, 0, 1000),
(3110101, 2330001, 1, 1, 0, 500),
(3110101, 2044012, 1, 1, 0, 300),
(3110101, 4130002, 1, 1, 0, 6000),
(3110102, 4000095, 1, 1, 0, 600000),
(3110102, 4000021, 1, 1, 0, 50000),
(3110102, 4131002, 1, 1, 0, 6000),
(3110102, 2060000, 1, 1, 0, 30000),
(3110102, 2061000, 1, 1, 0, 30000),
(3110102, 4010001, 1, 1, 0, 9000),
(3110102, 4010005, 1, 1, 0, 9000),
(3110102, 4020002, 1, 1, 0, 9000),
(3110102, 4004000, 1, 1, 0, 10000),
(3110102, 2000002, 1, 1, 0, 20000),
(3110102, 2000003, 1, 1, 0, 20000),
(3110102, 2044401, 1, 1, 0, 300),
(3110102, 1002173, 1, 1, 0, 1500),
(3110102, 1002164, 1, 1, 0, 1500),
(3110102, 1082051, 1, 1, 0, 1000),
(3110102, 1072035, 1, 1, 0, 800),
(3110102, 1332009, 1, 1, 0, 500),
(3110102, 1040029, 1, 1, 0, 800),
(3110102, 1060020, 1, 1, 0, 800),
(3110102, 1082068, 1, 1, 0, 1000),
(3110102, 1312006, 1, 1, 0, 700),
(3110102, 1322016, 1, 1, 0, 700),
(3110102, 1072294, 1, 1, 0, 800),
(3110102, 2044210, 1, 1, 0, 300),
(3110102, 4130003, 1, 1, 0, 6000);
INSERT IGNORE INTO `temp_data` (`dropperid`, `itemid`, `minimum_quantity`, `maximum_quantity`, `questid`, `chance`) VALUES
(3110102, 4130004, 1, 1, 0, 6000),
(3110102, 4130011, 1, 1, 0, 6000),
(3110300, 2000003, 1, 1, 0, 20000),
(3110300, 2060000, 1, 1, 0, 30000),
(3110300, 2061000, 1, 1, 0, 30000),
(3110300, 2000002, 1, 1, 0, 20000),
(3110300, 4010005, 1, 1, 0, 9000),
(3110300, 4020000, 1, 1, 0, 9000),
(3110300, 4006000, 1, 1, 0, 10000),
(3110300, 2044701, 1, 1, 0, 300),
(3110300, 1332020, 1, 1, 0, 500),
(3110300, 1040000, 1, 1, 0, 800),
(3110300, 1060075, 1, 1, 0, 800),
(3110300, 1402010, 1, 1, 0, 700),
(3110300, 1032007, 1, 1, 0, 1000),
(3110300, 1072078, 1, 1, 0, 800),
(3110300, 1082046, 1, 1, 0, 1000),
(3110300, 1002156, 1, 1, 0, 1500),
(3110300, 4010007, 1, 1, 0, 9000),
(3110300, 4000353, 1, 1, 0, 600000),
(3110300, 1072294, 1, 1, 0, 800),
(3110300, 2040530, 1, 1, 0, 300),
(3110300, 2044410, 1, 1, 0, 300),
(3110300, 2049100, 1, 1, 0, 150),
(3110300, 4130002, 1, 1, 0, 6000),
(3110300, 4130009, 1, 1, 0, 6000),
(3110300, 4130013, 1, 1, 0, 6000),
(3110301, 2000003, 1, 1, 0, 20000),
(3110301, 2060000, 1, 1, 0, 30000),
(3110301, 2061000, 1, 1, 0, 30000),
(3110301, 2000002, 1, 1, 0, 20000),
(3110301, 4010005, 1, 1, 0, 9000),
(3110301, 4020000, 1, 1, 0, 9000),
(3110301, 4006000, 1, 1, 0, 10000),
(3110301, 2044701, 1, 1, 0, 300),
(3110301, 1332020, 1, 1, 0, 500),
(3110301, 1040000, 1, 1, 0, 800),
(3110301, 1060075, 1, 1, 0, 800),
(3110301, 1402010, 1, 1, 0, 700),
(3110301, 1032007, 1, 1, 0, 1000),
(3110301, 1072078, 1, 1, 0, 800),
(3110301, 1082046, 1, 1, 0, 1000),
(3110301, 1002156, 1, 1, 0, 1500),
(3110301, 4010007, 1, 1, 0, 9000),
(3110301, 4000352, 1, 1, 0, 600000),
(3110301, 1082189, 1, 1, 0, 1000),
(3110301, 2040420, 1, 1, 0, 300),
(3110301, 4130001, 1, 1, 0, 6000),
(3110301, 4130006, 1, 1, 0, 6000),
(3110302, 2000002, 1, 1, 0, 20000),
(3110302, 2002005, 1, 1, 0, 20000),
(3110302, 2044502, 1, 1, 0, 300),
(3110302, 2000003, 1, 1, 0, 20000),
(3110302, 1322003, 1, 1, 0, 700),
(3110302, 2060000, 1, 1, 0, 30000),
(3110302, 4010005, 1, 1, 0, 9000),
(3110302, 4020006, 1, 1, 0, 9000),
(3110302, 2061000, 1, 1, 0, 30000),
(3110302, 1040021, 1, 1, 0, 800),
(3110302, 1060016, 1, 1, 0, 800),
(3110302, 1002180, 1, 1, 0, 1500),
(3110302, 1002143, 1, 1, 0, 1500),
(3110302, 1060052, 1, 1, 0, 800),
(3110302, 1040063, 1, 1, 0, 800),
(3110302, 1432003, 1, 1, 0, 500),
(3110302, 1051025, 1, 1, 0, 700),
(3110302, 1002025, 1, 1, 0, 1500),
(3110302, 1040079, 1, 1, 0, 800),
(3110302, 1060069, 1, 1, 0, 800),
(3110302, 4000356, 1, 1, 0, 600000),
(3110302, 1072297, 1, 1, 0, 800),
(3110302, 2040324, 1, 1, 0, 300),
(3110302, 2044210, 1, 1, 0, 300),
(3110302, 4130010, 1, 1, 0, 6000),
(3110302, 4130015, 1, 1, 0, 6000),
(3110303, 2060000, 1, 1, 0, 30000),
(3110303, 2061000, 1, 1, 0, 30000),
(3110303, 4010001, 1, 1, 0, 9000),
(3110303, 4004003, 1, 1, 0, 10000),
(3110303, 4020005, 1, 1, 0, 9000),
(3110303, 2000002, 1, 1, 0, 20000),
(3110303, 2000003, 1, 1, 0, 20000),
(3110303, 2040302, 1, 1, 0, 300),
(3110303, 1382018, 1, 1, 0, 700),
(3110303, 1472012, 1, 1, 0, 500),
(3110303, 1432003, 1, 1, 0, 500),
(3110303, 1462005, 1, 1, 0, 500),
(3110303, 1002183, 1, 1, 0, 1500),
(3110303, 1002167, 1, 1, 0, 1500),
(3110303, 1040086, 1, 1, 0, 800),
(3110303, 1060075, 1, 1, 0, 800),
(3110303, 1041076, 1, 1, 0, 800),
(3110303, 1061071, 1, 1, 0, 800),
(3110303, 1072000, 1, 1, 0, 800),
(3110303, 1032018, 1, 1, 0, 1000),
(3110303, 1082082, 1, 1, 0, 1000),
(3110303, 1082085, 1, 1, 0, 1000),
(3110303, 1072129, 1, 1, 0, 800),
(3110303, 1082010, 1, 1, 0, 1000),
(3110303, 4000356, 1, 1, 0, 600000),
(3110303, 1072297, 1, 1, 0, 800),
(3110303, 2330001, 1, 1, 0, 500),
(3110303, 2040417, 1, 1, 0, 300),
(3110303, 2044112, 1, 1, 0, 300),
(3110303, 2044310, 1, 1, 0, 300),
(3110303, 2044809, 1, 1, 0, 300),
(3110303, 4130001, 1, 1, 0, 6000),
(3110303, 4130002, 1, 1, 0, 6000),
(3110303, 4130016, 1, 1, 0, 6000),
(3210100, 4000021, 1, 1, 0, 50000),
(3210100, 2070001, 1, 1, 0, 500),
(3210100, 2000002, 1, 1, 0, 20000),
(3210100, 2000003, 1, 1, 0, 20000),
(3210100, 4000024, 1, 1, 0, 600000),
(3210100, 4020000, 1, 1, 0, 9000),
(3210100, 4010001, 1, 1, 0, 9000),
(3210100, 1332020, 1, 1, 0, 500),
(3210100, 4020007, 1, 1, 0, 9000),
(3210100, 1452005, 1, 1, 0, 500),
(3210100, 1040026, 1, 1, 0, 800),
(3210100, 1060019, 1, 1, 0, 800),
(3210100, 1082044, 1, 1, 0, 1000),
(3210100, 1072079, 1, 1, 0, 800),
(3210100, 1082052, 1, 1, 0, 1000),
(3210100, 1472012, 1, 1, 0, 500),
(3210100, 1072091, 1, 1, 0, 800),
(3210100, 1002178, 1, 1, 0, 1500),
(3210100, 1072103, 1, 1, 0, 800),
(3210100, 1462005, 1, 1, 0, 500),
(3210100, 1372012, 1, 1, 0, 700),
(3210100, 1002141, 1, 1, 0, 1500),
(3210100, 4010002, 1, 1, 0, 9000),
(3210100, 1372003, 1, 1, 0, 700),
(3210100, 2000001, 1, 1, 0, 20000),
(3210100, 1052107, 1, 1, 0, 700),
(3210100, 4130011, 1, 1, 0, 6000),
(3210100, 4130016, 1, 1, 0, 6000),
(3210100, 4130017, 1, 1, 0, 6000),
(3210200, 4000073, 1, 1, 0, 600000),
(3210200, 4000021, 1, 1, 0, 50000),
(3210200, 2000002, 1, 1, 0, 20000),
(3210200, 2000003, 1, 1, 0, 20000),
(3210200, 4003004, 1, 1, 0, 200000),
(3210200, 4020000, 1, 1, 0, 9000),
(3210200, 4020001, 1, 1, 0, 9000),
(3210200, 4004000, 1, 1, 0, 10000),
(3210200, 2070001, 1, 1, 0, 500),
(3210200, 2044701, 1, 1, 0, 300),
(3210200, 1322009, 1, 1, 0, 700),
(3210200, 2050003, 1, 1, 0, 50000),
(3210200, 1002174, 1, 1, 0, 1500),
(3210200, 1002038, 1, 1, 0, 1500),
(3210200, 1082042, 1, 1, 0, 1000),
(3210200, 1072041, 1, 1, 0, 800),
(3210200, 1412006, 1, 1, 0, 700),
(3210200, 1032008, 1, 1, 0, 1000),
(3210200, 1072002, 1, 1, 0, 800),
(3210200, 1332014, 1, 1, 0, 500),
(3210200, 1040073, 1, 1, 0, 800),
(3210200, 1060062, 1, 1, 0, 800),
(3210200, 1050035, 1, 1, 0, 700),
(3210200, 1462005, 1, 1, 0, 500),
(3210200, 1002145, 1, 1, 0, 1500),
(3210200, 1052107, 1, 1, 0, 700),
(3210200, 4130007, 1, 1, 0, 6000),
(3210200, 4130016, 1, 1, 0, 6000),
(3210201, 4000073, 1, 1, 0, 600000),
(3210201, 4000021, 1, 1, 0, 50000),
(3210201, 2000002, 1, 1, 0, 20000),
(3210201, 2000003, 1, 1, 0, 20000),
(3210201, 4003004, 1, 1, 0, 200000),
(3210201, 4020003, 1, 1, 0, 9000),
(3210201, 4010002, 1, 1, 0, 9000),
(3210201, 4004001, 1, 1, 0, 10000),
(3210201, 2044501, 1, 1, 0, 300),
(3210201, 4006001, 1, 1, 0, 10000),
(3210201, 4020007, 1, 1, 0, 9000),
(3210201, 1442001, 1, 1, 0, 700),
(3210201, 1332012, 1, 1, 0, 500),
(3210201, 1072083, 1, 1, 0, 800),
(3210201, 1002172, 1, 1, 0, 1500),
(3210201, 1472013, 1, 1, 0, 500),
(3210201, 1072089, 1, 1, 0, 800),
(3210201, 1082070, 1, 1, 0, 1000),
(3210201, 1051016, 1, 1, 0, 700),
(3210201, 1050036, 1, 1, 0, 700),
(3210201, 1051024, 1, 1, 0, 700),
(3210201, 1492004, 1, 1, 0, 500),
(3210201, 2043114, 1, 1, 0, 300),
(3210201, 4130003, 1, 1, 0, 6000),
(3210201, 4130004, 1, 1, 0, 6000),
(3210201, 4130012, 1, 1, 0, 6000),
(3210202, 4000073, 1, 1, 0, 600000),
(3210202, 4000021, 1, 1, 0, 50000),
(3210202, 2000002, 1, 1, 0, 20000),
(3210202, 2000003, 1, 1, 0, 20000),
(3210202, 4003004, 1, 1, 0, 200000),
(3210202, 4020005, 1, 1, 0, 9000),
(3210202, 4010001, 1, 1, 0, 9000),
(3210202, 4004003, 1, 1, 0, 10000),
(3210202, 4006000, 1, 1, 0, 10000),
(3210202, 2043701, 1, 1, 0, 300),
(3210202, 2070003, 1, 1, 0, 500),
(3210202, 1302017, 1, 1, 0, 700),
(3210202, 1002037, 1, 1, 0, 1500),
(3210202, 1002163, 1, 1, 0, 1500),
(3210202, 1040028, 1, 1, 0, 800),
(3210202, 1332001, 1, 1, 0, 500),
(3210202, 1041053, 1, 1, 0, 800),
(3210202, 1061049, 1, 1, 0, 800),
(3210202, 1060020, 1, 1, 0, 800),
(3210202, 1041066, 1, 1, 0, 800),
(3210202, 1061061, 1, 1, 0, 800),
(3210202, 1082045, 1, 1, 0, 1000),
(3210202, 1322015, 1, 1, 0, 700),
(3210202, 1032011, 1, 1, 0, 1000),
(3210202, 1492004, 1, 1, 0, 500),
(3210202, 1002628, 1, 1, 0, 1500),
(3210202, 2043110, 1, 1, 0, 300),
(3210202, 2044807, 1, 1, 0, 300),
(3210202, 4130006, 1, 1, 0, 6000),
(3210202, 4130012, 1, 1, 0, 6000),
(3210203, 4000108, 1, 1, 0, 600000),
(3210203, 4131009, 1, 1, 0, 6000),
(3210203, 2002008, 1, 1, 0, 20000),
(3210203, 2060000, 1, 1, 0, 30000),
(3210203, 2061000, 1, 1, 0, 30000),
(3210203, 4010002, 1, 1, 0, 9000),
(3210203, 4004003, 1, 1, 0, 10000),
(3210203, 2000002, 1, 1, 0, 20000),
(3210203, 2000003, 1, 1, 0, 20000),
(3210203, 2044501, 1, 1, 0, 300),
(3210203, 1060018, 1, 1, 0, 800),
(3210203, 1040021, 1, 1, 0, 800),
(3210203, 1072080, 1, 1, 0, 800),
(3210203, 1051006, 1, 1, 0, 700),
(3210203, 1050039, 1, 1, 0, 700),
(3210203, 1002153, 1, 1, 0, 1500),
(3210203, 1002166, 1, 1, 0, 1500),
(3210203, 1082025, 1, 1, 0, 1000),
(3210203, 1072126, 1, 1, 0, 800),
(3210203, 1072115, 1, 1, 0, 800),
(3210203, 1312007, 1, 1, 0, 700),
(3210203, 1332031, 1, 1, 0, 500),
(3210203, 1482005, 1, 1, 0, 500),
(3210203, 2040923, 1, 1, 0, 300),
(3210203, 2043212, 1, 1, 0, 300),
(3210203, 2049100, 1, 1, 0, 150),
(3210203, 4130003, 1, 1, 0, 6000),
(3210204, 4000109, 1, 1, 0, 600000),
(3210204, 4003004, 1, 1, 0, 200000),
(3210204, 4003005, 1, 1, 0, 200000),
(3210204, 2060000, 1, 1, 0, 30000),
(3210204, 2061000, 1, 1, 0, 30000),
(3210204, 4010004, 1, 1, 0, 9000),
(3210204, 4020006, 1, 1, 0, 9000),
(3210204, 4004002, 1, 1, 0, 10000),
(3210204, 2000002, 1, 1, 0, 20000),
(3210204, 2000003, 1, 1, 0, 20000),
(3210204, 2043202, 1, 1, 0, 300),
(3210204, 1040070, 1, 1, 0, 800),
(3210204, 1060059, 1, 1, 0, 800),
(3210204, 1040060, 1, 1, 0, 800),
(3210204, 1060046, 1, 1, 0, 800),
(3210204, 1082053, 1, 1, 0, 1000),
(3210204, 1050031, 1, 1, 0, 700),
(3210204, 1002004, 1, 1, 0, 1500),
(3210204, 1050021, 1, 1, 0, 700),
(3210204, 1072002, 1, 1, 0, 800),
(3210204, 1082071, 1, 1, 0, 1000),
(3210204, 1332011, 1, 1, 0, 500),
(3210204, 1052110, 1, 1, 0, 700),
(3210204, 2040617, 1, 1, 0, 300),
(3210204, 4130000, 1, 1, 0, 6000),
(3210204, 4130015, 1, 1, 0, 6000),
(3210204, 4130017, 1, 1, 0, 6000),
(3210205, 4000096, 1, 1, 0, 600000),
(3210205, 4000021, 1, 1, 0, 50000),
(3210205, 2002010, 1, 1, 0, 20000),
(3210205, 2060000, 1, 1, 0, 30000),
(3210205, 2061000, 1, 1, 0, 30000),
(3210205, 4020005, 1, 1, 0, 9000),
(3210205, 4004002, 1, 1, 0, 10000),
(3210205, 2000002, 1, 1, 0, 20000),
(3210205, 2000003, 1, 1, 0, 20000),
(3210205, 2040703, 1, 1, 0, 300),
(3210205, 2050001, 1, 1, 0, 50000),
(3210205, 1041043, 1, 1, 0, 800),
(3210205, 1061036, 1, 1, 0, 800),
(3210205, 1040057, 1, 1, 0, 800),
(3210205, 1060043, 1, 1, 0, 800),
(3210205, 1002048, 1, 1, 0, 1500),
(3210205, 1002136, 1, 1, 0, 1500),
(3210205, 1040076, 1, 1, 0, 800),
(3210205, 1060065, 1, 1, 0, 800),
(3210205, 1051015, 1, 1, 0, 700),
(3210205, 1050037, 1, 1, 0, 700),
(3210205, 1082075, 1, 1, 0, 1000),
(3210205, 1382019, 1, 1, 0, 700),
(3210205, 1082192, 1, 1, 0, 1000),
(3210205, 1052113, 1, 1, 0, 700),
(3210205, 4130001, 1, 1, 0, 6000),
(3210205, 4130004, 1, 1, 0, 6000),
(3210205, 4130014, 1, 1, 0, 6000),
(3210206, 4000103, 1, 1, 0, 600000),
(3210206, 4131006, 1, 1, 0, 6000),
(3210206, 2060000, 1, 1, 0, 30000),
(3210206, 2061000, 1, 1, 0, 30000),
(3210206, 4010003, 1, 1, 0, 9000),
(3210206, 4020005, 1, 1, 0, 9000),
(3210206, 4004000, 1, 1, 0, 10000),
(3210206, 2000002, 1, 1, 0, 20000),
(3210206, 2000003, 1, 1, 0, 20000),
(3210206, 2043001, 1, 1, 0, 300),
(3210206, 1332020, 1, 1, 0, 500),
(3210206, 2070003, 1, 1, 0, 500),
(3210206, 1072036, 1, 1, 0, 800),
(3210206, 1072082, 1, 1, 0, 800),
(3210206, 1072003, 1, 1, 0, 800),
(3210206, 1002179, 1, 1, 0, 1500),
(3210206, 1072103, 1, 1, 0, 800),
(3210206, 1051026, 1, 1, 0, 700),
(3210206, 1002168, 1, 1, 0, 1500),
(3210206, 1040000, 1, 1, 0, 800),
(3210206, 1060000, 1, 1, 0, 800),
(3210206, 1040081, 1, 1, 0, 800),
(3210206, 1060070, 1, 1, 0, 800),
(3210206, 1051032, 1, 1, 0, 700),
(3210206, 1002207, 1, 1, 0, 1500),
(3210206, 1072132, 1, 1, 0, 800),
(3210206, 1002212, 1, 1, 0, 1500),
(3210206, 1492005, 1, 1, 0, 500),
(3210206, 4130015, 1, 1, 0, 6000),
(3210206, 4130016, 1, 1, 0, 6000),
(3210207, 4000113, 1, 1, 0, 600000),
(3210207, 4131011, 1, 1, 0, 6000),
(3210207, 2060000, 1, 1, 0, 30000),
(3210207, 2061000, 1, 1, 0, 30000),
(3210207, 4020000, 1, 1, 0, 9000),
(3210207, 4020002, 1, 1, 0, 9000),
(3210207, 4004000, 1, 1, 0, 10000),
(3210207, 2000002, 1, 1, 0, 20000),
(3210207, 2000003, 1, 1, 0, 20000),
(3210207, 2041018, 1, 1, 0, 300),
(3210207, 2043102, 1, 1, 0, 300),
(3210207, 2070008, 1, 1, 0, 500),
(3210207, 4020007, 1, 1, 0, 9000),
(3210207, 1082048, 1, 1, 0, 1000),
(3210207, 1072076, 1, 1, 0, 800),
(3210207, 1372001, 1, 1, 0, 700),
(3210207, 1002139, 1, 1, 0, 1500),
(3210207, 1002178, 1, 1, 0, 1500),
(3210207, 1041069, 1, 1, 0, 800),
(3210207, 1061064, 1, 1, 0, 800),
(3210207, 1082055, 1, 1, 0, 1000),
(3210207, 1050038, 1, 1, 0, 700),
(3210207, 1082024, 1, 1, 0, 1000),
(3210207, 1072107, 1, 1, 0, 800),
(3210207, 1412005, 1, 1, 0, 700),
(3210207, 1072297, 1, 1, 0, 800),
(3210207, 2043214, 1, 1, 0, 300),
(3210207, 2049000, 1, 1, 0, 150),
(3210207, 4130007, 1, 1, 0, 6000),
(3210207, 4130008, 1, 1, 0, 6000),
(3210208, 4000168, 1, 1, 0, 600000),
(3210208, 4131009, 1, 1, 0, 6000),
(3210208, 2002005, 1, 1, 0, 20000),
(3210208, 2060000, 1, 1, 0, 30000),
(3210208, 2061000, 1, 1, 0, 30000),
(3210208, 4010002, 1, 1, 0, 9000),
(3210208, 4004003, 1, 1, 0, 10000),
(3210208, 2000002, 1, 1, 0, 20000),
(3210208, 2000003, 1, 1, 0, 20000),
(3210208, 2044501, 1, 1, 0, 300),
(3210208, 1382018, 1, 1, 0, 700),
(3210208, 1002173, 1, 1, 0, 1500),
(3210208, 1041052, 1, 1, 0, 800),
(3210208, 1061048, 1, 1, 0, 800),
(3210208, 1002048, 1, 1, 0, 1500),
(3210208, 1032008, 1, 1, 0, 1000),
(3210208, 1041065, 1, 1, 0, 800),
(3210208, 1061060, 1, 1, 0, 800),
(3210208, 1051008, 1, 1, 0, 700),
(3210208, 1082072, 1, 1, 0, 1000),
(3210208, 1082076, 1, 1, 0, 1000),
(3210208, 1072117, 1, 1, 0, 800),
(3210208, 1072127, 1, 1, 0, 800),
(3210208, 1052110, 1, 1, 0, 700),
(3210208, 1082195, 1, 1, 0, 1000),
(3210208, 4130006, 1, 1, 0, 6000),
(3210208, 4130008, 1, 1, 0, 6000),
(3210450, 4000153, 1, 1, 0, 600000),
(3210450, 4131008, 1, 1, 0, 6000),
(3210450, 2060000, 1, 1, 0, 30000),
(3210450, 2061000, 1, 1, 0, 30000),
(3210450, 4020000, 1, 1, 0, 9000),
(3210450, 4020001, 1, 1, 0, 9000),
(3210450, 2000002, 1, 1, 0, 20000),
(3210450, 2000003, 1, 1, 0, 20000),
(3210450, 2022040, 1, 1, 0, 20000),
(3210450, 1041042, 1, 1, 0, 800),
(3210450, 1061035, 1, 1, 0, 800),
(3210450, 1002023, 1, 1, 0, 1500),
(3210450, 1002163, 1, 1, 0, 1500),
(3210450, 1032010, 1, 1, 0, 1000),
(3210450, 1040062, 1, 1, 0, 800),
(3210450, 1060051, 1, 1, 0, 800),
(3210450, 1051015, 1, 1, 0, 700),
(3210450, 1302004, 1, 1, 0, 700),
(3210450, 1332014, 1, 1, 0, 500),
(3210450, 1072119, 1, 1, 0, 800),
(3210450, 1072110, 1, 1, 0, 800),
(3210450, 1082063, 1, 1, 0, 1000),
(3210450, 1002625, 1, 1, 0, 1500),
(3210450, 2330001, 1, 1, 0, 500),
(3210450, 4130000, 1, 1, 0, 6000),
(3210450, 4130014, 1, 1, 0, 6000),
(3210450, 4130017, 1, 1, 0, 6000),
(3210800, 4000026, 1, 1, 0, 600000),
(3210800, 4003004, 1, 1, 0, 200000),
(3210800, 2041010, 1, 1, 0, 300),
(3210800, 2000003, 1, 1, 0, 20000),
(3210800, 4000021, 1, 1, 0, 50000),
(3210800, 2070003, 1, 1, 0, 500),
(3210800, 4020003, 1, 1, 0, 9000),
(3210800, 4010004, 1, 1, 0, 9000),
(3210800, 4000029, 1, 1, 0, 600000),
(3210800, 1402010, 1, 1, 0, 700),
(3210800, 2070008, 1, 1, 0, 500),
(3210800, 1002038, 1, 1, 0, 1500),
(3210800, 1002172, 1, 1, 0, 1500),
(3210800, 1041050, 1, 1, 0, 800),
(3210800, 1061046, 1, 1, 0, 800),
(3210800, 1002136, 1, 1, 0, 1500),
(3210800, 1040075, 1, 1, 0, 800),
(3210800, 1060064, 1, 1, 0, 800),
(3210800, 1051014, 1, 1, 0, 700),
(3210800, 1072109, 1, 1, 0, 800),
(3210800, 1072116, 1, 1, 0, 800),
(3210800, 1092013, 1, 1, 0, 700),
(3210800, 1472017, 1, 1, 0, 500),
(3210800, 4020004, 1, 1, 0, 9000),
(3210800, 1302003, 1, 1, 0, 700),
(3210800, 1041094, 1, 1, 0, 800),
(3210800, 2000002, 1, 1, 0, 20000),
(3210800, 1082192, 1, 1, 0, 1000),
(3210800, 1072300, 1, 1, 0, 800),
(3210800, 2044414, 1, 1, 0, 300),
(3210800, 4130001, 1, 1, 0, 6000),
(3210800, 4130008, 1, 1, 0, 6000),
(3210800, 4130010, 1, 1, 0, 6000),
(3220000, 4000003, 1, 1, 0, 600000),
(3220000, 4000003, 1, 1, 0, 600000),
(3220000, 4000003, 1, 1, 0, 600000),
(3220000, 4000005, 1, 1, 0, 600000),
(3220000, 4000005, 1, 1, 0, 600000),
(3220000, 4000005, 1, 1, 0, 600000),
(3220000, 4000018, 1, 1, 0, 600000),
(3220000, 4000018, 1, 1, 0, 600000),
(3220000, 4000018, 1, 1, 0, 600000),
(3220000, 4000195, 1, 1, 0, 600000),
(3220000, 4000195, 1, 1, 0, 600000),
(3220000, 4000195, 1, 1, 0, 600000),
(3220000, 4010000, 1, 1, 0, 90000),
(3220000, 4020001, 1, 1, 0, 90000),
(3220000, 2000001, 1, 1, 0, 200000),
(3220000, 2000003, 1, 1, 0, 200000),
(3220000, 2012002, 1, 1, 0, 60000),
(3220000, 2040701, 1, 1, 0, 3000),
(3220000, 2040801, 1, 1, 0, 3000),
(3220000, 2040901, 1, 1, 0, 3000),
(3220000, 2041001, 1, 1, 0, 3000),
(3220000, 2043001, 1, 1, 0, 3000),
(3220000, 2043101, 1, 1, 0, 3000),
(3220000, 2041010, 1, 1, 0, 3000),
(3220000, 2043201, 1, 1, 0, 3000),
(3220000, 2041004, 1, 1, 0, 3000),
(3220000, 2060000, 1, 1, 0, 300000),
(3220000, 2061000, 1, 1, 0, 300000),
(3220000, 2041017, 1, 1, 0, 3000),
(3220000, 2040402, 1, 1, 0, 3000),
(3220000, 2044002, 1, 1, 0, 3000),
(3220000, 2040502, 1, 1, 0, 3000),
(3220000, 2040602, 1, 1, 0, 3000),
(3220000, 2041016, 1, 1, 0, 3000),
(3220000, 2070009, 1, 1, 0, 5000),
(3220000, 1002098, 1, 1, 0, 15000),
(3220000, 1002154, 1, 1, 0, 15000),
(3220000, 1002170, 1, 1, 0, 15000),
(3220000, 1002185, 1, 1, 0, 15000),
(3220000, 1040085, 1, 1, 0, 8000),
(3220000, 1041086, 1, 1, 0, 8000),
(3220000, 1050039, 1, 1, 0, 7000),
(3220000, 1051026, 1, 1, 0, 7000),
(3220000, 1040080, 1, 1, 0, 8000),
(3220000, 1041083, 1, 1, 0, 8000),
(3220000, 1040084, 1, 1, 0, 8000),
(3220000, 1041076, 1, 1, 0, 8000),
(3220000, 1082025, 1, 1, 0, 10000),
(3220000, 1082064, 1, 1, 0, 10000),
(3220000, 1082073, 1, 1, 0, 10000),
(3220000, 1082074, 1, 1, 0, 10000),
(3220000, 1072126, 1, 1, 0, 8000),
(3220000, 1072117, 1, 1, 0, 8000),
(3220000, 1072118, 1, 1, 0, 8000),
(3220000, 1072107, 1, 1, 0, 8000),
(3220000, 1002628, 1, 1, 0, 15000),
(3220000, 1052113, 1, 1, 0, 7000),
(3220000, 1082195, 1, 1, 0, 10000),
(3220000, 1072300, 1, 1, 0, 8000),
(3220000, 1322027, 1, 1, 0, 7000),
(3220000, 2044112, 1, 1, 0, 3000),
(3220000, 2044412, 1, 1, 0, 3000),
(3220001, 4000329, 1, 1, 0, 600000),
(3220001, 4000329, 1, 1, 0, 600000),
(3220001, 4000329, 1, 1, 0, 600000),
(3220001, 4000331, 1, 1, 0, 600000),
(3220001, 4000331, 1, 1, 0, 600000),
(3220001, 4000331, 1, 1, 0, 600000),
(3220001, 4000330, 1, 1, 0, 600000),
(3220001, 4000330, 1, 1, 0, 600000),
(3220001, 4000330, 1, 1, 0, 600000),
(3220001, 4010002, 1, 1, 0, 90000),
(3220001, 4020003, 1, 1, 0, 90000),
(3220001, 4010007, 1, 1, 0, 90000),
(3220001, 2022155, 1, 1, 0, 200000),
(3220001, 2000001, 1, 1, 0, 200000),
(3220001, 2000003, 1, 1, 0, 200000),
(3220001, 2040004, 1, 1, 0, 3000),
(3220001, 2040501, 1, 1, 0, 3000),
(3220001, 2040504, 1, 1, 0, 3000),
(3220001, 2040801, 1, 1, 0, 3000),
(3220001, 2041007, 1, 1, 0, 3000),
(3220001, 2041004, 1, 1, 0, 3000),
(3220001, 2043801, 1, 1, 0, 3000),
(3220001, 2044001, 1, 1, 0, 3000),
(3220001, 2044201, 1, 1, 0, 3000),
(3220001, 2044601, 1, 1, 0, 3000),
(3220001, 2044801, 1, 1, 0, 3000),
(3220001, 1082073, 1, 1, 0, 10000),
(3220001, 1082025, 1, 1, 0, 10000),
(3220001, 1082064, 1, 1, 0, 10000),
(3220001, 1082074, 1, 1, 0, 10000),
(3220001, 1082195, 1, 1, 0, 10000),
(3220001, 1032013, 1, 1, 0, 10000),
(3220001, 1302063, 1, 1, 0, 7000),
(3230100, 4000013, 1, 1, 0, 600000),
(3230100, 2000002, 1, 1, 0, 20000),
(3230100, 2002005, 1, 1, 0, 20000),
(3230100, 2044502, 1, 1, 0, 300),
(3230100, 2000003, 1, 1, 0, 20000),
(3230100, 1322003, 1, 1, 0, 700),
(3230100, 2060000, 1, 1, 0, 30000),
(3230100, 4010005, 1, 1, 0, 9000),
(3230100, 4020006, 1, 1, 0, 9000),
(3230100, 2061000, 1, 1, 0, 30000),
(3230100, 1040021, 1, 1, 0, 800),
(3230100, 1060016, 1, 1, 0, 800),
(3230100, 1002180, 1, 1, 0, 1500),
(3230100, 1002143, 1, 1, 0, 1500),
(3230100, 1060052, 1, 1, 0, 800),
(3230100, 1040063, 1, 1, 0, 800),
(3230100, 1432003, 1, 1, 0, 500),
(3230100, 1051025, 1, 1, 0, 700),
(3230100, 1002025, 1, 1, 0, 1500),
(3230100, 1040079, 1, 1, 0, 800),
(3230100, 1060069, 1, 1, 0, 800),
(3230100, 1482005, 1, 1, 0, 500),
(3230100, 1492006, 1, 1, 0, 500),
(3230100, 2330001, 1, 1, 0, 500),
(3230100, 2044902, 1, 1, 0, 300),
(3230100, 4130006, 1, 1, 0, 6000),
(3230100, 4130012, 1, 1, 0, 6000),
(3230100, 4130017, 1, 1, 0, 6000),
(3230101, 2000002, 1, 1, 0, 20000),
(3230101, 2040005, 1, 1, 0, 300),
(3230101, 2070002, 1, 1, 0, 500),
(3230101, 4010003, 1, 1, 0, 9000),
(3230101, 4020004, 1, 1, 0, 9000),
(3230101, 4000035, 1, 1, 0, 600000),
(3230101, 2048002, 1, 1, 0, 300),
(3230101, 1452000, 1, 1, 0, 500),
(3230101, 1051010, 1, 1, 0, 700),
(3230101, 1050022, 1, 1, 0, 700),
(3230101, 1051008, 1, 1, 0, 700),
(3230101, 1082069, 1, 1, 0, 1000),
(3230101, 1082056, 1, 1, 0, 1000),
(3230101, 1082047, 1, 1, 0, 1000),
(3230101, 1412004, 1, 1, 0, 700),
(3230101, 1072114, 1, 1, 0, 800),
(3230101, 1072118, 1, 1, 0, 800),
(3230101, 1472016, 1, 1, 0, 500),
(3230101, 1492005, 1, 1, 0, 500),
(3230101, 2040027, 1, 1, 0, 300),
(3230101, 4130007, 1, 1, 0, 6000),
(3230101, 4130014, 1, 1, 0, 6000),
(3230102, 4000043, 1, 1, 0, 600000),
(3230102, 2000003, 1, 1, 0, 20000),
(3230102, 2000002, 1, 1, 0, 20000),
(3230102, 4020000, 1, 1, 0, 9000),
(3230102, 4010005, 1, 1, 0, 9000),
(3230102, 2043301, 1, 1, 0, 300),
(3230102, 1302017, 1, 1, 0, 700),
(3230102, 2048005, 1, 1, 0, 300),
(3230102, 1332020, 1, 1, 0, 500),
(3230102, 4006001, 1, 1, 0, 10000),
(3230102, 1452005, 1, 1, 0, 500),
(3230102, 1442001, 1, 1, 0, 700),
(3230102, 1382017, 1, 1, 0, 700),
(3230102, 1072113, 1, 1, 0, 800),
(3230102, 1082056, 1, 1, 0, 1000),
(3230102, 1050000, 1, 1, 0, 700),
(3230102, 1050038, 1, 1, 0, 700),
(3230102, 1092014, 1, 1, 0, 700),
(3230102, 1072121, 1, 1, 0, 800),
(3230102, 1082074, 1, 1, 0, 1000),
(3230102, 1040080, 1, 1, 0, 800),
(3230102, 1060068, 1, 1, 0, 800),
(3230102, 1041074, 1, 1, 0, 800),
(3230102, 1061069, 1, 1, 0, 800),
(3230102, 1072297, 1, 1, 0, 800),
(3230102, 1482006, 1, 1, 0, 500),
(3230102, 2044802, 1, 1, 0, 300),
(3230102, 2040024, 1, 1, 0, 300),
(3230102, 2040423, 1, 1, 0, 300),
(3230102, 4130011, 1, 1, 0, 6000),
(3230102, 4130015, 1, 1, 0, 6000),
(3230103, 4000100, 1, 1, 0, 600000),
(3230103, 4131013, 1, 1, 0, 6000),
(3230103, 2002007, 1, 1, 0, 20000),
(3230103, 2060000, 1, 1, 0, 30000),
(3230103, 2061000, 1, 1, 0, 30000),
(3230103, 4020001, 1, 1, 0, 9000),
(3230103, 4020003, 1, 1, 0, 9000),
(3230103, 4004000, 1, 1, 0, 10000),
(3230103, 2000002, 1, 1, 0, 20000),
(3230103, 2000003, 1, 1, 0, 20000),
(3230103, 2040302, 1, 1, 0, 300),
(3230103, 2048002, 1, 1, 0, 300),
(3230103, 1082035, 1, 1, 0, 1000),
(3230103, 1072105, 1, 1, 0, 800),
(3230103, 1472011, 1, 1, 0, 500),
(3230103, 1452006, 1, 1, 0, 500),
(3230103, 1442003, 1, 1, 0, 700),
(3230103, 1002093, 1, 1, 0, 1500),
(3230103, 1002154, 1, 1, 0, 1500),
(3230103, 1040083, 1, 1, 0, 800),
(3230103, 1060072, 1, 1, 0, 800),
(3230103, 1032011, 1, 1, 0, 1000),
(3230103, 1041082, 1, 1, 0, 800),
(3230103, 1061081, 1, 1, 0, 800),
(3230103, 1050045, 1, 1, 0, 700),
(3230103, 1002625, 1, 1, 0, 1500),
(3230103, 2044112, 1, 1, 0, 300),
(3230103, 4130001, 1, 1, 0, 6000),
(3230103, 4130011, 1, 1, 0, 6000),
(3230104, 2000002, 1, 1, 0, 20000),
(3230104, 2040801, 1, 1, 0, 300),
(3230104, 2070002, 1, 1, 0, 500),
(3230104, 4020000, 1, 1, 0, 9000),
(3230104, 4010001, 1, 1, 0, 9000),
(3230104, 1382018, 1, 1, 0, 700),
(3230104, 4000167, 1, 1, 0, 600000),
(3230104, 2040701, 1, 1, 0, 300),
(3230104, 1332020, 1, 1, 0, 500),
(3230104, 1002023, 1, 1, 0, 1500),
(3230104, 1041050, 1, 1, 0, 800),
(3230104, 1061046, 1, 1, 0, 800),
(3230104, 1041056, 1, 1, 0, 800),
(3230104, 1061052, 1, 1, 0, 800),
(3230104, 1061048, 1, 1, 0, 800),
(3230104, 1041052, 1, 1, 0, 800),
(3230104, 1002135, 1, 1, 0, 1500),
(3230104, 1051014, 1, 1, 0, 700),
(3230104, 1402006, 1, 1, 0, 700),
(3230104, 1082023, 1, 1, 0, 1000),
(3230104, 1072114, 1, 1, 0, 800),
(3230104, 1002184, 1, 1, 0, 1500),
(3230104, 1082073, 1, 1, 0, 1000),
(3230104, 1482004, 1, 1, 0, 500),
(3230104, 2044212, 1, 1, 0, 300),
(3230104, 4130000, 1, 1, 0, 6000),
(3230104, 4130003, 1, 1, 0, 6000),
(3230104, 4130005, 1, 1, 0, 6000),
(3230200, 4000059, 1, 1, 0, 600000),
(3230200, 4003004, 1, 1, 0, 200000),
(3230200, 2041012, 1, 1, 0, 300),
(3230200, 2000002, 1, 1, 0, 20000),
(3230200, 2000003, 1, 1, 0, 20000),
(3230200, 1092008, 1, 1, 0, 700),
(3230200, 2040902, 1, 1, 0, 300),
(3230200, 2041005, 1, 1, 0, 300),
(3230200, 1302017, 1, 1, 0, 700),
(3230200, 2060000, 1, 1, 0, 30000),
(3230200, 2061000, 1, 1, 0, 30000),
(3230200, 4004001, 1, 1, 0, 10000),
(3230200, 4020000, 1, 1, 0, 9000),
(3230200, 1432008, 1, 1, 0, 500),
(3230200, 4006000, 1, 1, 0, 10000),
(3230200, 4010001, 1, 1, 0, 9000),
(3230200, 1082050, 1, 1, 0, 1000),
(3230200, 1082005, 1, 1, 0, 1000),
(3230200, 1072106, 1, 1, 0, 800),
(3230200, 1092007, 1, 1, 0, 700),
(3230200, 1072102, 1, 1, 0, 800),
(3230200, 1002176, 1, 1, 0, 1500),
(3230200, 1041065, 1, 1, 0, 800),
(3230200, 1061060, 1, 1, 0, 800),
(3230200, 1051027, 1, 1, 0, 700),
(3230200, 1302009, 1, 1, 0, 700),
(3230200, 1452007, 1, 1, 0, 500),
(3230200, 1002152, 1, 1, 0, 1500),
(3230200, 1002625, 1, 1, 0, 1500),
(3230200, 2044807, 1, 1, 0, 300),
(3230200, 4130009, 1, 1, 0, 6000),
(3230200, 4130014, 1, 1, 0, 6000),
(3230300, 4000067, 1, 1, 0, 400000),
(3230300, 2000002, 1, 1, 0, 20000),
(3230300, 2000003, 1, 1, 0, 20000),
(3230300, 4020000, 1, 1, 0, 9000),
(3230300, 4010001, 1, 1, 0, 9000),
(3230300, 4004000, 1, 1, 0, 10000),
(3230300, 4004001, 1, 1, 0, 10000),
(3230300, 4004002, 1, 1, 0, 10000),
(3230300, 4004003, 1, 1, 0, 10000),
(3230302, 4000099, 1, 1, 0, 600000),
(3230302, 4131008, 1, 1, 0, 6000),
(3230302, 2060000, 1, 1, 0, 30000),
(3230302, 2061000, 1, 1, 0, 30000),
(3230302, 4010006, 1, 1, 0, 9000),
(3230302, 4020004, 1, 1, 0, 9000),
(3230302, 4004003, 1, 1, 0, 10000),
(3230302, 2000002, 1, 1, 0, 20000),
(3230302, 2000003, 1, 1, 0, 20000),
(3230302, 2041023, 1, 1, 0, 300),
(3230302, 1072040, 1, 1, 0, 800),
(3230302, 1072078, 1, 1, 0, 800),
(3230302, 1472010, 1, 1, 0, 500),
(3230302, 1002141, 1, 1, 0, 1500),
(3230302, 1040075, 1, 1, 0, 800),
(3230302, 1060064, 1, 1, 0, 800),
(3230302, 1051009, 1, 1, 0, 700),
(3230302, 1442009, 1, 1, 0, 700),
(3230302, 1040082, 1, 1, 0, 800),
(3230302, 1060071, 1, 1, 0, 800),
(3230302, 1462006, 1, 1, 0, 500),
(3230302, 1052110, 1, 1, 0, 700),
(3230302, 4130005, 1, 1, 0, 6000),
(3230302, 4130012, 1, 1, 0, 6000),
(3230302, 4130013, 1, 1, 0, 6000),
(3230303, 4000104, 1, 1, 0, 600000),
(3230303, 1092021, 1, 1, 0, 700),
(3230303, 4131007, 1, 1, 0, 6000),
(3230303, 2060000, 1, 1, 0, 30000),
(3230303, 2061000, 1, 1, 0, 30000),
(3230303, 4010005, 1, 1, 0, 9000),
(3230303, 4020004, 1, 1, 0, 9000),
(3230303, 4004001, 1, 1, 0, 10000),
(3230303, 2000002, 1, 1, 0, 20000),
(3230303, 2000003, 1, 1, 0, 20000),
(3230303, 2043301, 1, 1, 0, 300),
(3230303, 1372003, 1, 1, 0, 700),
(3230303, 1312005, 1, 1, 0, 700),
(3230303, 1322003, 1, 1, 0, 700),
(3230303, 1402010, 1, 1, 0, 700),
(3230303, 1072104, 1, 1, 0, 800),
(3230303, 1072091, 1, 1, 0, 800),
(3230303, 1082046, 1, 1, 0, 1000),
(3230303, 1041084, 1, 1, 0, 800),
(3230303, 1061083, 1, 1, 0, 800),
(3230303, 1041081, 1, 1, 0, 800),
(3230303, 1061080, 1, 1, 0, 800),
(3230303, 1002181, 1, 1, 0, 1500),
(3230303, 1002092, 1, 1, 0, 1500),
(3230303, 1082080, 1, 1, 0, 1000),
(3230303, 1472018, 1, 1, 0, 500),
(3230303, 1462007, 1, 1, 0, 500),
(3230303, 1402003, 1, 1, 0, 700),
(3230303, 1002145, 1, 1, 0, 1500),
(3230303, 1482005, 1, 1, 0, 500),
(3230303, 2044312, 1, 1, 0, 300),
(3230303, 4130009, 1, 1, 0, 6000),
(3230303, 4130010, 1, 1, 0, 6000),
(3230303, 4130012, 1, 1, 0, 6000),
(3230304, 4000105, 1, 1, 0, 600000),
(3230304, 4131005, 1, 1, 0, 6000),
(3230304, 2060000, 1, 1, 0, 30000),
(3230304, 2061000, 1, 1, 0, 30000),
(3230304, 4010001, 1, 1, 0, 9000),
(3230304, 4004003, 1, 1, 0, 10000),
(3230304, 4020005, 1, 1, 0, 9000),
(3230304, 2000002, 1, 1, 0, 20000),
(3230304, 2000003, 1, 1, 0, 20000),
(3230304, 2040302, 1, 1, 0, 300),
(3230304, 1382018, 1, 1, 0, 700),
(3230304, 1472012, 1, 1, 0, 500),
(3230304, 1432003, 1, 1, 0, 500),
(3230304, 1462005, 1, 1, 0, 500),
(3230304, 1002183, 1, 1, 0, 1500),
(3230304, 1002167, 1, 1, 0, 1500),
(3230304, 1040086, 1, 1, 0, 800),
(3230304, 1060075, 1, 1, 0, 800),
(3230304, 1041076, 1, 1, 0, 800),
(3230304, 1061071, 1, 1, 0, 800),
(3230304, 1072000, 1, 1, 0, 800),
(3230304, 1032018, 1, 1, 0, 1000),
(3230304, 1082082, 1, 1, 0, 1000),
(3230304, 1082085, 1, 1, 0, 1000),
(3230304, 1072129, 1, 1, 0, 800),
(3230304, 1082010, 1, 1, 0, 1000),
(3230304, 1052110, 1, 1, 0, 700),
(3230304, 2040316, 1, 1, 0, 300),
(3230304, 2049000, 1, 1, 0, 150),
(3230304, 4130002, 1, 1, 0, 6000),
(3230304, 4130017, 1, 1, 0, 6000),
(3230305, 4000110, 1, 1, 0, 600000),
(3230305, 4000003, 1, 1, 0, 600000),
(3230305, 4000018, 1, 1, 0, 600000),
(3230305, 2060000, 1, 1, 0, 30000),
(3230305, 2061000, 1, 1, 0, 30000),
(3230305, 4020003, 1, 1, 0, 9000),
(3230305, 4004001, 1, 1, 0, 10000),
(3230305, 2000002, 1, 1, 0, 20000),
(3230305, 2000003, 1, 1, 0, 20000),
(3230305, 2041001, 1, 1, 0, 300),
(3230305, 1032002, 1, 1, 0, 1000),
(3230305, 1041066, 1, 1, 0, 800),
(3230305, 1061061, 1, 1, 0, 800),
(3230305, 1040029, 1, 1, 0, 800),
(3230305, 1060020, 1, 1, 0, 800),
(3230305, 1002184, 1, 1, 0, 1500),
(3230305, 1002099, 1, 1, 0, 1500),
(3230305, 1082064, 1, 1, 0, 1000),
(3230305, 1082075, 1, 1, 0, 1000),
(3230305, 1072119, 1, 1, 0, 800),
(3230305, 1442009, 1, 1, 0, 700),
(3230305, 1051033, 1, 1, 0, 700),
(3230305, 1492005, 1, 1, 0, 500),
(3230305, 2330001, 1, 1, 0, 500),
(3230305, 2040926, 1, 1, 0, 300),
(3230305, 4130003, 1, 1, 0, 6000),
(3230305, 4130004, 1, 1, 0, 6000),
(3230305, 4130014, 1, 1, 0, 6000),
(3230306, 4000115, 1, 1, 0, 600000),
(3230306, 1092021, 1, 1, 0, 700),
(3230306, 2002006, 1, 1, 0, 20000),
(3230306, 2060000, 1, 1, 0, 30000),
(3230306, 2061000, 1, 1, 0, 30000),
(3230306, 4010006, 1, 1, 0, 9000),
(3230306, 4004002, 1, 1, 0, 10000),
(3230306, 4010001, 1, 1, 0, 9000),
(3230306, 2000002, 1, 1, 0, 20000),
(3230306, 2000003, 1, 1, 0, 20000),
(3230306, 2043702, 1, 1, 0, 300),
(3230306, 2044201, 1, 1, 0, 300),
(3230306, 4006000, 1, 1, 0, 10000),
(3230306, 1072032, 1, 1, 0, 800),
(3230306, 1072041, 1, 1, 0, 800),
(3230306, 1051006, 1, 1, 0, 700),
(3230306, 1082069, 1, 1, 0, 1000),
(3230306, 1072089, 1, 1, 0, 800),
(3230306, 1041069, 1, 1, 0, 800),
(3230306, 1061064, 1, 1, 0, 800),
(3230306, 1002182, 1, 1, 0, 1500),
(3230306, 1002155, 1, 1, 0, 1500),
(3230306, 1040085, 1, 1, 0, 800),
(3230306, 1060074, 1, 1, 0, 800),
(3230306, 1492005, 1, 1, 0, 500),
(3230306, 2044901, 1, 1, 0, 300),
(3230306, 4130000, 1, 1, 0, 6000),
(3230306, 4130010, 1, 1, 0, 6000),
(3230307, 4000123, 1, 1, 0, 600000),
(3230307, 2060000, 1, 1, 0, 30000),
(3230307, 2061000, 1, 1, 0, 30000),
(3230307, 4004001, 1, 1, 0, 10000),
(3230307, 4020008, 1, 1, 0, 9000),
(3230307, 4010001, 1, 1, 0, 9000),
(3230307, 2000002, 1, 1, 0, 20000),
(3230307, 2000003, 1, 1, 0, 20000),
(3230307, 4003004, 1, 1, 0, 200000),
(3230307, 4000003, 1, 1, 0, 600000),
(3230307, 1051004, 1, 1, 0, 700),
(3230307, 1332004, 1, 1, 0, 500),
(3230307, 1040069, 1, 1, 0, 800),
(3230307, 1060058, 1, 1, 0, 800),
(3230307, 1002036, 1, 1, 0, 1500),
(3230307, 1312005, 1, 1, 0, 700),
(3230307, 1082008, 1, 1, 0, 1000),
(3230307, 1072104, 1, 1, 0, 800),
(3230307, 1302004, 1, 1, 0, 700),
(3230307, 1002183, 1, 1, 0, 1500),
(3230307, 1002152, 1, 1, 0, 1500),
(3230307, 1072120, 1, 1, 0, 800),
(3230307, 1082023, 1, 1, 0, 1000),
(3230307, 1482004, 1, 1, 0, 500),
(3230307, 2040929, 1, 1, 0, 300),
(3230307, 2044110, 1, 1, 0, 300),
(3230307, 4130010, 1, 1, 0, 6000),
(3230307, 4130013, 1, 1, 0, 6000),
(3230308, 4000116, 1, 1, 0, 600000),
(3230308, 2002008, 1, 1, 0, 20000),
(3230308, 2060000, 1, 1, 0, 30000),
(3230308, 2061000, 1, 1, 0, 30000),
(3230308, 4020008, 1, 1, 0, 9000),
(3230308, 4004002, 1, 1, 0, 10000),
(3230308, 2000002, 1, 1, 0, 20000),
(3230308, 2000003, 1, 1, 0, 20000),
(3230308, 4020001, 1, 1, 0, 9000),
(3230308, 2040902, 1, 1, 0, 300),
(3230308, 1322003, 1, 1, 0, 700),
(3230308, 4003005, 1, 1, 0, 200000),
(3230308, 4000003, 1, 1, 0, 600000),
(3230308, 1402006, 1, 1, 0, 700),
(3230308, 1422008, 1, 1, 0, 700),
(3230308, 1372000, 1, 1, 0, 700),
(3230308, 1072107, 1, 1, 0, 800),
(3230308, 1072120, 1, 1, 0, 800),
(3230308, 1072115, 1, 1, 0, 800),
(3230308, 1092012, 1, 1, 0, 700),
(3230308, 1082073, 1, 1, 0, 1000),
(3230308, 1041085, 1, 1, 0, 800),
(3230308, 1061084, 1, 1, 0, 800),
(3230308, 1051033, 1, 1, 0, 700),
(3230308, 1082065, 1, 1, 0, 1000),
(3230308, 1082010, 1, 1, 0, 1000),
(3230308, 1082083, 1, 1, 0, 1000),
(3230308, 1482005, 1, 1, 0, 500),
(3230308, 2043210, 1, 1, 0, 300),
(3230308, 4130004, 1, 1, 0, 6000),
(3230308, 4130006, 1, 1, 0, 6000),
(3230308, 4130015, 1, 1, 0, 6000),
(3230400, 4000127, 1, 1, 0, 600000),
(3230400, 2000002, 1, 1, 0, 20000),
(3230400, 2000003, 1, 1, 0, 20000),
(3230400, 2060000, 1, 1, 0, 30000),
(3230400, 2061000, 1, 1, 0, 30000),
(3230400, 4010001, 1, 1, 0, 9000),
(3230400, 4020007, 1, 1, 0, 9000),
(3230400, 4006001, 1, 1, 0, 10000),
(3230400, 4004004, 1, 1, 0, 10000),
(3230400, 1092008, 1, 1, 0, 700),
(3230400, 2070002, 1, 1, 0, 500),
(3230400, 1302013, 1, 1, 0, 700),
(3230400, 1402008, 1, 1, 0, 700),
(3230400, 1041033, 1, 1, 0, 800),
(3230400, 1062006, 1, 1, 0, 800),
(3230400, 1041049, 1, 1, 0, 800),
(3230400, 1061045, 1, 1, 0, 800),
(3230400, 1050011, 1, 1, 0, 700),
(3230400, 1082053, 1, 1, 0, 1000),
(3230400, 1040074, 1, 1, 0, 800),
(3230400, 1060063, 1, 1, 0, 800),
(3230400, 1002144, 1, 1, 0, 1500),
(3230400, 1372000, 1, 1, 0, 700),
(3230400, 1492004, 1, 1, 0, 500),
(3230400, 2044901, 1, 1, 0, 300),
(3230400, 2044414, 1, 1, 0, 300),
(3230400, 2049100, 1, 1, 0, 150),
(3230400, 4130001, 1, 1, 0, 6000),
(3230400, 4130008, 1, 1, 0, 6000),
(3230400, 4130015, 1, 1, 0, 6000),
(3230405, 4000154, 1, 1, 0, 600000),
(3230405, 2002005, 1, 1, 0, 20000),
(3230405, 4131005, 1, 1, 0, 6000),
(3230405, 2060000, 1, 1, 0, 30000),
(3230405, 2061000, 1, 1, 0, 30000),
(3230405, 4010001, 1, 1, 0, 9000),
(3230405, 1372012, 1, 1, 0, 700),
(3230405, 4010000, 1, 1, 0, 9000),
(3230405, 4020002, 1, 1, 0, 9000),
(3230405, 2000002, 1, 1, 0, 20000),
(3230405, 2000003, 1, 1, 0, 20000),
(3230405, 2040302, 1, 1, 0, 300),
(3230405, 1082054, 1, 1, 0, 1000),
(3230405, 1060062, 1, 1, 0, 800),
(3230405, 1040073, 1, 1, 0, 800),
(3230405, 1002177, 1, 1, 0, 1500),
(3230405, 1051023, 1, 1, 0, 700),
(3230405, 1302009, 1, 1, 0, 700),
(3230405, 1312007, 1, 1, 0, 700),
(3230405, 1332011, 1, 1, 0, 500),
(3230405, 1332031, 1, 1, 0, 500),
(3230405, 1072122, 1, 1, 0, 800),
(3230405, 1072128, 1, 1, 0, 800),
(3230405, 1082009, 1, 1, 0, 1000),
(3230405, 1082192, 1, 1, 0, 1000),
(3230405, 2044410, 1, 1, 0, 300),
(3230405, 4130009, 1, 1, 0, 6000),
(3230405, 4130013, 1, 1, 0, 6000),
(4110300, 2000002, 1, 1, 0, 20000),
(4110300, 2000003, 1, 1, 0, 20000),
(4110300, 4010006, 1, 1, 0, 9000),
(4110300, 4020007, 1, 1, 0, 9000),
(4110300, 2000004, 1, 1, 0, 20000),
(4110300, 2060000, 1, 1, 0, 30000),
(4110300, 2061000, 1, 1, 0, 30000),
(4110300, 4004004, 1, 1, 0, 10000),
(4110300, 2041019, 1, 1, 0, 300),
(4110300, 1002045, 1, 1, 0, 1500),
(4110300, 1061062, 1, 1, 0, 800),
(4110300, 1041067, 1, 1, 0, 800),
(4110300, 1050037, 1, 1, 0, 700),
(4110300, 1041076, 1, 1, 0, 800),
(4110300, 1060073, 1, 1, 0, 800),
(4110300, 1412005, 1, 1, 0, 700),
(4110300, 1452007, 1, 1, 0, 500),
(4110300, 1002213, 1, 1, 0, 1500),
(4110300, 1002085, 1, 1, 0, 1500),
(4110300, 1032012, 1, 1, 0, 1000),
(4110300, 1040096, 1, 1, 0, 800),
(4110300, 1060085, 1, 1, 0, 800),
(4110300, 4000357, 1, 1, 0, 600000),
(4110300, 1052116, 1, 1, 0, 700),
(4110300, 2330002, 1, 1, 0, 500),
(4110300, 4130002, 1, 1, 0, 6000),
(4110300, 4130012, 1, 1, 0, 6000),
(4110300, 4130013, 1, 1, 0, 6000),
(4110301, 2000002, 1, 1, 0, 20000),
(4110301, 2000003, 1, 1, 0, 20000),
(4110301, 4010002, 1, 1, 0, 9000),
(4110301, 4010004, 1, 1, 0, 9000),
(4110301, 4004000, 1, 1, 0, 10000),
(4110301, 2060000, 1, 1, 0, 30000),
(4110301, 2061000, 1, 1, 0, 30000),
(4110301, 2040504, 1, 1, 0, 300),
(4110301, 2044002, 1, 1, 0, 300),
(4110301, 1002085, 1, 1, 0, 1500),
(4110301, 1382001, 1, 1, 0, 700),
(4110301, 1082010, 1, 1, 0, 1000),
(4110301, 1041077, 1, 1, 0, 800),
(4110301, 4000358, 1, 1, 0, 600000),
(4110301, 4130007, 1, 1, 0, 6000),
(4110301, 4130012, 1, 1, 0, 6000),
(4110302, 2000002, 1, 1, 0, 20000),
(4110302, 2000003, 1, 1, 0, 20000),
(4110302, 4020000, 1, 1, 0, 9000),
(4110302, 4020006, 1, 1, 0, 9000),
(4110302, 4130012, 1, 1, 0, 6000),
(4110302, 2044102, 1, 1, 0, 300),
(4110302, 1372007, 1, 1, 0, 700),
(4110302, 1002215, 1, 1, 0, 1500),
(4110302, 4006001, 1, 1, 0, 10000),
(4110302, 1040089, 1, 1, 0, 800),
(4110302, 1050045, 1, 1, 0, 700),
(4110302, 4004002, 1, 1, 0, 10000),
(4110302, 2040001, 1, 1, 0, 300),
(4110302, 4000359, 1, 1, 0, 600000),
(4110302, 1082198, 1, 1, 0, 1000),
(4130100, 4000014, 1, 1, 0, 600000),
(4130100, 4020008, 1, 1, 0, 9000),
(4130100, 2000002, 1, 1, 0, 20000),
(4130100, 2000004, 1, 1, 0, 20000),
(4130100, 4010005, 1, 1, 0, 9000),
(4130100, 4000030, 1, 1, 0, 60000),
(4130100, 2000003, 1, 1, 0, 20000),
(4130100, 4006001, 1, 1, 0, 10000),
(4130100, 1050022, 1, 1, 0, 700),
(4130100, 1002138, 1, 1, 0, 1500),
(4130100, 1322016, 1, 1, 0, 700),
(4130100, 1082064, 1, 1, 0, 1000),
(4130100, 1060069, 1, 1, 0, 800),
(4130100, 1040079, 1, 1, 0, 800),
(4130100, 1002045, 1, 1, 0, 1500),
(4130100, 1382001, 1, 1, 0, 700),
(4130100, 1050046, 1, 1, 0, 700),
(4130100, 1302010, 1, 1, 0, 700),
(4130100, 1332016, 1, 1, 0, 500),
(4130100, 1072133, 1, 1, 0, 800),
(4130100, 1072125, 1, 1, 0, 800),
(4130100, 1052113, 1, 1, 0, 700),
(4130100, 2040025, 1, 1, 0, 300),
(4130100, 2040621, 1, 1, 0, 300),
(4130100, 2044014, 1, 1, 0, 300),
(4130100, 2049100, 1, 1, 0, 150),
(4130100, 4130006, 1, 1, 0, 6000),
(4130100, 4130016, 1, 1, 0, 6000),
(4130101, 4000045, 1, 1, 0, 600000),
(4130101, 2041013, 1, 1, 0, 300),
(4130101, 2000002, 1, 1, 0, 20000),
(4130101, 2000004, 1, 1, 0, 20000),
(4130101, 2000003, 1, 1, 0, 20000),
(4130101, 4020001, 1, 1, 0, 9000),
(4130101, 4010002, 1, 1, 0, 9000),
(4130101, 2040805, 1, 1, 0, 300),
(4130101, 1472016, 1, 1, 0, 500),
(4130101, 1002152, 1, 1, 0, 1500),
(4130101, 1002183, 1, 1, 0, 1500),
(4130101, 1041081, 1, 1, 0, 800),
(4130101, 1061080, 1, 1, 0, 800),
(4130101, 1402003, 1, 1, 0, 700),
(4130101, 1092004, 1, 1, 0, 700),
(4130101, 1072124, 1, 1, 0, 800),
(4130101, 1072142, 1, 1, 0, 800),
(4130101, 1061088, 1, 1, 0, 800),
(4130101, 1041089, 1, 1, 0, 800),
(4130101, 1061078, 1, 1, 0, 800),
(4130101, 1041079, 1, 1, 0, 800),
(4130101, 1072303, 1, 1, 0, 800),
(4130101, 2040923, 1, 1, 0, 300),
(4130101, 4130003, 1, 1, 0, 6000),
(4130101, 4130005, 1, 1, 0, 6000),
(4130101, 4130009, 1, 1, 0, 6000),
(4130102, 4000062, 1, 1, 0, 600000),
(4130102, 2041014, 1, 1, 0, 300),
(4130102, 4004004, 1, 1, 0, 10000),
(4130102, 2000002, 1, 1, 0, 20000),
(4130102, 2000004, 1, 1, 0, 20000),
(4130102, 2000003, 1, 1, 0, 20000),
(4130102, 4020006, 1, 1, 0, 9000),
(4130102, 4010003, 1, 1, 0, 9000),
(4130102, 4004000, 1, 1, 0, 10000),
(4130102, 1302013, 1, 1, 0, 700),
(4130102, 2044201, 1, 1, 0, 300),
(4130102, 4006001, 1, 1, 0, 10000),
(4130102, 1051027, 1, 1, 0, 700),
(4130102, 1002092, 1, 1, 0, 1500),
(4130102, 1040080, 1, 1, 0, 800),
(4130102, 1060068, 1, 1, 0, 800),
(4130102, 1072110, 1, 1, 0, 800),
(4130102, 1082063, 1, 1, 0, 1000),
(4130102, 1041087, 1, 1, 0, 800),
(4130102, 1061086, 1, 1, 0, 800),
(4130102, 1040095, 1, 1, 0, 800),
(4130102, 1060084, 1, 1, 0, 800),
(4130102, 1082084, 1, 1, 0, 1000),
(4130102, 1072132, 1, 1, 0, 800),
(4130102, 4130000, 1, 1, 0, 6000),
(4130102, 4130003, 1, 1, 0, 6000),
(4130102, 4130013, 1, 1, 0, 6000),
(4130103, 4000124, 1, 1, 0, 600000),
(4130103, 2060000, 1, 1, 0, 300000),
(4130103, 2061000, 1, 1, 0, 300000),
(4130103, 2000002, 1, 1, 0, 200000),
(4130103, 2000004, 1, 1, 0, 999999),
(4130103, 4131009, 1, 1, 0, 60000),
(4130103, 4010000, 1, 1, 0, 90000),
(4130103, 4005002, 1, 1, 0, 10000),
(4130103, 2040902, 1, 1, 0, 3000),
(4130103, 4020007, 1, 1, 0, 90000),
(4130103, 4020000, 1, 1, 0, 90000),
(4130103, 4006000, 1, 1, 0, 100000),
(4130103, 1060052, 1, 1, 0, 8000),
(4130103, 1040063, 1, 1, 0, 8000),
(4130103, 1442009, 1, 1, 0, 7000),
(4130103, 1082071, 1, 1, 0, 10000),
(4130103, 1462006, 1, 1, 0, 5000),
(4130103, 1051032, 1, 1, 0, 7000),
(4130103, 1372007, 1, 1, 0, 7000),
(4130103, 1472019, 1, 1, 0, 5000),
(4130103, 1072129, 1, 1, 0, 8000),
(4130103, 1432004, 1, 1, 0, 5000),
(4130103, 1072140, 1, 1, 0, 8000),
(4130103, 1082085, 1, 1, 0, 10000),
(4130103, 1312008, 1, 1, 0, 7000),
(4130103, 1492007, 1, 1, 0, 5000),
(4130103, 2043210, 1, 1, 0, 3000),
(4130103, 4130002, 1, 1, 0, 60000),
(4130103, 4130004, 1, 1, 0, 60000),
(4130103, 4130012, 1, 1, 0, 60000),
(4220000, 4000166, 1, 1, 0, 600000),
(4220000, 4000166, 1, 1, 0, 600000),
(4220000, 4000166, 1, 1, 0, 600000),
(4220000, 4000167, 1, 1, 0, 600000),
(4220000, 4000167, 1, 1, 0, 600000),
(4220000, 4000167, 1, 1, 0, 600000),
(4220000, 4010003, 1, 1, 0, 90000),
(4220000, 4020004, 1, 1, 0, 90000),
(4220000, 2000002, 1, 1, 0, 200000),
(4220000, 2000003, 1, 1, 0, 200000),
(4220000, 2040301, 1, 1, 0, 3000),
(4220000, 2040302, 1, 1, 0, 3000),
(4220000, 2040516, 1, 1, 0, 3000),
(4220000, 2040517, 1, 1, 0, 3000),
(4220000, 2040704, 1, 1, 0, 3000),
(4220000, 2040705, 1, 1, 0, 3000),
(4220000, 2040804, 1, 1, 0, 3000),
(4220000, 2040805, 1, 1, 0, 3000),
(4220000, 2041007, 1, 1, 0, 3000),
(4220000, 2041008, 1, 1, 0, 3000),
(4220000, 1302010, 1, 1, 0, 7000),
(4220000, 1312008, 1, 1, 0, 7000),
(4220000, 1322017, 1, 1, 0, 7000),
(4220000, 1402003, 1, 1, 0, 7000),
(4220000, 1412003, 1, 1, 0, 7000),
(4220000, 1422005, 1, 1, 0, 7000),
(4220000, 1432004, 1, 1, 0, 5000),
(4220000, 1442005, 1, 1, 0, 7000),
(4220000, 1452008, 1, 1, 0, 5000),
(4220000, 1462007, 1, 1, 0, 5000),
(4220000, 1332003, 1, 1, 0, 5000),
(4220000, 1472020, 1, 1, 0, 5000),
(4220000, 1332016, 1, 1, 0, 5000),
(4220000, 1482007, 1, 1, 0, 5000),
(4220000, 1492007, 1, 1, 0, 5000),
(4220000, 1382006, 1, 1, 0, 7000),
(4220000, 1372007, 1, 1, 0, 7000),
(4220000, 1442039, 1, 1, 0, 7000),
(4220000, 2040029, 1, 1, 0, 3000),
(4220000, 2040326, 1, 1, 0, 3000),
(4220000, 2044809, 1, 1, 0, 3000),
(4220000, 2049100, 1, 1, 0, 3000),
(4230100, 4000023, 1, 1, 0, 600000),
(4230100, 2040001, 1, 1, 0, 300),
(4230100, 2000002, 1, 1, 0, 20000),
(4230100, 4010006, 1, 1, 0, 9000),
(4230100, 2000003, 1, 1, 0, 20000),
(4230100, 4010001, 1, 1, 0, 9000),
(4230100, 1002103, 1, 1, 0, 1500),
(4230100, 2070010, 1, 1, 0, 500),
(4230100, 1462004, 1, 1, 0, 500),
(4230100, 1472013, 1, 1, 0, 500),
(4230100, 1412004, 1, 1, 0, 700),
(4230100, 1072090, 1, 1, 0, 800),
(4230100, 1472017, 1, 1, 0, 500),
(4230100, 1002166, 1, 1, 0, 1500),
(4230100, 1002098, 1, 1, 0, 1500),
(4230100, 1002169, 1, 1, 0, 1500),
(4230100, 1041075, 1, 1, 0, 800),
(4230100, 1061070, 1, 1, 0, 800),
(4230100, 1072132, 1, 1, 0, 800),
(4230100, 1072140, 1, 1, 0, 800),
(4230100, 1082066, 1, 1, 0, 1000),
(4230100, 1032008, 1, 1, 0, 1000),
(4230100, 4010005, 1, 1, 0, 9000),
(4230100, 1060057, 1, 1, 0, 800),
(4230100, 2000006, 1, 1, 0, 20000),
(4230100, 2044412, 1, 1, 0, 300),
(4230100, 2049100, 1, 1, 0, 150),
(4230100, 4130004, 1, 1, 0, 6000),
(4230100, 4130005, 1, 1, 0, 6000),
(4230100, 4130009, 1, 1, 0, 6000),
(4230101, 2000002, 1, 1, 0, 20000),
(4230101, 4003004, 1, 1, 0, 200000),
(4230101, 2000003, 1, 1, 0, 20000),
(4230101, 4010005, 1, 1, 0, 9000),
(4230101, 4020001, 1, 1, 0, 9000),
(4230101, 1462006, 1, 1, 0, 500),
(4230101, 4000031, 1, 1, 0, 600000),
(4230101, 1051009, 1, 1, 0, 700),
(4230101, 1051001, 1, 1, 0, 700),
(4230101, 1040074, 1, 1, 0, 800),
(4230101, 1060063, 1, 1, 0, 800),
(4230101, 1050039, 1, 1, 0, 700),
(4230101, 1002185, 1, 1, 0, 1500),
(4230101, 1002151, 1, 1, 0, 1500),
(4230101, 1041086, 1, 1, 0, 800),
(4230101, 1061085, 1, 1, 0, 800),
(4230101, 1472015, 1, 1, 0, 500),
(4230101, 1382001, 1, 1, 0, 700),
(4230101, 1462007, 1, 1, 0, 500),
(4230101, 1442005, 1, 1, 0, 700),
(4230101, 1332003, 1, 1, 0, 500),
(4230101, 1040000, 1, 1, 0, 800),
(4230101, 1082037, 1, 1, 0, 1000),
(4230101, 1041068, 1, 1, 0, 800),
(4230101, 1002628, 1, 1, 0, 1500),
(4230101, 2044314, 1, 1, 0, 300),
(4230101, 4130000, 1, 1, 0, 6000),
(4230101, 4130005, 1, 1, 0, 6000),
(4230101, 4130012, 1, 1, 0, 6000),
(4230102, 4000036, 1, 1, 0, 600000),
(4230102, 4004004, 1, 1, 0, 10000),
(4230102, 2000002, 1, 1, 0, 20000),
(4230102, 2000004, 1, 1, 0, 20000),
(4230102, 2000003, 1, 1, 0, 20000),
(4230102, 4010001, 1, 1, 0, 9000),
(4230102, 4020000, 1, 1, 0, 9000),
(4230102, 1302013, 1, 1, 0, 700),
(4230102, 4006001, 1, 1, 0, 10000),
(4230102, 1032008, 1, 1, 0, 1000),
(4230102, 1060050, 1, 1, 0, 800),
(4230102, 1040061, 1, 1, 0, 800),
(4230102, 1040085, 1, 1, 0, 800),
(4230102, 1060074, 1, 1, 0, 800),
(4230102, 1002099, 1, 1, 0, 1500),
(4230102, 1002207, 1, 1, 0, 1500),
(4230102, 1002211, 1, 1, 0, 1500),
(4230102, 1002215, 1, 1, 0, 1500),
(4230102, 1002212, 1, 1, 0, 1500),
(4230102, 1082066, 1, 1, 0, 1000);
INSERT IGNORE INTO `temp_data` (`dropperid`, `itemid`, `minimum_quantity`, `maximum_quantity`, `questid`, `chance`) VALUES
(4230102, 1072141, 1, 1, 0, 800),
(4230102, 1072303, 1, 1, 0, 800),
(4230102, 2330002, 1, 1, 0, 500),
(4230102, 2040026, 1, 1, 0, 300),
(4230102, 4130007, 1, 1, 0, 6000),
(4230102, 4130008, 1, 1, 0, 6000),
(4230103, 4000039, 1, 1, 0, 600000),
(4230103, 2000002, 1, 1, 0, 20000),
(4230103, 2000003, 1, 1, 0, 20000),
(4230103, 4020005, 1, 1, 0, 9000),
(4230103, 4010003, 1, 1, 0, 9000),
(4230103, 2000004, 1, 1, 0, 20000),
(4230103, 2060000, 1, 1, 0, 30000),
(4230103, 2061000, 1, 1, 0, 30000),
(4230103, 1332001, 1, 1, 0, 500),
(4230103, 1312006, 1, 1, 0, 700),
(4230103, 1002179, 1, 1, 0, 1500),
(4230103, 1092014, 1, 1, 0, 700),
(4230103, 1072121, 1, 1, 0, 800),
(4230103, 1072114, 1, 1, 0, 800),
(4230103, 1082076, 1, 1, 0, 1000),
(4230103, 1002151, 1, 1, 0, 1500),
(4230103, 1051034, 1, 1, 0, 700),
(4230103, 1472019, 1, 1, 0, 500),
(4230103, 1322017, 1, 1, 0, 700),
(4230103, 1050051, 1, 1, 0, 700),
(4230103, 2040027, 1, 1, 0, 300),
(4230103, 4130007, 1, 1, 0, 6000),
(4230103, 4130008, 1, 1, 0, 6000),
(4230104, 4000044, 1, 1, 0, 600000),
(4230104, 2000004, 1, 1, 0, 20000),
(4230104, 2000003, 1, 1, 0, 20000),
(4230104, 4010003, 1, 1, 0, 9000),
(4230104, 4020002, 1, 1, 0, 9000),
(4230104, 1302016, 1, 1, 0, 700),
(4230104, 2043201, 1, 1, 0, 300),
(4230104, 1040083, 1, 1, 0, 800),
(4230104, 1060072, 1, 1, 0, 800),
(4230104, 1061081, 1, 1, 0, 800),
(4230104, 1041082, 1, 1, 0, 800),
(4230104, 1002025, 1, 1, 0, 1500),
(4230104, 1382001, 1, 1, 0, 700),
(4230104, 1002217, 1, 1, 0, 1500),
(4230104, 1002085, 1, 1, 0, 1500),
(4230104, 1041087, 1, 1, 0, 800),
(4230104, 1061086, 1, 1, 0, 800),
(4230104, 1060084, 1, 1, 0, 800),
(4230104, 1040095, 1, 1, 0, 800),
(4230104, 1412003, 1, 1, 0, 700),
(4230104, 1482007, 1, 1, 0, 500),
(4230104, 2040427, 1, 1, 0, 300),
(4230104, 4130005, 1, 1, 0, 6000),
(4230104, 4130015, 1, 1, 0, 6000),
(4230104, 4130017, 1, 1, 0, 6000),
(4230105, 4000058, 1, 1, 0, 600000),
(4230105, 2041011, 1, 1, 0, 300),
(4230105, 2000002, 1, 1, 0, 20000),
(4230105, 2000003, 1, 1, 0, 20000),
(4230105, 4020003, 1, 1, 0, 9000),
(4230105, 4010000, 1, 1, 0, 9000),
(4230105, 4004003, 1, 1, 0, 10000),
(4230105, 2041001, 1, 1, 0, 300),
(4230105, 1332020, 1, 1, 0, 500),
(4230105, 1072103, 1, 1, 0, 800),
(4230105, 1002182, 1, 1, 0, 1500),
(4230105, 1002098, 1, 1, 0, 1500),
(4230105, 1041083, 1, 1, 0, 800),
(4230105, 1061082, 1, 1, 0, 800),
(4230105, 1040083, 1, 1, 0, 800),
(4230105, 1060072, 1, 1, 0, 800),
(4230105, 1382019, 1, 1, 0, 700),
(4230105, 1472015, 1, 1, 0, 500),
(4230105, 1050048, 1, 1, 0, 700),
(4230105, 1051038, 1, 1, 0, 700),
(4230105, 1082011, 1, 1, 0, 1000),
(4230105, 1072130, 1, 1, 0, 800),
(4230105, 2022039, 1, 1, 0, 20000),
(4230105, 4130004, 1, 1, 0, 6000),
(4230105, 4130013, 1, 1, 0, 6000),
(4230106, 4000060, 1, 1, 0, 600000),
(4230106, 4003004, 1, 1, 0, 200000),
(4230106, 2000002, 1, 1, 0, 20000),
(4230106, 2000003, 1, 1, 0, 20000),
(4230106, 4020005, 1, 1, 0, 9000),
(4230106, 4010004, 1, 1, 0, 9000),
(4230106, 4004001, 1, 1, 0, 10000),
(4230106, 2060000, 1, 1, 0, 30000),
(4230106, 2061000, 1, 1, 0, 30000),
(4230106, 1302016, 1, 1, 0, 700),
(4230106, 2070002, 1, 1, 0, 500),
(4230106, 4006000, 1, 1, 0, 10000),
(4230106, 2040705, 1, 1, 0, 300),
(4230106, 1082036, 1, 1, 0, 1000),
(4230106, 1082045, 1, 1, 0, 1000),
(4230106, 1040081, 1, 1, 0, 800),
(4230106, 1060070, 1, 1, 0, 800),
(4230106, 1060075, 1, 1, 0, 800),
(4230106, 1040086, 1, 1, 0, 800),
(4230106, 1072118, 1, 1, 0, 800),
(4230106, 1051032, 1, 1, 0, 700),
(4230106, 1002216, 1, 1, 0, 1500),
(4230106, 1002210, 1, 1, 0, 1500),
(4230106, 1041080, 1, 1, 0, 800),
(4230106, 1061079, 1, 1, 0, 800),
(4230106, 1050052, 1, 1, 0, 700),
(4230106, 1002628, 1, 1, 0, 1500),
(4230106, 2040319, 1, 1, 0, 300),
(4230106, 2044114, 1, 1, 0, 300),
(4230106, 2044214, 1, 1, 0, 300),
(4230106, 4130003, 1, 1, 0, 6000),
(4230106, 4130007, 1, 1, 0, 6000),
(4230106, 4130009, 1, 1, 0, 6000),
(4230107, 4000076, 1, 1, 0, 600000),
(4230107, 2000002, 1, 1, 0, 20000),
(4230107, 2000003, 1, 1, 0, 20000),
(4230107, 4003004, 1, 1, 0, 200000),
(4230107, 4010005, 1, 1, 0, 9000),
(4230107, 4020004, 1, 1, 0, 9000),
(4230107, 1332020, 1, 1, 0, 500),
(4230107, 2043202, 1, 1, 0, 300),
(4230107, 2041014, 1, 1, 0, 300),
(4230107, 4004002, 1, 1, 0, 10000),
(4230107, 4006000, 1, 1, 0, 10000),
(4230107, 4020007, 1, 1, 0, 9000),
(4230107, 1040030, 1, 1, 0, 800),
(4230107, 1060020, 1, 1, 0, 800),
(4230107, 1060061, 1, 1, 0, 800),
(4230107, 1040072, 1, 1, 0, 800),
(4230107, 1050035, 1, 1, 0, 700),
(4230107, 1060071, 1, 1, 0, 800),
(4230107, 1040082, 1, 1, 0, 800),
(4230107, 1082072, 1, 1, 0, 1000),
(4230107, 1082063, 1, 1, 0, 1000),
(4230107, 1051030, 1, 1, 0, 700),
(4230107, 1072134, 1, 1, 0, 800),
(4230107, 1072129, 1, 1, 0, 800),
(4230107, 1452008, 1, 1, 0, 500),
(4230107, 4130005, 1, 1, 0, 6000),
(4230107, 4130015, 1, 1, 0, 6000),
(4230108, 4000078, 1, 1, 0, 600000),
(4230108, 2000002, 1, 1, 0, 20000),
(4230108, 2000003, 1, 1, 0, 20000),
(4230108, 4010001, 1, 1, 0, 9000),
(4230108, 4020006, 1, 1, 0, 9000),
(4230108, 4004003, 1, 1, 0, 10000),
(4230108, 4000021, 1, 1, 0, 50000),
(4230108, 4003004, 1, 1, 0, 200000),
(4230108, 2041017, 1, 1, 0, 300),
(4230108, 2070002, 1, 1, 0, 500),
(4230108, 1432008, 1, 1, 0, 500),
(4230108, 2060000, 1, 1, 0, 30000),
(4230108, 2061000, 1, 1, 0, 30000),
(4230108, 1050031, 1, 1, 0, 700),
(4230108, 1072113, 1, 1, 0, 800),
(4230108, 1072108, 1, 1, 0, 800),
(4230108, 1082073, 1, 1, 0, 1000),
(4230108, 1422007, 1, 1, 0, 700),
(4230108, 1041082, 1, 1, 0, 800),
(4230108, 1061081, 1, 1, 0, 800),
(4230108, 1472018, 1, 1, 0, 500),
(4230108, 1442005, 1, 1, 0, 700),
(4230108, 1002209, 1, 1, 0, 1500),
(4230108, 1002218, 1, 1, 0, 1500),
(4230108, 1002086, 1, 1, 0, 1500),
(4230108, 2040623, 1, 1, 0, 300),
(4230108, 4130010, 1, 1, 0, 6000),
(4230108, 4130011, 1, 1, 0, 6000),
(4230109, 4000101, 1, 1, 0, 600000),
(4230109, 2060000, 1, 1, 0, 30000),
(4230109, 2061000, 1, 1, 0, 30000),
(4230109, 4010001, 1, 1, 0, 9000),
(4230109, 4004002, 1, 1, 0, 10000),
(4230109, 2000002, 1, 1, 0, 20000),
(4230109, 2000003, 1, 1, 0, 20000),
(4230109, 2040901, 1, 1, 0, 300),
(4230109, 1032018, 1, 1, 0, 1000),
(4230109, 1402002, 1, 1, 0, 700),
(4230109, 1002180, 1, 1, 0, 1500),
(4230109, 1082070, 1, 1, 0, 1000),
(4230109, 1051024, 1, 1, 0, 700),
(4230109, 1002154, 1, 1, 0, 1500),
(4230109, 1002167, 1, 1, 0, 1500),
(4230109, 1472017, 1, 1, 0, 500),
(4230109, 1072117, 1, 1, 0, 800),
(4230109, 1040087, 1, 1, 0, 800),
(4230109, 1060076, 1, 1, 0, 800),
(4230109, 1462007, 1, 1, 0, 500),
(4230109, 1092004, 1, 1, 0, 700),
(4230109, 1482006, 1, 1, 0, 500),
(4230109, 2043212, 1, 1, 0, 300),
(4230109, 2044414, 1, 1, 0, 300),
(4230109, 4130000, 1, 1, 0, 6000),
(4230109, 4130005, 1, 1, 0, 6000),
(4230109, 4130014, 1, 1, 0, 6000),
(4230110, 4000102, 1, 1, 0, 600000),
(4230110, 2060000, 1, 1, 0, 30000),
(4230110, 2061000, 1, 1, 0, 30000),
(4230110, 4020008, 1, 1, 0, 9000),
(4230110, 4004000, 1, 1, 0, 10000),
(4230110, 2000002, 1, 1, 0, 20000),
(4230110, 2000004, 1, 1, 0, 20000),
(4230110, 2040504, 1, 1, 0, 300),
(4230110, 2044002, 1, 1, 0, 300),
(4230110, 2044301, 1, 1, 0, 300),
(4230110, 1302013, 1, 1, 0, 700),
(4230110, 1002004, 1, 1, 0, 1500),
(4230110, 1041067, 1, 1, 0, 800),
(4230110, 1061062, 1, 1, 0, 800),
(4230110, 1002144, 1, 1, 0, 1500),
(4230110, 1002170, 1, 1, 0, 1500),
(4230110, 1002181, 1, 1, 0, 1500),
(4230110, 1040082, 1, 1, 0, 800),
(4230110, 1060071, 1, 1, 0, 800),
(4230110, 1061083, 1, 1, 0, 800),
(4230110, 1041084, 1, 1, 0, 800),
(4230110, 1040088, 1, 1, 0, 800),
(4230110, 1060077, 1, 1, 0, 800),
(4230110, 1082081, 1, 1, 0, 1000),
(4230110, 1082083, 1, 1, 0, 1000),
(4230110, 1072135, 1, 1, 0, 800),
(4230110, 1082195, 1, 1, 0, 1000),
(4230110, 2044902, 1, 1, 0, 300),
(4230110, 2040618, 1, 1, 0, 300),
(4230110, 2040627, 1, 1, 0, 300),
(4230110, 2040931, 1, 1, 0, 300),
(4230110, 2044014, 1, 1, 0, 300),
(4230110, 4130002, 1, 1, 0, 6000),
(4230110, 4130010, 1, 1, 0, 6000),
(4230110, 4130011, 1, 1, 0, 6000),
(4230111, 4000111, 1, 1, 0, 600000),
(4230111, 2060000, 1, 1, 0, 30000),
(4230111, 2061000, 1, 1, 0, 30000),
(4230111, 4010002, 1, 1, 0, 9000),
(4230111, 4010004, 1, 1, 0, 9000),
(4230111, 4004001, 1, 1, 0, 10000),
(4230111, 2000002, 1, 1, 0, 20000),
(4230111, 2000003, 1, 1, 0, 20000),
(4230111, 2040602, 1, 1, 0, 300),
(4230111, 2043302, 1, 1, 0, 300),
(4230111, 1041051, 1, 1, 0, 800),
(4230111, 1061047, 1, 1, 0, 800),
(4230111, 1051007, 1, 1, 0, 700),
(4230111, 1050021, 1, 1, 0, 700),
(4230111, 1002021, 1, 1, 0, 1500),
(4230111, 1002153, 1, 1, 0, 1500),
(4230111, 1002168, 1, 1, 0, 1500),
(4230111, 1072116, 1, 1, 0, 800),
(4230111, 1072127, 1, 1, 0, 800),
(4230111, 1072123, 1, 1, 0, 800),
(4230111, 1302010, 1, 1, 0, 700),
(4230111, 1472018, 1, 1, 0, 500),
(4230111, 1002628, 1, 1, 0, 1500),
(4230111, 2040926, 1, 1, 0, 300),
(4230111, 2044010, 1, 1, 0, 300),
(4230111, 4130003, 1, 1, 0, 6000),
(4230111, 4130006, 1, 1, 0, 6000),
(4230111, 4130015, 1, 1, 0, 6000),
(4230112, 4000112, 1, 1, 0, 600000),
(4230112, 2060000, 1, 1, 0, 30000),
(4230112, 2061000, 1, 1, 0, 30000),
(4230112, 4004001, 1, 1, 0, 10000),
(4230112, 2002008, 1, 1, 0, 20000),
(4230112, 2000002, 1, 1, 0, 20000),
(4230112, 2000004, 1, 1, 0, 20000),
(4230112, 2040004, 1, 1, 0, 300),
(4230112, 2040502, 1, 1, 0, 300),
(4230112, 1302016, 1, 1, 0, 700),
(4230112, 1302010, 1, 1, 0, 700),
(4230112, 1072101, 1, 1, 0, 800),
(4230112, 1051026, 1, 1, 0, 700),
(4230112, 1072000, 1, 1, 0, 800),
(4230112, 1072110, 1, 1, 0, 800),
(4230112, 1082025, 1, 1, 0, 1000),
(4230112, 1002169, 1, 1, 0, 1500),
(4230112, 1472020, 1, 1, 0, 500),
(4230112, 1412003, 1, 1, 0, 700),
(4230112, 1402003, 1, 1, 0, 700),
(4230112, 1040097, 1, 1, 0, 800),
(4230112, 1060086, 1, 1, 0, 800),
(4230112, 1002214, 1, 1, 0, 1500),
(4230112, 1492007, 1, 1, 0, 500),
(4230112, 2049000, 1, 1, 0, 150),
(4230112, 4130003, 1, 1, 0, 6000),
(4230112, 4130010, 1, 1, 0, 6000),
(4230113, 4000114, 1, 1, 0, 600000),
(4230113, 2060000, 1, 1, 0, 30000),
(4230113, 2061000, 1, 1, 0, 30000),
(4230113, 4010003, 1, 1, 0, 9000),
(4230113, 4004003, 1, 1, 0, 10000),
(4230113, 2000002, 1, 1, 0, 20000),
(4230113, 2000003, 1, 1, 0, 20000),
(4230113, 1382019, 1, 1, 0, 700),
(4230113, 2040401, 1, 1, 0, 300),
(4230113, 2044701, 1, 1, 0, 300),
(4230113, 1002047, 1, 1, 0, 1500),
(4230113, 1002139, 1, 1, 0, 1500),
(4230113, 1002142, 1, 1, 0, 1500),
(4230113, 1040061, 1, 1, 0, 800),
(4230113, 1060050, 1, 1, 0, 800),
(4230113, 1051025, 1, 1, 0, 700),
(4230113, 1082071, 1, 1, 0, 1000),
(4230113, 1082023, 1, 1, 0, 1000),
(4230113, 1072108, 1, 1, 0, 800),
(4230113, 1032018, 1, 1, 0, 1000),
(4230113, 1372007, 1, 1, 0, 700),
(4230113, 1332016, 1, 1, 0, 500),
(4230113, 1322017, 1, 1, 0, 700),
(4230113, 1052113, 1, 1, 0, 700),
(4230113, 4130008, 1, 1, 0, 6000),
(4230113, 4130013, 1, 1, 0, 6000),
(4230113, 4130017, 1, 1, 0, 6000),
(4230114, 4000115, 1, 1, 0, 600000),
(4230114, 2060000, 1, 1, 0, 30000),
(4230114, 2061000, 1, 1, 0, 30000),
(4230114, 4020007, 1, 1, 0, 9000),
(4230114, 2002010, 1, 1, 0, 20000),
(4230114, 4004000, 1, 1, 0, 10000),
(4230114, 2000002, 1, 1, 0, 20000),
(4230114, 2000003, 1, 1, 0, 20000),
(4230114, 2040804, 1, 1, 0, 300),
(4230114, 1402007, 1, 1, 0, 700),
(4230114, 1092029, 1, 1, 0, 700),
(4230114, 1002176, 1, 1, 0, 1500),
(4230114, 1002143, 1, 1, 0, 1500),
(4230114, 1040076, 1, 1, 0, 800),
(4230114, 1060065, 1, 1, 0, 800),
(4230114, 1050036, 1, 1, 0, 700),
(4230114, 1040085, 1, 1, 0, 800),
(4230114, 1060074, 1, 1, 0, 800),
(4230114, 1082074, 1, 1, 0, 1000),
(4230114, 1072116, 1, 1, 0, 800),
(4230114, 1092013, 1, 1, 0, 700),
(4230114, 1432004, 1, 1, 0, 500),
(4230114, 1312008, 1, 1, 0, 700),
(4230114, 1052113, 1, 1, 0, 700),
(4230114, 4130006, 1, 1, 0, 6000),
(4230114, 4130016, 1, 1, 0, 6000),
(4230114, 4130017, 1, 1, 0, 6000),
(4230115, 4000115, 1, 1, 0, 600000),
(4230115, 2060000, 1, 1, 0, 30000),
(4230115, 2061000, 1, 1, 0, 30000),
(4230115, 2002010, 1, 1, 0, 20000),
(4230115, 4020000, 1, 1, 0, 9000),
(4230115, 4020006, 1, 1, 0, 9000),
(4230115, 4004003, 1, 1, 0, 10000),
(4230115, 2000002, 1, 1, 0, 20000),
(4230115, 2000004, 1, 1, 0, 20000),
(4230115, 2043802, 1, 1, 0, 300),
(4230115, 2044102, 1, 1, 0, 300),
(4230115, 4006001, 1, 1, 0, 10000),
(4230115, 2070004, 1, 1, 0, 500),
(4230115, 1082069, 1, 1, 0, 1000),
(4230115, 1072000, 1, 1, 0, 800),
(4230115, 1072118, 1, 1, 0, 800),
(4230115, 1060069, 1, 1, 0, 800),
(4230115, 1040079, 1, 1, 0, 800),
(4230115, 1050049, 1, 1, 0, 700),
(4230115, 1041088, 1, 1, 0, 800),
(4230115, 1061087, 1, 1, 0, 800),
(4230115, 1082065, 1, 1, 0, 1000),
(4230115, 1072141, 1, 1, 0, 800),
(4230115, 1422005, 1, 1, 0, 700),
(4230115, 1472021, 1, 1, 0, 500),
(4230115, 1482007, 1, 1, 0, 500),
(4230115, 2040029, 1, 1, 0, 300),
(4230115, 2040617, 1, 1, 0, 300),
(4230115, 2040931, 1, 1, 0, 300),
(4230115, 2044214, 1, 1, 0, 300),
(4230115, 4130011, 1, 1, 0, 6000),
(4230115, 4130015, 1, 1, 0, 6000),
(4230115, 4130016, 1, 1, 0, 6000),
(4230116, 4000117, 1, 1, 0, 600000),
(4230116, 2002009, 1, 1, 0, 20000),
(4230116, 2000002, 1, 1, 0, 20000),
(4230116, 2000003, 1, 1, 0, 20000),
(4230116, 4010001, 1, 1, 0, 9000),
(4230116, 4010004, 1, 1, 0, 9000),
(4230116, 4004002, 1, 1, 0, 10000),
(4230116, 2041005, 1, 1, 0, 300),
(4230116, 1302016, 1, 1, 0, 700),
(4230116, 2060000, 1, 1, 0, 30000),
(4230116, 2061000, 1, 1, 0, 30000),
(4230116, 4020007, 1, 1, 0, 9000),
(4230116, 1372001, 1, 1, 0, 700),
(4230116, 1322015, 1, 1, 0, 700),
(4230116, 1402006, 1, 1, 0, 700),
(4230116, 1092007, 1, 1, 0, 700),
(4230116, 1072109, 1, 1, 0, 800),
(4230116, 1072120, 1, 1, 0, 800),
(4230116, 1082062, 1, 1, 0, 1000),
(4230116, 1040084, 1, 1, 0, 800),
(4230116, 1060073, 1, 1, 0, 800),
(4230116, 1050047, 1, 1, 0, 700),
(4230116, 1002211, 1, 1, 0, 1500),
(4230116, 1002028, 1, 1, 0, 1500),
(4230116, 1082195, 1, 1, 0, 1000),
(4230116, 4130007, 1, 1, 0, 6000),
(4230116, 4130017, 1, 1, 0, 6000),
(4230117, 4000118, 1, 1, 0, 600000),
(4230117, 4010003, 1, 1, 0, 9000),
(4230117, 4020007, 1, 1, 0, 9000),
(4230117, 2002007, 1, 1, 0, 20000),
(4230117, 4004000, 1, 1, 0, 10000),
(4230117, 2000002, 1, 1, 0, 20000),
(4230117, 2000003, 1, 1, 0, 20000),
(4230117, 2040707, 1, 1, 0, 300),
(4230117, 2060000, 1, 1, 0, 30000),
(4230117, 2061000, 1, 1, 0, 30000),
(4230117, 1092020, 1, 1, 0, 700),
(4230117, 2070002, 1, 1, 0, 500),
(4230117, 1082047, 1, 1, 0, 1000),
(4230117, 1082008, 1, 1, 0, 1000),
(4230117, 1041085, 1, 1, 0, 800),
(4230117, 1061084, 1, 1, 0, 800),
(4230117, 1060068, 1, 1, 0, 800),
(4230117, 1040080, 1, 1, 0, 800),
(4230117, 1050049, 1, 1, 0, 700),
(4230117, 1002208, 1, 1, 0, 1500),
(4230117, 1002212, 1, 1, 0, 1500),
(4230117, 1002217, 1, 1, 0, 1500),
(4230117, 1312008, 1, 1, 0, 700),
(4230117, 1332003, 1, 1, 0, 500),
(4230117, 1492006, 1, 1, 0, 500),
(4230117, 4130009, 1, 1, 0, 6000),
(4230117, 4130010, 1, 1, 0, 6000),
(4230118, 4000119, 1, 1, 0, 600000),
(4230118, 2002009, 1, 1, 0, 20000),
(4230118, 4010002, 1, 1, 0, 9000),
(4230118, 4020006, 1, 1, 0, 9000),
(4230118, 4004001, 1, 1, 0, 10000),
(4230118, 2040802, 1, 1, 0, 300),
(4230118, 2000002, 1, 1, 0, 20000),
(4230118, 2000004, 1, 1, 0, 20000),
(4230118, 2060000, 1, 1, 0, 30000),
(4230118, 2061000, 1, 1, 0, 30000),
(4230118, 2070004, 1, 1, 0, 500),
(4230118, 1041068, 1, 1, 0, 800),
(4230118, 1061063, 1, 1, 0, 800),
(4230118, 1050038, 1, 1, 0, 700),
(4230118, 1002155, 1, 1, 0, 1500),
(4230118, 1061070, 1, 1, 0, 800),
(4230118, 1041075, 1, 1, 0, 800),
(4230118, 1082024, 1, 1, 0, 1000),
(4230118, 1040000, 1, 1, 0, 800),
(4230118, 1060075, 1, 1, 0, 800),
(4230118, 1002024, 1, 1, 0, 1500),
(4230118, 1032012, 1, 1, 0, 1000),
(4230118, 1072143, 1, 1, 0, 800),
(4230118, 1422005, 1, 1, 0, 700),
(4230118, 1472021, 1, 1, 0, 500),
(4230118, 1072300, 1, 1, 0, 800),
(4230118, 2040031, 1, 1, 0, 300),
(4230118, 2040931, 1, 1, 0, 300),
(4230118, 4130004, 1, 1, 0, 6000),
(4230119, 4000120, 1, 1, 0, 600000),
(4230119, 2000002, 1, 1, 0, 20000),
(4230119, 2002006, 1, 1, 0, 20000),
(4230119, 2000003, 1, 1, 0, 20000),
(4230119, 4020002, 1, 1, 0, 9000),
(4230119, 4010005, 1, 1, 0, 9000),
(4230119, 4004003, 1, 1, 0, 10000),
(4230119, 2040804, 1, 1, 0, 300),
(4230119, 2060000, 1, 1, 0, 30000),
(4230119, 2061000, 1, 1, 0, 30000),
(4230119, 4131004, 1, 1, 0, 6000),
(4230119, 1092019, 1, 1, 0, 700),
(4230119, 1002178, 1, 1, 0, 1500),
(4230119, 1051016, 1, 1, 0, 700),
(4230119, 1082068, 1, 1, 0, 1000),
(4230119, 1072002, 1, 1, 0, 800),
(4230119, 1050035, 1, 1, 0, 700),
(4230119, 1041075, 1, 1, 0, 800),
(4230119, 1061070, 1, 1, 0, 800),
(4230119, 1061083, 1, 1, 0, 800),
(4230119, 1041084, 1, 1, 0, 800),
(4230119, 1082080, 1, 1, 0, 1000),
(4230119, 1072124, 1, 1, 0, 800),
(4230119, 1082067, 1, 1, 0, 1000),
(4230119, 1082195, 1, 1, 0, 1000),
(4230119, 2330001, 1, 1, 0, 500),
(4230119, 2044110, 1, 1, 0, 300),
(4230119, 4130001, 1, 1, 0, 6000),
(4230119, 4130006, 1, 1, 0, 6000),
(4230120, 4000121, 1, 1, 0, 600000),
(4230120, 4131004, 1, 1, 0, 6000),
(4230120, 4020003, 1, 1, 0, 9000),
(4230120, 4004001, 1, 1, 0, 10000),
(4230120, 2040804, 1, 1, 0, 300),
(4230120, 2000002, 1, 1, 0, 20000),
(4230120, 2000004, 1, 1, 0, 20000),
(4230120, 2060000, 1, 1, 0, 30000),
(4230120, 2061000, 1, 1, 0, 30000),
(4230120, 4006001, 1, 1, 0, 10000),
(4230120, 1002141, 1, 1, 0, 1500),
(4230120, 1002135, 1, 1, 0, 1500),
(4230120, 1041086, 1, 1, 0, 800),
(4230120, 1061085, 1, 1, 0, 800),
(4230120, 1061080, 1, 1, 0, 800),
(4230120, 1041081, 1, 1, 0, 800),
(4230120, 1040084, 1, 1, 0, 800),
(4230120, 1061071, 1, 1, 0, 800),
(4230120, 1051030, 1, 1, 0, 700),
(4230120, 1051039, 1, 1, 0, 700),
(4230120, 1082084, 1, 1, 0, 1000),
(4230120, 1072131, 1, 1, 0, 800),
(4230120, 1432004, 1, 1, 0, 500),
(4230120, 1452008, 1, 1, 0, 500),
(4230120, 1482007, 1, 1, 0, 500),
(4230120, 2040324, 1, 1, 0, 300),
(4230120, 2040530, 1, 1, 0, 300),
(4230120, 4130001, 1, 1, 0, 6000),
(4230120, 4130002, 1, 1, 0, 6000),
(4230121, 4000122, 1, 1, 0, 600000),
(4230121, 4131012, 1, 1, 0, 6000),
(4230121, 4020004, 1, 1, 0, 9000),
(4230121, 4020005, 1, 1, 0, 9000),
(4230121, 4004000, 1, 1, 0, 10000),
(4230121, 2043802, 1, 1, 0, 300),
(4230121, 2000002, 1, 1, 0, 20000),
(4230121, 2000004, 1, 1, 0, 20000),
(4230121, 2060000, 1, 1, 0, 30000),
(4230121, 2061000, 1, 1, 0, 30000),
(4230121, 1041053, 1, 1, 0, 800),
(4230121, 1061049, 1, 1, 0, 800),
(4230121, 1051015, 1, 1, 0, 700),
(4230121, 1082047, 1, 1, 0, 1000),
(4230121, 1051024, 1, 1, 0, 700),
(4230121, 1002155, 1, 1, 0, 1500),
(4230121, 1002184, 1, 1, 0, 1500),
(4230121, 1082072, 1, 1, 0, 1000),
(4230121, 1372007, 1, 1, 0, 700),
(4230121, 1040089, 1, 1, 0, 800),
(4230121, 1060078, 1, 1, 0, 800),
(4230121, 1061076, 1, 1, 0, 800),
(4230121, 1041077, 1, 1, 0, 800),
(4230121, 1412003, 1, 1, 0, 700),
(4230121, 1082198, 1, 1, 0, 1000),
(4230121, 2044901, 1, 1, 0, 300),
(4230121, 4130000, 1, 1, 0, 6000),
(4230121, 4130006, 1, 1, 0, 6000),
(4230121, 4130013, 1, 1, 0, 6000),
(4230123, 4000156, 1, 1, 0, 600000),
(4230123, 2000002, 1, 1, 0, 20000),
(4230123, 2000003, 1, 1, 0, 20000),
(4230123, 4000157, 1, 1, 0, 100000),
(4230123, 4020008, 1, 1, 0, 9000),
(4230123, 4020004, 1, 1, 0, 9000),
(4230123, 4004003, 1, 1, 0, 10000),
(4230123, 4003004, 1, 1, 0, 200000),
(4230123, 2048004, 1, 1, 0, 300),
(4230123, 2070002, 1, 1, 0, 500),
(4230123, 2044501, 1, 1, 0, 300),
(4230123, 1442009, 1, 1, 0, 700),
(4230123, 2060000, 1, 1, 0, 30000),
(4230123, 2061000, 1, 1, 0, 30000),
(4230123, 1452008, 1, 1, 0, 500),
(4230123, 1002024, 1, 1, 0, 1500),
(4230123, 1472017, 1, 1, 0, 500),
(4230123, 1041083, 1, 1, 0, 800),
(4230123, 1061082, 1, 1, 0, 800),
(4230123, 1082198, 1, 1, 0, 1000),
(4230123, 2044801, 1, 1, 0, 300),
(4230123, 2044805, 1, 1, 0, 300),
(4230123, 4130008, 1, 1, 0, 6000),
(4230124, 4000155, 1, 1, 0, 600000),
(4230124, 2000002, 1, 1, 0, 20000),
(4230124, 2000003, 1, 1, 0, 20000),
(4230124, 4000157, 1, 1, 0, 100000),
(4230124, 4010006, 1, 1, 0, 9000),
(4230124, 4020007, 1, 1, 0, 9000),
(4230124, 2000004, 1, 1, 0, 20000),
(4230124, 2060000, 1, 1, 0, 30000),
(4230124, 2061000, 1, 1, 0, 30000),
(4230124, 4004004, 1, 1, 0, 10000),
(4230124, 2041019, 1, 1, 0, 300),
(4230124, 1002045, 1, 1, 0, 1500),
(4230124, 1061062, 1, 1, 0, 800),
(4230124, 1041067, 1, 1, 0, 800),
(4230124, 1050037, 1, 1, 0, 700),
(4230124, 1041076, 1, 1, 0, 800),
(4230124, 1060073, 1, 1, 0, 800),
(4230124, 1412005, 1, 1, 0, 700),
(4230124, 1452007, 1, 1, 0, 500),
(4230124, 1002213, 1, 1, 0, 1500),
(4230124, 1002085, 1, 1, 0, 1500),
(4230124, 1032012, 1, 1, 0, 1000),
(4230124, 1040096, 1, 1, 0, 800),
(4230124, 1060085, 1, 1, 0, 800),
(4230124, 1002631, 1, 1, 0, 1500),
(4230124, 4130008, 1, 1, 0, 6000),
(4230124, 4130012, 1, 1, 0, 6000),
(4230124, 4130014, 1, 1, 0, 6000),
(4230125, 4000204, 1, 1, 0, 600000),
(4230125, 2000002, 1, 1, 0, 20000),
(4230125, 2000003, 1, 1, 0, 20000),
(4230125, 4020007, 1, 1, 0, 9000),
(4230125, 4010004, 1, 1, 0, 9000),
(4230125, 4010000, 1, 1, 0, 9000),
(4230125, 2060000, 1, 1, 0, 30000),
(4230125, 2061000, 1, 1, 0, 30000),
(4230125, 1002047, 1, 1, 0, 1500),
(4230125, 1002081, 1, 1, 0, 1500),
(4230125, 1002144, 1, 1, 0, 1500),
(4230125, 1002178, 1, 1, 0, 1500),
(4230125, 1422007, 1, 1, 0, 700),
(4230125, 1382019, 1, 1, 0, 700),
(4230125, 1332016, 1, 1, 0, 500),
(4230125, 1050052, 1, 1, 0, 700),
(4230125, 1072118, 1, 1, 0, 800),
(4230125, 1072108, 1, 1, 0, 800),
(4230125, 1072126, 1, 1, 0, 800),
(4230125, 2070002, 1, 1, 0, 500),
(4230125, 4006000, 1, 1, 0, 10000),
(4230125, 2044301, 1, 1, 0, 300),
(4230125, 2040705, 1, 1, 0, 300),
(4230125, 2040824, 1, 1, 0, 300),
(4230125, 2040929, 1, 1, 0, 300),
(4230125, 4130002, 1, 1, 0, 6000),
(4230125, 4130011, 1, 1, 0, 6000),
(4230126, 4000205, 1, 1, 0, 600000),
(4230126, 2041014, 1, 1, 0, 300),
(4230126, 4020003, 1, 1, 0, 9000),
(4230126, 2000002, 1, 1, 0, 20000),
(4230126, 2000004, 1, 1, 0, 20000),
(4230126, 2000003, 1, 1, 0, 20000),
(4230126, 4020006, 1, 1, 0, 9000),
(4230126, 4010003, 1, 1, 0, 9000),
(4230126, 2060000, 1, 1, 0, 30000),
(4230126, 2061000, 1, 1, 0, 30000),
(4230126, 1041084, 1, 1, 0, 800),
(4230126, 1060075, 1, 1, 0, 800),
(4230126, 1041082, 1, 1, 0, 800),
(4230126, 1060069, 1, 1, 0, 800),
(4230126, 1050048, 1, 1, 0, 700),
(4230126, 1051032, 1, 1, 0, 700),
(4230126, 1082010, 1, 1, 0, 1000),
(4230126, 2044201, 1, 1, 0, 300),
(4230126, 1082066, 1, 1, 0, 1000),
(4230126, 1082092, 1, 1, 0, 1000),
(4230126, 1082089, 1, 1, 0, 1000),
(4230126, 1082059, 1, 1, 0, 1000),
(4230126, 4006001, 1, 1, 0, 10000),
(4230126, 1002631, 1, 1, 0, 1500),
(4230126, 2040419, 1, 1, 0, 300),
(4230126, 2040425, 1, 1, 0, 300),
(4230126, 2049000, 1, 1, 0, 150),
(4230126, 4130004, 1, 1, 0, 6000),
(4230126, 4130008, 1, 1, 0, 6000),
(4230126, 4130012, 1, 1, 0, 6000),
(4230200, 2000002, 1, 1, 0, 20000),
(4230200, 2022040, 1, 1, 0, 20000),
(4230200, 2000003, 1, 1, 0, 20000),
(4230200, 4010002, 1, 1, 0, 9000),
(4230200, 4010003, 1, 1, 0, 9000),
(4230200, 4004001, 1, 1, 0, 10000),
(4230200, 2040001, 1, 1, 0, 300),
(4230200, 2040704, 1, 1, 0, 300),
(4230200, 4000158, 1, 1, 0, 600000),
(4230200, 1072112, 1, 1, 0, 800),
(4230200, 1051027, 1, 1, 0, 700),
(4230200, 1002170, 1, 1, 0, 1500),
(4230200, 1040000, 1, 1, 0, 800),
(4230200, 1060000, 1, 1, 0, 800),
(4230200, 1432005, 1, 1, 0, 500),
(4230200, 1472014, 1, 1, 0, 500),
(4230200, 1462006, 1, 1, 0, 500),
(4230200, 1002207, 1, 1, 0, 1500),
(4230200, 1002215, 1, 1, 0, 1500),
(4230200, 1040094, 1, 1, 0, 800),
(4230200, 1060083, 1, 1, 0, 800),
(4230200, 1051038, 1, 1, 0, 700),
(4230200, 1041088, 1, 1, 0, 800),
(4230200, 1061087, 1, 1, 0, 800),
(4230200, 1072300, 1, 1, 0, 800),
(4230200, 2040620, 1, 1, 0, 300),
(4230200, 2044310, 1, 1, 0, 300),
(4230200, 4130003, 1, 1, 0, 6000),
(4230200, 4130007, 1, 1, 0, 6000),
(4230201, 4000159, 1, 1, 0, 600000),
(4230201, 2002004, 1, 1, 0, 20000),
(4230201, 2000002, 1, 1, 0, 20000),
(4230201, 2000003, 1, 1, 0, 20000),
(4230201, 2022040, 1, 1, 0, 20000),
(4230201, 4020003, 1, 1, 0, 9000),
(4230201, 4010004, 1, 1, 0, 9000),
(4230201, 4004002, 1, 1, 0, 10000),
(4230201, 2040801, 1, 1, 0, 300),
(4230201, 2040901, 1, 1, 0, 300),
(4230201, 2060000, 1, 1, 0, 30000),
(4230201, 2061000, 1, 1, 0, 30000),
(4230201, 1072106, 1, 1, 0, 800),
(4230201, 1072102, 1, 1, 0, 800),
(4230201, 1082055, 1, 1, 0, 1000),
(4230201, 1002137, 1, 1, 0, 1500),
(4230201, 1072126, 1, 1, 0, 800),
(4230201, 1082024, 1, 1, 0, 1000),
(4230201, 1041074, 1, 1, 0, 800),
(4230201, 1061069, 1, 1, 0, 800),
(4230201, 1051031, 1, 1, 0, 700),
(4230201, 1041078, 1, 1, 0, 800),
(4230201, 1061077, 1, 1, 0, 800),
(4230201, 1051037, 1, 1, 0, 700),
(4230201, 1072140, 1, 1, 0, 800),
(4230201, 1082011, 1, 1, 0, 1000),
(4230201, 2040417, 1, 1, 0, 300),
(4230201, 4130006, 1, 1, 0, 6000),
(4230201, 4130016, 1, 1, 0, 6000),
(4230300, 4000169, 1, 1, 0, 600000),
(4230300, 4000021, 1, 1, 0, 50000),
(4230300, 2000002, 1, 1, 0, 20000),
(4230300, 2000003, 1, 1, 0, 20000),
(4230300, 4020005, 1, 1, 0, 9000),
(4230300, 4010004, 1, 1, 0, 9000),
(4230300, 4004001, 1, 1, 0, 10000),
(4230300, 2060000, 1, 1, 0, 30000),
(4230300, 2061000, 1, 1, 0, 30000),
(4230300, 1302016, 1, 1, 0, 700),
(4230300, 1082072, 1, 1, 0, 1000),
(4230300, 1072109, 1, 1, 0, 800),
(4230300, 1072112, 1, 1, 0, 800),
(4230300, 1092014, 1, 1, 0, 700),
(4230300, 1032011, 1, 1, 0, 1000),
(4230300, 1312007, 1, 1, 0, 700),
(4230300, 2070002, 1, 1, 0, 500),
(4230300, 1102001, 1, 1, 0, 1000),
(4230300, 4006000, 1, 1, 0, 10000),
(4230300, 2040705, 1, 1, 0, 300),
(4230300, 1482006, 1, 1, 0, 500),
(4230300, 2040029, 1, 1, 0, 300),
(4230300, 2040417, 1, 1, 0, 300),
(4230300, 4130009, 1, 1, 0, 6000),
(4230300, 4130015, 1, 1, 0, 6000),
(4230300, 4130017, 1, 1, 0, 6000),
(4230400, 4000178, 1, 1, 0, 600000),
(4230400, 2044001, 1, 1, 0, 300),
(4230400, 2060000, 1, 1, 0, 30000),
(4230400, 2061000, 1, 1, 0, 30000),
(4230400, 4020008, 1, 1, 0, 9000),
(4230400, 4010001, 1, 1, 0, 9000),
(4230400, 2000002, 1, 1, 0, 20000),
(4230400, 2000003, 1, 1, 0, 20000),
(4230400, 2000004, 1, 1, 0, 20000),
(4230400, 1002184, 1, 1, 0, 1500),
(4230400, 1032018, 1, 1, 0, 1000),
(4230400, 1041082, 1, 1, 0, 800),
(4230400, 1061081, 1, 1, 0, 800),
(4230400, 1050047, 1, 1, 0, 700),
(4230400, 1082071, 1, 1, 0, 1000),
(4230400, 1072116, 1, 1, 0, 800),
(4230400, 1072126, 1, 1, 0, 800),
(4230400, 4020007, 1, 1, 0, 9000),
(4230400, 2040923, 1, 1, 0, 300),
(4230400, 4130001, 1, 1, 0, 6000),
(4230400, 4130010, 1, 1, 0, 6000),
(4230400, 4130011, 1, 1, 0, 6000),
(4230500, 4000276, 1, 1, 0, 600000),
(4230500, 4000021, 1, 1, 0, 50000),
(4230500, 2060000, 1, 1, 0, 30000),
(4230500, 2061000, 1, 1, 0, 30000),
(4230500, 2040001, 1, 1, 0, 300),
(4230500, 2000002, 1, 1, 0, 20000),
(4230500, 4010006, 1, 1, 0, 9000),
(4230500, 2000003, 1, 1, 0, 20000),
(4230500, 1002023, 1, 1, 0, 1500),
(4230500, 4010001, 1, 1, 0, 9000),
(4230500, 1002103, 1, 1, 0, 1500),
(4230500, 1002092, 1, 1, 0, 1500),
(4230500, 1002155, 1, 1, 0, 1500),
(4230500, 1051016, 1, 1, 0, 700),
(4230500, 1061061, 1, 1, 0, 800),
(4230500, 1041066, 1, 1, 0, 800),
(4230500, 1050038, 1, 1, 0, 700),
(4230500, 1041095, 1, 1, 0, 800),
(4230500, 1061094, 1, 1, 0, 800),
(4230500, 1482006, 1, 1, 0, 500),
(4230500, 2330001, 1, 1, 0, 500),
(4230500, 4130004, 1, 1, 0, 6000),
(4230500, 4130014, 1, 1, 0, 6000),
(4230500, 4130016, 1, 1, 0, 6000),
(4230501, 4000277, 1, 1, 0, 600000),
(4230501, 2060000, 1, 1, 0, 30000),
(4230501, 2061000, 1, 1, 0, 30000),
(4230501, 4010001, 1, 1, 0, 9000),
(4230501, 2000002, 1, 1, 0, 20000),
(4230501, 2000003, 1, 1, 0, 20000),
(4230501, 2040901, 1, 1, 0, 300),
(4230501, 1472018, 1, 1, 0, 500),
(4230501, 1032018, 1, 1, 0, 1000),
(4230501, 1072110, 1, 1, 0, 800),
(4230501, 1051026, 1, 1, 0, 700),
(4230501, 1061076, 1, 1, 0, 800),
(4230501, 1002217, 1, 1, 0, 1500),
(4230501, 4004002, 1, 1, 0, 10000),
(4230501, 1072300, 1, 1, 0, 800),
(4230501, 2040420, 1, 1, 0, 300),
(4230501, 2049000, 1, 1, 0, 150),
(4230501, 4130000, 1, 1, 0, 6000),
(4230501, 4130009, 1, 1, 0, 6000),
(4230501, 4130011, 1, 1, 0, 6000),
(4230502, 4000278, 1, 1, 0, 600000),
(4230502, 2000002, 1, 1, 0, 20000),
(4230502, 2000003, 1, 1, 0, 20000),
(4230502, 4020008, 1, 1, 0, 9000),
(4230502, 4020004, 1, 1, 0, 9000),
(4230502, 4004003, 1, 1, 0, 10000),
(4230502, 2048004, 1, 1, 0, 300),
(4230502, 2070002, 1, 1, 0, 500),
(4230502, 2044501, 1, 1, 0, 300),
(4230502, 1442009, 1, 1, 0, 700),
(4230502, 2060000, 1, 1, 0, 30000),
(4230502, 2061000, 1, 1, 0, 30000),
(4230502, 1452008, 1, 1, 0, 500),
(4230502, 1002024, 1, 1, 0, 1500),
(4230502, 1041083, 1, 1, 0, 800),
(4230502, 1061082, 1, 1, 0, 800),
(4230502, 1072303, 1, 1, 0, 800),
(4230502, 2040823, 1, 1, 0, 300),
(4230502, 2043114, 1, 1, 0, 300),
(4230502, 4130003, 1, 1, 0, 6000),
(4230502, 4130009, 1, 1, 0, 6000),
(4230502, 4130017, 1, 1, 0, 6000),
(4230503, 4000281, 1, 1, 0, 600000),
(4230503, 2000002, 1, 1, 0, 20000),
(4230503, 2000003, 1, 1, 0, 20000),
(4230503, 4020005, 1, 1, 0, 9000),
(4230503, 4010004, 1, 1, 0, 9000),
(4230503, 4004001, 1, 1, 0, 10000),
(4230503, 2060000, 1, 1, 0, 30000),
(4230503, 2061000, 1, 1, 0, 30000),
(4230503, 1032008, 1, 1, 0, 1000),
(4230503, 1002081, 1, 1, 0, 1500),
(4230503, 1040089, 1, 1, 0, 800),
(4230503, 1060078, 1, 1, 0, 800),
(4230503, 1050052, 1, 1, 0, 700),
(4230503, 1102001, 1, 1, 0, 1000),
(4230503, 2040705, 1, 1, 0, 300),
(4230503, 4000280, 1, 1, 0, 600000),
(4230503, 1492006, 1, 1, 0, 500),
(4230503, 2044410, 1, 1, 0, 300),
(4230503, 4130001, 1, 1, 0, 6000),
(4230503, 4130007, 1, 1, 0, 6000),
(4230504, 4000281, 1, 1, 0, 600000),
(4230504, 2000002, 1, 1, 0, 20000),
(4230504, 2000003, 1, 1, 0, 20000),
(4230504, 4010002, 1, 1, 0, 9000),
(4230504, 4010004, 1, 1, 0, 9000),
(4230504, 4004000, 1, 1, 0, 10000),
(4230504, 2060000, 1, 1, 0, 30000),
(4230504, 2061000, 1, 1, 0, 30000),
(4230504, 2040504, 1, 1, 0, 300),
(4230504, 2044002, 1, 1, 0, 300),
(4230504, 1002085, 1, 1, 0, 1500),
(4230504, 1382001, 1, 1, 0, 700),
(4230504, 1082010, 1, 1, 0, 1000),
(4230504, 1041077, 1, 1, 0, 800),
(4230504, 4000279, 1, 1, 0, 600000),
(4230504, 1002631, 1, 1, 0, 1500),
(4230504, 2330002, 1, 1, 0, 500),
(4230504, 2044310, 1, 1, 0, 300),
(4230504, 4130002, 1, 1, 0, 6000),
(4230504, 4130013, 1, 1, 0, 6000),
(4230505, 4000291, 1, 1, 0, 600000),
(4230505, 2000002, 1, 1, 0, 20000),
(4230505, 2000003, 1, 1, 0, 20000),
(4230505, 4020000, 1, 1, 0, 9000),
(4230505, 4020006, 1, 1, 0, 9000),
(4230505, 2044102, 1, 1, 0, 300),
(4230505, 1372007, 1, 1, 0, 700),
(4230505, 1002215, 1, 1, 0, 1500),
(4230505, 4006001, 1, 1, 0, 10000),
(4230505, 1040089, 1, 1, 0, 800),
(4230505, 1050045, 1, 1, 0, 700),
(4230505, 4004002, 1, 1, 0, 10000),
(4230505, 2040001, 1, 1, 0, 300),
(4230505, 1052116, 1, 1, 0, 700),
(4230505, 2330002, 1, 1, 0, 500),
(4230505, 4130001, 1, 1, 0, 6000),
(4230505, 4130014, 1, 1, 0, 6000),
(4230505, 4130016, 1, 1, 0, 6000),
(4230506, 4000292, 1, 1, 0, 600000),
(4230506, 2000002, 1, 1, 0, 20000),
(4230506, 2000003, 1, 1, 0, 20000),
(4230506, 4010001, 1, 1, 0, 9000),
(4230506, 4020000, 1, 1, 0, 9000),
(4230506, 1041086, 1, 1, 0, 800),
(4230506, 1061085, 1, 1, 0, 800),
(4230506, 1302013, 1, 1, 0, 700),
(4230506, 1002083, 1, 1, 0, 1500),
(4230506, 1032007, 1, 1, 0, 1000),
(4230506, 1041080, 1, 1, 0, 800),
(4230506, 1061079, 1, 1, 0, 800),
(4230506, 1002212, 1, 1, 0, 1500),
(4230506, 1041092, 1, 1, 0, 800),
(4230506, 1061091, 1, 1, 0, 800),
(4230506, 1102003, 1, 1, 0, 1000),
(4230506, 4006001, 1, 1, 0, 10000),
(4230506, 1492007, 1, 1, 0, 500),
(4230506, 2040622, 1, 1, 0, 300),
(4230506, 2044110, 1, 1, 0, 300),
(4230506, 2044312, 1, 1, 0, 300),
(4230506, 2049100, 1, 1, 0, 150),
(4230506, 4130000, 1, 1, 0, 6000),
(4230506, 4130017, 1, 1, 0, 6000),
(4230600, 2000003, 1, 1, 0, 20000),
(4230600, 2060000, 1, 1, 0, 30000),
(4230600, 2061000, 1, 1, 0, 30000),
(4230600, 2000002, 1, 1, 0, 20000),
(4230600, 4000332, 1, 1, 0, 600000),
(4230600, 4020001, 1, 1, 0, 9000),
(4230600, 4004003, 1, 1, 0, 10000),
(4230600, 4006001, 1, 1, 0, 10000),
(4230600, 2044401, 1, 1, 0, 300),
(4230600, 2070003, 1, 1, 0, 500),
(4230600, 1372012, 1, 1, 0, 700),
(4230600, 1432003, 1, 1, 0, 500),
(4230600, 1452007, 1, 1, 0, 500),
(4230600, 1102000, 1, 1, 0, 1000),
(4230600, 1002210, 1, 1, 0, 1500),
(4230600, 1072002, 1, 1, 0, 800),
(4230600, 1082055, 1, 1, 0, 1000),
(4230600, 1041082, 1, 1, 0, 800),
(4230600, 1061081, 1, 1, 0, 800),
(4230600, 4010007, 1, 1, 0, 9000),
(4230600, 1492006, 1, 1, 0, 500),
(4230600, 2044802, 1, 1, 0, 300),
(4230600, 2040823, 1, 1, 0, 300),
(4230600, 2044412, 1, 1, 0, 300),
(4230600, 4130000, 1, 1, 0, 6000),
(4230600, 4130016, 1, 1, 0, 6000),
(4240000, 4000125, 1, 1, 0, 600000),
(4240000, 2060000, 1, 1, 0, 30000),
(4240000, 2061000, 1, 1, 0, 30000),
(4240000, 2000002, 1, 1, 0, 20000),
(4240000, 2000004, 1, 1, 0, 20000),
(4240000, 2002008, 1, 1, 0, 20000),
(4240000, 1102016, 1, 1, 0, 1000),
(4240000, 4010006, 1, 1, 0, 9000),
(4240000, 4020008, 1, 1, 0, 9000),
(4240000, 4004003, 1, 1, 0, 10000),
(4240000, 2043801, 1, 1, 0, 300),
(4240000, 4006001, 1, 1, 0, 10000),
(4240000, 4021009, 1, 1, 0, 7000),
(4240000, 1322016, 1, 1, 0, 700),
(4240000, 1041074, 1, 1, 0, 800),
(4240000, 1061069, 1, 1, 0, 800),
(4240000, 1041083, 1, 1, 0, 800),
(4240000, 1061082, 1, 1, 0, 800),
(4240000, 1332003, 1, 1, 0, 500),
(4240000, 1072122, 1, 1, 0, 800),
(4240000, 1072130, 1, 1, 0, 800),
(4240000, 1072133, 1, 1, 0, 800),
(4240000, 1082080, 1, 1, 0, 1000),
(4240000, 1072125, 1, 1, 0, 800),
(4240000, 1002216, 1, 1, 0, 1500),
(4240000, 1002101, 1, 1, 0, 1500),
(4240000, 2040029, 1, 1, 0, 300),
(4240000, 2040619, 1, 1, 0, 300),
(4240000, 2044114, 1, 1, 0, 300),
(4240000, 4130006, 1, 1, 0, 6000),
(4240000, 4130011, 1, 1, 0, 6000),
(4250000, 4000436, 1, 1, 0, 600000),
(4250000, 2000002, 1, 1, 0, 20000),
(4250000, 2000003, 1, 1, 0, 20000),
(4250000, 4010005, 1, 1, 0, 9000),
(4250000, 4020004, 1, 1, 0, 9000),
(4250000, 2040004, 1, 1, 0, 300),
(4250000, 1002025, 1, 1, 0, 1500),
(4250000, 1051025, 1, 1, 0, 700),
(4250000, 1082083, 1, 1, 0, 1000),
(4250000, 1072109, 1, 1, 0, 800),
(4250000, 1492006, 1, 1, 0, 500),
(4250000, 4130005, 1, 1, 0, 6000),
(4250000, 4130015, 1, 1, 0, 6000),
(4250000, 4130017, 1, 1, 0, 6000),
(4250001, 2000002, 1, 1, 0, 20000),
(4250001, 2000003, 1, 1, 0, 20000),
(4250001, 4010004, 1, 1, 0, 9000),
(4250001, 4020005, 1, 1, 0, 9000),
(4250001, 2040627, 1, 1, 0, 300),
(4250001, 1002215, 1, 1, 0, 1500),
(4250001, 1051038, 1, 1, 0, 700),
(4250001, 1082066, 1, 1, 0, 1000),
(4250001, 1072303, 1, 1, 0, 800),
(4250001, 1442005, 1, 1, 0, 700),
(4250001, 4000438, 1, 1, 0, 600000),
(4250001, 4130014, 1, 1, 0, 6000),
(5090000, 4000413, 1, 1, 0, 200000),
(5090001, 4000412, 1, 1, 0, 600000),
(5100000, 4000048, 1, 1, 0, 600000),
(5100000, 4003005, 1, 1, 0, 200000),
(5100000, 4000021, 1, 1, 0, 50000),
(5100000, 2000002, 1, 1, 0, 20000),
(5100000, 2000003, 1, 1, 0, 20000),
(5100000, 2000004, 1, 1, 0, 20000),
(5100000, 4020001, 1, 1, 0, 9000),
(5100000, 4010002, 1, 1, 0, 9000),
(5100000, 1072089, 1, 1, 0, 800),
(5100000, 1082038, 1, 1, 0, 1000),
(5100000, 1452006, 1, 1, 0, 500),
(5100000, 1442009, 1, 1, 0, 700),
(5100000, 1051044, 1, 1, 0, 700),
(5100000, 1051045, 1, 1, 0, 700),
(5100000, 2044602, 1, 1, 0, 300),
(5100000, 1041096, 1, 1, 0, 800),
(5100000, 1061095, 1, 1, 0, 800),
(5100000, 2040804, 1, 1, 0, 300),
(5100000, 4004002, 1, 1, 0, 10000),
(5100000, 1051037, 1, 1, 0, 700),
(5100000, 1052116, 1, 1, 0, 700),
(5100000, 2040321, 1, 1, 0, 300),
(5100000, 2040933, 1, 1, 0, 300),
(5100000, 2040925, 1, 1, 0, 300),
(5100000, 2043019, 1, 1, 0, 300),
(5100000, 2043110, 1, 1, 0, 300),
(5100000, 4130010, 1, 1, 0, 6000),
(5100000, 4130011, 1, 1, 0, 6000),
(5100002, 4000081, 1, 1, 0, 600000),
(5100002, 2000002, 1, 1, 0, 20000),
(5100002, 2000003, 1, 1, 0, 20000),
(5100002, 4010001, 1, 1, 0, 9000),
(5100002, 4020000, 1, 1, 0, 9000),
(5100002, 4004000, 1, 1, 0, 10000),
(5100002, 2041010, 1, 1, 0, 300),
(5100002, 2070003, 1, 1, 0, 500),
(5100002, 4006000, 1, 1, 0, 10000),
(5100002, 1051025, 1, 1, 0, 700),
(5100002, 1302009, 1, 1, 0, 700),
(5100002, 1041076, 1, 1, 0, 800),
(5100002, 1061071, 1, 1, 0, 800),
(5100002, 1332016, 1, 1, 0, 500),
(5100002, 1322017, 1, 1, 0, 700),
(5100002, 1002209, 1, 1, 0, 1500),
(5100002, 1002214, 1, 1, 0, 1500),
(5100002, 1040087, 1, 1, 0, 800),
(5100002, 1060076, 1, 1, 0, 800),
(5100002, 1072150, 1, 1, 0, 800),
(5100002, 1002242, 1, 1, 0, 1500),
(5100002, 1492007, 1, 1, 0, 500),
(5100002, 2040326, 1, 1, 0, 300),
(5100002, 2049000, 1, 1, 0, 150),
(5100002, 4130001, 1, 1, 0, 6000),
(5100002, 4130007, 1, 1, 0, 6000),
(5100003, 4000170, 1, 1, 0, 600000),
(5100003, 4000021, 1, 1, 0, 50000),
(5100003, 2000002, 1, 1, 0, 20000),
(5100003, 2000003, 1, 1, 0, 20000),
(5100003, 2000004, 1, 1, 0, 20000),
(5100003, 4020001, 1, 1, 0, 9000),
(5100003, 4010002, 1, 1, 0, 9000),
(5100003, 1332011, 1, 1, 0, 500),
(5100003, 1072118, 1, 1, 0, 800),
(5100003, 1051038, 1, 1, 0, 700),
(5100003, 2040901, 1, 1, 0, 300),
(5100003, 2002003, 1, 1, 0, 20000),
(5100003, 1322017, 1, 1, 0, 700),
(5100003, 2044602, 1, 1, 0, 300),
(5100003, 1041088, 1, 1, 0, 800),
(5100003, 1060077, 1, 1, 0, 800),
(5100003, 2040804, 1, 1, 0, 300),
(5100003, 4004002, 1, 1, 0, 10000),
(5100003, 1312008, 1, 1, 0, 700),
(5100003, 1082198, 1, 1, 0, 1000),
(5100003, 2044805, 1, 1, 0, 300),
(5100003, 4130003, 1, 1, 0, 6000),
(5100003, 4130008, 1, 1, 0, 6000),
(5100003, 4130016, 1, 1, 0, 6000),
(5100004, 4000172, 1, 1, 0, 600000),
(5100004, 4000021, 1, 1, 0, 50000),
(5100004, 4004004, 1, 1, 0, 10000),
(5100004, 2000003, 1, 1, 0, 20000),
(5100004, 2000004, 1, 1, 0, 20000),
(5100004, 4020004, 1, 1, 0, 9000),
(5100004, 4010005, 1, 1, 0, 9000),
(5100004, 1032021, 1, 1, 0, 1000),
(5100004, 1072134, 1, 1, 0, 800),
(5100004, 1082066, 1, 1, 0, 1000),
(5100004, 1050058, 1, 1, 0, 700),
(5100004, 1051046, 1, 1, 0, 700),
(5100004, 2043801, 1, 1, 0, 300),
(5100004, 1082081, 1, 1, 0, 1000),
(5100004, 1432006, 1, 1, 0, 500),
(5100004, 1040099, 1, 1, 0, 800),
(5100004, 1060088, 1, 1, 0, 800),
(5100004, 4004002, 1, 1, 0, 10000),
(5100004, 1040087, 1, 1, 0, 800),
(5100004, 1060076, 1, 1, 0, 800),
(5100004, 2043701, 1, 1, 0, 300),
(5100004, 1052119, 1, 1, 0, 700),
(5100004, 2040420, 1, 1, 0, 300),
(5100004, 4130003, 1, 1, 0, 6000),
(5100004, 4130005, 1, 1, 0, 6000),
(5100004, 4130011, 1, 1, 0, 6000),
(5100005, 4000171, 1, 1, 0, 600000),
(5100005, 2000002, 1, 1, 0, 20000),
(5100005, 4000021, 1, 1, 0, 50000),
(5100005, 2000004, 1, 1, 0, 20000),
(5100005, 2000003, 1, 1, 0, 20000),
(5100005, 4010005, 1, 1, 0, 9000),
(5100005, 4010001, 1, 1, 0, 9000),
(5100005, 4004003, 1, 1, 0, 10000),
(5100005, 4006000, 1, 1, 0, 10000),
(5100005, 2041023, 1, 1, 0, 300),
(5100005, 1402006, 1, 1, 0, 700),
(5100005, 2044201, 1, 1, 0, 300),
(5100005, 1051045, 1, 1, 0, 700),
(5100005, 2070004, 1, 1, 0, 500),
(5100005, 1422007, 1, 1, 0, 700),
(5100005, 1040095, 1, 1, 0, 800),
(5100005, 1060084, 1, 1, 0, 800),
(5100005, 1041079, 1, 1, 0, 800),
(5100005, 1061078, 1, 1, 0, 800),
(5100005, 2044901, 1, 1, 0, 300),
(5100005, 2040316, 1, 1, 0, 300),
(5100005, 2040621, 1, 1, 0, 300),
(5100005, 4130008, 1, 1, 0, 6000),
(5100005, 4130009, 1, 1, 0, 6000),
(5110300, 2000002, 1, 1, 0, 20000),
(5110300, 2000003, 1, 1, 0, 20000),
(5110300, 4004002, 1, 1, 0, 10000),
(5110300, 4020005, 1, 1, 0, 9000),
(5110300, 1332011, 1, 1, 0, 500),
(5110300, 1072118, 1, 1, 0, 800),
(5110300, 1051038, 1, 1, 0, 700),
(5110300, 2040901, 1, 1, 0, 300),
(5110300, 2002003, 1, 1, 0, 20000),
(5110300, 2044602, 1, 1, 0, 300),
(5110300, 1041088, 1, 1, 0, 800),
(5110300, 1060077, 1, 1, 0, 800),
(5110300, 1312008, 1, 1, 0, 700),
(5110300, 4000360, 1, 1, 0, 600000),
(5110300, 1482007, 1, 1, 0, 500),
(5110300, 2044902, 1, 1, 0, 300),
(5110300, 1052116, 1, 1, 0, 700),
(5110300, 2040027, 1, 1, 0, 300),
(5110300, 2040317, 1, 1, 0, 300),
(5110300, 4130000, 1, 1, 0, 6000),
(5110300, 4130004, 1, 1, 0, 6000),
(5110300, 4130006, 1, 1, 0, 6000),
(5110301, 4004004, 1, 1, 0, 10000),
(5110301, 2000002, 1, 1, 0, 20000),
(5110301, 2000003, 1, 1, 0, 20000),
(5110301, 4020005, 1, 1, 0, 9000),
(5110301, 1002159, 1, 1, 0, 1500),
(5110301, 1040057, 1, 1, 0, 800),
(5110301, 1082004, 1, 1, 0, 1000),
(5110301, 1040096, 1, 1, 0, 800),
(5110301, 1060085, 1, 1, 0, 800),
(5110301, 1050052, 1, 1, 0, 700),
(5110301, 1040087, 1, 1, 0, 800),
(5110301, 1060076, 1, 1, 0, 800),
(5110301, 1040091, 1, 1, 0, 800),
(5110301, 1060080, 1, 1, 0, 800),
(5110301, 4000364, 1, 1, 0, 600000),
(5110301, 1492008, 1, 1, 0, 500),
(5110301, 2040323, 1, 1, 0, 300),
(5110301, 2040422, 1, 1, 0, 300),
(5110301, 2043017, 1, 1, 0, 300),
(5110301, 4130001, 1, 1, 0, 6000),
(5110301, 4130005, 1, 1, 0, 6000),
(5110301, 4130006, 1, 1, 0, 6000),
(5110302, 2000003, 1, 1, 0, 20000),
(5110302, 2000002, 1, 1, 0, 20000),
(5110302, 2000004, 1, 1, 0, 20000),
(5110302, 4010006, 1, 1, 0, 9000),
(5110302, 1082066, 1, 1, 0, 1000),
(5110302, 1072146, 1, 1, 0, 800),
(5110302, 1041077, 1, 1, 0, 800),
(5110302, 1061076, 1, 1, 0, 800),
(5110302, 1051037, 1, 1, 0, 700),
(5110302, 1002029, 1, 1, 0, 1500),
(5110302, 1002248, 1, 1, 0, 1500),
(5110302, 1002269, 1, 1, 0, 1500),
(5110302, 2040804, 1, 1, 0, 300),
(5110302, 2040901, 1, 1, 0, 300),
(5110302, 4000365, 1, 1, 0, 600000),
(5110302, 1082201, 1, 1, 0, 1000),
(5110302, 2040425, 1, 1, 0, 300),
(5110302, 2040923, 1, 1, 0, 300),
(5110302, 2044114, 1, 1, 0, 300),
(5110302, 4130008, 1, 1, 0, 6000),
(5110302, 4130009, 1, 1, 0, 6000),
(5120000, 4000061, 1, 1, 0, 600000),
(5120000, 4003005, 1, 1, 0, 200000),
(5120000, 2041017, 1, 1, 0, 300),
(5120000, 4004004, 1, 1, 0, 10000),
(5120000, 2000002, 1, 1, 0, 20000),
(5120000, 2000004, 1, 1, 0, 20000),
(5120000, 2000003, 1, 1, 0, 20000),
(5120000, 4020002, 1, 1, 0, 9000),
(5120000, 4010006, 1, 1, 0, 9000),
(5120000, 4004000, 1, 1, 0, 10000),
(5120000, 1092007, 1, 1, 0, 700),
(5120000, 2070002, 1, 1, 0, 500),
(5120000, 4006001, 1, 1, 0, 10000),
(5120000, 2040504, 1, 1, 0, 300),
(5120000, 1002185, 1, 1, 0, 1500),
(5120000, 1060070, 1, 1, 0, 800),
(5120000, 1040081, 1, 1, 0, 800),
(5120000, 1422007, 1, 1, 0, 700),
(5120000, 1051033, 1, 1, 0, 700),
(5120000, 1002086, 1, 1, 0, 1500),
(5120000, 1040088, 1, 1, 0, 800),
(5120000, 1060077, 1, 1, 0, 800),
(5120000, 1072134, 1, 1, 0, 800),
(5120000, 1072128, 1, 1, 0, 800),
(5120000, 1072144, 1, 1, 0, 800),
(5120000, 1082086, 1, 1, 0, 1000),
(5120000, 1082201, 1, 1, 0, 1000),
(5120000, 2330002, 1, 1, 0, 500),
(5120000, 2040324, 1, 1, 0, 300),
(5120000, 2040423, 1, 1, 0, 300),
(5120000, 2043017, 1, 1, 0, 300),
(5120000, 4130010, 1, 1, 0, 6000),
(5120001, 4000070, 1, 1, 0, 600000),
(5120001, 4003005, 1, 1, 0, 200000),
(5120001, 2000002, 1, 1, 0, 20000),
(5120001, 2000004, 1, 1, 0, 20000),
(5120001, 2000003, 1, 1, 0, 20000),
(5120001, 4020000, 1, 1, 0, 9000),
(5120001, 4010005, 1, 1, 0, 9000),
(5120001, 4004000, 1, 1, 0, 10000),
(5120001, 4006000, 1, 1, 0, 10000),
(5120001, 2041012, 1, 1, 0, 300),
(5120001, 2043002, 1, 1, 0, 300),
(5120001, 1072115, 1, 1, 0, 800),
(5120001, 1072126, 1, 1, 0, 800),
(5120001, 1082074, 1, 1, 0, 1000),
(5120001, 1402007, 1, 1, 0, 700),
(5120001, 1002028, 1, 1, 0, 1500),
(5120001, 1032013, 1, 1, 0, 1000),
(5120001, 1040094, 1, 1, 0, 800),
(5120001, 1060083, 1, 1, 0, 800),
(5120001, 1041089, 1, 1, 0, 800),
(5120001, 1061088, 1, 1, 0, 800),
(5120001, 1050054, 1, 1, 0, 700),
(5120001, 1050058, 1, 1, 0, 700),
(5120001, 1072306, 1, 1, 0, 800),
(5120001, 2331000, 1, 1, 0, 500),
(5120001, 2040933, 1, 1, 0, 300),
(5120001, 2044212, 1, 1, 0, 300),
(5120001, 4130000, 1, 1, 0, 6000),
(5120001, 4130008, 1, 1, 0, 6000),
(5120001, 4130009, 1, 1, 0, 6000),
(5120002, 4000071, 1, 1, 0, 600000),
(5120002, 4003005, 1, 1, 0, 200000),
(5120002, 2000002, 1, 1, 0, 20000),
(5120002, 2000004, 1, 1, 0, 20000),
(5120002, 2000003, 1, 1, 0, 20000),
(5120002, 4020003, 1, 1, 0, 9000),
(5120002, 4010002, 1, 1, 0, 9000),
(5120002, 4004001, 1, 1, 0, 10000),
(5120002, 4006001, 1, 1, 0, 10000),
(5120002, 2041017, 1, 1, 0, 300),
(5120002, 2044001, 1, 1, 0, 300),
(5120002, 1312007, 1, 1, 0, 700),
(5120002, 1040084, 1, 1, 0, 800),
(5120002, 1060073, 1, 1, 0, 800),
(5120002, 1002045, 1, 1, 0, 1500),
(5120002, 1002024, 1, 1, 0, 1500),
(5120002, 1302010, 1, 1, 0, 700),
(5120002, 1082009, 1, 1, 0, 1000),
(5120002, 1082081, 1, 1, 0, 1000),
(5120002, 1072123, 1, 1, 0, 800),
(5120002, 1072131, 1, 1, 0, 800),
(5120002, 1051041, 1, 1, 0, 700),
(5120002, 1002267, 1, 1, 0, 1500),
(5120002, 1002631, 1, 1, 0, 1500),
(5120002, 2330002, 1, 1, 0, 500),
(5120002, 2044212, 1, 1, 0, 300),
(5120002, 2049100, 1, 1, 0, 150),
(5120002, 4130002, 1, 1, 0, 6000),
(5120002, 4130014, 1, 1, 0, 6000),
(5120003, 4000072, 1, 1, 0, 600000),
(5120003, 4003005, 1, 1, 0, 200000),
(5120003, 2000002, 1, 1, 0, 20000),
(5120003, 2000004, 1, 1, 0, 20000),
(5120003, 2000003, 1, 1, 0, 20000),
(5120003, 4020005, 1, 1, 0, 9000),
(5120003, 4010001, 1, 1, 0, 9000),
(5120003, 4004003, 1, 1, 0, 10000),
(5120003, 4006000, 1, 1, 0, 10000),
(5120003, 2041023, 1, 1, 0, 300),
(5120003, 1032019, 1, 1, 0, 1000),
(5120003, 2070004, 1, 1, 0, 500);
INSERT IGNORE INTO `temp_data` (`dropperid`, `itemid`, `minimum_quantity`, `maximum_quantity`, `questid`, `chance`) VALUES
(5120003, 2070010, 1, 1, 0, 500),
(5120003, 1002153, 1, 1, 0, 1500),
(5120003, 1002181, 1, 1, 0, 1500),
(5120003, 1032011, 1, 1, 0, 1000),
(5120003, 1041085, 1, 1, 0, 800),
(5120003, 1061084, 1, 1, 0, 800),
(5120003, 1051034, 1, 1, 0, 700),
(5120003, 1061077, 1, 1, 0, 800),
(5120003, 1041078, 1, 1, 0, 800),
(5120003, 1050052, 1, 1, 0, 700),
(5120003, 1072135, 1, 1, 0, 800),
(5120003, 1082082, 1, 1, 0, 1000),
(5120003, 1332015, 1, 1, 0, 500),
(5120003, 1322018, 1, 1, 0, 700),
(5120003, 1002634, 1, 1, 0, 1500),
(5120003, 2332000, 1, 1, 0, 500),
(5120003, 2040323, 1, 1, 0, 300),
(5120003, 2040924, 1, 1, 0, 300),
(5120003, 4130005, 1, 1, 0, 6000),
(5120003, 4130012, 1, 1, 0, 6000),
(5120100, 4000126, 1, 1, 0, 600000),
(5120100, 2060000, 1, 1, 0, 300000),
(5120100, 2061000, 1, 1, 0, 300000),
(5120100, 2000002, 1, 1, 0, 200000),
(5120100, 2000004, 1, 1, 0, 999999),
(5120100, 2002010, 1, 1, 0, 200000),
(5120100, 1032014, 1, 1, 0, 10000),
(5120100, 4004000, 1, 1, 0, 100000),
(5120100, 4020001, 1, 1, 0, 90000),
(5120100, 4010006, 1, 1, 0, 90000),
(5120100, 4020007, 1, 1, 0, 90000),
(5120100, 4011007, 1, 1, 0, 7000),
(5120100, 2044602, 1, 1, 0, 3000),
(5120100, 1041082, 1, 1, 0, 8000),
(5120100, 1061081, 1, 1, 0, 8000),
(5120100, 1002154, 1, 1, 0, 15000),
(5120100, 1082010, 1, 1, 0, 10000),
(5120100, 1082067, 1, 1, 0, 10000),
(5120100, 1072142, 1, 1, 0, 8000),
(5120100, 1040096, 1, 1, 0, 8000),
(5120100, 1060085, 1, 1, 0, 8000),
(5120100, 1002211, 1, 1, 0, 15000),
(5120100, 1402011, 1, 1, 0, 7000),
(5120100, 1092010, 1, 1, 0, 7000),
(5120100, 1412007, 1, 1, 0, 7000),
(5120100, 2043017, 1, 1, 0, 3000),
(5120100, 4130004, 1, 1, 0, 60000),
(5120100, 4130013, 1, 1, 0, 60000),
(5120500, 4000283, 1, 1, 0, 600000),
(5120500, 4000284, 1, 1, 0, 600000),
(5120500, 4000021, 1, 1, 0, 50000),
(5120500, 4003005, 1, 1, 0, 200000),
(5120500, 4004004, 1, 1, 0, 10000),
(5120500, 2000003, 1, 1, 0, 20000),
(5120500, 2000002, 1, 1, 0, 20000),
(5120500, 4020004, 1, 1, 0, 9000),
(5120500, 4010005, 1, 1, 0, 9000),
(5120500, 1032021, 1, 1, 0, 1000),
(5120500, 1072134, 1, 1, 0, 800),
(5120500, 1082066, 1, 1, 0, 1000),
(5120500, 1050058, 1, 1, 0, 700),
(5120500, 1082081, 1, 1, 0, 1000),
(5120500, 1040099, 1, 1, 0, 800),
(5120500, 1060088, 1, 1, 0, 800),
(5120500, 4004002, 1, 1, 0, 10000),
(5120500, 2043801, 1, 1, 0, 300),
(5120500, 1432006, 1, 1, 0, 500),
(5120500, 2043701, 1, 1, 0, 300),
(5120500, 1082201, 1, 1, 0, 1000),
(5120500, 2330002, 1, 1, 0, 500),
(5120500, 2040031, 1, 1, 0, 300),
(5120500, 2040515, 1, 1, 0, 300),
(5120500, 2049100, 1, 1, 0, 150),
(5120500, 4130000, 1, 1, 0, 6000),
(5120500, 4130009, 1, 1, 0, 6000),
(5120501, 4000293, 1, 1, 0, 600000),
(5120501, 2000002, 1, 1, 0, 20000),
(5120501, 2000003, 1, 1, 0, 20000),
(5120501, 4020005, 1, 1, 0, 9000),
(5120501, 4010001, 1, 1, 0, 9000),
(5120501, 4004003, 1, 1, 0, 10000),
(5120501, 4006000, 1, 1, 0, 10000),
(5120501, 2041023, 1, 1, 0, 300),
(5120501, 1050052, 1, 1, 0, 700),
(5120501, 1051037, 1, 1, 0, 700),
(5120501, 1032019, 1, 1, 0, 1000),
(5120501, 1040102, 1, 1, 0, 800),
(5120501, 1060090, 1, 1, 0, 800),
(5120501, 1051041, 1, 1, 0, 700),
(5120501, 1482008, 1, 1, 0, 500),
(5120501, 2040423, 1, 1, 0, 300),
(5120501, 2044310, 1, 1, 0, 300),
(5120501, 4130016, 1, 1, 0, 6000),
(5120501, 4130017, 1, 1, 0, 6000),
(5120502, 4000294, 1, 1, 0, 600000),
(5120502, 4004004, 1, 1, 0, 10000),
(5120502, 2000002, 1, 1, 0, 20000),
(5120502, 2000003, 1, 1, 0, 20000),
(5120502, 4020005, 1, 1, 0, 9000),
(5120502, 1002159, 1, 1, 0, 1500),
(5120502, 1040057, 1, 1, 0, 800),
(5120502, 1082004, 1, 1, 0, 1000),
(5120502, 1040096, 1, 1, 0, 800),
(5120502, 1060085, 1, 1, 0, 800),
(5120502, 1050052, 1, 1, 0, 700),
(5120502, 1040087, 1, 1, 0, 800),
(5120502, 1060076, 1, 1, 0, 800),
(5120502, 4006000, 1, 1, 0, 10000),
(5120502, 1040091, 1, 1, 0, 800),
(5120502, 1060080, 1, 1, 0, 800),
(5120502, 1052116, 1, 1, 0, 700),
(5120502, 2040425, 1, 1, 0, 300),
(5120502, 2040927, 1, 1, 0, 300),
(5120502, 4130000, 1, 1, 0, 6000),
(5120502, 4130003, 1, 1, 0, 6000),
(5120502, 4130005, 1, 1, 0, 6000),
(5120503, 4000286, 1, 1, 0, 600000),
(5120503, 2000002, 1, 1, 0, 20000),
(5120503, 2000003, 1, 1, 0, 20000),
(5120503, 4004002, 1, 1, 0, 10000),
(5120503, 4020005, 1, 1, 0, 9000),
(5120503, 1332011, 1, 1, 0, 500),
(5120503, 1072118, 1, 1, 0, 800),
(5120503, 1051038, 1, 1, 0, 700),
(5120503, 2040901, 1, 1, 0, 300),
(5120503, 2002003, 1, 1, 0, 20000),
(5120503, 2044602, 1, 1, 0, 300),
(5120503, 1041088, 1, 1, 0, 800),
(5120503, 1060077, 1, 1, 0, 800),
(5120503, 1312008, 1, 1, 0, 700),
(5120503, 1072303, 1, 1, 0, 800),
(5120503, 2040026, 1, 1, 0, 300),
(5120503, 2040422, 1, 1, 0, 300),
(5120503, 2040925, 1, 1, 0, 300),
(5120503, 2040927, 1, 1, 0, 300),
(5120503, 4130002, 1, 1, 0, 6000),
(5120503, 4130010, 1, 1, 0, 6000),
(5120503, 4130013, 1, 1, 0, 6000),
(5120504, 4000287, 1, 1, 0, 600000),
(5120504, 2000002, 1, 1, 0, 20000),
(5120504, 2000003, 1, 1, 0, 20000),
(5120504, 4020002, 1, 1, 0, 9000),
(5120504, 4010006, 1, 1, 0, 9000),
(5120504, 4004000, 1, 1, 0, 10000),
(5120504, 1002215, 1, 1, 0, 1500),
(5120504, 1040097, 1, 1, 0, 800),
(5120504, 1060086, 1, 1, 0, 800),
(5120504, 1092007, 1, 1, 0, 700),
(5120504, 1072072, 1, 1, 0, 800),
(5120504, 1040105, 1, 1, 0, 800),
(5120504, 1060093, 1, 1, 0, 800),
(5120504, 4006001, 1, 1, 0, 10000),
(5120504, 2040504, 1, 1, 0, 300),
(5120504, 1002634, 1, 1, 0, 1500),
(5120504, 2330002, 1, 1, 0, 500),
(5120504, 2040619, 1, 1, 0, 300),
(5120504, 2040825, 1, 1, 0, 300),
(5120504, 2040931, 1, 1, 0, 300),
(5120504, 4130007, 1, 1, 0, 6000),
(5120504, 4130012, 1, 1, 0, 6000),
(5120505, 4000021, 1, 1, 0, 50000),
(5120505, 4003005, 1, 1, 0, 200000),
(5120505, 2000003, 1, 1, 0, 20000),
(5120505, 2000002, 1, 1, 0, 20000),
(5120505, 2000004, 1, 1, 0, 20000),
(5120505, 4010006, 1, 1, 0, 9000),
(5120505, 1082066, 1, 1, 0, 1000),
(5120505, 1072146, 1, 1, 0, 800),
(5120505, 1041077, 1, 1, 0, 800),
(5120505, 1061076, 1, 1, 0, 800),
(5120505, 1051037, 1, 1, 0, 700),
(5120505, 1002029, 1, 1, 0, 1500),
(5120505, 1002248, 1, 1, 0, 1500),
(5120505, 1002269, 1, 1, 0, 1500),
(5120505, 4000288, 1, 1, 0, 600000),
(5120505, 2040804, 1, 1, 0, 300),
(5120505, 2040901, 1, 1, 0, 300),
(5120505, 1052119, 1, 1, 0, 700),
(5120505, 2040421, 1, 1, 0, 300),
(5120505, 2040534, 1, 1, 0, 300),
(5120505, 2040928, 1, 1, 0, 300),
(5120505, 2049000, 1, 1, 0, 150),
(5120505, 4130004, 1, 1, 0, 6000),
(5120505, 4130008, 1, 1, 0, 6000),
(5120505, 4130009, 1, 1, 0, 6000),
(5120506, 4000298, 1, 1, 0, 600000),
(5120506, 2000002, 1, 1, 0, 20000),
(5120506, 2000003, 1, 1, 0, 20000),
(5120506, 4020008, 1, 1, 0, 9000),
(5120506, 4010006, 1, 1, 0, 9000),
(5120506, 1002168, 1, 1, 0, 1500),
(5120506, 1002092, 1, 1, 0, 1500),
(5120506, 1040086, 1, 1, 0, 800),
(5120506, 1072127, 1, 1, 0, 800),
(5120506, 1402006, 1, 1, 0, 700),
(5120506, 2044201, 1, 1, 0, 300),
(5120506, 1040095, 1, 1, 0, 800),
(5120506, 1060084, 1, 1, 0, 800),
(5120506, 1452004, 1, 1, 0, 500),
(5120506, 1412007, 1, 1, 0, 700),
(5120506, 1050059, 1, 1, 0, 700),
(5120506, 1442010, 1, 1, 0, 700),
(5120506, 4000299, 1, 1, 0, 100000),
(5120506, 1492007, 1, 1, 0, 500),
(5120506, 2330002, 1, 1, 0, 500),
(5120506, 2040317, 1, 1, 0, 300),
(5120506, 2040617, 1, 1, 0, 300),
(5120506, 2040825, 1, 1, 0, 300),
(5120506, 2040927, 1, 1, 0, 300),
(5120506, 4130006, 1, 1, 0, 6000),
(5120506, 4130014, 1, 1, 0, 6000),
(5130100, 4000014, 1, 1, 0, 600000),
(5130100, 2000002, 1, 1, 0, 20000),
(5130100, 2002004, 1, 1, 0, 20000),
(5130100, 2012000, 1, 1, 0, 20000),
(5130100, 2012003, 1, 1, 0, 20000),
(5130100, 4010006, 1, 1, 0, 9000),
(5130100, 4020007, 1, 1, 0, 9000),
(5130100, 4000030, 1, 1, 0, 60000),
(5130100, 2000004, 1, 1, 0, 20000),
(5130100, 2070003, 1, 1, 0, 500),
(5130100, 1452007, 1, 1, 0, 500),
(5130100, 1432005, 1, 1, 0, 500),
(5130100, 1072108, 1, 1, 0, 800),
(5130100, 1072116, 1, 1, 0, 800),
(5130100, 1412005, 1, 1, 0, 700),
(5130100, 1051030, 1, 1, 0, 700),
(5130100, 1051037, 1, 1, 0, 700),
(5130100, 1040089, 1, 1, 0, 800),
(5130100, 1060078, 1, 1, 0, 800),
(5130100, 1041077, 1, 1, 0, 800),
(5130100, 1061076, 1, 1, 0, 800),
(5130100, 1082083, 1, 1, 0, 1000),
(5130100, 1382006, 1, 1, 0, 700),
(5130100, 1092008, 1, 1, 0, 700),
(5130100, 1462004, 1, 1, 0, 500),
(5130100, 2002001, 1, 1, 0, 20000),
(5130100, 4010004, 1, 1, 0, 9000),
(5130100, 1002631, 1, 1, 0, 1500),
(5130100, 2040422, 1, 1, 0, 300),
(5130100, 4130004, 1, 1, 0, 6000),
(5130100, 4130009, 1, 1, 0, 6000),
(5130100, 4130015, 1, 1, 0, 6000),
(5130101, 4000022, 1, 1, 0, 600000),
(5130101, 4020008, 1, 1, 0, 9000),
(5130101, 2000004, 1, 1, 0, 20000),
(5130101, 1092002, 1, 1, 0, 700),
(5130101, 2000003, 1, 1, 0, 20000),
(5130101, 2044501, 1, 1, 0, 300),
(5130101, 2044601, 1, 1, 0, 300),
(5130101, 1372012, 1, 1, 0, 700),
(5130101, 1082025, 1, 1, 0, 1000),
(5130101, 1082076, 1, 1, 0, 1000),
(5130101, 1072121, 1, 1, 0, 800),
(5130101, 1072143, 1, 1, 0, 800),
(5130101, 1041080, 1, 1, 0, 800),
(5130101, 1061079, 1, 1, 0, 800),
(5130101, 1002086, 1, 1, 0, 1500),
(5130101, 1050048, 1, 1, 0, 700),
(5130101, 1002247, 1, 1, 0, 1500),
(5130101, 1041091, 1, 1, 0, 800),
(5130101, 1061090, 1, 1, 0, 800),
(5130101, 1312009, 1, 1, 0, 700),
(5130101, 1452005, 1, 1, 0, 500),
(5130101, 1032002, 1, 1, 0, 1000),
(5130101, 2070003, 1, 1, 0, 500),
(5130101, 2000006, 1, 1, 0, 20000),
(5130101, 1040084, 1, 1, 0, 800),
(5130101, 1072303, 1, 1, 0, 800),
(5130101, 4130010, 1, 1, 0, 6000),
(5130101, 4130013, 1, 1, 0, 6000),
(5130102, 1050039, 1, 1, 0, 700),
(5130102, 4000025, 1, 1, 0, 600000),
(5130102, 4004004, 1, 1, 0, 10000),
(5130102, 2000003, 1, 1, 0, 20000),
(5130102, 2000004, 1, 1, 0, 20000),
(5130102, 4020008, 1, 1, 0, 9000),
(5130102, 2070004, 1, 1, 0, 500),
(5130102, 2044201, 1, 1, 0, 300),
(5130102, 1040085, 1, 1, 0, 800),
(5130102, 1060074, 1, 1, 0, 800),
(5130102, 1061069, 1, 1, 0, 800),
(5130102, 1041074, 1, 1, 0, 800),
(5130102, 1072120, 1, 1, 0, 800),
(5130102, 1002209, 1, 1, 0, 1500),
(5130102, 1002214, 1, 1, 0, 1500),
(5130102, 1082009, 1, 1, 0, 1000),
(5130102, 1002022, 1, 1, 0, 1500),
(5130102, 1032021, 1, 1, 0, 1000),
(5130102, 1082088, 1, 1, 0, 1000),
(5130102, 1072139, 1, 1, 0, 800),
(5130102, 1102018, 1, 1, 0, 1000),
(5130102, 1002249, 1, 1, 0, 1500),
(5130102, 1040091, 1, 1, 0, 800),
(5130102, 1060080, 1, 1, 0, 800),
(5130102, 1050059, 1, 1, 0, 700),
(5130102, 1382007, 1, 1, 0, 700),
(5130102, 1492008, 1, 1, 0, 500),
(5130102, 2044802, 1, 1, 0, 300),
(5130102, 2040425, 1, 1, 0, 300),
(5130102, 2040618, 1, 1, 0, 300),
(5130102, 4130000, 1, 1, 0, 6000),
(5130102, 4130016, 1, 1, 0, 6000),
(5130102, 4130017, 1, 1, 0, 6000),
(5130103, 4000033, 1, 1, 0, 600000),
(5130103, 2000002, 1, 1, 0, 20000),
(5130103, 2000004, 1, 1, 0, 20000),
(5130103, 2000003, 1, 1, 0, 20000),
(5130103, 4010000, 1, 1, 0, 9000),
(5130103, 4020004, 1, 1, 0, 9000),
(5130103, 4020007, 1, 1, 0, 9000),
(5130103, 1332031, 1, 1, 0, 500),
(5130103, 1382019, 1, 1, 0, 700),
(5130103, 1050046, 1, 1, 0, 700),
(5130103, 1002218, 1, 1, 0, 1500),
(5130103, 1002210, 1, 1, 0, 1500),
(5130103, 1051038, 1, 1, 0, 700),
(5130103, 1041079, 1, 1, 0, 800),
(5130103, 1061078, 1, 1, 0, 800),
(5130103, 1040098, 1, 1, 0, 800),
(5130103, 1060087, 1, 1, 0, 800),
(5130103, 1092009, 1, 1, 0, 700),
(5130103, 1082092, 1, 1, 0, 1000),
(5130103, 1052119, 1, 1, 0, 700),
(5130103, 2044801, 1, 1, 0, 300),
(5130103, 2040027, 1, 1, 0, 300),
(5130103, 2043212, 1, 1, 0, 300),
(5130103, 2044212, 1, 1, 0, 300),
(5130103, 4130007, 1, 1, 0, 6000),
(5130103, 4130011, 1, 1, 0, 6000),
(5130104, 4000051, 1, 1, 0, 600000),
(5130104, 4003004, 1, 1, 0, 200000),
(5130104, 2041019, 1, 1, 0, 300),
(5130104, 4000021, 1, 1, 0, 50000),
(5130104, 2000003, 1, 1, 0, 20000),
(5130104, 2000004, 1, 1, 0, 20000),
(5130104, 4020001, 1, 1, 0, 9000),
(5130104, 4010001, 1, 1, 0, 9000),
(5130104, 2070003, 1, 1, 0, 500),
(5130104, 2060000, 1, 1, 0, 30000),
(5130104, 2061000, 1, 1, 0, 30000),
(5130104, 4004003, 1, 1, 0, 10000),
(5130104, 1102000, 1, 1, 0, 1000),
(5130104, 1082064, 1, 1, 0, 1000),
(5130104, 1082075, 1, 1, 0, 1000),
(5130104, 1072119, 1, 1, 0, 800),
(5130104, 1072127, 1, 1, 0, 800),
(5130104, 1002213, 1, 1, 0, 1500),
(5130104, 1002215, 1, 1, 0, 1500),
(5130104, 1040097, 1, 1, 0, 800),
(5130104, 1060086, 1, 1, 0, 800),
(5130104, 1050052, 1, 1, 0, 700),
(5130104, 1332017, 1, 1, 0, 500),
(5130104, 1422009, 1, 1, 0, 700),
(5130104, 1462008, 1, 1, 0, 500),
(5130104, 1482007, 1, 1, 0, 500),
(5130104, 2040326, 1, 1, 0, 300),
(5130104, 2044110, 1, 1, 0, 300),
(5130104, 2044809, 1, 1, 0, 300),
(5130104, 4130002, 1, 1, 0, 6000),
(5130104, 4130015, 1, 1, 0, 6000),
(5130104, 4130017, 1, 1, 0, 6000),
(5130105, 4000055, 1, 1, 0, 600000),
(5130105, 4003004, 1, 1, 0, 200000),
(5130105, 4004004, 1, 1, 0, 10000),
(5130105, 4000021, 1, 1, 0, 50000),
(5130105, 2000003, 1, 1, 0, 20000),
(5130105, 2000004, 1, 1, 0, 20000),
(5130105, 4020004, 1, 1, 0, 9000),
(5130105, 4010005, 1, 1, 0, 9000),
(5130105, 4004002, 1, 1, 0, 10000),
(5130105, 2043701, 1, 1, 0, 300),
(5130105, 1041086, 1, 1, 0, 800),
(5130105, 1061085, 1, 1, 0, 800),
(5130105, 1041082, 1, 1, 0, 800),
(5130105, 1061081, 1, 1, 0, 800),
(5130105, 1002208, 1, 1, 0, 1500),
(5130105, 1002216, 1, 1, 0, 1500),
(5130105, 1032021, 1, 1, 0, 1000),
(5130105, 1382006, 1, 1, 0, 700),
(5130105, 1102015, 1, 1, 0, 1000),
(5130105, 1072151, 1, 1, 0, 800),
(5130105, 1072138, 1, 1, 0, 800),
(5130105, 1082059, 1, 1, 0, 1000),
(5130105, 1082090, 1, 1, 0, 1000),
(5130105, 1092010, 1, 1, 0, 700),
(5130105, 1040102, 1, 1, 0, 800),
(5130105, 1060090, 1, 1, 0, 800),
(5130105, 2040027, 1, 1, 0, 300),
(5130105, 2040317, 1, 1, 0, 300),
(5130105, 2044112, 1, 1, 0, 300),
(5130105, 4130007, 1, 1, 0, 6000),
(5130105, 4130017, 1, 1, 0, 6000),
(5130107, 4000069, 1, 1, 0, 600000),
(5130107, 2000003, 1, 1, 0, 20000),
(5130107, 2000004, 1, 1, 0, 20000),
(5130107, 2000002, 1, 1, 0, 20000),
(5130107, 4010000, 1, 1, 0, 9000),
(5130107, 4020006, 1, 1, 0, 9000),
(5130107, 4004000, 1, 1, 0, 10000),
(5130107, 1082062, 1, 1, 0, 1000),
(5130107, 1082071, 1, 1, 0, 1000),
(5130107, 1072109, 1, 1, 0, 800),
(5130107, 1072117, 1, 1, 0, 800),
(5130107, 1322016, 1, 1, 0, 700),
(5130107, 1312008, 1, 1, 0, 700),
(5130107, 1051039, 1, 1, 0, 700),
(5130107, 1040094, 1, 1, 0, 800),
(5130107, 1060083, 1, 1, 0, 800),
(5130107, 1032019, 1, 1, 0, 1000),
(5130107, 1002244, 1, 1, 0, 1500),
(5130107, 1102016, 1, 1, 0, 1000),
(5130107, 1040092, 1, 1, 0, 800),
(5130107, 1060081, 1, 1, 0, 800),
(5130107, 1002269, 1, 1, 0, 1500),
(5130107, 1002247, 1, 1, 0, 1500),
(5130107, 1040105, 1, 1, 0, 800),
(5130107, 1060093, 1, 1, 0, 800),
(5130107, 1482008, 1, 1, 0, 500),
(5130107, 2040026, 1, 1, 0, 300),
(5130107, 2040515, 1, 1, 0, 300),
(5130107, 4130001, 1, 1, 0, 6000),
(5130107, 4130006, 1, 1, 0, 6000),
(5130107, 4130011, 1, 1, 0, 6000),
(5130108, 4000069, 1, 1, 0, 600000),
(5130108, 4000082, 1, 1, 0, 20000),
(5130108, 2000003, 1, 1, 0, 20000),
(5130108, 2000004, 1, 1, 0, 20000),
(5130108, 2000002, 1, 1, 0, 20000),
(5130108, 4010001, 1, 1, 0, 9000),
(5130108, 4020004, 1, 1, 0, 9000),
(5130108, 4004002, 1, 1, 0, 10000),
(5130108, 2040402, 1, 1, 0, 300),
(5130108, 1002169, 1, 1, 0, 1500),
(5130108, 1002155, 1, 1, 0, 1500),
(5130108, 1041084, 1, 1, 0, 800),
(5130108, 1061083, 1, 1, 0, 800),
(5130108, 1332011, 1, 1, 0, 500),
(5130108, 1032018, 1, 1, 0, 1000),
(5130108, 1072130, 1, 1, 0, 800),
(5130108, 1072133, 1, 1, 0, 800),
(5130108, 1072141, 1, 1, 0, 800),
(5130108, 1051046, 1, 1, 0, 700),
(5130108, 1102017, 1, 1, 0, 1000),
(5130108, 1051043, 1, 1, 0, 700),
(5130108, 1092011, 1, 1, 0, 700),
(5130108, 1082094, 1, 1, 0, 1000),
(5130108, 1002084, 1, 1, 0, 1500),
(5130108, 1002243, 1, 1, 0, 1500),
(5130108, 1041100, 1, 1, 0, 800),
(5130108, 1061099, 1, 1, 0, 800),
(5130108, 2040029, 1, 1, 0, 300),
(5130108, 2040419, 1, 1, 0, 300),
(5130108, 4130002, 1, 1, 0, 6000),
(5130108, 4130014, 1, 1, 0, 6000),
(5130108, 4130015, 1, 1, 0, 6000),
(5140000, 4000052, 1, 1, 0, 600000),
(5140000, 4003005, 1, 1, 0, 200000),
(5140000, 4000021, 1, 1, 0, 50000),
(5140000, 2000003, 1, 1, 0, 20000),
(5140000, 2000004, 1, 1, 0, 20000),
(5140000, 2070004, 1, 1, 0, 500),
(5140000, 4020007, 1, 1, 0, 9000),
(5140000, 4020000, 1, 1, 0, 9000),
(5140000, 2060000, 1, 1, 0, 30000),
(5140000, 2040901, 1, 1, 0, 300),
(5140000, 4004001, 1, 1, 0, 10000),
(5140000, 4006001, 1, 1, 0, 10000),
(5140000, 2061000, 1, 1, 0, 30000),
(5140000, 1422008, 1, 1, 0, 700),
(5140000, 1472014, 1, 1, 0, 500),
(5140000, 1082072, 1, 1, 0, 1000),
(5140000, 1072114, 1, 1, 0, 800),
(5140000, 1072127, 1, 1, 0, 800),
(5140000, 1082066, 1, 1, 0, 1000),
(5140000, 1072134, 1, 1, 0, 800),
(5140000, 1050051, 1, 1, 0, 700),
(5140000, 1041077, 1, 1, 0, 800),
(5140000, 1061076, 1, 1, 0, 800),
(5140000, 1050053, 1, 1, 0, 700),
(5140000, 1032014, 1, 1, 0, 1000),
(5140000, 1412007, 1, 1, 0, 700),
(5140000, 1050059, 1, 1, 0, 700),
(5140000, 1002029, 1, 1, 0, 1500),
(5140000, 1072151, 1, 1, 0, 800),
(5140000, 1102021, 1, 1, 0, 1000),
(5140000, 1041097, 1, 1, 0, 800),
(5140000, 1061096, 1, 1, 0, 800),
(5140000, 1002634, 1, 1, 0, 1500),
(5140000, 2040024, 1, 1, 0, 300),
(5140000, 2044214, 1, 1, 0, 300),
(5140000, 4130001, 1, 1, 0, 6000),
(5140000, 4130003, 1, 1, 0, 6000),
(5140000, 4130013, 1, 1, 0, 6000),
(5150000, 4000177, 1, 1, 0, 600000),
(5150000, 2060000, 1, 1, 0, 30000),
(5150000, 2061000, 1, 1, 0, 30000),
(5150000, 1082066, 1, 1, 0, 1000),
(5150000, 1072146, 1, 1, 0, 800),
(5150000, 1082087, 1, 1, 0, 1000),
(5150000, 4010006, 1, 1, 0, 9000),
(5150000, 2000004, 1, 1, 0, 20000),
(5150000, 1041077, 1, 1, 0, 800),
(5150000, 1061076, 1, 1, 0, 800),
(5150000, 2000003, 1, 1, 0, 20000),
(5150000, 2000002, 1, 1, 0, 20000),
(5150000, 1051037, 1, 1, 0, 700),
(5150000, 1041094, 1, 1, 0, 800),
(5150000, 1061093, 1, 1, 0, 800),
(5150000, 1040092, 1, 1, 0, 800),
(5150000, 1060081, 1, 1, 0, 800),
(5150000, 2040804, 1, 1, 0, 300),
(5150000, 2040901, 1, 1, 0, 300),
(5150000, 1002029, 1, 1, 0, 1500),
(5150000, 1002248, 1, 1, 0, 1500),
(5150000, 1002269, 1, 1, 0, 1500),
(5150000, 1372014, 1, 1, 0, 700),
(5150000, 1072306, 1, 1, 0, 800),
(5150000, 2040824, 1, 1, 0, 300),
(5150000, 2040928, 1, 1, 0, 300),
(5150000, 4130005, 1, 1, 0, 6000),
(5150000, 4130007, 1, 1, 0, 6000),
(5150001, 4000206, 1, 1, 0, 600000),
(5150001, 2000003, 1, 1, 0, 20000),
(5150001, 2000004, 1, 1, 0, 20000),
(5150001, 4020004, 1, 1, 0, 9000),
(5150001, 4010005, 1, 1, 0, 9000),
(5150001, 1072122, 1, 1, 0, 800),
(5150001, 1072132, 1, 1, 0, 800),
(5150001, 1072140, 1, 1, 0, 800),
(5150001, 1072128, 1, 1, 0, 800),
(5150001, 2043801, 1, 1, 0, 300),
(5150001, 1040092, 1, 1, 0, 800),
(5150001, 1060081, 1, 1, 0, 800),
(5150001, 1040098, 1, 1, 0, 800),
(5150001, 1060087, 1, 1, 0, 800),
(5150001, 1050059, 1, 1, 0, 700),
(5150001, 1051045, 1, 1, 0, 700),
(5150001, 1002030, 1, 1, 0, 1500),
(5150001, 1002252, 1, 1, 0, 1500),
(5150001, 1002281, 1, 1, 0, 1500),
(5150001, 1002287, 1, 1, 0, 1500),
(5150001, 2044701, 1, 1, 0, 300),
(5150001, 2043701, 1, 1, 0, 300),
(5150001, 1072306, 1, 1, 0, 800),
(5150001, 2043210, 1, 1, 0, 300),
(5150001, 2044312, 1, 1, 0, 300),
(5150001, 4130003, 1, 1, 0, 6000),
(5150001, 4130010, 1, 1, 0, 6000),
(5200000, 4000083, 1, 1, 0, 600000),
(5200000, 4010000, 1, 1, 0, 9000),
(5200000, 4020006, 1, 1, 0, 9000),
(5200000, 4004003, 1, 1, 0, 10000),
(5200000, 2044102, 1, 1, 0, 300),
(5200000, 2000001, 1, 1, 0, 20000),
(5200000, 2000003, 1, 1, 0, 20000),
(5200000, 1002129, 1, 1, 0, 1500),
(5200000, 1322002, 1, 1, 0, 700),
(5200000, 1322004, 1, 1, 0, 700),
(5200000, 1040016, 1, 1, 0, 800),
(5200000, 1060011, 1, 1, 0, 800),
(5200000, 1041048, 1, 1, 0, 800),
(5200000, 1061044, 1, 1, 0, 800),
(5200000, 2070000, 1, 1, 0, 500),
(5200000, 2060001, 1, 1, 0, 30000),
(5200000, 2061001, 1, 1, 0, 30000),
(5200000, 1482002, 1, 1, 0, 500),
(5200000, 2044212, 1, 1, 0, 300),
(5200001, 4000084, 1, 1, 0, 600000),
(5200001, 4020002, 1, 1, 0, 9000),
(5200001, 4010002, 1, 1, 0, 9000),
(5200001, 4004001, 1, 1, 0, 10000),
(5200001, 4006000, 1, 1, 0, 10000),
(5200001, 2041016, 1, 1, 0, 300),
(5200001, 2000001, 1, 1, 0, 20000),
(5200001, 2000003, 1, 1, 0, 20000),
(5200001, 1002142, 1, 1, 0, 1500),
(5200001, 1040024, 1, 1, 0, 800),
(5200001, 1062006, 1, 1, 0, 800),
(5200001, 1322009, 1, 1, 0, 700),
(5200001, 1061043, 1, 1, 0, 800),
(5200001, 1041047, 1, 1, 0, 800),
(5200001, 1442003, 1, 1, 0, 700),
(5200001, 1050026, 1, 1, 0, 700),
(5200001, 2060001, 1, 1, 0, 30000),
(5200001, 2061001, 1, 1, 0, 30000),
(5200001, 2049000, 1, 1, 0, 150),
(5200002, 4000085, 1, 1, 0, 600000),
(5200002, 4020000, 1, 1, 0, 9000),
(5200002, 4010005, 1, 1, 0, 9000),
(5200002, 4004001, 1, 1, 0, 10000),
(5200002, 4006000, 1, 1, 0, 10000),
(5200002, 2040805, 1, 1, 0, 300),
(5200002, 2000001, 1, 1, 0, 20000),
(5200002, 2000003, 1, 1, 0, 20000),
(5200002, 1082052, 1, 1, 0, 1000),
(5200002, 1041059, 1, 1, 0, 800),
(5200002, 1061055, 1, 1, 0, 800),
(5200002, 1041054, 1, 1, 0, 800),
(5200002, 1061050, 1, 1, 0, 800),
(5200002, 1032009, 1, 1, 0, 1000),
(5200002, 1041064, 1, 1, 0, 800),
(5200002, 1072089, 1, 1, 0, 800),
(5200002, 1452006, 1, 1, 0, 500),
(5200002, 1050000, 1, 1, 0, 700),
(5200002, 2060001, 1, 1, 0, 30000),
(5200002, 2061001, 1, 1, 0, 30000),
(5200002, 2040926, 1, 1, 0, 300),
(5220000, 4000043, 1, 1, 0, 600000),
(5220000, 4000043, 1, 1, 0, 600000),
(5220000, 4000043, 1, 1, 0, 600000),
(5220000, 4000044, 1, 1, 0, 600000),
(5220000, 4000044, 1, 1, 0, 600000),
(5220000, 4000044, 1, 1, 0, 600000),
(5220000, 4010003, 1, 1, 0, 90000),
(5220000, 4020005, 1, 1, 0, 90000),
(5220000, 2000002, 1, 1, 0, 200000),
(5220000, 2000003, 1, 1, 0, 200000),
(5220000, 2001001, 1, 1, 0, 200000),
(5220000, 2002000, 1, 1, 0, 200000),
(5220000, 2041022, 1, 1, 0, 3000),
(5220000, 2044601, 1, 1, 0, 3000),
(5220000, 2041013, 1, 1, 0, 3000),
(5220000, 2044701, 1, 1, 0, 3000),
(5220000, 2048001, 1, 1, 0, 3000),
(5220000, 2040707, 1, 1, 0, 3000),
(5220000, 2040004, 1, 1, 0, 3000),
(5220000, 2040513, 1, 1, 0, 3000),
(5220000, 2040704, 1, 1, 0, 3000),
(5220000, 2040804, 1, 1, 0, 3000),
(5220000, 2040702, 1, 1, 0, 3000),
(5220000, 2040802, 1, 1, 0, 3000),
(5220000, 2040902, 1, 1, 0, 3000),
(5220000, 2041002, 1, 1, 0, 3000),
(5220000, 2043002, 1, 1, 0, 3000),
(5220000, 2060000, 1, 1, 0, 300000),
(5220000, 2061000, 1, 1, 0, 300000),
(5220000, 1002029, 1, 1, 0, 15000),
(5220000, 1002246, 1, 1, 0, 15000),
(5220000, 1002270, 1, 1, 0, 15000),
(5220000, 1002249, 1, 1, 0, 15000),
(5220000, 1040093, 1, 1, 0, 8000),
(5220000, 1041092, 1, 1, 0, 8000),
(5220000, 1050056, 1, 1, 0, 7000),
(5220000, 1051047, 1, 1, 0, 7000),
(5220000, 1050060, 1, 1, 0, 7000),
(5220000, 1051041, 1, 1, 0, 7000),
(5220000, 1040100, 1, 1, 0, 8000),
(5220000, 1041095, 1, 1, 0, 8000),
(5220000, 1082061, 1, 1, 0, 10000),
(5220000, 1082088, 1, 1, 0, 10000),
(5220000, 1082091, 1, 1, 0, 10000),
(5220000, 1082094, 1, 1, 0, 10000),
(5220000, 1072149, 1, 1, 0, 8000),
(5220000, 1072136, 1, 1, 0, 8000),
(5220000, 1072144, 1, 1, 0, 8000),
(5220000, 1072152, 1, 1, 0, 8000),
(5220000, 1002634, 1, 1, 0, 15000),
(5220000, 1052119, 1, 1, 0, 7000),
(5220000, 1082201, 1, 1, 0, 10000),
(5220000, 1072306, 1, 1, 0, 8000),
(5220000, 3010008, 1, 1, 0, 5000),
(5220002, 4000029, 1, 1, 0, 600000),
(5220002, 4000029, 1, 1, 0, 600000),
(5220002, 4000029, 1, 1, 0, 600000),
(5220002, 4000031, 1, 1, 0, 600000),
(5220002, 4000031, 1, 1, 0, 600000),
(5220002, 4000031, 1, 1, 0, 600000),
(5220002, 4000021, 1, 1, 0, 500000),
(5220002, 4000021, 1, 1, 0, 500000),
(5220002, 4000021, 1, 1, 0, 500000),
(5220002, 4000026, 1, 1, 0, 600000),
(5220002, 4000026, 1, 1, 0, 600000),
(5220002, 4000026, 1, 1, 0, 600000),
(5220002, 4010005, 1, 1, 0, 90000),
(5220002, 4020005, 1, 1, 0, 90000),
(5220002, 2000002, 1, 1, 0, 200000),
(5220002, 2000003, 1, 1, 0, 200000),
(5220002, 2002002, 1, 1, 0, 200000),
(5220002, 2002003, 1, 1, 0, 200000),
(5220002, 2040301, 1, 1, 0, 3000),
(5220002, 2040504, 1, 1, 0, 3000),
(5220002, 2040707, 1, 1, 0, 3000),
(5220002, 2040801, 1, 1, 0, 3000),
(5220002, 2040901, 1, 1, 0, 3000),
(5220002, 2041016, 1, 1, 0, 3000),
(5220002, 2043801, 1, 1, 0, 3000),
(5220002, 2044101, 1, 1, 0, 3000),
(5220002, 2044601, 1, 1, 0, 3000),
(5220002, 2044701, 1, 1, 0, 3000),
(5220002, 2040514, 1, 1, 0, 3000),
(5220002, 2041002, 1, 1, 0, 3000),
(5220002, 2041017, 1, 1, 0, 3000),
(5220002, 2043702, 1, 1, 0, 3000),
(5220002, 2044302, 1, 1, 0, 3000),
(5220002, 2060000, 1, 1, 0, 300000),
(5220002, 2061000, 1, 1, 0, 300000),
(5220002, 1302010, 1, 1, 0, 7000),
(5220002, 1312008, 1, 1, 0, 7000),
(5220002, 1322017, 1, 1, 0, 7000),
(5220002, 1332003, 1, 1, 0, 5000),
(5220002, 1372007, 1, 1, 0, 7000),
(5220002, 1382006, 1, 1, 0, 7000),
(5220002, 1402003, 1, 1, 0, 7000),
(5220002, 1412003, 1, 1, 0, 7000),
(5220002, 1422005, 1, 1, 0, 7000),
(5220002, 1432004, 1, 1, 0, 5000),
(5220002, 1442005, 1, 1, 0, 7000),
(5220002, 1452008, 1, 1, 0, 5000),
(5220002, 1462007, 1, 1, 0, 5000),
(5220002, 1472021, 1, 1, 0, 5000),
(5220002, 1482007, 1, 1, 0, 5000),
(5220002, 1492007, 1, 1, 0, 5000),
(5220002, 2044802, 1, 1, 0, 3000),
(5220002, 2044901, 1, 1, 0, 3000),
(5220002, 1432039, 1, 1, 0, 5000),
(5220002, 2040931, 1, 1, 0, 3000),
(5220002, 2040928, 1, 1, 0, 3000),
(5220003, 4000113, 1, 1, 0, 600000),
(5220003, 4000113, 1, 1, 0, 600000),
(5220003, 4000113, 1, 1, 0, 600000),
(5220003, 4000114, 1, 1, 0, 600000),
(5220003, 4000114, 1, 1, 0, 600000),
(5220003, 4000114, 1, 1, 0, 600000),
(5220003, 4000115, 1, 1, 0, 600000),
(5220003, 4000115, 1, 1, 0, 600000),
(5220003, 4000115, 1, 1, 0, 600000),
(5220003, 4004001, 1, 1, 0, 100000),
(5220003, 4010003, 1, 1, 0, 90000),
(5220003, 4020006, 1, 1, 0, 90000),
(5220003, 2000002, 1, 1, 0, 200000),
(5220003, 2000003, 1, 1, 0, 200000),
(5220003, 2002002, 1, 1, 0, 200000),
(5220003, 2002003, 1, 1, 0, 200000),
(5220003, 2040401, 1, 1, 0, 3000),
(5220003, 2040516, 1, 1, 0, 3000),
(5220003, 2040704, 1, 1, 0, 3000),
(5220003, 2040804, 1, 1, 0, 3000),
(5220003, 2041013, 1, 1, 0, 3000),
(5220003, 2041016, 1, 1, 0, 3000),
(5220003, 2043201, 1, 1, 0, 3000),
(5220003, 2043701, 1, 1, 0, 3000),
(5220003, 2044201, 1, 1, 0, 3000),
(5220003, 2044301, 1, 1, 0, 3000),
(5220003, 2040302, 1, 1, 0, 3000),
(5220003, 2040502, 1, 1, 0, 3000),
(5220003, 2041002, 1, 1, 0, 3000),
(5220003, 2043802, 1, 1, 0, 3000),
(5220003, 2044502, 1, 1, 0, 3000),
(5220003, 2060000, 1, 1, 0, 300000),
(5220003, 2061000, 1, 1, 0, 300000),
(5220003, 1302011, 1, 1, 0, 7000),
(5220003, 1312009, 1, 1, 0, 7000),
(5220003, 1322018, 1, 1, 0, 7000),
(5220003, 1332015, 1, 1, 0, 5000),
(5220003, 1332017, 1, 1, 0, 5000),
(5220003, 1372014, 1, 1, 0, 7000),
(5220003, 1382007, 1, 1, 0, 7000),
(5220003, 1402011, 1, 1, 0, 7000),
(5220003, 1412007, 1, 1, 0, 7000),
(5220003, 1422009, 1, 1, 0, 7000),
(5220003, 1432006, 1, 1, 0, 5000),
(5220003, 1442010, 1, 1, 0, 7000),
(5220003, 1452004, 1, 1, 0, 5000),
(5220003, 1462008, 1, 1, 0, 5000),
(5220003, 1472025, 1, 1, 0, 5000),
(5220003, 1482008, 1, 1, 0, 5000),
(5220003, 1492008, 1, 1, 0, 5000),
(5220003, 2044801, 1, 1, 0, 3000),
(5220003, 2044902, 1, 1, 0, 3000),
(5220003, 1372033, 1, 1, 0, 7000),
(5220003, 2040627, 1, 1, 0, 3000),
(5220003, 2040825, 1, 1, 0, 3000),
(5220003, 2040933, 1, 1, 0, 3000),
(5220003, 2044114, 1, 1, 0, 3000),
(5220003, 2044807, 1, 1, 0, 3000),
(5220004, 2040001, 1, 1, 0, 3000),
(5220004, 2040004, 1, 1, 0, 3000),
(5220004, 2040301, 1, 1, 0, 3000),
(5220004, 2040401, 1, 1, 0, 3000),
(5220004, 2040501, 1, 1, 0, 3000),
(5220004, 2040504, 1, 1, 0, 3000),
(5220004, 2040601, 1, 1, 0, 3000),
(5220004, 2040701, 1, 1, 0, 3000),
(5220004, 2040704, 1, 1, 0, 3000),
(5220004, 2040707, 1, 1, 0, 3000),
(5220004, 2040801, 1, 1, 0, 3000),
(5220004, 2041001, 1, 1, 0, 3000),
(5220004, 2041004, 1, 1, 0, 3000),
(5220004, 2040804, 1, 1, 0, 3000),
(5220004, 2040901, 1, 1, 0, 3000),
(5220004, 2070005, 1, 1, 0, 4000),
(5220004, 1102002, 1, 1, 0, 10000),
(5220004, 1032013, 1, 1, 0, 10000),
(5220004, 2000005, 1, 1, 0, 999999),
(5220004, 1452009, 1, 1, 0, 5000),
(5220004, 1382007, 1, 1, 0, 7000),
(5220004, 1462009, 1, 1, 0, 5000),
(5220004, 1322019, 1, 1, 0, 7000),
(5220004, 1312010, 1, 1, 0, 7000),
(5220004, 1412008, 1, 1, 0, 7000),
(5220004, 1422010, 1, 1, 0, 7000),
(5220004, 1472026, 1, 1, 0, 5000),
(5220004, 1432007, 1, 1, 0, 5000),
(5220004, 1442008, 1, 1, 0, 7000),
(5220004, 1302012, 1, 1, 0, 7000),
(5220004, 1402012, 1, 1, 0, 7000),
(5220004, 1332018, 1, 1, 0, 5000),
(5220004, 1332019, 1, 1, 0, 5000),
(5220004, 2043001, 1, 1, 0, 3000),
(5220004, 2043101, 1, 1, 0, 3000),
(5220004, 2043201, 1, 1, 0, 3000),
(5220004, 2043301, 1, 1, 0, 3000),
(5220004, 2043701, 1, 1, 0, 3000),
(5220004, 2043801, 1, 1, 0, 3000),
(5220004, 2044001, 1, 1, 0, 3000),
(5220004, 2044101, 1, 1, 0, 3000),
(5220004, 2044201, 1, 1, 0, 3000),
(5220004, 2044301, 1, 1, 0, 3000),
(5220004, 2044401, 1, 1, 0, 3000),
(5220004, 2044501, 1, 1, 0, 3000),
(5220004, 2044601, 1, 1, 0, 3000),
(5220004, 2044701, 1, 1, 0, 3000),
(5220004, 2000004, 1, 1, 0, 999999),
(5220004, 1092017, 1, 1, 0, 7000),
(5250000, 2000002, 1, 1, 0, 20000),
(5250000, 2000003, 1, 1, 0, 20000),
(5250000, 4010002, 1, 1, 0, 9000),
(5250000, 4020002, 1, 1, 0, 9000),
(5250000, 2044312, 1, 1, 0, 300),
(5250000, 1002208, 1, 1, 0, 1500),
(5250000, 1052116, 1, 1, 0, 700),
(5250000, 1082010, 1, 1, 0, 1000),
(5250000, 1072143, 1, 1, 0, 800),
(5250000, 1452004, 1, 1, 0, 500),
(5250000, 4000437, 1, 1, 0, 600000),
(5250000, 4130003, 1, 1, 0, 6000),
(5250000, 4130014, 1, 1, 0, 6000),
(5250000, 4130017, 1, 1, 0, 6000),
(5250001, 2000002, 1, 1, 0, 20000),
(5250001, 2000003, 1, 1, 0, 20000),
(5250001, 4010000, 1, 1, 0, 9000),
(5250001, 4020000, 1, 1, 0, 9000),
(5250001, 2041014, 1, 1, 0, 300),
(5250001, 1002214, 1, 1, 0, 1500),
(5250001, 1040096, 1, 1, 0, 800),
(5250001, 1041079, 1, 1, 0, 800),
(5250001, 1082198, 1, 1, 0, 1000),
(5250001, 1072133, 1, 1, 0, 800),
(5250001, 1372007, 1, 1, 0, 700),
(5250001, 4000439, 1, 1, 0, 600000),
(5250001, 4130015, 1, 1, 0, 6000),
(5250001, 4130016, 1, 1, 0, 6000),
(5250002, 4000440, 1, 1, 0, 600000),
(5250002, 2000002, 1, 1, 0, 20000),
(5250002, 2000003, 1, 1, 0, 20000),
(5250002, 4010001, 1, 1, 0, 9000),
(5250002, 4020003, 1, 1, 0, 9000),
(5250002, 2044802, 1, 1, 0, 300),
(5250002, 1002634, 1, 1, 0, 1500),
(5250002, 1040092, 1, 1, 0, 800),
(5250002, 1041093, 1, 1, 0, 800),
(5250002, 1082087, 1, 1, 0, 1000),
(5250002, 1072145, 1, 1, 0, 800),
(5250002, 1332015, 1, 1, 0, 500),
(5250002, 4130001, 1, 1, 0, 6000),
(5250002, 4130014, 1, 1, 0, 6000),
(5300000, 4000086, 1, 1, 0, 600000),
(5300000, 4010001, 1, 1, 0, 9000),
(5300000, 4020003, 1, 1, 0, 9000),
(5300000, 4004000, 1, 1, 0, 10000),
(5300000, 4006001, 1, 1, 0, 10000),
(5300000, 2000002, 1, 1, 0, 20000),
(5300000, 2000003, 1, 1, 0, 20000),
(5300000, 2050001, 1, 1, 0, 50000),
(5300000, 2070001, 1, 1, 0, 500),
(5300000, 4020007, 1, 1, 0, 9000),
(5300000, 1082016, 1, 1, 0, 1000),
(5300000, 1002035, 1, 1, 0, 1500),
(5300000, 1002165, 1, 1, 0, 1500),
(5300000, 1041048, 1, 1, 0, 800),
(5300000, 1061044, 1, 1, 0, 800),
(5300000, 1072081, 1, 1, 0, 800),
(5300000, 1072075, 1, 1, 0, 800),
(5300000, 1382017, 1, 1, 0, 700),
(5300000, 1032002, 1, 1, 0, 1000),
(5300000, 1040030, 1, 1, 0, 800),
(5300000, 1060020, 1, 1, 0, 800),
(5300000, 1082054, 1, 1, 0, 1000),
(5300000, 2040705, 1, 1, 0, 300),
(5300000, 1482004, 1, 1, 0, 500),
(5300000, 4130000, 1, 1, 0, 6000),
(5300000, 4130005, 1, 1, 0, 6000),
(5300000, 4130011, 1, 1, 0, 6000),
(5300001, 4000087, 1, 1, 0, 600000),
(5300001, 4010000, 1, 1, 0, 9000),
(5300001, 4020004, 1, 1, 0, 9000),
(5300001, 4004001, 1, 1, 0, 10000),
(5300001, 4006001, 1, 1, 0, 10000),
(5300001, 2040402, 1, 1, 0, 300),
(5300001, 2000002, 1, 1, 0, 20000),
(5300001, 2000003, 1, 1, 0, 20000),
(5300001, 2050000, 1, 1, 0, 50000),
(5300001, 1002175, 1, 1, 0, 1500),
(5300001, 1402002, 1, 1, 0, 700),
(5300001, 1050029, 1, 1, 0, 700),
(5300001, 1002138, 1, 1, 0, 1500),
(5300001, 1041068, 1, 1, 0, 800),
(5300001, 1061063, 1, 1, 0, 800),
(5300001, 1082036, 1, 1, 0, 1000),
(5300001, 1072105, 1, 1, 0, 800),
(5300001, 1332014, 1, 1, 0, 500),
(5300001, 1051023, 1, 1, 0, 700),
(5300001, 1002625, 1, 1, 0, 1500),
(5300001, 2040623, 1, 1, 0, 300),
(5300001, 4130013, 1, 1, 0, 6000),
(5300001, 4130016, 1, 1, 0, 6000),
(5300100, 4000041, 1, 1, 0, 600000),
(5300100, 4004004, 1, 1, 0, 10000),
(5300100, 2000002, 1, 1, 0, 20000),
(5300100, 2000003, 1, 1, 0, 20000),
(5300100, 4020008, 1, 1, 0, 9000),
(5300100, 4010006, 1, 1, 0, 9000),
(5300100, 2000004, 1, 1, 0, 20000),
(5300100, 4006000, 1, 1, 0, 10000),
(5300100, 1002168, 1, 1, 0, 1500),
(5300100, 1002092, 1, 1, 0, 1500),
(5300100, 1040086, 1, 1, 0, 800),
(5300100, 1060000, 1, 1, 0, 800),
(5300100, 1051031, 1, 1, 0, 700),
(5300100, 1051039, 1, 1, 0, 700),
(5300100, 1082011, 1, 1, 0, 1000),
(5300100, 1452008, 1, 1, 0, 500),
(5300100, 1072143, 1, 1, 0, 800),
(5300100, 1472020, 1, 1, 0, 500),
(5300100, 1032019, 1, 1, 0, 1000),
(5300100, 1040090, 1, 1, 0, 800),
(5300100, 1060079, 1, 1, 0, 800),
(5300100, 1452004, 1, 1, 0, 500),
(5300100, 1072137, 1, 1, 0, 800),
(5300100, 1082093, 1, 1, 0, 1000),
(5300100, 1082198, 1, 1, 0, 1000),
(5300100, 4130006, 1, 1, 0, 6000),
(5300100, 4130010, 1, 1, 0, 6000),
(5300100, 4130016, 1, 1, 0, 6000),
(5400000, 4000088, 1, 1, 0, 600000),
(5400000, 4020005, 1, 1, 0, 9000),
(5400000, 4010003, 1, 1, 0, 9000),
(5400000, 4004003, 1, 1, 0, 10000),
(5400000, 4006000, 1, 1, 0, 10000),
(5400000, 2043801, 1, 1, 0, 300),
(5400000, 2000002, 1, 1, 0, 20000),
(5400000, 2000003, 1, 1, 0, 20000),
(5400000, 2050002, 1, 1, 0, 50000),
(5400000, 1432008, 1, 1, 0, 500),
(5400000, 2070002, 1, 1, 0, 500),
(5400000, 2060001, 1, 1, 0, 30000),
(5400000, 2061001, 1, 1, 0, 30000),
(5400000, 1060045, 1, 1, 0, 800),
(5400000, 1040059, 1, 1, 0, 800),
(5400000, 1002177, 1, 1, 0, 1500),
(5400000, 1041067, 1, 1, 0, 800),
(5400000, 1061062, 1, 1, 0, 800),
(5400000, 1051001, 1, 1, 0, 700),
(5400000, 1422008, 1, 1, 0, 700),
(5400000, 1002021, 1, 1, 0, 1500),
(5400000, 1082062, 1, 1, 0, 1000),
(5400000, 1072108, 1, 1, 0, 800),
(5400000, 1422007, 1, 1, 0, 700),
(5400000, 1082192, 1, 1, 0, 1000),
(5400000, 2044801, 1, 1, 0, 300),
(5400000, 2044809, 1, 1, 0, 300),
(5400000, 4130002, 1, 1, 0, 6000),
(5400000, 4130011, 1, 1, 0, 6000),
(5400000, 4130014, 1, 1, 0, 6000),
(6090000, 4000336, 1, 1, 0, 600000),
(6090001, 4000415, 1, 1, 0, 600000),
(6090003, 4000416, 1, 1, 0, 600000),
(6090004, 4000419, 1, 1, 0, 600000),
(6110300, 2000006, 1, 1, 0, 20000),
(6110300, 4020007, 1, 1, 0, 9000),
(6110300, 4010000, 1, 1, 0, 9000),
(6110300, 4004000, 1, 1, 0, 10000),
(6110300, 1041078, 1, 1, 0, 800),
(6110300, 1041089, 1, 1, 0, 800),
(6110300, 1002022, 1, 1, 0, 1500),
(6110300, 1032019, 1, 1, 0, 1000),
(6110300, 1051047, 1, 1, 0, 700),
(6110300, 1040099, 1, 1, 0, 800),
(6110300, 1060088, 1, 1, 0, 800),
(6110300, 1432006, 1, 1, 0, 500),
(6110300, 1462008, 1, 1, 0, 500),
(6110300, 1472024, 1, 1, 0, 500),
(6110300, 1102022, 1, 1, 0, 1000),
(6110300, 1382007, 1, 1, 0, 700),
(6110300, 1472026, 1, 1, 0, 500),
(6110300, 1082107, 1, 1, 0, 1000),
(6110300, 1040104, 1, 1, 0, 800),
(6110300, 1060092, 1, 1, 0, 800),
(6110300, 1072157, 1, 1, 0, 800),
(6110300, 1032020, 1, 1, 0, 1000),
(6110300, 1051062, 1, 1, 0, 700),
(6110300, 4000354, 1, 1, 0, 600000),
(6110300, 1072306, 1, 1, 0, 800),
(6110300, 2040933, 1, 1, 0, 300),
(6110300, 2049100, 1, 1, 0, 150),
(6110300, 4130004, 1, 1, 0, 6000),
(6110300, 4130009, 1, 1, 0, 6000),
(6110300, 4130011, 1, 1, 0, 6000),
(6110301, 2000002, 1, 1, 0, 20000),
(6110301, 2000006, 1, 1, 0, 20000),
(6110301, 2000004, 1, 1, 0, 20000),
(6110301, 4020005, 1, 1, 0, 9000),
(6110301, 4010002, 1, 1, 0, 9000),
(6110301, 4004001, 1, 1, 0, 10000),
(6110301, 1092015, 1, 1, 0, 700),
(6110301, 1472027, 1, 1, 0, 500),
(6110301, 1050088, 1, 1, 0, 700),
(6110301, 1072080, 1, 1, 0, 800),
(6110301, 1072085, 1, 1, 0, 800),
(6110301, 1032015, 1, 1, 0, 1000),
(6110301, 1050081, 1, 1, 0, 700),
(6110301, 1051078, 1, 1, 0, 700),
(6110301, 1002289, 1, 1, 0, 1500),
(6110301, 1462008, 1, 1, 0, 500),
(6110301, 1322018, 1, 1, 0, 700),
(6110301, 2043302, 1, 1, 0, 300),
(6110301, 4000363, 1, 1, 0, 600000),
(6110301, 1072309, 1, 1, 0, 800),
(6110301, 2330003, 1, 1, 0, 500),
(6110301, 2040621, 1, 1, 0, 300),
(6110301, 2049000, 1, 1, 0, 150),
(6110301, 4130001, 1, 1, 0, 6000),
(6110301, 4130007, 1, 1, 0, 6000),
(6130100, 4000014, 1, 1, 0, 600000),
(6130100, 2000006, 1, 1, 0, 20000),
(6130100, 2000004, 1, 1, 0, 20000),
(6130100, 4020007, 1, 1, 0, 9000),
(6130100, 4010005, 1, 1, 0, 9000),
(6130100, 2070005, 1, 1, 0, 400),
(6130100, 4000030, 1, 1, 0, 60000),
(6130100, 1060068, 1, 1, 0, 800),
(6130100, 1040080, 1, 1, 0, 800),
(6130100, 1040083, 1, 1, 0, 800),
(6130100, 1060072, 1, 1, 0, 800),
(6130100, 1041080, 1, 1, 0, 800),
(6130100, 1061079, 1, 1, 0, 800),
(6130100, 1082067, 1, 1, 0, 1000),
(6130100, 1092004, 1, 1, 0, 700),
(6130100, 1050056, 1, 1, 0, 700),
(6130100, 1372014, 1, 1, 0, 700),
(6130100, 1002246, 1, 1, 0, 1500),
(6130100, 1002248, 1, 1, 0, 1500),
(6130100, 1072136, 1, 1, 0, 800),
(6130100, 1072146, 1, 1, 0, 800),
(6130100, 1072148, 1, 1, 0, 800),
(6130100, 1040100, 1, 1, 0, 800),
(6130100, 1060089, 1, 1, 0, 800),
(6130100, 1102022, 1, 1, 0, 1000),
(6130100, 1060091, 1, 1, 0, 800),
(6130100, 1040103, 1, 1, 0, 800),
(6130100, 1072160, 1, 1, 0, 800),
(6130100, 1072162, 1, 1, 0, 800),
(6130100, 1082106, 1, 1, 0, 1000),
(6130100, 1482008, 1, 1, 0, 500),
(6130100, 2331000, 1, 1, 0, 500),
(6130100, 2040319, 1, 1, 0, 300),
(6130100, 4130004, 1, 1, 0, 6000),
(6130100, 4130014, 1, 1, 0, 6000),
(6130101, 4000040, 1, 1, 0, 600000),
(6130101, 1092012, 1, 1, 0, 7000),
(6130101, 2070006, 1, 1, 0, 2000),
(6130101, 2040001, 1, 1, 0, 3000),
(6130101, 2040004, 1, 1, 0, 3000),
(6130101, 2040301, 1, 1, 0, 3000),
(6130101, 2040401, 1, 1, 0, 3000),
(6130101, 2040501, 1, 1, 0, 3000),
(6130101, 2040504, 1, 1, 0, 3000),
(6130101, 2040601, 1, 1, 0, 3000),
(6130101, 2040701, 1, 1, 0, 3000),
(6130101, 2040704, 1, 1, 0, 3000),
(6130101, 2040707, 1, 1, 0, 3000),
(6130101, 2040801, 1, 1, 0, 3000),
(6130101, 2041001, 1, 1, 0, 3000),
(6130101, 2041004, 1, 1, 0, 3000),
(6130101, 2040804, 1, 1, 0, 3000),
(6130101, 2040901, 1, 1, 0, 3000),
(6130101, 1032019, 1, 1, 0, 10000),
(6130101, 1382006, 1, 1, 0, 7000),
(6130101, 2331000, 1, 1, 0, 5000),
(6130101, 2040427, 1, 1, 0, 3000),
(6130101, 2040618, 1, 1, 0, 3000),
(6130101, 2040619, 1, 1, 0, 3000),
(6130101, 2040024, 1, 1, 0, 3000),
(6130101, 2043212, 1, 1, 0, 3000),
(6130103, 4000050, 1, 1, 0, 600000),
(6130103, 2000006, 1, 1, 0, 20000),
(6130103, 2000004, 1, 1, 0, 20000),
(6130103, 4020008, 1, 1, 0, 9000),
(6130103, 4010001, 1, 1, 0, 9000),
(6130103, 2040401, 1, 1, 0, 300),
(6130103, 4004002, 1, 1, 0, 10000),
(6130103, 1050045, 1, 1, 0, 700),
(6130103, 1040087, 1, 1, 0, 800),
(6130103, 1060076, 1, 1, 0, 800),
(6130103, 1040097, 1, 1, 0, 800),
(6130103, 1060086, 1, 1, 0, 800),
(6130103, 1002170, 1, 1, 0, 1500),
(6130103, 1002025, 1, 1, 0, 1500),
(6130103, 1040093, 1, 1, 0, 800),
(6130103, 1060082, 1, 1, 0, 800),
(6130103, 1072150, 1, 1, 0, 800),
(6130103, 1072138, 1, 1, 0, 800),
(6130103, 1082060, 1, 1, 0, 1000),
(6130103, 1072145, 1, 1, 0, 800),
(6130103, 1102024, 1, 1, 0, 1000),
(6130103, 1072157, 1, 1, 0, 800),
(6130103, 1002286, 1, 1, 0, 1500),
(6130103, 1302012, 1, 1, 0, 700),
(6130103, 1082095, 1, 1, 0, 1000),
(6130103, 2040418, 1, 1, 0, 300),
(6130103, 4130008, 1, 1, 0, 6000),
(6130103, 4130015, 1, 1, 0, 6000),
(6130200, 4000128, 1, 1, 0, 600000),
(6130200, 4010001, 1, 1, 0, 9000),
(6130200, 2000006, 1, 1, 0, 20000),
(6130200, 2000004, 1, 1, 0, 20000),
(6130200, 4020008, 1, 1, 0, 9000),
(6130200, 4010005, 1, 1, 0, 9000),
(6130200, 2043701, 1, 1, 0, 300),
(6130200, 2043801, 1, 1, 0, 300),
(6130200, 2041001, 1, 1, 0, 300),
(6130200, 4004001, 1, 1, 0, 10000),
(6130200, 1002182, 1, 1, 0, 1500),
(6130200, 1002093, 1, 1, 0, 1500),
(6130200, 1050046, 1, 1, 0, 700),
(6130200, 1032012, 1, 1, 0, 1000),
(6130200, 1040088, 1, 1, 0, 800),
(6130200, 1060077, 1, 1, 0, 800),
(6130200, 1072122, 1, 1, 0, 800),
(6130200, 1082094, 1, 1, 0, 1000),
(6130200, 1082061, 1, 1, 0, 1000),
(6130200, 1082087, 1, 1, 0, 1000),
(6130200, 1072152, 1, 1, 0, 800),
(6130200, 1051042, 1, 1, 0, 700),
(6130200, 1302011, 1, 1, 0, 700),
(6130200, 1102015, 1, 1, 0, 1000),
(6130200, 1452009, 1, 1, 0, 500),
(6130200, 1082098, 1, 1, 0, 1000),
(6130200, 1312010, 1, 1, 0, 700),
(6130200, 1072163, 1, 1, 0, 800),
(6130200, 1052122, 1, 1, 0, 700),
(6130200, 2043112, 1, 1, 0, 300),
(6130200, 2044312, 1, 1, 0, 300),
(6130200, 4130004, 1, 1, 0, 6000),
(6130200, 4130012, 1, 1, 0, 6000),
(6130200, 4130015, 1, 1, 0, 6000),
(6130202, 4000173, 1, 1, 0, 600000),
(6130202, 2000006, 1, 1, 0, 20000),
(6130202, 2000004, 1, 1, 0, 20000),
(6130202, 4020008, 1, 1, 0, 9000),
(6130202, 4010001, 1, 1, 0, 9000),
(6130202, 1432004, 1, 1, 0, 500),
(6130202, 1442009, 1, 1, 0, 700),
(6130202, 1452008, 1, 1, 0, 500),
(6130202, 1462006, 1, 1, 0, 500),
(6130202, 1082086, 1, 1, 0, 1000),
(6130202, 1082093, 1, 1, 0, 1000),
(6130202, 1072144, 1, 1, 0, 800),
(6130202, 2040401, 1, 1, 0, 300),
(6130202, 1060088, 1, 1, 0, 800),
(6130202, 1040099, 1, 1, 0, 800),
(6130202, 1102018, 1, 1, 0, 1000),
(6130202, 1041091, 1, 1, 0, 800),
(6130202, 1061090, 1, 1, 0, 800),
(6130202, 2040004, 1, 1, 0, 300),
(6130202, 4004002, 1, 1, 0, 10000),
(6130202, 2040501, 1, 1, 0, 300),
(6130202, 1040089, 1, 1, 0, 800),
(6130202, 1060078, 1, 1, 0, 800),
(6130202, 4130002, 1, 1, 0, 6000),
(6130203, 4000283, 1, 1, 0, 600000),
(6130203, 4000285, 1, 1, 0, 600000),
(6130203, 4000021, 1, 1, 0, 50000),
(6130203, 4003005, 1, 1, 0, 200000),
(6130203, 2000006, 1, 1, 0, 20000),
(6130203, 2000004, 1, 1, 0, 20000),
(6130203, 4020007, 1, 1, 0, 9000),
(6130203, 4010005, 1, 1, 0, 9000),
(6130203, 2070005, 1, 1, 0, 400),
(6130203, 1041083, 1, 1, 0, 800),
(6130203, 1061082, 1, 1, 0, 800),
(6130203, 1072090, 1, 1, 0, 800),
(6130203, 1041079, 1, 1, 0, 800),
(6130203, 1061078, 1, 1, 0, 800),
(6130203, 1002215, 1, 1, 0, 1500),
(6130203, 1102015, 1, 1, 0, 1000),
(6130203, 1050056, 1, 1, 0, 700),
(6130203, 1002637, 1, 1, 0, 1500),
(6130203, 2040622, 1, 1, 0, 300),
(6130203, 2043112, 1, 1, 0, 300),
(6130203, 2044014, 1, 1, 0, 300),
(6130203, 4130002, 1, 1, 0, 6000),
(6130203, 4130005, 1, 1, 0, 6000),
(6130203, 4130013, 1, 1, 0, 6000),
(6130204, 4000295, 1, 1, 0, 600000),
(6130204, 4003005, 1, 1, 0, 200000),
(6130204, 4000021, 1, 1, 0, 50000),
(6130204, 2000002, 1, 1, 0, 20000),
(6130204, 2000006, 1, 1, 0, 20000),
(6130204, 2000004, 1, 1, 0, 20000),
(6130204, 4020004, 1, 1, 0, 9000),
(6130204, 4010006, 1, 1, 0, 9000),
(6130204, 1040093, 1, 1, 0, 800),
(6130204, 1060082, 1, 1, 0, 800),
(6130204, 1051064, 1, 1, 0, 700),
(6130204, 1051065, 1, 1, 0, 700),
(6130204, 1082062, 1, 1, 0, 1000),
(6130204, 1040104, 1, 1, 0, 800),
(6130204, 1060092, 1, 1, 0, 800),
(6130204, 4004000, 1, 1, 0, 10000),
(6130204, 1040107, 1, 1, 0, 800),
(6130204, 1060095, 1, 1, 0, 800),
(6130204, 2040301, 1, 1, 0, 300),
(6130204, 2043001, 1, 1, 0, 300),
(6130204, 1402011, 1, 1, 0, 700),
(6130204, 1402003, 1, 1, 0, 700),
(6130204, 1052119, 1, 1, 0, 700),
(6130204, 2330003, 1, 1, 0, 500),
(6130204, 2044802, 1, 1, 0, 300),
(6130204, 2040421, 1, 1, 0, 300),
(6130204, 2049000, 1, 1, 0, 150),
(6130204, 4130000, 1, 1, 0, 6000),
(6130204, 4130012, 1, 1, 0, 6000),
(6130207, 4000282, 1, 1, 0, 600000),
(6130207, 4000021, 1, 1, 0, 50000),
(6130207, 4003005, 1, 1, 0, 200000),
(6130207, 2000002, 1, 1, 0, 20000),
(6130207, 2000006, 1, 1, 0, 20000),
(6130207, 4020004, 1, 1, 0, 9000),
(6130207, 1040109, 1, 1, 0, 800),
(6130207, 1060098, 1, 1, 0, 800),
(6130207, 1032011, 1, 1, 0, 1000),
(6130207, 1102017, 1, 1, 0, 1000),
(6130207, 1051030, 1, 1, 0, 700),
(6130207, 1002210, 1, 1, 0, 1500),
(6130207, 1051046, 1, 1, 0, 700),
(6130207, 1452008, 1, 1, 0, 500),
(6130207, 2043701, 1, 1, 0, 300),
(6130207, 1072309, 1, 1, 0, 800),
(6130207, 2330003, 1, 1, 0, 500),
(6130207, 2040328, 1, 1, 0, 300),
(6130207, 2044112, 1, 1, 0, 300),
(6130207, 4130006, 1, 1, 0, 6000),
(6130207, 4130007, 1, 1, 0, 6000),
(6130208, 4000296, 1, 1, 0, 600000),
(6130208, 2000002, 1, 1, 0, 20000),
(6130208, 2000006, 1, 1, 0, 20000),
(6130208, 2000004, 1, 1, 0, 20000),
(6130208, 4020005, 1, 1, 0, 9000),
(6130208, 4010002, 1, 1, 0, 9000),
(6130208, 4004001, 1, 1, 0, 10000),
(6130208, 1092015, 1, 1, 0, 700),
(6130208, 1472027, 1, 1, 0, 500),
(6130208, 1050088, 1, 1, 0, 700),
(6130208, 1072080, 1, 1, 0, 800),
(6130208, 1072085, 1, 1, 0, 800),
(6130208, 1032015, 1, 1, 0, 1000),
(6130208, 1050081, 1, 1, 0, 700),
(6130208, 1051078, 1, 1, 0, 700),
(6130208, 1002289, 1, 1, 0, 1500),
(6130208, 1462008, 1, 1, 0, 500),
(6130208, 1322018, 1, 1, 0, 700),
(6130208, 2043302, 1, 1, 0, 300),
(6130208, 1082204, 1, 1, 0, 1000),
(6130208, 2044902, 1, 1, 0, 300),
(6130208, 4130006, 1, 1, 0, 6000),
(6130208, 4130008, 1, 1, 0, 6000),
(6130208, 4130012, 1, 1, 0, 6000),
(6130209, 4000289, 1, 1, 0, 600000),
(6130209, 4000021, 1, 1, 0, 50000);
INSERT IGNORE INTO `temp_data` (`dropperid`, `itemid`, `minimum_quantity`, `maximum_quantity`, `questid`, `chance`) VALUES
(6130209, 4003005, 1, 1, 0, 200000),
(6130209, 4020004, 1, 1, 0, 9000),
(6130209, 4020002, 1, 1, 0, 9000),
(6130209, 2000002, 1, 1, 0, 20000),
(6130209, 2000004, 1, 1, 0, 20000),
(6130209, 4004003, 1, 1, 0, 10000),
(6130209, 1032014, 1, 1, 0, 1000),
(6130209, 1040096, 1, 1, 0, 800),
(6130209, 1060085, 1, 1, 0, 800),
(6130209, 1092015, 1, 1, 0, 700),
(6130209, 1332019, 1, 1, 0, 500),
(6130209, 4006000, 1, 1, 0, 10000),
(6130209, 2040301, 1, 1, 0, 300),
(6130209, 1492008, 1, 1, 0, 500),
(6130209, 2040925, 1, 1, 0, 300),
(6130209, 2043017, 1, 1, 0, 300),
(6130209, 2043110, 1, 1, 0, 300),
(6130209, 4130014, 1, 1, 0, 6000),
(6130209, 4130017, 1, 1, 0, 6000),
(6220000, 4000032, 1, 1, 0, 600000),
(6220000, 4000032, 1, 1, 0, 600000),
(6220000, 4000032, 1, 1, 0, 600000),
(6220000, 4000033, 1, 1, 0, 600000),
(6220000, 4000033, 1, 1, 0, 600000),
(6220000, 4000033, 1, 1, 0, 600000),
(6220000, 4000021, 1, 1, 0, 500000),
(6220000, 4000021, 1, 1, 0, 500000),
(6220000, 4000021, 1, 1, 0, 500000),
(6220000, 4010002, 1, 1, 0, 90000),
(6220000, 4020003, 1, 1, 0, 90000),
(6220000, 2000002, 1, 1, 0, 200000),
(6220000, 2000003, 1, 1, 0, 200000),
(6220000, 2002000, 1, 1, 0, 200000),
(6220000, 2002001, 1, 1, 0, 200000),
(6220000, 2040004, 1, 1, 0, 3000),
(6220000, 2040501, 1, 1, 0, 3000),
(6220000, 2040516, 1, 1, 0, 3000),
(6220000, 2040804, 1, 1, 0, 3000),
(6220000, 2041001, 1, 1, 0, 3000),
(6220000, 2043301, 1, 1, 0, 3000),
(6220000, 2044001, 1, 1, 0, 3000),
(6220000, 2044401, 1, 1, 0, 3000),
(6220000, 2044601, 1, 1, 0, 3000),
(6220000, 2044701, 1, 1, 0, 3000),
(6220000, 2040702, 1, 1, 0, 3000),
(6220000, 2041008, 1, 1, 0, 3000),
(6220000, 2044502, 1, 1, 0, 3000),
(6220000, 2044702, 1, 1, 0, 3000),
(6220000, 2048002, 1, 1, 0, 3000),
(6220000, 2060000, 1, 1, 0, 300000),
(6220000, 2061000, 1, 1, 0, 300000),
(6220000, 1302012, 1, 1, 0, 7000),
(6220000, 1312010, 1, 1, 0, 7000),
(6220000, 1322019, 1, 1, 0, 7000),
(6220000, 1332018, 1, 1, 0, 5000),
(6220000, 1372015, 1, 1, 0, 7000),
(6220000, 1382010, 1, 1, 0, 7000),
(6220000, 1402012, 1, 1, 0, 7000),
(6220000, 1412008, 1, 1, 0, 7000),
(6220000, 1422010, 1, 1, 0, 7000),
(6220000, 1432007, 1, 1, 0, 5000),
(6220000, 1442008, 1, 1, 0, 7000),
(6220000, 1452011, 1, 1, 0, 5000),
(6220000, 1462009, 1, 1, 0, 5000),
(6220000, 1472029, 1, 1, 0, 5000),
(6220000, 1482009, 1, 1, 0, 5000),
(6220000, 1492009, 1, 1, 0, 5000),
(6220000, 2040031, 1, 1, 0, 3000),
(6220000, 2040627, 1, 1, 0, 3000),
(6220000, 2044312, 1, 1, 0, 3000),
(6220000, 2044807, 1, 1, 0, 3000),
(6220001, 4000117, 1, 1, 0, 600000),
(6220001, 4000118, 1, 1, 0, 600000),
(6220001, 4000119, 1, 1, 0, 600000),
(6220001, 4004001, 1, 1, 0, 100000),
(6220001, 4004000, 1, 1, 0, 100000),
(6220001, 2000002, 1, 1, 0, 200000),
(6220001, 2000003, 1, 1, 0, 200000),
(6220001, 2040516, 1, 1, 0, 3000),
(6220001, 2040707, 1, 1, 0, 3000),
(6220001, 2040804, 1, 1, 0, 3000),
(6220001, 2041016, 1, 1, 0, 3000),
(6220001, 2043101, 1, 1, 0, 3000),
(6220001, 2043301, 1, 1, 0, 3000),
(6220001, 2044401, 1, 1, 0, 3000),
(6220001, 2044301, 1, 1, 0, 3000),
(6220001, 2044901, 1, 1, 0, 3000),
(6220001, 2330003, 1, 1, 0, 5000),
(6220001, 2070004, 1, 1, 0, 5000),
(6220001, 1002024, 1, 1, 0, 15000),
(6220001, 1002095, 1, 1, 0, 15000),
(6220001, 1002254, 1, 1, 0, 15000),
(6220001, 1002289, 1, 1, 0, 15000),
(6220001, 1002285, 1, 1, 0, 15000),
(6220001, 1002637, 1, 1, 0, 15000),
(6220001, 1302049, 1, 1, 0, 7000),
(6220001, 2040425, 1, 1, 0, 3000),
(6220001, 2040925, 1, 1, 0, 3000),
(6220001, 2043214, 1, 1, 0, 3000),
(6220001, 2049000, 1, 1, 0, 1500),
(6230100, 4000027, 1, 1, 0, 600000),
(6230100, 2000006, 1, 1, 0, 20000),
(6230100, 4020008, 1, 1, 0, 9000),
(6230100, 4010006, 1, 1, 0, 9000),
(6230100, 2043701, 1, 1, 0, 300),
(6230100, 2070004, 1, 1, 0, 500),
(6230100, 1422005, 1, 1, 0, 700),
(6230100, 1002218, 1, 1, 0, 1500),
(6230100, 2000005, 1, 1, 0, 20000),
(6230100, 1002021, 1, 1, 0, 1500),
(6230100, 1002166, 1, 1, 0, 1500),
(6230100, 1050047, 1, 1, 0, 700),
(6230100, 1040095, 1, 1, 0, 800),
(6230100, 1060084, 1, 1, 0, 800),
(6230100, 1041087, 1, 1, 0, 800),
(6230100, 1061086, 1, 1, 0, 800),
(6230100, 1051045, 1, 1, 0, 700),
(6230100, 1082061, 1, 1, 0, 1000),
(6230100, 1050060, 1, 1, 0, 700),
(6230100, 1082090, 1, 1, 0, 1000),
(6230100, 1072148, 1, 1, 0, 800),
(6230100, 1472023, 1, 1, 0, 500),
(6230100, 1442010, 1, 1, 0, 700),
(6230100, 1102016, 1, 1, 0, 1000),
(6230100, 1051054, 1, 1, 0, 700),
(6230100, 1082106, 1, 1, 0, 1000),
(6230100, 1072154, 1, 1, 0, 800),
(6230100, 1041103, 1, 1, 0, 800),
(6230100, 1061102, 1, 1, 0, 800),
(6230100, 1082204, 1, 1, 0, 1000),
(6230100, 2040323, 1, 1, 0, 300),
(6230100, 2040823, 1, 1, 0, 300),
(6230100, 2043212, 1, 1, 0, 300),
(6230100, 2044809, 1, 1, 0, 300),
(6230100, 2049100, 1, 1, 0, 150),
(6230100, 4130011, 1, 1, 0, 6000),
(6230100, 4130012, 1, 1, 0, 6000),
(6230100, 4130016, 1, 1, 0, 6000),
(6230200, 4000057, 1, 1, 0, 600000),
(6230200, 4004004, 1, 1, 0, 10000),
(6230200, 2000006, 1, 1, 0, 20000),
(6230200, 2000004, 1, 1, 0, 20000),
(6230200, 4020000, 1, 1, 0, 9000),
(6230200, 4010004, 1, 1, 0, 9000),
(6230200, 4004003, 1, 1, 0, 10000),
(6230200, 4006000, 1, 1, 0, 10000),
(6230200, 1002218, 1, 1, 0, 1500),
(6230200, 1472020, 1, 1, 0, 500),
(6230200, 1002100, 1, 1, 0, 1500),
(6230200, 1050055, 1, 1, 0, 700),
(6230200, 1002268, 1, 1, 0, 1500),
(6230200, 1082087, 1, 1, 0, 1000),
(6230200, 1041094, 1, 1, 0, 800),
(6230200, 1061093, 1, 1, 0, 800),
(6230200, 1102018, 1, 1, 0, 1000),
(6230200, 1092011, 1, 1, 0, 700),
(6230200, 1472025, 1, 1, 0, 500),
(6230200, 1082088, 1, 1, 0, 1000),
(6230200, 1332017, 1, 1, 0, 500),
(6230200, 1472023, 1, 1, 0, 500),
(6230200, 1051052, 1, 1, 0, 700),
(6230200, 1072164, 1, 1, 0, 800),
(6230200, 1072155, 1, 1, 0, 800),
(6230200, 1072161, 1, 1, 0, 800),
(6230200, 2040419, 1, 1, 0, 300),
(6230200, 2040620, 1, 1, 0, 300),
(6230200, 4130005, 1, 1, 0, 6000),
(6230200, 4130013, 1, 1, 0, 6000),
(6230300, 4000129, 1, 1, 0, 600000),
(6230300, 4020008, 1, 1, 0, 9000),
(6230300, 4010006, 1, 1, 0, 9000),
(6230300, 2000002, 1, 1, 0, 20000),
(6230300, 2000004, 1, 1, 0, 20000),
(6230300, 4004003, 1, 1, 0, 10000),
(6230300, 2040301, 1, 1, 0, 300),
(6230300, 4006000, 1, 1, 0, 10000),
(6230300, 4004004, 1, 1, 0, 10000),
(6230300, 1051031, 1, 1, 0, 700),
(6230300, 1082065, 1, 1, 0, 1000),
(6230300, 1072125, 1, 1, 0, 800),
(6230300, 1040089, 1, 1, 0, 800),
(6230300, 1060078, 1, 1, 0, 800),
(6230300, 1002101, 1, 1, 0, 1500),
(6230300, 1002242, 1, 1, 0, 1500),
(6230300, 1040099, 1, 1, 0, 800),
(6230300, 1060088, 1, 1, 0, 800),
(6230300, 1051042, 1, 1, 0, 700),
(6230300, 1082060, 1, 1, 0, 1000),
(6230300, 1102024, 1, 1, 0, 1000),
(6230300, 1050061, 1, 1, 0, 700),
(6230300, 1432007, 1, 1, 0, 500),
(6230300, 1082096, 1, 1, 0, 1000),
(6230300, 1072158, 1, 1, 0, 800),
(6230300, 1032015, 1, 1, 0, 1000),
(6230300, 1482008, 1, 1, 0, 500),
(6230300, 2044801, 1, 1, 0, 300),
(6230300, 2040318, 1, 1, 0, 300),
(6230300, 2040622, 1, 1, 0, 300),
(6230300, 4130001, 1, 1, 0, 6000),
(6230400, 4000143, 1, 1, 0, 600000),
(6230400, 2000002, 1, 1, 0, 20000),
(6230400, 2000004, 1, 1, 0, 20000),
(6230400, 2043802, 1, 1, 0, 300),
(6230400, 2040804, 1, 1, 0, 300),
(6230400, 2002000, 1, 1, 0, 20000),
(6230400, 4004000, 1, 1, 0, 10000),
(6230400, 4010000, 1, 1, 0, 9000),
(6230400, 4020003, 1, 1, 0, 9000),
(6230400, 1051034, 1, 1, 0, 700),
(6230400, 1002085, 1, 1, 0, 1500),
(6230400, 1002210, 1, 1, 0, 1500),
(6230400, 1051037, 1, 1, 0, 700),
(6230400, 1040096, 1, 1, 0, 800),
(6230400, 1060085, 1, 1, 0, 800),
(6230400, 1372014, 1, 1, 0, 700),
(6230400, 1082091, 1, 1, 0, 1000),
(6230400, 1082093, 1, 1, 0, 1000),
(6230400, 1082086, 1, 1, 0, 1000),
(6230400, 1072149, 1, 1, 0, 800),
(6230400, 1472024, 1, 1, 0, 500),
(6230400, 1102017, 1, 1, 0, 1000),
(6230400, 1322018, 1, 1, 0, 700),
(6230400, 1032020, 1, 1, 0, 1000),
(6230400, 1002281, 1, 1, 0, 1500),
(6230400, 1002286, 1, 1, 0, 1500),
(6230400, 1082099, 1, 1, 0, 1000),
(6230400, 1041098, 1, 1, 0, 800),
(6230400, 1061097, 1, 1, 0, 800),
(6230400, 1032014, 1, 1, 0, 1000),
(6230400, 1492009, 1, 1, 0, 500),
(6230400, 2044902, 1, 1, 0, 300),
(6230400, 2040422, 1, 1, 0, 300),
(6230400, 2040530, 1, 1, 0, 300),
(6230400, 2040924, 1, 1, 0, 300),
(6230400, 2044414, 1, 1, 0, 300),
(6230400, 4130012, 1, 1, 0, 6000),
(6230400, 4130013, 1, 1, 0, 6000),
(6230401, 2040515, 1, 1, 0, 300),
(6230401, 2044410, 1, 1, 0, 300),
(6230401, 4130009, 1, 1, 0, 6000),
(6230401, 4130010, 1, 1, 0, 6000),
(6230401, 4130014, 1, 1, 0, 6000),
(6230500, 4000144, 1, 1, 0, 600000),
(6230500, 4000021, 1, 1, 0, 50000),
(6230500, 2000002, 1, 1, 0, 20000),
(6230500, 2000004, 1, 1, 0, 20000),
(6230500, 4010006, 1, 1, 0, 9000),
(6230500, 4020006, 1, 1, 0, 9000),
(6230500, 4006000, 1, 1, 0, 10000),
(6230500, 4004004, 1, 1, 0, 10000),
(6230500, 2041022, 1, 1, 0, 300),
(6230500, 2043301, 1, 1, 0, 300),
(6230500, 1050049, 1, 1, 0, 700),
(6230500, 1072123, 1, 1, 0, 800),
(6230500, 1082085, 1, 1, 0, 1000),
(6230500, 1050056, 1, 1, 0, 700),
(6230500, 1002084, 1, 1, 0, 1500),
(6230500, 1002249, 1, 1, 0, 1500),
(6230500, 1002270, 1, 1, 0, 1500),
(6230500, 1002244, 1, 1, 0, 1500),
(6230500, 1040091, 1, 1, 0, 800),
(6230500, 1060080, 1, 1, 0, 800),
(6230500, 1072161, 1, 1, 0, 800),
(6230500, 1072166, 1, 1, 0, 800),
(6230500, 1082103, 1, 1, 0, 1000),
(6230500, 1332019, 1, 1, 0, 500),
(6230500, 1072159, 1, 1, 0, 800),
(6230500, 1002637, 1, 1, 0, 1500),
(6230500, 2040620, 1, 1, 0, 300),
(6230500, 4130001, 1, 1, 0, 6000),
(6230500, 4130007, 1, 1, 0, 6000),
(6230600, 4000185, 1, 1, 0, 600000),
(6230600, 2000006, 1, 1, 0, 20000),
(6230600, 2000004, 1, 1, 0, 20000),
(6230600, 4000030, 1, 1, 0, 60000),
(6230600, 4010006, 1, 1, 0, 9000),
(6230600, 4010004, 1, 1, 0, 9000),
(6230600, 4020005, 1, 1, 0, 9000),
(6230600, 1040094, 1, 1, 0, 800),
(6230600, 1060083, 1, 1, 0, 800),
(6230600, 1041085, 1, 1, 0, 800),
(6230600, 1061083, 1, 1, 0, 800),
(6230600, 1040091, 1, 1, 0, 800),
(6230600, 1060080, 1, 1, 0, 800),
(6230600, 1041091, 1, 1, 0, 800),
(6230600, 1061090, 1, 1, 0, 800),
(6230600, 1051043, 1, 1, 0, 700),
(6230600, 1051046, 1, 1, 0, 700),
(6230600, 1082095, 1, 1, 0, 1000),
(6230600, 1082098, 1, 1, 0, 1000),
(6230600, 1072158, 1, 1, 0, 800),
(6230600, 1472024, 1, 1, 0, 500),
(6230600, 4006000, 1, 1, 0, 10000),
(6230600, 1462008, 1, 1, 0, 500),
(6230600, 4020007, 1, 1, 0, 9000),
(6230600, 1002634, 1, 1, 0, 1500),
(6230600, 2332000, 1, 1, 0, 500),
(6230600, 2040317, 1, 1, 0, 300),
(6230600, 2040328, 1, 1, 0, 300),
(6230600, 2040928, 1, 1, 0, 300),
(6230600, 2044112, 1, 1, 0, 300),
(6230600, 2044414, 1, 1, 0, 300),
(6230600, 4130006, 1, 1, 0, 6000),
(6230600, 4130011, 1, 1, 0, 6000),
(6230600, 4130015, 1, 1, 0, 6000),
(6230601, 4000186, 1, 1, 0, 600000),
(6230601, 4020008, 1, 1, 0, 9000),
(6230601, 2041001, 1, 1, 0, 300),
(6230601, 2000002, 1, 1, 0, 20000),
(6230601, 2000004, 1, 1, 0, 20000),
(6230601, 4010003, 1, 1, 0, 9000),
(6230601, 4010005, 1, 1, 0, 9000),
(6230601, 4000030, 1, 1, 0, 60000),
(6230601, 2041004, 1, 1, 0, 300),
(6230601, 2040401, 1, 1, 0, 300),
(6230601, 1002242, 1, 1, 0, 1500),
(6230601, 1002247, 1, 1, 0, 1500),
(6230601, 1002208, 1, 1, 0, 1500),
(6230601, 1092017, 1, 1, 0, 700),
(6230601, 1442010, 1, 1, 0, 700),
(6230601, 1432007, 1, 1, 0, 500),
(6230601, 1412008, 1, 1, 0, 700),
(6230601, 1082109, 1, 1, 0, 1000),
(6230601, 1041097, 1, 1, 0, 800),
(6230601, 1061096, 1, 1, 0, 800),
(6230601, 2040001, 1, 1, 0, 300),
(6230601, 1061100, 1, 1, 0, 800),
(6230601, 1041101, 1, 1, 0, 800),
(6230601, 1072172, 1, 1, 0, 800),
(6230601, 1372015, 1, 1, 0, 700),
(6230601, 4020007, 1, 1, 0, 9000),
(6230601, 1052122, 1, 1, 0, 700),
(6230601, 2040024, 1, 1, 0, 300),
(6230601, 2040625, 1, 1, 0, 300),
(6230601, 4130007, 1, 1, 0, 6000),
(6230601, 4130015, 1, 1, 0, 6000),
(6230602, 4000207, 1, 1, 0, 600000),
(6230602, 2000002, 1, 1, 0, 20000),
(6230602, 2000004, 1, 1, 0, 20000),
(6230602, 2043802, 1, 1, 0, 300),
(6230602, 2040804, 1, 1, 0, 300),
(6230602, 2002000, 1, 1, 0, 20000),
(6230602, 4010000, 1, 1, 0, 9000),
(6230602, 4020003, 1, 1, 0, 9000),
(6230602, 1082010, 1, 1, 0, 1000),
(6230602, 1082065, 1, 1, 0, 1000),
(6230602, 1082082, 1, 1, 0, 1000),
(6230602, 1082085, 1, 1, 0, 1000),
(6230602, 1092011, 1, 1, 0, 700),
(6230602, 1302011, 1, 1, 0, 700),
(6230602, 1332017, 1, 1, 0, 500),
(6230602, 1472023, 1, 1, 0, 500),
(6230602, 1002084, 1, 1, 0, 1500),
(6230602, 1002246, 1, 1, 0, 1500),
(6230602, 1002248, 1, 1, 0, 1500),
(6230602, 1002269, 1, 1, 0, 1500),
(6230602, 1082103, 1, 1, 0, 1000),
(6230602, 1082106, 1, 1, 0, 1000),
(6230602, 1082098, 1, 1, 0, 1000),
(6230602, 1082096, 1, 1, 0, 1000),
(6230602, 1482009, 1, 1, 0, 500),
(6230602, 2330002, 1, 1, 0, 500),
(6230602, 2040328, 1, 1, 0, 300),
(6230602, 2040417, 1, 1, 0, 300),
(6230602, 2040423, 1, 1, 0, 300),
(6230602, 2040928, 1, 1, 0, 300),
(6230602, 4130000, 1, 1, 0, 6000),
(6230602, 4130010, 1, 1, 0, 6000),
(6230602, 4130016, 1, 1, 0, 6000),
(6300000, 4000049, 1, 1, 0, 600000),
(6300000, 4003005, 1, 1, 0, 200000),
(6300000, 4000021, 1, 1, 0, 50000),
(6300000, 2000006, 1, 1, 0, 20000),
(6300000, 4020007, 1, 1, 0, 9000),
(6300000, 4010000, 1, 1, 0, 9000),
(6300000, 4004000, 1, 1, 0, 10000),
(6300000, 1041078, 1, 1, 0, 800),
(6300000, 1041089, 1, 1, 0, 800),
(6300000, 1002022, 1, 1, 0, 1500),
(6300000, 1032019, 1, 1, 0, 1000),
(6300000, 1051047, 1, 1, 0, 700),
(6300000, 1040099, 1, 1, 0, 800),
(6300000, 1060088, 1, 1, 0, 800),
(6300000, 1432006, 1, 1, 0, 500),
(6300000, 1462008, 1, 1, 0, 500),
(6300000, 1472024, 1, 1, 0, 500),
(6300000, 1102022, 1, 1, 0, 1000),
(6300000, 1382007, 1, 1, 0, 700),
(6300000, 1472026, 1, 1, 0, 500),
(6300000, 1082107, 1, 1, 0, 1000),
(6300000, 1040104, 1, 1, 0, 800),
(6300000, 1060092, 1, 1, 0, 800),
(6300000, 1072157, 1, 1, 0, 800),
(6300000, 1032020, 1, 1, 0, 1000),
(6300000, 1051062, 1, 1, 0, 700),
(6300005, 4000176, 1, 1, 0, 600000),
(6300005, 1032014, 1, 1, 0, 10000),
(6300005, 1102024, 1, 1, 0, 10000),
(6300005, 2070006, 1, 1, 0, 2000),
(6300005, 2043101, 1, 1, 0, 3000),
(6300005, 2043201, 1, 1, 0, 3000),
(6300005, 2043301, 1, 1, 0, 3000),
(6300005, 2043701, 1, 1, 0, 3000),
(6300005, 2043801, 1, 1, 0, 3000),
(6300005, 2044001, 1, 1, 0, 3000),
(6300005, 2044101, 1, 1, 0, 3000),
(6300005, 2044201, 1, 1, 0, 3000),
(6300005, 2044301, 1, 1, 0, 3000),
(6300005, 2044401, 1, 1, 0, 3000),
(6300005, 2044501, 1, 1, 0, 3000),
(6300005, 2044601, 1, 1, 0, 3000),
(6300005, 2044701, 1, 1, 0, 3000),
(6300005, 2048001, 1, 1, 0, 3000),
(6300005, 2048004, 1, 1, 0, 3000),
(6300005, 2043001, 1, 1, 0, 3000),
(6300005, 1092010, 1, 1, 0, 7000),
(6300005, 2332000, 1, 1, 0, 5000),
(6300005, 2044801, 1, 1, 0, 3000),
(6300005, 2044901, 1, 1, 0, 3000),
(6300005, 2040422, 1, 1, 0, 3000),
(6300005, 2043019, 1, 1, 0, 3000),
(6300100, 4000130, 1, 1, 0, 600000),
(6300100, 2041022, 1, 1, 0, 300),
(6300100, 4004004, 1, 1, 0, 10000),
(6300100, 2000001, 1, 1, 0, 20000),
(6300100, 2000004, 1, 1, 0, 20000),
(6300100, 4020003, 1, 1, 0, 9000),
(6300100, 4010006, 1, 1, 0, 9000),
(6300100, 4004001, 1, 1, 0, 10000),
(6300100, 1040098, 1, 1, 0, 800),
(6300100, 1060087, 1, 1, 0, 800),
(6300100, 1072139, 1, 1, 0, 800),
(6300100, 1041093, 1, 1, 0, 800),
(6300100, 1061092, 1, 1, 0, 800),
(6300100, 1072158, 1, 1, 0, 800),
(6300100, 1082097, 1, 1, 0, 1000),
(6300100, 1051065, 1, 1, 0, 700),
(6300100, 1061097, 1, 1, 0, 800),
(6300100, 1041098, 1, 1, 0, 800),
(6300100, 1082108, 1, 1, 0, 1000),
(6300100, 1040106, 1, 1, 0, 800),
(6300100, 1060094, 1, 1, 0, 800),
(6300100, 1472027, 1, 1, 0, 500),
(6300100, 1452010, 1, 1, 0, 500),
(6300100, 1442008, 1, 1, 0, 700),
(6300100, 1072172, 1, 1, 0, 800),
(6300100, 1082122, 1, 1, 0, 1000),
(6300100, 1082109, 1, 1, 0, 1000),
(6300100, 1050082, 1, 1, 0, 700),
(6300100, 1492010, 1, 1, 0, 500),
(6300100, 2040421, 1, 1, 0, 300),
(6300100, 2040825, 1, 1, 0, 300),
(6300100, 4130003, 1, 1, 0, 6000),
(6300100, 4130004, 1, 1, 0, 6000),
(6400000, 4000056, 1, 1, 0, 600000),
(6400000, 4003004, 1, 1, 0, 200000),
(6400000, 2041022, 1, 1, 0, 300),
(6400000, 4004004, 1, 1, 0, 10000),
(6400000, 4000021, 1, 1, 0, 50000),
(6400000, 2000002, 1, 1, 0, 20000),
(6400000, 2000004, 1, 1, 0, 20000),
(6400000, 4020003, 1, 1, 0, 9000),
(6400000, 4010006, 1, 1, 0, 9000),
(6400000, 4003002, 1, 1, 0, 7000),
(6400000, 4004001, 1, 1, 0, 10000),
(6400000, 1082084, 1, 1, 0, 1000),
(6400000, 1072142, 1, 1, 0, 800),
(6400000, 1442005, 1, 1, 0, 700),
(6400000, 1472019, 1, 1, 0, 500),
(6400000, 1051045, 1, 1, 0, 700),
(6400000, 1002245, 1, 1, 0, 1500),
(6400000, 1050060, 1, 1, 0, 700),
(6400000, 1040092, 1, 1, 0, 800),
(6400000, 1060081, 1, 1, 0, 800),
(6400000, 1041096, 1, 1, 0, 800),
(6400000, 1061095, 1, 1, 0, 800),
(6400000, 1002030, 1, 1, 0, 1500),
(6400000, 1032015, 1, 1, 0, 1000),
(6400000, 1061096, 1, 1, 0, 800),
(6400000, 1041097, 1, 1, 0, 800),
(6400000, 1072166, 1, 1, 0, 800),
(6400000, 1082097, 1, 1, 0, 1000),
(6400000, 1002271, 1, 1, 0, 1500),
(6400000, 1002338, 1, 1, 0, 1500),
(6400100, 4000131, 1, 1, 0, 600000),
(6400100, 2000002, 1, 1, 0, 20000),
(6400100, 2000004, 1, 1, 0, 20000),
(6400100, 4020003, 1, 1, 0, 9000),
(6400100, 4010006, 1, 1, 0, 9000),
(6400100, 4004004, 1, 1, 0, 10000),
(6400100, 2002008, 1, 1, 0, 20000),
(6400100, 2044001, 1, 1, 0, 300),
(6400100, 2041013, 1, 1, 0, 300),
(6400100, 1051046, 1, 1, 0, 700),
(6400100, 1002268, 1, 1, 0, 1500),
(6400100, 1072149, 1, 1, 0, 800),
(6400100, 1002282, 1, 1, 0, 1500),
(6400100, 1041099, 1, 1, 0, 800),
(6400100, 1061098, 1, 1, 0, 800),
(6400100, 1050061, 1, 1, 0, 700),
(6400100, 1082098, 1, 1, 0, 1000),
(6400100, 1092017, 1, 1, 0, 700),
(6400100, 1472029, 1, 1, 0, 500),
(6400100, 1002289, 1, 1, 0, 1500),
(6400100, 1002252, 1, 1, 0, 1500),
(6400100, 1040106, 1, 1, 0, 800),
(6400100, 1060094, 1, 1, 0, 800),
(6400100, 1412008, 1, 1, 0, 700),
(6400100, 1032022, 1, 1, 0, 1000),
(6400100, 1051058, 1, 1, 0, 700),
(6400100, 1050077, 1, 1, 0, 700),
(6400100, 1072173, 1, 1, 0, 800),
(6400100, 1082116, 1, 1, 0, 1000),
(6400100, 1082207, 1, 1, 0, 1000),
(6400100, 2040321, 1, 1, 0, 300),
(6400100, 2040534, 1, 1, 0, 300),
(6400100, 2043114, 1, 1, 0, 300),
(6400100, 4130000, 1, 1, 0, 6000),
(6400100, 4130002, 1, 1, 0, 6000),
(6400100, 4130013, 1, 1, 0, 6000),
(7090000, 4000411, 1, 1, 0, 600000),
(7110300, 2000006, 1, 1, 0, 20000),
(7110300, 4020001, 1, 1, 0, 9000),
(7110300, 4010003, 1, 1, 0, 9000),
(7110300, 2043701, 1, 1, 0, 300),
(7110300, 2044701, 1, 1, 0, 300),
(7110300, 4004000, 1, 1, 0, 10000),
(7110300, 4006000, 1, 1, 0, 10000),
(7110300, 2040302, 1, 1, 0, 300),
(7110300, 1050055, 1, 1, 0, 700),
(7110300, 1041094, 1, 1, 0, 800),
(7110300, 1061093, 1, 1, 0, 800),
(7110300, 1050069, 1, 1, 0, 700),
(7110300, 1040102, 1, 1, 0, 800),
(7110300, 1060090, 1, 1, 0, 800),
(7110300, 1082100, 1, 1, 0, 1000),
(7110300, 1041102, 1, 1, 0, 800),
(7110300, 1061101, 1, 1, 0, 800),
(7110300, 1002254, 1, 1, 0, 1500),
(7110300, 1002288, 1, 1, 0, 1500),
(7110300, 1092015, 1, 1, 0, 700),
(7110300, 1332018, 1, 1, 0, 500),
(7110300, 1402012, 1, 1, 0, 700),
(7110300, 1472029, 1, 1, 0, 500),
(7110300, 1322020, 1, 1, 0, 700),
(7110300, 1002273, 1, 1, 0, 1500),
(7110300, 1002339, 1, 1, 0, 1500),
(7110300, 1051066, 1, 1, 0, 700),
(7110300, 1041105, 1, 1, 0, 800),
(7110300, 1061104, 1, 1, 0, 800),
(7110300, 4000362, 1, 1, 0, 600000),
(7110300, 1082204, 1, 1, 0, 1000),
(7110300, 2330003, 1, 1, 0, 500),
(7110300, 2040026, 1, 1, 0, 300),
(7110300, 2040319, 1, 1, 0, 300),
(7110300, 4130009, 1, 1, 0, 6000),
(7110300, 4130015, 1, 1, 0, 6000),
(7110301, 2000006, 1, 1, 0, 20000),
(7110301, 2000004, 1, 1, 0, 20000),
(7110301, 4010004, 1, 1, 0, 9000),
(7110301, 4020006, 1, 1, 0, 9000),
(7110301, 4004003, 1, 1, 0, 10000),
(7110301, 2044601, 1, 1, 0, 300),
(7110301, 1051044, 1, 1, 0, 700),
(7110301, 1002029, 1, 1, 0, 1500),
(7110301, 1002248, 1, 1, 0, 1500),
(7110301, 1051041, 1, 1, 0, 700),
(7110301, 1072147, 1, 1, 0, 800),
(7110301, 1072150, 1, 1, 0, 800),
(7110301, 1072145, 1, 1, 0, 800),
(7110301, 1051053, 1, 1, 0, 700),
(7110301, 1002094, 1, 1, 0, 1500),
(7110301, 1002253, 1, 1, 0, 1500),
(7110301, 1051062, 1, 1, 0, 700),
(7110301, 1040105, 1, 1, 0, 800),
(7110301, 1060093, 1, 1, 0, 800),
(7110301, 1050063, 1, 1, 0, 700),
(7110301, 1402012, 1, 1, 0, 700),
(7110301, 1040108, 1, 1, 0, 800),
(7110301, 1060097, 1, 1, 0, 800),
(7110301, 1072210, 1, 1, 0, 800),
(7110301, 1002275, 1, 1, 0, 1500),
(7110301, 1072177, 1, 1, 0, 800),
(7110301, 4000361, 1, 1, 0, 600000),
(7110301, 1482010, 1, 1, 0, 500),
(7110301, 2044801, 1, 1, 0, 300),
(7110301, 2040025, 1, 1, 0, 300),
(7110301, 2040621, 1, 1, 0, 300),
(7110301, 2040933, 1, 1, 0, 300),
(7110301, 4130004, 1, 1, 0, 6000),
(7110301, 4130005, 1, 1, 0, 6000),
(7110301, 4130007, 1, 1, 0, 6000),
(7130000, 4000074, 1, 1, 0, 600000),
(7130000, 2050004, 1, 1, 0, 50000),
(7130000, 2000006, 1, 1, 0, 20000),
(7130000, 2000004, 1, 1, 0, 20000),
(7130000, 4010004, 1, 1, 0, 9000),
(7130000, 4020006, 1, 1, 0, 9000),
(7130000, 4006001, 1, 1, 0, 10000),
(7130000, 4004003, 1, 1, 0, 10000),
(7130000, 2044601, 1, 1, 0, 300),
(7130000, 1051044, 1, 1, 0, 700),
(7130000, 1002029, 1, 1, 0, 1500),
(7130000, 1002248, 1, 1, 0, 1500),
(7130000, 1051041, 1, 1, 0, 700),
(7130000, 1072147, 1, 1, 0, 800),
(7130000, 1072150, 1, 1, 0, 800),
(7130000, 1072145, 1, 1, 0, 800),
(7130000, 1051053, 1, 1, 0, 700),
(7130000, 1002094, 1, 1, 0, 1500),
(7130000, 1002253, 1, 1, 0, 1500),
(7130000, 1051062, 1, 1, 0, 700),
(7130000, 1040105, 1, 1, 0, 800),
(7130000, 1060093, 1, 1, 0, 800),
(7130000, 1050063, 1, 1, 0, 700),
(7130000, 1402012, 1, 1, 0, 700),
(7130000, 1040108, 1, 1, 0, 800),
(7130000, 1060097, 1, 1, 0, 800),
(7130000, 1072210, 1, 1, 0, 800),
(7130000, 1002275, 1, 1, 0, 1500),
(7130000, 1072177, 1, 1, 0, 800),
(7130000, 4161021, 1, 1, 0, 7000),
(7130000, 1072312, 1, 1, 0, 800),
(7130000, 2044901, 1, 1, 0, 300),
(7130000, 2040419, 1, 1, 0, 300),
(7130000, 2040427, 1, 1, 0, 300),
(7130000, 4130008, 1, 1, 0, 6000),
(7130000, 4130010, 1, 1, 0, 6000),
(7130000, 4130011, 1, 1, 0, 6000),
(7130001, 4000079, 1, 1, 0, 600000),
(7130001, 2050000, 1, 1, 0, 50000),
(7130001, 2000006, 1, 1, 0, 20000),
(7130001, 2000004, 1, 1, 0, 20000),
(7130001, 4020007, 1, 1, 0, 9000),
(7130001, 4010004, 1, 1, 0, 9000),
(7130001, 2044301, 1, 1, 0, 300),
(7130001, 2041021, 1, 1, 0, 300),
(7130001, 1312009, 1, 1, 0, 700),
(7130001, 1332015, 1, 1, 0, 500),
(7130001, 1402011, 1, 1, 0, 700),
(7130001, 1002246, 1, 1, 0, 1500),
(7130001, 1032014, 1, 1, 0, 1000),
(7130001, 1041095, 1, 1, 0, 800),
(7130001, 1061094, 1, 1, 0, 800),
(7130001, 1072146, 1, 1, 0, 800),
(7130001, 1051054, 1, 1, 0, 700),
(7130001, 1372015, 1, 1, 0, 700),
(7130001, 1050070, 1, 1, 0, 700),
(7130001, 1050069, 1, 1, 0, 700),
(7130001, 1072165, 1, 1, 0, 800),
(7130001, 1082105, 1, 1, 0, 1000),
(7130001, 1082108, 1, 1, 0, 1000),
(7130001, 1041102, 1, 1, 0, 800),
(7130001, 1061101, 1, 1, 0, 800),
(7130001, 1002095, 1, 1, 0, 1500),
(7130001, 1032016, 1, 1, 0, 1000),
(7130001, 1372016, 1, 1, 0, 700),
(7130001, 1492009, 1, 1, 0, 500),
(7130001, 2040618, 1, 1, 0, 300),
(7130001, 4130002, 1, 1, 0, 6000),
(7130001, 4130003, 1, 1, 0, 6000),
(7130002, 4000236, 1, 1, 0, 600000),
(7130002, 2000006, 1, 1, 0, 20000),
(7130002, 2000004, 1, 1, 0, 20000),
(7130002, 4010000, 1, 1, 0, 9000),
(7130002, 4020001, 1, 1, 0, 9000),
(7130002, 2040902, 1, 1, 0, 300),
(7130002, 2040801, 1, 1, 0, 300),
(7130002, 4006000, 1, 1, 0, 10000),
(7130002, 4004001, 1, 1, 0, 10000),
(7130002, 1040103, 1, 1, 0, 800),
(7130002, 1060091, 1, 1, 0, 800),
(7130002, 1082100, 1, 1, 0, 1000),
(7130002, 1072184, 1, 1, 0, 800),
(7130002, 1002285, 1, 1, 0, 1500),
(7130002, 1302012, 1, 1, 0, 700),
(7130002, 1332019, 1, 1, 0, 500),
(7130002, 1382007, 1, 1, 0, 700),
(7130002, 1092011, 1, 1, 0, 700),
(7130002, 1002640, 1, 1, 0, 1500),
(7130002, 2330003, 1, 1, 0, 500),
(7130002, 2040625, 1, 1, 0, 300),
(7130002, 2044014, 1, 1, 0, 300),
(7130002, 4130000, 1, 1, 0, 6000),
(7130002, 4130005, 1, 1, 0, 6000),
(7130003, 4000237, 1, 1, 0, 600000),
(7130003, 2000006, 1, 1, 0, 20000),
(7130003, 2000004, 1, 1, 0, 20000),
(7130003, 4010003, 1, 1, 0, 9000),
(7130003, 4020003, 1, 1, 0, 9000),
(7130003, 2044101, 1, 1, 0, 300),
(7130003, 2041002, 1, 1, 0, 300),
(7130003, 4006000, 1, 1, 0, 10000),
(7130003, 4004003, 1, 1, 0, 10000),
(7130003, 2070005, 1, 1, 0, 400),
(7130003, 1072156, 1, 1, 0, 800),
(7130003, 1002253, 1, 1, 0, 1500),
(7130003, 1051063, 1, 1, 0, 700),
(7130003, 1082096, 1, 1, 0, 1000),
(7130003, 1092016, 1, 1, 0, 700),
(7130003, 1432007, 1, 1, 0, 500),
(7130003, 1372015, 1, 1, 0, 700),
(7130003, 1412008, 1, 1, 0, 700),
(7130003, 1002640, 1, 1, 0, 1500),
(7130003, 2040423, 1, 1, 0, 300),
(7130003, 4130001, 1, 1, 0, 6000),
(7130003, 4130010, 1, 1, 0, 6000),
(7130003, 4130013, 1, 1, 0, 6000),
(7130004, 4000231, 1, 1, 0, 600000),
(7130004, 2000006, 1, 1, 0, 20000),
(7130004, 2000004, 1, 1, 0, 20000),
(7130004, 4010004, 1, 1, 0, 9000),
(7130004, 4020004, 1, 1, 0, 9000),
(7130004, 2041008, 1, 1, 0, 300),
(7130004, 2044401, 1, 1, 0, 300),
(7130004, 4006001, 1, 1, 0, 10000),
(7130004, 4004004, 1, 1, 0, 10000),
(7130004, 1002338, 1, 1, 0, 1500),
(7130004, 1050074, 1, 1, 0, 700),
(7130004, 1082107, 1, 1, 0, 1000),
(7130004, 1072161, 1, 1, 0, 800),
(7130004, 1102029, 1, 1, 0, 1000),
(7130004, 1452010, 1, 1, 0, 500),
(7130004, 1402012, 1, 1, 0, 700),
(7130004, 1322028, 1, 1, 0, 700),
(7130004, 1032022, 1, 1, 0, 1000),
(7130004, 1072312, 1, 1, 0, 800),
(7130004, 2330003, 1, 1, 0, 500),
(7130010, 4000147, 1, 1, 0, 600000),
(7130010, 2050004, 1, 1, 0, 50000),
(7130010, 2000006, 1, 1, 0, 20000),
(7130010, 2000002, 1, 1, 0, 20000),
(7130010, 2002005, 1, 1, 0, 20000),
(7130010, 2020015, 1, 1, 0, 20000),
(7130010, 4020008, 1, 1, 0, 9000),
(7130010, 4020005, 1, 1, 0, 9000),
(7130010, 4004002, 1, 1, 0, 10000),
(7130010, 4006001, 1, 1, 0, 10000),
(7130010, 2040601, 1, 1, 0, 300),
(7130010, 2041016, 1, 1, 0, 300),
(7130010, 1302016, 1, 1, 0, 700),
(7130010, 1051065, 1, 1, 0, 700),
(7130010, 1072154, 1, 1, 0, 800),
(7130010, 1041101, 1, 1, 0, 800),
(7130010, 1061100, 1, 1, 0, 800),
(7130010, 1452010, 1, 1, 0, 500),
(7130010, 1102030, 1, 1, 0, 1000),
(7130010, 1050073, 1, 1, 0, 700),
(7130010, 1412009, 1, 1, 0, 700),
(7130010, 1332022, 1, 1, 0, 500),
(7130010, 1082123, 1, 1, 0, 1000),
(7130010, 1082118, 1, 1, 0, 1000),
(7130010, 1051078, 1, 1, 0, 700),
(7130010, 1072184, 1, 1, 0, 800),
(7130010, 1002328, 1, 1, 0, 1500),
(7130010, 1051077, 1, 1, 0, 700),
(7130010, 1050088, 1, 1, 0, 700),
(7130010, 1072196, 1, 1, 0, 800),
(7130010, 1072209, 1, 1, 0, 800),
(7130010, 1082142, 1, 1, 0, 1000),
(7130010, 1372016, 1, 1, 0, 700),
(7130010, 1082207, 1, 1, 0, 1000),
(7130010, 2040025, 1, 1, 0, 300),
(7130010, 2040418, 1, 1, 0, 300),
(7130010, 2040923, 1, 1, 0, 300),
(7130010, 2040928, 1, 1, 0, 300),
(7130010, 2044412, 1, 1, 0, 300),
(7130010, 4130002, 1, 1, 0, 6000),
(7130010, 4130004, 1, 1, 0, 6000),
(7130010, 4130006, 1, 1, 0, 6000),
(7130020, 4000179, 1, 1, 0, 600000),
(7130020, 2050004, 1, 1, 0, 50000),
(7130020, 2000006, 1, 1, 0, 20000),
(7130020, 2000002, 1, 1, 0, 20000),
(7130020, 2002003, 1, 1, 0, 20000),
(7130020, 2020015, 1, 1, 0, 20000),
(7130020, 2022040, 1, 1, 0, 20000),
(7130020, 1072164, 1, 1, 0, 800),
(7130020, 4020008, 1, 1, 0, 9000),
(7130020, 4010001, 1, 1, 0, 9000),
(7130020, 4004003, 1, 1, 0, 10000),
(7130020, 4006001, 1, 1, 0, 10000),
(7130020, 1002329, 1, 1, 0, 1500),
(7130020, 2044701, 1, 1, 0, 300),
(7130020, 1002287, 1, 1, 0, 1500),
(7130020, 1041101, 1, 1, 0, 800),
(7130020, 1061100, 1, 1, 0, 800),
(7130020, 1051095, 1, 1, 0, 700),
(7130020, 1051078, 1, 1, 0, 700),
(7130020, 1072152, 1, 1, 0, 800),
(7130020, 2048001, 1, 1, 0, 300),
(7130020, 1422012, 1, 1, 0, 700),
(7130020, 1002323, 1, 1, 0, 1500),
(7130020, 1102032, 1, 1, 0, 1000),
(7130020, 1072194, 1, 1, 0, 800),
(7130020, 1102035, 1, 1, 0, 1000),
(7130020, 1072312, 1, 1, 0, 800),
(7130020, 2044901, 1, 1, 0, 300),
(7130020, 2040324, 1, 1, 0, 300),
(7130020, 2040421, 1, 1, 0, 300),
(7130020, 4130010, 1, 1, 0, 6000),
(7130020, 4130013, 1, 1, 0, 6000),
(7130100, 2000006, 1, 1, 0, 20000),
(7130100, 2000004, 1, 1, 0, 20000),
(7130100, 4010006, 1, 1, 0, 9000),
(7130100, 4000028, 1, 1, 0, 600000),
(7130100, 2070005, 1, 1, 0, 400),
(7130100, 2043101, 1, 1, 0, 300),
(7130100, 4006000, 1, 1, 0, 10000),
(7130100, 1041093, 1, 1, 0, 800),
(7130100, 1061092, 1, 1, 0, 800),
(7130100, 1040100, 1, 1, 0, 800),
(7130100, 1060089, 1, 1, 0, 800),
(7130100, 1050067, 1, 1, 0, 700),
(7130100, 1051055, 1, 1, 0, 700),
(7130100, 1002095, 1, 1, 0, 1500),
(7130100, 1002287, 1, 1, 0, 1500),
(7130100, 1002283, 1, 1, 0, 1500),
(7130100, 1051064, 1, 1, 0, 700),
(7130100, 1072163, 1, 1, 0, 800),
(7130100, 1322019, 1, 1, 0, 700),
(7130100, 1452009, 1, 1, 0, 500),
(7130100, 1472026, 1, 1, 0, 500),
(7130100, 1102027, 1, 1, 0, 1000),
(7130100, 1082115, 1, 1, 0, 1000),
(7130100, 1072184, 1, 1, 0, 800),
(7130100, 1002272, 1, 1, 0, 1500),
(7130100, 1082118, 1, 1, 0, 1000),
(7130100, 1002637, 1, 1, 0, 1500),
(7130100, 2040421, 1, 1, 0, 300),
(7130100, 2049000, 1, 1, 0, 150),
(7130100, 4130008, 1, 1, 0, 6000),
(7130100, 4130014, 1, 1, 0, 6000),
(7130101, 2000005, 1, 1, 0, 20000),
(7130101, 4020008, 1, 1, 0, 9000),
(7130101, 4010003, 1, 1, 0, 9000),
(7130101, 2044101, 1, 1, 0, 300),
(7130101, 4000046, 1, 1, 0, 600000),
(7130101, 4006001, 1, 1, 0, 10000),
(7130101, 1051047, 1, 1, 0, 700),
(7130101, 1041091, 1, 1, 0, 800),
(7130101, 1061090, 1, 1, 0, 800),
(7130101, 1412008, 1, 1, 0, 700),
(7130101, 1452011, 1, 1, 0, 500),
(7130101, 1422010, 1, 1, 0, 700),
(7130101, 1082100, 1, 1, 0, 1000),
(7130101, 1072167, 1, 1, 0, 800),
(7130101, 1041103, 1, 1, 0, 800),
(7130101, 1061102, 1, 1, 0, 800),
(7130101, 1092016, 1, 1, 0, 700),
(7130101, 1051063, 1, 1, 0, 700),
(7130101, 1002284, 1, 1, 0, 1500),
(7130101, 1082104, 1, 1, 0, 1000),
(7130101, 1102028, 1, 1, 0, 1000),
(7130101, 1382010, 1, 1, 0, 700),
(7130101, 1051056, 1, 1, 0, 700),
(7130101, 1002327, 1, 1, 0, 1500),
(7130101, 1050077, 1, 1, 0, 700),
(7130101, 1072211, 1, 1, 0, 800),
(7130101, 1482009, 1, 1, 0, 500),
(7130101, 2044114, 1, 1, 0, 300),
(7130101, 4130008, 1, 1, 0, 6000),
(7130101, 4130012, 1, 1, 0, 6000),
(7130101, 4130014, 1, 1, 0, 6000),
(7130102, 4000050, 1, 1, 0, 600000),
(7130102, 2041020, 1, 1, 0, 300),
(7130102, 2000006, 1, 1, 0, 20000),
(7130102, 2000004, 1, 1, 0, 20000),
(7130102, 4020008, 1, 1, 0, 9000),
(7130102, 4010001, 1, 1, 0, 9000),
(7130102, 2043801, 1, 1, 0, 300),
(7130102, 2044702, 1, 1, 0, 300),
(7130102, 2070010, 1, 1, 0, 500),
(7130102, 4004002, 1, 1, 0, 10000),
(7130102, 2041005, 1, 1, 0, 300),
(7130102, 1002185, 1, 1, 0, 1500),
(7130102, 1041081, 1, 1, 0, 800),
(7130102, 1061080, 1, 1, 0, 800),
(7130102, 1050047, 1, 1, 0, 700),
(7130102, 1002028, 1, 1, 0, 1500),
(7130102, 1072124, 1, 1, 0, 800),
(7130102, 1072128, 1, 1, 0, 800),
(7130102, 1082081, 1, 1, 0, 1000),
(7130102, 1082010, 1, 1, 0, 1000),
(7130102, 1432006, 1, 1, 0, 500),
(7130102, 1472022, 1, 1, 0, 500),
(7130102, 1082091, 1, 1, 0, 1000),
(7130102, 1442010, 1, 1, 0, 700),
(7130102, 1102023, 1, 1, 0, 1000),
(7130102, 1072137, 1, 1, 0, 800),
(7130102, 1050068, 1, 1, 0, 700),
(7130102, 1002030, 1, 1, 0, 1500),
(7130102, 1002282, 1, 1, 0, 1500),
(7130102, 1050063, 1, 1, 0, 700),
(7130102, 1492008, 1, 1, 0, 500),
(7130102, 2044901, 1, 1, 0, 300),
(7130102, 2040625, 1, 1, 0, 300),
(7130102, 4130010, 1, 1, 0, 6000),
(7130102, 4130017, 1, 1, 0, 6000),
(7130102, 4000049, 1, 1, 0, 600000),
(7130102, 4130003, 1, 1, 0, 6000),
(7130102, 4003005, 1, 1, 0, 200000),
(7130102, 2041023, 1, 1, 0, 300),
(7130102, 4000021, 1, 1, 0, 50000),
(7130102, 4020005, 1, 1, 0, 9000),
(7130102, 4010005, 1, 1, 0, 9000),
(7130102, 1050069, 1, 1, 0, 700),
(7130102, 1051054, 1, 1, 0, 700),
(7130102, 2044101, 1, 1, 0, 300),
(7130102, 1402012, 1, 1, 0, 700),
(7130102, 1422009, 1, 1, 0, 700),
(7130102, 2070005, 1, 1, 0, 400),
(7130102, 1050074, 1, 1, 0, 700),
(7130102, 1051058, 1, 1, 0, 700),
(7130102, 1032011, 1, 1, 0, 1000),
(7130102, 1092006, 1, 1, 0, 700),
(7130102, 1332015, 1, 1, 0, 500),
(7130102, 1002084, 1, 1, 0, 1500),
(7130102, 4004000, 1, 1, 0, 10000),
(7130102, 1452011, 1, 1, 0, 500),
(7130102, 2040025, 1, 1, 0, 300),
(7130102, 2043017, 1, 1, 0, 300),
(7130102, 2043210, 1, 1, 0, 300),
(7130102, 2044214, 1, 1, 0, 300),
(7130103, 4000208, 1, 1, 0, 600000),
(7130103, 2002003, 1, 1, 0, 20000),
(7130103, 2002004, 1, 1, 0, 20000),
(7130103, 2000006, 1, 1, 0, 20000),
(7130103, 2000004, 1, 1, 0, 20000),
(7130103, 4020007, 1, 1, 0, 9000),
(7130103, 4020002, 1, 1, 0, 9000),
(7130103, 4020001, 1, 1, 0, 9000),
(7130103, 4006001, 1, 1, 0, 10000),
(7130103, 2040301, 1, 1, 0, 300),
(7130103, 2040516, 1, 1, 0, 300),
(7130103, 1040092, 1, 1, 0, 800),
(7130103, 1060081, 1, 1, 0, 800),
(7130103, 1041092, 1, 1, 0, 800),
(7130103, 1061091, 1, 1, 0, 800),
(7130103, 1041095, 1, 1, 0, 800),
(7130103, 1061094, 1, 1, 0, 800),
(7130103, 1050061, 1, 1, 0, 700),
(7130103, 1051063, 1, 1, 0, 700),
(7130103, 1051054, 1, 1, 0, 700),
(7130103, 1092023, 1, 1, 0, 700),
(7130103, 1072182, 1, 1, 0, 800),
(7130103, 1072172, 1, 1, 0, 800),
(7130103, 1072210, 1, 1, 0, 800),
(7130103, 1072177, 1, 1, 0, 800),
(7130103, 1082207, 1, 1, 0, 1000),
(7130103, 2040418, 1, 1, 0, 300),
(7130103, 4130001, 1, 1, 0, 6000),
(7130103, 4130004, 1, 1, 0, 6000),
(7130103, 4130012, 1, 1, 0, 6000),
(7130104, 2000002, 1, 1, 0, 20000),
(7130104, 2000006, 1, 1, 0, 20000),
(7130104, 2000004, 1, 1, 0, 20000),
(7130104, 4010001, 1, 1, 0, 9000),
(7130104, 4020000, 1, 1, 0, 9000),
(7130104, 4006001, 1, 1, 0, 10000),
(7130104, 4004000, 1, 1, 0, 10000),
(7130104, 1002095, 1, 1, 0, 1500),
(7130104, 1051054, 1, 1, 0, 700),
(7130104, 1082110, 1, 1, 0, 1000),
(7130104, 1072163, 1, 1, 0, 800),
(7130104, 1472028, 1, 1, 0, 500),
(7130104, 1032020, 1, 1, 0, 1000),
(7130104, 1102023, 1, 1, 0, 1000),
(7130104, 2040002, 1, 1, 0, 300),
(7130104, 2040705, 1, 1, 0, 300),
(7130104, 1332018, 1, 1, 0, 500),
(7130104, 1422010, 1, 1, 0, 700),
(7130104, 4000297, 1, 1, 0, 600000),
(7130104, 1082204, 1, 1, 0, 1000),
(7130104, 2040427, 1, 1, 0, 300),
(7130104, 2040824, 1, 1, 0, 300),
(7130104, 2049100, 1, 1, 0, 150),
(7130104, 4130000, 1, 1, 0, 6000),
(7130104, 4130017, 1, 1, 0, 6000),
(7130200, 4000053, 1, 1, 0, 600000),
(7130200, 2000006, 1, 1, 0, 20000),
(7130200, 4020001, 1, 1, 0, 9000),
(7130200, 4010003, 1, 1, 0, 9000),
(7130200, 2043701, 1, 1, 0, 300),
(7130200, 2044701, 1, 1, 0, 300),
(7130200, 4004000, 1, 1, 0, 10000),
(7130200, 4006000, 1, 1, 0, 10000),
(7130200, 2040302, 1, 1, 0, 300),
(7130200, 1050055, 1, 1, 0, 700),
(7130200, 1041094, 1, 1, 0, 800),
(7130200, 1061093, 1, 1, 0, 800),
(7130200, 1050069, 1, 1, 0, 700),
(7130200, 1040102, 1, 1, 0, 800),
(7130200, 1060090, 1, 1, 0, 800),
(7130200, 1082100, 1, 1, 0, 1000),
(7130200, 1041102, 1, 1, 0, 800),
(7130200, 1061101, 1, 1, 0, 800),
(7130200, 1002254, 1, 1, 0, 1500),
(7130200, 1002288, 1, 1, 0, 1500),
(7130200, 1092015, 1, 1, 0, 700),
(7130200, 1332018, 1, 1, 0, 500),
(7130200, 1402012, 1, 1, 0, 700),
(7130200, 1472029, 1, 1, 0, 500),
(7130200, 1322020, 1, 1, 0, 700),
(7130200, 1002273, 1, 1, 0, 1500),
(7130200, 1002339, 1, 1, 0, 1500),
(7130200, 1051066, 1, 1, 0, 700),
(7130200, 1041105, 1, 1, 0, 800),
(7130200, 1061104, 1, 1, 0, 800),
(7130200, 1072309, 1, 1, 0, 800),
(7130200, 2040031, 1, 1, 0, 300),
(7130200, 4130006, 1, 1, 0, 6000),
(7130200, 4130009, 1, 1, 0, 6000),
(7130200, 4130014, 1, 1, 0, 6000),
(7130300, 4000148, 1, 1, 0, 600000),
(7130300, 2000005, 1, 1, 0, 20000),
(7130300, 2000004, 1, 1, 0, 20000),
(7130300, 2002004, 1, 1, 0, 20000),
(7130300, 4006001, 1, 1, 0, 10000),
(7130300, 4010006, 1, 1, 0, 9000),
(7130300, 4020006, 1, 1, 0, 9000),
(7130300, 2044301, 1, 1, 0, 300),
(7130300, 2041009, 1, 1, 0, 300),
(7130300, 1002284, 1, 1, 0, 1500),
(7130300, 1002253, 1, 1, 0, 1500),
(7130300, 1072155, 1, 1, 0, 800),
(7130300, 1072167, 1, 1, 0, 800),
(7130300, 1050074, 1, 1, 0, 700),
(7130300, 1302018, 1, 1, 0, 700),
(7130300, 1002274, 1, 1, 0, 1500),
(7130300, 1002276, 1, 1, 0, 1500),
(7130300, 1041107, 1, 1, 0, 800),
(7130300, 1061106, 1, 1, 0, 800),
(7130300, 1050080, 1, 1, 0, 700),
(7130300, 1051068, 1, 1, 0, 700),
(7130300, 1072212, 1, 1, 0, 800),
(7130300, 1082110, 1, 1, 0, 1000),
(7130300, 1041121, 1, 1, 0, 800),
(7130300, 1061120, 1, 1, 0, 800),
(7130300, 1072203, 1, 1, 0, 800),
(7130300, 1072206, 1, 1, 0, 800),
(7130300, 1082143, 1, 1, 0, 1000),
(7130300, 1072312, 1, 1, 0, 800),
(7130300, 2040031, 1, 1, 0, 300),
(7130300, 2040823, 1, 1, 0, 300),
(7130300, 2043210, 1, 1, 0, 300),
(7130300, 4130000, 1, 1, 0, 6000),
(7130400, 4010001, 1, 1, 0, 90000),
(7130400, 4020001, 1, 1, 0, 90000),
(7130400, 4004003, 1, 1, 0, 100000),
(7130400, 4006001, 1, 1, 0, 100000),
(7130400, 2000006, 1, 1, 0, 999999),
(7130400, 2000004, 1, 1, 0, 999999),
(7130400, 2002003, 1, 1, 0, 200000),
(7130400, 2040504, 1, 1, 0, 3000),
(7130400, 1050058, 1, 1, 0, 7000),
(7130400, 1041094, 1, 1, 0, 8000),
(7130400, 1061093, 1, 1, 0, 8000),
(7130400, 2040302, 1, 1, 0, 3000),
(7130400, 1092016, 1, 1, 0, 7000),
(7130400, 1102021, 1, 1, 0, 10000),
(7130400, 1462009, 1, 1, 0, 5000),
(7130400, 1472024, 1, 1, 0, 5000),
(7130400, 1040102, 1, 1, 0, 8000),
(7130400, 1060090, 1, 1, 0, 8000),
(7130400, 1072309, 1, 1, 0, 8000),
(7130400, 4130002, 1, 1, 0, 60000),
(7130400, 4130005, 1, 1, 0, 60000),
(7130400, 4130015, 1, 1, 0, 60000),
(7130401, 4010004, 1, 1, 0, 90000),
(7130401, 4020000, 1, 1, 0, 90000),
(7130401, 4004002, 1, 1, 0, 100000),
(7130401, 4006001, 1, 1, 0, 100000),
(7130401, 2000006, 1, 1, 0, 999999),
(7130401, 2000004, 1, 1, 0, 999999),
(7130401, 2002000, 1, 1, 0, 200000),
(7130401, 2040601, 1, 1, 0, 3000),
(7130401, 2040701, 1, 1, 0, 3000),
(7130401, 1051041, 1, 1, 0, 7000),
(7130401, 1442010, 1, 1, 0, 7000),
(7130401, 1072158, 1, 1, 0, 8000),
(7130401, 1072163, 1, 1, 0, 8000),
(7130401, 1412008, 1, 1, 0, 7000),
(7130401, 1040106, 1, 1, 0, 8000),
(7130401, 1060094, 1, 1, 0, 8000),
(7130401, 1422009, 1, 1, 0, 7000),
(7130401, 1032022, 1, 1, 0, 10000),
(7130401, 1452010, 1, 1, 0, 5000),
(7130401, 2070007, 1, 1, 0, 2000),
(7130401, 1482009, 1, 1, 0, 5000),
(7130401, 2040620, 1, 1, 0, 3000),
(7130401, 2044012, 1, 1, 0, 3000),
(7130401, 4130006, 1, 1, 0, 60000),
(7130401, 4130015, 1, 1, 0, 60000),
(7130402, 4010006, 1, 1, 0, 90000),
(7130402, 4020006, 1, 1, 0, 90000),
(7130402, 4004001, 1, 1, 0, 100000),
(7130402, 4006000, 1, 1, 0, 100000),
(7130402, 2000006, 1, 1, 0, 999999),
(7130402, 2000004, 1, 1, 0, 999999),
(7130402, 2002006, 1, 1, 0, 200000),
(7130402, 2041007, 1, 1, 0, 3000),
(7130402, 1032019, 1, 1, 0, 10000),
(7130402, 1082090, 1, 1, 0, 10000),
(7130402, 1041092, 1, 1, 0, 8000),
(7130402, 1061091, 1, 1, 0, 8000),
(7130402, 2043001, 1, 1, 0, 3000),
(7130402, 1032022, 1, 1, 0, 10000),
(7130402, 1402012, 1, 1, 0, 7000),
(7130402, 1072155, 1, 1, 0, 8000),
(7130402, 1422005, 1, 1, 0, 7000),
(7130402, 1041101, 1, 1, 0, 8000),
(7130402, 1061100, 1, 1, 0, 8000),
(7130402, 2070007, 1, 1, 0, 2000),
(7130402, 1002637, 1, 1, 0, 15000),
(7130402, 2330003, 1, 1, 0, 5000),
(7130402, 2040024, 1, 1, 0, 3000),
(7130402, 2040534, 1, 1, 0, 3000),
(7130402, 2043112, 1, 1, 0, 3000),
(7130402, 4130017, 1, 1, 0, 60000),
(7130500, 4000226, 1, 1, 0, 600000),
(7130500, 2000006, 1, 1, 0, 20000),
(7130500, 2000004, 1, 1, 0, 20000),
(7130500, 4010001, 1, 1, 0, 9000),
(7130500, 4020000, 1, 1, 0, 9000),
(7130500, 2040002, 1, 1, 0, 300),
(7130500, 2040705, 1, 1, 0, 300),
(7130500, 4006001, 1, 1, 0, 10000),
(7130500, 4004000, 1, 1, 0, 10000),
(7130500, 1002095, 1, 1, 0, 1500),
(7130500, 1051054, 1, 1, 0, 700),
(7130500, 1082110, 1, 1, 0, 1000),
(7130500, 1072163, 1, 1, 0, 800),
(7130500, 1332018, 1, 1, 0, 500),
(7130500, 1422010, 1, 1, 0, 700),
(7130500, 1472028, 1, 1, 0, 500),
(7130500, 1032020, 1, 1, 0, 1000),
(7130500, 1102023, 1, 1, 0, 1000),
(7130500, 4000227, 1, 1, 0, 600000),
(7130500, 4000228, 1, 1, 0, 600000),
(7130500, 1052122, 1, 1, 0, 700),
(7130500, 2040326, 1, 1, 0, 300),
(7130500, 2040623, 1, 1, 0, 300),
(7130500, 2040824, 1, 1, 0, 300),
(7130500, 4130007, 1, 1, 0, 6000),
(7130500, 4130011, 1, 1, 0, 6000),
(7130500, 4130015, 1, 1, 0, 6000),
(7130501, 4000229, 1, 1, 0, 600000),
(7130501, 2000006, 1, 1, 0, 20000),
(7130501, 2000004, 1, 1, 0, 20000),
(7130501, 4010002, 1, 1, 0, 9000),
(7130501, 4020002, 1, 1, 0, 9000),
(7130501, 2040505, 1, 1, 0, 300),
(7130501, 2043002, 1, 1, 0, 300),
(7130501, 4006001, 1, 1, 0, 10000),
(7130501, 4004002, 1, 1, 0, 10000),
(7130501, 1082105, 1, 1, 0, 1000),
(7130501, 1072178, 1, 1, 0, 800),
(7130501, 1002276, 1, 1, 0, 1500),
(7130501, 1041103, 1, 1, 0, 800),
(7130501, 1061102, 1, 1, 0, 800),
(7130501, 1472027, 1, 1, 0, 500),
(7130501, 1302018, 1, 1, 0, 700),
(7130501, 2070005, 1, 1, 0, 400),
(7130501, 1102027, 1, 1, 0, 1000),
(7130501, 1092016, 1, 1, 0, 700),
(7130501, 4000230, 1, 1, 0, 600000),
(7130501, 1052122, 1, 1, 0, 700),
(7130501, 2040321, 1, 1, 0, 300),
(7130501, 2040515, 1, 1, 0, 300),
(7130501, 2040625, 1, 1, 0, 300),
(7130501, 4130008, 1, 1, 0, 6000),
(7130501, 4130010, 1, 1, 0, 6000),
(7130600, 2000006, 1, 1, 0, 20000),
(7130600, 2000004, 1, 1, 0, 20000),
(7130600, 4010001, 1, 1, 0, 9000),
(7130600, 4010000, 1, 1, 0, 9000),
(7130600, 2044101, 1, 1, 0, 300),
(7130600, 2041008, 1, 1, 0, 300),
(7130600, 4006001, 1, 1, 0, 10000),
(7130600, 4004002, 1, 1, 0, 10000),
(7130600, 1051062, 1, 1, 0, 700),
(7130600, 1002287, 1, 1, 0, 1500),
(7130600, 1082119, 1, 1, 0, 1000),
(7130600, 1072211, 1, 1, 0, 800),
(7130600, 1332019, 1, 1, 0, 500),
(7130600, 1452009, 1, 1, 0, 500),
(7130600, 4000260, 1, 1, 0, 600000),
(7130600, 2040512, 1, 1, 0, 300),
(7130600, 2044010, 1, 1, 0, 300),
(7130600, 4130001, 1, 1, 0, 6000),
(7130600, 4130005, 1, 1, 0, 6000),
(7130600, 4130017, 1, 1, 0, 6000),
(7130601, 2000006, 1, 1, 0, 20000),
(7130601, 2000004, 1, 1, 0, 20000),
(7130601, 4020007, 1, 1, 0, 9000),
(7130601, 4020001, 1, 1, 0, 9000),
(7130601, 2044602, 1, 1, 0, 300),
(7130601, 2043701, 1, 1, 0, 300),
(7130601, 4006000, 1, 1, 0, 10000),
(7130601, 4004003, 1, 1, 0, 10000),
(7130601, 1040106, 1, 1, 0, 800),
(7130601, 1060094, 1, 1, 0, 800),
(7130601, 1002252, 1, 1, 0, 1500),
(7130601, 1082125, 1, 1, 0, 1000),
(7130601, 1072212, 1, 1, 0, 800),
(7130601, 1462009, 1, 1, 0, 500),
(7130601, 1322019, 1, 1, 0, 700),
(7130601, 4000261, 1, 1, 0, 600000),
(7130601, 1052125, 1, 1, 0, 700),
(7130601, 2044802, 1, 1, 0, 300),
(7130601, 2040927, 1, 1, 0, 300),
(7130601, 4130003, 1, 1, 0, 6000),
(7130601, 4130011, 1, 1, 0, 6000),
(7130601, 4130016, 1, 1, 0, 6000),
(7140000, 4000132, 1, 1, 0, 600000),
(7140000, 2000006, 1, 1, 0, 20000),
(7140000, 4004001, 1, 1, 0, 10000),
(7140000, 4020002, 1, 1, 0, 9000),
(7140000, 4010002, 1, 1, 0, 9000),
(7140000, 2041001, 1, 1, 0, 300),
(7140000, 2040502, 1, 1, 0, 300),
(7140000, 1040107, 1, 1, 0, 800),
(7140000, 1060095, 1, 1, 0, 800),
(7140000, 1002094, 1, 1, 0, 1500),
(7140000, 1002287, 1, 1, 0, 1500),
(7140000, 1040108, 1, 1, 0, 800),
(7140000, 1060097, 1, 1, 0, 800),
(7140000, 1050082, 1, 1, 0, 700),
(7140000, 1002273, 1, 1, 0, 1500),
(7140000, 1002277, 1, 1, 0, 1500),
(7140000, 1002338, 1, 1, 0, 1500),
(7140000, 1072182, 1, 1, 0, 800),
(7140000, 1082114, 1, 1, 0, 1000),
(7140000, 1092025, 1, 1, 0, 700),
(7140000, 1462011, 1, 1, 0, 500),
(7140000, 1432010, 1, 1, 0, 500),
(7140000, 1050089, 1, 1, 0, 700),
(7140000, 1072192, 1, 1, 0, 800),
(7140000, 1072207, 1, 1, 0, 800),
(7140000, 1082128, 1, 1, 0, 1000),
(7140000, 1002640, 1, 1, 0, 1500),
(7140000, 2040924, 1, 1, 0, 300),
(7140000, 2043015, 1, 1, 0, 300),
(7140000, 4130001, 1, 1, 0, 6000),
(7140000, 4130005, 1, 1, 0, 6000),
(7160000, 4000133, 1, 1, 0, 600000),
(7160000, 2000006, 1, 1, 0, 20000),
(7160000, 2000002, 1, 1, 0, 20000),
(7160000, 4020008, 1, 1, 0, 9000),
(7160000, 4010003, 1, 1, 0, 9000),
(7160000, 2044401, 1, 1, 0, 300),
(7160000, 4006001, 1, 1, 0, 10000),
(7160000, 4004000, 1, 1, 0, 10000),
(7160000, 4131007, 1, 1, 0, 6000),
(7160000, 2070005, 1, 1, 0, 400),
(7160000, 1050070, 1, 1, 0, 700),
(7160000, 1452011, 1, 1, 0, 500),
(7160000, 1082103, 1, 1, 0, 1000),
(7160000, 1040107, 1, 1, 0, 800),
(7160000, 1060095, 1, 1, 0, 800),
(7160000, 1051057, 1, 1, 0, 700),
(7160000, 1002330, 1, 1, 0, 1500),
(7160000, 1002272, 1, 1, 0, 1500),
(7160000, 1032016, 1, 1, 0, 1000),
(7160000, 1041105, 1, 1, 0, 800),
(7160000, 1061104, 1, 1, 0, 800),
(7160000, 1050075, 1, 1, 0, 700),
(7160000, 1051077, 1, 1, 0, 700),
(7160000, 1051066, 1, 1, 0, 700),
(7160000, 1072173, 1, 1, 0, 800),
(7160000, 1082116, 1, 1, 0, 1000),
(7160000, 1082109, 1, 1, 0, 1000),
(7160000, 1082121, 1, 1, 0, 1000),
(7160000, 1041115, 1, 1, 0, 800),
(7160000, 1061114, 1, 1, 0, 800),
(7160000, 1072197, 1, 1, 0, 800),
(7160000, 1082125, 1, 1, 0, 1000),
(7160000, 1082131, 1, 1, 0, 1000),
(7160000, 2330003, 1, 1, 0, 500),
(7160000, 1492010, 1, 1, 0, 500),
(7160000, 2040619, 1, 1, 0, 300),
(7160000, 4130003, 1, 1, 0, 6000),
(7160000, 4130007, 1, 1, 0, 6000);
INSERT IGNORE INTO `temp_data` (`dropperid`, `itemid`, `minimum_quantity`, `maximum_quantity`, `questid`, `chance`) VALUES
(7160000, 4130011, 1, 1, 0, 6000),
(7220000, 4000284, 1, 1, 0, 600000),
(7220000, 4000284, 1, 1, 0, 600000),
(7220000, 4000284, 1, 1, 0, 600000),
(7220000, 4000285, 1, 1, 0, 600000),
(7220000, 4000285, 1, 1, 0, 600000),
(7220000, 4000285, 1, 1, 0, 600000),
(7220000, 4000021, 1, 1, 0, 500000),
(7220000, 4000021, 1, 1, 0, 500000),
(7220000, 4000021, 1, 1, 0, 500000),
(7220000, 4000283, 1, 1, 0, 600000),
(7220000, 4000283, 1, 1, 0, 600000),
(7220000, 4000283, 1, 1, 0, 600000),
(7220000, 4004000, 1, 1, 0, 100000),
(7220000, 4010001, 1, 1, 0, 90000),
(7220000, 4020006, 1, 1, 0, 90000),
(7220000, 2000002, 1, 1, 0, 200000),
(7220000, 2000003, 1, 1, 0, 200000),
(7220000, 2002004, 1, 1, 0, 200000),
(7220000, 2002011, 1, 1, 0, 200000),
(7220000, 2022142, 1, 1, 0, 200000),
(7220000, 2040901, 1, 1, 0, 3000),
(7220000, 2041001, 1, 1, 0, 3000),
(7220000, 2043801, 1, 1, 0, 3000),
(7220000, 2043101, 1, 1, 0, 3000),
(7220000, 2041010, 1, 1, 0, 3000),
(7220000, 2043301, 1, 1, 0, 3000),
(7220000, 2044101, 1, 1, 0, 3000),
(7220000, 2044501, 1, 1, 0, 3000),
(7220000, 2041022, 1, 1, 0, 3000),
(7220000, 2044601, 1, 1, 0, 3000),
(7220000, 2048005, 1, 1, 0, 3000),
(7220000, 2040005, 1, 1, 0, 3000),
(7220000, 2040514, 1, 1, 0, 3000),
(7220000, 2040705, 1, 1, 0, 3000),
(7220000, 2040805, 1, 1, 0, 3000),
(7220000, 2060001, 1, 1, 0, 300000),
(7220000, 2061001, 1, 1, 0, 300000),
(7220000, 2070004, 1, 1, 0, 5000),
(7220000, 1302012, 1, 1, 0, 7000),
(7220000, 1312010, 1, 1, 0, 7000),
(7220000, 1322019, 1, 1, 0, 7000),
(7220000, 1332018, 1, 1, 0, 5000),
(7220000, 1372015, 1, 1, 0, 7000),
(7220000, 1382010, 1, 1, 0, 7000),
(7220000, 1402012, 1, 1, 0, 7000),
(7220000, 1412008, 1, 1, 0, 7000),
(7220000, 1422010, 1, 1, 0, 7000),
(7220000, 1432007, 1, 1, 0, 5000),
(7220000, 1442008, 1, 1, 0, 7000),
(7220000, 1452011, 1, 1, 0, 5000),
(7220000, 1462009, 1, 1, 0, 5000),
(7220000, 1472029, 1, 1, 0, 5000),
(7220000, 1482009, 1, 1, 0, 5000),
(7220000, 1492009, 1, 1, 0, 5000),
(7220000, 2044801, 1, 1, 0, 3000),
(7220000, 2040025, 1, 1, 0, 3000),
(7220000, 2040825, 1, 1, 0, 3000),
(7220000, 2043019, 1, 1, 0, 3000),
(7220000, 2044014, 1, 1, 0, 3000),
(7220000, 2044312, 1, 1, 0, 3000),
(7220000, 2044412, 1, 1, 0, 3000),
(7220000, 2049100, 1, 1, 0, 3000),
(7220001, 4000172, 1, 1, 0, 600000),
(7220001, 4000172, 1, 1, 0, 600000),
(7220001, 4000172, 1, 1, 0, 600000),
(7220001, 4000172, 1, 1, 0, 600000),
(7220001, 4000172, 1, 1, 0, 600000),
(7220001, 4000172, 1, 1, 0, 600000),
(7220001, 4000172, 1, 1, 0, 600000),
(7220001, 4000172, 1, 1, 0, 600000),
(7220001, 4000021, 1, 1, 0, 500000),
(7220001, 4004002, 1, 1, 0, 100000),
(7220001, 4010004, 1, 1, 0, 90000),
(7220001, 4020004, 1, 1, 0, 90000),
(7220001, 2000002, 1, 1, 0, 200000),
(7220001, 2000003, 1, 1, 0, 200000),
(7220001, 2002002, 1, 1, 0, 200000),
(7220001, 2002000, 1, 1, 0, 200000),
(7220001, 2040301, 1, 1, 0, 3000),
(7220001, 2040501, 1, 1, 0, 3000),
(7220001, 2040513, 1, 1, 0, 3000),
(7220001, 2040701, 1, 1, 0, 3000),
(7220001, 2040804, 1, 1, 0, 3000),
(7220001, 2041010, 1, 1, 0, 3000),
(7220001, 2043301, 1, 1, 0, 3000),
(7220001, 2043801, 1, 1, 0, 3000),
(7220001, 2044501, 1, 1, 0, 3000),
(7220001, 2041016, 1, 1, 0, 3000),
(7220001, 2041017, 1, 1, 0, 3000),
(7220001, 2043702, 1, 1, 0, 3000),
(7220001, 2044702, 1, 1, 0, 3000),
(7220001, 2040902, 1, 1, 0, 3000),
(7220001, 2040602, 1, 1, 0, 3000),
(7220001, 2060001, 1, 1, 0, 300000),
(7220001, 2061001, 1, 1, 0, 300000),
(7220001, 2070005, 1, 1, 0, 4000),
(7220001, 1002095, 1, 1, 0, 15000),
(7220001, 1002254, 1, 1, 0, 15000),
(7220001, 1002289, 1, 1, 0, 15000),
(7220001, 1002285, 1, 1, 0, 15000),
(7220001, 1040103, 1, 1, 0, 8000),
(7220001, 1041099, 1, 1, 0, 8000),
(7220001, 1050070, 1, 1, 0, 7000),
(7220001, 1051055, 1, 1, 0, 7000),
(7220001, 1050064, 1, 1, 0, 7000),
(7220001, 1051065, 1, 1, 0, 7000),
(7220001, 1040107, 1, 1, 0, 8000),
(7220001, 1041100, 1, 1, 0, 8000),
(7220001, 1082105, 1, 1, 0, 10000),
(7220001, 1082100, 1, 1, 0, 10000),
(7220001, 1082108, 1, 1, 0, 10000),
(7220001, 1082097, 1, 1, 0, 10000),
(7220001, 1072156, 1, 1, 0, 8000),
(7220001, 1072160, 1, 1, 0, 8000),
(7220001, 1072167, 1, 1, 0, 8000),
(7220001, 1072161, 1, 1, 0, 8000),
(7220001, 1002637, 1, 1, 0, 15000),
(7220001, 1052122, 1, 1, 0, 7000),
(7220001, 1082204, 1, 1, 0, 10000),
(7220001, 1072309, 1, 1, 0, 8000),
(7220001, 2044802, 1, 1, 0, 3000),
(7220001, 2044901, 1, 1, 0, 3000),
(7220001, 2040025, 1, 1, 0, 3000),
(7220001, 2040427, 1, 1, 0, 3000),
(7220001, 2040625, 1, 1, 0, 3000),
(7220001, 2040933, 1, 1, 0, 3000),
(7220001, 2043017, 1, 1, 0, 3000),
(7220002, 4000298, 1, 1, 0, 600000),
(7220002, 4000298, 1, 1, 0, 600000),
(7220002, 4000298, 1, 1, 0, 600000),
(7220002, 4000289, 1, 1, 0, 600000),
(7220002, 4000289, 1, 1, 0, 600000),
(7220002, 4000289, 1, 1, 0, 600000),
(7220002, 4003005, 1, 1, 0, 200000),
(7220002, 4004004, 1, 1, 0, 100000),
(7220002, 4010005, 1, 1, 0, 90000),
(7220002, 4020008, 1, 1, 0, 90000),
(7220002, 2000002, 1, 1, 0, 200000),
(7220002, 2000003, 1, 1, 0, 200000),
(7220002, 2002002, 1, 1, 0, 200000),
(7220002, 2002003, 1, 1, 0, 200000),
(7220002, 2022149, 1, 1, 0, 200000),
(7220002, 2040004, 1, 1, 0, 3000),
(7220002, 2040504, 1, 1, 0, 3000),
(7220002, 2040601, 1, 1, 0, 3000),
(7220002, 2040701, 1, 1, 0, 3000),
(7220002, 2040707, 1, 1, 0, 3000),
(7220002, 2040801, 1, 1, 0, 3000),
(7220002, 2041010, 1, 1, 0, 3000),
(7220002, 2043101, 1, 1, 0, 3000),
(7220002, 2044001, 1, 1, 0, 3000),
(7220002, 2044601, 1, 1, 0, 3000),
(7220002, 2040402, 1, 1, 0, 3000),
(7220002, 2040514, 1, 1, 0, 3000),
(7220002, 2040702, 1, 1, 0, 3000),
(7220002, 2041005, 1, 1, 0, 3000),
(7220002, 2044302, 1, 1, 0, 3000),
(7220002, 2060001, 1, 1, 0, 300000),
(7220002, 2061001, 1, 1, 0, 300000),
(7220002, 1302018, 1, 1, 0, 7000),
(7220002, 1312011, 1, 1, 0, 7000),
(7220002, 1322028, 1, 1, 0, 7000),
(7220002, 1332023, 1, 1, 0, 5000),
(7220002, 1372016, 1, 1, 0, 7000),
(7220002, 1382008, 1, 1, 0, 7000),
(7220002, 1402004, 1, 1, 0, 7000),
(7220002, 1412009, 1, 1, 0, 7000),
(7220002, 1422012, 1, 1, 0, 7000),
(7220002, 1432010, 1, 1, 0, 5000),
(7220002, 1442019, 1, 1, 0, 7000),
(7220002, 1452015, 1, 1, 0, 5000),
(7220002, 1462013, 1, 1, 0, 5000),
(7220002, 1472031, 1, 1, 0, 5000),
(7220002, 1482010, 1, 1, 0, 5000),
(7220002, 1492010, 1, 1, 0, 5000),
(7220002, 2044902, 1, 1, 0, 3000),
(7220002, 2040619, 1, 1, 0, 3000),
(7220002, 2044414, 1, 1, 0, 3000),
(7220002, 2049000, 1, 1, 0, 1500),
(8090000, 4000418, 1, 1, 0, 600000),
(8110300, 2000006, 1, 1, 0, 20000),
(8110300, 2000005, 1, 1, 0, 20000),
(8110300, 4010005, 1, 1, 0, 9000),
(8110300, 4020005, 1, 1, 0, 9000),
(8110300, 2044602, 1, 1, 0, 300),
(8110300, 2041005, 1, 1, 0, 300),
(8110300, 4006000, 1, 1, 0, 10000),
(8110300, 4004000, 1, 1, 0, 10000),
(8110300, 2000002, 1, 1, 0, 20000),
(8110300, 2070005, 1, 1, 0, 400),
(8110300, 1082114, 1, 1, 0, 1000),
(8110300, 1072158, 1, 1, 0, 800),
(8110300, 1002288, 1, 1, 0, 1500),
(8110300, 1040107, 1, 1, 0, 800),
(8110300, 1060095, 1, 1, 0, 800),
(8110300, 1452011, 1, 1, 0, 500),
(8110300, 1442008, 1, 1, 0, 700),
(8110300, 1312010, 1, 1, 0, 700),
(8110300, 1102031, 1, 1, 0, 1000),
(8110300, 4000355, 1, 1, 0, 600000),
(8110300, 2044902, 1, 1, 0, 300),
(8110300, 2044807, 1, 1, 0, 300),
(8110300, 4130012, 1, 1, 0, 6000),
(8110300, 4130013, 1, 1, 0, 6000),
(8130100, 4021008, 1, 1, 0, 90000),
(8130100, 2000005, 1, 1, 0, 999999),
(8130100, 1452009, 1, 1, 0, 5000),
(8130100, 1382007, 1, 1, 0, 7000),
(8130100, 1462009, 1, 1, 0, 5000),
(8130100, 1322019, 1, 1, 0, 7000),
(8130100, 1312010, 1, 1, 0, 7000),
(8130100, 1412008, 1, 1, 0, 7000),
(8130100, 1422010, 1, 1, 0, 7000),
(8130100, 1472026, 1, 1, 0, 5000),
(8130100, 1432007, 1, 1, 0, 5000),
(8130100, 1442008, 1, 1, 0, 7000),
(8130100, 1302012, 1, 1, 0, 7000),
(8130100, 1402012, 1, 1, 0, 7000),
(8130100, 1332018, 1, 1, 0, 5000),
(8130100, 1332019, 1, 1, 0, 5000),
(8130100, 2043001, 1, 1, 0, 3000),
(8130100, 2043101, 1, 1, 0, 3000),
(8130100, 2043201, 1, 1, 0, 3000),
(8130100, 2043301, 1, 1, 0, 3000),
(8130100, 2043701, 1, 1, 0, 3000),
(8130100, 2043801, 1, 1, 0, 3000),
(8130100, 2044001, 1, 1, 0, 3000),
(8130100, 2044101, 1, 1, 0, 3000),
(8130100, 2044201, 1, 1, 0, 3000),
(8130100, 2044301, 1, 1, 0, 3000),
(8130100, 2044401, 1, 1, 0, 3000),
(8130100, 2044501, 1, 1, 0, 3000),
(8130100, 2044601, 1, 1, 0, 3000),
(8130100, 2044701, 1, 1, 0, 3000),
(8130100, 2000004, 1, 1, 0, 999999),
(8130100, 1092016, 1, 1, 0, 7000),
(8130100, 2070007, 1, 1, 0, 2000),
(8130100, 1482009, 1, 1, 0, 5000),
(8130100, 1492009, 1, 1, 0, 5000),
(8130100, 2044801, 1, 1, 0, 3000),
(8130100, 2044901, 1, 1, 0, 3000),
(8130100, 2040419, 1, 1, 0, 3000),
(8130100, 2040622, 1, 1, 0, 3000),
(8130100, 2049000, 1, 1, 0, 1500),
(8140000, 4000054, 1, 1, 0, 600000),
(8140000, 4003005, 1, 1, 0, 200000),
(8140000, 1402004, 1, 1, 0, 700),
(8140000, 2040902, 1, 1, 0, 300),
(8140000, 2070006, 1, 1, 0, 200),
(8140000, 4010001, 1, 1, 0, 9000),
(8140000, 4020008, 1, 1, 0, 9000),
(8140000, 4010003, 1, 1, 0, 9000),
(8140000, 4004001, 1, 1, 0, 10000),
(8140000, 4006001, 1, 1, 0, 10000),
(8140000, 4020006, 1, 1, 0, 9000),
(8140000, 1051053, 1, 1, 0, 700),
(8140000, 1442008, 1, 1, 0, 700),
(8140000, 1002285, 1, 1, 0, 1500),
(8140000, 1040104, 1, 1, 0, 800),
(8140000, 1060092, 1, 1, 0, 800),
(8140000, 1050064, 1, 1, 0, 700),
(8140000, 1472028, 1, 1, 0, 500),
(8140000, 1102029, 1, 1, 0, 1000),
(8140000, 1002271, 1, 1, 0, 1500),
(8140000, 1002275, 1, 1, 0, 1500),
(8140000, 1072172, 1, 1, 0, 800),
(8140000, 1072178, 1, 1, 0, 800),
(8140000, 1072210, 1, 1, 0, 800),
(8140000, 1032023, 1, 1, 0, 1000),
(8140000, 1050092, 1, 1, 0, 700),
(8140000, 1051082, 1, 1, 0, 700),
(8140000, 1072193, 1, 1, 0, 800),
(8140000, 1082129, 1, 1, 0, 1000),
(8140000, 1482010, 1, 1, 0, 500),
(8140000, 2040825, 1, 1, 0, 300),
(8140000, 2040933, 1, 1, 0, 300),
(8140000, 2044010, 1, 1, 0, 300),
(8140000, 4130007, 1, 1, 0, 6000),
(8140001, 4000238, 1, 1, 0, 600000),
(8140001, 2000006, 1, 1, 0, 20000),
(8140001, 2000005, 1, 1, 0, 20000),
(8140001, 4010005, 1, 1, 0, 9000),
(8140001, 4020005, 1, 1, 0, 9000),
(8140001, 2044602, 1, 1, 0, 300),
(8140001, 2041005, 1, 1, 0, 300),
(8140001, 4006000, 1, 1, 0, 10000),
(8140001, 4004000, 1, 1, 0, 10000),
(8140001, 2000002, 1, 1, 0, 20000),
(8140001, 2070005, 1, 1, 0, 400),
(8140001, 1082114, 1, 1, 0, 1000),
(8140001, 1072158, 1, 1, 0, 800),
(8140001, 1002288, 1, 1, 0, 1500),
(8140001, 1040107, 1, 1, 0, 800),
(8140001, 1060095, 1, 1, 0, 800),
(8140001, 1452011, 1, 1, 0, 500),
(8140001, 1442008, 1, 1, 0, 700),
(8140001, 1312010, 1, 1, 0, 700),
(8140001, 1102031, 1, 1, 0, 1000),
(8140001, 1492010, 1, 1, 0, 500),
(8140001, 2040318, 1, 1, 0, 300),
(8140001, 2040824, 1, 1, 0, 300),
(8140001, 2044310, 1, 1, 0, 300),
(8140001, 2044805, 1, 1, 0, 300),
(8140001, 4130004, 1, 1, 0, 6000),
(8140001, 4130015, 1, 1, 0, 6000),
(8140001, 4130016, 1, 1, 0, 6000),
(8140002, 4000239, 1, 1, 0, 600000),
(8140002, 2000006, 1, 1, 0, 20000),
(8140002, 2000005, 1, 1, 0, 20000),
(8140002, 4010006, 1, 1, 0, 9000),
(8140002, 4020007, 1, 1, 0, 9000),
(8140002, 2040707, 1, 1, 0, 300),
(8140002, 2043301, 1, 1, 0, 300),
(8140002, 4006001, 1, 1, 0, 10000),
(8140002, 4004001, 1, 1, 0, 10000),
(8140002, 2000002, 1, 1, 0, 20000),
(8140002, 1102030, 1, 1, 0, 1000),
(8140002, 1002339, 1, 1, 0, 1500),
(8140002, 1051057, 1, 1, 0, 700),
(8140002, 1082112, 1, 1, 0, 1000),
(8140002, 1072173, 1, 1, 0, 800),
(8140002, 1472029, 1, 1, 0, 500),
(8140002, 1382010, 1, 1, 0, 700),
(8140002, 1462012, 1, 1, 0, 500),
(8140002, 2070005, 1, 1, 0, 400),
(8140002, 1032022, 1, 1, 0, 1000),
(8140002, 4000240, 1, 1, 0, 60000),
(8140002, 1052125, 1, 1, 0, 700),
(8140002, 2330003, 1, 1, 0, 500),
(8140002, 2040026, 1, 1, 0, 300),
(8140002, 2040316, 1, 1, 0, 300),
(8140002, 2043015, 1, 1, 0, 300),
(8140002, 2049000, 1, 1, 0, 150),
(8140002, 4130000, 1, 1, 0, 6000),
(8140002, 4130002, 1, 1, 0, 6000),
(8140002, 4130010, 1, 1, 0, 6000),
(8140100, 4000057, 1, 1, 0, 600000),
(8140100, 4004004, 1, 1, 0, 10000),
(8140100, 2000006, 1, 1, 0, 20000),
(8140100, 2000004, 1, 1, 0, 20000),
(8140100, 4020007, 1, 1, 0, 9000),
(8140100, 4010003, 1, 1, 0, 9000),
(8140100, 2070004, 1, 1, 0, 500),
(8140100, 4004003, 1, 1, 0, 10000),
(8140100, 4006000, 1, 1, 0, 10000),
(8140100, 1002217, 1, 1, 0, 1500),
(8140100, 1032013, 1, 1, 0, 1000),
(8140100, 1072131, 1, 1, 0, 800),
(8140100, 1050055, 1, 1, 0, 700),
(8140100, 1422009, 1, 1, 0, 700),
(8140100, 1072152, 1, 1, 0, 800),
(8140100, 1002267, 1, 1, 0, 1500),
(8140100, 1041092, 1, 1, 0, 800),
(8140100, 1061091, 1, 1, 0, 800),
(8140100, 1092009, 1, 1, 0, 700),
(8140100, 1102021, 1, 1, 0, 1000),
(8140100, 1032020, 1, 1, 0, 1000),
(8140100, 1462009, 1, 1, 0, 500),
(8140100, 1302012, 1, 1, 0, 700),
(8140100, 1082095, 1, 1, 0, 1000),
(8140100, 1082099, 1, 1, 0, 1000),
(8140100, 1002283, 1, 1, 0, 1500),
(8140100, 2040328, 1, 1, 0, 300),
(8140100, 2040512, 1, 1, 0, 300),
(8140100, 4130002, 1, 1, 0, 6000),
(8140100, 4130003, 1, 1, 0, 6000),
(8140100, 4130009, 1, 1, 0, 6000),
(8140100, 4000056, 1, 1, 0, 600000),
(8140100, 4003004, 1, 1, 0, 200000),
(8140100, 4004004, 1, 1, 0, 10000),
(8140100, 4010001, 1, 1, 0, 9000),
(8140100, 4020002, 1, 1, 0, 9000),
(8140100, 1072127, 1, 1, 0, 800),
(8140100, 1412007, 1, 1, 0, 700),
(8140100, 1332019, 1, 1, 0, 500),
(8140100, 1472022, 1, 1, 0, 500),
(8140100, 1302011, 1, 1, 0, 700),
(8140100, 2044001, 1, 1, 0, 300),
(8140100, 2043801, 1, 1, 0, 300),
(8140100, 1051030, 1, 1, 0, 700),
(8140100, 1051031, 1, 1, 0, 700),
(8140100, 1051034, 1, 1, 0, 700),
(8140100, 1412003, 1, 1, 0, 700),
(8140100, 1302018, 1, 1, 0, 700),
(8140100, 4004001, 1, 1, 0, 10000),
(8140100, 1040100, 1, 1, 0, 800),
(8140100, 1060089, 1, 1, 0, 800),
(8140100, 1492009, 1, 1, 0, 500),
(8140100, 2044802, 1, 1, 0, 300),
(8140100, 2040318, 1, 1, 0, 300),
(8140100, 2040619, 1, 1, 0, 300),
(8140100, 2040927, 1, 1, 0, 300),
(8140100, 2044012, 1, 1, 0, 300),
(8140100, 4130004, 1, 1, 0, 6000),
(8140101, 4000234, 1, 1, 0, 600000),
(8140101, 2000006, 1, 1, 0, 20000),
(8140101, 2000005, 1, 1, 0, 20000),
(8140101, 4010003, 1, 1, 0, 9000),
(8140101, 4020001, 1, 1, 0, 9000),
(8140101, 2048004, 1, 1, 0, 300),
(8140101, 2040901, 1, 1, 0, 300),
(8140101, 4006001, 1, 1, 0, 10000),
(8140101, 4004003, 1, 1, 0, 10000),
(8140101, 2000002, 1, 1, 0, 20000),
(8140101, 1082117, 1, 1, 0, 1000),
(8140101, 1072179, 1, 1, 0, 800),
(8140101, 1002328, 1, 1, 0, 1500),
(8140101, 1040109, 1, 1, 0, 800),
(8140101, 1060098, 1, 1, 0, 800),
(8140101, 1452014, 1, 1, 0, 500),
(8140101, 1382008, 1, 1, 0, 700),
(8140101, 1032023, 1, 1, 0, 1000),
(8140101, 1092026, 1, 1, 0, 700),
(8140101, 1312030, 1, 1, 0, 700),
(8140101, 1402035, 1, 1, 0, 700),
(8140101, 1472053, 1, 1, 0, 500),
(8140101, 1002640, 1, 1, 0, 1500),
(8140101, 2040825, 1, 1, 0, 300),
(8140101, 4130001, 1, 1, 0, 6000),
(8140101, 4130007, 1, 1, 0, 6000),
(8140102, 4000232, 1, 1, 0, 600000),
(8140102, 2000006, 1, 1, 0, 20000),
(8140102, 2000005, 1, 1, 0, 20000),
(8140102, 4010001, 1, 1, 0, 9000),
(8140102, 4020000, 1, 1, 0, 9000),
(8140102, 2040805, 1, 1, 0, 300),
(8140102, 2040703, 1, 1, 0, 300),
(8140102, 4006000, 1, 1, 0, 10000),
(8140102, 4004004, 1, 1, 0, 10000),
(8140102, 2000002, 1, 1, 0, 20000),
(8140102, 1072211, 1, 1, 0, 800),
(8140102, 1002274, 1, 1, 0, 1500),
(8140102, 1051068, 1, 1, 0, 700),
(8140102, 1082118, 1, 1, 0, 1000),
(8140102, 1402004, 1, 1, 0, 700),
(8140102, 1332023, 1, 1, 0, 500),
(8140102, 1032022, 1, 1, 0, 1000),
(8140102, 1092023, 1, 1, 0, 700),
(8140102, 1422027, 1, 1, 0, 700),
(8140102, 1452019, 1, 1, 0, 500),
(8140102, 1382035, 1, 1, 0, 700),
(8140102, 1432004, 1, 1, 0, 500),
(8140102, 4161015, 1, 1, 0, 7000),
(8140102, 1002643, 1, 1, 0, 1500),
(8140102, 2331000, 1, 1, 0, 500),
(8140102, 2040321, 1, 1, 0, 300),
(8140102, 2040622, 1, 1, 0, 300),
(8140102, 2044807, 1, 1, 0, 300),
(8140102, 4130000, 1, 1, 0, 6000),
(8140102, 4130002, 1, 1, 0, 6000),
(8140102, 4130013, 1, 1, 0, 6000),
(8140103, 4000233, 1, 1, 0, 600000),
(8140103, 2000006, 1, 1, 0, 20000),
(8140103, 2000005, 1, 1, 0, 20000),
(8140103, 4010000, 1, 1, 0, 9000),
(8140103, 4020001, 1, 1, 0, 9000),
(8140103, 2040004, 1, 1, 0, 300),
(8140103, 2043701, 1, 1, 0, 300),
(8140103, 4006000, 1, 1, 0, 10000),
(8140103, 4004002, 1, 1, 0, 10000),
(8140103, 2000002, 1, 1, 0, 20000),
(8140103, 1082116, 1, 1, 0, 1000),
(8140103, 1072177, 1, 1, 0, 800),
(8140103, 1002277, 1, 1, 0, 1500),
(8140103, 1041106, 1, 1, 0, 800),
(8140103, 1061105, 1, 1, 0, 800),
(8140103, 1412009, 1, 1, 0, 700),
(8140103, 1452013, 1, 1, 0, 500),
(8140103, 1442019, 1, 1, 0, 700),
(8140103, 1102032, 1, 1, 0, 1000),
(8140103, 1332051, 1, 1, 0, 500),
(8140103, 1322045, 1, 1, 0, 700),
(8140103, 1412021, 1, 1, 0, 700),
(8140103, 1432011, 1, 1, 0, 500),
(8140103, 4161016, 1, 1, 0, 7000),
(8140103, 1492010, 1, 1, 0, 500),
(8140103, 2332000, 1, 1, 0, 500),
(8140103, 2044314, 1, 1, 0, 300),
(8140103, 4130005, 1, 1, 0, 6000),
(8140103, 4130011, 1, 1, 0, 6000),
(8140103, 4130017, 1, 1, 0, 6000),
(8140110, 4000241, 1, 1, 0, 600000),
(8140110, 2000006, 1, 1, 0, 20000),
(8140110, 2000005, 1, 1, 0, 20000),
(8140110, 4020008, 1, 1, 0, 9000),
(8140110, 4010006, 1, 1, 0, 9000),
(8140110, 2044702, 1, 1, 0, 300),
(8140110, 2043802, 1, 1, 0, 300),
(8140110, 4006000, 1, 1, 0, 10000),
(8140110, 4004002, 1, 1, 0, 10000),
(8140110, 2000002, 1, 1, 0, 20000),
(8140110, 1050083, 1, 1, 0, 700),
(8140110, 1082119, 1, 1, 0, 1000),
(8140110, 1072185, 1, 1, 0, 800),
(8140110, 1002330, 1, 1, 0, 1500),
(8140110, 1092027, 1, 1, 0, 700),
(8140110, 1452015, 1, 1, 0, 500),
(8140110, 1462013, 1, 1, 0, 500),
(8140110, 1432010, 1, 1, 0, 500),
(8140110, 1302056, 1, 1, 0, 700),
(8140110, 1372010, 1, 1, 0, 700),
(8140110, 1332052, 1, 1, 0, 500),
(8140110, 1482010, 1, 1, 0, 500),
(8140110, 2044801, 1, 1, 0, 300),
(8140111, 4000242, 1, 1, 0, 600000),
(8140111, 2000006, 1, 1, 0, 20000),
(8140111, 2000005, 1, 1, 0, 20000),
(8140111, 4010003, 1, 1, 0, 9000),
(8140111, 4020003, 1, 1, 0, 9000),
(8140111, 2041014, 1, 1, 0, 300),
(8140111, 2044001, 1, 1, 0, 300),
(8140111, 4006001, 1, 1, 0, 10000),
(8140111, 4004003, 1, 1, 0, 10000),
(8140111, 2000002, 1, 1, 0, 20000),
(8140111, 2070006, 1, 1, 0, 200),
(8140111, 1051080, 1, 1, 0, 700),
(8140111, 1082122, 1, 1, 0, 1000),
(8140111, 1072183, 1, 1, 0, 800),
(8140111, 1002328, 1, 1, 0, 1500),
(8140111, 1092025, 1, 1, 0, 700),
(8140111, 1372016, 1, 1, 0, 700),
(8140111, 1472031, 1, 1, 0, 500),
(8140111, 1032023, 1, 1, 0, 1000),
(8140111, 1432030, 1, 1, 0, 500),
(8140111, 1442044, 1, 1, 0, 700),
(8140111, 1462015, 1, 1, 0, 500),
(8140111, 2330003, 1, 1, 0, 500),
(8140111, 1482010, 1, 1, 0, 500),
(8140111, 2040323, 1, 1, 0, 300),
(8140111, 2043214, 1, 1, 0, 300),
(8140111, 4130001, 1, 1, 0, 6000),
(8140111, 4130007, 1, 1, 0, 6000),
(8140111, 4130012, 1, 1, 0, 6000),
(8140200, 4000145, 1, 1, 0, 600000),
(8140200, 4010001, 1, 1, 0, 9000),
(8140200, 4020001, 1, 1, 0, 9000),
(8140200, 4004003, 1, 1, 0, 10000),
(8140200, 4006001, 1, 1, 0, 10000),
(8140200, 2000006, 1, 1, 0, 20000),
(8140200, 2000004, 1, 1, 0, 20000),
(8140200, 2002003, 1, 1, 0, 20000),
(8140200, 2040302, 1, 1, 0, 300),
(8140200, 2040802, 1, 1, 0, 300),
(8140200, 2020014, 1, 1, 0, 20000),
(8140200, 1050054, 1, 1, 0, 700),
(8140200, 1002270, 1, 1, 0, 1500),
(8140200, 1040093, 1, 1, 0, 800),
(8140200, 1060082, 1, 1, 0, 800),
(8140200, 1082059, 1, 1, 0, 1000),
(8140200, 1072144, 1, 1, 0, 800),
(8140200, 1050058, 1, 1, 0, 700),
(8140200, 1472022, 1, 1, 0, 500),
(8140200, 1051052, 1, 1, 0, 700),
(8140200, 1072162, 1, 1, 0, 800),
(8140200, 1082104, 1, 1, 0, 1000),
(8140200, 1072159, 1, 1, 0, 800),
(8140200, 1051062, 1, 1, 0, 700),
(8140200, 1032015, 1, 1, 0, 1000),
(8140200, 1322019, 1, 1, 0, 700),
(8140200, 1032022, 1, 1, 0, 1000),
(8140200, 1050073, 1, 1, 0, 700),
(8140200, 1072182, 1, 1, 0, 800),
(8140200, 1082114, 1, 1, 0, 1000),
(8140200, 1482009, 1, 1, 0, 500),
(8140200, 2040318, 1, 1, 0, 300),
(8140200, 2040925, 1, 1, 0, 300),
(8140200, 4130000, 1, 1, 0, 6000),
(8140200, 4130014, 1, 1, 0, 6000),
(8140200, 4130016, 1, 1, 0, 6000),
(8140300, 4000146, 1, 1, 0, 600000),
(8140300, 2000006, 1, 1, 0, 20000),
(8140300, 2000004, 1, 1, 0, 20000),
(8140300, 4020007, 1, 1, 0, 9000),
(8140300, 4010005, 1, 1, 0, 9000),
(8140300, 4006000, 1, 1, 0, 10000),
(8140300, 4004004, 1, 1, 0, 10000),
(8140300, 2040513, 1, 1, 0, 300),
(8140300, 2044602, 1, 1, 0, 300),
(8140300, 1051043, 1, 1, 0, 700),
(8140300, 1041096, 1, 1, 0, 800),
(8140300, 1061095, 1, 1, 0, 800),
(8140300, 1040090, 1, 1, 0, 800),
(8140300, 1060079, 1, 1, 0, 800),
(8140300, 1051055, 1, 1, 0, 700),
(8140300, 1060095, 1, 1, 0, 800),
(8140300, 1040107, 1, 1, 0, 800),
(8140300, 1002252, 1, 1, 0, 1500),
(8140300, 1002289, 1, 1, 0, 1500),
(8140300, 1072160, 1, 1, 0, 800),
(8140300, 1041099, 1, 1, 0, 800),
(8140300, 1061098, 1, 1, 0, 800),
(8140300, 1002288, 1, 1, 0, 1500),
(8140300, 1472027, 1, 1, 0, 500),
(8140300, 1322020, 1, 1, 0, 700),
(8140300, 1382010, 1, 1, 0, 700),
(8140300, 1051057, 1, 1, 0, 700),
(8140300, 1040109, 1, 1, 0, 800),
(8140300, 1060098, 1, 1, 0, 800),
(8140300, 1002277, 1, 1, 0, 1500),
(8140300, 1002340, 1, 1, 0, 1500),
(8140300, 2070005, 1, 1, 0, 400),
(8140300, 1492009, 1, 1, 0, 500),
(8140300, 2040622, 1, 1, 0, 300),
(8140300, 2040623, 1, 1, 0, 300),
(8140300, 2043110, 1, 1, 0, 300),
(8140300, 4130016, 1, 1, 0, 6000),
(8140300, 4130017, 1, 1, 0, 6000),
(8140500, 4000080, 1, 1, 0, 600000),
(8140500, 4003005, 1, 1, 0, 200000),
(8140500, 2000006, 1, 1, 0, 20000),
(8140500, 2000005, 1, 1, 0, 20000),
(8140500, 4020007, 1, 1, 0, 9000),
(8140500, 4020001, 1, 1, 0, 9000),
(8140500, 4004000, 1, 1, 0, 10000),
(8140500, 2044001, 1, 1, 0, 300),
(8140500, 2041022, 1, 1, 0, 300),
(8140500, 1050070, 1, 1, 0, 700),
(8140500, 1072156, 1, 1, 0, 800),
(8140500, 1072164, 1, 1, 0, 800),
(8140500, 1082096, 1, 1, 0, 1000),
(8140500, 1312011, 1, 1, 0, 700),
(8140500, 1082111, 1, 1, 0, 1000),
(8140500, 1082117, 1, 1, 0, 1000),
(8140500, 1082121, 1, 1, 0, 1000),
(8140500, 1092024, 1, 1, 0, 700),
(8140500, 1072174, 1, 1, 0, 800),
(8140500, 1050078, 1, 1, 0, 700),
(8140500, 1060098, 1, 1, 0, 800),
(8140500, 1040109, 1, 1, 0, 800),
(8140500, 1002340, 1, 1, 0, 1500),
(8140500, 1452014, 1, 1, 0, 500),
(8140500, 1060104, 1, 1, 0, 800),
(8140500, 1040115, 1, 1, 0, 800),
(8140500, 1072208, 1, 1, 0, 800),
(8140500, 1082126, 1, 1, 0, 1000),
(8140500, 1032017, 1, 1, 0, 1000),
(8140500, 1072195, 1, 1, 0, 800),
(8140500, 1052125, 1, 1, 0, 700),
(8140500, 4130006, 1, 1, 0, 6000),
(8140500, 4130014, 1, 1, 0, 6000),
(8140600, 4000182, 1, 1, 0, 600000),
(8140600, 2000006, 1, 1, 0, 20000),
(8140600, 2000005, 1, 1, 0, 20000),
(8140600, 2020015, 1, 1, 0, 20000),
(8140600, 2020013, 1, 1, 0, 20000),
(8140600, 4020007, 1, 1, 0, 9000),
(8140600, 4020001, 1, 1, 0, 9000),
(8140600, 4004000, 1, 1, 0, 10000),
(8140600, 2040401, 1, 1, 0, 300),
(8140600, 2040501, 1, 1, 0, 300),
(8140600, 1472028, 1, 1, 0, 500),
(8140600, 2040513, 1, 1, 0, 300),
(8140600, 1452013, 1, 1, 0, 500),
(8140600, 1472023, 1, 1, 0, 500),
(8140600, 1462008, 1, 1, 0, 500),
(8140600, 1102030, 1, 1, 0, 1000),
(8140600, 1040111, 1, 1, 0, 800),
(8140600, 1060100, 1, 1, 0, 800),
(8140600, 1060098, 1, 1, 0, 800),
(8140600, 1040109, 1, 1, 0, 800),
(8140600, 1082108, 1, 1, 0, 1000),
(8140600, 1082117, 1, 1, 0, 1000),
(8140600, 1032017, 1, 1, 0, 1000),
(8140600, 1072160, 1, 1, 0, 800),
(8140600, 1002324, 1, 1, 0, 1500),
(8140600, 1072194, 1, 1, 0, 800),
(8140600, 1072205, 1, 1, 0, 800),
(8140600, 1052128, 1, 1, 0, 700),
(8140600, 2040929, 1, 1, 0, 300),
(8140600, 2049100, 1, 1, 0, 150),
(8140600, 4130010, 1, 1, 0, 6000),
(8140600, 4130015, 1, 1, 0, 6000),
(8140600, 4130016, 1, 1, 0, 6000),
(8140700, 2000006, 1, 1, 0, 20000),
(8140700, 2000005, 1, 1, 0, 20000),
(8140700, 4020007, 1, 1, 0, 9000),
(8140700, 4020001, 1, 1, 0, 9000),
(8140700, 4004000, 1, 1, 0, 10000),
(8140700, 1002528, 1, 1, 0, 1500),
(8140700, 1040117, 1, 1, 0, 800),
(8140700, 1060106, 1, 1, 0, 800),
(8140700, 1041120, 1, 1, 0, 800),
(8140700, 1061119, 1, 1, 0, 800),
(8140700, 1082134, 1, 1, 0, 1000),
(8140700, 1072204, 1, 1, 0, 800),
(8140700, 1372009, 1, 1, 0, 700),
(8140700, 1472033, 1, 1, 0, 500),
(8140700, 2043801, 1, 1, 0, 300),
(8140700, 2041022, 1, 1, 0, 300),
(8140700, 4000262, 1, 1, 0, 600000),
(8140700, 4000244, 1, 1, 0, 2000),
(8140700, 4000245, 1, 1, 0, 2000),
(8140700, 1082207, 1, 1, 0, 1000),
(8140700, 2044902, 1, 1, 0, 300),
(8140700, 2290106, 1, 1, 0, 500),
(8140700, 2040515, 1, 1, 0, 300),
(8140700, 2044314, 1, 1, 0, 300),
(8140700, 2044805, 1, 1, 0, 300),
(8140700, 4130007, 1, 1, 0, 6000),
(8140700, 4130012, 1, 1, 0, 6000),
(8140701, 2000006, 1, 1, 0, 20000),
(8140701, 2000005, 1, 1, 0, 20000),
(8140701, 4010001, 1, 1, 0, 9000),
(8140701, 4020005, 1, 1, 0, 9000),
(8140701, 4004001, 1, 1, 0, 10000),
(8140701, 1002365, 1, 1, 0, 1500),
(8140701, 1040111, 1, 1, 0, 800),
(8140701, 1060100, 1, 1, 0, 800),
(8140701, 1051096, 1, 1, 0, 700),
(8140701, 1082144, 1, 1, 0, 1000),
(8140701, 1072197, 1, 1, 0, 800),
(8140701, 1302023, 1, 1, 0, 700),
(8140701, 1332027, 1, 1, 0, 500),
(8140701, 2044601, 1, 1, 0, 300),
(8140701, 2044101, 1, 1, 0, 300),
(8140701, 4000263, 1, 1, 0, 600000),
(8140701, 4000244, 1, 1, 0, 2000),
(8140701, 4000245, 1, 1, 0, 2000),
(8140701, 1082210, 1, 1, 0, 1000),
(8140701, 2290122, 1, 1, 0, 500),
(8140701, 2040925, 1, 1, 0, 300),
(8140701, 4130003, 1, 1, 0, 6000),
(8140701, 4130008, 1, 1, 0, 6000),
(8140702, 2000006, 1, 1, 0, 20000),
(8140702, 2000005, 1, 1, 0, 20000),
(8140702, 4020003, 1, 1, 0, 9000),
(8140702, 4020008, 1, 1, 0, 9000),
(8140702, 4004002, 1, 1, 0, 10000),
(8140702, 1002403, 1, 1, 0, 1500),
(8140702, 1050092, 1, 1, 0, 700),
(8140702, 1041117, 1, 1, 0, 800),
(8140702, 1061116, 1, 1, 0, 800),
(8140702, 1050106, 1, 1, 0, 700),
(8140702, 1082139, 1, 1, 0, 1000),
(8140702, 1072206, 1, 1, 0, 800),
(8140702, 1312015, 1, 1, 0, 700),
(8140702, 1452017, 1, 1, 0, 500),
(8140702, 2044701, 1, 1, 0, 300),
(8140702, 2040602, 1, 1, 0, 300),
(8140702, 4000264, 1, 1, 0, 600000),
(8140702, 4000244, 1, 1, 0, 2000),
(8140702, 4000245, 1, 1, 0, 2000),
(8140702, 1492011, 1, 1, 0, 500),
(8140702, 2290112, 1, 1, 0, 500),
(8140702, 2040621, 1, 1, 0, 300),
(8140702, 2043015, 1, 1, 0, 300),
(8140702, 4130004, 1, 1, 0, 6000),
(8140702, 4130005, 1, 1, 0, 6000),
(8140702, 4130015, 1, 1, 0, 6000),
(8140703, 2000006, 1, 1, 0, 20000),
(8140703, 2000005, 1, 1, 0, 20000),
(8140703, 4020008, 1, 1, 0, 9000),
(8140703, 4020006, 1, 1, 0, 9000),
(8140703, 4004003, 1, 1, 0, 10000),
(8140703, 1002325, 1, 1, 0, 1500),
(8140703, 1050090, 1, 1, 0, 700),
(8140703, 1051082, 1, 1, 0, 700),
(8140703, 1082151, 1, 1, 0, 1000),
(8140703, 1040120, 1, 1, 0, 800),
(8140703, 1060109, 1, 1, 0, 800),
(8140703, 1072212, 1, 1, 0, 800),
(8140703, 1322029, 1, 1, 0, 700),
(8140703, 1442020, 1, 1, 0, 700),
(8140703, 2043801, 1, 1, 0, 300),
(8140703, 2040901, 1, 1, 0, 300),
(8140703, 4000265, 1, 1, 0, 600000),
(8140703, 4000244, 1, 1, 0, 2000),
(8140703, 4000245, 1, 1, 0, 2000),
(8140703, 1082159, 1, 1, 0, 1000),
(8140703, 2290088, 1, 1, 0, 500),
(8140703, 1002643, 1, 1, 0, 1500),
(8140703, 2044801, 1, 1, 0, 300),
(8140703, 2290099, 1, 1, 0, 500),
(8141000, 4000134, 1, 1, 0, 600000),
(8141000, 2000002, 1, 1, 0, 20000),
(8141000, 2000006, 1, 1, 0, 20000),
(8141000, 4010001, 1, 1, 0, 9000),
(8141000, 4020008, 1, 1, 0, 9000),
(8141000, 4004000, 1, 1, 0, 10000),
(8141000, 2044602, 1, 1, 0, 300),
(8141000, 2070006, 1, 1, 0, 200),
(8141000, 1051063, 1, 1, 0, 700),
(8141000, 1002254, 1, 1, 0, 1500),
(8141000, 1002285, 1, 1, 0, 1500),
(8141000, 1422010, 1, 1, 0, 700),
(8141000, 1050074, 1, 1, 0, 700),
(8141000, 1050072, 1, 1, 0, 700),
(8141000, 1322028, 1, 1, 0, 700),
(8141000, 1002327, 1, 1, 0, 1500),
(8141000, 1002278, 1, 1, 0, 1500),
(8141000, 1050083, 1, 1, 0, 700),
(8141000, 1041106, 1, 1, 0, 800),
(8141000, 1061105, 1, 1, 0, 800),
(8141000, 1050076, 1, 1, 0, 700),
(8141000, 1082115, 1, 1, 0, 1000),
(8141000, 1051068, 1, 1, 0, 700),
(8141000, 1051079, 1, 1, 0, 700),
(8141000, 1040112, 1, 1, 0, 800),
(8141000, 1060101, 1, 1, 0, 800),
(8141000, 1041117, 1, 1, 0, 800),
(8141000, 1061116, 1, 1, 0, 800),
(8141000, 1082132, 1, 1, 0, 1000),
(8141000, 2290082, 1, 1, 0, 500),
(8141000, 1072315, 1, 1, 0, 800),
(8141000, 2044802, 1, 1, 0, 300),
(8141000, 2290097, 1, 1, 0, 500),
(8141000, 2040317, 1, 1, 0, 300),
(8141000, 2040929, 1, 1, 0, 300),
(8141000, 2044809, 1, 1, 0, 300),
(8141000, 2049000, 1, 1, 0, 150),
(8141000, 4130013, 1, 1, 0, 6000),
(8141100, 4000135, 1, 1, 0, 600000),
(8141100, 2000006, 1, 1, 0, 20000),
(8141100, 2000005, 1, 1, 0, 20000),
(8141100, 4020008, 1, 1, 0, 9000),
(8141100, 4004004, 1, 1, 0, 10000),
(8141100, 2043002, 1, 1, 0, 300),
(8141100, 2040902, 1, 1, 0, 300),
(8141100, 4131003, 1, 1, 0, 6000),
(8141100, 4006001, 1, 1, 0, 10000),
(8141100, 1082105, 1, 1, 0, 1000),
(8141100, 1072165, 1, 1, 0, 800),
(8141100, 1051058, 1, 1, 0, 700),
(8141100, 1402015, 1, 1, 0, 700),
(8141100, 1050081, 1, 1, 0, 700),
(8141100, 1050077, 1, 1, 0, 700),
(8141100, 1002329, 1, 1, 0, 1500),
(8141100, 1051080, 1, 1, 0, 700),
(8141100, 1072185, 1, 1, 0, 800),
(8141100, 1082119, 1, 1, 0, 1000),
(8141100, 1462012, 1, 1, 0, 500),
(8141100, 1050093, 1, 1, 0, 700),
(8141100, 1051083, 1, 1, 0, 700),
(8141100, 1061115, 1, 1, 0, 800),
(8141100, 1041116, 1, 1, 0, 800),
(8141100, 1082134, 1, 1, 0, 1000),
(8141100, 2040025, 1, 1, 0, 300),
(8141100, 2040031, 1, 1, 0, 300),
(8141100, 2040418, 1, 1, 0, 300),
(8141100, 2040427, 1, 1, 0, 300),
(8141100, 4130000, 1, 1, 0, 6000),
(8141100, 4130010, 1, 1, 0, 6000),
(8141100, 4130016, 1, 1, 0, 6000),
(8141300, 4000183, 1, 1, 0, 600000),
(8141300, 2000005, 1, 1, 0, 20000),
(8141300, 2020013, 1, 1, 0, 20000),
(8141300, 2002001, 1, 1, 0, 20000),
(8141300, 2000002, 1, 1, 0, 20000),
(8141300, 4020006, 1, 1, 0, 9000),
(8141300, 4004004, 1, 1, 0, 10000),
(8141300, 4006000, 1, 1, 0, 10000),
(8141300, 2020015, 1, 1, 0, 20000),
(8141300, 4010006, 1, 1, 0, 9000),
(8141300, 2040601, 1, 1, 0, 300),
(8141300, 2040701, 1, 1, 0, 300),
(8141300, 1072207, 1, 1, 0, 800),
(8141300, 1032020, 1, 1, 0, 1000),
(8141300, 1002271, 1, 1, 0, 1500),
(8141300, 1072183, 1, 1, 0, 800),
(8141300, 1102026, 1, 1, 0, 1000),
(8141300, 1041119, 1, 1, 0, 800),
(8141300, 1061118, 1, 1, 0, 800),
(8141300, 1452011, 1, 1, 0, 500),
(8141300, 1442008, 1, 1, 0, 700),
(8141300, 1432007, 1, 1, 0, 500),
(8141300, 1050089, 1, 1, 0, 700),
(8141300, 1051083, 1, 1, 0, 700),
(8141300, 1092027, 1, 1, 0, 700),
(8141300, 1002365, 1, 1, 0, 1500),
(8141300, 1072224, 1, 1, 0, 800),
(8141300, 1482011, 1, 1, 0, 500),
(8141300, 2290098, 1, 1, 0, 500),
(8141300, 2040618, 1, 1, 0, 300),
(8141300, 2040512, 1, 1, 0, 300),
(8141300, 2040627, 1, 1, 0, 300),
(8141300, 4130006, 1, 1, 0, 6000),
(8141300, 4130008, 1, 1, 0, 6000),
(8141300, 4130014, 1, 1, 0, 6000),
(8142000, 4000149, 1, 1, 0, 600000),
(8142000, 2000005, 1, 1, 0, 20000),
(8142000, 2002001, 1, 1, 0, 20000),
(8142000, 2000002, 1, 1, 0, 20000),
(8142000, 4020003, 1, 1, 0, 9000),
(8142000, 4004004, 1, 1, 0, 10000),
(8142000, 4006000, 1, 1, 0, 10000),
(8142000, 2020015, 1, 1, 0, 20000),
(8142000, 2044001, 1, 1, 0, 300),
(8142000, 2041022, 1, 1, 0, 300),
(8142000, 1432007, 1, 1, 0, 500),
(8142000, 1082107, 1, 1, 0, 1000),
(8142000, 1051056, 1, 1, 0, 700),
(8142000, 1332023, 1, 1, 0, 500),
(8142000, 1082112, 1, 1, 0, 1000),
(8142000, 1082116, 1, 1, 0, 1000),
(8142000, 1040110, 1, 1, 0, 800),
(8142000, 1060099, 1, 1, 0, 800),
(8142000, 1050076, 1, 1, 0, 700),
(8142000, 1072212, 1, 1, 0, 800),
(8142000, 1002339, 1, 1, 0, 1500),
(8142000, 1051078, 1, 1, 0, 700),
(8142000, 1452013, 1, 1, 0, 500),
(8142000, 1051067, 1, 1, 0, 700),
(8142000, 1051096, 1, 1, 0, 700),
(8142000, 1050091, 1, 1, 0, 700),
(8142000, 1040111, 1, 1, 0, 800),
(8142000, 1060100, 1, 1, 0, 800),
(8142000, 1082133, 1, 1, 0, 1000),
(8142000, 1492011, 1, 1, 0, 500),
(8142000, 2040427, 1, 1, 0, 300),
(8142000, 4130003, 1, 1, 0, 6000),
(8142000, 4130009, 1, 1, 0, 6000),
(8142100, 4000184, 1, 1, 0, 600000),
(8142100, 2000006, 1, 1, 0, 20000),
(8142100, 2000005, 1, 1, 0, 20000),
(8142100, 4010004, 1, 1, 0, 9000),
(8142100, 4020004, 1, 1, 0, 9000),
(8142100, 4004001, 1, 1, 0, 10000),
(8142100, 4006000, 1, 1, 0, 10000),
(8142100, 1412009, 1, 1, 0, 700),
(8142100, 2040801, 1, 1, 0, 300),
(8142100, 2040804, 1, 1, 0, 300),
(8142100, 1422010, 1, 1, 0, 700),
(8142100, 1092025, 1, 1, 0, 700),
(8142100, 1072197, 1, 1, 0, 800),
(8142100, 1040110, 1, 1, 0, 800),
(8142100, 1060099, 1, 1, 0, 800),
(8142100, 1032017, 1, 1, 0, 1000),
(8142100, 1041118, 1, 1, 0, 800),
(8142100, 1061117, 1, 1, 0, 800),
(8142100, 1050090, 1, 1, 0, 700),
(8142100, 1051084, 1, 1, 0, 700),
(8142100, 1050095, 1, 1, 0, 700),
(8142100, 1051097, 1, 1, 0, 700),
(8142100, 4006001, 1, 1, 0, 10000),
(8142100, 1092026, 1, 1, 0, 700),
(8142100, 1002325, 1, 1, 0, 1500),
(8142100, 1092028, 1, 1, 0, 700),
(8142100, 1072220, 1, 1, 0, 800),
(8142100, 2290032, 1, 1, 0, 500),
(8142100, 2290114, 1, 1, 0, 500),
(8142100, 2040318, 1, 1, 0, 300),
(8142100, 2043019, 1, 1, 0, 300),
(8142100, 4130000, 1, 1, 0, 6000),
(8142100, 4130009, 1, 1, 0, 6000),
(8143000, 4000150, 1, 1, 0, 600000),
(8143000, 2000002, 1, 1, 0, 20000),
(8143000, 2000005, 1, 1, 0, 20000),
(8143000, 2022003, 1, 1, 0, 20000),
(8143000, 2002002, 1, 1, 0, 20000),
(8143000, 4010001, 1, 1, 0, 9000),
(8143000, 4006001, 1, 1, 0, 10000),
(8143000, 4010002, 1, 1, 0, 9000),
(8143000, 2044702, 1, 1, 0, 300),
(8143000, 2040401, 1, 1, 0, 300),
(8143000, 1002283, 1, 1, 0, 1500),
(8143000, 1050064, 1, 1, 0, 700),
(8143000, 1092016, 1, 1, 0, 700),
(8143000, 1422012, 1, 1, 0, 700),
(8143000, 1462010, 1, 1, 0, 500),
(8143000, 1082122, 1, 1, 0, 1000),
(8143000, 1082120, 1, 1, 0, 1000),
(8143000, 1072183, 1, 1, 0, 800),
(8143000, 1082117, 1, 1, 0, 1000),
(8143000, 1072179, 1, 1, 0, 800),
(8143000, 1002328, 1, 1, 0, 1500),
(8143000, 1051094, 1, 1, 0, 700),
(8143000, 1002402, 1, 1, 0, 1500),
(8143000, 1061118, 1, 1, 0, 800),
(8143000, 1041119, 1, 1, 0, 800),
(8143000, 1040116, 1, 1, 0, 800),
(8143000, 1060105, 1, 1, 0, 800),
(8143000, 1051084, 1, 1, 0, 700),
(8143000, 1082130, 1, 1, 0, 1000),
(8143000, 2043019, 1, 1, 0, 300),
(8143000, 4130011, 1, 1, 0, 6000),
(8143000, 4130016, 1, 1, 0, 6000),
(8143000, 4130017, 1, 1, 0, 6000),
(8150000, 2040002, 1, 1, 0, 3000),
(8150000, 2040005, 1, 1, 0, 3000),
(8150000, 2040302, 1, 1, 0, 3000),
(8150000, 2040402, 1, 1, 0, 3000),
(8150000, 2040502, 1, 1, 0, 3000),
(8150000, 2040505, 1, 1, 0, 3000),
(8150000, 2040602, 1, 1, 0, 3000),
(8150000, 2040702, 1, 1, 0, 3000),
(8150000, 2040705, 1, 1, 0, 3000),
(8150000, 2040708, 1, 1, 0, 3000),
(8150000, 2040802, 1, 1, 0, 3000),
(8150000, 2040805, 1, 1, 0, 3000),
(8150000, 2040902, 1, 1, 0, 3000),
(8150000, 2043002, 1, 1, 0, 3000),
(8150000, 2043102, 1, 1, 0, 3000),
(8150000, 2043202, 1, 1, 0, 3000),
(8150000, 2043302, 1, 1, 0, 3000),
(8150000, 2043702, 1, 1, 0, 3000),
(8150000, 2043802, 1, 1, 0, 3000),
(8150000, 2044002, 1, 1, 0, 3000),
(8150000, 2044102, 1, 1, 0, 3000),
(8150000, 2044202, 1, 1, 0, 3000),
(8150000, 2044302, 1, 1, 0, 3000),
(8150000, 2044402, 1, 1, 0, 3000),
(8150000, 2044502, 1, 1, 0, 3000),
(8150000, 2044602, 1, 1, 0, 3000),
(8150000, 2044702, 1, 1, 0, 3000),
(8150000, 2070007, 1, 1, 0, 2000),
(8150000, 2044802, 1, 1, 0, 3000),
(8150000, 2044902, 1, 1, 0, 3000),
(8150000, 2040029, 1, 1, 0, 3000),
(8150000, 2040425, 1, 1, 0, 3000),
(8150000, 2043212, 1, 1, 0, 3000),
(8150000, 2044012, 1, 1, 0, 3000),
(8150000, 2044212, 1, 1, 0, 3000),
(8150100, 4000180, 1, 1, 0, 600000),
(8150100, 2000006, 1, 1, 0, 20000),
(8150100, 2022003, 1, 1, 0, 20000),
(8150100, 4006000, 1, 1, 0, 10000),
(8150100, 2000005, 1, 1, 0, 20000),
(8150100, 4006001, 1, 1, 0, 10000),
(8150100, 2020013, 1, 1, 0, 20000),
(8150100, 4004002, 1, 1, 0, 10000),
(8150100, 4010005, 1, 1, 0, 9000),
(8150100, 2040901, 1, 1, 0, 300),
(8150100, 2041001, 1, 1, 0, 300),
(8150100, 1082142, 1, 1, 0, 1000),
(8150100, 1072192, 1, 1, 0, 800),
(8150100, 1072204, 1, 1, 0, 800),
(8150100, 1032017, 1, 1, 0, 1000),
(8150100, 1040112, 1, 1, 0, 800),
(8150100, 1060101, 1, 1, 0, 800),
(8150100, 1322028, 1, 1, 0, 700),
(8150100, 1332022, 1, 1, 0, 500),
(8150100, 1002405, 1, 1, 0, 1500),
(8150100, 2041013, 1, 1, 0, 300),
(8150100, 1002366, 1, 1, 0, 1500),
(8150100, 1072214, 1, 1, 0, 800),
(8150100, 4161018, 1, 1, 0, 7000),
(8150100, 1072315, 1, 1, 0, 800),
(8150100, 1052131, 1, 1, 0, 700),
(8150100, 2044902, 1, 1, 0, 300),
(8150100, 2290118, 1, 1, 0, 500),
(8150100, 4130006, 1, 1, 0, 6000),
(8150100, 4130007, 1, 1, 0, 6000),
(8150101, 4000181, 1, 1, 0, 600000),
(8150101, 2000006, 1, 1, 0, 20000),
(8150101, 2022003, 1, 1, 0, 20000),
(8150101, 4006000, 1, 1, 0, 10000),
(8150101, 2000005, 1, 1, 0, 20000),
(8150101, 4006001, 1, 1, 0, 10000),
(8150101, 2020013, 1, 1, 0, 20000),
(8150101, 4010002, 1, 1, 0, 9000),
(8150101, 4020007, 1, 1, 0, 9000),
(8150101, 2041022, 1, 1, 0, 300),
(8150101, 2043001, 1, 1, 0, 300),
(8150101, 1082143, 1, 1, 0, 1000),
(8150101, 1072193, 1, 1, 0, 800),
(8150101, 1072203, 1, 1, 0, 800),
(8150101, 1002403, 1, 1, 0, 1500),
(8150101, 1040117, 1, 1, 0, 800),
(8150101, 1060106, 1, 1, 0, 800),
(8150101, 1302018, 1, 1, 0, 700),
(8150101, 1312011, 1, 1, 0, 700),
(8150101, 1032023, 1, 1, 0, 1000),
(8150101, 2040301, 1, 1, 0, 300),
(8150101, 1002326, 1, 1, 0, 1500),
(8150101, 1072223, 1, 1, 0, 800),
(8150101, 2290042, 1, 1, 0, 500),
(8150101, 2290052, 1, 1, 0, 500),
(8150101, 4161018, 1, 1, 0, 7000),
(8150101, 1072318, 1, 1, 0, 800),
(8150101, 2290102, 1, 1, 0, 500),
(8150101, 2040420, 1, 1, 0, 300),
(8150101, 2040931, 1, 1, 0, 300),
(8150101, 2049100, 1, 1, 0, 150),
(8150101, 4130009, 1, 1, 0, 6000),
(8150101, 4130010, 1, 1, 0, 6000),
(8150200, 2000006, 1, 1, 0, 20000),
(8150200, 2000005, 1, 1, 0, 20000),
(8150200, 2022003, 1, 1, 0, 20000),
(8150200, 2020015, 1, 1, 0, 20000),
(8150200, 4010005, 1, 1, 0, 9000),
(8150200, 4010002, 1, 1, 0, 9000),
(8150200, 4004004, 1, 1, 0, 10000),
(8150200, 1002529, 1, 1, 0, 1500),
(8150200, 1050102, 1, 1, 0, 700),
(8150200, 1051105, 1, 1, 0, 700),
(8150200, 1051092, 1, 1, 0, 700),
(8150200, 1082135, 1, 1, 0, 1000),
(8150200, 1072194, 1, 1, 0, 800),
(8150200, 1092026, 1, 1, 0, 700),
(8150200, 1402005, 1, 1, 0, 700),
(8150200, 1462018, 1, 1, 0, 500),
(8150200, 2040001, 1, 1, 0, 300),
(8150200, 2043301, 1, 1, 0, 300),
(8150200, 4000266, 1, 1, 0, 600000),
(8150200, 4000244, 1, 1, 0, 2000),
(8150200, 4000245, 1, 1, 0, 2000),
(8150200, 1082210, 1, 1, 0, 1000),
(8150200, 1002646, 1, 1, 0, 1500),
(8150200, 2290100, 1, 1, 0, 500),
(8150200, 2040425, 1, 1, 0, 300),
(8150200, 4130005, 1, 1, 0, 6000),
(8150201, 2000006, 1, 1, 0, 20000),
(8150201, 2000005, 1, 1, 0, 20000),
(8150201, 2022003, 1, 1, 0, 20000),
(8150201, 2020013, 1, 1, 0, 20000),
(8150201, 4010001, 1, 1, 0, 9000),
(8150201, 4020002, 1, 1, 0, 9000),
(8150201, 4004004, 1, 1, 0, 10000),
(8150201, 1002530, 1, 1, 0, 1500),
(8150201, 1050098, 1, 1, 0, 700),
(8150201, 1041122, 1, 1, 0, 800),
(8150201, 1061121, 1, 1, 0, 800),
(8150201, 1051101, 1, 1, 0, 700),
(8150201, 1082158, 1, 1, 0, 1000),
(8150201, 1072208, 1, 1, 0, 800),
(8150201, 1092027, 1, 1, 0, 700),
(8150201, 1402016, 1, 1, 0, 700),
(8150201, 1382035, 1, 1, 0, 700),
(8150201, 2040302, 1, 1, 0, 300),
(8150201, 2040501, 1, 1, 0, 300),
(8150201, 4000267, 1, 1, 0, 600000),
(8150201, 4000244, 1, 1, 0, 2000),
(8150201, 4000245, 1, 1, 0, 2000),
(8150201, 1082136, 1, 1, 0, 1000),
(8150201, 2290004, 1, 1, 0, 500),
(8150201, 2290006, 1, 1, 0, 500),
(8150201, 2290024, 1, 1, 0, 500),
(8150201, 2290036, 1, 1, 0, 500),
(8150201, 2290056, 1, 1, 0, 500),
(8150201, 2290072, 1, 1, 0, 500),
(8150201, 2290078, 1, 1, 0, 500),
(8150201, 1492012, 1, 1, 0, 500),
(8150201, 2044802, 1, 1, 0, 300),
(8150201, 2290117, 1, 1, 0, 500),
(8150201, 2040618, 1, 1, 0, 300),
(8150201, 2044012, 1, 1, 0, 300),
(8150201, 2044210, 1, 1, 0, 300),
(8150201, 2049100, 1, 1, 0, 150),
(8150201, 4130002, 1, 1, 0, 6000),
(8150201, 4130015, 1, 1, 0, 6000),
(8150201, 4130017, 1, 1, 0, 6000),
(8150300, 2000006, 1, 1, 0, 20000),
(8150300, 2000005, 1, 1, 0, 20000),
(8150300, 4004002, 1, 1, 0, 10000),
(8150300, 4010001, 1, 1, 0, 9000),
(8150300, 4020000, 1, 1, 0, 9000),
(8150300, 4006001, 1, 1, 0, 10000),
(8150300, 1002365, 1, 1, 0, 1500),
(8150300, 1050089, 1, 1, 0, 700),
(8150300, 1041118, 1, 1, 0, 800),
(8150300, 1061116, 1, 1, 0, 800),
(8150300, 1082129, 1, 1, 0, 1000),
(8150300, 1072223, 1, 1, 0, 800),
(8150300, 1452017, 1, 1, 0, 500),
(8150300, 2040701, 1, 1, 0, 300),
(8150300, 2040516, 1, 1, 0, 300),
(8150300, 2043002, 1, 1, 0, 300),
(8150300, 4000268, 1, 1, 0, 600000),
(8150300, 4000244, 1, 1, 0, 2000),
(8150300, 4000245, 1, 1, 0, 2000),
(8150300, 1052128, 1, 1, 0, 700),
(8150300, 2044901, 1, 1, 0, 300),
(8150300, 2290120, 1, 1, 0, 500),
(8150300, 2043114, 1, 1, 0, 300),
(8150300, 4130002, 1, 1, 0, 6000),
(8150300, 4130005, 1, 1, 0, 6000),
(8150300, 4130013, 1, 1, 0, 6000),
(8150301, 4000269, 1, 1, 0, 600000),
(8150301, 2000006, 1, 1, 0, 20000),
(8150301, 2022003, 1, 1, 0, 20000),
(8150301, 4006000, 1, 1, 0, 10000),
(8150301, 2000005, 1, 1, 0, 20000),
(8150301, 4004003, 1, 1, 0, 10000),
(8150301, 4020005, 1, 1, 0, 9000),
(8150301, 4010004, 1, 1, 0, 9000),
(8150301, 1002532, 1, 1, 0, 1500),
(8150301, 1050094, 1, 1, 0, 700),
(8150301, 1051105, 1, 1, 0, 700),
(8150301, 1082143, 1, 1, 0, 1000),
(8150301, 1072227, 1, 1, 0, 800),
(8150301, 1422013, 1, 1, 0, 700),
(8150301, 1372010, 1, 1, 0, 700),
(8150301, 2040401, 1, 1, 0, 300),
(8150301, 2040001, 1, 1, 0, 300),
(8150301, 2044001, 1, 1, 0, 300),
(8150301, 4000244, 1, 1, 0, 2000),
(8150301, 4000245, 1, 1, 0, 2000),
(8150301, 1082213, 1, 1, 0, 1000),
(8150301, 2290101, 1, 1, 0, 500),
(8150301, 2040924, 1, 1, 0, 300),
(8150301, 4130004, 1, 1, 0, 6000),
(8150301, 4130013, 1, 1, 0, 6000),
(8150302, 4000270, 1, 1, 0, 600000),
(8150302, 2000006, 1, 1, 0, 20000),
(8150302, 2000005, 1, 1, 0, 20000),
(8150302, 2022003, 1, 1, 0, 20000),
(8150302, 2020013, 1, 1, 0, 20000),
(8150302, 4004000, 1, 1, 0, 10000),
(8150302, 4020002, 1, 1, 0, 9000),
(8150302, 4010005, 1, 1, 0, 9000),
(8150302, 4006001, 1, 1, 0, 10000),
(8150302, 4006000, 1, 1, 0, 10000),
(8150302, 1002531, 1, 1, 0, 1500),
(8150302, 1040115, 1, 1, 0, 800),
(8150302, 1060107, 1, 1, 0, 800),
(8150302, 1051095, 1, 1, 0, 700),
(8150302, 1082127, 1, 1, 0, 1000),
(8150302, 1072214, 1, 1, 0, 800),
(8150302, 1332027, 1, 1, 0, 500),
(8150302, 1442020, 1, 1, 0, 700),
(8150302, 2040302, 1, 1, 0, 300),
(8150302, 2044301, 1, 1, 0, 300),
(8150302, 2044402, 1, 1, 0, 300),
(8150302, 4131004, 1, 1, 0, 6000),
(8150302, 4000244, 1, 1, 0, 2000),
(8150302, 4000245, 1, 1, 0, 2000),
(8150302, 2290010, 1, 1, 0, 500),
(8150302, 2290019, 1, 1, 0, 500),
(8150302, 2290026, 1, 1, 0, 500),
(8150302, 2290076, 1, 1, 0, 500),
(8150302, 1482012, 1, 1, 0, 500),
(8150302, 2290119, 1, 1, 0, 500),
(8150302, 4130009, 1, 1, 0, 6000),
(8150302, 4130014, 1, 1, 0, 6000),
(8150302, 4130017, 1, 1, 0, 6000),
(8160000, 4000151, 1, 1, 0, 600000),
(8160000, 2000006, 1, 1, 0, 20000),
(8160000, 2022003, 1, 1, 0, 20000),
(8160000, 4006000, 1, 1, 0, 10000),
(8160000, 4010001, 1, 1, 0, 9000),
(8160000, 4020002, 1, 1, 0, 9000),
(8160000, 4004003, 1, 1, 0, 10000),
(8160000, 2040705, 1, 1, 0, 300),
(8160000, 2040602, 1, 1, 0, 300),
(8160000, 1092015, 1, 1, 0, 700),
(8160000, 1462009, 1, 1, 0, 500),
(8160000, 1472028, 1, 1, 0, 500),
(8160000, 1050062, 1, 1, 0, 700),
(8160000, 1442019, 1, 1, 0, 700),
(8160000, 1472031, 1, 1, 0, 500),
(8160000, 1452015, 1, 1, 0, 500),
(8160000, 1050081, 1, 1, 0, 700),
(8160000, 1002329, 1, 1, 0, 1500),
(8160000, 1072179, 1, 1, 0, 800),
(8160000, 1082123, 1, 1, 0, 1000),
(8160000, 1051079, 1, 1, 0, 700),
(8160000, 1032023, 1, 1, 0, 1000),
(8160000, 1051095, 1, 1, 0, 700),
(8160000, 1092026, 1, 1, 0, 700),
(8160000, 1002403, 1, 1, 0, 1500),
(8160000, 1040118, 1, 1, 0, 800),
(8160000, 1060107, 1, 1, 0, 800),
(8160000, 1061119, 1, 1, 0, 800),
(8160000, 1041120, 1, 1, 0, 800),
(8160000, 1072213, 1, 1, 0, 800),
(8160000, 1052131, 1, 1, 0, 700),
(8160000, 2040924, 1, 1, 0, 300),
(8160000, 4130003, 1, 1, 0, 6000),
(8160000, 4130004, 1, 1, 0, 6000),
(8160000, 4130014, 1, 1, 0, 6000),
(8170000, 4000152, 1, 1, 0, 600000),
(8170000, 4010004, 1, 1, 0, 9000),
(8170000, 4010005, 1, 1, 0, 9000),
(8170000, 2000006, 1, 1, 0, 20000),
(8170000, 2000005, 1, 1, 0, 20000),
(8170000, 4004004, 1, 1, 0, 10000),
(8170000, 4006001, 1, 1, 0, 10000),
(8170000, 2040702, 1, 1, 0, 300),
(8170000, 2040802, 1, 1, 0, 300),
(8170000, 4020008, 1, 1, 0, 9000),
(8170000, 2002001, 1, 1, 0, 20000),
(8170000, 1002281, 1, 1, 0, 1500),
(8170000, 1092017, 1, 1, 0, 700),
(8170000, 1332018, 1, 1, 0, 500),
(8170000, 1332019, 1, 1, 0, 500),
(8170000, 1050072, 1, 1, 0, 700),
(8170000, 1452012, 1, 1, 0, 500),
(8170000, 1072177, 1, 1, 0, 800),
(8170000, 1041107, 1, 1, 0, 800),
(8170000, 1061106, 1, 1, 0, 800),
(8170000, 1050083, 1, 1, 0, 700),
(8170000, 1051069, 1, 1, 0, 700);
INSERT IGNORE INTO `temp_data` (`dropperid`, `itemid`, `minimum_quantity`, `maximum_quantity`, `questid`, `chance`) VALUES
(8170000, 1072211, 1, 1, 0, 800),
(8170000, 1072178, 1, 1, 0, 800),
(8170000, 1462013, 1, 1, 0, 500),
(8170000, 1102031, 1, 1, 0, 1000),
(8170000, 1050095, 1, 1, 0, 700),
(8170000, 1092027, 1, 1, 0, 700),
(8170000, 1002404, 1, 1, 0, 1500),
(8170000, 1032017, 1, 1, 0, 1000),
(8170000, 1040113, 1, 1, 0, 800),
(8170000, 1060102, 1, 1, 0, 800),
(8170000, 1072227, 1, 1, 0, 800),
(8170000, 2040512, 1, 1, 0, 300),
(8170000, 4130001, 1, 1, 0, 6000),
(8170000, 4130003, 1, 1, 0, 6000),
(8170000, 4130008, 1, 1, 0, 6000),
(8180000, 2000005, 1, 1, 0, 999999),
(8180000, 2000004, 1, 1, 0, 999999),
(8180000, 1302056, 1, 1, 0, 7000),
(8180000, 1312030, 1, 1, 0, 7000),
(8180000, 1322045, 1, 1, 0, 7000),
(8180000, 1332051, 1, 1, 0, 5000),
(8180000, 1332052, 1, 1, 0, 5000),
(8180000, 1372010, 1, 1, 0, 7000),
(8180000, 1382035, 1, 1, 0, 7000),
(8180000, 1402035, 1, 1, 0, 7000),
(8180000, 1412021, 1, 1, 0, 7000),
(8180000, 1422027, 1, 1, 0, 7000),
(8180000, 1432030, 1, 1, 0, 5000),
(8180000, 1442044, 1, 1, 0, 7000),
(8180000, 1452019, 1, 1, 0, 5000),
(8180000, 1462015, 1, 1, 0, 5000),
(8180000, 1472053, 1, 1, 0, 5000),
(8180000, 2043001, 1, 1, 0, 3000),
(8180000, 2043101, 1, 1, 0, 3000),
(8180000, 2043201, 1, 1, 0, 3000),
(8180000, 2043301, 1, 1, 0, 3000),
(8180000, 2043701, 1, 1, 0, 3000),
(8180000, 2043801, 1, 1, 0, 3000),
(8180000, 2044001, 1, 1, 0, 3000),
(8180000, 2044101, 1, 1, 0, 3000),
(8180000, 2044301, 1, 1, 0, 3000),
(8180000, 2044201, 1, 1, 0, 3000),
(8180000, 2044401, 1, 1, 0, 3000),
(8180000, 2044501, 1, 1, 0, 3000),
(8180000, 2044601, 1, 1, 0, 3000),
(8180000, 2044701, 1, 1, 0, 3000),
(8180000, 2040805, 1, 1, 0, 3000),
(8180000, 4004000, 1, 1, 0, 100000),
(8180000, 4004001, 1, 1, 0, 100000),
(8180000, 4004002, 1, 1, 0, 100000),
(8180000, 4004003, 1, 1, 0, 100000),
(8180000, 4000235, 1, 1, 0, 200000),
(8180000, 4000244, 1, 1, 0, 20000),
(8180000, 4000245, 1, 1, 0, 20000),
(8180000, 2290003, 1, 1, 0, 5000),
(8180000, 2290015, 1, 1, 0, 5000),
(8180000, 2290030, 1, 1, 0, 5000),
(8180000, 2290035, 1, 1, 0, 5000),
(8180000, 2290036, 1, 1, 0, 5000),
(8180000, 2290063, 1, 1, 0, 5000),
(8180000, 2290080, 1, 1, 0, 5000),
(8180000, 1482012, 1, 1, 0, 5000),
(8180000, 1492012, 1, 1, 0, 5000),
(8180000, 2044801, 1, 1, 0, 3000),
(8180000, 2044901, 1, 1, 0, 3000),
(8180000, 2290098, 1, 1, 0, 5000),
(8180000, 2290101, 1, 1, 0, 5000),
(8180000, 2290117, 1, 1, 0, 5000),
(8180000, 2040328, 1, 1, 0, 3000),
(8180000, 2040824, 1, 1, 0, 3000),
(8180000, 2043112, 1, 1, 0, 3000),
(8180000, 2044014, 1, 1, 0, 3000),
(8180000, 2049000, 1, 1, 0, 1500),
(8180001, 2000005, 1, 1, 0, 999999),
(8180001, 2000004, 1, 1, 0, 999999),
(8180001, 1302056, 1, 1, 0, 7000),
(8180001, 1312030, 1, 1, 0, 7000),
(8180001, 1322045, 1, 1, 0, 7000),
(8180001, 1332051, 1, 1, 0, 5000),
(8180001, 1332052, 1, 1, 0, 5000),
(8180001, 1372010, 1, 1, 0, 7000),
(8180001, 1382035, 1, 1, 0, 7000),
(8180001, 1402035, 1, 1, 0, 7000),
(8180001, 1412021, 1, 1, 0, 7000),
(8180001, 1422027, 1, 1, 0, 7000),
(8180001, 1432030, 1, 1, 0, 5000),
(8180001, 1442044, 1, 1, 0, 7000),
(8180001, 1452019, 1, 1, 0, 5000),
(8180001, 1462015, 1, 1, 0, 5000),
(8180001, 1472053, 1, 1, 0, 5000),
(8180001, 2040002, 1, 1, 0, 3000),
(8180001, 2040005, 1, 1, 0, 3000),
(8180001, 2040302, 1, 1, 0, 3000),
(8180001, 2040402, 1, 1, 0, 3000),
(8180001, 2040502, 1, 1, 0, 3000),
(8180001, 2040505, 1, 1, 0, 3000),
(8180001, 2040513, 1, 1, 0, 3000),
(8180001, 2040516, 1, 1, 0, 3000),
(8180001, 2040602, 1, 1, 0, 3000),
(8180001, 2040702, 1, 1, 0, 3000),
(8180001, 2040705, 1, 1, 0, 3000),
(8180001, 2040708, 1, 1, 0, 3000),
(8180001, 2040802, 1, 1, 0, 3000),
(8180001, 2040902, 1, 1, 0, 3000),
(8180001, 4004000, 1, 1, 0, 100000),
(8180001, 4004001, 1, 1, 0, 100000),
(8180001, 4004002, 1, 1, 0, 100000),
(8180001, 4004003, 1, 1, 0, 100000),
(8180001, 4000243, 1, 1, 0, 200000),
(8180001, 4000244, 1, 1, 0, 20000),
(8180001, 4000245, 1, 1, 0, 20000),
(8180001, 2290018, 1, 1, 0, 5000),
(8180001, 2290019, 1, 1, 0, 5000),
(8180001, 2290032, 1, 1, 0, 5000),
(8180001, 2290042, 1, 1, 0, 5000),
(8180001, 2290059, 1, 1, 0, 5000),
(8180001, 2290069, 1, 1, 0, 5000),
(8180001, 2290072, 1, 1, 0, 5000),
(8180001, 2290092, 1, 1, 0, 5000),
(8180001, 1482012, 1, 1, 0, 5000),
(8180001, 1492012, 1, 1, 0, 5000),
(8180001, 2290100, 1, 1, 0, 5000),
(8180001, 2290102, 1, 1, 0, 5000),
(8180001, 2290119, 1, 1, 0, 5000),
(8180001, 2040618, 1, 1, 0, 3000),
(8180001, 2040532, 1, 1, 0, 3000),
(8180001, 2040925, 1, 1, 0, 3000),
(8180001, 2043114, 1, 1, 0, 3000),
(8180001, 2043214, 1, 1, 0, 3000),
(8180001, 2044112, 1, 1, 0, 3000),
(8180001, 2049100, 1, 1, 0, 3000),
(8190000, 4000272, 1, 1, 0, 600000),
(8190000, 2000006, 1, 1, 0, 20000),
(8190000, 2000005, 1, 1, 0, 20000),
(8190000, 2022003, 1, 1, 0, 20000),
(8190000, 2020013, 1, 1, 0, 20000),
(8190000, 4004001, 1, 1, 0, 10000),
(8190000, 4010000, 1, 1, 0, 9000),
(8190000, 4020004, 1, 1, 0, 9000),
(8190000, 4006001, 1, 1, 0, 10000),
(8190000, 4006000, 1, 1, 0, 10000),
(8190000, 1002398, 1, 1, 0, 1500),
(8190000, 1040111, 1, 1, 0, 800),
(8190000, 1060102, 1, 1, 0, 800),
(8190000, 1051092, 1, 1, 0, 700),
(8190000, 1082158, 1, 1, 0, 1000),
(8190000, 1072228, 1, 1, 0, 800),
(8190000, 1332052, 1, 1, 0, 500),
(8190000, 1402016, 1, 1, 0, 700),
(8190000, 2044702, 1, 1, 0, 300),
(8190000, 2040004, 1, 1, 0, 300),
(8190000, 4000244, 1, 1, 0, 2000),
(8190000, 4000245, 1, 1, 0, 2000),
(8190000, 2290030, 1, 1, 0, 500),
(8190000, 2290044, 1, 1, 0, 500),
(8190000, 2290054, 1, 1, 0, 500),
(8190000, 2290066, 1, 1, 0, 500),
(8190000, 2290092, 1, 1, 0, 500),
(8190000, 2290103, 1, 1, 0, 500),
(8190000, 1002646, 1, 1, 0, 1500),
(8190000, 2040419, 1, 1, 0, 300),
(8190000, 2044110, 1, 1, 0, 300),
(8190000, 2049000, 1, 1, 0, 150),
(8190000, 4130004, 1, 1, 0, 6000),
(8190000, 4130006, 1, 1, 0, 6000),
(8190000, 4130008, 1, 1, 0, 6000),
(8190002, 4000271, 1, 1, 0, 600000),
(8190002, 2022003, 1, 1, 0, 20000),
(8190002, 2000006, 1, 1, 0, 20000),
(8190002, 2000005, 1, 1, 0, 20000),
(8190002, 4004003, 1, 1, 0, 10000),
(8190002, 4020007, 1, 1, 0, 9000),
(8190002, 4010005, 1, 1, 0, 9000),
(8190002, 4006001, 1, 1, 0, 10000),
(8190002, 4006000, 1, 1, 0, 10000),
(8190002, 1002406, 1, 1, 0, 1500),
(8190002, 1051101, 1, 1, 0, 700),
(8190002, 1050097, 1, 1, 0, 700),
(8190002, 1082139, 1, 1, 0, 1000),
(8190002, 1072225, 1, 1, 0, 800),
(8190002, 1032023, 1, 1, 0, 1000),
(8190002, 1412021, 1, 1, 0, 700),
(8190002, 1452019, 1, 1, 0, 500),
(8190002, 2043801, 1, 1, 0, 300),
(8190002, 2041023, 1, 1, 0, 300),
(8190002, 2040707, 1, 1, 0, 300),
(8190002, 4130013, 1, 1, 0, 6000),
(8190002, 4000244, 1, 1, 0, 2000),
(8190002, 4000245, 1, 1, 0, 2000),
(8190002, 1082152, 1, 1, 0, 1000),
(8190002, 2290000, 1, 1, 0, 500),
(8190002, 2290008, 1, 1, 0, 500),
(8190002, 2290018, 1, 1, 0, 500),
(8190002, 2290038, 1, 1, 0, 500),
(8190002, 2290060, 1, 1, 0, 500),
(8190002, 2290080, 1, 1, 0, 500),
(8190002, 1492012, 1, 1, 0, 500),
(8190002, 2290124, 1, 1, 0, 500),
(8190002, 1082213, 1, 1, 0, 1000),
(8190002, 2044901, 1, 1, 0, 300),
(8190003, 4000274, 1, 1, 0, 600000),
(8190003, 2022003, 1, 1, 0, 20000),
(8190003, 2000006, 1, 1, 0, 20000),
(8190003, 2000005, 1, 1, 0, 20000),
(8190003, 4004001, 1, 1, 0, 10000),
(8190003, 4010001, 1, 1, 0, 9000),
(8190003, 4020001, 1, 1, 0, 9000),
(8190003, 4006001, 1, 1, 0, 10000),
(8190003, 4006000, 1, 1, 0, 10000),
(8190003, 1002377, 1, 1, 0, 1500),
(8190003, 1050107, 1, 1, 0, 700),
(8190003, 1050103, 1, 1, 0, 700),
(8190003, 1082135, 1, 1, 0, 1000),
(8190003, 1072221, 1, 1, 0, 800),
(8190003, 1032017, 1, 1, 0, 1000),
(8190003, 1422027, 1, 1, 0, 700),
(8190003, 1332051, 1, 1, 0, 500),
(8190003, 2044602, 1, 1, 0, 300),
(8190003, 2043301, 1, 1, 0, 300),
(8190003, 2040805, 1, 1, 0, 300),
(8190003, 4000244, 1, 1, 0, 2000),
(8190003, 4000245, 1, 1, 0, 2000),
(8190003, 1082140, 1, 1, 0, 1000),
(8190003, 2290012, 1, 1, 0, 500),
(8190003, 2290014, 1, 1, 0, 500),
(8190003, 2290050, 1, 1, 0, 500),
(8190003, 2290062, 1, 1, 0, 500),
(8190003, 2290070, 1, 1, 0, 500),
(8190003, 2290086, 1, 1, 0, 500),
(8190003, 1482011, 1, 1, 0, 500),
(8190003, 1072318, 1, 1, 0, 800),
(8190003, 2044902, 1, 1, 0, 300),
(8190003, 2290108, 1, 1, 0, 500),
(8190003, 2040534, 1, 1, 0, 300),
(8190003, 2040627, 1, 1, 0, 300),
(8190003, 2049000, 1, 1, 0, 150),
(8190003, 4130001, 1, 1, 0, 6000),
(8190003, 4130014, 1, 1, 0, 6000),
(8190004, 4000273, 1, 1, 0, 600000),
(8190004, 2022003, 1, 1, 0, 20000),
(8190004, 2000006, 1, 1, 0, 20000),
(8190004, 2000005, 1, 1, 0, 20000),
(8190004, 4004004, 1, 1, 0, 10000),
(8190004, 4020006, 1, 1, 0, 9000),
(8190004, 4020002, 1, 1, 0, 9000),
(8190004, 4006001, 1, 1, 0, 10000),
(8190004, 4006000, 1, 1, 0, 10000),
(8190004, 1002380, 1, 1, 0, 1500),
(8190004, 1051102, 1, 1, 0, 700),
(8190004, 1040121, 1, 1, 0, 800),
(8190004, 1060109, 1, 1, 0, 800),
(8190004, 1082151, 1, 1, 0, 1000),
(8190004, 1072215, 1, 1, 0, 800),
(8190004, 1322045, 1, 1, 0, 700),
(8190004, 1302056, 1, 1, 0, 700),
(8190004, 2041004, 1, 1, 0, 300),
(8190004, 2041013, 1, 1, 0, 300),
(8190004, 2044201, 1, 1, 0, 300),
(8190004, 4000244, 1, 1, 0, 2000),
(8190004, 4000245, 1, 1, 0, 2000),
(8190004, 2290002, 1, 1, 0, 500),
(8190004, 2290009, 1, 1, 0, 500),
(8190004, 2290034, 1, 1, 0, 500),
(8190004, 2290058, 1, 1, 0, 500),
(8190004, 2290068, 1, 1, 0, 500),
(8190004, 2290090, 1, 1, 0, 500),
(8190004, 2290053, 1, 1, 0, 500),
(8190004, 1482012, 1, 1, 0, 500),
(8190004, 2044801, 1, 1, 0, 300),
(8190004, 2290121, 1, 1, 0, 500),
(8190004, 2040326, 1, 1, 0, 300),
(8190004, 2040530, 1, 1, 0, 300),
(8190004, 2040924, 1, 1, 0, 300),
(8190004, 2044214, 1, 1, 0, 300),
(8190004, 4130010, 1, 1, 0, 6000),
(8200000, 4000443, 1, 1, 0, 600000),
(8200000, 1002640, 1, 1, 0, 1500),
(8200000, 1041107, 1, 1, 0, 800),
(8200000, 1040110, 1, 1, 0, 800),
(8200000, 1082112, 1, 1, 0, 1000),
(8200000, 1072179, 1, 1, 0, 800),
(8200000, 1102028, 1, 1, 0, 1000),
(8200000, 1402015, 1, 1, 0, 700),
(8200000, 1452011, 1, 1, 0, 500),
(8200000, 4004002, 1, 1, 0, 10000),
(8200000, 4010000, 1, 1, 0, 9000),
(8200000, 4020000, 1, 1, 0, 9000),
(8200000, 4130000, 1, 1, 0, 6000),
(8200000, 4130013, 1, 1, 0, 6000),
(8200000, 2330004, 1, 1, 0, 500),
(8200000, 2040532, 1, 1, 0, 300),
(8200000, 2044112, 1, 1, 0, 300),
(8200000, 2044807, 1, 1, 0, 300),
(8200001, 4000444, 1, 1, 0, 600000),
(8200001, 4000446, 1, 1, 0, 10000),
(8200001, 2000006, 1, 1, 0, 20000),
(8200001, 2022003, 1, 1, 0, 20000),
(8200001, 4004003, 1, 1, 0, 10000),
(8200001, 4010001, 1, 1, 0, 9000),
(8200001, 4020001, 1, 1, 0, 9000),
(8200001, 1002532, 1, 1, 0, 1500),
(8200001, 1072205, 1, 1, 0, 800),
(8200001, 1082144, 1, 1, 0, 1000),
(8200001, 1052128, 1, 1, 0, 700),
(8200001, 1051097, 1, 1, 0, 700),
(8200001, 1382035, 1, 1, 0, 700),
(8200001, 1402005, 1, 1, 0, 700),
(8200001, 1312015, 1, 1, 0, 700),
(8200001, 4130001, 1, 1, 0, 6000),
(8200001, 4130014, 1, 1, 0, 6000),
(8200001, 2043301, 1, 1, 0, 300),
(8200001, 2040321, 1, 1, 0, 300),
(8200001, 2040029, 1, 1, 0, 300),
(8200001, 2290050, 1, 1, 0, 500),
(8200002, 4000445, 1, 1, 0, 600000),
(8200002, 4000446, 1, 1, 0, 10000),
(8200002, 2000006, 1, 1, 0, 20000),
(8200002, 2022003, 1, 1, 0, 20000),
(8200002, 4004000, 1, 1, 0, 10000),
(8200002, 4010002, 1, 1, 0, 9000),
(8200002, 4020002, 1, 1, 0, 9000),
(8200002, 1040113, 1, 1, 0, 800),
(8200002, 1060102, 1, 1, 0, 800),
(8200002, 1002366, 1, 1, 0, 1500),
(8200002, 1072195, 1, 1, 0, 800),
(8200002, 1082210, 1, 1, 0, 1000),
(8200002, 1051085, 1, 1, 0, 700),
(8200002, 1452017, 1, 1, 0, 500),
(8200002, 1402016, 1, 1, 0, 700),
(8200002, 1442044, 1, 1, 0, 700),
(8200002, 1092027, 1, 1, 0, 700),
(8200002, 4130002, 1, 1, 0, 6000),
(8200002, 4130015, 1, 1, 0, 6000),
(8200002, 2330004, 1, 1, 0, 500),
(8200002, 2040707, 1, 1, 0, 300),
(8200002, 2044212, 1, 1, 0, 300),
(8200002, 2044401, 1, 1, 0, 300),
(8200002, 2290066, 1, 1, 0, 500),
(8200003, 4000447, 1, 1, 0, 600000),
(8200003, 4000459, 1, 1, 0, 20000),
(8200003, 2000006, 1, 1, 0, 20000),
(8200003, 2022003, 1, 1, 0, 20000),
(8200003, 4004001, 1, 1, 0, 10000),
(8200003, 4010006, 1, 1, 0, 9000),
(8200003, 4020006, 1, 1, 0, 9000),
(8200003, 1082130, 1, 1, 0, 1000),
(8200003, 1050095, 1, 1, 0, 700),
(8200003, 1002405, 1, 1, 0, 1500),
(8200003, 1072315, 1, 1, 0, 800),
(8200003, 1041118, 1, 1, 0, 800),
(8200003, 1061117, 1, 1, 0, 800),
(8200003, 1332027, 1, 1, 0, 500),
(8200003, 1482012, 1, 1, 0, 500),
(8200003, 1412010, 1, 1, 0, 700),
(8200003, 4130003, 1, 1, 0, 6000),
(8200003, 4130016, 1, 1, 0, 6000),
(8200003, 2330004, 1, 1, 0, 500),
(8200003, 2044412, 1, 1, 0, 300),
(8200003, 2044702, 1, 1, 0, 300),
(8200003, 2040927, 1, 1, 0, 300),
(8200003, 2290056, 1, 1, 0, 500),
(8200004, 4000448, 1, 1, 0, 600000),
(8200004, 4000459, 1, 1, 0, 20000),
(8200004, 2000006, 1, 1, 0, 20000),
(8200004, 2022003, 1, 1, 0, 20000),
(8200004, 2020015, 1, 1, 0, 20000),
(8200004, 4004001, 1, 1, 0, 10000),
(8200004, 4010001, 1, 1, 0, 9000),
(8200004, 4020008, 1, 1, 0, 9000),
(8200004, 1072198, 1, 1, 0, 800),
(8200004, 1082132, 1, 1, 0, 1000),
(8200004, 1050091, 1, 1, 0, 700),
(8200004, 1002326, 1, 1, 0, 1500),
(8200004, 1041121, 1, 1, 0, 800),
(8200004, 1061120, 1, 1, 0, 800),
(8200004, 1482011, 1, 1, 0, 500),
(8200004, 1302056, 1, 1, 0, 700),
(8200004, 1422013, 1, 1, 0, 700),
(8200004, 1092036, 1, 1, 0, 700),
(8200004, 4130004, 1, 1, 0, 6000),
(8200004, 4130017, 1, 1, 0, 6000),
(8200004, 2040025, 1, 1, 0, 300),
(8200004, 2044312, 1, 1, 0, 300),
(8200004, 2044901, 1, 1, 0, 300),
(8200004, 2290073, 1, 1, 0, 500),
(8200005, 4000449, 1, 1, 0, 600000),
(8200005, 4000451, 1, 1, 0, 10000),
(8200005, 2000006, 1, 1, 0, 20000),
(8200005, 2022003, 1, 1, 0, 20000),
(8200005, 2020013, 1, 1, 0, 20000),
(8200005, 4004000, 1, 1, 0, 10000),
(8200005, 4010004, 1, 1, 0, 9000),
(8200005, 4020001, 1, 1, 0, 9000),
(8200005, 1072207, 1, 1, 0, 800),
(8200005, 1082127, 1, 1, 0, 1000),
(8200005, 1040118, 1, 1, 0, 800),
(8200005, 1060107, 1, 1, 0, 800),
(8200005, 1002643, 1, 1, 0, 1500),
(8200005, 1051103, 1, 1, 0, 700),
(8200005, 1302023, 1, 1, 0, 700),
(8200005, 1322029, 1, 1, 0, 700),
(8200005, 4130005, 1, 1, 0, 6000),
(8200005, 2044012, 1, 1, 0, 300),
(8200005, 2040931, 1, 1, 0, 300),
(8200005, 2290079, 1, 1, 0, 500),
(8200006, 4000450, 1, 1, 0, 600000),
(8200006, 4000451, 1, 1, 0, 10000),
(8200006, 2000006, 1, 1, 0, 20000),
(8200006, 2000005, 1, 1, 0, 20000),
(8200006, 2022003, 1, 1, 0, 20000),
(8200006, 4004003, 1, 1, 0, 10000),
(8200006, 4010003, 1, 1, 0, 9000),
(8200006, 4020003, 1, 1, 0, 9000),
(8200006, 1002378, 1, 1, 0, 1500),
(8200006, 1072227, 1, 1, 0, 800),
(8200006, 1082135, 1, 1, 0, 1000),
(8200006, 1052131, 1, 1, 0, 700),
(8200006, 1051107, 1, 1, 0, 700),
(8200006, 1382035, 1, 1, 0, 700),
(8200006, 1462017, 1, 1, 0, 500),
(8200006, 1412021, 1, 1, 0, 700),
(8200006, 1032023, 1, 1, 0, 1000),
(8200006, 4130006, 1, 1, 0, 6000),
(8200006, 2040317, 1, 1, 0, 300),
(8200006, 2040824, 1, 1, 0, 300),
(8200006, 2290077, 1, 1, 0, 500),
(8200007, 4000452, 1, 1, 0, 600000),
(8200007, 4000459, 1, 1, 0, 20000),
(8200007, 2000006, 1, 1, 0, 20000),
(8200007, 2022003, 1, 1, 0, 20000),
(8200007, 4004002, 1, 1, 0, 10000),
(8200007, 4010004, 1, 1, 0, 9000),
(8200007, 4020004, 1, 1, 0, 9000),
(8200007, 1040121, 1, 1, 0, 800),
(8200007, 1041124, 1, 1, 0, 800),
(8200007, 1002400, 1, 1, 0, 1500),
(8200007, 1072214, 1, 1, 0, 800),
(8200007, 1082213, 1, 1, 0, 1000),
(8200007, 1051091, 1, 1, 0, 700),
(8200007, 1462018, 1, 1, 0, 500),
(8200007, 1332052, 1, 1, 0, 500),
(8200007, 1422027, 1, 1, 0, 700),
(8200007, 4130007, 1, 1, 0, 6000),
(8200007, 2040701, 1, 1, 0, 300),
(8200007, 2044301, 1, 1, 0, 300),
(8200007, 2040302, 1, 1, 0, 300),
(8200007, 2290007, 1, 1, 0, 500),
(8200008, 4000453, 1, 1, 0, 600000),
(8200008, 4000459, 1, 1, 0, 20000),
(8200008, 2000006, 1, 1, 0, 20000),
(8200008, 2022003, 1, 1, 0, 20000),
(8200008, 4004000, 1, 1, 0, 10000),
(8200008, 4010005, 1, 1, 0, 9000),
(8200008, 4020005, 1, 1, 0, 9000),
(8200008, 1082140, 1, 1, 0, 1000),
(8200008, 1050104, 1, 1, 0, 700),
(8200008, 1002407, 1, 1, 0, 1500),
(8200008, 1072318, 1, 1, 0, 800),
(8200008, 1060111, 1, 1, 0, 800),
(8200008, 1061123, 1, 1, 0, 800),
(8200008, 1472033, 1, 1, 0, 500),
(8200008, 1442020, 1, 1, 0, 700),
(8200008, 1472053, 1, 1, 0, 500),
(8200008, 4130008, 1, 1, 0, 6000),
(8200008, 2044101, 1, 1, 0, 300),
(8200008, 2044501, 1, 1, 0, 300),
(8200008, 2290006, 1, 1, 0, 500),
(8200009, 4000454, 1, 1, 0, 600000),
(8200009, 4000456, 1, 1, 0, 10000),
(8200009, 2000006, 1, 1, 0, 20000),
(8200009, 2022003, 1, 1, 0, 20000),
(8200009, 4004001, 1, 1, 0, 10000),
(8200009, 4010000, 1, 1, 0, 9000),
(8200009, 4020007, 1, 1, 0, 9000),
(8200009, 1072221, 1, 1, 0, 800),
(8200009, 1082153, 1, 1, 0, 1000),
(8200009, 1050108, 1, 1, 0, 700),
(8200009, 1002381, 1, 1, 0, 1500),
(8200009, 1492011, 1, 1, 0, 500),
(8200009, 1432011, 1, 1, 0, 500),
(8200009, 1402035, 1, 1, 0, 700),
(8200009, 4130000, 1, 1, 0, 6000),
(8200009, 4130009, 1, 1, 0, 6000),
(8200009, 2044601, 1, 1, 0, 300),
(8200009, 2044001, 1, 1, 0, 300),
(8200009, 2040924, 1, 1, 0, 300),
(8200009, 2290039, 1, 1, 0, 500),
(8200010, 4000455, 1, 1, 0, 600000),
(8200010, 4000456, 1, 1, 0, 10000),
(8200010, 2000006, 1, 1, 0, 20000),
(8200010, 2000005, 1, 1, 0, 20000),
(8200010, 2022003, 1, 1, 0, 20000),
(8200010, 4004003, 1, 1, 0, 10000),
(8200010, 4010002, 1, 1, 0, 9000),
(8200010, 4020000, 1, 1, 0, 9000),
(8200010, 1072225, 1, 1, 0, 800),
(8200010, 1082158, 1, 1, 0, 1000),
(8200010, 1050099, 1, 1, 0, 700),
(8200010, 1002646, 1, 1, 0, 1500),
(8200010, 1432030, 1, 1, 0, 500),
(8200010, 1312030, 1, 1, 0, 700),
(8200010, 4130001, 1, 1, 0, 6000),
(8200010, 4130010, 1, 1, 0, 6000),
(8200010, 2043801, 1, 1, 0, 300),
(8200010, 2041022, 1, 1, 0, 300),
(8200010, 2290089, 1, 1, 0, 500),
(8200011, 4000457, 1, 1, 0, 600000),
(8200011, 4000459, 1, 1, 0, 20000),
(8200011, 2000006, 1, 1, 0, 20000),
(8200011, 2000005, 1, 1, 0, 20000),
(8200011, 2022003, 1, 1, 0, 20000),
(8200011, 4004002, 1, 1, 0, 10000),
(8200011, 4010003, 1, 1, 0, 9000),
(8200011, 4020002, 1, 1, 0, 9000),
(8200011, 1002379, 1, 1, 0, 1500),
(8200011, 1072229, 1, 1, 0, 800),
(8200011, 1082138, 1, 1, 0, 1000),
(8200011, 1052131, 1, 1, 0, 700),
(8200011, 1372010, 1, 1, 0, 700),
(8200011, 1322045, 1, 1, 0, 700),
(8200011, 4130002, 1, 1, 0, 6000),
(8200011, 4130011, 1, 1, 0, 6000),
(8200011, 2044201, 1, 1, 0, 300),
(8200011, 2041008, 1, 1, 0, 300),
(8200011, 2044602, 1, 1, 0, 300),
(8200011, 2290046, 1, 1, 0, 500),
(8200012, 4000458, 1, 1, 0, 600000),
(8200012, 4000459, 1, 1, 0, 20000),
(8200012, 2000006, 1, 1, 0, 20000),
(8200012, 2000005, 1, 1, 0, 20000),
(8200012, 2022003, 1, 1, 0, 20000),
(8200012, 4004002, 1, 1, 0, 10000),
(8200012, 4010000, 1, 1, 0, 9000),
(8200012, 4020000, 1, 1, 0, 9000),
(8200012, 1040122, 1, 1, 0, 800),
(8200012, 1060111, 1, 1, 0, 800),
(8200012, 1002401, 1, 1, 0, 1500),
(8200012, 1072216, 1, 1, 0, 800),
(8200012, 1082213, 1, 1, 0, 1000),
(8200012, 1452021, 1, 1, 0, 500),
(8200012, 1322045, 1, 1, 0, 700),
(8200012, 4130003, 1, 1, 0, 6000),
(8200012, 4130012, 1, 1, 0, 6000),
(8200012, 2040501, 1, 1, 0, 300),
(8200012, 2043701, 1, 1, 0, 300),
(8200012, 2290093, 1, 1, 0, 500),
(8220000, 4000073, 1, 1, 0, 600000),
(8220000, 4000073, 1, 1, 0, 600000),
(8220000, 4000073, 1, 1, 0, 600000),
(8220000, 4000074, 1, 1, 0, 600000),
(8220000, 4000074, 1, 1, 0, 600000),
(8220000, 4000074, 1, 1, 0, 600000),
(8220000, 4000021, 1, 1, 0, 500000),
(8220000, 4000021, 1, 1, 0, 500000),
(8220000, 4000021, 1, 1, 0, 500000),
(8220000, 4006000, 1, 1, 0, 100000),
(8220000, 4004004, 1, 1, 0, 100000),
(8220000, 4010006, 1, 1, 0, 90000),
(8220000, 4020008, 1, 1, 0, 90000),
(8220000, 2000004, 1, 1, 0, 999999),
(8220000, 2000006, 1, 1, 0, 999999),
(8220000, 2002003, 1, 1, 0, 200000),
(8220000, 2012001, 1, 1, 0, 200000),
(8220000, 2040707, 1, 1, 0, 3000),
(8220000, 2041007, 1, 1, 0, 3000),
(8220000, 2043701, 1, 1, 0, 3000),
(8220000, 2044301, 1, 1, 0, 3000),
(8220000, 2041019, 1, 1, 0, 3000),
(8220000, 2044401, 1, 1, 0, 3000),
(8220000, 2040001, 1, 1, 0, 3000),
(8220000, 2040301, 1, 1, 0, 3000),
(8220000, 2040401, 1, 1, 0, 3000),
(8220000, 2043301, 1, 1, 0, 3000),
(8220000, 2044302, 1, 1, 0, 3000),
(8220000, 2041020, 1, 1, 0, 3000),
(8220000, 2044402, 1, 1, 0, 3000),
(8220000, 2040002, 1, 1, 0, 3000),
(8220000, 2040302, 1, 1, 0, 3000),
(8220000, 2060001, 1, 1, 0, 300000),
(8220000, 2061001, 1, 1, 0, 300000),
(8220000, 1002532, 1, 1, 0, 15000),
(8220000, 1002366, 1, 1, 0, 15000),
(8220000, 1002405, 1, 1, 0, 15000),
(8220000, 1002326, 1, 1, 0, 15000),
(8220000, 1040113, 1, 1, 0, 8000),
(8220000, 1041121, 1, 1, 0, 8000),
(8220000, 1050095, 1, 1, 0, 7000),
(8220000, 1051097, 1, 1, 0, 7000),
(8220000, 1050091, 1, 1, 0, 7000),
(8220000, 1051085, 1, 1, 0, 7000),
(8220000, 1040117, 1, 1, 0, 8000),
(8220000, 1041117, 1, 1, 0, 8000),
(8220000, 1082130, 1, 1, 0, 10000),
(8220000, 1082134, 1, 1, 0, 10000),
(8220000, 1082127, 1, 1, 0, 10000),
(8220000, 1082144, 1, 1, 0, 10000),
(8220000, 1072198, 1, 1, 0, 8000),
(8220000, 1072209, 1, 1, 0, 8000),
(8220000, 1072205, 1, 1, 0, 8000),
(8220000, 1072194, 1, 1, 0, 8000),
(8220000, 1002643, 1, 1, 0, 15000),
(8220000, 1052128, 1, 1, 0, 7000),
(8220000, 1082210, 1, 1, 0, 10000),
(8220000, 1072315, 1, 1, 0, 8000),
(8220000, 2043017, 1, 1, 0, 3000),
(8220000, 2044114, 1, 1, 0, 3000),
(8220000, 2044214, 1, 1, 0, 3000),
(8220001, 4000048, 1, 1, 0, 600000),
(8220001, 4000049, 1, 1, 0, 600000),
(8220001, 4000051, 1, 1, 0, 600000),
(8220001, 4000021, 1, 1, 0, 500000),
(8220001, 4004002, 1, 1, 0, 100000),
(8220001, 4010004, 1, 1, 0, 90000),
(8220001, 4020004, 1, 1, 0, 90000),
(8220001, 2000004, 1, 1, 0, 999999),
(8220001, 2000006, 1, 1, 0, 999999),
(8220001, 2022001, 1, 1, 0, 200000),
(8220001, 2022186, 1, 1, 0, 200000),
(8220001, 2043701, 1, 1, 0, 3000),
(8220001, 2041016, 1, 1, 0, 3000),
(8220001, 2043801, 1, 1, 0, 3000),
(8220001, 2040804, 1, 1, 0, 3000),
(8220001, 2040501, 1, 1, 0, 3000),
(8220001, 2040601, 1, 1, 0, 3000),
(8220001, 2040701, 1, 1, 0, 3000),
(8220001, 2040801, 1, 1, 0, 3000),
(8220001, 2040901, 1, 1, 0, 3000),
(8220001, 2041001, 1, 1, 0, 3000),
(8220001, 2041008, 1, 1, 0, 3000),
(8220001, 2043302, 1, 1, 0, 3000),
(8220001, 2043702, 1, 1, 0, 3000),
(8220001, 2041017, 1, 1, 0, 3000),
(8220001, 2043802, 1, 1, 0, 3000),
(8220001, 2060001, 1, 1, 0, 300000),
(8220001, 2061001, 1, 1, 0, 300000),
(8220001, 2070008, 1, 1, 0, 5000),
(8220001, 1302023, 1, 1, 0, 7000),
(8220001, 1312015, 1, 1, 0, 7000),
(8220001, 1322029, 1, 1, 0, 7000),
(8220001, 1332027, 1, 1, 0, 5000),
(8220001, 1382035, 1, 1, 0, 7000),
(8220001, 1402016, 1, 1, 0, 7000),
(8220001, 1412010, 1, 1, 0, 7000),
(8220001, 1422013, 1, 1, 0, 7000),
(8220001, 1432011, 1, 1, 0, 5000),
(8220001, 1442020, 1, 1, 0, 7000),
(8220001, 1452017, 1, 1, 0, 5000),
(8220001, 1462018, 1, 1, 0, 5000),
(8220001, 1472033, 1, 1, 0, 5000),
(8220001, 1032017, 1, 1, 0, 10000),
(8220001, 1092028, 1, 1, 0, 7000),
(8220001, 1482011, 1, 1, 0, 5000),
(8220001, 1492011, 1, 1, 0, 5000),
(8220001, 2044802, 1, 1, 0, 3000),
(8220001, 2040026, 1, 1, 0, 3000),
(8220001, 2040323, 1, 1, 0, 3000),
(8220001, 2040927, 1, 1, 0, 3000),
(8220001, 2044314, 1, 1, 0, 3000),
(8220001, 2049100, 1, 1, 0, 3000),
(8220002, 4000364, 1, 1, 0, 600000),
(8220002, 4000364, 1, 1, 0, 600000),
(8220002, 4000364, 1, 1, 0, 600000),
(8220002, 4000365, 1, 1, 0, 600000),
(8220002, 4000365, 1, 1, 0, 600000),
(8220002, 4000365, 1, 1, 0, 600000),
(8220002, 4000356, 1, 1, 0, 600000),
(8220002, 4000356, 1, 1, 0, 600000),
(8220002, 4000356, 1, 1, 0, 600000),
(8220002, 4004004, 1, 1, 0, 100000),
(8220002, 4010005, 1, 1, 0, 90000),
(8220002, 4020008, 1, 1, 0, 90000),
(8220002, 2000004, 1, 1, 0, 999999),
(8220002, 2000006, 1, 1, 0, 999999),
(8220002, 2040301, 1, 1, 0, 3000),
(8220002, 2040501, 1, 1, 0, 3000),
(8220002, 2040504, 1, 1, 0, 3000),
(8220002, 2040513, 1, 1, 0, 3000),
(8220002, 2040516, 1, 1, 0, 3000),
(8220002, 2041007, 1, 1, 0, 3000),
(8220002, 2041013, 1, 1, 0, 3000),
(8220002, 2041016, 1, 1, 0, 3000),
(8220002, 2041019, 1, 1, 0, 3000),
(8220002, 2041022, 1, 1, 0, 3000),
(8220002, 1372009, 1, 1, 0, 7000),
(8220002, 1302023, 1, 1, 0, 7000),
(8220002, 1312015, 1, 1, 0, 7000),
(8220002, 1322029, 1, 1, 0, 7000),
(8220002, 1402005, 1, 1, 0, 7000),
(8220002, 1402016, 1, 1, 0, 7000),
(8220002, 1412010, 1, 1, 0, 7000),
(8220002, 1422013, 1, 1, 0, 7000),
(8220002, 1432011, 1, 1, 0, 5000),
(8220002, 1442020, 1, 1, 0, 7000),
(8220002, 1452017, 1, 1, 0, 5000),
(8220002, 1462018, 1, 1, 0, 5000),
(8220002, 1332027, 1, 1, 0, 5000),
(8220002, 1472033, 1, 1, 0, 5000),
(8220002, 1332026, 1, 1, 0, 5000),
(8220002, 1482011, 1, 1, 0, 5000),
(8220002, 1492011, 1, 1, 0, 5000),
(8220002, 1382008, 1, 1, 0, 7000),
(8220002, 2070007, 1, 1, 0, 2000),
(8220002, 2330003, 1, 1, 0, 5000),
(8220002, 2040326, 1, 1, 0, 3000),
(8220002, 2040422, 1, 1, 0, 3000),
(8220002, 2040532, 1, 1, 0, 3000),
(8220002, 2040931, 1, 1, 0, 3000),
(8220003, 4000268, 1, 1, 0, 600000),
(8220003, 4000268, 1, 1, 0, 600000),
(8220003, 4000268, 1, 1, 0, 600000),
(8220003, 4000269, 1, 1, 0, 600000),
(8220003, 4000269, 1, 1, 0, 600000),
(8220003, 4000269, 1, 1, 0, 600000),
(8220003, 4000270, 1, 1, 0, 600000),
(8220003, 4000270, 1, 1, 0, 600000),
(8220003, 4000270, 1, 1, 0, 600000),
(8220003, 4006001, 1, 1, 0, 100000),
(8220003, 4006000, 1, 1, 0, 100000),
(8220003, 2000005, 1, 1, 0, 999999),
(8220003, 2000006, 1, 1, 0, 999999),
(8220003, 2020013, 1, 1, 0, 999999),
(8220003, 2290006, 1, 1, 0, 5000),
(8220003, 2290031, 1, 1, 0, 5000),
(8220003, 2290033, 1, 1, 0, 5000),
(8220003, 2290061, 1, 1, 0, 5000),
(8220003, 2290077, 1, 1, 0, 5000),
(8220003, 2290105, 1, 1, 0, 5000),
(8220003, 2290118, 1, 1, 0, 5000),
(8220003, 1382035, 1, 1, 0, 7000),
(8220003, 1372010, 1, 1, 0, 7000),
(8220003, 1302056, 1, 1, 0, 7000),
(8220003, 1312030, 1, 1, 0, 7000),
(8220003, 1322045, 1, 1, 0, 7000),
(8220003, 1402035, 1, 1, 0, 7000),
(8220003, 1412021, 1, 1, 0, 7000),
(8220003, 1422027, 1, 1, 0, 7000),
(8220003, 1432030, 1, 1, 0, 5000),
(8220003, 1442044, 1, 1, 0, 7000),
(8220003, 1452019, 1, 1, 0, 5000),
(8220003, 1462015, 1, 1, 0, 5000),
(8220003, 1332052, 1, 1, 0, 5000),
(8220003, 1472053, 1, 1, 0, 5000),
(8220003, 1332051, 1, 1, 0, 5000),
(8220003, 1482012, 1, 1, 0, 5000),
(8220003, 1492012, 1, 1, 0, 5000),
(8220003, 2040824, 1, 1, 0, 3000),
(8220003, 2044212, 1, 1, 0, 3000),
(8220004, 4000460, 1, 1, 0, 600000),
(8220004, 4006001, 1, 1, 0, 100000),
(8220004, 4006000, 1, 1, 0, 100000),
(8220004, 2000005, 1, 1, 0, 999999),
(8220004, 2000006, 1, 1, 0, 999999),
(8220004, 2020013, 1, 1, 0, 999999),
(8220004, 2290018, 1, 1, 0, 5000),
(8220004, 2290019, 1, 1, 0, 5000),
(8220004, 2290025, 1, 1, 0, 5000),
(8220004, 2290059, 1, 1, 0, 5000),
(8220004, 2290077, 1, 1, 0, 5000),
(8220004, 2290106, 1, 1, 0, 5000),
(8220004, 1082141, 1, 1, 0, 10000),
(8220004, 1050105, 1, 1, 0, 7000),
(8220004, 1002405, 1, 1, 0, 15000),
(8220004, 1072318, 1, 1, 0, 8000),
(8220004, 1051093, 1, 1, 0, 7000),
(8220004, 1332052, 1, 1, 0, 5000),
(8220004, 1322045, 1, 1, 0, 7000),
(8220004, 1372010, 1, 1, 0, 7000),
(8220004, 2049000, 1, 1, 0, 1500),
(8220004, 2330004, 1, 1, 0, 5000),
(8220004, 2040326, 1, 1, 0, 3000),
(8220004, 2040924, 1, 1, 0, 3000),
(8220004, 2040025, 1, 1, 0, 3000),
(8220004, 2040532, 1, 1, 0, 3000),
(8220004, 2040029, 1, 1, 0, 3000),
(8220005, 4000461, 1, 1, 0, 600000),
(8220005, 4006001, 1, 1, 0, 100000),
(8220005, 4006000, 1, 1, 0, 100000),
(8220005, 2000005, 1, 1, 0, 999999),
(8220005, 2000006, 1, 1, 0, 999999),
(8220005, 2020013, 1, 1, 0, 999999),
(8220005, 2290003, 1, 1, 0, 5000),
(8220005, 2290037, 1, 1, 0, 5000),
(8220005, 2290055, 1, 1, 0, 5000),
(8220005, 2290080, 1, 1, 0, 5000),
(8220005, 2290099, 1, 1, 0, 5000),
(8220005, 1072222, 1, 1, 0, 8000),
(8220005, 1082154, 1, 1, 0, 10000),
(8220005, 1050108, 1, 1, 0, 7000),
(8220005, 1002382, 1, 1, 0, 15000),
(8220005, 1051104, 1, 1, 0, 7000),
(8220005, 1482012, 1, 1, 0, 5000),
(8220005, 1402035, 1, 1, 0, 7000),
(8220005, 1452021, 1, 1, 0, 5000),
(8220005, 2049000, 1, 1, 0, 1500),
(8220005, 2040317, 1, 1, 0, 3000),
(8220005, 2040321, 1, 1, 0, 3000),
(8220005, 2040931, 1, 1, 0, 3000),
(8220005, 2040927, 1, 1, 0, 3000),
(8220006, 4000462, 1, 1, 0, 600000),
(8220006, 4006001, 1, 1, 0, 100000),
(8220006, 4006000, 1, 1, 0, 100000),
(8220006, 2000005, 1, 1, 0, 999999),
(8220006, 2000006, 1, 1, 0, 999999),
(8220006, 2020013, 1, 1, 0, 999999),
(8220006, 2290013, 1, 1, 0, 5000),
(8220006, 2290043, 1, 1, 0, 5000),
(8220006, 2290061, 1, 1, 0, 5000),
(8220006, 2290120, 1, 1, 0, 5000),
(8220006, 2290090, 1, 1, 0, 5000),
(8220006, 1072226, 1, 1, 0, 8000),
(8220006, 1082160, 1, 1, 0, 10000),
(8220006, 1050099, 1, 1, 0, 7000),
(8220006, 1002646, 1, 1, 0, 15000),
(8220006, 1051107, 1, 1, 0, 7000),
(8220006, 1432030, 1, 1, 0, 5000),
(8220006, 1462017, 1, 1, 0, 5000),
(8220006, 1472053, 1, 1, 0, 5000),
(8220006, 1492012, 1, 1, 0, 5000),
(8220006, 2049100, 1, 1, 0, 3000),
(8220006, 2043701, 1, 1, 0, 3000),
(8220006, 2044701, 1, 1, 0, 3000),
(8220006, 2044301, 1, 1, 0, 3000),
(8220006, 2044501, 1, 1, 0, 3000),
(8220006, 2044801, 1, 1, 0, 3000),
(8220006, 2044901, 1, 1, 0, 3000),
(8220007, 2000005, 1, 1, 0, 999999),
(8220007, 2000004, 1, 1, 0, 999999),
(8220007, 1032030, 1, 1, 0, 10000),
(8220007, 1382007, 1, 1, 0, 7000),
(8220007, 1322019, 1, 1, 0, 7000),
(8220007, 1312010, 1, 1, 0, 7000),
(8220007, 1412008, 1, 1, 0, 7000),
(8220007, 1432007, 1, 1, 0, 5000),
(8220007, 1302012, 1, 1, 0, 7000),
(8220007, 1332018, 1, 1, 0, 5000),
(8220007, 1332019, 1, 1, 0, 5000),
(8220007, 2043001, 1, 1, 0, 3000),
(8220007, 2043101, 1, 1, 0, 3000),
(8220007, 2043301, 1, 1, 0, 3000),
(8220007, 2043701, 1, 1, 0, 3000),
(8220007, 2044001, 1, 1, 0, 3000),
(8220007, 2044201, 1, 1, 0, 3000),
(8220007, 2044301, 1, 1, 0, 3000),
(8220007, 2044501, 1, 1, 0, 3000),
(8220007, 2044601, 1, 1, 0, 3000),
(8220007, 2044701, 1, 1, 0, 3000),
(8220009, 2000005, 1, 1, 0, 999999),
(8220009, 1452009, 1, 1, 0, 5000),
(8220009, 1382007, 1, 1, 0, 7000),
(8220009, 1462009, 1, 1, 0, 5000),
(8220009, 1322019, 1, 1, 0, 7000),
(8220009, 1312010, 1, 1, 0, 7000),
(8220009, 1412008, 1, 1, 0, 7000),
(8220009, 1422010, 1, 1, 0, 7000),
(8220009, 1472026, 1, 1, 0, 5000),
(8220009, 1432007, 1, 1, 0, 5000),
(8220009, 1442008, 1, 1, 0, 7000),
(8220009, 1302012, 1, 1, 0, 7000),
(8220009, 1402012, 1, 1, 0, 7000),
(8220009, 1332018, 1, 1, 0, 5000),
(8220009, 1332019, 1, 1, 0, 5000),
(8220009, 2043001, 1, 1, 0, 3000),
(8220009, 2043101, 1, 1, 0, 3000),
(8220009, 2043201, 1, 1, 0, 3000),
(8220009, 2043301, 1, 1, 0, 3000),
(8220009, 2043701, 1, 1, 0, 3000),
(8220009, 2043801, 1, 1, 0, 3000),
(8220009, 2044001, 1, 1, 0, 3000),
(8220009, 2044101, 1, 1, 0, 3000),
(8220009, 2044201, 1, 1, 0, 3000),
(8220009, 2044301, 1, 1, 0, 3000),
(8220009, 2044401, 1, 1, 0, 3000),
(8220009, 2044501, 1, 1, 0, 3000),
(8220009, 2044601, 1, 1, 0, 3000),
(8220009, 2044701, 1, 1, 0, 3000),
(8220009, 2000004, 1, 1, 0, 999999),
(8220009, 1092017, 1, 1, 0, 7000),
(8500002, 2020013, 1, 1, 0, 999999),
(8500002, 2020015, 1, 1, 0, 999999),
(8500002, 2000005, 1, 1, 0, 999999),
(8500002, 1312015, 1, 1, 0, 7000),
(8500002, 1332026, 1, 1, 0, 5000),
(8500002, 1332027, 1, 1, 0, 5000),
(8500002, 1462018, 1, 1, 0, 5000),
(8500002, 1372009, 1, 1, 0, 7000),
(8500002, 2041013, 1, 1, 0, 3000),
(8500002, 2041016, 1, 1, 0, 3000),
(8500002, 2041019, 1, 1, 0, 3000),
(8500002, 2041022, 1, 1, 0, 3000),
(8500002, 2290006, 1, 1, 0, 5000),
(8500002, 2290011, 1, 1, 0, 5000),
(8500002, 2290013, 1, 1, 0, 5000),
(8500002, 2290028, 1, 1, 0, 5000),
(8500002, 2290037, 1, 1, 0, 5000),
(8500002, 2290043, 1, 1, 0, 5000),
(8500002, 2290051, 1, 1, 0, 5000),
(8500002, 2290056, 1, 1, 0, 5000),
(8500002, 2290061, 1, 1, 0, 5000),
(8500002, 2290066, 1, 1, 0, 5000),
(8500002, 2290071, 1, 1, 0, 5000),
(8500002, 2290078, 1, 1, 0, 5000),
(8500002, 2290089, 1, 1, 0, 5000),
(8500002, 2290091, 1, 1, 0, 5000),
(8500002, 2000004, 1, 1, 0, 999999),
(8500002, 1072213, 1, 1, 0, 8000),
(8500002, 1072224, 1, 1, 0, 8000),
(8500002, 1072227, 1, 1, 0, 8000),
(8500002, 1072220, 1, 1, 0, 8000),
(8500002, 1040120, 1, 1, 0, 8000),
(8500002, 1060109, 1, 1, 0, 8000),
(8500002, 1041122, 1, 1, 0, 8000),
(8500002, 1061121, 1, 1, 0, 8000),
(8500002, 1050106, 1, 1, 0, 7000),
(8500002, 1051105, 1, 1, 0, 7000),
(8500002, 1050102, 1, 1, 0, 7000),
(8500002, 1051101, 1, 1, 0, 7000),
(8500002, 1050098, 1, 1, 0, 7000),
(8500002, 1051092, 1, 1, 0, 7000),
(8500002, 1002377, 1, 1, 0, 15000),
(8500002, 1082158, 1, 1, 0, 10000),
(8500002, 1072221, 1, 1, 0, 8000),
(8500002, 1482011, 1, 1, 0, 5000),
(8500002, 1002646, 1, 1, 0, 15000),
(8500002, 1052131, 1, 1, 0, 7000),
(8500002, 1082213, 1, 1, 0, 10000),
(8500002, 1072318, 1, 1, 0, 8000),
(8500002, 2290104, 1, 1, 0, 5000),
(8500002, 2290107, 1, 1, 0, 5000),
(8500002, 2290121, 1, 1, 0, 5000),
(8500002, 2290123, 1, 1, 0, 5000),
(8500002, 2040318, 1, 1, 0, 3000),
(8500002, 2040321, 1, 1, 0, 3000),
(8500002, 2040419, 1, 1, 0, 3000),
(8500002, 2040421, 1, 1, 0, 3000),
(8500002, 2044809, 1, 1, 0, 3000),
(8500002, 2049100, 1, 1, 0, 3000),
(8510000, 2020013, 1, 1, 0, 999999),
(8510000, 2020015, 1, 1, 0, 999999),
(8510000, 2000005, 1, 1, 0, 999999),
(8510000, 2000004, 1, 1, 0, 999999),
(8510000, 1302023, 1, 1, 0, 7000),
(8510000, 1322029, 1, 1, 0, 7000),
(8510000, 1402005, 1, 1, 0, 7000),
(8510000, 1412010, 1, 1, 0, 7000),
(8510000, 1040121, 1, 1, 0, 8000),
(8510000, 1060110, 1, 1, 0, 8000),
(8510000, 1050103, 1, 1, 0, 7000),
(8510000, 1051102, 1, 1, 0, 7000),
(8510000, 1050097, 1, 1, 0, 7000),
(8510000, 1051091, 1, 1, 0, 7000),
(8510000, 1041123, 1, 1, 0, 8000),
(8510000, 1061122, 1, 1, 0, 8000),
(8510000, 1050107, 1, 1, 0, 7000),
(8510000, 1051106, 1, 1, 0, 7000),
(8510000, 2040513, 1, 1, 0, 3000),
(8510000, 2040516, 1, 1, 0, 3000),
(8510000, 2040501, 1, 1, 0, 3000),
(8510000, 2040504, 1, 1, 0, 3000),
(8510000, 2040401, 1, 1, 0, 3000),
(8510000, 4001085, 1, 1, 0, 600000),
(8510000, 4000175, 1, 1, 0, 600000),
(8510000, 1492011, 1, 1, 0, 5000),
(8510000, 1052131, 1, 1, 0, 7000),
(8510000, 2290000, 1, 1, 0, 5000),
(8510000, 2290001, 1, 1, 0, 5000),
(8510000, 2290004, 1, 1, 0, 5000),
(8510000, 2290005, 1, 1, 0, 5000),
(8510000, 2290024, 1, 1, 0, 5000),
(8510000, 2290025, 1, 1, 0, 5000),
(8510000, 2290026, 1, 1, 0, 5000),
(8510000, 2290027, 1, 1, 0, 5000),
(8510000, 2290052, 1, 1, 0, 5000),
(8510000, 2290053, 1, 1, 0, 5000),
(8510000, 2290054, 1, 1, 0, 5000),
(8510000, 2290055, 1, 1, 0, 5000),
(8510000, 2290076, 1, 1, 0, 5000),
(8510000, 2290077, 1, 1, 0, 5000),
(8510000, 2290082, 1, 1, 0, 5000),
(8510000, 2290083, 1, 1, 0, 5000),
(8510000, 2290097, 1, 1, 0, 5000),
(8510000, 2290099, 1, 1, 0, 5000),
(8510000, 2290106, 1, 1, 0, 5000),
(8510000, 2290108, 1, 1, 0, 5000),
(8510000, 2290112, 1, 1, 0, 5000),
(8510000, 2290114, 1, 1, 0, 5000),
(8510000, 2290122, 1, 1, 0, 5000),
(8510000, 2290124, 1, 1, 0, 5000),
(8800002, 2020013, 1, 1, 0, 999999),
(8800002, 2020015, 1, 1, 0, 999999),
(8800002, 2000005, 1, 1, 0, 999999),
(8800002, 1002357, 1, 1, 0, 999999),
(8800002, 1002357, 1, 1, 0, 999999),
(8800002, 1002357, 1, 1, 0, 300000),
(8800002, 1002357, 1, 1, 0, 300000),
(8800002, 1002357, 1, 1, 0, 300000),
(8800002, 2280007, 1, 1, 0, 1350000),
(8800002, 2280008, 1, 1, 0, 1350000),
(8800002, 2280009, 1, 1, 0, 1350000),
(8800002, 2280010, 1, 1, 0, 1350000),
(8800002, 2290007, 1, 1, 0, 22500),
(8800002, 2290016, 1, 1, 0, 22500),
(8800002, 2290020, 1, 1, 0, 22500),
(8800002, 2290022, 1, 1, 0, 22500),
(8800002, 2290029, 1, 1, 0, 22500),
(8800002, 2290040, 1, 1, 0, 22500),
(8800002, 2290046, 1, 1, 0, 22500),
(8800002, 2290048, 1, 1, 0, 22500),
(8800002, 2290057, 1, 1, 0, 22500),
(8800002, 2290064, 1, 1, 0, 22500),
(8800002, 2290067, 1, 1, 0, 22500),
(8800002, 2290074, 1, 1, 0, 22500),
(8800002, 2290079, 1, 1, 0, 22500),
(8800002, 2290084, 1, 1, 0, 22500),
(8800002, 2290094, 1, 1, 0, 22500),
(8800002, 1302056, 1, 1, 0, 31500),
(8800002, 1312030, 1, 1, 0, 31500),
(8800002, 1322045, 1, 1, 0, 31500),
(8800002, 1332051, 1, 1, 0, 22500),
(8800002, 1332052, 1, 1, 0, 22500),
(8800002, 1372010, 1, 1, 0, 31500),
(8800002, 1382035, 1, 1, 0, 31500),
(8800002, 1402035, 1, 1, 0, 31500),
(8800002, 1412021, 1, 1, 0, 31500),
(8800002, 1422027, 1, 1, 0, 31500),
(8800002, 1432030, 1, 1, 0, 22500),
(8800002, 1442044, 1, 1, 0, 31500),
(8800002, 1452019, 1, 1, 0, 22500),
(8800002, 1452020, 1, 1, 0, 22500),
(8800002, 1462015, 1, 1, 0, 22500),
(8800002, 1462016, 1, 1, 0, 22500),
(8800002, 1472053, 1, 1, 0, 22500),
(8800002, 2000004, 1, 1, 0, 999999),
(8800002, 1482012, 1, 1, 0, 22500),
(8800002, 1492012, 1, 1, 0, 22500),
(8800002, 2290110, 1, 1, 0, 22500),
(8800002, 2290115, 1, 1, 0, 22500),
(8800002, 2040026, 1, 1, 0, 13500),
(8800002, 2040031, 1, 1, 0, 13500),
(8800002, 2040321, 1, 1, 0, 13500),
(8800002, 2040328, 1, 1, 0, 13500),
(8800002, 2040512, 1, 1, 0, 13500),
(8800002, 2049000, 1, 1, 0, 6750),
(8800002, 2049100, 1, 1, 0, 13500),
(8810018, 2020013, 1, 1, 0, 999999),
(8810018, 2020015, 1, 1, 0, 999999),
(8810018, 2000005, 1, 1, 0, 999999),
(8810018, 2000006, 1, 1, 0, 999999),
(8810018, 2000004, 1, 1, 0, 999999),
(8810018, 1302056, 1, 1, 0, 1512000),
(8810018, 1312030, 1, 1, 0, 1512000),
(8810018, 1322045, 1, 1, 0, 1512000),
(8810018, 1332051, 1, 1, 0, 1080000),
(8810018, 1332052, 1, 1, 0, 1080000),
(8810018, 1372010, 1, 1, 0, 1512000),
(8810018, 1382035, 1, 1, 0, 1512000),
(8810018, 1402035, 1, 1, 0, 1512000),
(8810018, 1412021, 1, 1, 0, 1512000),
(8810018, 1422027, 1, 1, 0, 1512000),
(8810018, 1432030, 1, 1, 0, 1080000),
(8810018, 1442044, 1, 1, 0, 1512000),
(8810018, 1452019, 1, 1, 0, 1080000),
(8810018, 1452020, 1, 1, 0, 1080000),
(8810018, 1452021, 1, 1, 0, 1080000),
(8810018, 1462015, 1, 1, 0, 1080000),
(8810018, 1462016, 1, 1, 0, 1080000),
(8810018, 1462017, 1, 1, 0, 1080000),
(8810018, 1472053, 1, 1, 0, 1080000),
(8810018, 1372032, 1, 1, 0, 1512000),
(8810018, 1302059, 1, 1, 0, 1512000),
(8810018, 1312031, 1, 1, 0, 1512000),
(8810018, 1322052, 1, 1, 0, 1512000),
(8810018, 1332049, 1, 1, 0, 1080000),
(8810018, 1332050, 1, 1, 0, 1080000),
(8810018, 1382036, 1, 1, 0, 1512000),
(8810018, 1402036, 1, 1, 0, 1512000),
(8810018, 1412026, 1, 1, 0, 1512000),
(8810018, 1422028, 1, 1, 0, 1512000),
(8810018, 1432038, 1, 1, 0, 1080000),
(8810018, 1442045, 1, 1, 0, 1512000),
(8810018, 1452044, 1, 1, 0, 1080000),
(8810018, 1462039, 1, 1, 0, 1080000),
(8810018, 1472051, 1, 1, 0, 1080000),
(8810018, 1472052, 1, 1, 0, 1080000),
(8810018, 1122000, 1, 1, 0, 999999),
(8810018, 1122000, 1, 1, 0, 999999),
(8810018, 1122000, 1, 1, 0, 300000),
(8810018, 1122000, 1, 1, 0, 300000),
(8810018, 2290017, 1, 1, 0, 1080000),
(8810018, 2290021, 1, 1, 0, 1080000),
(8810018, 2290023, 1, 1, 0, 1080000),
(8810018, 2290041, 1, 1, 0, 1080000),
(8810018, 2290047, 1, 1, 0, 1080000),
(8810018, 2290049, 1, 1, 0, 1080000),
(8810018, 2290065, 1, 1, 0, 1080000),
(8810018, 2290075, 1, 1, 0, 1080000),
(8810018, 2290085, 1, 1, 0, 1080000),
(8810018, 2290095, 1, 1, 0, 1080000),
(8810018, 2290096, 1, 1, 0, 800000),
(8810018, 1482012, 1, 1, 0, 1080000),
(8810018, 1492012, 1, 1, 0, 1080000),
(8810018, 1482013, 1, 1, 0, 1080000),
(8810018, 1492013, 1, 1, 0, 1080000),
(8810018, 2290111, 1, 1, 0, 1080000),
(8810018, 2290116, 1, 1, 0, 1080000),
(8810018, 2040317, 1, 1, 0, 648000),
(8810018, 2040418, 1, 1, 0, 648000),
(8810018, 2040421, 1, 1, 0, 648000),
(8810018, 2040512, 1, 1, 0, 648000),
(8810018, 2040515, 1, 1, 0, 648000),
(8810018, 2040625, 1, 1, 0, 648000),
(8810018, 2049000, 1, 1, 0, 324000),
(8810018, 2049100, 1, 1, 0, 648000),
(9300003, 1072369, 1, 1, 0, 300000),
(9300012, 4001023, 1, 1, 0, 999999),
(9300028, 4001024, 1, 1, 0, 999999),
(9300039, 4001054, 1, 1, 0, 600000),
(9300119, 2000002, 1, 1, 0, 200000),
(9300119, 2000004, 1, 1, 0, 999999),
(9300119, 2000006, 1, 1, 0, 999999),
(9300119, 2020013, 1, 1, 0, 999999),
(9300119, 2020014, 1, 1, 0, 200000),
(9300119, 2020015, 1, 1, 0, 999999),
(9300119, 2041010, 1, 1, 0, 3000),
(9300119, 2040502, 1, 1, 0, 3000),
(9300119, 2044201, 1, 1, 0, 3000),
(9300119, 2040001, 1, 1, 0, 3000),
(9300119, 2040601, 1, 1, 0, 3000),
(9300119, 2040505, 1, 1, 0, 3000),
(9300119, 2040002, 1, 1, 0, 3000),
(9300119, 2040401, 1, 1, 0, 3000),
(9300119, 2043201, 1, 1, 0, 3000),
(9300119, 2044101, 1, 1, 0, 3000),
(9300119, 2043101, 1, 1, 0, 3000),
(9300119, 2040801, 1, 1, 0, 3000),
(9300139, 2000002, 1, 1, 0, 200000),
(9300139, 2000004, 1, 1, 0, 999999),
(9300139, 2000006, 1, 1, 0, 999999),
(9300139, 2020013, 1, 1, 0, 999999),
(9300139, 2020014, 1, 1, 0, 200000),
(9300139, 2020015, 1, 1, 0, 999999),
(9300139, 2044601, 1, 1, 0, 3000),
(9300139, 2040707, 1, 1, 0, 3000),
(9300139, 2044401, 1, 1, 0, 3000),
(9300139, 2040504, 1, 1, 0, 3000),
(9300139, 2044501, 1, 1, 0, 3000),
(9300139, 2044001, 1, 1, 0, 3000),
(9300139, 2043701, 1, 1, 0, 3000),
(9300139, 2043001, 1, 1, 0, 3000),
(9300139, 2040004, 1, 1, 0, 3000),
(9300139, 2044701, 1, 1, 0, 3000),
(9300139, 2043801, 1, 1, 0, 3000),
(9300139, 2043301, 1, 1, 0, 3000),
(9300182, 4001164, 1, 1, 0, 600000),
(9300182, 2000002, 1, 1, 0, 200000),
(9300182, 2000006, 1, 1, 0, 999999),
(9300182, 2020013, 1, 1, 0, 999999),
(9300182, 2020014, 1, 1, 0, 200000),
(9300182, 2020015, 1, 1, 0, 999999),
(9300182, 2043001, 1, 1, 0, 3000),
(9300182, 2043101, 1, 1, 0, 3000),
(9300182, 2043201, 1, 1, 0, 3000),
(9300182, 2043301, 1, 1, 0, 3000),
(9300182, 2043701, 1, 1, 0, 3000),
(9300182, 2043801, 1, 1, 0, 3000),
(9300182, 2044001, 1, 1, 0, 3000),
(9300182, 2044101, 1, 1, 0, 3000),
(9300182, 2044201, 1, 1, 0, 3000),
(9300182, 2044301, 1, 1, 0, 3000),
(9300182, 2044401, 1, 1, 0, 3000),
(9300182, 2044501, 1, 1, 0, 3000),
(9300182, 2044601, 1, 1, 0, 3000),
(9300182, 2044701, 1, 1, 0, 3000),
(9300182, 2049000, 1, 1, 0, 1500),
(9300215, 2022413, 1, 1, 0, 200000),
(9300215, 2022414, 1, 1, 0, 200000),
(9300215, 2022415, 1, 1, 0, 200000),
(9300215, 2022416, 1, 1, 0, 200000),
(9300215, 2022417, 1, 1, 0, 200000),
(9300215, 2022418, 1, 1, 0, 200000),
(9300215, 2022419, 1, 1, 0, 200000),
(9300215, 2022420, 1, 1, 0, 200000),
(9300215, 2022421, 1, 1, 0, 200000),
(9300274, 4000001, 1, 1, 0, 600000),
(9300274, 2000000, 1, 1, 0, 20000),
(9300274, 2040705, 1, 1, 0, 300),
(9300274, 1072004, 1, 1, 0, 800),
(9300274, 1002043, 1, 1, 0, 1500),
(9300274, 1432000, 1, 1, 0, 500),
(9300274, 1312000, 1, 1, 0, 700),
(9300274, 2060000, 1, 1, 0, 30000),
(9300274, 4010000, 1, 1, 0, 9000),
(9300274, 4020007, 1, 1, 0, 9000),
(9300274, 2061000, 1, 1, 0, 30000),
(9300274, 1082012, 1, 1, 0, 1000),
(9300274, 1072015, 1, 1, 0, 800),
(9300274, 1072031, 1, 1, 0, 800),
(9300274, 4030001, 1, 1, 0, 10000),
(9300274, 1052095, 1, 1, 0, 700),
(9300274, 2330000, 1, 1, 0, 500),
(9500317, 4001141, 1, 1, 0, 600000),
(9500317, 2022279, 1, 1, 0, 200000),
(8830000, 1302112, 1, 1, 0, 7000),
(8830000, 1302113, 1, 1, 0, 7000),
(8830000, 1312042, 1, 1, 0, 7000),
(8830000, 1312043, 1, 1, 0, 7000),
(8830000, 1322068, 1, 1, 0, 7000),
(8830000, 1322069, 1, 1, 0, 7000),
(8830000, 1332084, 1, 1, 0, 5000),
(8830000, 1332085, 1, 1, 0, 5000),
(8830000, 1332086, 1, 1, 0, 5000),
(8830000, 1332087, 1, 1, 0, 5000),
(8830000, 1372050, 1, 1, 0, 7000),
(8830000, 1382066, 1, 1, 0, 7000),
(8830000, 1382067, 1, 1, 0, 7000),
(8830000, 1402056, 1, 1, 0, 7000),
(8830000, 1402057, 1, 1, 0, 7000),
(8830000, 1402058, 1, 1, 0, 7000),
(8830000, 1402059, 1, 1, 0, 7000),
(8830000, 1412038, 1, 1, 0, 7000),
(8830000, 1412039, 1, 1, 0, 7000),
(8830000, 1422042, 1, 1, 0, 7000),
(8830000, 1422043, 1, 1, 0, 7000),
(8830000, 1432054, 1, 1, 0, 5000),
(8830000, 1432055, 1, 1, 0, 5000),
(8830000, 1442074, 1, 1, 0, 7000),
(8830000, 1442075, 1, 1, 0, 7000),
(8830000, 1452066, 1, 1, 0, 5000),
(8830000, 1452067, 1, 1, 0, 5000),
(8830000, 1452068, 1, 1, 0, 5000),
(8830000, 1452069, 1, 1, 0, 5000),
(8830000, 1452070, 1, 1, 0, 5000),
(8830000, 1462059, 1, 1, 0, 5000),
(8830000, 1462060, 1, 1, 0, 5000),
(8830000, 1462061, 1, 1, 0, 5000),
(8830000, 1462062, 1, 1, 0, 5000),
(8830000, 1462063, 1, 1, 0, 5000),
(8830000, 1472083, 1, 1, 0, 5000),
(8830000, 1472084, 1, 1, 0, 5000),
(8830000, 1482031, 1, 1, 0, 5000),
(8830000, 1482032, 1, 1, 0, 5000),
(8830000, 1492035, 1, 1, 0, 5000),
(8830000, 1492036, 1, 1, 0, 5000),
(8830000, 2000004, 1, 1, 0, 999999),
(8830000, 2000005, 1, 1, 0, 999999),
(8830000, 2000006, 1, 1, 0, 999999),
(8830000, 2030000, 1, 1, 0, 200000),
(8830000, 2050004, 1, 1, 0, 500000),
(8830000, 2020001, 1, 1, 0, 200000),
(8830000, 2020000, 1, 1, 0, 200000),
(8830000, 2000002, 1, 1, 0, 200000),
(8830000, 2020005, 1, 1, 0, 200000),
(8830000, 2020003, 1, 1, 0, 200000),
(8830000, 2020009, 1, 1, 0, 200000),
(8830000, 2020006, 1, 1, 0, 200000),
(8830000, 2020007, 1, 1, 0, 200000),
(8830000, 2022000, 1, 1, 0, 200000),
(8830000, 2020010, 1, 1, 0, 200000),
(8830000, 2001000, 1, 1, 0, 200000),
(8830000, 2001002, 1, 1, 0, 200000),
(8830000, 2020012, 1, 1, 0, 200000),
(8830000, 2020013, 1, 1, 0, 999999),
(8830000, 2020014, 1, 1, 0, 200000),
(8830000, 2020015, 1, 1, 0, 999999),
(8830000, 2049100, 1, 1, 0, 3000),
(8830000, 2049000, 1, 1, 0, 1500);
INSERT IGNORE INTO `temp_data` (`dropperid`, `itemid`, `minimum_quantity`, `maximum_quantity`, `questid`, `chance`) VALUES
(8830000, 2040739, 1, 1, 0, 3000),
(8830000, 1072376, 1, 1, 0, 8000),
(8830000, 4001261, 1, 1, 0, 600000),
(8830000, 2330005, 1, 1, 0, 5000),
(8830000, 1382068, 1, 1, 0, 7000),
(8830000, 1402062, 1, 1, 0, 7000),
(8830000, 1472086, 1, 1, 0, 5000),
(8830000, 1442078, 1, 1, 0, 7000),
(8830000, 1452071, 1, 1, 0, 5000),
(8830000, 1492037, 1, 1, 0, 5000),
(100134, 4000497, 1, 1, 0, 600000),
(100134, 2000000, 1, 1, 0, 20000),
(100134, 2010009, 1, 1, 0, 20000),
(100134, 4010002, 1, 1, 0, 9000),
(100134, 4020002, 1, 1, 0, 9000),
(100134, 2040500, 1, 1, 0, 300),
(100134, 2044400, 1, 1, 0, 300),
(100134, 1002042, 1, 1, 0, 1500),
(100134, 1002051, 1, 1, 0, 1500),
(100134, 1032003, 1, 1, 0, 1000),
(100134, 1040009, 1, 1, 0, 800),
(100134, 1060009, 1, 1, 0, 800),
(100134, 1051000, 1, 1, 0, 700),
(100134, 1072050, 1, 1, 0, 800),
(100133, 4000496, 1, 1, 0, 600000),
(100133, 2000000, 1, 1, 0, 20000),
(100133, 2010009, 1, 1, 0, 20000),
(100133, 4010001, 1, 1, 0, 9000),
(100133, 4020003, 1, 1, 0, 9000),
(100133, 2048000, 1, 1, 0, 300),
(100133, 2041004, 1, 1, 0, 300),
(100133, 1002041, 1, 1, 0, 1500),
(100133, 1002007, 1, 1, 0, 1500),
(100133, 1032001, 1, 1, 0, 1000),
(100133, 1040038, 1, 1, 0, 800),
(100133, 1060028, 1, 1, 0, 800),
(100133, 1041064, 1, 1, 0, 800),
(100133, 1061023, 1, 1, 0, 800),
(100133, 1072009, 1, 1, 0, 800),
(100133, 1082000, 1, 1, 0, 1000),
(100133, 1442006, 1, 1, 0, 700),
(100132, 4000495, 1, 1, 0, 600000),
(100132, 2000000, 1, 1, 0, 20000),
(100132, 2010009, 1, 1, 0, 20000),
(100132, 4010000, 1, 1, 0, 9000),
(100132, 4020007, 1, 1, 0, 9000),
(100132, 2040823, 1, 1, 0, 300),
(100132, 2041018, 1, 1, 0, 300),
(100132, 1002001, 1, 1, 0, 1500),
(100132, 1002003, 1, 1, 0, 1500),
(100132, 1040014, 1, 1, 0, 800),
(100132, 1040015, 1, 1, 0, 800),
(100132, 1060008, 1, 1, 0, 800),
(100132, 1041014, 1, 1, 0, 800),
(100132, 1061014, 1, 1, 0, 800),
(100132, 1072004, 1, 1, 0, 800),
(100132, 1082003, 1, 1, 0, 1000),
(100132, 1442000, 1, 1, 0, 700),
(100131, 4000494, 1, 1, 0, 600000),
(100131, 2000000, 1, 1, 0, 20000),
(100131, 2010009, 1, 1, 0, 20000),
(100131, 4010006, 1, 1, 0, 9000),
(100131, 4020006, 1, 1, 0, 9000),
(100131, 2040400, 1, 1, 0, 300),
(100131, 2040618, 1, 1, 0, 300),
(100131, 1002019, 1, 1, 0, 1500),
(100131, 1002002, 1, 1, 0, 1500),
(100131, 1040013, 1, 1, 0, 800),
(100131, 1041012, 1, 1, 0, 800),
(100131, 1060004, 1, 1, 0, 800),
(100131, 1072005, 1, 1, 0, 800),
(100130, 4000493, 1, 1, 0, 600000),
(100130, 2010000, 1, 1, 0, 20000),
(100130, 2010009, 1, 1, 0, 20000),
(100130, 4010005, 1, 1, 0, 9000),
(100130, 4020005, 1, 1, 0, 9000),
(100130, 2040003, 1, 1, 0, 300),
(100130, 1002008, 1, 1, 0, 1500),
(100130, 1040010, 1, 1, 0, 800),
(100130, 1041004, 1, 1, 0, 800),
(100130, 1060007, 1, 1, 0, 800),
(1110130, 4000012, 1, 1, 0, 600000),
(1110130, 2000000, 1, 1, 0, 20000),
(1110130, 2043102, 1, 1, 0, 300),
(1110130, 2000003, 1, 1, 0, 20000),
(1110130, 4020003, 1, 1, 0, 9000),
(1110130, 1322000, 1, 1, 0, 700),
(1110130, 2060000, 1, 1, 0, 30000),
(1110130, 1041044, 1, 1, 0, 800),
(1110130, 1061037, 1, 1, 0, 800),
(1110130, 4010004, 1, 1, 0, 9000),
(1110130, 1092008, 1, 1, 0, 700),
(1110130, 1041017, 1, 1, 0, 800),
(1110130, 1061012, 1, 1, 0, 800),
(1110130, 1462002, 1, 1, 0, 500),
(1110130, 2061000, 1, 1, 0, 30000),
(1110130, 1041063, 1, 1, 0, 800),
(1110130, 1061059, 1, 1, 0, 800),
(1110130, 1452003, 1, 1, 0, 500),
(1110130, 2048000, 1, 1, 0, 300),
(1110130, 1002033, 1, 1, 0, 1500),
(1110130, 1302007, 1, 1, 0, 700),
(1110130, 4020002, 1, 1, 0, 9000),
(1110130, 1032001, 1, 1, 0, 1000),
(1110130, 1002010, 1, 1, 0, 1500),
(1110130, 2000001, 1, 1, 0, 20000),
(1110130, 1002143, 1, 1, 0, 1500),
(1110130, 1432005, 1, 1, 0, 500),
(1110130, 1412012, 1, 1, 0, 700),
(1110130, 1072285, 1, 1, 0, 800),
(1110130, 1482001, 1, 1, 0, 500),
(1140130, 2000000, 1, 1, 0, 20000),
(1140130, 2000003, 1, 1, 0, 20000),
(1140130, 4000195, 1, 1, 0, 600000),
(1140130, 2060000, 1, 1, 0, 30000),
(1140130, 2061000, 1, 1, 0, 30000),
(1140130, 4010000, 1, 1, 0, 9000),
(1140130, 4020007, 1, 1, 0, 9000),
(1140130, 4010004, 1, 1, 0, 9000),
(1140130, 2040501, 1, 1, 0, 300),
(1140130, 2040801, 1, 1, 0, 300),
(1140130, 1041062, 1, 1, 0, 800),
(1140130, 1061058, 1, 1, 0, 800),
(1140130, 1050010, 1, 1, 0, 700),
(1140130, 2048001, 1, 1, 0, 300),
(1140130, 1041029, 1, 1, 0, 800),
(1140130, 1061027, 1, 1, 0, 800),
(1140130, 1072046, 1, 1, 0, 800),
(1140130, 1072066, 1, 1, 0, 800),
(1140130, 1082018, 1, 1, 0, 1000),
(1140130, 1002107, 1, 1, 0, 1500),
(1140130, 1002113, 1, 1, 0, 1500),
(1140130, 1050003, 1, 1, 0, 700),
(1140130, 1412012, 1, 1, 0, 700),
(1140130, 1082180, 1, 1, 0, 1000),
(1140130, 2044802, 1, 1, 0, 300),
(2230131, 4000008, 1, 1, 0, 600000),
(2230131, 2000001, 1, 1, 0, 20000),
(2230131, 2002000, 1, 1, 0, 20000),
(2230131, 2044302, 1, 1, 0, 300),
(2230131, 1032000, 1, 1, 0, 1000),
(2230131, 1032004, 1, 1, 0, 1000),
(2230131, 1452001, 1, 1, 0, 500),
(2230131, 1412002, 1, 1, 0, 700),
(2230131, 2060000, 1, 1, 0, 30000),
(2230131, 4010002, 1, 1, 0, 9000),
(2230131, 4020003, 1, 1, 0, 9000),
(2230131, 1002158, 1, 1, 0, 1500),
(2230131, 2000003, 1, 1, 0, 20000),
(2230131, 1040048, 1, 1, 0, 800),
(2230131, 2061000, 1, 1, 0, 30000),
(2230131, 1060038, 1, 1, 0, 800),
(2230131, 1372003, 1, 1, 0, 700),
(2230131, 1060018, 1, 1, 0, 800),
(2230131, 1040026, 1, 1, 0, 800),
(2230131, 1040009, 1, 1, 0, 800),
(2230131, 4010003, 1, 1, 0, 9000),
(2230131, 2000002, 1, 1, 0, 20000),
(2230131, 1050030, 1, 1, 0, 700),
(2230131, 1050031, 1, 1, 0, 700),
(2230131, 1432003, 1, 1, 0, 500),
(2230131, 1002035, 1, 1, 0, 1500),
(2230131, 1312007, 1, 1, 0, 700),
(2230131, 1040021, 1, 1, 0, 800),
(2230131, 1082183, 1, 1, 0, 1000),
(2230131, 1492003, 1, 1, 0, 500),
(2230131, 2049100, 1, 1, 0, 300),
(3300000, 2000003, 1, 1, 0, 20000),
(3300000, 2060000, 1, 1, 0, 30000),
(3300000, 2061000, 1, 1, 0, 30000),
(3300000, 2000002, 1, 1, 0, 20000),
(3300000, 4010005, 1, 1, 0, 9000),
(3300000, 4020000, 1, 1, 0, 9000),
(3300000, 2044701, 1, 1, 0, 300),
(3300000, 1332020, 1, 1, 0, 500),
(3300000, 1040000, 1, 1, 0, 800),
(3300000, 1060075, 1, 1, 0, 800),
(3300000, 1402010, 1, 1, 0, 700),
(3300000, 1032007, 1, 1, 0, 1000),
(3300000, 1072078, 1, 1, 0, 800),
(3300000, 1082046, 1, 1, 0, 1000),
(3300000, 1002156, 1, 1, 0, 1500),
(3300000, 1002622, 1, 1, 0, 1500),
(3300000, 4130005, 1, 1, 0, 6000),
(3300000, 4130009, 1, 1, 0, 6000),
(3300000, 4130021, 1, 1, 0, 6000),
(3300000, 4000499, 1, 1, 0, 600000),
(3300000, 2043216, 1, 1, 0, 300),
(3300000, 2043311, 1, 1, 0, 300),
(3300000, 2382092, 1, 1, 0, 20000),
(3300003, 4131008, 1, 1, 0, 6000),
(3300003, 2060000, 1, 1, 0, 30000),
(3300003, 2061000, 1, 1, 0, 30000),
(3300003, 4020000, 1, 1, 0, 9000),
(3300003, 4020001, 1, 1, 0, 9000),
(3300003, 2000002, 1, 1, 0, 20000),
(3300003, 2000003, 1, 1, 0, 20000),
(3300003, 1041042, 1, 1, 0, 800),
(3300003, 1061035, 1, 1, 0, 800),
(3300003, 1002023, 1, 1, 0, 1500),
(3300003, 1002163, 1, 1, 0, 1500),
(3300003, 1032010, 1, 1, 0, 1000),
(3300003, 1040062, 1, 1, 0, 800),
(3300003, 1060051, 1, 1, 0, 800),
(3300003, 1051015, 1, 1, 0, 700),
(3300003, 1302004, 1, 1, 0, 700),
(3300003, 1332014, 1, 1, 0, 500),
(3300003, 1072119, 1, 1, 0, 800),
(3300003, 1072110, 1, 1, 0, 800),
(3300003, 1082063, 1, 1, 0, 1000),
(3300003, 1002625, 1, 1, 0, 1500),
(3300003, 2330001, 1, 1, 0, 500),
(3300003, 4130000, 1, 1, 0, 6000),
(3300003, 4130014, 1, 1, 0, 6000),
(3300003, 4130017, 1, 1, 0, 6000),
(3300003, 4000502, 1, 1, 0, 600000),
(3300003, 2044416, 1, 1, 0, 300),
(3300003, 2043711, 1, 1, 0, 300),
(3300003, 2382095, 1, 1, 0, 20000),
(3300002, 4131003, 1, 1, 0, 6000),
(3300002, 2060000, 1, 1, 0, 30000),
(3300002, 2061000, 1, 1, 0, 30000),
(3300002, 4010001, 1, 1, 0, 9000),
(3300002, 4020000, 1, 1, 0, 9000),
(3300002, 4004001, 1, 1, 0, 10000),
(3300002, 2000002, 1, 1, 0, 20000),
(3300002, 2000003, 1, 1, 0, 20000),
(3300002, 2040701, 1, 1, 0, 300),
(3300002, 1462000, 1, 1, 0, 500),
(3300002, 1322014, 1, 1, 0, 700),
(3300002, 1050030, 1, 1, 0, 700),
(3300002, 1040058, 1, 1, 0, 800),
(3300002, 1060044, 1, 1, 0, 800),
(3300002, 1041058, 1, 1, 0, 800),
(3300002, 1061054, 1, 1, 0, 800),
(3300002, 1072101, 1, 1, 0, 800),
(3300002, 1002013, 1, 1, 0, 1500),
(3300002, 1052107, 1, 1, 0, 700),
(3300002, 4000501, 1, 1, 0, 600000),
(3300002, 2044216, 1, 1, 0, 300),
(3300002, 2044316, 1, 1, 0, 300),
(3300002, 2382094, 1, 1, 0, 20000),
(3300001, 2000003, 1, 1, 0, 20000),
(3300001, 2060000, 1, 1, 0, 30000),
(3300001, 2061000, 1, 1, 0, 30000),
(3300001, 2000002, 1, 1, 0, 20000),
(3300001, 4010005, 1, 1, 0, 9000),
(3300001, 4020000, 1, 1, 0, 9000),
(3300001, 2044701, 1, 1, 0, 300),
(3300001, 1332020, 1, 1, 0, 500),
(3300001, 1040000, 1, 1, 0, 800),
(3300001, 1060075, 1, 1, 0, 800),
(3300001, 1402010, 1, 1, 0, 700),
(3300001, 1032007, 1, 1, 0, 1000),
(3300001, 1072078, 1, 1, 0, 800),
(3300001, 1082046, 1, 1, 0, 1000),
(3300001, 1002156, 1, 1, 0, 1500),
(3300001, 4010007, 1, 1, 0, 9000),
(3300001, 1002622, 1, 1, 0, 1500),
(3300001, 4130005, 1, 1, 0, 6000),
(3300001, 4130009, 1, 1, 0, 6000),
(3300001, 4130021, 1, 1, 0, 6000),
(3300001, 4000500, 1, 1, 0, 600000),
(3300001, 4000507, 1, 1, 0, 100000),
(3300001, 2044024, 1, 1, 0, 300),
(3300001, 2044116, 1, 1, 0, 300),
(3300001, 2382093, 1, 1, 0, 20000),
(3300004, 4131008, 1, 1, 0, 6000),
(3300004, 2060000, 1, 1, 0, 30000),
(3300004, 2061000, 1, 1, 0, 30000),
(3300004, 4020000, 1, 1, 0, 9000),
(3300004, 4020001, 1, 1, 0, 9000),
(3300004, 2000002, 1, 1, 0, 20000),
(3300004, 2000003, 1, 1, 0, 20000),
(3300004, 1041042, 1, 1, 0, 800),
(3300004, 1061035, 1, 1, 0, 800),
(3300004, 1002023, 1, 1, 0, 1500),
(3300004, 1002163, 1, 1, 0, 1500),
(3300004, 1032010, 1, 1, 0, 1000),
(3300004, 1040062, 1, 1, 0, 800),
(3300004, 1060051, 1, 1, 0, 800),
(3300004, 1051015, 1, 1, 0, 700),
(3300004, 1302004, 1, 1, 0, 700),
(3300004, 1332014, 1, 1, 0, 500),
(3300004, 1072119, 1, 1, 0, 800),
(3300004, 1072110, 1, 1, 0, 800),
(3300004, 1082063, 1, 1, 0, 1000),
(3300004, 1002625, 1, 1, 0, 1500),
(3300004, 2330001, 1, 1, 0, 500),
(3300004, 4130000, 1, 1, 0, 6000),
(3300004, 4130014, 1, 1, 0, 6000),
(3300004, 4130017, 1, 1, 0, 6000),
(3300004, 4000503, 1, 1, 0, 600000),
(3300004, 2044611, 1, 1, 0, 300),
(3300004, 2044711, 1, 1, 0, 300),
(3300004, 2044816, 1, 1, 0, 300),
(3300004, 2382096, 1, 1, 0, 20000),
(3300005, 2022570, 1, 1, 0, 20000),
(3300005, 2022571, 1, 1, 0, 20000),
(3300005, 2022572, 1, 1, 0, 20000),
(3300005, 2022573, 1, 1, 0, 20000),
(3300005, 2022574, 1, 1, 0, 20000),
(3300005, 2000001, 1, 1, 0, 20000),
(3300005, 2000003, 1, 1, 0, 20000),
(3300005, 2040004, 1, 1, 0, 300),
(3300005, 2040501, 1, 1, 0, 300),
(3300005, 2040504, 1, 1, 0, 300),
(3300005, 2040801, 1, 1, 0, 300),
(3300005, 2041007, 1, 1, 0, 300),
(3300005, 2041004, 1, 1, 0, 300),
(3300005, 2043801, 1, 1, 0, 300),
(3300005, 2044001, 1, 1, 0, 300),
(3300005, 2044201, 1, 1, 0, 300),
(3300005, 2044601, 1, 1, 0, 300),
(3300005, 2044801, 1, 1, 0, 300),
(3300005, 1082073, 1, 1, 0, 1000),
(3300005, 1082025, 1, 1, 0, 1000),
(3300005, 1082064, 1, 1, 0, 1000),
(3300005, 1082074, 1, 1, 0, 1000),
(3300005, 1082195, 1, 1, 0, 1000),
(3300005, 1032013, 1, 1, 0, 1000),
(3300005, 4000504, 1, 1, 0, 600000),
(3300005, 2043216, 1, 1, 0, 300),
(3300005, 2043311, 1, 1, 0, 300),
(3300005, 2044024, 1, 1, 0, 300),
(3300005, 2044116, 1, 1, 0, 300),
(3300005, 2044216, 1, 1, 0, 300),
(3300005, 2044316, 1, 1, 0, 300),
(3300005, 2044416, 1, 1, 0, 300),
(3300005, 2043711, 1, 1, 0, 300),
(3300005, 2043811, 1, 1, 0, 300),
(3300005, 2044511, 1, 1, 0, 300),
(3300005, 2044611, 1, 1, 0, 300),
(3300005, 2044711, 1, 1, 0, 300),
(3300005, 2044816, 1, 1, 0, 300),
(3300005, 2388067, 1, 1, 0, 20000),
(3300006, 2022575, 1, 1, 0, 20000),
(3300006, 2022576, 1, 1, 0, 20000),
(3300006, 2022577, 1, 1, 0, 20000),
(3300006, 2022578, 1, 1, 0, 20000),
(3300006, 2022579, 1, 1, 0, 20000),
(3300006, 2000001, 1, 1, 0, 20000),
(3300006, 2000003, 1, 1, 0, 20000),
(3300006, 2040701, 1, 1, 0, 300),
(3300006, 2040801, 1, 1, 0, 300),
(3300006, 2040901, 1, 1, 0, 300),
(3300006, 2041001, 1, 1, 0, 300),
(3300006, 2043001, 1, 1, 0, 300),
(3300006, 2043101, 1, 1, 0, 300),
(3300006, 2041010, 1, 1, 0, 300),
(3300006, 2043201, 1, 1, 0, 300),
(3300006, 2041004, 1, 1, 0, 300),
(3300006, 2060000, 1, 1, 0, 30000),
(3300006, 2061000, 1, 1, 0, 30000),
(3300006, 2041017, 1, 1, 0, 300),
(3300006, 2040402, 1, 1, 0, 300),
(3300006, 2044002, 1, 1, 0, 300),
(3300006, 2040502, 1, 1, 0, 300),
(3300006, 2040602, 1, 1, 0, 300),
(3300006, 2041016, 1, 1, 0, 300),
(3300006, 2070009, 1, 1, 0, 500),
(3300006, 1002098, 1, 1, 0, 1500),
(3300006, 1002154, 1, 1, 0, 1500),
(3300006, 1002170, 1, 1, 0, 1500),
(3300006, 1002185, 1, 1, 0, 1500),
(3300006, 1040085, 1, 1, 0, 800),
(3300006, 1041086, 1, 1, 0, 800),
(3300006, 1050039, 1, 1, 0, 700),
(3300006, 1051026, 1, 1, 0, 700),
(3300006, 1040080, 1, 1, 0, 800),
(3300006, 1041083, 1, 1, 0, 800),
(3300006, 1040084, 1, 1, 0, 800),
(3300006, 1041076, 1, 1, 0, 800),
(3300006, 1082025, 1, 1, 0, 1000),
(3300006, 1082064, 1, 1, 0, 1000),
(3300006, 1082073, 1, 1, 0, 1000),
(3300006, 1082074, 1, 1, 0, 1000),
(3300006, 1072126, 1, 1, 0, 800),
(3300006, 1072117, 1, 1, 0, 800),
(3300006, 1072118, 1, 1, 0, 800),
(3300006, 1072107, 1, 1, 0, 800),
(3300006, 1002628, 1, 1, 0, 1500),
(3300006, 1052113, 1, 1, 0, 700),
(3300006, 1082195, 1, 1, 0, 1000),
(3300006, 1072300, 1, 1, 0, 800),
(3300006, 2044112, 1, 1, 0, 300),
(3300006, 2044412, 1, 1, 0, 300),
(3300006, 4000506, 1, 1, 0, 600000),
(3300006, 2043216, 1, 1, 0, 300),
(3300006, 2043311, 1, 1, 0, 300),
(3300006, 2044024, 1, 1, 0, 300),
(3300006, 2044116, 1, 1, 0, 300),
(3300006, 2044216, 1, 1, 0, 300),
(3300006, 2044316, 1, 1, 0, 300),
(3300006, 2044416, 1, 1, 0, 300),
(3300006, 2043711, 1, 1, 0, 300),
(3300006, 2043811, 1, 1, 0, 300),
(3300006, 2044511, 1, 1, 0, 300),
(3300006, 2044611, 1, 1, 0, 300),
(3300006, 2044711, 1, 1, 0, 300),
(3300006, 2044816, 1, 1, 0, 300),
(3300006, 2388068, 1, 1, 0, 20000),
(3300007, 2022580, 1, 1, 0, 20000),
(3300007, 2022581, 1, 1, 0, 20000),
(3300007, 2022582, 1, 1, 0, 20000),
(3300007, 2022583, 1, 1, 0, 20000),
(3300007, 2022584, 1, 1, 0, 20000),
(3300007, 4010000, 1, 1, 0, 9000),
(3300007, 4020000, 1, 1, 0, 9000),
(3300007, 2000000, 1, 1, 0, 20000),
(3300007, 2010009, 1, 1, 0, 20000),
(3300007, 2020014, 1, 1, 0, 20000),
(3300007, 2040001, 1, 1, 0, 300),
(3300007, 2040301, 1, 1, 0, 300),
(3300007, 2040401, 1, 1, 0, 300),
(3300007, 2043201, 1, 1, 0, 300),
(3300007, 2043701, 1, 1, 0, 300),
(3300007, 2041016, 1, 1, 0, 300),
(3300007, 2043801, 1, 1, 0, 300),
(3300007, 2044001, 1, 1, 0, 300),
(3300007, 2040501, 1, 1, 0, 300),
(3300007, 2040601, 1, 1, 0, 300),
(3300007, 2060000, 1, 1, 0, 30000),
(3300007, 2061000, 1, 1, 0, 30000),
(3300007, 2070000, 1, 1, 0, 500),
(3300007, 1002049, 1, 1, 0, 1500),
(3300007, 1002073, 1, 1, 0, 1500),
(3300007, 1002159, 1, 1, 0, 1500),
(3300007, 1002150, 1, 1, 0, 1500),
(3300007, 1040041, 1, 1, 0, 800),
(3300007, 1041024, 1, 1, 0, 800),
(3300007, 1050025, 1, 1, 0, 700),
(3300007, 1051005, 1, 1, 0, 700),
(3300007, 1040023, 1, 1, 0, 800),
(3300007, 1041033, 1, 1, 0, 800),
(3300007, 1040050, 1, 1, 0, 800),
(3300007, 1041060, 1, 1, 0, 800),
(3300007, 1082001, 1, 1, 0, 1000),
(3300007, 1082028, 1, 1, 0, 1000),
(3300007, 1082018, 1, 1, 0, 1000),
(3300007, 1082039, 1, 1, 0, 1000),
(3300007, 1072052, 1, 1, 0, 800),
(3300007, 1072074, 1, 1, 0, 800),
(3300007, 1072069, 1, 1, 0, 800),
(3300007, 1072087, 1, 1, 0, 800),
(3300007, 2040002, 1, 1, 0, 300),
(3300007, 2040302, 1, 1, 0, 300),
(3300007, 2040402, 1, 1, 0, 300),
(3300007, 2043302, 1, 1, 0, 300),
(3300007, 2043702, 1, 1, 0, 300),
(3300007, 1002619, 1, 1, 0, 1500),
(3300007, 1052104, 1, 1, 0, 700),
(3300007, 1082186, 1, 1, 0, 1000),
(3300007, 1072291, 1, 1, 0, 800),
(3300007, 2330000, 1, 1, 0, 500),
(3300007, 2044801, 1, 1, 0, 300),
(3300007, 2044902, 1, 1, 0, 300),
(3300007, 2040418, 1, 1, 0, 300),
(3300007, 2040928, 1, 1, 0, 300),
(3300007, 2043114, 1, 1, 0, 300),
(3300007, 2044414, 1, 1, 0, 300),
(3300007, 4000505, 1, 1, 0, 600000),
(3300007, 2043216, 1, 1, 0, 300),
(3300007, 2043311, 1, 1, 0, 300),
(3300007, 2044024, 1, 1, 0, 300),
(3300007, 2044116, 1, 1, 0, 300),
(3300007, 2044216, 1, 1, 0, 300),
(3300007, 2044316, 1, 1, 0, 300),
(3300007, 2044416, 1, 1, 0, 300),
(3300007, 2043711, 1, 1, 0, 300),
(3300007, 2043811, 1, 1, 0, 300),
(3300007, 2044511, 1, 1, 0, 300),
(3300007, 2044611, 1, 1, 0, 300),
(3300007, 2044711, 1, 1, 0, 300),
(3300007, 2044816, 1, 1, 0, 300),
(3300007, 2388069, 1, 1, 0, 20000),
(3300008, 4001318, 1, 1, 0, 600000),
(3300008, 4010005, 1, 1, 0, 90000),
(3300008, 4020005, 1, 1, 0, 90000),
(3300008, 2000002, 1, 1, 0, 200000),
(3300008, 2000003, 1, 1, 0, 200000),
(3300008, 2002002, 1, 1, 0, 200000),
(3300008, 2002003, 1, 1, 0, 200000),
(3300008, 2040301, 1, 1, 0, 3000),
(3300008, 2040504, 1, 1, 0, 3000),
(3300008, 2040707, 1, 1, 0, 3000),
(3300008, 2040801, 1, 1, 0, 3000),
(3300008, 2040901, 1, 1, 0, 3000),
(3300008, 2041016, 1, 1, 0, 3000),
(3300008, 2043801, 1, 1, 0, 3000),
(3300008, 2044101, 1, 1, 0, 3000),
(3300008, 2044601, 1, 1, 0, 3000),
(3300008, 2044701, 1, 1, 0, 3000),
(3300008, 2040514, 1, 1, 0, 3000),
(3300008, 2041002, 1, 1, 0, 3000),
(3300008, 2041017, 1, 1, 0, 3000),
(3300008, 2043702, 1, 1, 0, 3000),
(3300008, 2044302, 1, 1, 0, 3000),
(3300008, 2060000, 1, 1, 0, 300000),
(3300008, 2061000, 1, 1, 0, 300000),
(3300008, 1302010, 1, 1, 0, 7000),
(3300008, 1312008, 1, 1, 0, 7000),
(3300008, 1322017, 1, 1, 0, 7000),
(3300008, 1332003, 1, 1, 0, 5000),
(3300008, 1372007, 1, 1, 0, 7000),
(3300008, 1382006, 1, 1, 0, 7000),
(3300008, 1402003, 1, 1, 0, 7000),
(3300008, 1412003, 1, 1, 0, 7000),
(3300008, 1422005, 1, 1, 0, 7000),
(3300008, 1432004, 1, 1, 0, 5000),
(3300008, 1442005, 1, 1, 0, 7000),
(3300008, 1452008, 1, 1, 0, 5000),
(3300008, 1462007, 1, 1, 0, 5000),
(3300008, 1472021, 1, 1, 0, 5000),
(3300008, 1482007, 1, 1, 0, 5000),
(3300008, 1492007, 1, 1, 0, 5000),
(3300008, 2044802, 1, 1, 0, 3000),
(3300008, 2044901, 1, 1, 0, 3000),
(3300008, 2040931, 1, 1, 0, 3000),
(3300008, 2040928, 1, 1, 0, 3000),
(3300008, 2043216, 1, 1, 0, 3000),
(3300008, 2043311, 1, 1, 0, 3000),
(3300008, 2044024, 1, 1, 0, 3000),
(3300008, 2044116, 1, 1, 0, 3000),
(3300008, 2044216, 1, 1, 0, 3000),
(3300008, 2044316, 1, 1, 0, 3000),
(3300008, 2044416, 1, 1, 0, 3000),
(3300008, 2043711, 1, 1, 0, 3000),
(3300008, 2043811, 1, 1, 0, 3000),
(3300008, 2044511, 1, 1, 0, 3000),
(3300008, 2044611, 1, 1, 0, 3000),
(3300008, 2044711, 1, 1, 0, 3000),
(3300008, 2044816, 1, 1, 0, 3000),
(100100, 2380000, 1, 1, 0, 1000),
(100101, 2380001, 1, 1, 0, 1000),
(130100, 2380003, 1, 1, 0, 1000),
(130101, 2380004, 1, 1, 0, 1000),
(210100, 2380005, 1, 1, 0, 1000),
(1210100, 2380006, 1, 1, 0, 1000),
(1210102, 2380007, 1, 1, 0, 1000),
(1110101, 2380008, 1, 1, 0, 1000),
(1210101, 2380009, 1, 1, 0, 1000),
(1120100, 2380010, 1, 1, 0, 1000),
(1110100, 2380011, 1, 1, 0, 1000),
(1210103, 2380012, 1, 1, 0, 1000),
(1130100, 2381000, 1, 1, 0, 1000),
(1140100, 2381001, 1, 1, 0, 1000),
(2220100, 2381002, 1, 1, 0, 1000),
(2300100, 2381003, 1, 1, 0, 1000),
(2130103, 2381006, 1, 1, 0, 1000),
(2110200, 2381007, 1, 1, 0, 1000),
(2130100, 2381008, 1, 1, 0, 1000),
(2230108, 2381009, 1, 1, 0, 1000),
(2100102, 2381010, 1, 1, 0, 1000),
(2230103, 2381011, 1, 1, 0, 1000),
(5200000, 2381012, 1, 1, 0, 1000),
(2230105, 2381013, 1, 1, 0, 1000),
(2230110, 2381014, 1, 1, 0, 1000),
(2100105, 2381015, 1, 1, 0, 1000),
(2230101, 2381016, 1, 1, 0, 1000),
(2230107, 2381017, 1, 1, 0, 1000),
(2230111, 2381018, 1, 1, 0, 1000),
(2100106, 2381019, 1, 1, 0, 1000),
(2110300, 2381020, 1, 1, 0, 1000),
(2230106, 2381021, 1, 1, 0, 1000),
(2230102, 2381022, 1, 1, 0, 1000),
(2100103, 2381023, 1, 1, 0, 1000),
(2230100, 2381024, 1, 1, 0, 1000),
(2100107, 2381025, 1, 1, 0, 1000),
(2230109, 2381026, 1, 1, 0, 1000),
(2230104, 2381027, 1, 1, 0, 1000),
(2100104, 2381028, 1, 1, 0, 1000),
(2230200, 2381029, 1, 1, 0, 1000),
(2110301, 2381031, 1, 1, 0, 1000),
(3000000, 2381032, 1, 1, 0, 1000),
(3000005, 2381034, 1, 1, 0, 1000),
(3000006, 2381035, 1, 1, 0, 1000),
(3100102, 2381036, 1, 1, 0, 1000),
(5200001, 2381037, 1, 1, 0, 1000),
(5200002, 2381038, 1, 1, 0, 1000),
(3230307, 2382000, 1, 1, 0, 1000),
(3110100, 2382002, 1, 1, 0, 1000),
(3110101, 2382004, 1, 1, 0, 1000),
(3110102, 2382005, 1, 1, 0, 1000),
(5300000, 2382006, 1, 1, 0, 1000),
(3230104, 2382007, 1, 1, 0, 1000),
(3110300, 2382009, 1, 1, 0, 1000),
(3210200, 2382011, 1, 1, 0, 1000),
(3210201, 2382012, 1, 1, 0, 1000),
(3210202, 2382013, 1, 1, 0, 1000),
(5300001, 2382014, 1, 1, 0, 1000),
(3210204, 2382015, 1, 1, 0, 1000),
(3210205, 2382016, 1, 1, 0, 1000),
(3210207, 2382017, 1, 1, 0, 1000),
(3230100, 2382018, 1, 1, 0, 1000),
(3230101, 2382019, 1, 1, 0, 1000),
(3230200, 2382020, 1, 1, 0, 1000),
(3230302, 2382022, 1, 1, 0, 1000),
(5400000, 2382023, 1, 1, 0, 1000),
(3110302, 2382024, 1, 1, 0, 1000),
(3210203, 2382025, 1, 1, 0, 1000),
(3210206, 2382026, 1, 1, 0, 1000),
(3210450, 2382027, 1, 1, 0, 1000),
(3210208, 2382028, 1, 1, 0, 1000),
(3210800, 2382029, 1, 1, 0, 1000),
(3230102, 2382030, 1, 1, 0, 1000),
(3230303, 2382031, 1, 1, 0, 1000),
(3230306, 2382032, 1, 1, 0, 1000),
(3230103, 2382033, 1, 1, 0, 1000),
(3230304, 2382034, 1, 1, 0, 1000),
(3230405, 2382035, 1, 1, 0, 1000),
(3110303, 2382036, 1, 1, 0, 1000),
(3230308, 2382037, 1, 1, 0, 1000),
(3230305, 2382038, 1, 1, 0, 1000),
(4230100, 2382039, 1, 1, 0, 1000),
(4230101, 2382040, 1, 1, 0, 1000),
(4230113, 2382041, 1, 1, 0, 1000),
(4230200, 2382043, 1, 1, 0, 1000),
(4230201, 2382044, 1, 1, 0, 1000),
(4230500, 2382045, 1, 1, 0, 1000),
(4230107, 2382047, 1, 1, 0, 1000),
(4230111, 2382048, 1, 1, 0, 1000),
(4230114, 2382049, 1, 1, 0, 1000),
(4230119, 2382050, 1, 1, 0, 1000),
(4230501, 2382051, 1, 1, 0, 1000),
(4230105, 2382052, 1, 1, 0, 1000),
(4230103, 2382053, 1, 1, 0, 1000),
(4230109, 2382054, 1, 1, 0, 1000),
(4230124, 2382056, 1, 1, 0, 1000),
(4110300, 2382057, 1, 1, 0, 1000),
(4230108, 2382058, 1, 1, 0, 1000),
(4230123, 2382059, 1, 1, 0, 1000),
(4230502, 2382060, 1, 1, 0, 1000),
(4230120, 2382061, 1, 1, 0, 1000),
(4230112, 2382062, 1, 1, 0, 1000),
(4230125, 2382063, 1, 1, 0, 1000),
(4230106, 2382064, 1, 1, 0, 1000),
(4130100, 2382065, 1, 1, 0, 1000),
(4230110, 2382066, 1, 1, 0, 1000),
(4230300, 2382068, 1, 1, 0, 1000),
(4230400, 2382069, 1, 1, 0, 1000),
(4230503, 2382070, 1, 1, 0, 1000),
(4230504, 2382071, 1, 1, 0, 1000),
(4110301, 2382072, 1, 1, 0, 1000),
(4250000, 2382076, 1, 1, 0, 1000),
(4230121, 2383000, 1, 1, 0, 1000),
(4130101, 2383001, 1, 1, 0, 1000),
(4230115, 2383002, 1, 1, 0, 1000),
(4130102, 2383003, 1, 1, 0, 1000),
(4130103, 2383004, 1, 1, 0, 25000),
(4230505, 2383006, 1, 1, 0, 1000),
(9300255, 2383007, 1, 1, 0, 1000),
(4230102, 2383008, 1, 1, 0, 1000),
(4230104, 2383009, 1, 1, 0, 1000),
(4230506, 2383010, 1, 1, 0, 1000),
(5130100, 2383012, 1, 1, 0, 1000),
(5100000, 2383013, 1, 1, 0, 1000),
(5100003, 2383014, 1, 1, 0, 1000),
(5120503, 2383015, 1, 1, 0, 1000),
(9300144, 2383016, 1, 1, 0, 1000),
(5100002, 2383017, 1, 1, 0, 1000),
(5120504, 2383018, 1, 1, 0, 1000),
(5130103, 2383019, 1, 1, 0, 1000),
(5120001, 2383021, 1, 1, 0, 1000),
(5120002, 2383022, 1, 1, 0, 1000),
(5120003, 2383023, 1, 1, 0, 1000),
(5100005, 2383024, 1, 1, 0, 1000),
(5120501, 2383025, 1, 1, 0, 1000),
(5120100, 2383026, 1, 1, 0, 25000),
(5120502, 2383027, 1, 1, 0, 1000),
(9300149, 2383028, 1, 1, 0, 1000),
(5300100, 2383029, 1, 1, 0, 1000),
(5130101, 2383030, 1, 1, 0, 1000),
(5130104, 2383031, 1, 1, 0, 1000),
(5120506, 2383032, 1, 1, 0, 1000),
(5130105, 2383033, 1, 1, 0, 1000),
(5120500, 2383035, 1, 1, 0, 1000),
(5150001, 2383036, 1, 1, 0, 1000),
(5130107, 2383037, 1, 1, 0, 1000),
(5130108, 2383038, 1, 1, 0, 1000),
(5130102, 2383039, 1, 1, 0, 1000),
(5140000, 2383040, 1, 1, 0, 1000),
(5120505, 2383041, 1, 1, 0, 1000),
(5110302, 2383042, 1, 1, 0, 1000),
(5150000, 2383043, 1, 1, 0, 1000),
(6130100, 2383044, 1, 1, 0, 1000),
(6130103, 2383045, 1, 1, 0, 1000),
(6130202, 2383046, 1, 1, 0, 20000),
(6130203, 2383047, 1, 1, 0, 1000),
(5090000, 2383048, 1, 1, 0, 25000),
(5090001, 2383049, 1, 1, 0, 25000),
(4250001, 2383056, 1, 1, 0, 1000),
(5250000, 2383057, 1, 1, 0, 1000),
(5250002, 2383058, 1, 1, 0, 1000),
(5250001, 2383059, 1, 1, 0, 1000),
(6130200, 2384000, 1, 1, 0, 1000),
(9400201, 2384001, 1, 1, 0, 1000),
(6130207, 2384002, 1, 1, 0, 1000),
(6230602, 2384003, 1, 1, 0, 1000),
(6230400, 2384004, 1, 1, 0, 1000),
(6230600, 2384006, 1, 1, 0, 1000),
(6230200, 2384007, 1, 1, 0, 1000),
(6130204, 2384008, 1, 1, 0, 1000),
(6300000, 2384009, 1, 1, 0, 1000),
(6090000, 2384010, 1, 1, 0, 25000),
(6110300, 2384011, 1, 1, 0, 1000),
(6230300, 2384012, 1, 1, 0, 1000),
(6130209, 2384013, 1, 1, 0, 1000),
(6230500, 2384014, 1, 1, 0, 1000),
(6230601, 2384015, 1, 1, 0, 1000),
(6400000, 2384016, 1, 1, 0, 1000),
(6130208, 2384017, 1, 1, 0, 1000),
(9300146, 2384018, 1, 1, 0, 1000),
(8140200, 2384019, 1, 1, 0, 1000),
(7130100, 2384020, 1, 1, 0, 1000),
(7130400, 2384021, 1, 1, 0, 25000),
(7130401, 2384022, 1, 1, 0, 25000),
(7130402, 2384023, 1, 1, 0, 25000),
(7130500, 2384024, 1, 1, 0, 1000),
(7130104, 2384025, 1, 1, 0, 1000),
(7130001, 2384026, 1, 1, 0, 1000),
(7130002, 2384027, 1, 1, 0, 1000),
(7130600, 2384028, 1, 1, 0, 1000),
(7130103, 2384029, 1, 1, 0, 1000),
(6300100, 2384032, 1, 1, 0, 1000),
(7130501, 2384033, 1, 1, 0, 1000),
(7130200, 2384035, 1, 1, 0, 1000),
(7130101, 2384036, 1, 1, 0, 1000),
(6090001, 2384037, 1, 1, 0, 25000),
(7090000, 2384038, 1, 1, 0, 25000),
(6090003, 2384039, 1, 1, 0, 25000),
(6090004, 2384040, 1, 1, 0, 25000),
(8140300, 2385000, 1, 1, 0, 1000),
(7130003, 2385001, 1, 1, 0, 1000),
(7130601, 2385002, 1, 1, 0, 1000),
(6400100, 2385003, 1, 1, 0, 1000),
(7130102, 2385004, 1, 1, 0, 1000),
(7130004, 2385005, 1, 1, 0, 1000),
(8140000, 2385006, 1, 1, 0, 1000),
(8140001, 2385007, 1, 1, 0, 1000),
(8110300, 2385008, 1, 1, 0, 1000),
(8140100, 2385009, 1, 1, 0, 1000),
(8140002, 2385011, 1, 1, 0, 1000),
(7130010, 2385012, 1, 1, 0, 1000),
(7130020, 2385013, 1, 1, 0, 1000),
(8140110, 2385014, 1, 1, 0, 1000),
(8140101, 2385016, 1, 1, 0, 1000),
(8140102, 2385017, 1, 1, 0, 1000),
(8140103, 2385018, 1, 1, 0, 1000),
(8140111, 2385019, 1, 1, 0, 1000),
(7130300, 2385020, 1, 1, 0, 1000),
(8140500, 2385021, 1, 1, 0, 1000),
(8140700, 2385022, 1, 1, 0, 1000),
(8090000, 2385023, 1, 1, 0, 25000),
(8200000, 2385025, 1, 1, 0, 1000),
(8140600, 2386000, 1, 1, 0, 1000),
(8140701, 2386001, 1, 1, 0, 1000),
(9300324, 2386002, 1, 1, 0, 25000),
(8141300, 2386003, 1, 1, 0, 1000),
(8142000, 2386004, 1, 1, 0, 1000),
(8140702, 2386005, 1, 1, 0, 1000),
(8140703, 2386006, 1, 1, 0, 1000),
(8142100, 2386007, 1, 1, 0, 1000),
(8150300, 2386008, 1, 1, 0, 1000),
(9500136, 2386009, 1, 1, 0, 1000),
(9500137, 2386010, 1, 1, 0, 1000),
(8150200, 2386011, 1, 1, 0, 1000),
(8150100, 2386012, 1, 1, 0, 1000),
(8150301, 2386013, 1, 1, 0, 1000),
(8150101, 2386014, 1, 1, 0, 1000),
(8150302, 2386015, 1, 1, 0, 1000),
(8150201, 2386016, 1, 1, 0, 1000),
(8190000, 2386017, 1, 1, 0, 1000),
(8200001, 2386021, 1, 1, 0, 1000),
(8200002, 2386022, 1, 1, 0, 1000),
(8200003, 2386023, 1, 1, 0, 1000),
(8200004, 2386024, 1, 1, 0, 1000),
(8160000, 2387000, 1, 1, 0, 1000),
(8170000, 2387001, 1, 1, 0, 1000),
(8190003, 2387002, 1, 1, 0, 1000),
(8190004, 2387003, 1, 1, 0, 1000),
(8190002, 2387004, 1, 1, 0, 1000),
(8200005, 2387006, 1, 1, 0, 1000),
(8200006, 2387007, 1, 1, 0, 1000),
(8200007, 2387008, 1, 1, 0, 1000),
(8200008, 2387009, 1, 1, 0, 1000),
(8200009, 2387010, 1, 1, 0, 1000),
(8200010, 2387011, 1, 1, 0, 1000),
(8200011, 2387012, 1, 1, 0, 1000),
(8200012, 2387013, 1, 1, 0, 1000),
(9300184, 2388000, 1, 1, 0, 25000),
(9300003, 2388001, 1, 1, 0, 1000),
(5220002, 2388002, 1, 1, 0, 25000),
(5220000, 2388003, 1, 1, 0, 25000),
(9300012, 2388004, 1, 1, 0, 25000),
(5220003, 2388005, 1, 1, 0, 25000),
(6130101, 2388006, 1, 1, 0, 25000),
(6220000, 2388007, 1, 1, 0, 25000),
(6300005, 2388008, 1, 1, 0, 25000),
(7220001, 2388009, 1, 1, 0, 25000),
(7220000, 2388010, 1, 1, 0, 25000),
(9300119, 2388011, 1, 1, 0, 25000),
(9300039, 2388012, 1, 1, 0, 25000),
(7220002, 2388013, 1, 1, 0, 25000),
(9300139, 2388014, 1, 1, 0, 25000),
(8220001, 2388016, 1, 1, 0, 25000),
(8150000, 2388017, 1, 1, 0, 25000),
(8180000, 2388018, 1, 1, 0, 25000),
(8180001, 2388019, 1, 1, 0, 25000),
(8510000, 2388020, 1, 1, 0, 25000),
(9300028, 2388021, 1, 1, 0, 25000),
(8500002, 2388022, 1, 1, 0, 25000),
(3220000, 2388025, 1, 1, 0, 25000),
(8130100, 2388026, 1, 1, 0, 25000),
(9500317, 2388028, 1, 1, 0, 25000),
(3220001, 2388029, 1, 1, 0, 25000),
(4220000, 2388030, 1, 1, 0, 25000),
(6220001, 2388031, 1, 1, 0, 25000),
(8220003, 2388033, 1, 1, 0, 25000),
(8220004, 2388040, 1, 1, 0, 25000),
(8220005, 2388041, 1, 1, 0, 25000),
(8220006, 2388042, 1, 1, 0, 25000),
(8820000, 2388043, 1, 1, 0, 25000),
(9300274, 2380013, 1, 1, 0, 1000),
(8830000, 2388055, 1, 1, 0, 25000),
(1110130, 2380014, 1, 1, 0, 1000),
(100130, 2380015, 1, 1, 0, 1000),
(100131, 2380016, 1, 1, 0, 1000),
(100132, 2380017, 1, 1, 0, 1000),
(100133, 2380018, 1, 1, 0, 1000),
(100134, 2380019, 1, 1, 0, 1000),
(2230131, 2381083, 1, 1, 0, 1000),
(3300001, 2382093, 1, 1, 0, 1000),
(3300002, 2382094, 1, 1, 0, 1000),
(3300003, 2382095, 1, 1, 0, 1000),
(3300004, 2382096, 1, 1, 0, 1000),
(5220004, 2388052, 1, 1, 0, 25000),
(8220007, 2388053, 1, 1, 0, 25000),
(8220009, 2388054, 1, 1, 0, 25000),
(3300006, 2388068, 1, 1, 0, 1000),
(3300007, 2388069, 1, 1, 0, 1000),
(8170000, 0, 664, 996, 0, 400000),
(8160000, 0, 664, 996, 0, 400000),
(8141000, 0, 625, 926, 0, 400000),
(8142000, 0, 622, 948, 0, 400000),
(8142100, 0, 638, 944, 0, 400000),
(9420516, 0, 638, 944, 0, 400000),
(9420515, 0, 600, 900, 0, 400000),
(8141100, 0, 646, 959, 0, 400000),
(8143000, 0, 416, 623, 0, 400000),
(9400013, 0, 697, 1020, 0, 400000),
(6400000, 0, 333, 493, 0, 400000),
(6230200, 0, 325, 486, 0, 400000),
(7140000, 0, 361, 540, 0, 400000),
(7130010, 0, 364, 545, 0, 400000),
(7160000, 0, 400, 600, 0, 400000),
(7130300, 0, 408, 610, 0, 400000),
(8140500, 0, 640, 960, 0, 400000),
(7130001, 0, 344, 516, 0, 400000),
(7130600, 0, 347, 515, 0, 400000),
(6300100, 0, 320, 480, 0, 400000),
(7130501, 0, 352, 528, 0, 400000),
(7130101, 0, 409, 599, 0, 400000),
(7130200, 0, 417, 548, 0, 400000),
(8140300, 0, 468, 960, 0, 400000),
(6400100, 0, 334, 497, 0, 400000),
(6300000, 0, 417, 548, 0, 400000),
(8130100, 0, 1621, 2387, 0, 400000),
(6130200, 0, 312, 468, 0, 400000),
(9400201, 0, 320, 463, 0, 400000),
(6230400, 0, 328, 492, 0, 400000),
(6230602, 0, 328, 492, 0, 400000),
(6230600, 0, 324, 486, 0, 400000),
(5100000, 0, 330, 490, 0, 400000),
(6230300, 0, 320, 480, 0, 400000),
(6230500, 0, 332, 498, 0, 400000),
(6230601, 0, 332, 498, 0, 400000),
(7130100, 0, 340, 500, 0, 400000),
(8140200, 0, 336, 509, 0, 400000),
(5100002, 0, 212, 381, 0, 400000),
(5120504, 0, 208, 312, 0, 400000),
(5130103, 0, 224, 336, 0, 400000),
(5120000, 0, 224, 336, 0, 400000),
(5120001, 0, 235, 348, 0, 400000),
(5120002, 0, 235, 348, 0, 400000),
(5120003, 0, 235, 348, 0, 400000),
(5100005, 0, 232, 348, 0, 400000),
(5120100, 0, 324, 486, 0, 400000),
(5130101, 0, 256, 348, 0, 400000),
(5130104, 0, 254, 386, 0, 400000),
(5300100, 0, 251, 359, 0, 400000),
(9400204, 0, 200, 305, 0, 400000),
(5100004, 0, 268, 402, 0, 400000),
(5130107, 0, 273, 408, 0, 400000),
(5150001, 0, 272, 408, 0, 400000),
(5140000, 0, 280, 420, 0, 400000),
(5130102, 0, 280, 420, 0, 400000),
(5150000, 0, 296, 447, 0, 400000),
(9400003, 0, 280, 420, 0, 400000),
(6130100, 0, 304, 456, 0, 400000),
(6130101, 0, 800, 1196, 0, 400000),
(6130202, 0, 304, 456, 0, 400000),
(100100, 0, 4, 6, 0, 400000),
(100101, 0, 8, 12, 0, 400000),
(120100, 0, 8, 12, 0, 400000),
(130100, 0, 12, 18, 0, 400000),
(130101, 0, 12, 18, 0, 400000),
(210100, 0, 12, 18, 0, 400000),
(1210100, 0, 14, 21, 0, 400000),
(1210102, 0, 16, 24, 0, 400000),
(1210101, 0, 20, 30, 0, 400000),
(1110101, 0, 20, 30, 0, 400000),
(1120100, 0, 24, 36, 0, 400000),
(1210103, 0, 24, 36, 0, 400000),
(1110100, 0, 28, 42, 0, 400000),
(1130100, 0, 32, 48, 0, 400000),
(1140100, 0, 34, 47, 0, 400000),
(2220100, 0, 36, 54, 0, 400000),
(2300100, 0, 32, 48, 0, 400000),
(2130103, 0, 33, 49, 0, 400000),
(2110200, 0, 36, 54, 0, 400000),
(2130100, 0, 40, 60, 0, 400000),
(2230108, 0, 40, 60, 0, 400000),
(9600002, 0, 43, 65, 0, 400000),
(2100102, 0, 40, 60, 0, 400000),
(5200000, 0, 60, 90, 0, 400000),
(2230103, 0, 47, 62, 0, 400000),
(2070010, 0, 44, 66, 0, 400000),
(2100105, 0, 44, 63, 0, 400000),
(2230101, 0, 44, 66, 0, 400000),
(2230102, 0, 44, 66, 0, 400000),
(9400000, 0, 40, 60, 0, 400000),
(7130500, 0, 337, 501, 0, 400000),
(2230100, 0, 48, 72, 0, 400000),
(2230106, 0, 44, 66, 0, 400000),
(9600003, 0, 58, 81, 0, 400000),
(2100103, 0, 49, 66, 0, 400000),
(2230104, 0, 56, 78, 0, 400000),
(2230109, 0, 52, 78, 0, 400000),
(2100104, 0, 52, 77, 0, 400000),
(2230200, 0, 52, 78, 0, 400000),
(3000002, 0, 80, 120, 0, 400000),
(9400010, 0, 52, 78, 0, 400000),
(5200001, 0, 64, 96, 0, 400000),
(5200002, 0, 64, 96, 0, 400000),
(3000000, 0, 52, 78, 0, 400000),
(9400002, 0, 52, 78, 0, 400000),
(3230400, 0, 97, 139, 0, 400000),
(3000006, 0, 56, 84, 0, 400000),
(9600004, 0, 64, 99, 0, 400000),
(3230307, 0, 100, 144, 0, 400000),
(3110300, 0, 70, 114, 0, 400000),
(3110100, 0, 74, 144, 0, 400000),
(3210100, 0, 76, 114, 0, 400000),
(3110102, 0, 80, 120, 0, 400000),
(3110101, 0, 80, 120, 0, 400000),
(3230104, 0, 56, 84, 0, 400000),
(5300000, 0, 68, 102, 0, 400000),
(5300001, 0, 72, 108, 0, 400000),
(3210200, 0, 80, 120, 0, 400000),
(3210201, 0, 80, 120, 0, 400000),
(3210202, 0, 80, 120, 0, 400000),
(9600006, 0, 83, 116, 0, 400000),
(9400509, 0, 232, 348, 0, 400000),
(3210205, 0, 84, 126, 0, 400000),
(3210204, 0, 84, 126, 0, 400000),
(3210207, 0, 84, 126, 0, 400000),
(3230100, 0, 60, 90, 0, 400000),
(3230101, 0, 56, 84, 0, 400000),
(3230200, 0, 56, 84, 0, 400000),
(3230300, 0, 94, 144, 0, 400000),
(5400000, 0, 76, 114, 0, 400000),
(3230302, 0, 76, 114, 0, 400000),
(9600005, 0, 93, 138, 0, 400000),
(3210206, 0, 76, 114, 0, 400000),
(3210203, 0, 76, 114, 0, 400000),
(3210208, 0, 76, 114, 0, 400000),
(3210450, 0, 75, 114, 0, 400000),
(3230405, 0, 96, 114, 0, 400000),
(3230102, 0, 92, 138, 0, 400000),
(3210800, 0, 88, 132, 0, 400000),
(3230303, 0, 96, 144, 0, 400000),
(3230306, 0, 96, 144, 0, 400000),
(9600008, 0, 43, 60, 0, 400000),
(3230103, 0, 96, 144, 0, 400000),
(3230304, 0, 96, 144, 0, 400000),
(9600007, 0, 136, 162, 0, 400000),
(3230308, 0, 96, 144, 0, 400000),
(3230305, 0, 96, 144, 0, 400000),
(4230100, 0, 96, 144, 0, 400000),
(4230101, 0, 104, 156, 0, 400000),
(4230113, 0, 108, 162, 0, 400000),
(4230200, 0, 104, 156, 0, 400000),
(4230201, 0, 108, 162, 0, 400000),
(4230116, 0, 108, 162, 0, 400000),
(9400011, 0, 95, 135, 0, 400000),
(4230500, 0, 96, 144, 0, 400000),
(4230107, 0, 112, 168, 0, 400000),
(4230111, 0, 116, 174, 0, 400000),
(4230114, 0, 117, 174, 0, 400000),
(4230119, 0, 116, 174, 0, 400000),
(4230501, 0, 128, 192, 0, 400000),
(4230105, 0, 120, 180, 0, 400000),
(4230103, 0, 120, 180, 0, 400000),
(4230109, 0, 123, 190, 0, 400000),
(4230124, 0, 120, 180, 0, 400000),
(4230117, 0, 128, 192, 0, 400000),
(4230108, 0, 132, 198, 0, 400000),
(4230123, 0, 132, 198, 0, 400000),
(4230112, 0, 140, 210, 0, 400000),
(4230120, 0, 140, 210, 0, 400000),
(4230106, 0, 114, 216, 0, 400000),
(4130100, 0, 160, 240, 0, 400000),
(4230110, 0, 164, 246, 0, 400000),
(4000077, 0, 148, 222, 0, 400000),
(4230118, 0, 164, 246, 0, 400000),
(4230300, 0, 160, 240, 0, 400000),
(4130101, 0, 168, 252, 0, 400000),
(4230115, 0, 172, 258, 0, 400000),
(4230121, 0, 164, 246, 0, 400000),
(4130102, 0, 172, 258, 0, 400000),
(4230126, 0, 172, 258, 0, 400000),
(9400101, 0, 88, 132, 0, 400000),
(4230505, 0, 177, 258, 0, 400000),
(4230506, 0, 180, 268, 0, 400000),
(4230102, 0, 176, 246, 0, 400000),
(4230104, 0, 176, 246, 0, 400000),
(5130100, 0, 200, 300, 0, 400000),
(5100003, 0, 200, 300, 0, 400000),
(5120503, 0, 208, 312, 0, 400000),
(5110301, 0, 240, 360, 0, 400000),
(5110302, 0, 288, 432, 0, 400000),
(9400121, 0, 1000, 5000, 0, 400000),
(9400112, 0, 10000, 20000, 0, 400000),
(9400112, 0, 10000, 20000, 0, 400000),
(9400113, 0, 20000, 50000, 0, 400000),
(9400113, 0, 20000, 50000, 0, 400000),
(9400300, 0, 20000, 30000, 0, 400000),
(9400300, 0, 20000, 30000, 0, 400000),
(9400300, 0, 20000, 30000, 0, 400000),
(9410009, 0, 50, 90, 0, 400000),
(9410011, 0, 50, 90, 0, 400000),
(9420540, 0, 500, 700, 0, 400000),
(9400014, 0, 1000, 5000, 0, 400000),
(8180001, 0, 3000, 6000, 0, 400000),
(8180000, 0, 3000, 6000, 0, 400000),
(8140102, 0, 500, 800, 0, 400000),
(8140103, 0, 500, 800, 0, 400000),
(8140101, 0, 500, 800, 0, 400000),
(8140700, 0, 500, 800, 0, 400000),
(8140701, 0, 600, 900, 0, 400000),
(8190003, 0, 697, 1020, 0, 400000),
(8190004, 0, 750, 1150, 0, 400000),
(8190005, 0, 800, 1200, 0, 400000),
(8140110, 0, 500, 800, 0, 400000),
(8140111, 0, 600, 900, 0, 400000),
(9400575, 0, 1000, 5000, 0, 400000),
(8190000, 0, 800, 1200, 0, 400000),
(8190002, 0, 900, 1300, 0, 400000),
(9400545, 0, 600, 900, 0, 400000),
(9420500, 0, 36, 54, 0, 400000),
(9420502, 0, 30, 42, 0, 400000),
(9420506, 0, 56, 69, 0, 400000),
(9420503, 0, 76, 114, 0, 400000),
(9420501, 0, 92, 138, 0, 400000),
(9420504, 0, 208, 312, 0, 400000),
(9420505, 0, 232, 348, 0, 400000),
(9420508, 0, 254, 364, 0, 400000),
(9420509, 0, 280, 420, 0, 400000),
(9420510, 0, 329, 482, 0, 400000),
(9420511, 0, 304, 456, 0, 400000),
(9420512, 0, 332, 495, 0, 400000),
(9420513, 0, 1059, 2941, 0, 400000),
(6130208, 0, 312, 475, 0, 400000),
(7130104, 0, 332, 495, 0, 400000),
(8810018, 0, 40000, 50000, 0, 400000),
(8140001, 0, 500, 700, 0, 400000),
(8140002, 0, 600, 800, 0, 400000),
(4110302, 0, 180, 270, 0, 400000),
(2220000, 0, 30, 70, 0, 400000),
(9420519, 0, 700, 750, 0, 400000),
(9420517, 0, 750, 850, 0, 400000),
(8220002, 0, 300, 600, 0, 400000),
(8220004, 0, 12000, 14000, 0, 400000),
(8200011, 0, 750, 1050, 0, 400000),
(8220001, 0, 700, 900, 0, 400000),
(8820001, 0, 40000, 50000, 0, 400000),
(100120, 0, 1, 5, 0, 400000),
(100121, 0, 10, 14, 0, 400000),
(7130020, 0, 300, 450, 0, 400000),
(9300328, 0, 4, 6, 0, 400000),
(9400569, 0, 500, 800, 0, 400000),
(9500168, 0, 500, 800, 0, 400000),
(9500169, 0, 500, 800, 0, 400000),
(9500170, 0, 500, 800, 0, 400000),
(9500171, 0, 500, 800, 0, 400000),
(9500172, 0, 500, 800, 0, 400000),
(9500173, 0, 500, 800, 0, 400000),
(9500174, 0, 500, 800, 0, 400000),
(9500175, 0, 500, 800, 0, 400000),
(9500176, 0, 500, 800, 0, 400000),
(8220000, 0, 500, 800, 0, 400000),
(9420544, 0, 2000, 5000, 0, 400000),
(9420549, 0, 2000, 5000, 0, 400000),
(8200000, 0, 400, 600, 0, 400000),
(8200001, 0, 640, 920, 0, 400000),
(8200002, 0, 650, 930, 0, 400000),
(8200003, 0, 640, 950, 0, 400000),
(8200004, 0, 640, 956, 0, 400000),
(8200005, 0, 650, 980, 0, 400000),
(8200006, 0, 680, 1050, 0, 400000),
(8200007, 0, 680, 990, 0, 400000),
(8200008, 0, 690, 1020, 0, 400000),
(8200009, 0, 700, 1060, 0, 400000),
(8200010, 0, 710, 1070, 0, 400000),
(8200012, 0, 760, 1070, 0, 400000),
(6110301, 0, 330, 500, 0, 400000),
(9400110, 0, 171, 227, 0, 400000),
(9400111, 0, 175, 240, 0, 400000),
(9400100, 0, 64, 96, 0, 400000),
(9400101, 0, 88, 112, 0, 400000),
(9400102, 0, 88, 132, 0, 400000),
(9400103, 0, 200, 300, 0, 400000),
(9420522, 0, 1000, 2000, 0, 400000),
(9420522, 0, 1000, 2000, 0, 400000),
(9420522, 0, 1000, 2000, 0, 400000),
(9420522, 0, 1000, 2000, 0, 400000),
(9420522, 0, 1000, 2000, 0, 400000),
(9420522, 0, 1000, 2000, 0, 400000),
(8810018, 0, 30000, 40000, 0, 700000),
(8810018, 0, 30000, 40000, 0, 700000),
(8810018, 0, 30000, 40000, 0, 700000),
(8810018, 0, 30000, 40000, 0, 700000),
(8810018, 0, 30000, 40000, 0, 700000),
(8810018, 0, 30000, 40000, 0, 700000),
(8810018, 0, 30000, 40000, 0, 700000),
(8810018, 0, 30000, 40000, 0, 700000),
(8810018, 0, 30000, 40000, 0, 700000),
(8810018, 0, 30000, 40000, 0, 700000),
(8800002, 0, 10000, 15000, 0, 700000),
(8800002, 0, 10000, 15000, 0, 700000),
(8800002, 0, 10000, 15000, 0, 700000),
(8800002, 0, 10000, 15000, 0, 700000),
(8800002, 0, 10000, 15000, 0, 700000),
(8800002, 0, 10000, 15000, 0, 700000),
(8800002, 0, 10000, 15000, 0, 700000),
(8800002, 0, 10000, 15000, 0, 700000),
(8800002, 0, 10000, 15000, 0, 700000),
(8800002, 0, 10000, 15000, 0, 700000),
(8510000, 0, 10000, 20000, 0, 400000),
(8510000, 0, 10000, 20000, 0, 400000),
(8510000, 0, 10000, 20000, 0, 400000),
(8510000, 0, 10000, 20000, 0, 400000),
(8510000, 0, 10000, 20000, 0, 400000),
(8520000, 0, 10000, 20000, 0, 400000),
(8520000, 0, 10000, 20000, 0, 400000),
(8520000, 0, 10000, 20000, 0, 400000),
(8520000, 0, 10000, 20000, 0, 400000),
(8520000, 0, 10000, 20000, 0, 400000),
(8500002, 0, 10000, 20000, 0, 400000),
(8500002, 0, 10000, 20000, 0, 400000),
(8500002, 0, 10000, 20000, 0, 400000),
(8500002, 0, 10000, 20000, 0, 400000),
(8500002, 0, 10000, 20000, 0, 400000),
(9400409, 0, 10000, 20000, 0, 400000),
(9400409, 0, 10000, 20000, 0, 400000),
(9400409, 0, 10000, 20000, 0, 400000),
(9400409, 0, 10000, 20000, 0, 400000),
(9400409, 0, 10000, 20000, 0, 400000),
(6230100, 4031213, 1, 1, 2097, 200000),
(7130100, 4031214, 1, 1, 2097, 200000),
(7220001, 4031793, 1, 1, 3647, 999999),
(7130101, 4031215, 1, 1, 2097, 200000),
(210100, 4031273, 1, 1, 2104, 500000),
(2220100, 2022016, 1, 1, 8164, 100000),
(2130100, 4031153, 1, 1, 2070, 10000),
(5100003, 4031268, 1, 1, 3629, 30000),
(2230105, 4031259, 1, 1, 3080, 30000),
(2230106, 4031260, 1, 1, 3080, 30000),
(2230108, 4031261, 1, 1, 3080, 30000),
(2230200, 4031262, 1, 1, 3081, 30000),
(3230104, 4031263, 1, 1, 3081, 30000),
(2230109, 4031264, 1, 1, 3081, 30000),
(4230200, 4031265, 1, 1, 3082, 30000),
(4230123, 4031266, 1, 1, 3082, 30000),
(4230124, 4031267, 1, 1, 3082, 30000),
(4230116, 4031103, 1, 1, 3414, 100000),
(4230117, 4031104, 1, 1, 3414, 100000),
(4230118, 4031105, 1, 1, 3414, 100000),
(4240000, 4031106, 1, 1, 3414, 100000),
(7130400, 4031232, 1, 1, 3611, 1000000),
(7130401, 4031233, 1, 1, 3611, 1000000),
(7130402, 4031234, 1, 1, 3611, 1000000),
(5100004, 4031790, 1, 1, 3642, 100000),
(4230113, 4031675, 1, 1, 4917, 1000000),
(9400546, 4031681, 1, 1, 4915, 1000000),
(9600005, 4000191, 1, 1, 0, 1000000),
(9600006, 4000192, 1, 1, 0, 1000000),
(8500002, 4031196, 1, 1, 0, 80000),
(8500002, 4031196, 1, 1, 0, 80000),
(8500002, 4031196, 1, 1, 0, 80000),
(8500002, 4031196, 1, 1, 0, 80000),
(3000006, 4031209, 1, 1, 3072, 500000),
(2230109, 4031209, 1, 1, 3072, 500000),
(2230200, 4031209, 1, 1, 3072, 500000),
(3230104, 4031209, 1, 1, 3072, 500000),
(3230306, 4031159, 1, 1, 2074, 500000),
(9500400, 4031224, 1, 1, 3607, 1000000),
(9500400, 4031223, 1, 1, 3608, 1000000),    # thanks Lame for noticing Hongbu's gourd unavailable
(9420003, 4031400, 1, 1, 8761, 1000000),
(9420001, 4031401, 1, 1, 8761, 1000000),
(9300097, 4031472, 1, 1, 6301, 100000),
(9300098, 4031472, 1, 1, 6301, 100000),
(9300099, 4031472, 1, 1, 6301, 100000),
(5300100, 4031925, 1, 1, 2223, 100000),
(1110100, 4031146, 1, 1, 2065, 1000000),
(1130100, 4031147, 1, 1, 2065, 1000000),
(2230102, 4031155, 1, 1, 2071, 1000000),
(3230100, 4031239, 1, 1, 2099, 50000),
(4230100, 4031212, 1, 1, 2096, 500000),
(5300000, 4031311, 1, 1, 3093, 1000000),
(8140600, 4031256, 1, 1, 3076, 100000),
(8140600, 4031251, 1, 1, 3076, 300000),
(8510000, 4031253, 1, 1, 3076, 1000000),
(8520000, 4031253, 1, 1, 3076, 1000000),
(5130107, 4031218, 1, 1, 3071, 10000),
(5130108, 4031218, 1, 1, 3071, 10000),
(3230200, 4031309, 1, 1, 3088, 500000),
(4230106, 4031309, 1, 1, 3088, 500000),
(5120000, 4031309, 1, 1, 3088, 500000),
(8150100, 4031252, 1, 1, 3078, 10000),
(8150101, 4031252, 1, 1, 3078, 10000),
(8150100, 4031254, 1, 1, 3078, 10000),
(8150101, 4031254, 1, 1, 3078, 10000),
(8150100, 4031255, 1, 1, 3078, 10000),
(8150101, 4031255, 1, 1, 3078, 10000),
(4240000, 4031926, 1, 1, 3454, 1000000),
(4230118, 4031926, 1, 1, 3454, 10000),
(4230117, 4031926, 1, 1, 3454, 10000),
(4230116, 4031926, 1, 1, 3454, 10000),
(6130202, 4031222, 1, 1, 3621, 100000),
(3230302, 4031089, 1, 1, 3223, 100000),
(4230119, 4031090, 1, 1, 3227, 100000),
(3210205, 4031093, 1, 1, 3229, 1000000),
(3110102, 4031129, 1, 1, 3207, 1000000),
(4230119, 4031206, 1, 1, 3441, 50000),
(3230400, 4031140, 1, 1, 3440, 100000),
(3230400, 4031135, 1, 1, 3438, 100000),
(3210208, 4031279, 1, 1, 3632, 1000000),
(2230106, 4031269, 1, 1, 3629, 1000000),
(4230300, 4031241, 1, 1, 3606, 1000000),
(4230112, 4031115, 1, 1, 3416, 100000),
(4240000, 4031102, 1, 1, 3413, 1000000),
(6230300, 4031189, 1, 1, 3448, 100000),
(6230300, 4031195, 1, 1, 3449, 500000),
(130101, 4031846, 1, 1, 2173, 50000),
(1210100, 4031846, 1, 1, 2173, 50000),
(8180001, 4031464, 1, 1, 6303, 1000000);
INSERT IGNORE INTO `temp_data` (`dropperid`, `itemid`, `minimum_quantity`, `maximum_quantity`, `questid`, `chance`) VALUES
(7130104, 4031436, 1, 1, 3828, 1000000),
(3110302, 4031694, 1, 1, 3312, 50000),
(3110303, 4031694, 1, 1, 3312, 100000),
(5120506, 4031432, 1, 1, 3810, 1000000),
(6130209, 4031433, 1, 1, 3804, 100000),
(9400110, 4031139, 1, 1, 8005, 100000),
(9400111, 4031139, 1, 1, 8005, 100000),
(9600002, 4000188, 1, 1, 0, 1000000),
(9600001, 4000187, 1, 1, 0, 1000000),
(9420005, 4000252, 1, 1, 0, 1000000),
(9420005, 4000253, 1, 1, 0, 1000000),
(3110100, 4031405, 1, 1, 8732, 500000),
(9600007, 4000193, 1, 1, 0, 1000000),
(9400543, 4031680, 1, 1, 4914, 300000),
(9420003, 4000251, 1, 1, 0, 1000000),
(4230116, 4031674, 1, 1, 4916, 300000),
(9600003, 4000189, 1, 1, 0, 1000000),
(9600004, 4000190, 1, 1, 0, 1000000),
(9420002, 4000248, 1, 1, 0, 1000000),
(3110100, 4031164, 1, 1, 2084, 300000),
(2000, 4031161, 1, 1, 1008, 1000000),
(2000, 4031162, 1, 1, 1008, 1000000),
(6130200, 4031170, 1, 1, 7100, 500000),
(6230300, 4031170, 1, 1, 7100, 500000),
(6230400, 4031170, 1, 1, 7100, 500000),
(6230500, 4031170, 1, 1, 7100, 500000),
(6300100, 4031170, 1, 1, 7100, 500000),
(6400100, 4031170, 1, 1, 7100, 500000),
(7130010, 4031170, 1, 1, 7100, 500000),
(7130300, 4031170, 1, 1, 7100, 500000),
(7140000, 4031170, 1, 1, 7100, 500000),
(8140200, 4031170, 1, 1, 7100, 500000),
(8140300, 4031170, 1, 1, 7100, 500000),
(8141000, 4031170, 1, 1, 7100, 500000),
(8141100, 4031170, 1, 1, 7100, 500000),
(8142000, 4031170, 1, 1, 7100, 500000),
(8143000, 4031170, 1, 1, 7100, 500000),
(8160000, 4031170, 1, 1, 7100, 500000),
(8170000, 4031170, 1, 1, 7100, 500000),
(9500127, 4031170, 1, 1, 7100, 500000),
(9500135, 4031170, 1, 1, 7100, 500000),
(9500136, 4031170, 1, 1, 7100, 500000),
(9500137, 4031170, 1, 1, 7100, 500000),
(7130300, 4031171, 1, 1, 7101, 100000),
(7160000, 4031171, 1, 1, 7101, 100000),
(6130200, 4031175, 1, 1, 7101, 300000),
(6230300, 4031175, 1, 1, 7101, 300000),
(6230400, 4031175, 1, 1, 7101, 300000),
(6230500, 4031175, 1, 1, 7101, 300000),
(6300100, 4031175, 1, 1, 7101, 350000),
(6400100, 4031175, 1, 1, 7101, 350000),
(7130010, 4031175, 1, 1, 7101, 400000),
(7130300, 4031175, 1, 1, 7101, 400000),
(7140000, 4031175, 1, 1, 7101, 400000),
(8140200, 4031175, 1, 1, 7101, 350000),
(8140300, 4031175, 1, 1, 7101, 350000),
(8141000, 4031175, 1, 1, 7101, 450000),
(8141100, 4031175, 1, 1, 7101, 450000),
(8142000, 4031175, 1, 1, 7101, 450000),
(8143000, 4031175, 1, 1, 7101, 450000),
(8160000, 4031175, 1, 1, 7101, 600000),
(8170000, 4031175, 1, 1, 7101, 600000),
(9500127, 4031175, 1, 1, 7101, 300000),
(9500135, 4031175, 1, 1, 7101, 400000),
(9500136, 4031175, 1, 1, 7101, 450000),
(9500137, 4031175, 1, 1, 7101, 450000),
(8141100, 4031176, 1, 1, 7104, 50000),
(8143000, 4031176, 1, 1, 7104, 50000),
(9500136, 4031176, 1, 1, 7104, 50000),
(9500137, 4031176, 1, 1, 7104, 50000),
(8141100, 4031177, 1, 1, 7104, 100000),
(8143000, 4031177, 1, 1, 7104, 100000),
(9500136, 4031177, 1, 1, 7104, 100000),
(9500137, 4031177, 1, 1, 7104, 100000),
(8141100, 4031178, 1, 1, 7104, 10000),
(8143000, 4031178, 1, 1, 7104, 10000),
(9500136, 4031178, 1, 1, 7104, 10000),
(9500137, 4031178, 1, 1, 7104, 10000),
(8160000, 4031172, 1, 1, 7103, 50000),
(8170000, 4031172, 1, 1, 7103, 50000),
(8141000, 4031193, 1, 1, 3446, 60000),
(7130501, 4031412, 1, 1, 3712, 100000),
(8140111, 4031413, 1, 1, 3712, 100000),
(8150201, 4031414, 1, 1, 3712, 100000),
(8150302, 4031415, 1, 1, 3712, 100000),
(8180000, 4001076, 1, 1, 7301, 1000000),
(8180000, 4001076, 1, 1, 7301, 1000000),
(8180000, 4001076, 1, 1, 7301, 1000000),
(8150200, 4001075, 1, 1, 7301, 50000),
(8150201, 4001075, 1, 1, 7301, 50000),
(8150300, 4001077, 1, 1, 7301, 60000),
(8150301, 4001077, 1, 1, 7301, 60000),
(8150302, 4001077, 1, 1, 7301, 60000),
(8150200, 4001079, 1, 1, 7301, 60000),
(8180000, 4001104, 1, 1, 7303, 1000000),
(8180000, 4001104, 1, 1, 7303, 1000000),
(8180000, 4001104, 1, 1, 7303, 1000000),
(8150200, 4001103, 1, 1, 7303, 50000),
(8150201, 4001103, 1, 1, 7303, 50000),
(8150300, 4001105, 1, 1, 7303, 60000),
(8150301, 4001105, 1, 1, 7303, 60000),
(8150302, 4001105, 1, 1, 7303, 60000),
(8150200, 4001079, 1, 1, 7303, 60000),
(8180000, 4031343, 1, 1, 6904, 400000),
(8180001, 4031344, 1, 1, 6904, 400000),
(8180000, 4031511, 1, 1, 6914, 400000),
(8180001, 4031512, 1, 1, 6914, 400000),
(8180000, 4031514, 1, 1, 6924, 400000),
(8180001, 4031515, 1, 1, 6924, 400000),
(8180000, 4031517, 1, 1, 6934, 400000),
(8180001, 4031518, 1, 1, 6934, 400000),
(8180000, 4031860, 1, 1, 6944, 400000),
(8180001, 4031861, 1, 1, 6944, 400000),
(8140101, 4031465, 1, 1, 6250, 5000),
(8140101, 4031487, 1, 1, 6251, 5000),
(8140102, 4031465, 1, 1, 6250, 5000),
(8140102, 4031487, 1, 1, 6251, 5000),
(8140103, 4031465, 1, 1, 6250, 5000),
(8140103, 4031487, 1, 1, 6251, 5000),
(8140101, 4031487, 1, 1, 6251, 5000),
(8150300, 4031449, 1, 1, 6120, 60000),
(8150300, 4031449, 1, 1, 6120, 60000),
(8150300, 4031449, 1, 1, 6120, 60000),
(8150301, 4031449, 1, 1, 6120, 60000),
(8150301, 4031449, 1, 1, 6120, 60000),
(8150301, 4031449, 1, 1, 6120, 60000),
(8150302, 4031449, 1, 1, 6120, 60000),
(8150302, 4031449, 1, 1, 6120, 60000),
(8150302, 4031449, 1, 1, 6120, 60000),
(8150300, 4031482, 1, 1, 6121, 20000),
(8150300, 4031482, 1, 1, 6121, 20000),
(8150300, 4031482, 1, 1, 6121, 20000),
(8150301, 4031482, 1, 1, 6121, 20000),
(8150301, 4031482, 1, 1, 6121, 20000),
(8150301, 4031482, 1, 1, 6121, 20000),
(8150302, 4031482, 1, 1, 6121, 20000),
(8150302, 4031482, 1, 1, 6121, 20000),
(8150302, 4031482, 1, 1, 6121, 20000),
(8150300, 4031483, 1, 1, 6122, 20000),
(8150300, 4031483, 1, 1, 6122, 20000),
(8150300, 4031483, 1, 1, 6122, 20000),
(8150301, 4031483, 1, 1, 6122, 20000),
(8150301, 4031483, 1, 1, 6122, 20000),
(8150301, 4031483, 1, 1, 6122, 20000),
(8150302, 4031483, 1, 1, 6122, 20000),
(8150302, 4031483, 1, 1, 6122, 20000),
(8150302, 4031483, 1, 1, 6122, 20000),
(8150300, 4031484, 1, 1, 6123, 20000),
(8150300, 4031484, 1, 1, 6123, 20000),
(8150300, 4031484, 1, 1, 6123, 20000),
(8150301, 4031484, 1, 1, 6123, 20000),
(8150301, 4031484, 1, 1, 6123, 20000),
(8150301, 4031484, 1, 1, 6123, 20000),
(8150302, 4031484, 1, 1, 6123, 20000),
(8150302, 4031484, 1, 1, 6123, 20000),
(8150302, 4031484, 1, 1, 6123, 20000),
(8150300, 4031485, 1, 1, 6124, 20000),
(8150300, 4031485, 1, 1, 6124, 20000),
(8150300, 4031485, 1, 1, 6124, 20000),
(8150301, 4031485, 1, 1, 6124, 20000),
(8150301, 4031485, 1, 1, 6124, 20000),
(8150301, 4031485, 1, 1, 6124, 20000),
(8150302, 4031485, 1, 1, 6124, 20000),
(8150302, 4031485, 1, 1, 6124, 20000),
(8150302, 4031485, 1, 1, 6124, 20000),
(8130100, 4031466, 1, 1, 6107, 500000),
(7130101, 4031466, 1, 1, 6107, 80000),
(7130100, 4031466, 1, 1, 6107, 80000),
(6230100, 4031466, 1, 1, 6107, 30000),
(9300100, 4031470, 1, 1, 6225, 250000),
(9300086, 4031470, 1, 1, 6225, 1000),
(9300100, 4031469, 1, 1, 6315, 1000),
(9300086, 4031469, 1, 1, 6315, 250000),
(8160000, 4031474, 1, 1, 6295, 50000),
(8160000, 4031473, 1, 1, 6226, 20000),
(8160000, 4031496, 1, 1, 6316, 20000),
(9300079, 4031461, 1, 1, 6169, 30000),
(9300078, 4031461, 1, 1, 6169, 30000),
(9300077, 4031461, 1, 1, 6169, 30000),
(9300076, 4031461, 1, 1, 6169, 30000),
(9300075, 4031461, 1, 1, 6169, 30000),
(9300074, 4031461, 1, 1, 6169, 30000),
(9300073, 4031461, 1, 1, 6169, 30000),
(9300072, 4031461, 1, 1, 6169, 30000),
(9300071, 4031461, 1, 1, 6169, 30000),
(9300070, 4031461, 1, 1, 6169, 30000),
(9300069, 4031461, 1, 1, 6169, 30000),
(9300068, 4031461, 1, 1, 6169, 30000),
(9300067, 4031461, 1, 1, 6169, 30000),
(9300066, 4031461, 1, 1, 6169, 30000),
(9300065, 4031461, 1, 1, 6169, 30000),
(9300274, 4032190, 1, 1, 20705, 50000),
(9300274, 4032314, 1, 1, 21709, 150000),
(1210102, 4032314, 1, 1, 21709, 150000),
(1210100, 4032340, 1, 1, 21710, 200000),
(9300274, 4032315, 1, 1, 21711, 50000),
(1110130, 4032316, 1, 1, 21714, 50000),
(100121, 4000483, 1, 1, 0, 400000),
(9001011, 4032096, 1, 1, 20201, 700000),
(9001011, 4032097, 1, 1, 20202, 700000),
(9001011, 4032098, 1, 1, 20203, 700000),
(9001011, 4032099, 1, 1, 20204, 700000),
(9001011, 4032100, 1, 1, 20205, 700000),
(9001009, 4032101, 1, 1, 20301, 700000),
(9001009, 4032102, 1, 1, 20302, 700000),
(9001009, 4032103, 1, 1, 20303, 700000),
(9001009, 4032104, 1, 1, 20304, 700000),
(9001009, 4032105, 1, 1, 20305, 700000),
(9300289, 4032120, 1, 1, 20601, 999999),
(9300289, 4032121, 1, 1, 20602, 999999),
(9300289, 4032122, 1, 1, 20603, 999999),
(9300289, 4032123, 1, 1, 20604, 999999),
(9300289, 4032124, 1, 1, 20605, 999999),
(9300294, 4032125, 1, 1, 20611, 999999),
(9300294, 4032126, 1, 1, 20612, 999999),
(9300294, 4032127, 1, 1, 20613, 999999),
(9300294, 4032128, 1, 1, 20614, 999999),
(9300294, 4032129, 1, 1, 20615, 999999),
(8200011, 2290048, 1, 1, 0, 600),
(8200011, 2290040, 1, 1, 0, 600),
(9420549, 2280010, 1, 1, 0, 50000),
(9420549, 2280009, 1, 1, 0, 70000),
(9420549, 2280008, 1, 1, 0, 50000),
(9420549, 2280007, 1, 1, 0, 50000),
(9420544, 2280010, 1, 1, 0, 70000),
(9420544, 2280009, 1, 1, 0, 90000),
(9420544, 2280008, 1, 1, 0, 70000),
(9420544, 2280007, 1, 1, 0, 70000),
(8520000, 2280010, 1, 1, 0, 30000),
(8520000, 2280009, 1, 1, 0, 50000),
(8520000, 2280008, 1, 1, 0, 30000),
(8520000, 2280007, 1, 1, 0, 30000),
(8510000, 2280010, 1, 1, 0, 30000),
(8510000, 2280009, 1, 1, 0, 50000),
(8510000, 2280008, 1, 1, 0, 30000),
(8510000, 2280007, 1, 1, 0, 30000),
(8500002, 2280010, 1, 1, 0, 35000),
(8500002, 2280009, 1, 1, 0, 50000),
(8500002, 2280008, 1, 1, 0, 35000),
(8500002, 2280007, 1, 1, 0, 35000),
(8140701, 4031872, 1, 1, 6340, 100000),
(8140700, 4031871, 1, 1, 6350, 100000),
(8500002, 4031869, 1, 1, 6360, 999999),
(8141000, 4031873, 1, 1, 6380, 60000),
(8141100, 4031874, 1, 1, 6390, 60000),
(7130101, 4001112, 1, 1, 0, 7000),
(8170000, 4001112, 1, 1, 0, 7500),
(5130107, 4001107, 1, 1, 0, 7000),
(8143000, 4001107, 1, 1, 0, 7500),
(7160000, 4001110, 1, 1, 0, 7000),
(8150100, 4161018, 1, 1, 0, 7000),
(7130000, 4161021, 1, 1, 0, 7000),
(8150000, 4001111, 1, 1, 0, 700000),
(8140000, 4031477, 1, 1, 0, 10000),
(8170000, 4031453, 1, 1, 6291, 50000),
(8160000, 4031474, 1, 1, 6295, 50000),
(8180001, 4031479, 1, 1, 6151, 999999),
(8130100, 4031475, 1, 1, 6153, 999999),
(8140000, 4031460, 1, 1, 6168, 10000),
(8180001, 4031457, 1, 1, 6231, 400000),
(8170000, 4031458, 1, 1, 6231, 10000),
(6130104, 4031459, 1, 1, 6231, 500000),
(9300094, 2280004, 1, 1, 0, 7000),
(9300095, 2280004, 1, 1, 0, 7000),
(9300094, 2280005, 1, 1, 0, 7000),
(9300095, 2280005, 1, 1, 0, 7000),
(9300094, 2280006, 1, 1, 0, 7000),
(9300095, 2280006, 1, 1, 0, 7000),
(8500002, 4001084, 1, 1, 0, 999999),
(8800002, 4001083, 1, 1, 0, 999999),
(9300367, 2022179, 1, 1, 0, 300000),
(9300368, 2022179, 1, 1, 0, 300000),
(9300369, 2022179, 1, 1, 0, 300000),
(9300370, 2022179, 1, 1, 0, 300000),
(9300371, 2022179, 1, 1, 0, 300000),
(9300372, 2022179, 1, 1, 0, 300000),
(9300373, 2022179, 1, 1, 0, 300000),
(9300374, 2022179, 1, 1, 0, 300000),
(9300375, 2022179, 1, 1, 0, 300000),
(9300376, 2022179, 1, 1, 0, 300000),
(9300377, 2022179, 1, 1, 0, 300000),
(9300367, 1002971, 1, 1, 0, 40000),
(9300368, 1002971, 1, 1, 0, 40000),
(9300369, 1002971, 1, 1, 0, 40000),
(9300370, 1002971, 1, 1, 0, 40000),
(9300371, 1002971, 1, 1, 0, 40000),
(9300372, 1002971, 1, 1, 0, 40000),
(9300373, 1002971, 1, 1, 0, 40000),
(9300374, 1002971, 1, 1, 0, 40000),
(9300375, 1002971, 1, 1, 0, 40000),
(9300376, 1002971, 1, 1, 0, 40000),
(9300377, 1002971, 1, 1, 0, 40000),
(9300367, 1442046, 1, 1, 0, 30000),
(9300368, 1442046, 1, 1, 0, 30000),
(9300369, 1442046, 1, 1, 0, 30000),
(9300370, 1442046, 1, 1, 0, 30000),
(9300371, 1442046, 1, 1, 0, 30000),
(9300372, 1442046, 1, 1, 0, 30000),
(9300373, 1442046, 1, 1, 0, 30000),
(9300374, 1442046, 1, 1, 0, 30000),
(9300375, 1442046, 1, 1, 0, 30000),
(9300376, 1442046, 1, 1, 0, 30000),
(9300377, 1442046, 1, 1, 0, 30000),
(9300367, 1442057, 1, 1, 0, 40000),
(9300368, 1442057, 1, 1, 0, 40000),
(9300369, 1442057, 1, 1, 0, 40000),
(9300370, 1442057, 1, 1, 0, 40000),
(9300371, 1442057, 1, 1, 0, 40000),
(9300372, 1442057, 1, 1, 0, 40000),
(9300373, 1442057, 1, 1, 0, 40000),
(9300374, 1442057, 1, 1, 0, 40000),
(9300375, 1442057, 1, 1, 0, 40000),
(9300376, 1442057, 1, 1, 0, 40000),
(9300377, 1442057, 1, 1, 0, 40000),
(8200001, 4020009, 1, 1, 0, 1000),
(8200002, 4020009, 1, 1, 0, 1000),
(8200003, 4020009, 1, 1, 0, 1000),
(8200004, 4020009, 1, 1, 0, 1000),
(8200005, 4020009, 1, 1, 0, 1000),
(8200006, 4020009, 1, 1, 0, 1000),
(8200007, 4020009, 1, 1, 0, 1000),
(8200008, 4020009, 1, 1, 0, 1000),
(8200009, 4020009, 1, 1, 0, 1000),
(8200010, 4020009, 1, 1, 0, 1000),
(8200011, 4020009, 1, 1, 0, 1000),
(8200012, 4020009, 1, 1, 0, 1000),
(9300000, 4001008, 1, 1, 0, 999999),
(9300001, 4001007, 1, 1, 0, 200000),
(9300002, 4001008, 1, 1, 0, 999999),
(9300003, 4001008, 1, 1, 0, 999999),
(4230109, 1452016, 1, 1, 0, 700),
(9300005, 4001022, 1, 1, 0, 999999),
(9300006, 4001022, 1, 1, 0, 999999),
(9300007, 4001022, 1, 1, 0, 999999),
(9300008, 4001022, 1, 1, 0, 999999),
(9300014, 4001022, 1, 1, 0, 999999),
(9300010, 4001022, 1, 1, 0, 999999),
(9300012, 4001023, 1, 1, 0, 999999),
(9300170, 4001156, 1, 1, 0, 999999),
(9300171, 4001156, 1, 1, 0, 999999),
(9300169, 4001156, 1, 1, 0, 999999),
(9000100, 4031013, 1, 1, 0, 700000),
(9000101, 4031013, 1, 1, 0, 700000),
(9000000, 4031013, 1, 1, 0, 700000),
(9000001, 4031013, 1, 1, 0, 700000),
(9000200, 4031013, 1, 1, 0, 700000),
(9000201, 4031013, 1, 1, 0, 700000),
(9000300, 4031013, 1, 1, 0, 700000),
(9000301, 4031013, 1, 1, 0, 700000),
(8180000, 4031511, 1, 1, 6904, 600000),
(8180001, 4031511, 1, 1, 6904, 600000),
(9400407, 4000343, 1, 1, 0, 100000),
(9300018, 4031802, 1, 1, 1035, 999999),
(6110301, 4031745, 1, 1, 3358, 5000),
(9302010, 2022524, 1, 1, 0, 100000),
(9400256, 4032192, 1, 1, 0, 50000),
(9400257, 4032192, 1, 1, 0, 50000),
(9410066, 4000306, 1, 1, 0, 700000),
(9410066, 4000306, 1, 1, 0, 700000),
(9410066, 4000306, 1, 1, 0, 700000),
(9410066, 4000306, 1, 1, 0, 700000),
(9410066, 4000306, 1, 1, 0, 700000),
(9410066, 4000306, 1, 1, 0, 700000),
(9410066, 4000306, 1, 1, 0, 700000),
(9410066, 4000306, 1, 1, 0, 700000),
(9410066, 4000306, 1, 1, 0, 700000),
(9410066, 4000306, 1, 1, 0, 700000),
(9410066, 4000306, 1, 1, 0, 700000),
(9410066, 4000306, 1, 1, 0, 700000),
(9410066, 4000306, 1, 1, 0, 700000),
(9410066, 4000306, 1, 1, 0, 700000),
(9410066, 4000306, 1, 1, 0, 700000),
(9410066, 4000306, 1, 1, 0, 700000),
(9410066, 4000306, 1, 1, 0, 700000),
(9410066, 4000306, 1, 1, 0, 700000),
(9410066, 4000306, 1, 1, 0, 700000),
(9410066, 4000306, 1, 1, 0, 700000),
(9420015, 2022042, 1, 1, 0, 700000),
(9420015, 2022042, 1, 1, 0, 700000),
(9420015, 2022042, 1, 1, 0, 700000),
(9420015, 2022042, 1, 1, 0, 700000),
(9420015, 2022042, 1, 1, 0, 700000),
(9420015, 4032176, 1, 1, 0, 700000),
(9420015, 4032176, 1, 1, 0, 700000),
(9420015, 4032176, 1, 1, 0, 700000),
(9420015, 4032176, 1, 1, 0, 700000),
(9420015, 4032176, 1, 1, 0, 700000),
(9420015, 4032176, 1, 1, 0, 700000),
(9420015, 4032176, 1, 1, 0, 700000),
(9420015, 4032176, 1, 1, 0, 700000),
(9420015, 4032176, 1, 1, 0, 700000),
(9420015, 4032176, 1, 1, 0, 700000),
(9420015, 4032176, 1, 1, 0, 700000),
(9420015, 4032176, 1, 1, 0, 700000),
(9420015, 4032176, 1, 1, 0, 700000),
(9420015, 4032176, 1, 1, 0, 700000),
(9420015, 4032176, 1, 1, 0, 700000),
(9420015, 4032176, 1, 1, 0, 700000),
(9420015, 4032176, 1, 1, 0, 700000),
(9420015, 4032176, 1, 1, 0, 700000),
(9420015, 4032176, 1, 1, 0, 700000),
(9420015, 4032176, 1, 1, 0, 700000),
(9420015, 4000420, 1, 1, 0, 700000),
(9420015, 4000420, 1, 1, 0, 700000),
(9420015, 4000420, 1, 1, 0, 700000),
(9420015, 4000420, 1, 1, 0, 700000),
(9420015, 4000420, 1, 1, 0, 700000),
(9420015, 4000420, 1, 1, 0, 700000),
(9420015, 4000420, 1, 1, 0, 700000),
(9420015, 4000420, 1, 1, 0, 700000),
(9420015, 4000420, 1, 1, 0, 700000),
(9420015, 4000420, 1, 1, 0, 700000),
(9420015, 4000420, 1, 1, 0, 700000),
(9420015, 4000420, 1, 1, 0, 700000),
(9420015, 4000420, 1, 1, 0, 700000),
(9420015, 4000420, 1, 1, 0, 700000),
(9420015, 4000420, 1, 1, 0, 700000),
(9420015, 4000420, 1, 1, 0, 700000),
(9420015, 4000420, 1, 1, 0, 700000),
(9420015, 4000420, 1, 1, 0, 700000),
(9420015, 4000420, 1, 1, 0, 700000),
(9420015, 4000420, 1, 1, 0, 700000),
(9420015, 4000420, 1, 1, 0, 700000),
(9420015, 4000420, 1, 1, 0, 700000),
(9420015, 4000420, 1, 1, 0, 700000),
(9420015, 4000420, 1, 1, 0, 700000),
(9420015, 4000420, 1, 1, 0, 700000),
(9420015, 4000420, 1, 1, 0, 700000),
(9420015, 4000420, 1, 1, 0, 700000),
(9420015, 4000420, 1, 1, 0, 700000),
(9420015, 4000420, 1, 1, 0, 700000),
(9420015, 4000420, 1, 1, 0, 700000),
(9420015, 4000420, 1, 1, 0, 700000),
(9420015, 4000420, 1, 1, 0, 700000),
(9420015, 4000420, 1, 1, 0, 700000),
(9420015, 4000420, 1, 1, 0, 700000),
(9420015, 4000420, 1, 1, 0, 700000),
(9420015, 4000420, 1, 1, 0, 700000),
(9420015, 4000420, 1, 1, 0, 700000),
(9420015, 4000420, 1, 1, 0, 700000),
(9420015, 4000420, 1, 1, 0, 700000),
(9420015, 4000420, 1, 1, 0, 700000),
(9420015, 4000421, 1, 1, 0, 700000),
(9420015, 4000421, 1, 1, 0, 700000),
(9420015, 4000421, 1, 1, 0, 700000),
(9420015, 4000421, 1, 1, 0, 700000),
(9420015, 4000421, 1, 1, 0, 700000),
(9420015, 4000421, 1, 1, 0, 700000),
(9420015, 4000421, 1, 1, 0, 700000),
(9420015, 4000421, 1, 1, 0, 700000),
(9420015, 4000421, 1, 1, 0, 700000),
(9420015, 4000421, 1, 1, 0, 700000),
(9420015, 4000421, 1, 1, 0, 700000),
(9420015, 4000421, 1, 1, 0, 700000),
(9420015, 4000421, 1, 1, 0, 700000),
(9420015, 4000421, 1, 1, 0, 700000),
(9420015, 4000421, 1, 1, 0, 700000),
(9420015, 4000421, 1, 1, 0, 700000),
(9420015, 4000421, 1, 1, 0, 700000),
(9420015, 4000421, 1, 1, 0, 700000),
(9420015, 4000421, 1, 1, 0, 700000),
(9420015, 4000421, 1, 1, 0, 700000),
(9420015, 4000421, 1, 1, 0, 700000),
(9420015, 4000421, 1, 1, 0, 700000),
(9420015, 4000421, 1, 1, 0, 700000),
(9420015, 4000421, 1, 1, 0, 700000),
(9420015, 4000421, 1, 1, 0, 700000),
(9420015, 4000421, 1, 1, 0, 700000),
(9420015, 4000421, 1, 1, 0, 700000),
(9420015, 4000421, 1, 1, 0, 700000),
(9420015, 4000421, 1, 1, 0, 700000),
(9420015, 4000421, 1, 1, 0, 700000),
(9420015, 4000421, 1, 1, 0, 700000),
(9420015, 4000421, 1, 1, 0, 700000),
(9420015, 4000421, 1, 1, 0, 700000),
(9420015, 4000421, 1, 1, 0, 700000),
(9420015, 4000421, 1, 1, 0, 700000),
(9420015, 4000421, 1, 1, 0, 700000),
(9420015, 4000421, 1, 1, 0, 700000),
(9420015, 4000421, 1, 1, 0, 700000),
(9420015, 4000421, 1, 1, 0, 700000),
(9420015, 4000421, 1, 1, 0, 700000),
(9400569, 2022311, 1, 4, 0, 700000),
(9400569, 2020017, 1, 4, 0, 700000),
(9400569, 2020018, 1, 4, 0, 700000),
(9400569, 2022310, 1, 4, 0, 700000),
(9400569, 2022456, 1, 4, 0, 700000),
(9400569, 2020014, 1, 4, 0, 700000),
(9400569, 2020015, 1, 4, 0, 700000),
(9400569, 2002001, 1, 4, 0, 700000),
(9400569, 2002005, 1, 4, 0, 700000),
(9400569, 2002003, 1, 4, 0, 700000),
(9400569, 2002205, 1, 4, 0, 700000),
(9500168, 2022311, 1, 4, 0, 700000),
(9500168, 2020017, 1, 4, 0, 700000),
(9500168, 2020018, 1, 4, 0, 700000),
(9500168, 2022310, 1, 4, 0, 700000),
(9500168, 2022456, 1, 4, 0, 700000),
(9500168, 2020014, 1, 4, 0, 700000),
(9500168, 2020015, 1, 4, 0, 700000),
(9500168, 2002001, 1, 4, 0, 700000),
(9500168, 2002005, 1, 4, 0, 700000),
(9500168, 2002003, 1, 4, 0, 700000),
(9500168, 2002205, 1, 4, 0, 700000),
(9500169, 2022311, 1, 4, 0, 700000),
(9500169, 2020017, 1, 4, 0, 700000),
(9500169, 2020018, 1, 4, 0, 700000),
(9500169, 2022310, 1, 4, 0, 700000),
(9500169, 2022456, 1, 4, 0, 700000),
(9500169, 2020014, 1, 4, 0, 700000),
(9500169, 2020015, 1, 4, 0, 700000),
(9500169, 2002001, 1, 4, 0, 700000),
(9500169, 2002005, 1, 4, 0, 700000),
(9500169, 2002003, 1, 4, 0, 700000),
(9500169, 2002205, 1, 4, 0, 700000),
(9500170, 2022311, 1, 4, 0, 700000),
(9500170, 2020017, 1, 4, 0, 700000),
(9500170, 2020018, 1, 4, 0, 700000),
(9500170, 2022310, 1, 4, 0, 700000),
(9500170, 2022456, 1, 4, 0, 700000),
(9500170, 2020014, 1, 4, 0, 700000),
(9500170, 2020015, 1, 4, 0, 700000),
(9500170, 2002001, 1, 4, 0, 700000),
(9500170, 2002005, 1, 4, 0, 700000),
(9500170, 2002003, 1, 4, 0, 700000),
(9500170, 2002205, 1, 4, 0, 700000),
(9500171, 2022311, 1, 4, 0, 700000),
(9500171, 2020017, 1, 4, 0, 700000),
(9500171, 2020018, 1, 4, 0, 700000),
(9500171, 2022310, 1, 4, 0, 700000),
(9500171, 2022456, 1, 4, 0, 700000),
(9500171, 2020014, 1, 4, 0, 700000),
(9500171, 2020015, 1, 4, 0, 700000),
(9500171, 2002001, 1, 4, 0, 700000),
(9500171, 2002005, 1, 4, 0, 700000),
(9500171, 2002003, 1, 4, 0, 700000),
(9500171, 2002205, 1, 4, 0, 700000),
(9500172, 2022311, 1, 4, 0, 700000),
(9500172, 2020017, 1, 4, 0, 700000),
(9500172, 2020018, 1, 4, 0, 700000),
(9500172, 2022310, 1, 4, 0, 700000),
(9500172, 2022456, 1, 4, 0, 700000),
(9500172, 2020014, 1, 4, 0, 700000),
(9500172, 2020015, 1, 4, 0, 700000),
(9500172, 2002001, 1, 4, 0, 700000),
(9500172, 2002005, 1, 4, 0, 700000),
(9500172, 2002003, 1, 4, 0, 700000),
(9500172, 2002205, 1, 4, 0, 700000),
(9500173, 2022311, 1, 4, 0, 700000),
(9500173, 2020017, 1, 4, 0, 700000),
(9500173, 2020018, 1, 4, 0, 700000),
(9500173, 2022310, 1, 4, 0, 700000),
(9500173, 2022456, 1, 4, 0, 700000),
(9500173, 2020014, 1, 4, 0, 700000),
(9500173, 2020015, 1, 4, 0, 700000),
(9500173, 2002001, 1, 4, 0, 700000),
(9500173, 2002005, 1, 4, 0, 700000),
(9500173, 2002003, 1, 4, 0, 700000),
(9500173, 2002205, 1, 4, 0, 700000),
(9500174, 2022311, 1, 4, 0, 700000),
(9500174, 2020017, 1, 4, 0, 700000),
(9500174, 2020018, 1, 4, 0, 700000),
(9500174, 2022310, 1, 4, 0, 700000),
(9500174, 2022456, 1, 4, 0, 700000),
(9500174, 2020014, 1, 4, 0, 700000),
(9500174, 2020015, 1, 4, 0, 700000),
(9500174, 2002001, 1, 4, 0, 700000),
(9500174, 2002005, 1, 4, 0, 700000),
(9500174, 2002003, 1, 4, 0, 700000),
(9500174, 2002205, 1, 4, 0, 700000),
(9500175, 2022311, 1, 4, 0, 700000),
(9500175, 2020017, 1, 4, 0, 700000),
(9500175, 2020018, 1, 4, 0, 700000),
(9500175, 2022310, 1, 4, 0, 700000),
(9500175, 2022456, 1, 4, 0, 700000),
(9500175, 2020014, 1, 4, 0, 700000),
(9500175, 2020015, 1, 4, 0, 700000),
(9500175, 2002001, 1, 4, 0, 700000),
(9500175, 2002005, 1, 4, 0, 700000),
(9500175, 2002003, 1, 4, 0, 700000),
(9500175, 2002205, 1, 4, 0, 700000),
(9500176, 2022311, 1, 4, 0, 700000),
(9500176, 2020017, 1, 4, 0, 700000),
(9500176, 2020018, 1, 4, 0, 700000),
(9500176, 2022310, 1, 4, 0, 700000),
(9500176, 2022456, 1, 4, 0, 700000),
(9500176, 2020014, 1, 4, 0, 700000),
(9500176, 2020015, 1, 4, 0, 700000),
(9500176, 2002001, 1, 4, 0, 700000),
(9500176, 2002005, 1, 4, 0, 700000),
(9500176, 2002003, 1, 4, 0, 700000),
(9500176, 2002205, 1, 4, 0, 700000),
(9300217, 2022430, 1, 1, 0, 700000),
(9300217, 2022431, 1, 1, 0, 700000),
(9300217, 2022432, 1, 1, 0, 700000),
(9300217, 2022433, 1, 1, 0, 700000),
(9300218, 2022430, 1, 1, 0, 700000),
(9300218, 2022431, 1, 1, 0, 700000),
(9300218, 2022432, 1, 1, 0, 700000),
(9300218, 2022433, 1, 1, 0, 700000),
(9300219, 2022430, 1, 1, 0, 700000),
(9300219, 2022431, 1, 1, 0, 700000),
(9300219, 2022432, 1, 1, 0, 700000),
(9300219, 2022433, 1, 1, 0, 700000),
(9300220, 2022430, 1, 1, 0, 700000),
(9300220, 2022431, 1, 1, 0, 700000),
(9300220, 2022432, 1, 1, 0, 700000),
(9300220, 2022433, 1, 1, 0, 700000),
(9300221, 2022430, 1, 1, 0, 700000),
(9300221, 2022431, 1, 1, 0, 700000),
(9300221, 2022432, 1, 1, 0, 700000),
(9300221, 2022433, 1, 1, 0, 700000),
(9300222, 2022430, 1, 1, 0, 700000),
(9300222, 2022431, 1, 1, 0, 700000),
(9300222, 2022432, 1, 1, 0, 700000),
(9300222, 2022433, 1, 1, 0, 700000),
(9300223, 2022430, 1, 1, 0, 700000),
(9300223, 2022431, 1, 1, 0, 700000),
(9300223, 2022432, 1, 1, 0, 700000),
(9300223, 2022433, 1, 1, 0, 700000),
(9300224, 2022430, 1, 1, 0, 700000),
(9300224, 2022431, 1, 1, 0, 700000),
(9300224, 2022432, 1, 1, 0, 700000),
(9300224, 2022433, 1, 1, 0, 700000),
(9300225, 2022430, 1, 1, 0, 700000),
(9300225, 2022431, 1, 1, 0, 700000),
(9300225, 2022432, 1, 1, 0, 700000),
(9300225, 2022433, 1, 1, 0, 700000),
(9300226, 2022430, 1, 1, 0, 700000),
(9300226, 2022431, 1, 1, 0, 700000),
(9300226, 2022432, 1, 1, 0, 700000),
(9300226, 2022433, 1, 1, 0, 700000),
(9300227, 2022430, 1, 1, 0, 700000),
(9300227, 2022431, 1, 1, 0, 700000),
(9300227, 2022432, 1, 1, 0, 700000),
(9300227, 2022433, 1, 1, 0, 700000),
(9300228, 2022430, 1, 1, 0, 700000),
(9300228, 2022431, 1, 1, 0, 700000),
(9300228, 2022432, 1, 1, 0, 700000),
(9300228, 2022433, 1, 1, 0, 700000),
(9300229, 2022430, 1, 1, 0, 700000),
(9300229, 2022431, 1, 1, 0, 700000),
(9300229, 2022432, 1, 1, 0, 700000),
(9300229, 2022433, 1, 1, 0, 700000),
(9300230, 2022430, 1, 1, 0, 700000),
(9300230, 2022431, 1, 1, 0, 700000),
(9300230, 2022432, 1, 1, 0, 700000),
(9300230, 2022433, 1, 1, 0, 700000),
(9300231, 2022430, 1, 1, 0, 700000),
(9300231, 2022431, 1, 1, 0, 700000),
(9300231, 2022432, 1, 1, 0, 700000),
(9300231, 2022433, 1, 1, 0, 700000),
(9300232, 2022430, 1, 1, 0, 700000),
(9300232, 2022431, 1, 1, 0, 700000),
(9300232, 2022432, 1, 1, 0, 700000),
(9300232, 2022433, 1, 1, 0, 700000),
(9300233, 2022430, 1, 1, 0, 700000),
(9300233, 2022431, 1, 1, 0, 700000),
(9300233, 2022432, 1, 1, 0, 700000),
(9300233, 2022433, 1, 1, 0, 700000),
(9300234, 2022430, 1, 1, 0, 700000),
(9300234, 2022431, 1, 1, 0, 700000),
(9300234, 2022432, 1, 1, 0, 700000),
(9300234, 2022433, 1, 1, 0, 700000),
(9300235, 2022430, 1, 1, 0, 700000),
(9300235, 2022431, 1, 1, 0, 700000),
(9300235, 2022432, 1, 1, 0, 700000),
(9300235, 2022433, 1, 1, 0, 700000),
(9300236, 2022430, 1, 1, 0, 700000),
(9300236, 2022431, 1, 1, 0, 700000),
(9300236, 2022432, 1, 1, 0, 700000),
(9300236, 2022433, 1, 1, 0, 700000),
(9300237, 2022430, 1, 1, 0, 700000),
(9300237, 2022431, 1, 1, 0, 700000),
(9300237, 2022432, 1, 1, 0, 700000),
(9300237, 2022433, 1, 1, 0, 700000),
(9300238, 2022430, 1, 1, 0, 700000),
(9300238, 2022431, 1, 1, 0, 700000),
(9300238, 2022432, 1, 1, 0, 700000),
(9300238, 2022433, 1, 1, 0, 700000),
(9300239, 2022430, 1, 1, 0, 700000),
(9300239, 2022431, 1, 1, 0, 700000),
(9300239, 2022432, 1, 1, 0, 700000),
(9300239, 2022433, 1, 1, 0, 700000),
(9300240, 2022430, 1, 1, 0, 700000),
(9300240, 2022431, 1, 1, 0, 700000),
(9300240, 2022432, 1, 1, 0, 700000),
(9300240, 2022433, 1, 1, 0, 700000),
(9300241, 2022430, 1, 1, 0, 700000),
(9300241, 2022431, 1, 1, 0, 700000),
(9300241, 2022432, 1, 1, 0, 700000),
(9300241, 2022433, 1, 1, 0, 700000),
(9300242, 2022430, 1, 1, 0, 700000),
(9300242, 2022431, 1, 1, 0, 700000),
(9300242, 2022432, 1, 1, 0, 700000),
(9300242, 2022433, 1, 1, 0, 700000),
(9300243, 2022430, 1, 1, 0, 700000),
(9300243, 2022431, 1, 1, 0, 700000),
(9300243, 2022432, 1, 1, 0, 700000),
(9300243, 2022433, 1, 1, 0, 700000),
(9300244, 2022430, 1, 1, 0, 700000),
(9300244, 2022431, 1, 1, 0, 700000),
(9300244, 2022432, 1, 1, 0, 700000),
(9300244, 2022433, 1, 1, 0, 700000),
(9300245, 2022430, 1, 1, 0, 700000),
(9300245, 2022431, 1, 1, 0, 700000),
(9300245, 2022432, 1, 1, 0, 700000),
(9300245, 2022433, 1, 1, 0, 700000),
(9300246, 2022430, 1, 1, 0, 700000),
(9300246, 2022431, 1, 1, 0, 700000),
(9300246, 2022432, 1, 1, 0, 700000),
(9300246, 2022433, 1, 1, 0, 700000),
(9300247, 2022430, 1, 1, 0, 700000),
(9300247, 2022431, 1, 1, 0, 700000),
(9300247, 2022432, 1, 1, 0, 700000),
(9300247, 2022433, 1, 1, 0, 700000),
(9300248, 2022430, 1, 1, 0, 700000),
(9300248, 2022431, 1, 1, 0, 700000),
(9300248, 2022432, 1, 1, 0, 700000),
(9300248, 2022433, 1, 1, 0, 700000),
(9300249, 2022430, 1, 1, 0, 700000),
(9300249, 2022431, 1, 1, 0, 700000),
(9300249, 2022432, 1, 1, 0, 700000),
(9300249, 2022433, 1, 1, 0, 700000),
(9300250, 2022430, 1, 1, 0, 700000),
(9300250, 2022431, 1, 1, 0, 700000),
(9300250, 2022432, 1, 1, 0, 700000),
(9300250, 2022433, 1, 1, 0, 700000),
(9300251, 2022430, 1, 1, 0, 700000),
(9300251, 2022431, 1, 1, 0, 700000),
(9300251, 2022432, 1, 1, 0, 700000),
(9300251, 2022433, 1, 1, 0, 700000),
(9300252, 2022430, 1, 1, 0, 700000),
(9300252, 2022431, 1, 1, 0, 700000),
(9300252, 2022432, 1, 1, 0, 700000),
(9300252, 2022433, 1, 1, 0, 700000),
(9300253, 2022430, 1, 1, 0, 700000),
(9300253, 2022431, 1, 1, 0, 700000),
(9300253, 2022432, 1, 1, 0, 700000),
(9300253, 2022433, 1, 1, 0, 700000),
(9300254, 2022430, 1, 1, 0, 700000),
(9300254, 2022431, 1, 1, 0, 700000),
(9300254, 2022432, 1, 1, 0, 700000),
(9300254, 2022433, 1, 1, 0, 700000),
(9300255, 2022430, 1, 1, 0, 700000),
(9300255, 2022431, 1, 1, 0, 700000),
(9300255, 2022432, 1, 1, 0, 700000),
(9300255, 2022433, 1, 1, 0, 700000),
(9300256, 2022430, 1, 1, 0, 700000),
(9300256, 2022431, 1, 1, 0, 700000),
(9300256, 2022432, 1, 1, 0, 700000),
(9300256, 2022433, 1, 1, 0, 700000),
(9300257, 2022430, 1, 1, 0, 700000),
(9300257, 2022431, 1, 1, 0, 700000),
(9300257, 2022432, 1, 1, 0, 700000),
(9300257, 2022433, 1, 1, 0, 700000),
(9300258, 2022430, 1, 1, 0, 700000),
(9300258, 2022431, 1, 1, 0, 700000),
(9300258, 2022432, 1, 1, 0, 700000),
(9300258, 2022433, 1, 1, 0, 700000),
(9300259, 2022430, 1, 1, 0, 700000),
(9300259, 2022431, 1, 1, 0, 700000),
(9300259, 2022432, 1, 1, 0, 700000),
(9300259, 2022433, 1, 1, 0, 700000),
(9300260, 2022430, 1, 1, 0, 700000),
(9300260, 2022431, 1, 1, 0, 700000),
(9300260, 2022432, 1, 1, 0, 700000),
(9300260, 2022433, 1, 1, 0, 700000),
(9300261, 2022430, 1, 1, 0, 700000),
(9300261, 2022431, 1, 1, 0, 700000),
(9300261, 2022432, 1, 1, 0, 700000),
(9300261, 2022433, 1, 1, 0, 700000),
(9300262, 2022430, 1, 1, 0, 700000),
(9300262, 2022431, 1, 1, 0, 700000),
(9300262, 2022432, 1, 1, 0, 700000),
(9300262, 2022433, 1, 1, 0, 700000),
(9300263, 2022430, 1, 1, 0, 700000),
(9300263, 2022431, 1, 1, 0, 700000),
(9300263, 2022432, 1, 1, 0, 700000),
(9300263, 2022433, 1, 1, 0, 700000),
(9300264, 2022430, 1, 1, 0, 700000),
(9300264, 2022431, 1, 1, 0, 700000),
(9300264, 2022432, 1, 1, 0, 700000),
(9300264, 2022433, 1, 1, 0, 700000),
(9300265, 2022430, 1, 1, 0, 700000),
(9300265, 2022431, 1, 1, 0, 700000),
(9300265, 2022432, 1, 1, 0, 700000),
(9300265, 2022433, 1, 1, 0, 700000),
(9300266, 2022430, 1, 1, 0, 700000),
(9300266, 2022431, 1, 1, 0, 700000),
(9300266, 2022432, 1, 1, 0, 700000),
(9300266, 2022433, 1, 1, 0, 700000),
(9300267, 2022430, 1, 1, 0, 700000),
(9300267, 2022431, 1, 1, 0, 700000),
(9300267, 2022432, 1, 1, 0, 700000),
(9300267, 2022433, 1, 1, 0, 700000),
(9300270, 2022430, 1, 1, 0, 700000),
(9300270, 2022431, 1, 1, 0, 700000),
(9300270, 2022432, 1, 1, 0, 700000),
(9300270, 2022433, 1, 1, 0, 700000),
(8140500, 4007007, 1, 1, 0, 10000),
(4230502, 4007007, 1, 1, 0, 10000),
(3210205, 4007007, 1, 1, 0, 10000),
(8200012, 4007007, 1, 1, 0, 10000),
(8150200, 4007007, 1, 1, 0, 10000),
(5120003, 4007007, 1, 1, 0, 10000),
(5130104, 4007007, 1, 1, 0, 10000),
(6110300, 4007007, 1, 1, 0, 10000),
(7130000, 4007007, 1, 1, 0, 10000),
(4230119, 4007007, 1, 1, 0, 10000),
(6130204, 4007007, 1, 1, 0, 10000),
(3110102, 4007007, 1, 1, 0, 10000),
(8142100, 4007007, 1, 1, 0, 10000),
(8190003, 4007007, 1, 1, 0, 10000),
(5120506, 4007007, 1, 1, 0, 10000),
(4230118, 4007007, 1, 1, 0, 10000),
(4230101, 4007007, 1, 1, 0, 10000),
(7130104, 4007002, 1, 1, 0, 10000),
(3230400, 4007002, 1, 1, 0, 10000),
(5300001, 4007002, 1, 1, 0, 10000),
(4230124, 4007002, 1, 1, 0, 10000),
(7140000, 4007002, 1, 1, 0, 10000),
(8143000, 4007002, 1, 1, 0, 10000),
(4110300, 4007002, 1, 1, 0, 10000),
(5100000, 4007002, 1, 1, 0, 10000),
(4230106, 4007002, 1, 1, 0, 10000),
(4230115, 4007002, 1, 1, 0, 10000),
(6230500, 4007002, 1, 1, 0, 10000),
(9400011, 4007002, 1, 1, 0, 10000),
(3210208, 4007002, 1, 1, 0, 10000),
(6110301, 4007002, 1, 1, 0, 10000),
(8141000, 4007002, 1, 1, 0, 10000),
(8190003, 4007002, 1, 1, 0, 10000),
(5120506, 4007002, 1, 1, 0, 10000),
(4230101, 4007002, 1, 1, 0, 10000),
(3230306, 4007000, 1, 1, 0, 10000),
(5130103, 4007000, 1, 1, 0, 10000),
(3110300, 4007000, 1, 1, 0, 10000),
(4230600, 4007000, 1, 1, 0, 10000),
(8150200, 4007000, 1, 1, 0, 10000),
(7110301, 4007000, 1, 1, 0, 10000),
(3210200, 4007000, 1, 1, 0, 10000),
(8190000, 4007000, 1, 1, 0, 10000),
(5400000, 4007000, 1, 1, 0, 10000),
(3230101, 4007000, 1, 1, 0, 10000),
(5100000, 4007000, 1, 1, 0, 10000),
(4230115, 4007000, 1, 1, 0, 10000),
(5110302, 4007000, 1, 1, 0, 10000),
(4230114, 4007000, 1, 1, 0, 10000),
(4110301, 4007000, 1, 1, 0, 10000),
(8142100, 4007000, 1, 1, 0, 10000),
(5110301, 4007000, 1, 1, 0, 10000),
(5100004, 4007000, 1, 1, 0, 10000),
(6110301, 4007000, 1, 1, 0, 10000),
(8190003, 4007000, 1, 1, 0, 10000),
(6230400, 4007000, 1, 1, 0, 10000),
(3230200, 4007000, 1, 1, 0, 10000),
(5130101, 4007000, 1, 1, 0, 10000),
(5120503, 4007000, 1, 1, 0, 10000),
(5120504, 4007000, 1, 1, 0, 10000),
(4230102, 4007000, 1, 1, 0, 10000),
(4230101, 4007000, 1, 1, 0, 10000),
(3210100, 4007003, 1, 1, 0, 10000),
(5120001, 4007003, 1, 1, 0, 10000),
(3230101, 4007003, 1, 1, 0, 10000),
(3110302, 4007003, 1, 1, 0, 10000),
(4230101, 4007003, 1, 1, 0, 10000),
(4230119, 4007003, 1, 1, 0, 10000),
(4250000, 4007003, 1, 1, 0, 10000),
(4230102, 4007003, 1, 1, 0, 10000),
(5110302, 4007003, 1, 1, 0, 10000),
(9400012, 4007003, 1, 1, 0, 10000),
(8140110, 4007003, 1, 1, 0, 10000),
(8150201, 4007003, 1, 1, 0, 10000),
(8190003, 4007003, 1, 1, 0, 10000),
(3110100, 4007005, 1, 1, 0, 10000),
(3210205, 4007005, 1, 1, 0, 10000),
(5400000, 4007005, 1, 1, 0, 10000),
(3230306, 4007005, 1, 1, 0, 10000),
(4230101, 4007005, 1, 1, 0, 10000),
(4230107, 4007005, 1, 1, 0, 10000),
(4250000, 4007005, 1, 1, 0, 10000),
(4110301, 4007005, 1, 1, 0, 10000),
(5130107, 4007005, 1, 1, 0, 10000),
(6110300, 4007005, 1, 1, 0, 10000),
(8200003, 4007005, 1, 1, 0, 10000),
(8190000, 4007005, 1, 1, 0, 10000),
(3110300, 4007006, 1, 1, 0, 10000),
(5400000, 4007006, 1, 1, 0, 10000),
(3210200, 4007006, 1, 1, 0, 10000),
(4230101, 4007006, 1, 1, 0, 10000),
(4110302, 4007006, 1, 1, 0, 10000),
(4110301, 4007006, 1, 1, 0, 10000),
(4230115, 4007006, 1, 1, 0, 10000),
(4230102, 4007006, 1, 1, 0, 10000),
(4230600, 4007006, 1, 1, 0, 10000),
(5120504, 4007006, 1, 1, 0, 10000),
(5130103, 4007006, 1, 1, 0, 10000),
(5110301, 4007006, 1, 1, 0, 10000),
(5130101, 4007006, 1, 1, 0, 10000),
(5100004, 4007006, 1, 1, 0, 10000),
(5110302, 4007006, 1, 1, 0, 10000),
(8142100, 4007006, 1, 1, 0, 10000),
(8200001, 4007006, 1, 1, 0, 10000),
(3210100, 4007001, 1, 1, 0, 10000),
(2230102, 4007001, 1, 1, 0, 10000),
(3110102, 4007001, 1, 1, 0, 10000),
(3210200, 4007001, 1, 1, 0, 10000),
(4230200, 4007001, 1, 1, 0, 10000),
(4230101, 4007001, 1, 1, 0, 10000),
(4230105, 4007001, 1, 1, 0, 10000),
(4230122, 4007001, 1, 1, 0, 10000),
(4110302, 4007001, 1, 1, 0, 10000),
(5100000, 4007001, 1, 1, 0, 10000),
(5130103, 4007001, 1, 1, 0, 10000),
(5120001, 4007001, 1, 1, 0, 10000),
(5120003, 4007001, 1, 1, 0, 10000),
(5130101, 4007001, 1, 1, 0, 10000),
(6130209, 4007001, 1, 1, 0, 10000),
(7110301, 4007001, 1, 1, 0, 10000),
(8200000, 4007001, 1, 1, 0, 10000),
(8140110, 4007001, 1, 1, 0, 10000),
(7160000, 4007001, 1, 1, 0, 10000),
(8140101, 4007001, 1, 1, 0, 10000),
(8140500, 4007001, 1, 1, 0, 10000),
(8141300, 4007001, 1, 1, 0, 10000),
(8200003, 4007001, 1, 1, 0, 10000),
(8190002, 4007001, 1, 1, 0, 10000),
(8190005, 4007001, 1, 1, 0, 10000),
(8200012, 4007001, 1, 1, 0, 10000),
(4110300, 4007004, 1, 1, 0, 10000),
(3230400, 4007004, 1, 1, 0, 10000),
(3110300, 4007004, 1, 1, 0, 10000),
(5300001, 4007004, 1, 1, 0, 10000),
(3210208, 4007004, 1, 1, 0, 10000),
(3210450, 4007004, 1, 1, 0, 10000),
(4230113, 4007004, 1, 1, 0, 10000),
(4230101, 4007004, 1, 1, 0, 10000),
(4230119, 4007004, 1, 1, 0, 10000),
(4230600, 4007004, 1, 1, 0, 10000),
(5120503, 4007004, 1, 1, 0, 10000),
(5130107, 4007004, 1, 1, 0, 10000),
(6130103, 4007004, 1, 1, 0, 10000),
(6130208, 4007004, 1, 1, 0, 10000),
(8190003, 4007004, 1, 1, 0, 10000),
(8200009, 4007004, 1, 1, 0, 10000),
(8200011, 4007004, 1, 1, 0, 10000),
(8200001, 4007004, 1, 1, 0, 10000),
(9420003, 4007004, 1, 1, 0, 10000),
(4130104, 4000062, 1, 1, 0, 10000),
(4230122, 4000058, 1, 1, 0, 10000),
(9001000, 4031059, 1, 1, 0, 999999),
(9001001, 4031059, 1, 1, 0, 999999),
(9001002, 4031059, 1, 1, 0, 999999),
(9001003, 4031059, 1, 1, 0, 999999),
(9001004, 4031059, 1, 1, 0, 999999),
(9001005, 4031857, 1, 1, 2192, 700000),
(9001012, 4032311, 1, 1, 0, 300000),
(9001012, 4032311, 1, 1, 0, 300000),
(9001013, 4032339, 1, 1, 21303, 999999),
(4230113, 1452016, 1, 1, 0, 700),
(4230103, 1452016, 1, 1, 0, 700),
(2230102, 1452016, 1, 1, 0, 700),
(6230100, 1452016, 1, 1, 0, 700),
(2110200, 1452016, 1, 1, 0, 700),
(2230104, 1452016, 1, 1, 0, 700),
(9400570, 1452016, 1, 1, 0, 700),
(4230106, 1452016, 1, 1, 0, 700),
(5120502, 1452016, 1, 1, 0, 700),
(3230400, 1452022, 1, 1, 0, 700),
(2230102, 1452022, 1, 1, 0, 700),
(6130100, 1452022, 1, 1, 0, 700),
(4230103, 1452022, 1, 1, 0, 700),
(5130100, 1452022, 1, 1, 0, 700),
(9400570, 1452022, 1, 1, 0, 700),
(3210208, 1452022, 1, 1, 0, 700),
(6130204, 1452022, 1, 1, 0, 700),
(7130103, 1452022, 1, 1, 0, 700),
(8140000, 1452022, 1, 1, 0, 700),
(5200000, 1452022, 1, 1, 0, 700),
(2100104, 1452022, 1, 1, 0, 700),
(3210800, 1452022, 1, 1, 0, 700),
(4230121, 1452022, 1, 1, 0, 700),
(4230101, 1472030, 1, 1, 0, 700),
(4230102, 1472030, 1, 1, 0, 700),
(7130100, 1472030, 1, 1, 0, 700),
(2230101, 1472030, 1, 1, 0, 700),
(3210200, 1472030, 1, 1, 0, 700),
(7130200, 1472030, 1, 1, 0, 700),
(9400570, 1472030, 1, 1, 0, 700),
(2230110, 1472030, 1, 1, 0, 700),
(5200001, 1472030, 1, 1, 0, 700),
(3110303, 1472030, 1, 1, 0, 700),
(4130101, 1472030, 1, 1, 0, 700),
(5120506, 1472030, 1, 1, 0, 700),
(1130100, 1472032, 1, 1, 0, 700),
(4230111, 1472032, 1, 1, 0, 700),
(4230112, 1472032, 1, 1, 0, 700),
(7130102, 1472032, 1, 1, 0, 700),
(3210100, 1472032, 1, 1, 0, 700),
(2230102, 1472032, 1, 1, 0, 700),
(4130100, 1472032, 1, 1, 0, 700),
(9400570, 1472032, 1, 1, 0, 700),
(3230306, 1472032, 1, 1, 0, 700),
(6130203, 1472032, 1, 1, 0, 700),
(7130000, 1472032, 1, 1, 0, 700),
(8140002, 1472032, 1, 1, 0, 700),
(3230200, 1462014, 1, 1, 0, 700),
(4230109, 1462014, 1, 1, 0, 700),
(2230102, 1462014, 1, 1, 0, 700),
(9400570, 1462014, 1, 1, 0, 700),
(5300100, 1462019, 1, 1, 0, 700),
(4230109, 1462019, 1, 1, 0, 700),
(4230110, 1462019, 1, 1, 0, 700),
(9400570, 1462019, 1, 1, 0, 700),
(5400000, 1462019, 1, 1, 0, 700),
(4230505, 1462019, 1, 1, 0, 700),
(6230602, 1462019, 1, 1, 0, 700),
(7110301, 1462019, 1, 1, 0, 700),
(7140000, 1462019, 1, 1, 0, 700),
(2230102, 1332025, 1, 1, 0, 700),
(8140500, 1332025, 1, 1, 0, 700),
(2230103, 1332025, 1, 1, 0, 700),
(4230101, 1332025, 1, 1, 0, 700),
(9400570, 1332025, 1, 1, 0, 700),
(3100101, 1332025, 1, 1, 0, 700),
(4230117, 1332025, 1, 1, 0, 700),
(5110302, 1332025, 1, 1, 0, 700),
(7130500, 1332025, 1, 1, 0, 700),
(7130200, 1332025, 1, 1, 0, 700),
(9400570, 1302020, 1, 1, 0, 700),
(6110300, 1382039, 1, 1, 0, 750),
(5100002, 1382039, 1, 1, 0, 750),
(6230300, 1332056, 1, 1, 0, 750),
(5120505, 1332056, 1, 1, 0, 750),
(5120502, 1332056, 1, 1, 0, 750),
(5110302, 1332056, 1, 1, 0, 750),
(5100005, 1332056, 1, 1, 0, 750),
(9400512, 1302030, 1, 1, 0, 700),
(3000005, 1302030, 1, 1, 0, 700),
(4230102, 1302030, 1, 1, 0, 700),
(9400570, 1302030, 1, 1, 0, 700),
(3110102, 1302030, 1, 1, 0, 700),
(4230124, 1302030, 1, 1, 0, 700),
(5150001, 1302030, 1, 1, 0, 700),
(6400000, 1302030, 1, 1, 0, 700),
(4230105, 1442024, 1, 1, 0, 700),
(3110100, 1442024, 1, 1, 0, 700),
(8110300, 1442024, 1, 1, 0, 700),
(9400570, 1442024, 1, 1, 0, 700),
(3230100, 1442024, 1, 1, 0, 700),
(4230300, 1442024, 1, 1, 0, 700),
(6130207, 1442024, 1, 1, 0, 700),
(7130002, 1442024, 1, 1, 0, 700),
(3230305, 1432012, 1, 1, 0, 700),
(6230300, 1432012, 1, 1, 0, 700),
(2230102, 1432012, 1, 1, 0, 700),
(9400570, 1432012, 1, 1, 0, 700),
(3230200, 1432012, 1, 1, 0, 700),
(4230118, 1432012, 1, 1, 0, 700),
(6130202, 1432012, 1, 1, 0, 700),
(6110300, 1432012, 1, 1, 0, 700),
(7130004, 1432012, 1, 1, 0, 700),
(7130300, 1382009, 1, 1, 0, 700),
(3000000, 1382009, 1, 1, 0, 700),
(3110100, 1382009, 1, 1, 0, 700),
(9400570, 1382009, 1, 1, 0, 700),
(2230103, 1382009, 1, 1, 0, 700),
(2100107, 1382009, 1, 1, 0, 700),
(3210100, 1382009, 1, 1, 0, 700),
(4230502, 1382009, 1, 1, 0, 700),
(9420530, 1482007, 1, 1, 0, 2000),
(9420530, 1002166, 1, 1, 0, 2000),
(9420530, 1002212, 1, 1, 0, 2000),
(9420530, 1032012, 1, 1, 0, 1800),
(9420530, 1060080, 1, 1, 0, 2000),
(9420530, 1040091, 1, 1, 0, 2000),
(9420530, 1051010, 1, 1, 0, 1800),
(9420530, 1051006, 1, 1, 0, 1800),
(9420530, 1082028, 1, 1, 0, 2000),
(9420530, 1092008, 1, 1, 0, 1800),
(9420534, 1082104, 1, 1, 0, 2000),
(9420534, 1072041, 1, 1, 0, 2000),
(9420534, 1061102, 1, 1, 0, 2000),
(9420534, 1041103, 1, 1, 0, 2000),
(9420534, 1050068, 1, 1, 0, 1800),
(9420534, 1050067, 1, 1, 0, 1800),
(9420534, 1061077, 1, 1, 0, 2000),
(9420534, 1032011, 1, 1, 0, 1800),
(9420534, 1472016, 1, 1, 0, 1300),
(9420534, 1442037, 1, 1, 0, 1800),
(9420534, 2044701, 1, 1, 0, 1000),
(9420534, 4130013, 1, 1, 0, 5000),
(9420534, 4004004, 1, 1, 0, 5000),
(9420534, 4010002, 1, 1, 0, 300),
(9420536, 1051079, 1, 1, 0, 1800),
(9420536, 1050082, 1, 1, 0, 1800),
(9420536, 1050064, 1, 1, 0, 1800),
(9420536, 1051065, 1, 1, 0, 1800),
(9420536, 1051058, 1, 1, 0, 1800),
(9420536, 1050074, 1, 1, 0, 1800),
(9420536, 1092016, 1, 1, 0, 1800),
(9420536, 1072154, 1, 1, 0, 2000),
(9420536, 1072167, 1, 1, 0, 2000),
(9420536, 1082105, 1, 1, 0, 2000),
(9420536, 1082097, 1, 1, 0, 2000),
(9420536, 1382007, 1, 1, 0, 1800),
(5130102, 1322054, 1, 1, 0, 750),
(5110302, 1322054, 1, 1, 0, 750),
(5250002, 1422029, 1, 1, 0, 750),
(6230500, 1422029, 1, 1, 0, 750),
(6130209, 1422029, 1, 1, 0, 750),
(5030107, 1422029, 1, 1, 0, 750),
(5130105, 1422029, 1, 1, 0, 750),
(6110301, 1312032, 1, 1, 0, 750),
(5300100, 1312032, 1, 1, 0, 750),
(5120506, 1312032, 1, 1, 0, 750),
(5120002, 1312032, 1, 1, 0, 750),
(5110301, 1312032, 1, 1, 0, 750),
(5250002, 1092046, 1, 1, 0, 750),
(6300000, 1092046, 1, 1, 0, 750),
(5130104, 1092046, 1, 1, 0, 750),
(6130209, 1092045, 1, 1, 0, 750),
(6130209, 1432040, 1, 1, 0, 750),
(6110300, 1432040, 1, 1, 0, 750),
(5130104, 1432040, 1, 1, 0, 750),
(5120100, 1432040, 1, 1, 0, 750),
(5120001, 1432040, 1, 1, 0, 750),
(6300000, 1402039, 1, 1, 0, 750),
(6130200, 1402039, 1, 1, 0, 750),
(5150000, 1402039, 1, 1, 0, 750),
(5120506, 1402039, 1, 1, 0, 750),
(5120502, 1442051, 1, 1, 0, 750),
(5110302, 1442051, 1, 1, 0, 750),
(6230601, 1482022, 1, 1, 0, 750),
(6230401, 1482022, 1, 1, 0, 750),
(5130104, 1482022, 1, 1, 0, 750),
(5120003, 1482022, 1, 1, 0, 750),
(5100002, 1482022, 1, 1, 0, 750),
(7130500, 1492022, 1, 1, 0, 750),
(7130402, 1492022, 1, 1, 0, 1250),
(6300002, 1492022, 1, 1, 0, 750),
(6230600, 1332055, 1, 1, 0, 750),
(6230400, 1332055, 1, 1, 0, 750),
(6130204, 1332055, 1, 1, 0, 750),
(6110300, 1332055, 1, 1, 0, 750),
(5150001, 1332055, 1, 1, 0, 750),
(6230601, 1462040, 1, 1, 0, 750),
(6130209, 1462040, 1, 1, 0, 750),
(5140000, 1462040, 1, 1, 0, 750),
(6220001, 1472055, 1, 1, 0, 1250),
(6220000, 1472055, 1, 1, 0, 1250),
(5120500, 1472055, 1, 1, 0, 750),
(5120000, 1472055, 1, 1, 0, 750),
(9001006, 4031856, 1, 1, 2191, 700000),
(9400218, 4001106, 25, 50, 0, 999999),
(9400217, 4001106, 1, 3, 0, 999999),
(2110200, 4032390, 1, 1, 2248, 200000),
(8140200, 1382012, 1, 1, 0, 700),
(7130600, 1382012, 1, 1, 0, 700),
(5100004, 1382012, 1, 1, 0, 700),
(4230123, 1382012, 1, 1, 0, 700),
(5300001, 1382012, 1, 1, 0, 700),
(9400570, 1382012, 1, 1, 0, 700),
(2110200, 1382012, 1, 1, 0, 700),
(6300001, 1492021, 1, 1, 0, 700),
(3230102, 1492021, 1, 1, 0, 700),
(3000006, 1492021, 1, 1, 0, 700),
(5130101, 1492020, 1, 1, 0, 700),
(5200002, 1492020, 1, 1, 0, 700),
(1140100, 1492020, 1, 1, 0, 700),
(7160000, 1482021, 1, 1, 0, 700),
(7130501, 1482021, 1, 1, 0, 700),
(6130208, 1482021, 1, 1, 0, 700),
(4230503, 1422014, 1, 1, 0, 700),
(3230302, 1422014, 1, 1, 0, 700),
(9400570, 1422014, 1, 1, 0, 700),
(7130001, 1422014, 1, 1, 0, 700),
(7130000, 1422014, 1, 1, 0, 700),
(3000005, 1422014, 1, 1, 0, 700),
(5130100, 1422014, 1, 1, 0, 700),
(7130100, 1422014, 1, 1, 0, 700),
(9420530, 1472013, 1, 1, 0, 1300),
(9420530, 1462007, 1, 1, 0, 1500),
(9420530, 1452007, 1, 1, 0, 1500),
(9420530, 1432004, 1, 1, 0, 1500),
(9420530, 1382019, 1, 1, 0, 1800),
(9420530, 2041002, 1, 1, 0, 1000),
(9420530, 2040901, 1, 1, 0, 1000);
INSERT IGNORE INTO `temp_data` (`dropperid`, `itemid`, `minimum_quantity`, `maximum_quantity`, `questid`, `chance`) VALUES
(9420530, 2020014, 1, 1, 0, 10000),
(9420530, 400006, 1, 1, 0, 333333),
(9420530, 400002, 1, 1, 0, 10000),
(9420534, 4020008, 1, 1, 0, 300),
(9420534, 4006000, 1, 1, 0, 5000),
(9420534, 400004, 1, 1, 0, 333333),
(9420534, 400002, 1, 1, 0, 10000),
(9420534, 4000472, 1, 1, 0, 300000),
(9420536, 2332000, 1, 1, 0, 500),
(9420536, 2330004, 1, 1, 0, 500),
(9420536, 1482009, 1, 1, 0, 2000),
(9420536, 1082204, 1, 1, 0, 2000),
(9420536, 1072309, 1, 1, 0, 2000),
(9420536, 1002095, 1, 1, 0, 2000),
(9420536, 1002273, 1, 1, 0, 2000),
(9420536, 1002278, 1, 1, 0, 2000),
(9420536, 1032021, 1, 1, 0, 1800),
(9420536, 1332019, 1, 1, 0, 1500),
(9420536, 1462011, 1, 1, 0, 1500),
(9420536, 1452011, 1, 1, 0, 1500),
(9420536, 1422005, 1, 1, 0, 1800),
(9420536, 2040805, 1, 1, 0, 1000),
(9420536, 400004, 1, 1, 0, 333333),
(9420536, 2022003, 1, 1, 0, 333333),
(9420536, 2070008, 1, 1, 0, 500),
(9420536, 4000474, 1, 1, 0, 300000),
(6130203, 1322054, 1, 1, 0, 750),
(6130100, 1322054, 1, 1, 0, 750),
(5130108, 1322054, 1, 1, 0, 750),
(6230601, 1412027, 1, 1, 0, 750),
(6230401, 1412027, 1, 1, 0, 750),
(6130209, 1412027, 1, 1, 0, 750),
(6110301, 1412027, 1, 1, 0, 750),
(5120506, 1412027, 1, 1, 0, 750),
(6230601, 1092047, 1, 1, 0, 750),
(6230401, 1092047, 1, 1, 0, 750),
(6220001, 1092047, 1, 1, 0, 750),
(6230602, 1092047, 1, 1, 0, 750),
(5140000, 1092047, 1, 1, 0, 750),
(5130101, 1092046, 1, 1, 0, 750),
(6110300, 1092046, 1, 1, 0, 750),
(5120500, 1092045, 1, 1, 0, 750),
(6300001, 1092045, 1, 1, 0, 750),
(6230300, 1092045, 1, 1, 0, 750),
(6230401, 1092045, 1, 1, 0, 750),
(5120002, 1402039, 1, 1, 0, 750),
(5250000, 1302064, 1, 1, 0, 750),
(5130104, 1302064, 1, 1, 0, 750),
(5130101, 1302064, 1, 1, 0, 750),
(5120506, 1302064, 1, 1, 0, 750),
(5120502, 1302064, 1, 1, 0, 750),
(5250002, 1442051, 1, 1, 0, 750),
(5250001, 1442051, 1, 1, 0, 750),
(5250000, 1442051, 1, 1, 0, 750),
(6230500, 1492022, 1, 1, 0, 750),
(5220003, 1492022, 1, 1, 0, 1250),
(6230401, 1372034, 1, 1, 0, 750),
(6230400, 1372034, 1, 1, 0, 750),
(5250000, 1372034, 1, 1, 0, 750),
(5120503, 1372034, 1, 1, 0, 750),
(5100004, 1372034, 1, 1, 0, 750),
(6230201, 1382039, 1, 1, 0, 750),
(6130218, 1382039, 1, 1, 0, 750),
(6130204, 1382039, 1, 1, 0, 750),
(5130102, 1462040, 1, 1, 0, 750),
(5130101, 1462040, 1, 1, 0, 750),
(6300001, 1452045, 1, 1, 0, 750),
(6230602, 1452045, 1, 1, 0, 750),
(6230100, 1452045, 1, 1, 0, 750),
(6130209, 1452045, 1, 1, 0, 750),
(5130108, 1452045, 1, 1, 0, 750),
(6230400, 1472055, 1, 1, 0, 750),
(9400216, 4001106, 1, 3, 0, 999999),
(9400215, 4001106, 1, 3, 0, 999999),
(9400214, 4001106, 1, 3, 0, 999999),
(9400213, 4001106, 1, 3, 0, 999999),
(9400212, 4001106, 1, 1, 0, 999999),
(9400211, 4001106, 1, 1, 0, 999999),
(9400209, 4001106, 1, 3, 0, 999999),
(9400209, 4001106, 1, 3, 0, 999999),
(3110102, 1382012, 1, 1, 0, 700),
(2230107, 1092030, 1, 1, 0, 700),
(1210103, 1092030, 1, 1, 0, 700),
(4230114, 1092030, 1, 1, 0, 700),
(5100002, 1092030, 1, 1, 0, 700),
(4230600, 1092030, 1, 1, 0, 700),
(8140110, 1492021, 1, 1, 0, 700),
(6300100, 1492021, 1, 1, 0, 700),
(4240000, 1482021, 1, 1, 0, 700),
(4230500, 1482021, 1, 1, 0, 700),
(5130104, 1482020, 1, 1, 0, 700),
(4230116, 1482020, 1, 1, 0, 700),
(3230400, 1482020, 1, 1, 0, 700),
(2230101, 1482020, 1, 1, 0, 700),
(7130003, 1422014, 1, 1, 0, 700),
(7130104, 1422014, 1, 1, 0, 700),
(5130107, 1422014, 1, 1, 0, 700),
(4230100, 1422014, 1, 1, 0, 700),
(7130601, 1412011, 1, 1, 0, 700),
(6110301, 1412011, 1, 1, 0, 700),
(4230120, 1412011, 1, 1, 0, 700),
(3210205, 1412011, 1, 1, 0, 700),
(9400570, 1412011, 1, 1, 0, 700),
(7130001, 1412011, 1, 1, 0, 700),
(2230102, 1412011, 1, 1, 0, 700),
(9420530, 400004, 1, 1, 0, 333333),
(9420530, 2002009, 1, 1, 0, 333333),
(9420530, 4020007, 1, 1, 0, 300),
(9420530, 4010004, 1, 1, 0, 300),
(9420530, 4000468, 1, 1, 0, 300000),
(9420534, 2044901, 1, 1, 0, 1000),
(9420534, 2330003, 1, 1, 0, 500),
(9420534, 1002254, 1, 1, 0, 2000),
(9420534, 1382015, 1, 1, 0, 1800),
(9420534, 1452010, 1, 1, 0, 1500),
(9420530, 1492007, 1, 1, 0, 2000),
(9420015, 4000420, 1, 1, 0, 300000),
(9420015, 4000421, 1, 1, 0, 300000),
(9420500, 4000369, 1, 1, 0, 300000),
(9420500, 4000370, 1, 1, 0, 300000),
(9420500, 400001, 1, 1, 0, 333333),
(9420500, 2002002, 1, 1, 0, 333333),
(9420500, 2044002, 1, 1, 0, 1000),
(9420500, 1332001, 1, 1, 0, 1500),
(9420500, 1382002, 1, 1, 0, 1800),
(9420500, 1002178, 1, 1, 0, 2000),
(9420500, 2060000, 1, 1, 0, 10000),
(9420500, 4010006, 1, 1, 0, 300),
(9420500, 4020005, 1, 1, 0, 300),
(9420500, 2020028, 1, 1, 0, 20000),
(9420500, 400003, 1, 1, 0, 10000),
(9420500, 1060052, 1, 1, 0, 2000),
(9420500, 1051006, 1, 1, 0, 1800),
(9420500, 1051007, 1, 1, 0, 1800),
(9420500, 1002142, 1, 1, 0, 2000),
(9420500, 2061000, 1, 1, 0, 10000),
(9420500, 1422008, 1, 1, 0, 1800),
(9420500, 4030012, 1, 1, 0, 125000),
(9420500, 1052095, 1, 1, 0, 1800),
(9420500, 2330001, 1, 1, 0, 500),
(9420501, 4000372, 1, 1, 0, 300000),
(9420501, 400003, 1, 1, 0, 10000),
(9420501, 400002, 1, 1, 0, 10000),
(9420501, 404000, 1, 1, 0, 300),
(9420501, 4010005, 1, 1, 0, 300),
(9420501, 2043301, 1, 1, 0, 1000),
(9420501, 1072103, 1, 1, 0, 2000),
(9420501, 1032008, 1, 1, 0, 1800),
(9420501, 1050011, 1, 1, 0, 1800),
(9420501, 1040044, 1, 1, 0, 2000),
(9420501, 1060033, 1, 1, 0, 2000),
(9420501, 1302017, 1, 1, 0, 1800),
(9420501, 2048005, 1, 1, 0, 1000),
(9420501, 2020028, 1, 1, 0, 20000),
(9420501, 1050051, 1, 1, 0, 1800),
(9420501, 1040099, 1, 1, 0, 2000),
(9420501, 1060088, 1, 1, 0, 2000),
(9420501, 1050058, 1, 1, 0, 1800),
(9420501, 1332020, 1, 1, 0, 1500),
(9420501, 4006001, 1, 1, 0, 5000),
(9420501, 4030012, 1, 1, 0, 125000),
(9420501, 1072297, 1, 1, 0, 2000),
(9420501, 1482001, 1, 1, 0, 2000),
(9420501, 1482005, 1, 1, 0, 2000),
(9420501, 1492005, 1, 1, 0, 2000),
(9420502, 4000366, 1, 1, 0, 300000),
(9420502, 4000367, 1, 1, 0, 300000),
(9420502, 400000, 1, 1, 0, 10000),
(9420502, 2043202, 1, 1, 0, 1000),
(9420502, 1372001, 1, 1, 0, 1800),
(9420502, 400003, 1, 1, 0, 10000),
(9420502, 1072008, 1, 1, 0, 2000),
(9420502, 2060000, 1, 1, 0, 10000),
(9420502, 4010005, 1, 1, 0, 300),
(9420502, 4020004, 1, 1, 0, 300),
(9420502, 1312016, 1, 1, 0, 1800),
(9420502, 1051008, 1, 1, 0, 1800),
(9420502, 1051009, 1, 1, 0, 1800),
(9420502, 2020028, 1, 1, 0, 20000),
(9420502, 1092007, 1, 1, 0, 1800),
(9420502, 1002141, 1, 1, 0, 2000),
(9420502, 1002177, 1, 1, 0, 2000),
(9420502, 1040074, 1, 1, 0, 2000),
(9420502, 1060063, 1, 1, 0, 2000),
(9420502, 2061000, 1, 1, 0, 10000),
(9420502, 1402009, 1, 1, 0, 1800),
(9420502, 1002610, 1, 1, 0, 2000),
(9420502, 2330000, 1, 1, 0, 500),
(9420503, 4000371, 1, 1, 0, 300000),
(9420503, 4000370, 1, 1, 0, 300000),
(9420503, 1061047, 1, 1, 0, 2000),
(9420503, 1061048, 1, 1, 0, 2000),
(9420503, 1061049, 1, 1, 0, 2000),
(9420503, 2070001, 1, 1, 0, 500),
(9420503, 1060050, 1, 1, 0, 2000),
(9420503, 1060051, 1, 1, 0, 2000),
(9420503, 4001000, 1, 1, 0, 5000),
(9420503, 1040061, 1, 1, 0, 2000),
(9420503, 1002137, 1, 1, 0, 2000),
(9420503, 400002, 1, 1, 0, 10000),
(9420503, 400003, 1, 1, 0, 10000),
(9420503, 1002153, 1, 1, 0, 2000),
(9420503, 1002181, 1, 1, 0, 2000),
(9420503, 2020028, 1, 1, 0, 20000),
(9420503, 404000, 1, 1, 0, 300),
(9420503, 4010001, 1, 1, 0, 300),
(9420503, 1041075, 1, 1, 0, 2000),
(9420503, 1061070, 1, 1, 0, 2000),
(9420503, 1002613, 1, 1, 0, 2000),
(9420504, 4000377, 1, 1, 0, 300000),
(9420504, 4004004, 1, 1, 0, 5000),
(9420504, 400002, 1, 1, 0, 10000),
(9420504, 400004, 1, 1, 0, 333333),
(9420504, 400003, 1, 1, 0, 10000),
(9420504, 4010001, 1, 1, 0, 300),
(9420504, 404000, 1, 1, 0, 300),
(9420504, 1041086, 1, 1, 0, 2000),
(9420504, 1061085, 1, 1, 0, 2000),
(9420504, 1302013, 1, 1, 0, 1800),
(9420504, 1002083, 1, 1, 0, 2000),
(9420504, 1032007, 1, 1, 0, 1800),
(9420504, 1041080, 1, 1, 0, 2000),
(9420504, 1061079, 1, 1, 0, 2000),
(9420504, 1040094, 1, 1, 0, 2000),
(9420504, 1060083, 1, 1, 0, 2000),
(9420504, 1002211, 1, 1, 0, 2000),
(9420504, 1002212, 1, 1, 0, 2000),
(9420504, 2020028, 1, 1, 0, 20000),
(9420504, 1041092, 1, 1, 0, 2000),
(9420504, 1061091, 1, 1, 0, 2000),
(9420504, 1102003, 1, 1, 0, 2000),
(9420504, 4006001, 1, 1, 0, 5000),
(9420504, 4030012, 1, 1, 0, 125000),
(9420504, 1072291, 1, 1, 0, 2000),
(9420504, 1082186, 1, 1, 0, 2000),
(9420504, 1482003, 1, 1, 0, 1800),
(9420504, 2331000, 1, 1, 0, 500),
(9420505, 4000378, 1, 1, 0, 300000),
(9420505, 400002, 1, 1, 0, 10000),
(9420505, 2002004, 1, 1, 0, 10000),
(9420505, 1032002, 1, 1, 0, 1800),
(9420505, 1041014, 1, 1, 0, 2000),
(9420505, 1002185, 1, 1, 0, 2000),
(9420505, 1002167, 1, 1, 0, 2000),
(9420505, 2020028, 1, 1, 0, 20000),
(9420505, 4010006, 1, 1, 0, 300),
(9420505, 4020007, 1, 1, 0, 300),
(9420505, 1002036, 1, 1, 0, 2000),
(9420505, 400004, 1, 1, 0, 333333),
(9420505, 2070003, 1, 1, 0, 500),
(9420505, 1041065, 1, 1, 0, 2000),
(9420505, 1061060, 1, 1, 0, 2000),
(9420505, 1051038, 1, 1, 0, 1800),
(9420505, 1051039, 1, 1, 0, 1800),
(9420505, 4030012, 1, 1, 0, 125000),
(9420505, 1002616, 1, 1, 0, 2000),
(9420505, 1052101, 1, 1, 0, 1800),
(9420505, 1082183, 1, 1, 0, 2000),
(9420506, 4000368, 1, 1, 0, 300000),
(9420506, 400001, 1, 1, 0, 333333),
(9420506, 2002000, 1, 1, 0, 10000),
(9420506, 2044302, 1, 1, 0, 1000),
(9420506, 1032000, 1, 1, 0, 1800),
(9420506, 1002179, 1, 1, 0, 2000),
(9420506, 1050030, 1, 1, 0, 1800),
(9420506, 1050031, 1, 1, 0, 1800),
(9420506, 2060000, 1, 1, 0, 10000),
(9420506, 4010002, 1, 1, 0, 300),
(9420506, 4020003, 1, 1, 0, 300),
(9420506, 2020028, 1, 1, 0, 20000),
(9420506, 1432003, 1, 1, 0, 1500),
(9420506, 400003, 1, 1, 0, 10000),
(9420506, 1002035, 1, 1, 0, 2000),
(9420506, 2061000, 1, 1, 0, 10000),
(9420506, 1312007, 1, 1, 0, 1800),
(9420506, 1040021, 1, 1, 0, 2000),
(9420506, 1040081, 1, 1, 0, 2000),
(9420506, 1060070, 1, 1, 0, 2000),
(9420507, 4000374, 1, 1, 0, 300000),
(9420507, 4000375, 1, 1, 0, 300000),
(9420507, 4000376, 1, 1, 0, 300000),
(9420507, 400004, 1, 1, 0, 333333),
(9420507, 400003, 1, 1, 0, 10000),
(9420507, 4010003, 1, 1, 0, 300),
(9420507, 4020002, 1, 1, 0, 300),
(9420507, 1302016, 1, 1, 0, 1800),
(9420507, 1051032, 1, 1, 0, 1800),
(9420507, 1051033, 1, 1, 0, 1800),
(9420507, 2043201, 1, 1, 0, 1000),
(9420507, 1041027, 1, 1, 0, 1200),
(9420507, 1061025, 1, 1, 0, 1200),
(9420507, 1040089, 1, 1, 0, 1200),
(9420507, 1060078, 1, 1, 0, 1200),
(9420507, 2020028, 1, 1, 0, 20000),
(9420507, 1002213, 1, 1, 0, 1200),
(9420507, 1002214, 1, 1, 0, 1200),
(9420507, 1002216, 1, 1, 0, 1200),
(9420507, 1050053, 1, 1, 0, 1800),
(9420507, 1050054, 1, 1, 0, 1800),
(9420507, 1002242, 1, 1, 0, 1200),
(9420507, 1002243, 1, 1, 0, 1200),
(9420507, 1002619, 1, 1, 0, 1200),
(9420507, 1052104, 1, 1, 0, 1800),
(9420507, 1482002, 1, 1, 0, 1800),
(9420507, 1492002, 1, 1, 0, 1800),
(9420507, 2044802, 1, 1, 0, 1000),
(9420508, 4000373, 1, 1, 0, 300000),
(9420508, 400002, 1, 1, 0, 10000),
(9420508, 400003, 1, 1, 0, 10000),
(9420508, 4020005, 1, 1, 0, 300),
(9420508, 4010003, 1, 1, 0, 300),
(9420508, 400004, 1, 1, 0, 333333),
(9420508, 2060000, 1, 1, 0, 10000),
(9420508, 2061000, 1, 1, 0, 10000),
(9420508, 1060074, 1, 1, 0, 2000),
(9420508, 1002128, 1, 1, 0, 2000),
(9420508, 1072054, 1, 1, 0, 2000),
(9420508, 1051010, 1, 1, 0, 1800),
(9420508, 2020028, 1, 1, 0, 20000),
(9420508, 1041078, 1, 1, 0, 2000),
(9420508, 1061077, 1, 1, 0, 2000),
(9420508, 1040086, 1, 1, 0, 2000),
(9420508, 1040095, 1, 1, 0, 2000),
(9420508, 1060084, 1, 1, 0, 2000),
(9420508, 1041087, 1, 1, 0, 2000),
(9420508, 1061086, 1, 1, 0, 2000),
(9420508, 1002217, 1, 1, 0, 2000),
(9420508, 1072288, 1, 1, 0, 2000),
(9420508, 1072294, 1, 1, 0, 2000),
(9420508, 1482000, 1, 1, 0, 2000),
(9420508, 1482004, 1, 1, 0, 2000),
(9420508, 1482006, 1, 1, 0, 2000),
(9420508, 1492004, 1, 1, 0, 2000),
(9420508, 1492006, 1, 1, 0, 2000),
(9420509, 4000380, 1, 1, 0, 300000),
(9420509, 1050039, 1, 1, 0, 1800),
(9420509, 4004004, 1, 1, 0, 5000),
(9420509, 400003, 1, 1, 0, 10000),
(9420509, 400004, 1, 1, 0, 333333),
(9420509, 1051001, 1, 1, 0, 1800),
(9420509, 1051014, 1, 1, 0, 1800),
(9420509, 4020008, 1, 1, 0, 300),
(9420509, 2070004, 1, 1, 0, 500),
(9420509, 1060064, 1, 1, 0, 2000),
(9420509, 1040075, 1, 1, 0, 2000),
(9420509, 2044201, 1, 1, 0, 1000),
(9420509, 2020028, 1, 1, 0, 20000),
(9420509, 1402007, 1, 1, 0, 1800),
(9420509, 1050036, 1, 1, 0, 1800),
(9420509, 1050037, 1, 1, 0, 1800),
(9420509, 4001005, 1, 1, 0, 5000),
(9420509, 1050059, 1, 1, 0, 1800),
(9420509, 1050060, 1, 1, 0, 1800),
(9420509, 1041093, 1, 1, 0, 2000),
(9420509, 1061092, 1, 1, 0, 2000),
(9420509, 1002631, 1, 1, 0, 2000),
(9420509, 1052116, 1, 1, 0, 1800),
(9420509, 2330002, 1, 1, 0, 500),
(9420510, 4000379, 1, 1, 0, 300000),
(9420510, 1061071, 1, 1, 0, 2000),
(9420510, 400006, 1, 1, 0, 333333),
(9420510, 4020008, 1, 1, 0, 300),
(9420510, 4010006, 1, 1, 0, 300),
(9420510, 1040109, 1, 1, 0, 2000),
(9420510, 1060098, 1, 1, 0, 2000),
(9420510, 1041068, 1, 1, 0, 2000),
(9420510, 1061063, 1, 1, 0, 2000),
(9420510, 1032011, 1, 1, 0, 1800),
(9420510, 1452008, 1, 1, 0, 1500),
(9420510, 1102017, 1, 1, 0, 2000),
(9420510, 1312008, 1, 1, 0, 1800),
(9420510, 2043701, 1, 1, 0, 1000),
(9420510, 1041076, 1, 1, 0, 2000),
(9420510, 1051030, 1, 1, 0, 1800),
(9420510, 2020028, 1, 1, 0, 20000),
(9420510, 1051031, 1, 1, 0, 1800),
(9420510, 1051034, 1, 1, 0, 1800),
(9420510, 1002209, 1, 1, 0, 2000),
(9420510, 1002210, 1, 1, 0, 2000),
(9420510, 1051046, 1, 1, 0, 1800),
(9420510, 1051047, 1, 1, 0, 1800),
(9420510, 4030012, 1, 1, 0, 125000),
(9420510, 1492001, 1, 1, 0, 3000),
(9420511, 4000382, 1, 1, 0, 300000),
(9420511, 400006, 1, 1, 0, 333333),
(9420511, 400004, 1, 1, 0, 333333),
(9420511, 4020007, 1, 1, 0, 300),
(9420511, 4010005, 1, 1, 0, 300),
(9420511, 2070005, 1, 1, 0, 500),
(9420511, 1041083, 1, 1, 0, 2000),
(9420511, 1061082, 1, 1, 0, 2000),
(9420511, 1072090, 1, 1, 0, 2000),
(9420511, 1041079, 1, 1, 0, 2000),
(9420511, 1061078, 1, 1, 0, 2000),
(9420511, 4001006, 1, 1, 0, 1000),
(9420511, 2020028, 1, 1, 0, 20000),
(9420511, 1002215, 1, 1, 0, 2000),
(9420511, 1050055, 1, 1, 0, 1800),
(9420511, 1102015, 1, 1, 0, 2000),
(9420511, 1050056, 1, 1, 0, 1800),
(9420511, 1041098, 1, 1, 0, 2000),
(9420511, 1482008, 1, 1, 0, 3000),
(9420511, 1492008, 1, 1, 0, 3000),
(9420512, 4000383, 1, 1, 0, 300000),
(9420512, 400002, 1, 1, 0, 10000),
(9420512, 400004, 1, 1, 0, 333333),
(9420512, 4010006, 1, 1, 0, 300),
(9420512, 4020006, 1, 1, 0, 300),
(9420512, 4006000, 1, 1, 0, 5000),
(9420512, 4004004, 1, 1, 0, 5000),
(9420512, 2020028, 1, 1, 0, 20000),
(9420512, 1040093, 1, 1, 0, 2000),
(9420512, 1060082, 1, 1, 0, 2000),
(9420512, 1082082, 1, 1, 0, 2000),
(9420512, 1302011, 1, 1, 0, 1800),
(9420512, 1312009, 1, 1, 0, 1800),
(9420512, 1040089, 1, 1, 0, 2000),
(9420512, 1060078, 1, 1, 0, 2000),
(9420512, 2041022, 1, 1, 0, 1000),
(9420512, 2043301, 1, 1, 0, 1000),
(9420512, 1032015, 1, 1, 0, 1800),
(9420512, 1050093, 1, 1, 0, 1800),
(9420512, 1002637, 1, 1, 0, 2000),
(9420512, 1052122, 1, 1, 0, 1800),
(9420512, 2330003, 1, 1, 0, 500),
(9420513, 4000384, 1, 1, 0, 300000),
(9420513, 4000385, 1, 1, 0, 300000),
(9420513, 2020013, 1, 1, 0, 333333),
(9420513, 2020015, 1, 1, 0, 333333),
(9420513, 400006, 1, 1, 0, 333333),
(9420513, 1072178, 1, 1, 0, 4000),
(9420513, 1040112, 1, 1, 0, 4000),
(9420513, 1041120, 1, 1, 0, 4000),
(9420513, 1061119, 1, 1, 0, 4000),
(9420513, 1051097, 1, 1, 0, 3000),
(9420513, 1060106, 1, 1, 0, 4000),
(9420513, 1041118, 1, 1, 0, 4000),
(9420513, 1072198, 1, 1, 0, 4000),
(9420513, 1312015, 1, 1, 0, 3000),
(9420513, 1332026, 1, 1, 0, 25000),
(9420513, 1462018, 1, 1, 0, 25000),
(9420513, 1372009, 1, 1, 0, 3000),
(9420513, 2041022, 1, 1, 0, 1000),
(9420513, 2290118, 1, 1, 0, 4000),
(9420513, 2290100, 1, 1, 0, 4000),
(9420514, 4000429, 1, 1, 0, 300000),
(9420514, 400006, 1, 1, 0, 333333),
(9420514, 400005, 1, 1, 0, 333333),
(9420514, 4020008, 1, 1, 0, 300),
(9420514, 4010006, 1, 1, 0, 300),
(9420514, 2044702, 1, 1, 0, 1000),
(9420514, 2043802, 1, 1, 0, 1000),
(9420514, 4006000, 1, 1, 0, 5000),
(9420514, 4004002, 1, 1, 0, 5000),
(9420514, 400002, 1, 1, 0, 10000),
(9420514, 1050083, 1, 1, 0, 1800),
(9420514, 1082119, 1, 1, 0, 2000),
(9420514, 1072185, 1, 1, 0, 2000),
(9420514, 1002330, 1, 1, 0, 2000),
(9420514, 1092027, 1, 1, 0, 1800),
(9420514, 1452015, 1, 1, 0, 1500),
(9420514, 1462013, 1, 1, 0, 1500),
(9420514, 1432010, 1, 1, 0, 1500),
(9420514, 1302056, 1, 1, 0, 1800),
(9420514, 1372010, 1, 1, 0, 1800),
(9420514, 1332052, 1, 1, 0, 1500),
(9420514, 1002640, 1, 1, 0, 2000),
(9420514, 1052125, 1, 1, 0, 1800),
(9420514, 1082207, 1, 1, 0, 2000),
(9420514, 2330004, 1, 1, 0, 500),
(9420514, 2290099, 1, 1, 0, 2000),
(9420516, 4000431, 1, 1, 0, 300000),
(9420516, 400006, 1, 1, 0, 333333),
(9420516, 400005, 1, 1, 0, 333333),
(9420516, 4004002, 1, 1, 0, 5000),
(9420516, 4010001, 1, 1, 0, 300),
(9420516, 404000, 1, 1, 0, 300),
(9420516, 4006001, 1, 1, 0, 5000),
(9420516, 1002365, 1, 1, 0, 2000),
(9420516, 1050089, 1, 1, 0, 1800),
(9420516, 1041118, 1, 1, 0, 2000),
(9420516, 1061116, 1, 1, 0, 2000),
(9420516, 1082129, 1, 1, 0, 2000),
(9420516, 1072223, 1, 1, 0, 2000),
(9420516, 1452017, 1, 1, 0, 1500),
(9420516, 2040701, 1, 1, 0, 1000),
(9420516, 2040516, 1, 1, 0, 1000),
(9420516, 2043002, 1, 1, 0, 1000),
(9420515, 4000430, 1, 1, 0, 300000),
(9420515, 400006, 1, 1, 0, 333333),
(9420515, 400005, 1, 1, 0, 333333),
(9420515, 4010003, 1, 1, 0, 300),
(9420515, 4020001, 1, 1, 0, 300),
(9420515, 2048004, 1, 1, 0, 1000),
(9420515, 2040901, 1, 1, 0, 1000),
(9420515, 4006001, 1, 1, 0, 5000),
(9420515, 4004003, 1, 1, 0, 5000),
(9420515, 400002, 1, 1, 0, 10000),
(9420515, 1082117, 1, 1, 0, 2000),
(9420515, 1072179, 1, 1, 0, 2000),
(9420515, 1002328, 1, 1, 0, 2000),
(9420515, 1040109, 1, 1, 0, 2000),
(9420515, 1060098, 1, 1, 0, 2000),
(9420515, 1452014, 1, 1, 0, 1500),
(9420515, 1382008, 1, 1, 0, 1800),
(9420515, 1032023, 1, 1, 0, 1800),
(9420515, 1092026, 1, 1, 0, 1800),
(9420515, 1312030, 1, 1, 0, 1800),
(9420515, 1402035, 1, 1, 0, 1800),
(9420515, 1472053, 1, 1, 0, 1300),
(9420517, 4000432, 1, 1, 0, 300000),
(9420517, 2022003, 1, 1, 0, 333333),
(9420517, 400006, 1, 1, 0, 333333),
(9420517, 400005, 1, 1, 0, 333333),
(9420517, 4004003, 1, 1, 0, 5000),
(9420517, 4020007, 1, 1, 0, 300),
(9420517, 4010005, 1, 1, 0, 300),
(9420517, 4006001, 1, 1, 0, 5000),
(9420517, 4006000, 1, 1, 0, 5000),
(9420517, 1002406, 1, 1, 0, 2000),
(9420517, 1051101, 1, 1, 0, 1800),
(9420517, 1050097, 1, 1, 0, 1800),
(9420517, 1082139, 1, 1, 0, 2000),
(9420517, 1072225, 1, 1, 0, 2000),
(9420517, 1032023, 1, 1, 0, 1800),
(9420517, 1412021, 1, 1, 0, 1800),
(9420517, 1452019, 1, 1, 0, 1500),
(9420517, 2043801, 1, 1, 0, 1000),
(9420517, 2041023, 1, 1, 0, 1000),
(9420517, 2040707, 1, 1, 0, 1000),
(9420517, 1082152, 1, 1, 0, 2000),
(9420517, 2290000, 1, 1, 0, 2000),
(9420517, 2290008, 1, 1, 0, 2000),
(9420517, 2290018, 1, 1, 0, 2000),
(9420517, 2290038, 1, 1, 0, 2000),
(9420517, 2290060, 1, 1, 0, 2000),
(9420517, 2290080, 1, 1, 0, 2000),
(9420517, 2290103, 1, 1, 0, 2000),
(9420518, 400006, 1, 1, 0, 333333),
(9420518, 400005, 1, 1, 0, 333333),
(9420518, 2022003, 1, 1, 0, 333333),
(9420518, 2020013, 1, 1, 0, 333333),
(9420518, 4010001, 1, 1, 0, 300),
(9420518, 4020002, 1, 1, 0, 300),
(9420518, 4004004, 1, 1, 0, 5000),
(9420518, 1002530, 1, 1, 0, 2000),
(9420518, 1050098, 1, 1, 0, 1800),
(9420518, 1041122, 1, 1, 0, 2000),
(9420518, 1061121, 1, 1, 0, 2000),
(9420518, 1051101, 1, 1, 0, 1800),
(9420518, 1082158, 1, 1, 0, 2000),
(9420518, 1072208, 1, 1, 0, 2000),
(9420518, 1092027, 1, 1, 0, 1800),
(9420518, 1402016, 1, 1, 0, 1800),
(9420518, 1382035, 1, 1, 0, 1800),
(9420518, 2040302, 1, 1, 0, 1000),
(9420518, 2040501, 1, 1, 0, 1000),
(9420518, 4000433, 1, 1, 0, 300000),
(9420518, 1082136, 1, 1, 0, 2000),
(9420518, 2044902, 1, 1, 0, 1000),
(9420518, 2290123, 1, 1, 0, 2000),
(9420519, 4000434, 1, 1, 0, 300000),
(9420519, 2022003, 1, 1, 0, 333333),
(9420519, 400006, 1, 1, 0, 333333),
(9420519, 400005, 1, 1, 0, 333333),
(9420519, 4004004, 1, 1, 0, 5000),
(9420519, 4020006, 1, 1, 0, 300),
(9420519, 4020002, 1, 1, 0, 300),
(9420519, 4006001, 1, 1, 0, 5000),
(9420519, 4006000, 1, 1, 0, 5000),
(9420519, 1002380, 1, 1, 0, 2000),
(9420519, 1051102, 1, 1, 0, 1800),
(9420519, 1040121, 1, 1, 0, 2000),
(9420519, 1060109, 1, 1, 0, 2000),
(9420519, 1082151, 1, 1, 0, 2000),
(9420519, 1072215, 1, 1, 0, 2000),
(9420519, 1322045, 1, 1, 0, 1800),
(9420519, 1302056, 1, 1, 0, 1800),
(9420519, 2041004, 1, 1, 0, 1000),
(9420519, 2041013, 1, 1, 0, 1000),
(9420519, 2044201, 1, 1, 0, 1000),
(9420519, 2330005, 1, 1, 0, 500),
(9420519, 2290113, 1, 1, 0, 2000),
(9420522, 2020013, 1, 1, 0, 333333),
(9420522, 2020015, 1, 1, 0, 333333),
(9420522, 400005, 1, 1, 0, 333333),
(9420522, 1302056, 1, 1, 0, 3000),
(9420522, 1312030, 1, 1, 0, 3000),
(9420522, 1322045, 1, 1, 0, 3000),
(9420522, 1332051, 1, 1, 0, 25000),
(9420522, 1332052, 1, 1, 0, 25000),
(9420522, 1372010, 1, 1, 0, 3000),
(9420522, 1382035, 1, 1, 0, 3000),
(9420522, 1402035, 1, 1, 0, 3000),
(9420522, 1412021, 1, 1, 0, 3000),
(9420522, 1422027, 1, 1, 0, 3000),
(9420522, 1432030, 1, 1, 0, 25000),
(9420522, 1442044, 1, 1, 0, 3000),
(9420522, 1452019, 1, 1, 0, 25000),
(9420522, 1452020, 1, 1, 0, 25000),
(9420522, 1462015, 1, 1, 0, 25000),
(9420522, 1462016, 1, 1, 0, 25000),
(9420522, 1472053, 1, 1, 0, 13000),
(9420522, 400004, 1, 1, 0, 333333),
(9420522, 2290028, 1, 1, 0, 4000),
(9420522, 2290037, 1, 1, 0, 4000),
(9420522, 2290043, 1, 1, 0, 4000),
(9420522, 2290066, 1, 1, 0, 4000),
(9420522, 2290089, 1, 1, 0, 4000),
(9420522, 2290091, 1, 1, 0, 4000),
(9420522, 2290011, 1, 1, 0, 4000),
(9420522, 2290001, 1, 1, 0, 4000),
(9420522, 2290025, 1, 1, 0, 4000),
(9420522, 2290083, 1, 1, 0, 4000),
(9420522, 2290000, 1, 1, 0, 4000),
(9420522, 2290082, 1, 1, 0, 4000),
(9420522, 4000435, 1, 1, 0, 300000),
(9420522, 2290107, 1, 1, 0, 4000),
(9420527, 4000465, 1, 1, 0, 300000),
(9420527, 400006, 1, 1, 0, 333333),
(9420527, 2020028, 1, 1, 0, 20000),
(9420527, 401000, 1, 1, 0, 300),
(9420527, 4020001, 1, 1, 0, 300),
(9420527, 2002010, 1, 1, 0, 333333),
(9420527, 2040101, 1, 1, 0, 1000),
(9420527, 2040311, 1, 1, 0, 1000),
(9420527, 4130010, 1, 1, 0, 5000),
(9420527, 1332015, 1, 1, 0, 1500),
(9420527, 1302013, 1, 1, 0, 1800),
(9420527, 1472017, 1, 1, 0, 1300),
(9420527, 1082064, 1, 1, 0, 2000),
(9420527, 1072124, 1, 1, 0, 2000),
(9420527, 1072055, 1, 1, 0, 2000),
(9420527, 1050047, 1, 1, 0, 1800),
(9420527, 1050046, 1, 1, 0, 1800),
(9420527, 1051039, 1, 1, 0, 1800),
(9420527, 2060001, 1, 1, 0, 10000),
(9420527, 2061001, 1, 1, 0, 10000),
(9420527, 1002625, 1, 1, 0, 2000),
(9420527, 1052110, 1, 1, 0, 1800),
(9420527, 1082192, 1, 1, 0, 2000),
(9420527, 1492000, 1, 1, 0, 1800),
(9420527, 2330000, 1, 1, 0, 500),
(9420528, 4000466, 1, 1, 0, 300000),
(9420528, 2020006, 1, 1, 0, 333333),
(9420528, 400010, 1, 1, 0, 333333),
(9420528, 2050004, 1, 1, 0, 5000),
(9420528, 4010001, 1, 1, 0, 300),
(9420528, 4020002, 1, 1, 0, 300),
(9420528, 2040516, 1, 1, 0, 1000),
(9420528, 2044501, 1, 1, 0, 1000),
(9420528, 4131008, 1, 1, 0, 5000),
(9420528, 4130000, 1, 1, 0, 5000),
(9420528, 2040704, 1, 1, 0, 1000),
(9420528, 4004001, 1, 1, 0, 5000),
(9420528, 1302016, 1, 1, 0, 1800),
(9420528, 1322017, 1, 1, 0, 1800),
(9420528, 1332016, 1, 1, 0, 1500),
(9420528, 1372012, 1, 1, 0, 1800),
(9420528, 1102003, 1, 1, 0, 2000),
(9420528, 1082050, 1, 1, 0, 2000),
(9420528, 1060078, 1, 1, 0, 2000),
(9420528, 1072134, 1, 1, 0, 2000),
(9420528, 1032018, 1, 1, 0, 1800),
(9420528, 1002024, 1, 1, 0, 2000),
(9420528, 4006000, 1, 1, 0, 5000),
(9420528, 1002628, 1, 1, 0, 2000),
(9420528, 1052113, 1, 1, 0, 1800),
(9420528, 1072285, 1, 1, 0, 2000),
(9420528, 1072300, 1, 1, 0, 2000),
(9420528, 1082195, 1, 1, 0, 2000),
(9420528, 2330001, 1, 1, 0, 500),
(9420529, 4000467, 1, 1, 0, 300000),
(9420529, 400006, 1, 1, 0, 333333),
(9420529, 4006001, 1, 1, 0, 5000),
(9420529, 2040005, 1, 1, 0, 1000),
(9420529, 2043801, 1, 1, 0, 1000),
(9420529, 4004000, 1, 1, 0, 5000),
(9420529, 4003002, 1, 1, 0, 7000),
(9420529, 1402010, 1, 1, 0, 1800),
(9420529, 1412003, 1, 1, 0, 1800),
(9420529, 1452008, 1, 1, 0, 1500),
(9420529, 1462006, 1, 1, 0, 1500),
(9420529, 1472021, 1, 1, 0, 1300),
(9420529, 2040302, 1, 1, 0, 1000),
(9420529, 1092009, 1, 1, 0, 1800),
(9420529, 1082083, 1, 1, 0, 2000),
(9420529, 1082072, 1, 1, 0, 2000),
(9420529, 1040089, 1, 1, 0, 2000),
(9420529, 1041080, 1, 1, 0, 2000),
(9420529, 1051030, 1, 1, 0, 1800),
(9420529, 1051038, 1, 1, 0, 1800),
(9420529, 1002184, 1, 1, 0, 2000),
(9420529, 1002099, 1, 1, 0, 2000),
(9420529, 1002216, 1, 1, 0, 2000),
(9420529, 1040096, 1, 1, 0, 2000),
(9420529, 1060085, 1, 1, 0, 2000),
(9420529, 1052098, 1, 1, 0, 1800),
(9420529, 1072303, 1, 1, 0, 2000),
(9420529, 1082198, 1, 1, 0, 2000),
(9420531, 4000469, 1, 1, 0, 300000),
(9420531, 2060001, 1, 1, 0, 10000),
(9420531, 2061001, 1, 1, 0, 10000),
(9420531, 4003005, 1, 1, 0, 40000),
(9420531, 4004003, 1, 1, 0, 5000),
(9420531, 4010002, 1, 1, 0, 300),
(9420531, 4020006, 1, 1, 0, 300),
(9420531, 400002, 1, 1, 0, 10000),
(9420531, 400006, 1, 1, 0, 333333),
(9420531, 400005, 1, 1, 0, 333333),
(9420531, 1332017, 1, 1, 0, 1500),
(9420531, 1302010, 1, 1, 0, 1800),
(9420531, 1372007, 1, 1, 0, 1800),
(9420531, 1402003, 1, 1, 0, 1800),
(9420531, 1412007, 1, 1, 0, 1800),
(9420531, 1452004, 1, 1, 0, 1500),
(9420531, 1092012, 1, 1, 0, 1800),
(9420531, 1082067, 1, 1, 0, 2000),
(9420531, 1082091, 1, 1, 0, 2000),
(9420531, 1041081, 1, 1, 0, 2000),
(9420531, 1061080, 1, 1, 0, 2000),
(9420531, 1041093, 1, 1, 0, 2000),
(9420531, 1061092, 1, 1, 0, 2000),
(9420531, 2040804, 1, 1, 0, 500),
(9420531, 2041005, 1, 1, 0, 1000),
(9420531, 2330002, 1, 1, 0, 500),
(9420532, 4000470, 1, 1, 0, 300000),
(9420532, 400002, 1, 1, 0, 10000),
(9420532, 400006, 1, 1, 0, 333333),
(9420532, 2043009, 1, 1, 0, 1000),
(9420532, 2044102, 1, 1, 0, 1000),
(9420532, 1032008, 1, 1, 0, 1800),
(9420532, 1002243, 1, 1, 0, 2000),
(9420532, 1002244, 1, 1, 0, 2000),
(9420532, 1002270, 1, 1, 0, 2000),
(9420532, 1002155, 1, 1, 0, 2000),
(9420532, 1051043, 1, 1, 0, 1800),
(9420532, 1041087, 1, 1, 0, 2000),
(9420532, 1061086, 1, 1, 0, 2000),
(9420532, 1041095, 1, 1, 0, 2000),
(9420532, 1061094, 1, 1, 0, 2000),
(9420532, 1072149, 1, 1, 0, 2000),
(9420532, 1072110, 1, 1, 0, 2000),
(9420532, 1051046, 1, 1, 0, 1800),
(9420532, 1051047, 1, 1, 0, 1800),
(9420532, 1102017, 1, 1, 0, 2000),
(9420532, 1472020, 1, 1, 0, 1300),
(9420532, 1332021, 1, 1, 0, 1500),
(9420532, 1332029, 1, 1, 0, 1500),
(9420532, 1372017, 1, 1, 0, 1800),
(9420532, 1002622, 1, 1, 0, 2000),
(9420532, 1052107, 1, 1, 0, 1800),
(9420532, 1082189, 1, 1, 0, 2000),
(9420532, 1492003, 1, 1, 0, 2000),
(9420533, 4000471, 1, 1, 0, 300000),
(9420533, 2002004, 1, 1, 0, 10000),
(9420533, 400009, 1, 1, 0, 333333),
(9420533, 400006, 1, 1, 0, 333333),
(9420533, 2002011, 1, 1, 0, 10000),
(9420533, 2044302, 1, 1, 0, 1000),
(9420533, 2048001, 1, 1, 0, 1000),
(9420533, 1312009, 1, 1, 0, 1800),
(9420533, 1322012, 1, 1, 0, 1800),
(9420533, 1332020, 1, 1, 0, 1500),
(9420533, 1372008, 1, 1, 0, 1800),
(9420533, 1402017, 1, 1, 0, 1800),
(9420533, 1432007, 1, 1, 0, 1500),
(9420533, 1051023, 1, 1, 0, 1800),
(9420533, 1051038, 1, 1, 0, 1800),
(9420533, 1050052, 1, 1, 0, 1800),
(9420533, 1050039, 1, 1, 0, 1800),
(9420533, 1040105, 1, 1, 0, 2000),
(9420533, 1060093, 1, 1, 0, 2000),
(9420533, 1041096, 1, 1, 0, 2000),
(9420533, 1061095, 1, 1, 0, 2000),
(9420533, 1002248, 1, 1, 0, 2000),
(9420533, 1002249, 1, 1, 0, 2000),
(9420533, 1002254, 1, 1, 0, 2000),
(9420533, 1082180, 1, 1, 0, 2000),
(9420535, 4000473, 1, 1, 0, 300000),
(9420535, 4030009, 1, 1, 0, 28000),
(9420535, 400002, 1, 1, 0, 10000),
(9420535, 400004, 1, 1, 0, 333333),
(9420535, 2020028, 1, 1, 0, 20000),
(9420535, 4030012, 1, 1, 0, 125000),
(9420535, 2022003, 1, 1, 0, 333333),
(9420535, 2044402, 1, 1, 0, 1000),
(9420535, 2043701, 1, 1, 0, 1000),
(9420535, 4010006, 1, 1, 0, 300),
(9420535, 404000, 1, 1, 0, 300),
(9420535, 1050060, 1, 1, 0, 1800),
(9420535, 1041076, 1, 1, 0, 2000),
(9420535, 1061071, 1, 1, 0, 2000),
(9420535, 1322007, 1, 1, 0, 1800),
(9420535, 1442009, 1, 1, 0, 1800),
(9420535, 1102012, 1, 1, 0, 2000),
(9420535, 1092029, 1, 1, 0, 1800),
(9420535, 1072018, 1, 1, 0, 2000),
(9420535, 1072159, 1, 1, 0, 2000),
(9420535, 1072161, 1, 1, 0, 2000),
(9420535, 1051016, 1, 1, 0, 1800),
(9420535, 1050070, 1, 1, 0, 1800),
(9420535, 1051055, 1, 1, 0, 1800),
(9420535, 1032020, 1, 1, 0, 1800),
(9420535, 1082106, 1, 1, 0, 2000),
(9420535, 1082093, 1, 1, 0, 2000),
(9420535, 1492009, 1, 1, 0, 2000),
(9420537, 4000475, 1, 1, 0, 300000),
(9420537, 2022003, 1, 1, 0, 333333),
(9420537, 400006, 1, 1, 0, 333333),
(9420537, 1322009, 1, 1, 0, 1800),
(9420537, 4010005, 1, 1, 0, 300),
(9420537, 4020007, 1, 1, 0, 300),
(9420537, 4006000, 1, 1, 0, 5000),
(9420537, 4004002, 1, 1, 0, 5000),
(9420537, 1372015, 1, 1, 0, 1800),
(9420537, 1102030, 1, 1, 0, 2000),
(9420537, 1041102, 1, 1, 0, 2000),
(9420537, 1061101, 1, 1, 0, 2000),
(9420537, 1050083, 1, 1, 0, 1800),
(9420537, 1051080, 1, 1, 0, 1800),
(9420537, 1072155, 1, 1, 0, 2000),
(9420537, 1072165, 1, 1, 0, 2000),
(9420537, 1032022, 1, 1, 0, 1800),
(9420537, 1002252, 1, 1, 0, 2000),
(9420537, 1002284, 1, 1, 0, 2000),
(9420537, 1002289, 1, 1, 0, 2000),
(9420537, 1452011, 1, 1, 0, 1500),
(9420537, 1462013, 1, 1, 0, 1500),
(9420537, 1472027, 1, 1, 0, 1300),
(9420537, 2043301, 1, 1, 0, 1000),
(9420537, 2040513, 1, 1, 0, 1000),
(9420537, 1002634, 1, 1, 0, 2000),
(9420537, 1052119, 1, 1, 0, 1800),
(9420537, 1072306, 1, 1, 0, 2000),
(9420537, 1082201, 1, 1, 0, 2000),
(9420538, 4000476, 1, 1, 0, 300000),
(9420538, 4010002, 1, 1, 0, 300),
(9420538, 4010001, 1, 1, 0, 300),
(9420538, 4004002, 1, 1, 0, 5000),
(9420538, 400006, 1, 1, 0, 333333),
(9420538, 400004, 1, 1, 0, 333333),
(9420538, 2070004, 1, 1, 0, 500),
(9420538, 4006000, 1, 1, 0, 5000),
(9420538, 2040705, 1, 1, 0, 1000),
(9420538, 2041017, 1, 1, 0, 1000),
(9420538, 1432010, 1, 1, 0, 1500),
(9420538, 1422012, 1, 1, 0, 1800),
(9420538, 1102029, 1, 1, 0, 2000),
(9420538, 1092015, 1, 1, 0, 1800),
(9420538, 1082123, 1, 1, 0, 2000),
(9420538, 1082112, 1, 1, 0, 2000),
(9420538, 1060091, 1, 1, 0, 2000),
(9420538, 1060094, 1, 1, 0, 2000),
(9420538, 1002274, 1, 1, 0, 2000),
(9420538, 1002278, 1, 1, 0, 2000),
(9420538, 1072179, 1, 1, 0, 2000),
(9420538, 1072163, 1, 1, 0, 2000),
(9420538, 1072155, 1, 1, 0, 2000),
(9420538, 1040109, 1, 1, 0, 2000),
(9420538, 1041106, 1, 1, 0, 2000),
(9420538, 1060098, 1, 1, 0, 2000),
(9420538, 1072312, 1, 1, 0, 2000),
(9420538, 1482010, 1, 1, 0, 2000),
(9420538, 1492010, 1, 1, 0, 2000),
(9420539, 4000477, 1, 1, 0, 300000),
(9420539, 401000, 1, 1, 0, 300),
(9420539, 4010002, 1, 1, 0, 300),
(9420539, 4020005, 1, 1, 0, 300),
(9420539, 4004004, 1, 1, 0, 5000),
(9420539, 400006, 1, 1, 0, 333333),
(9420539, 400009, 1, 1, 0, 333333),
(9420539, 2002008, 1, 1, 0, 333333),
(9420539, 2070005, 1, 1, 0, 500),
(9420539, 4006001, 1, 1, 0, 5000),
(9420539, 4006000, 1, 1, 0, 5000),
(9420539, 2040514, 1, 1, 0, 1000),
(9420539, 2040802, 1, 1, 0, 1000),
(9420539, 2044601, 1, 1, 0, 1000),
(9420539, 1412009, 1, 1, 0, 1800),
(9420539, 1402033, 1, 1, 0, 1800),
(9420539, 1382028, 1, 1, 0, 1800),
(9420539, 1102035, 1, 1, 0, 2000),
(9420539, 1102031, 1, 1, 0, 2000),
(9420539, 1082116, 1, 1, 0, 2000),
(9420539, 1082108, 1, 1, 0, 2000),
(9420539, 1082099, 1, 1, 0, 2000),
(9420539, 1002284, 1, 1, 0, 2000),
(9420539, 1050074, 1, 1, 0, 1800),
(9420539, 1050083, 1, 1, 0, 1800),
(9420539, 1050078, 1, 1, 0, 1800),
(9420540, 4000478, 1, 1, 0, 300000),
(9420540, 4010003, 1, 1, 0, 300),
(9420540, 4010006, 1, 1, 0, 300),
(9420540, 404000, 1, 1, 0, 300),
(9420540, 4004000, 1, 1, 0, 5000),
(9420540, 400005, 1, 1, 0, 333333),
(9420540, 400011, 1, 1, 0, 333333),
(9420540, 2002006, 1, 1, 0, 10000),
(9420540, 2070012, 1, 1, 0, 20000),
(9420540, 4006001, 1, 1, 0, 5000),
(9420540, 2022003, 1, 1, 0, 40000),
(9420540, 2041014, 1, 1, 0, 1000),
(9420540, 2040804, 1, 1, 0, 500),
(9420540, 2040613, 1, 1, 0, 1000),
(9420540, 1452017, 1, 1, 0, 1500),
(9420540, 1472031, 1, 1, 0, 1300),
(9420540, 1002329, 1, 1, 0, 2000),
(9420540, 1002366, 1, 1, 0, 2000),
(9420540, 1002405, 1, 1, 0, 2000),
(9420540, 1050095, 1, 1, 0, 1800),
(9420540, 1051097, 1, 1, 0, 1800),
(9420540, 1072198, 1, 1, 0, 2000),
(9420540, 1072209, 1, 1, 0, 2000),
(9420540, 1082134, 1, 1, 0, 2000),
(9420540, 2330005, 1, 1, 0, 500),
(9420540, 2290120, 1, 1, 0, 2000),
(9420544, 1032031, 1, 1, 0, 3000),
(9420544, 4001241, 1, 1, 0, 300000),
(9420544, 2020013, 1, 1, 0, 333333),
(9420544, 2020014, 1, 1, 0, 100000),
(9420544, 1302056, 1, 1, 0, 3000),
(9420544, 1312030, 1, 1, 0, 3000),
(9420544, 1322045, 1, 1, 0, 3000),
(9420544, 1332051, 1, 1, 0, 25000),
(9420544, 1332052, 1, 1, 0, 25000),
(9420544, 1372010, 1, 1, 0, 3000),
(9420544, 1382035, 1, 1, 0, 3000),
(9420544, 1402035, 1, 1, 0, 3000),
(9420544, 1422027, 1, 1, 0, 3000),
(9420544, 1412021, 1, 1, 0, 3000),
(9420544, 1432030, 1, 1, 0, 25000),
(9420544, 1452020, 1, 1, 0, 25000),
(9420544, 1462015, 1, 1, 0, 25000),
(9420544, 1462016, 1, 1, 0, 25000),
(9420544, 1472053, 1, 1, 0, 13000),
(9420544, 1452019, 1, 1, 0, 25000),
(9420544, 1442044, 1, 1, 0, 3000),
(9420544, 1492012, 1, 1, 0, 333333),
(9420544, 1482012, 1, 1, 0, 333333),
(9420544, 2043001, 1, 1, 0, 1000),
(9420544, 2043101, 1, 1, 0, 1000),
(9420544, 2043201, 1, 1, 0, 1000),
(9420544, 2043301, 1, 1, 0, 1000),
(9420544, 2043701, 1, 1, 0, 1000),
(9420544, 2043801, 1, 1, 0, 1000),
(9420544, 2044001, 1, 1, 0, 1000),
(9420544, 2044101, 1, 1, 0, 1000),
(9420544, 2044301, 1, 1, 0, 1000),
(9420544, 2044201, 1, 1, 0, 1000),
(9420544, 2044401, 1, 1, 0, 1000),
(9420544, 2044501, 1, 1, 0, 1000),
(9420544, 2044601, 1, 1, 0, 1000),
(9420544, 2044701, 1, 1, 0, 1000),
(9420544, 2040804, 1, 1, 0, 500),
(9420544, 2040001, 1, 1, 0, 1000),
(9420544, 2040004, 1, 1, 0, 1000),
(9420544, 2040301, 1, 1, 0, 1000),
(9420544, 2040401, 1, 1, 0, 1000),
(9420544, 2040501, 1, 1, 0, 1000),
(9420544, 2040504, 1, 1, 0, 1000),
(9420544, 2040516, 1, 1, 0, 1000),
(9420544, 2040513, 1, 1, 0, 1000),
(9420544, 2040601, 1, 1, 0, 1000),
(9420544, 2040701, 1, 1, 0, 1000),
(9420544, 2040704, 1, 1, 0, 1000),
(9420544, 2040707, 1, 1, 0, 1000),
(9420544, 2040801, 1, 1, 0, 1000),
(9420544, 2040901, 1, 1, 0, 1000),
(9420544, 2290098, 1, 1, 0, 4000),
(9420544, 2290015, 1, 1, 0, 4000),
(9420544, 2290027, 1, 1, 0, 4000),
(9420544, 2290089, 1, 1, 0, 4000),
(9420544, 2290054, 1, 1, 0, 4000),
(9420544, 2290119, 1, 1, 0, 4000),
(9420544, 2290002, 1, 1, 0, 4000),
(9420544, 2290022, 1, 1, 0, 4000),
(9420544, 2290034, 1, 1, 0, 4000),
(9420544, 2290105, 1, 1, 0, 4000),
(9420544, 2290110, 1, 1, 0, 4000),
(9420544, 2290094, 1, 1, 0, 4000),
(9420544, 2290052, 1, 1, 0, 4000),
(9420544, 1002926, 1, 1, 0, 300000),
(9420544, 1002926, 1, 1, 0, 300000),
(9420544, 1002926, 1, 1, 0, 300000),
(9420544, 1002926, 1, 1, 0, 300000),
(9420544, 1002926, 1, 1, 0, 300000),
(9420549, 1032031, 1, 1, 0, 3000),
(9420549, 2043001, 1, 1, 0, 1000),
(9420549, 2020013, 1, 1, 0, 333333),
(9420549, 2020014, 1, 1, 0, 100000),
(9420549, 1302056, 1, 1, 0, 3000),
(9420549, 1312030, 1, 1, 0, 3000),
(9420549, 1322045, 1, 1, 0, 3000),
(9420549, 1332051, 1, 1, 0, 25000),
(9420549, 1332052, 1, 1, 0, 25000),
(9420549, 1372010, 1, 1, 0, 3000),
(9420549, 1382035, 1, 1, 0, 3000),
(9420549, 1402035, 1, 1, 0, 3000),
(9420549, 1422027, 1, 1, 0, 3000),
(9420549, 1412021, 1, 1, 0, 3000),
(9420549, 1432030, 1, 1, 0, 25000),
(9420549, 1452020, 1, 1, 0, 25000),
(9420549, 1462015, 1, 1, 0, 25000),
(9420549, 1462016, 1, 1, 0, 25000),
(9420549, 1472053, 1, 1, 0, 13000),
(9420549, 1452019, 1, 1, 0, 25000),
(9420549, 1442044, 1, 1, 0, 3000),
(9420549, 1492012, 1, 1, 0, 333333),
(9420549, 1482012, 1, 1, 0, 333333),
(9420549, 2043101, 1, 1, 0, 1000),
(9420549, 2043201, 1, 1, 0, 1000),
(9420549, 2043301, 1, 1, 0, 1000),
(9420549, 2043701, 1, 1, 0, 1000),
(9420549, 2043801, 1, 1, 0, 1000),
(9420549, 2044001, 1, 1, 0, 1000),
(9420549, 2044101, 1, 1, 0, 1000),
(9420549, 2044301, 1, 1, 0, 1000),
(9420549, 2044201, 1, 1, 0, 1000),
(9420549, 2044401, 1, 1, 0, 1000),
(9420549, 2044501, 1, 1, 0, 1000),
(9420549, 2044601, 1, 1, 0, 1000),
(9420549, 2044701, 1, 1, 0, 1000),
(9420549, 2040804, 1, 1, 0, 500),
(9420549, 2040001, 1, 1, 0, 1000),
(9420549, 2040004, 1, 1, 0, 1000),
(9420549, 2040301, 1, 1, 0, 1000),
(9420549, 2040401, 1, 1, 0, 1000),
(9420549, 2040501, 1, 1, 0, 1000),
(9420549, 2040504, 1, 1, 0, 1000),
(9420549, 2040516, 1, 1, 0, 1000),
(9420549, 2040513, 1, 1, 0, 1000),
(9420549, 2040601, 1, 1, 0, 1000),
(9420549, 2040701, 1, 1, 0, 1000),
(9420549, 2040704, 1, 1, 0, 1000),
(9420549, 2040707, 1, 1, 0, 1000),
(9420549, 2040801, 1, 1, 0, 1000),
(9420549, 2040901, 1, 1, 0, 1000),
(9420549, 2290098, 1, 1, 0, 4000),
(9420549, 2290015, 1, 1, 0, 4000),
(9420549, 2290027, 1, 1, 0, 4000),
(9420549, 2290089, 1, 1, 0, 4000),
(9420549, 2290054, 1, 1, 0, 4000),
(9420549, 2290119, 1, 1, 0, 4000),
(9420549, 2290002, 1, 1, 0, 4000),
(9420549, 2290022, 1, 1, 0, 4000),
(9420549, 2290034, 1, 1, 0, 4000),
(9420549, 2290105, 1, 1, 0, 4000),
(9420549, 2290110, 1, 1, 0, 4000),
(9420549, 2290094, 1, 1, 0, 4000),
(9420549, 2290052, 1, 1, 0, 4000),
(9420549, 4001242, 1, 1, 0, 300000),
(9420549, 1002927, 1, 1, 0, 300000),
(9420549, 1002927, 1, 1, 0, 300000),
(9420549, 1002927, 1, 1, 0, 300000),
(9420549, 1002927, 1, 1, 0, 300000),
(8140700, 2290126, 1, 1, 0, 1500),
(8500002, 2290126, 1, 1, 0, 40000),
(8150300, 2290127, 1, 1, 0, 1500),
(8220004, 2290127, 1, 1, 0, 15000),
(8180001, 2290128, 1, 1, 0, 15000),
(8150302, 2290128, 1, 1, 0, 1500),
(8200001, 2290129, 1, 1, 0, 1500),
(8500002, 2290129, 1, 1, 0, 40000),
(8180000, 2290130, 1, 1, 0, 15000),
(8190004, 2290130, 1, 1, 0, 1500),
(8200002, 2290131, 1, 1, 0, 1500),
(8220005, 2290131, 1, 1, 0, 15000),
(8800002, 2280015, 1, 1, 0, 50000),
(8220005, 2290136, 1, 1, 0, 15000),
(8200003, 2290136, 1, 1, 0, 1500),
(8200007, 2290136, 1, 1, 0, 1500),
(8810018, 2290137, 1, 1, 0, 45000),
(8200012, 2290137, 1, 1, 0, 1500),
(8800002, 2280016, 1, 1, 0, 45000),
(8220006, 2290138, 1, 1, 0, 15000),
(8200006, 2290138, 1, 1, 0, 1500),
(8200012, 2290139, 1, 1, 0, 1500),
(8810018, 2290139, 1, 1, 0, 45000),
(8800002, 2280014, 1, 1, 0, 45000),
(8200004, 2290134, 1, 1, 0, 1500),
(8220004, 2290134, 1, 1, 0, 15000),
(8220006, 2290135, 1, 1, 0, 15000),
(8150200, 2290135, 1, 1, 0, 1500),
(8800002, 2280013, 1, 1, 0, 45000),
(8140600, 2290132, 1, 1, 0, 1500),
(8510000, 2290132, 1, 1, 0, 15000),
(8520000, 2290132, 1, 1, 0, 15000),
(8810018, 2290133, 1, 1, 0, 45000),
(8200008, 2290133, 1, 1, 0, 1500),
(6130200, 4031171, 1, 1, 7101, 100000),
(8141100, 4031171, 1, 1, 7101, 100000),
(8142000, 4031171, 1, 1, 7101, 100000),
(8143000, 4031171, 1, 1, 7101, 100000),
(8160000, 4031171, 1, 1, 7101, 100000),
(8170000, 4031171, 1, 1, 7101, 100000),
(9500127, 4031171, 1, 1, 7101, 100000),
(9500135, 4031171, 1, 1, 7101, 100000),
(9500136, 4031171, 1, 1, 7101, 100000),
(8141000, 4031171, 1, 1, 7101, 100000),
(8140300, 4031171, 1, 1, 7101, 100000),
(8140200, 4031171, 1, 1, 7101, 100000),
(6230300, 4031171, 1, 1, 7101, 100000),
(6230400, 4031171, 1, 1, 7101, 100000),
(6230500, 4031171, 1, 1, 7101, 100000),
(6300100, 4031171, 1, 1, 7101, 100000),
(6400100, 4031171, 1, 1, 7101, 100000),
(7130010, 4031171, 1, 1, 7101, 100000),
(7130300, 4031171, 1, 1, 7101, 100000),
(7140000, 4031171, 1, 1, 7101, 100000),
(9500137, 4031171, 1, 1, 7101, 100000);

CREATE TABLE IF NOT EXISTS `drop_data_global` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `continent` tinyint(1) NOT NULL DEFAULT '-1',
  `itemid` int(11) NOT NULL DEFAULT '0',
  `minimum_quantity` int(11) NOT NULL DEFAULT '1',
  `maximum_quantity` int(11) NOT NULL DEFAULT '1',
  `questid` int(11) NOT NULL DEFAULT '0',
  `chance` int(11) NOT NULL DEFAULT '0',
  `comments` varchar(45) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `mobid` (`continent`) USING BTREE
) ENGINE=InnoDB  DEFAULT CHARSET=latin1 ROW_FORMAT=DYNAMIC AUTO_INCREMENT=5 ;

INSERT INTO `drop_data_global` (`id`, `continent`, `itemid`, `minimum_quantity`, `maximum_quantity`, `questid`, `chance`, `comments`) VALUES
(1, -1, 4031865, 1, 1, 0, 35000, 'NX Card 100 PTS'),
(2, -1, 4031866, 1, 1, 0, 20000, 'NX Card 250 PTS'),
(3, -1, 4001126, 1, 2, 0, 8000, 'Maple Leaves'),
(4, -1, 2049100, 1, 1, 0, 1200, 'Chaos Scroll 60%'),
(5, -1, 2340000, 1, 1, 0, 1200, 'White Scroll'),
(6, -1, 4001006, 1, 1, 0, 10000, 'Flaming Feather');

CREATE TABLE IF NOT EXISTS `dueyitems` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `PackageId` int(10) unsigned NOT NULL DEFAULT '0',
  `inventoryitemid` int(10) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `INVENTORYITEMID` (`inventoryitemid`),
  KEY `PackageId` (`PackageId`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `dueypackages` (
  `PackageId` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `ReceiverId` int(10) unsigned NOT NULL,
  `SenderName` varchar(13) NOT NULL,
  `Mesos` int(10) unsigned DEFAULT '0',
  `TimeStamp` timestamp NOT NULL DEFAULT '2015-01-01 05:00:00',
  `Message` varchar(200) NULL,
  `Checked` tinyint(1) unsigned DEFAULT '1',
  `Type` tinyint(1) unsigned DEFAULT '0',
  PRIMARY KEY (`PackageId`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `eventstats` (
  `characterid` int(11) unsigned NOT NULL,
  `name` varchar(11) NOT NULL DEFAULT '0' COMMENT '0',
  `info` int(11) NOT NULL,
  PRIMARY KEY (`characterid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE IF NOT EXISTS `famelog` (
  `famelogid` int(11) NOT NULL AUTO_INCREMENT,
  `characterid` int(11) NOT NULL DEFAULT '0',
  `characterid_to` int(11) NOT NULL DEFAULT '0',
  `when` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`famelogid`),
  KEY `characterid` (`characterid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `family_character` (
  `cid` int(11) NOT NULL,
  `familyid` int(11) NOT NULL,
  `seniorid` int(11) NOT NULL,
  `reputation` int(11) NOT NULL DEFAULT '0',
  `todaysrep` int(11) NOT NULL DEFAULT '0',
  `totalreputation` int(11) NOT NULL DEFAULT '0',
  `reptosenior` int(11) NOT NULL DEFAULT '0',
  `precepts` varchar(200) DEFAULT NULL,
  `lastresettime` BIGINT(20) NOT NULL DEFAULT '0',
  PRIMARY KEY (`cid`),
  INDEX (cid, familyid)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE IF NOT EXISTS `family_entitlement` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `charid` int(11) NOT NULL,
  `entitlementid` int(11) NOT NULL,
  `timestamp` BIGINT(20) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  INDEX (charid)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE IF NOT EXISTS `fredstorage` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `cid` int(10) unsigned NOT NULL,
  `daynotes` int(4) unsigned NOT NULL,
  `timestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  UNIQUE KEY `cid_2` (`cid`),
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `gifts` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `to` int(11) NOT NULL,
  `from` varchar(13) NOT NULL,
  `message` tinytext NOT NULL,
  `sn` int(10) unsigned NOT NULL,
  `ringid` int(10) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `guilds` (
  `guildid` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `leader` int(10) unsigned NOT NULL DEFAULT '0',
  `GP` int(10) unsigned NOT NULL DEFAULT '0',
  `logo` int(10) unsigned DEFAULT NULL,
  `logoColor` smallint(5) unsigned NOT NULL DEFAULT '0',
  `name` varchar(45) NOT NULL,
  `rank1title` varchar(45) NOT NULL DEFAULT 'Master',
  `rank2title` varchar(45) NOT NULL DEFAULT 'Jr. Master',
  `rank3title` varchar(45) NOT NULL DEFAULT 'Member',
  `rank4title` varchar(45) NOT NULL DEFAULT 'Member',
  `rank5title` varchar(45) NOT NULL DEFAULT 'Member',
  `capacity` int(10) unsigned NOT NULL DEFAULT '10',
  `logoBG` int(10) unsigned DEFAULT NULL,
  `logoBGColor` smallint(5) unsigned NOT NULL DEFAULT '0',
  `notice` varchar(101) DEFAULT NULL,
  `signature` int(11) NOT NULL DEFAULT '0',
  `allianceId` int(11) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`guildid`),
  INDEX (guildid, name)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `hwidaccounts` (
  `accountid` int(11) NOT NULL DEFAULT '0',
  `hwid` varchar(40) NOT NULL DEFAULT '',
  `relevance` tinyint(2) NOT NULL DEFAULT '0',
  `expiresat` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`accountid`,`hwid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `hwidbans` (
  `hwidbanid` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `hwid` varchar(30) NOT NULL,
  PRIMARY KEY (`hwidbanid`),
  UNIQUE KEY `hwid_2` (`hwid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `inventoryequipment` (
  `inventoryequipmentid` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `inventoryitemid` int(10) unsigned NOT NULL DEFAULT '0',
  `upgradeslots` int(11) NOT NULL DEFAULT '0',
  `level` int(11) NOT NULL DEFAULT '0',
  `str` int(11) NOT NULL DEFAULT '0',
  `dex` int(11) NOT NULL DEFAULT '0',
  `int` int(11) NOT NULL DEFAULT '0',
  `luk` int(11) NOT NULL DEFAULT '0',
  `hp` int(11) NOT NULL DEFAULT '0',
  `mp` int(11) NOT NULL DEFAULT '0',
  `watk` int(11) NOT NULL DEFAULT '0',
  `matk` int(11) NOT NULL DEFAULT '0',
  `wdef` int(11) NOT NULL DEFAULT '0',
  `mdef` int(11) NOT NULL DEFAULT '0',
  `acc` int(11) NOT NULL DEFAULT '0',
  `avoid` int(11) NOT NULL DEFAULT '0',
  `hands` int(11) NOT NULL DEFAULT '0',
  `speed` int(11) NOT NULL DEFAULT '0',
  `jump` int(11) NOT NULL DEFAULT '0',
  `locked` int(11) NOT NULL DEFAULT '0',
  `vicious` int(11) unsigned NOT NULL DEFAULT '0',
  `itemlevel` int(11) NOT NULL DEFAULT '1',
  `itemexp` int(11) unsigned NOT NULL DEFAULT '0',
  `ringid` int(11) NOT NULL DEFAULT '-1',
  PRIMARY KEY (`inventoryequipmentid`),
  KEY `INVENTORYITEMID` (`inventoryitemid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `inventoryitems` (
  `inventoryitemid` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `type` tinyint(3) unsigned NOT NULL,
  `characterid` int(11) DEFAULT NULL,
  `accountid` int(11) DEFAULT NULL,
  `itemid` int(11) NOT NULL DEFAULT '0',
  `inventorytype` int(11) NOT NULL DEFAULT '0',
  `position` int(11) NOT NULL DEFAULT '0',
  `quantity` int(11) NOT NULL DEFAULT '0',
  `owner` tinytext NOT NULL,
  `petid` int(11) NOT NULL DEFAULT '-1',
  `flag` int(11) NOT NULL,
  `expiration` bigint(20) NOT NULL DEFAULT '-1',
  `giftFrom` varchar(26) NOT NULL,
  PRIMARY KEY (`inventoryitemid`),
  KEY `CHARID` (`characterid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `inventorymerchant` (
  `inventorymerchantid` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `inventoryitemid` int(10) unsigned NOT NULL DEFAULT '0',
  `characterid` int(11) DEFAULT NULL,
  `bundles` int(10) NOT NULL DEFAULT '0',
  PRIMARY KEY (`inventorymerchantid`),
  KEY `INVENTORYITEMID` (`inventoryitemid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `ipbans` (
  `ipbanid` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `ip` varchar(40) NOT NULL DEFAULT '',
  `aid` varchar(40) DEFAULT NULL,
  PRIMARY KEY (`ipbanid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `keymap` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `characterid` int(11) NOT NULL DEFAULT '0',
  `key` int(11) NOT NULL DEFAULT '0',
  `type` int(11) NOT NULL DEFAULT '0',
  `action` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `macbans` (
  `macbanid` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `mac` varchar(30) NOT NULL,
  `aid` varchar(40) DEFAULT NULL,
  PRIMARY KEY (`macbanid`),
  UNIQUE KEY `mac_2` (`mac`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `macfilters` (
  `macfilterid` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `filter` varchar(30) NOT NULL,
  PRIMARY KEY (`macfilterid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `makercreatedata` (
  `id` tinyint(3) unsigned NOT NULL,
  `itemid` int(11) NOT NULL,
  `req_level` tinyint(3) unsigned NOT NULL,
  `req_maker_level` tinyint(3) unsigned NOT NULL,
  `req_meso` int(11) NOT NULL,
  `req_item` int(11) NOT NULL,
  `req_equip` int(11) NOT NULL,
  `catalyst` int(11) NOT NULL,
  `quantity` smallint(6) NOT NULL,
  `tuc` tinyint(3) NOT NULL,
  PRIMARY KEY (`id`,`itemid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

CREATE TABLE IF NOT EXISTS `makerrecipedata` (
  `itemid` int(11) NOT NULL,
  `req_item` int(11) NOT NULL,
  `count` smallint(6) NOT NULL,
  PRIMARY KEY (`itemid`,`req_item`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

CREATE TABLE IF NOT EXISTS `makerrewarddata` (
  `itemid` int(11) NOT NULL,
  `rewardid` int(11) NOT NULL,
  `quantity` smallint(6) NOT NULL,
  `prob` tinyint(3) unsigned NOT NULL DEFAULT '100',
  PRIMARY KEY (`itemid`,`rewardid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

# updated with the MapleSkillMakerFetcher feature
INSERT IGNORE INTO `makercreatedata` (`id`, `itemid`, `req_level`, `req_maker_level`, `req_meso`, `req_item`, `req_equip`, `catalyst`, `quantity`, `tuc`) VALUES
  (0, 4250000, 45, 1, 110000, 0, 0, 0, 1, 0),
  (0, 4250100, 45, 1, 110000, 0, 0, 0, 1, 0),
  (0, 4250200, 45, 1, 110000, 0, 0, 0, 1, 0),
  (0, 4250300, 45, 1, 110000, 0, 0, 0, 1, 0),
  (0, 4250400, 45, 1, 110000, 0, 0, 0, 1, 0),
  (0, 4250500, 45, 1, 110000, 0, 0, 0, 1, 0),
  (0, 4250600, 45, 1, 110000, 0, 0, 0, 1, 0),
  (0, 4250700, 45, 1, 110000, 0, 0, 0, 1, 0),
  (0, 4250800, 45, 1, 110000, 0, 0, 0, 1, 0),
  (0, 4250900, 45, 1, 110000, 0, 0, 0, 1, 0),
  (0, 4251000, 45, 1, 110000, 0, 0, 0, 1, 0),
  (0, 4251100, 45, 1, 110000, 0, 0, 0, 1, 0),
  (0, 4251300, 75, 2, 165000, 0, 0, 0, 1, 0),
  (0, 4251400, 75, 2, 165000, 0, 0, 0, 1, 0),
  (0, 4250001, 45, 1, 330000, 0, 0, 0, 1, 0),
  (0, 4250101, 45, 1, 330000, 0, 0, 0, 1, 0),
  (0, 4250201, 45, 1, 330000, 0, 0, 0, 1, 0),
  (0, 4250301, 45, 1, 330000, 0, 0, 0, 1, 0),
  (0, 4250401, 45, 1, 330000, 0, 0, 0, 1, 0),
  (0, 4250501, 45, 1, 330000, 0, 0, 0, 1, 0),
  (0, 4250601, 45, 1, 330000, 0, 0, 0, 1, 0),
  (0, 4250701, 45, 1, 330000, 0, 0, 0, 1, 0),
  (0, 4250801, 45, 1, 330000, 0, 0, 0, 1, 0),
  (0, 4250901, 45, 1, 330000, 0, 0, 0, 1, 0),
  (0, 4251001, 45, 1, 330000, 0, 0, 0, 1, 0),
  (0, 4251101, 45, 1, 330000, 0, 0, 0, 1, 0),
  (0, 4251301, 75, 2, 495000, 0, 0, 0, 1, 0),
  (0, 4251401, 75, 2, 495000, 0, 0, 0, 1, 0),
  (0, 4250002, 45, 2, 550000, 0, 0, 0, 1, 0),
  (0, 4250102, 45, 2, 550000, 0, 0, 0, 1, 0),
  (0, 4250202, 45, 2, 550000, 0, 0, 0, 1, 0),
  (0, 4250302, 45, 2, 550000, 0, 0, 0, 1, 0),
  (0, 4250402, 45, 2, 550000, 0, 0, 0, 1, 0),
  (0, 4250502, 45, 2, 550000, 0, 0, 0, 1, 0),
  (0, 4250602, 45, 2, 550000, 0, 0, 0, 1, 0),
  (0, 4250702, 45, 2, 550000, 0, 0, 0, 1, 0),
  (0, 4250802, 45, 2, 550000, 0, 0, 0, 1, 0),
  (0, 4250902, 45, 2, 550000, 0, 0, 0, 1, 0),
  (0, 4251002, 45, 2, 550000, 0, 0, 0, 1, 0),
  (0, 4251102, 45, 2, 550000, 0, 0, 0, 1, 0),
  (0, 4251302, 75, 3, 825000, 0, 0, 0, 1, 0),
  (0, 4251402, 75, 3, 825000, 0, 0, 0, 1, 0),
  (0, 4001174, 45, 1, 0, 4031966, 0, 0, 1, 0),
  (0, 4001175, 50, 1, 0, 4031967, 0, 0, 1, 0),
  (0, 4001176, 55, 1, 0, 4031968, 0, 0, 10, 0),
  (0, 4001177, 60, 1, 0, 4031969, 0, 0, 100, 0),
  (0, 4001178, 65, 1, 0, 4031970, 0, 0, 5, 0),
  (0, 4001179, 70, 1, 0, 4031971, 0, 0, 7, 0),
  (0, 4001180, 75, 2, 0, 4031972, 0, 0, 1, 0),
  (0, 4001181, 80, 2, 0, 4031973, 0, 0, 1, 0),
  (0, 4001182, 85, 2, 0, 4031974, 0, 0, 6, 0),
  (0, 4001183, 90, 2, 0, 4031975, 0, 0, 30, 0),
  (0, 4001184, 95, 2, 0, 4031976, 0, 0, 2, 0),
  (0, 4001185, 100, 2, 0, 4031977, 0, 0, 1, 0),
  (0, 4031980, 105, 2, 0, 4031979, 0, 0, 1, 0),
  (0, 4001186, 105, 3, 0, 4031978, 0, 0, 1, 0),
  (0, 4032334, 150, 1, 0, 0, 0, 0, 1, 0),
  (0, 4032312, 70, 1, 0, 0, 0, 0, 1, 0),
  (0, 2041058, 50, 1, 55000, 0, 1122013, 0, 1, 0),
  (0, 2040727, 50, 1, 55000, 0, 1122013, 0, 1, 0),
  (0, 4260007, 105, 3, 2200000, 4001126, 0, 0, 5, 0),
  (0, 4260008, 105, 3, 5500000, 4001126, 0, 0, 10, 0),
  (1, 1002028, 45, 1, 55000, 0, 0, 4130018, 1, 1),
  (1, 1002085, 45, 1, 50000, 0, 0, 4130018, 1, 1),
  (1, 1002086, 45, 1, 41000, 0, 0, 4130018, 1, 1),
  (1, 1002022, 50, 1, 60000, 0, 0, 4130018, 1, 1),
  (1, 1002100, 50, 1, 60000, 0, 0, 4130018, 1, 1),
  (1, 1002101, 50, 1, 60000, 0, 0, 4130018, 1, 1),
  (1, 1002029, 55, 1, 82000, 0, 0, 4130018, 1, 1),
  (1, 1002084, 55, 1, 82000, 0, 0, 4130018, 1, 1),
  (1, 1002030, 65, 1, 93000, 0, 0, 4130018, 1, 1),
  (1, 1002094, 65, 1, 93000, 0, 0, 4130018, 1, 1),
  (1, 1002095, 65, 1, 93000, 0, 0, 4130018, 1, 1),
  (1, 1002338, 75, 2, 146000, 0, 0, 4130018, 1, 2),
  (1, 1002339, 75, 2, 146000, 0, 0, 4130018, 1, 2),
  (1, 1002340, 75, 2, 146000, 0, 0, 4130018, 1, 2),
  (1, 1002528, 85, 2, 161000, 0, 0, 4130018, 1, 2),
  (1, 1002529, 85, 2, 161000, 0, 0, 4130018, 1, 2),
  (1, 1002530, 85, 2, 161000, 0, 0, 4130018, 1, 2),
  (1, 1002531, 85, 2, 161000, 0, 0, 4130018, 1, 2),
  (1, 1002532, 85, 2, 161000, 0, 0, 4130018, 1, 2),
  (1, 1002377, 95, 2, 184000, 0, 0, 4130018, 1, 2),
  (1, 1002378, 95, 2, 184000, 0, 0, 4130018, 1, 2),
  (1, 1002379, 95, 2, 184000, 0, 0, 4130018, 1, 2),
  (1, 1002551, 105, 3, 308000, 0, 0, 4130018, 1, 3),
  (1, 1002790, 115, 3, 352000, 0, 0, 4130018, 1, 3),
  (1, 1002776, 115, 3, 352000, 0, 0, 4130018, 1, 3),
  (1, 1040087, 45, 1, 41000, 0, 0, 4130019, 1, 1),
  (1, 1040088, 45, 1, 41000, 0, 0, 4130019, 1, 1),
  (1, 1040089, 45, 1, 41000, 0, 0, 4130019, 1, 1),
  (1, 1041087, 45, 1, 41000, 0, 0, 4130019, 1, 1),
  (1, 1041088, 45, 1, 41000, 0, 0, 4130019, 1, 1),
  (1, 1041089, 45, 1, 41000, 0, 0, 4130019, 1, 1),
  (1, 1040090, 55, 1, 50000, 0, 0, 4130019, 1, 1),
  (1, 1040091, 55, 1, 50000, 0, 0, 4130019, 1, 1),
  (1, 1040092, 55, 1, 50000, 0, 0, 4130019, 1, 1),
  (1, 1040093, 55, 1, 50000, 0, 0, 4130019, 1, 1),
  (1, 1041091, 55, 1, 50000, 0, 0, 4130019, 1, 1),
  (1, 1041092, 55, 1, 50000, 0, 0, 4130019, 1, 1),
  (1, 1041093, 55, 1, 50000, 0, 0, 4130019, 1, 1),
  (1, 1040102, 65, 1, 55000, 0, 0, 4130019, 1, 1),
  (1, 1040103, 65, 1, 55000, 0, 0, 4130019, 1, 1),
  (1, 1040104, 65, 1, 55000, 0, 0, 4130019, 1, 1),
  (1, 1041097, 65, 1, 55000, 0, 0, 4130019, 1, 1),
  (1, 1041098, 65, 1, 55000, 0, 0, 4130019, 1, 1),
  (1, 1041099, 65, 1, 55000, 0, 0, 4130019, 1, 1),
  (1, 1040111, 85, 2, 123000, 0, 0, 4130019, 1, 2),
  (1, 1040112, 85, 2, 123000, 0, 0, 4130019, 1, 2),
  (1, 1040113, 85, 2, 123000, 0, 0, 4130019, 1, 2),
  (1, 1041119, 85, 2, 146000, 0, 0, 4130019, 1, 2),
  (1, 1041120, 85, 2, 146000, 0, 0, 4130019, 1, 2),
  (1, 1041121, 85, 2, 146000, 0, 0, 4130019, 1, 2),
  (1, 1040120, 95, 2, 153000, 0, 0, 4130019, 1, 2),
  (1, 1040121, 95, 2, 153000, 0, 0, 4130019, 1, 2),
  (1, 1040122, 95, 2, 153000, 0, 0, 4130019, 1, 2),
  (1, 1041122, 95, 2, 153000, 0, 0, 4130019, 1, 2),
  (1, 1041123, 95, 2, 153000, 0, 0, 4130019, 1, 2),
  (1, 1041124, 95, 2, 153000, 0, 0, 4130019, 1, 2),
  (1, 1060076, 45, 1, 33000, 0, 0, 4130020, 1, 1),
  (1, 1060077, 45, 1, 33000, 0, 0, 4130020, 1, 1),
  (1, 1060078, 45, 1, 33000, 0, 0, 4130020, 1, 1),
  (1, 1061086, 45, 1, 33000, 0, 0, 4130020, 1, 1),
  (1, 1061087, 45, 1, 33000, 0, 0, 4130020, 1, 1),
  (1, 1061088, 45, 1, 33000, 0, 0, 4130020, 1, 1),
  (1, 1060079, 55, 1, 41000, 0, 0, 4130020, 1, 1),
  (1, 1060080, 55, 1, 41000, 0, 0, 4130020, 1, 1),
  (1, 1060081, 55, 1, 41000, 0, 0, 4130020, 1, 1),
  (1, 1060082, 55, 1, 41000, 0, 0, 4130020, 1, 1),
  (1, 1061090, 55, 1, 41000, 0, 0, 4130020, 1, 1),
  (1, 1061091, 55, 1, 41000, 0, 0, 4130020, 1, 1),
  (1, 1061092, 55, 1, 41000, 0, 0, 4130020, 1, 1),
  (1, 1060090, 65, 1, 50000, 0, 0, 4130020, 1, 1),
  (1, 1060091, 65, 1, 50000, 0, 0, 4130020, 1, 1),
  (1, 1060092, 65, 1, 50000, 0, 0, 4130020, 1, 1),
  (1, 1061096, 65, 1, 50000, 0, 0, 4130020, 1, 1),
  (1, 1061097, 65, 1, 50000, 0, 0, 4130020, 1, 1),
  (1, 1061098, 65, 1, 50000, 0, 0, 4130020, 1, 1),
  (1, 1060100, 85, 2, 107000, 0, 0, 4130020, 1, 2),
  (1, 1060101, 85, 2, 107000, 0, 0, 4130020, 1, 2),
  (1, 1060102, 85, 2, 107000, 0, 0, 4130020, 1, 2),
  (1, 1061118, 85, 2, 130000, 0, 0, 4130020, 1, 2),
  (1, 1061119, 85, 2, 130000, 0, 0, 4130020, 1, 2),
  (1, 1061120, 85, 2, 130000, 0, 0, 4130020, 1, 2),
  (1, 1060109, 95, 2, 138000, 0, 0, 4130020, 1, 2),
  (1, 1060110, 95, 2, 138000, 0, 0, 4130020, 1, 2),
  (1, 1060111, 95, 2, 138000, 0, 0, 4130020, 1, 2),
  (1, 1061121, 95, 2, 138000, 0, 0, 4130020, 1, 2),
  (1, 1061122, 95, 2, 138000, 0, 0, 4130020, 1, 2),
  (1, 1061123, 95, 2, 138000, 0, 0, 4130020, 1, 2),
  (1, 1050080, 75, 2, 138000, 0, 0, 4130021, 1, 2),
  (1, 1050081, 75, 2, 138000, 0, 0, 4130021, 1, 2),
  (1, 1050082, 75, 2, 138000, 0, 0, 4130021, 1, 2),
  (1, 1050083, 75, 2, 138000, 0, 0, 4130021, 1, 2),
  (1, 1051077, 75, 2, 138000, 0, 0, 4130021, 1, 2),
  (1, 1051078, 75, 2, 138000, 0, 0, 4130021, 1, 2),
  (1, 1051079, 75, 2, 138000, 0, 0, 4130021, 1, 2),
  (1, 1051080, 75, 2, 138000, 0, 0, 4130021, 1, 2),
  (1, 1052075, 105, 3, 352000, 0, 0, 4130021, 1, 3),
  (1, 1052160, 115, 3, 418000, 0, 0, 4130021, 1, 3),
  (1, 1052155, 115, 3, 418000, 0, 0, 4130021, 1, 3),
  (1, 1072132, 45, 1, 30000, 0, 0, 4130001, 1, 1),
  (1, 1072133, 45, 1, 30000, 0, 0, 4130001, 1, 1),
  (1, 1072134, 45, 1, 30000, 0, 0, 4130001, 1, 1),
  (1, 1072135, 45, 1, 30000, 0, 0, 4130001, 1, 1),
  (1, 1072147, 55, 1, 39000, 0, 0, 4130001, 1, 1),
  (1, 1072148, 55, 1, 39000, 0, 0, 4130001, 1, 1),
  (1, 1072149, 55, 1, 39000, 0, 0, 4130001, 1, 1),
  (1, 1072154, 65, 1, 47000, 0, 0, 4130001, 1, 1),
  (1, 1072155, 65, 1, 47000, 0, 0, 4130001, 1, 1),
  (1, 1072156, 65, 1, 47000, 0, 0, 4130001, 1, 1),
  (1, 1072210, 75, 2, 84000, 0, 0, 4130001, 1, 2),
  (1, 1072211, 75, 2, 84000, 0, 0, 4130001, 1, 2),
  (1, 1072212, 75, 2, 84000, 0, 0, 4130001, 1, 2),
  (1, 1072196, 85, 2, 115000, 0, 0, 4130001, 1, 2),
  (1, 1072197, 85, 2, 115000, 0, 0, 4130001, 1, 2),
  (1, 1072198, 85, 2, 115000, 0, 0, 4130001, 1, 2),
  (1, 1072220, 95, 2, 138000, 0, 0, 4130001, 1, 2),
  (1, 1072221, 95, 2, 138000, 0, 0, 4130001, 1, 2),
  (1, 1072222, 95, 2, 138000, 0, 0, 4130001, 1, 2),
  (1, 1072273, 105, 3, 231000, 0, 0, 4130001, 1, 3),
  (1, 1072361, 115, 3, 264000, 0, 0, 4130001, 1, 3),
  (1, 1072355, 115, 3, 264000, 0, 0, 4130001, 1, 3),
  (1, 1082009, 45, 1, 50000, 0, 0, 4130000, 1, 1),
  (1, 1082010, 45, 1, 55000, 0, 0, 4130000, 1, 1),
  (1, 1082011, 45, 1, 60000, 0, 0, 4130000, 1, 1),
  (1, 1082059, 55, 1, 66000, 0, 0, 4130000, 1, 1),
  (1, 1082060, 55, 1, 71000, 0, 0, 4130000, 1, 1),
  (1, 1082061, 55, 1, 77000, 0, 0, 4130000, 1, 1),
  (1, 1082103, 65, 1, 82000, 0, 0, 4130000, 1, 1),
  (1, 1082104, 65, 1, 88000, 0, 0, 4130000, 1, 1),
  (1, 1082105, 65, 1, 93000, 0, 0, 4130000, 1, 1),
  (1, 1082114, 75, 2, 161000, 0, 0, 4130000, 1, 2),
  (1, 1082115, 75, 2, 165000, 0, 0, 4130000, 1, 2),
  (1, 1082116, 75, 2, 168000, 0, 0, 4130000, 1, 2),
  (1, 1082117, 75, 2, 168000, 0, 0, 4130000, 1, 2),
  (1, 1082128, 85, 2, 184000, 0, 0, 4130000, 1, 2),
  (1, 1082129, 85, 2, 188000, 0, 0, 4130000, 1, 2),
  (1, 1082130, 85, 2, 191000, 0, 0, 4130000, 1, 2),
  (1, 1082139, 95, 2, 207000, 0, 0, 4130000, 1, 2),
  (1, 1082140, 95, 2, 210000, 0, 0, 4130000, 1, 2),
  (1, 1082141, 95, 2, 214000, 0, 0, 4130000, 1, 2),
  (1, 1082168, 105, 3, 330000, 0, 0, 4130000, 1, 3),
  (1, 1082239, 115, 3, 363000, 0, 0, 4130000, 1, 3),
  (1, 1082234, 115, 3, 363000, 0, 0, 4130000, 1, 3),
  (1, 1092004, 45, 1, 82000, 0, 0, 4130022, 1, 1),
  (1, 1092009, 55, 1, 99000, 0, 0, 4130022, 1, 1),
  (1, 1092010, 55, 1, 104000, 0, 0, 4130022, 1, 1),
  (1, 1092011, 55, 1, 104000, 0, 0, 4130022, 1, 1),
  (1, 1092015, 65, 1, 110000, 0, 0, 4130022, 1, 1),
  (1, 1092016, 65, 1, 115000, 0, 0, 4130022, 1, 1),
  (1, 1092017, 65, 1, 115000, 0, 0, 4130022, 1, 1),
  (1, 1092023, 75, 2, 168000, 0, 0, 4130022, 1, 2),
  (1, 1092024, 75, 2, 176000, 0, 0, 4130022, 1, 2),
  (1, 1092025, 75, 2, 176000, 0, 0, 4130022, 1, 2),
  (1, 1092026, 85, 2, 184000, 0, 0, 4130022, 1, 2),
  (1, 1092027, 85, 2, 191000, 0, 0, 4130022, 1, 2),
  (1, 1092028, 85, 2, 191000, 0, 0, 4130022, 1, 2),
  (1, 1092036, 95, 2, 199000, 0, 0, 4130022, 1, 2),
  (1, 1092037, 95, 2, 207000, 0, 0, 4130022, 1, 2),
  (1, 1092038, 95, 2, 214000, 0, 0, 4130022, 1, 2),
  (1, 1092060, 105, 3, 231000, 0, 0, 4130022, 1, 3),
  (1, 1092058, 115, 3, 385000, 0, 0, 4130022, 1, 3),
  (1, 1302010, 45, 1, 66000, 0, 0, 4130002, 1, 1),
  (1, 1312008, 45, 1, 77000, 0, 0, 4130003, 1, 1),
  (1, 1322017, 45, 1, 77000, 0, 0, 4130004, 1, 1),
  (1, 1402003, 45, 1, 110000, 0, 0, 4130005, 1, 1),
  (1, 1412003, 45, 1, 77000, 0, 0, 4130006, 1, 1),
  (1, 1422005, 45, 1, 82000, 0, 0, 4130007, 1, 1),
  (1, 1432004, 45, 1, 82000, 0, 0, 4130008, 1, 1),
  (1, 1442005, 45, 1, 82000, 0, 0, 4130009, 1, 1),
  (1, 1302011, 55, 1, 82000, 0, 0, 4130002, 1, 1),
  (1, 1312009, 55, 1, 104000, 0, 0, 4130003, 1, 1),
  (1, 1322018, 55, 1, 104000, 0, 0, 4130004, 1, 1),
  (1, 1402011, 55, 1, 126000, 0, 0, 4130005, 1, 1),
  (1, 1412007, 55, 1, 104000, 0, 0, 4130006, 1, 1),
  (1, 1422009, 55, 1, 104000, 0, 0, 4130007, 1, 1),
  (1, 1432006, 55, 1, 104000, 0, 0, 4130008, 1, 1),
  (1, 1442010, 55, 1, 137000, 0, 0, 4130009, 1, 1),
  (1, 1302012, 65, 1, 137000, 0, 0, 4130002, 1, 1),
  (1, 1312010, 65, 1, 165000, 0, 0, 4130003, 1, 1),
  (1, 1322019, 65, 1, 137000, 0, 0, 4130004, 1, 1),
  (1, 1402012, 65, 1, 143000, 0, 0, 4130005, 1, 1),
  (1, 1412008, 65, 1, 137000, 0, 0, 4130006, 1, 1),
  (1, 1422010, 65, 1, 137000, 0, 0, 4130007, 1, 1),
  (1, 1432007, 65, 1, 137000, 0, 0, 4130008, 1, 1),
  (1, 1442008, 65, 1, 165000, 0, 0, 4130009, 1, 1),
  (1, 1322020, 70, 1, 165000, 0, 0, 4130004, 1, 1),
  (1, 1302018, 75, 2, 231000, 0, 0, 4130002, 1, 2),
  (1, 1312011, 75, 2, 269000, 0, 0, 4130003, 1, 2),
  (1, 1322028, 75, 2, 269000, 0, 0, 4130004, 1, 2),
  (1, 1402004, 75, 2, 231000, 0, 0, 4130005, 1, 2),
  (1, 1402015, 75, 2, 231000, 0, 0, 4130005, 1, 2),
  (1, 1412009, 75, 2, 238000, 0, 0, 4130006, 1, 2),
  (1, 1422012, 75, 2, 238000, 0, 0, 4130007, 1, 2),
  (1, 1432010, 75, 2, 238000, 0, 0, 4130008, 1, 2),
  (1, 1442019, 75, 2, 269000, 0, 0, 4130009, 1, 2),
  (1, 1302023, 85, 2, 269000, 0, 0, 4130002, 1, 2),
  (1, 1312015, 85, 2, 308000, 0, 0, 4130003, 1, 2),
  (1, 1322029, 85, 2, 308000, 0, 0, 4130004, 1, 2),
  (1, 1402005, 85, 2, 308000, 0, 0, 4130005, 1, 2),
  (1, 1402016, 85, 2, 308000, 0, 0, 4130005, 1, 2),
  (1, 1412010, 85, 2, 284000, 0, 0, 4130006, 1, 2),
  (1, 1422013, 85, 2, 284000, 0, 0, 4130007, 1, 2),
  (1, 1432011, 85, 2, 284000, 0, 0, 4130008, 1, 2),
  (1, 1442020, 85, 2, 346000, 0, 0, 4130009, 1, 2),
  (1, 1302056, 95, 2, 369000, 0, 0, 4130002, 1, 2),
  (1, 1312030, 95, 2, 361000, 0, 0, 4130003, 1, 2),
  (1, 1322045, 95, 2, 361000, 0, 0, 4130004, 1, 2),
  (1, 1402035, 95, 2, 361000, 0, 0, 4130005, 1, 2),
  (1, 1412021, 95, 2, 377000, 0, 0, 4130006, 1, 2),
  (1, 1422027, 95, 2, 346000, 0, 0, 4130007, 1, 2),
  (1, 1432030, 95, 2, 377000, 0, 0, 4130008, 1, 2),
  (1, 1442044, 95, 2, 361000, 0, 0, 4130009, 1, 2),
  (1, 1302059, 105, 3, 605000, 0, 0, 4130002, 1, 3),
  (1, 1312031, 105, 3, 583000, 0, 0, 4130003, 1, 3),
  (1, 1322052, 105, 3, 528000, 0, 0, 4130004, 1, 3),
  (1, 1402036, 105, 3, 605000, 0, 0, 4130005, 1, 3),
  (1, 1412026, 105, 3, 572000, 0, 0, 4130006, 1, 3),
  (1, 1422028, 105, 3, 561000, 0, 0, 4130007, 1, 3),
  (1, 1432038, 105, 3, 583000, 0, 0, 4130008, 1, 3),
  (1, 1442045, 105, 3, 627000, 0, 0, 4130009, 1, 3),
  (1, 1302086, 115, 3, 748000, 0, 0, 4130002, 1, 3),
  (1, 1312038, 115, 3, 638000, 0, 0, 4130003, 1, 3),
  (1, 1322061, 115, 3, 539000, 0, 0, 4130004, 1, 3),
  (1, 1402047, 115, 3, 715000, 0, 0, 4130005, 1, 3),
  (1, 1412034, 115, 3, 715000, 0, 0, 4130006, 1, 3),
  (1, 1422038, 115, 3, 616000, 0, 0, 4130007, 1, 3),
  (1, 1432049, 115, 3, 627000, 0, 0, 4130008, 1, 3),
  (1, 1442067, 115, 3, 682000, 0, 0, 4130009, 1, 3),
  (1, 1302081, 115, 3, 748000, 0, 0, 4130002, 1, 3),
  (1, 1312037, 115, 3, 638000, 0, 0, 4130003, 1, 3),
  (1, 1322060, 115, 3, 539000, 0, 0, 4130004, 1, 3),
  (1, 1402046, 115, 3, 715000, 0, 0, 4130005, 1, 3),
  (1, 1412033, 115, 3, 715000, 0, 0, 4130006, 1, 3),
  (1, 1422037, 115, 3, 616000, 0, 0, 4130007, 1, 3),
  (1, 1432047, 115, 3, 627000, 0, 0, 4130008, 1, 3),
  (1, 1442063, 115, 3, 682000, 0, 0, 4130009, 1, 3),
  (2, 1002215, 45, 1, 22000, 0, 0, 4130018, 1, 1),
  (2, 1002216, 45, 1, 22000, 0, 0, 4130018, 1, 1),
  (2, 1002217, 45, 1, 22000, 0, 0, 4130018, 1, 1),
  (2, 1002218, 45, 1, 22000, 0, 0, 4130018, 1, 1),
  (2, 1002242, 55, 1, 28000, 0, 0, 4130018, 1, 1),
  (2, 1002243, 55, 1, 28000, 0, 0, 4130018, 1, 1),
  (2, 1002244, 55, 1, 28000, 0, 0, 4130018, 1, 1),
  (2, 1002245, 55, 1, 28000, 0, 0, 4130018, 1, 1),
  (2, 1002246, 55, 1, 28000, 0, 0, 4130018, 1, 1),
  (2, 1002252, 65, 1, 44000, 0, 0, 4130018, 1, 1),
  (2, 1002253, 65, 1, 44000, 0, 0, 4130018, 1, 1),
  (2, 1002254, 65, 1, 44000, 0, 0, 4130018, 1, 1),
  (2, 1002271, 75, 2, 73000, 0, 0, 4130018, 1, 2),
  (2, 1002272, 75, 2, 73000, 0, 0, 4130018, 1, 2),
  (2, 1002273, 75, 2, 73000, 0, 0, 4130018, 1, 2),
  (2, 1002274, 75, 2, 73000, 0, 0, 4130018, 1, 2),
  (2, 1002363, 85, 2, 84000, 0, 0, 4130018, 1, 2),
  (2, 1002364, 85, 2, 84000, 0, 0, 4130018, 1, 2),
  (2, 1002365, 85, 2, 84000, 0, 0, 4130018, 1, 2),
  (2, 1002366, 85, 2, 84000, 0, 0, 4130018, 1, 2),
  (2, 1002398, 95, 2, 96000, 0, 0, 4130018, 1, 2),
  (2, 1002399, 95, 2, 96000, 0, 0, 4130018, 1, 2),
  (2, 1002400, 95, 2, 96000, 0, 0, 4130018, 1, 2),
  (2, 1002401, 95, 2, 96000, 0, 0, 4130018, 1, 2),
  (2, 1002773, 105, 3, 165000, 0, 0, 4130018, 1, 3),
  (2, 1002791, 115, 3, 187000, 0, 0, 4130018, 1, 3),
  (2, 1002777, 115, 3, 187000, 0, 0, 4130018, 1, 3),
  (2, 1050045, 43, 1, 50000, 0, 0, 4130021, 1, 1),
  (2, 1050046, 43, 1, 50000, 0, 0, 4130021, 1, 1),
  (2, 1050047, 43, 1, 50000, 0, 0, 4130021, 1, 1),
  (2, 1050048, 43, 1, 50000, 0, 0, 4130021, 1, 1),
  (2, 1050049, 43, 1, 50000, 0, 0, 4130021, 1, 1),
  (2, 1051030, 43, 1, 50000, 0, 0, 4130021, 1, 1),
  (2, 1051031, 43, 1, 50000, 0, 0, 4130021, 1, 1),
  (2, 1051032, 43, 1, 50000, 0, 0, 4130021, 1, 1),
  (2, 1051033, 43, 1, 50000, 0, 0, 4130021, 1, 1),
  (2, 1051034, 43, 1, 50000, 0, 0, 4130021, 1, 1),
  (2, 1050053, 53, 1, 55000, 0, 0, 4130021, 1, 1),
  (2, 1050054, 53, 1, 55000, 0, 0, 4130021, 1, 1),
  (2, 1050055, 53, 1, 55000, 0, 0, 4130021, 1, 1),
  (2, 1050056, 53, 1, 55000, 0, 0, 4130021, 1, 1),
  (2, 1051044, 53, 1, 55000, 0, 0, 4130021, 1, 1),
  (2, 1051045, 53, 1, 55000, 0, 0, 4130021, 1, 1),
  (2, 1051046, 53, 1, 55000, 0, 0, 4130021, 1, 1),
  (2, 1051047, 53, 1, 55000, 0, 0, 4130021, 1, 1),
  (2, 1050067, 63, 1, 66000, 0, 0, 4130021, 1, 1),
  (2, 1050068, 63, 1, 66000, 0, 0, 4130021, 1, 1),
  (2, 1050069, 63, 1, 66000, 0, 0, 4130021, 1, 1),
  (2, 1050070, 63, 1, 66000, 0, 0, 4130021, 1, 1),
  (2, 1051052, 63, 1, 66000, 0, 0, 4130021, 1, 1),
  (2, 1051053, 63, 1, 66000, 0, 0, 4130021, 1, 1),
  (2, 1051054, 63, 1, 66000, 0, 0, 4130021, 1, 1),
  (2, 1051055, 63, 1, 66000, 0, 0, 4130021, 1, 1),
  (2, 1050072, 73, 2, 123000, 0, 0, 4130021, 1, 2),
  (2, 1050073, 73, 2, 123000, 0, 0, 4130021, 1, 2),
  (2, 1050074, 73, 2, 123000, 0, 0, 4130021, 1, 2),
  (2, 1051056, 73, 2, 123000, 0, 0, 4130021, 1, 2),
  (2, 1051057, 73, 2, 123000, 0, 0, 4130021, 1, 2),
  (2, 1051058, 73, 2, 123000, 0, 0, 4130021, 1, 2),
  (2, 1050092, 83, 2, 153000, 0, 0, 4130021, 1, 2),
  (2, 1050093, 83, 2, 153000, 0, 0, 4130021, 1, 2),
  (2, 1050094, 83, 2, 153000, 0, 0, 4130021, 1, 2),
  (2, 1050095, 83, 2, 153000, 0, 0, 4130021, 1, 2),
  (2, 1051094, 83, 2, 153000, 0, 0, 4130021, 1, 2),
  (2, 1051095, 83, 2, 153000, 0, 0, 4130021, 1, 2),
  (2, 1051096, 83, 2, 153000, 0, 0, 4130021, 1, 2),
  (2, 1051097, 83, 2, 153000, 0, 0, 4130021, 1, 2),
  (2, 1050102, 93, 2, 184000, 0, 0, 4130021, 1, 2),
  (2, 1050103, 93, 2, 184000, 0, 0, 4130021, 1, 2),
  (2, 1050104, 93, 2, 184000, 0, 0, 4130021, 1, 2),
  (2, 1050105, 93, 2, 184000, 0, 0, 4130021, 1, 2),
  (2, 1051101, 93, 2, 184000, 0, 0, 4130021, 1, 2),
  (2, 1051102, 93, 2, 184000, 0, 0, 4130021, 1, 2),
  (2, 1051103, 93, 2, 184000, 0, 0, 4130021, 1, 2),
  (2, 1051104, 93, 2, 184000, 0, 0, 4130021, 1, 2),
  (2, 1052076, 103, 3, 319000, 0, 0, 4130021, 1, 3),
  (2, 1052161, 115, 3, 374000, 0, 0, 4130021, 1, 3),
  (2, 1052156, 115, 3, 374000, 0, 0, 4130021, 1, 3),
  (2, 1072140, 45, 1, 30000, 0, 0, 4130001, 1, 1),
  (2, 1072141, 45, 1, 30000, 0, 0, 4130001, 1, 1),
  (2, 1072142, 45, 1, 30000, 0, 0, 4130001, 1, 1),
  (2, 1072143, 45, 1, 30000, 0, 0, 4130001, 1, 1),
  (2, 1072136, 55, 1, 33000, 0, 0, 4130001, 1, 1),
  (2, 1072137, 55, 1, 33000, 0, 0, 4130001, 1, 1),
  (2, 1072138, 55, 1, 33000, 0, 0, 4130001, 1, 1),
  (2, 1072139, 55, 1, 33000, 0, 0, 4130001, 1, 1),
  (2, 1072157, 65, 1, 44000, 0, 0, 4130001, 1, 1),
  (2, 1072158, 65, 1, 44000, 0, 0, 4130001, 1, 1),
  (2, 1072159, 65, 1, 44000, 0, 0, 4130001, 1, 1),
  (2, 1072160, 65, 1, 44000, 0, 0, 4130001, 1, 1),
  (2, 1072177, 75, 2, 77000, 0, 0, 4130001, 1, 2),
  (2, 1072178, 75, 2, 77000, 0, 0, 4130001, 1, 2),
  (2, 1072179, 75, 2, 77000, 0, 0, 4130001, 1, 2),
  (2, 1072206, 85, 2, 92000, 0, 0, 4130001, 1, 2),
  (2, 1072207, 85, 2, 92000, 0, 0, 4130001, 1, 2),
  (2, 1072208, 85, 2, 92000, 0, 0, 4130001, 1, 2),
  (2, 1072209, 85, 2, 92000, 0, 0, 4130001, 1, 2),
  (2, 1072223, 95, 2, 107000, 0, 0, 4130001, 1, 2),
  (2, 1072224, 95, 2, 107000, 0, 0, 4130001, 1, 2),
  (2, 1072225, 95, 2, 107000, 0, 0, 4130001, 1, 2),
  (2, 1072226, 95, 2, 107000, 0, 0, 4130001, 1, 2),
  (2, 1072268, 105, 3, 198000, 0, 0, 4130001, 1, 3),
  (2, 1072362, 115, 3, 242000, 0, 0, 4130001, 1, 3),
  (2, 1072356, 115, 3, 242000, 0, 0, 4130001, 1, 3),
  (2, 1082080, 45, 1, 55000, 0, 0, 4130000, 1, 1),
  (2, 1082081, 45, 1, 44000, 0, 0, 4130000, 1, 1),
  (2, 1082082, 45, 1, 50000, 0, 0, 4130000, 1, 1),
  (2, 1082086, 55, 1, 58000, 0, 0, 4130000, 1, 1),
  (2, 1082087, 55, 1, 63000, 0, 0, 4130000, 1, 1),
  (2, 1082088, 55, 1, 69000, 0, 0, 4130000, 1, 1),
  (2, 1082098, 65, 1, 77000, 0, 0, 4130000, 1, 1),
  (2, 1082099, 65, 1, 80000, 0, 0, 4130000, 1, 1),
  (2, 1082100, 65, 1, 82000, 0, 0, 4130000, 1, 1),
  (2, 1082121, 75, 2, 153000, 0, 0, 4130000, 1, 2),
  (2, 1082122, 75, 2, 157000, 0, 0, 4130000, 1, 2),
  (2, 1082123, 75, 2, 161000, 0, 0, 4130000, 1, 2),
  (2, 1082131, 85, 2, 176000, 0, 0, 4130000, 1, 2),
  (2, 1082132, 85, 2, 180000, 0, 0, 4130000, 1, 2),
  (2, 1082133, 85, 2, 180000, 0, 0, 4130000, 1, 2),
  (2, 1082134, 85, 2, 184000, 0, 0, 4130000, 1, 2),
  (2, 1082151, 95, 2, 199000, 0, 0, 4130000, 1, 2),
  (2, 1082152, 95, 2, 203000, 0, 0, 4130000, 1, 2),
  (2, 1082153, 95, 2, 203000, 0, 0, 4130000, 1, 2),
  (2, 1082154, 95, 2, 207000, 0, 0, 4130000, 1, 2),
  (2, 1082164, 105, 3, 330000, 0, 0, 4130000, 1, 3),
  (2, 1082240, 115, 3, 363000, 0, 0, 4130000, 1, 3),
  (2, 1082235, 115, 3, 363000, 0, 0, 4130000, 1, 3),
  (2, 1092057, 115, 3, 385000, 0, 0, 4130022, 1, 3),
  (2, 1372007, 43, 1, 110000, 0, 0, 4130010, 1, 1),
  (2, 1382006, 50, 1, 82000, 0, 0, 4130011, 1, 1),
  (2, 1372014, 53, 1, 126000, 0, 0, 4130010, 1, 1),
  (2, 1382007, 60, 1, 110000, 0, 0, 4130011, 1, 1),
  (2, 1372015, 63, 1, 143000, 0, 0, 4130010, 1, 1),
  (2, 1382010, 70, 1, 137000, 0, 0, 4130011, 1, 1),
  (2, 1372016, 73, 2, 223000, 0, 0, 4130010, 1, 2),
  (2, 1382008, 80, 2, 238000, 0, 0, 4130011, 1, 2),
  (2, 1372009, 83, 2, 250000, 0, 0, 4130010, 1, 2),
  (2, 1382035, 90, 2, 292000, 0, 0, 4130011, 1, 2),
  (2, 1372010, 93, 2, 277000, 0, 0, 4130010, 1, 2),
  (2, 1372032, 103, 3, 506000, 0, 0, 4130010, 1, 3),
  (2, 1382036, 105, 3, 517000, 0, 0, 4130011, 1, 3),
  (2, 1372045, 115, 3, 561000, 0, 0, 4130010, 1, 3),
  (2, 1382059, 115, 3, 572000, 0, 0, 4130011, 1, 3),
  (2, 1372044, 115, 3, 561000, 0, 0, 4130010, 1, 3),
  (2, 1382057, 115, 3, 572000, 0, 0, 4130011, 1, 3),
  (4, 1002211, 45, 1, 22000, 0, 0, 4130018, 1, 1),
  (4, 1002212, 45, 1, 22000, 0, 0, 4130018, 1, 1),
  (4, 1002213, 45, 1, 22000, 0, 0, 4130018, 1, 1),
  (4, 1002214, 45, 1, 22000, 0, 0, 4130018, 1, 1),
  (4, 1002267, 55, 1, 30000, 0, 0, 4130018, 1, 1),
  (4, 1002268, 55, 1, 30000, 0, 0, 4130018, 1, 1),
  (4, 1002269, 55, 1, 30000, 0, 0, 4130018, 1, 1),
  (4, 1002270, 55, 1, 30000, 0, 0, 4130018, 1, 1),
  (4, 1002286, 65, 1, 47000, 0, 0, 4130018, 1, 1),
  (4, 1002287, 65, 1, 47000, 0, 0, 4130018, 1, 1),
  (4, 1002288, 65, 1, 47000, 0, 0, 4130018, 1, 1),
  (4, 1002289, 65, 1, 47000, 0, 0, 4130018, 1, 1),
  (4, 1002275, 75, 2, 77000, 0, 0, 4130018, 1, 2),
  (4, 1002276, 75, 2, 77000, 0, 0, 4130018, 1, 2),
  (4, 1002277, 75, 2, 77000, 0, 0, 4130018, 1, 2),
  (4, 1002278, 75, 2, 77000, 0, 0, 4130018, 1, 2),
  (4, 1002402, 85, 2, 88000, 0, 0, 4130018, 1, 2),
  (4, 1002403, 85, 2, 88000, 0, 0, 4130018, 1, 2),
  (4, 1002404, 85, 2, 88000, 0, 0, 4130018, 1, 2),
  (4, 1002405, 85, 2, 88000, 0, 0, 4130018, 1, 2),
  (4, 1002406, 95, 2, 100000, 0, 0, 4130018, 1, 2),
  (4, 1002407, 95, 2, 100000, 0, 0, 4130018, 1, 2),
  (4, 1002408, 95, 2, 100000, 0, 0, 4130018, 1, 2),
  (4, 1002547, 105, 3, 165000, 0, 0, 4130018, 1, 3),
  (4, 1002792, 115, 3, 187000, 0, 0, 4130018, 1, 3),
  (4, 1002778, 115, 3, 187000, 0, 0, 4130018, 1, 3),
  (4, 1050051, 45, 1, 52000, 0, 0, 4130021, 1, 1),
  (4, 1050052, 45, 1, 52000, 0, 0, 4130021, 1, 1),
  (4, 1051037, 45, 1, 52000, 0, 0, 4130021, 1, 1),
  (4, 1051038, 45, 1, 52000, 0, 0, 4130021, 1, 1),
  (4, 1051039, 45, 1, 52000, 0, 0, 4130021, 1, 1),
  (4, 1050058, 55, 1, 58000, 0, 0, 4130021, 1, 1),
  (4, 1050059, 55, 1, 58000, 0, 0, 4130021, 1, 1),
  (4, 1050060, 55, 1, 58000, 0, 0, 4130021, 1, 1),
  (4, 1051041, 55, 1, 58000, 0, 0, 4130021, 1, 1),
  (4, 1051042, 55, 1, 58000, 0, 0, 4130021, 1, 1),
  (4, 1051043, 55, 1, 58000, 0, 0, 4130021, 1, 1),
  (4, 1050061, 65, 1, 63000, 0, 0, 4130021, 1, 1),
  (4, 1050062, 65, 1, 63000, 0, 0, 4130021, 1, 1),
  (4, 1050063, 65, 1, 63000, 0, 0, 4130021, 1, 1),
  (4, 1050064, 65, 1, 63000, 0, 0, 4130021, 1, 1),
  (4, 1051062, 65, 1, 63000, 0, 0, 4130021, 1, 1),
  (4, 1051063, 65, 1, 63000, 0, 0, 4130021, 1, 1),
  (4, 1051064, 65, 1, 63000, 0, 0, 4130021, 1, 1),
  (4, 1051065, 65, 1, 63000, 0, 0, 4130021, 1, 1),
  (4, 1050075, 75, 2, 107000, 0, 0, 4130021, 1, 2),
  (4, 1050076, 75, 2, 107000, 0, 0, 4130021, 1, 2),
  (4, 1050077, 75, 2, 107000, 0, 0, 4130021, 1, 2),
  (4, 1050078, 75, 2, 107000, 0, 0, 4130021, 1, 2),
  (4, 1051066, 75, 2, 107000, 0, 0, 4130021, 1, 2),
  (4, 1051067, 75, 2, 107000, 0, 0, 4130021, 1, 2),
  (4, 1051068, 75, 2, 107000, 0, 0, 4130021, 1, 2),
  (4, 1051069, 75, 2, 107000, 0, 0, 4130021, 1, 2),
  (4, 1050088, 85, 2, 153000, 0, 0, 4130021, 1, 2),
  (4, 1050089, 85, 2, 153000, 0, 0, 4130021, 1, 2),
  (4, 1050090, 85, 2, 153000, 0, 0, 4130021, 1, 2),
  (4, 1050091, 85, 2, 153000, 0, 0, 4130021, 1, 2),
  (4, 1051082, 85, 2, 153000, 0, 0, 4130021, 1, 2),
  (4, 1051083, 85, 2, 153000, 0, 0, 4130021, 1, 2),
  (4, 1051084, 85, 2, 153000, 0, 0, 4130021, 1, 2),
  (4, 1051085, 85, 2, 153000, 0, 0, 4130021, 1, 2),
  (4, 1050106, 95, 2, 184000, 0, 0, 4130021, 1, 2),
  (4, 1050107, 95, 2, 184000, 0, 0, 4130021, 1, 2),
  (4, 1050108, 95, 2, 184000, 0, 0, 4130021, 1, 2),
  (4, 1051105, 95, 2, 184000, 0, 0, 4130021, 1, 2),
  (4, 1051106, 95, 2, 184000, 0, 0, 4130021, 1, 2),
  (4, 1051107, 95, 2, 184000, 0, 0, 4130021, 1, 2),
  (4, 1052071, 105, 3, 330000, 0, 0, 4130021, 1, 3),
  (4, 1052162, 115, 3, 396000, 0, 0, 4130021, 1, 3),
  (4, 1052157, 115, 3, 396000, 0, 0, 4130021, 1, 3),
  (4, 1072122, 45, 1, 28000, 0, 0, 4130001, 1, 1),
  (4, 1072123, 45, 1, 28000, 0, 0, 4130001, 1, 1),
  (4, 1072124, 45, 1, 28000, 0, 0, 4130001, 1, 1),
  (4, 1072125, 45, 1, 28000, 0, 0, 4130001, 1, 1),
  (4, 1072144, 55, 1, 36000, 0, 0, 4130001, 1, 1),
  (4, 1072145, 55, 1, 36000, 0, 0, 4130001, 1, 1),
  (4, 1072146, 55, 1, 36000, 0, 0, 4130001, 1, 1),
  (4, 1072164, 65, 1, 50000, 0, 0, 4130001, 1, 1),
  (4, 1072165, 65, 1, 50000, 0, 0, 4130001, 1, 1),
  (4, 1072166, 65, 1, 50000, 0, 0, 4130001, 1, 1),
  (4, 1072167, 65, 1, 50000, 0, 0, 4130001, 1, 1),
  (4, 1072182, 75, 2, 84000, 0, 0, 4130001, 1, 2),
  (4, 1072183, 75, 2, 84000, 0, 0, 4130001, 1, 2),
  (4, 1072184, 75, 2, 84000, 0, 0, 4130001, 1, 2),
  (4, 1072185, 75, 2, 84000, 0, 0, 4130001, 1, 2),
  (4, 1072203, 85, 2, 107000, 0, 0, 4130001, 1, 2),
  (4, 1072204, 85, 2, 107000, 0, 0, 4130001, 1, 2),
  (4, 1072205, 85, 2, 107000, 0, 0, 4130001, 1, 2),
  (4, 1072227, 95, 2, 130000, 0, 0, 4130001, 1, 2),
  (4, 1072228, 95, 2, 130000, 0, 0, 4130001, 1, 2),
  (4, 1072229, 95, 2, 130000, 0, 0, 4130001, 1, 2),
  (4, 1072269, 105, 3, 198000, 0, 0, 4130001, 1, 3),
  (4, 1072363, 115, 3, 220000, 0, 0, 4130001, 1, 3),
  (4, 1072357, 115, 3, 220000, 0, 0, 4130001, 1, 3),
  (4, 1082083, 45, 1, 58000, 0, 0, 4130000, 1, 1),
  (4, 1082084, 45, 1, 47000, 0, 0, 4130000, 1, 1),
  (4, 1082085, 45, 1, 52000, 0, 0, 4130000, 1, 1),
  (4, 1082089, 55, 1, 60000, 0, 0, 4130000, 1, 1),
  (4, 1082090, 55, 1, 66000, 0, 0, 4130000, 1, 1),
  (4, 1082091, 55, 1, 71000, 0, 0, 4130000, 1, 1),
  (4, 1082106, 65, 1, 77000, 0, 0, 4130000, 1, 1),
  (4, 1082107, 65, 1, 82000, 0, 0, 4130000, 1, 1),
  (4, 1082108, 65, 1, 88000, 0, 0, 4130000, 1, 1),
  (4, 1082109, 75, 2, 153000, 0, 0, 4130000, 1, 2),
  (4, 1082110, 75, 2, 157000, 0, 0, 4130000, 1, 2),
  (4, 1082111, 75, 2, 157000, 0, 0, 4130000, 1, 2),
  (4, 1082112, 75, 2, 161000, 0, 0, 4130000, 1, 2),
  (4, 1082125, 85, 2, 176000, 0, 0, 4130000, 1, 2),
  (4, 1082126, 85, 2, 180000, 0, 0, 4130000, 1, 2),
  (4, 1082127, 85, 2, 184000, 0, 0, 4130000, 1, 2),
  (4, 1082158, 95, 2, 199000, 0, 0, 4130000, 1, 2),
  (4, 1082159, 95, 2, 203000, 0, 0, 4130000, 1, 2),
  (4, 1082160, 95, 2, 207000, 0, 0, 4130000, 1, 2),
  (4, 1082163, 105, 3, 330000, 0, 0, 4130000, 1, 3),
  (4, 1082241, 115, 3, 363000, 0, 0, 4130000, 1, 3),
  (4, 1082236, 115, 3, 363000, 0, 0, 4130000, 1, 3),
  (4, 1452008, 45, 1, 110000, 0, 0, 4130012, 1, 1),
  (4, 1462007, 45, 1, 93000, 0, 0, 4130013, 1, 1),
  (4, 1452004, 55, 1, 137000, 0, 0, 4130012, 1, 1),
  (4, 1462008, 55, 1, 132000, 0, 0, 4130013, 1, 1),
  (4, 1452009, 65, 1, 165000, 0, 0, 4130012, 1, 1),
  (4, 1452010, 65, 1, 165000, 0, 0, 4130012, 1, 1),
  (4, 1452011, 65, 1, 165000, 0, 0, 4130012, 1, 1),
  (4, 1462009, 65, 1, 165000, 0, 0, 4130013, 1, 1),
  (4, 1452012, 75, 2, 269000, 0, 0, 4130012, 1, 2),
  (4, 1452013, 75, 2, 269000, 0, 0, 4130012, 1, 2),
  (4, 1452014, 75, 2, 269000, 0, 0, 4130012, 1, 2),
  (4, 1452015, 75, 2, 269000, 0, 0, 4130012, 1, 2),
  (4, 1462010, 75, 2, 269000, 0, 0, 4130013, 1, 2),
  (4, 1462011, 75, 2, 269000, 0, 0, 4130013, 1, 2),
  (4, 1462012, 75, 2, 269000, 0, 0, 4130013, 1, 2),
  (4, 1462013, 75, 2, 269000, 0, 0, 4130013, 1, 2),
  (4, 1452017, 85, 2, 308000, 0, 0, 4130012, 1, 2),
  (4, 1462018, 85, 2, 308000, 0, 0, 4130013, 1, 2),
  (4, 1452019, 95, 2, 346000, 0, 0, 4130012, 1, 2),
  (4, 1452020, 95, 2, 346000, 0, 0, 4130012, 1, 2),
  (4, 1452021, 95, 2, 346000, 0, 0, 4130012, 1, 2),
  (4, 1462015, 95, 2, 346000, 0, 0, 4130013, 1, 2),
  (4, 1462016, 95, 2, 346000, 0, 0, 4130013, 1, 2),
  (4, 1462017, 95, 2, 346000, 0, 0, 4130013, 1, 2),
  (4, 1452044, 105, 3, 550000, 0, 0, 4130012, 1, 3),
  (4, 1462039, 105, 3, 550000, 0, 0, 4130013, 1, 3),
  (4, 1452059, 115, 3, 605000, 0, 0, 4130012, 1, 3),
  (4, 1462051, 115, 3, 605000, 0, 0, 4130013, 1, 3),
  (4, 1452057, 115, 3, 605000, 0, 0, 4130012, 1, 3),
  (4, 1462050, 115, 3, 605000, 0, 0, 4130013, 1, 3),
  (8, 1002207, 45, 1, 22000, 0, 0, 4130018, 1, 1),
  (8, 1002208, 45, 1, 22000, 0, 0, 4130018, 1, 1),
  (8, 1002209, 45, 1, 22000, 0, 0, 4130018, 1, 1),
  (8, 1002210, 45, 1, 22000, 0, 0, 4130018, 1, 1),
  (8, 1002247, 55, 1, 30000, 0, 0, 4130018, 1, 1),
  (8, 1002248, 55, 1, 30000, 0, 0, 4130018, 1, 1),
  (8, 1002249, 55, 1, 30000, 0, 0, 4130018, 1, 1),
  (8, 1002281, 65, 1, 47000, 0, 0, 4130018, 1, 1),
  (8, 1002282, 65, 1, 47000, 0, 0, 4130018, 1, 1),
  (8, 1002283, 65, 1, 47000, 0, 0, 4130018, 1, 1),
  (8, 1002284, 65, 1, 47000, 0, 0, 4130018, 1, 1),
  (8, 1002285, 65, 1, 47000, 0, 0, 4130018, 1, 1),
  (8, 1002327, 75, 2, 77000, 0, 0, 4130018, 1, 2),
  (8, 1002328, 75, 2, 77000, 0, 0, 4130018, 1, 2),
  (8, 1002329, 75, 2, 77000, 0, 0, 4130018, 1, 2),
  (8, 1002330, 75, 2, 77000, 0, 0, 4130018, 1, 2),
  (8, 1002323, 85, 2, 88000, 0, 0, 4130018, 1, 2),
  (8, 1002324, 85, 2, 88000, 0, 0, 4130018, 1, 2),
  (8, 1002325, 85, 2, 88000, 0, 0, 4130018, 1, 2),
  (8, 1002326, 85, 2, 88000, 0, 0, 4130018, 1, 2),
  (8, 1002380, 95, 2, 100000, 0, 0, 4130018, 1, 2),
  (8, 1002381, 95, 2, 100000, 0, 0, 4130018, 1, 2),
  (8, 1002382, 95, 2, 100000, 0, 0, 4130018, 1, 2),
  (8, 1002383, 95, 2, 100000, 0, 0, 4130018, 1, 2),
  (8, 1002550, 105, 3, 165000, 0, 0, 4130018, 1, 3),
  (8, 1002793, 115, 3, 209000, 0, 0, 4130018, 1, 3),
  (8, 1002779, 115, 3, 209000, 0, 0, 4130018, 1, 3),
  (8, 1040094, 45, 1, 41000, 0, 0, 4130019, 1, 1),
  (8, 1040095, 45, 1, 41000, 0, 0, 4130019, 1, 1),
  (8, 1040096, 45, 1, 41000, 0, 0, 4130019, 1, 1),
  (8, 1040097, 45, 1, 41000, 0, 0, 4130019, 1, 1),
  (8, 1041077, 45, 1, 41000, 0, 0, 4130019, 1, 1),
  (8, 1041078, 45, 1, 41000, 0, 0, 4130019, 1, 1),
  (8, 1041079, 45, 1, 41000, 0, 0, 4130019, 1, 1),
  (8, 1041080, 45, 1, 41000, 0, 0, 4130019, 1, 1),
  (8, 1040098, 55, 1, 50000, 0, 0, 4130019, 1, 1),
  (8, 1040099, 55, 1, 50000, 0, 0, 4130019, 1, 1),
  (8, 1040100, 55, 1, 50000, 0, 0, 4130019, 1, 1),
  (8, 1041094, 55, 1, 50000, 0, 0, 4130019, 1, 1),
  (8, 1041095, 55, 1, 50000, 0, 0, 4130019, 1, 1),
  (8, 1041096, 55, 1, 50000, 0, 0, 4130019, 1, 1),
  (8, 1040105, 65, 1, 55000, 0, 0, 4130019, 1, 1),
  (8, 1040106, 65, 1, 55000, 0, 0, 4130019, 1, 1),
  (8, 1040107, 65, 1, 55000, 0, 0, 4130019, 1, 1),
  (8, 1041100, 65, 1, 55000, 0, 0, 4130019, 1, 1),
  (8, 1041101, 65, 1, 55000, 0, 0, 4130019, 1, 1),
  (8, 1041102, 65, 1, 55000, 0, 0, 4130019, 1, 1),
  (8, 1041103, 65, 1, 55000, 0, 0, 4130019, 1, 1),
  (8, 1040108, 75, 2, 107000, 0, 0, 4130019, 1, 2),
  (8, 1040109, 75, 2, 107000, 0, 0, 4130019, 1, 2),
  (8, 1040110, 75, 2, 107000, 0, 0, 4130019, 1, 2),
  (8, 1041105, 75, 2, 107000, 0, 0, 4130019, 1, 2),
  (8, 1041106, 75, 2, 107000, 0, 0, 4130019, 1, 2),
  (8, 1041107, 75, 2, 107000, 0, 0, 4130019, 1, 2),
  (8, 1040115, 85, 2, 138000, 0, 0, 4130019, 1, 2),
  (8, 1040116, 85, 2, 138000, 0, 0, 4130019, 1, 2),
  (8, 1040117, 85, 2, 138000, 0, 0, 4130019, 1, 2),
  (8, 1040118, 85, 2, 138000, 0, 0, 4130019, 1, 2),
  (8, 1041115, 85, 2, 138000, 0, 0, 4130019, 1, 2),
  (8, 1041116, 85, 2, 138000, 0, 0, 4130019, 1, 2),
  (8, 1041117, 85, 2, 138000, 0, 0, 4130019, 1, 2),
  (8, 1041118, 85, 2, 138000, 0, 0, 4130019, 1, 2),
  (8, 1060083, 45, 1, 33000, 0, 0, 4130020, 1, 1),
  (8, 1060084, 45, 1, 33000, 0, 0, 4130020, 1, 1),
  (8, 1060085, 45, 1, 33000, 0, 0, 4130020, 1, 1),
  (8, 1060086, 45, 1, 33000, 0, 0, 4130020, 1, 1),
  (8, 1061076, 45, 1, 33000, 0, 0, 4130020, 1, 1),
  (8, 1061077, 45, 1, 33000, 0, 0, 4130020, 1, 1),
  (8, 1061078, 45, 1, 33000, 0, 0, 4130020, 1, 1),
  (8, 1061079, 45, 1, 33000, 0, 0, 4130020, 1, 1),
  (8, 1060087, 55, 1, 41000, 0, 0, 4130020, 1, 1),
  (8, 1060088, 55, 1, 41000, 0, 0, 4130020, 1, 1),
  (8, 1060089, 55, 1, 41000, 0, 0, 4130020, 1, 1),
  (8, 1061093, 55, 1, 41000, 0, 0, 4130020, 1, 1),
  (8, 1061094, 55, 1, 41000, 0, 0, 4130020, 1, 1),
  (8, 1061095, 55, 1, 41000, 0, 0, 4130020, 1, 1),
  (8, 1060093, 65, 1, 50000, 0, 0, 4130020, 1, 1),
  (8, 1060094, 65, 1, 50000, 0, 0, 4130020, 1, 1),
  (8, 1060095, 65, 1, 50000, 0, 0, 4130020, 1, 1),
  (8, 1061099, 65, 1, 50000, 0, 0, 4130020, 1, 1),
  (8, 1061100, 65, 1, 50000, 0, 0, 4130020, 1, 1),
  (8, 1061101, 65, 1, 50000, 0, 0, 4130020, 1, 1),
  (8, 1061102, 65, 1, 50000, 0, 0, 4130020, 1, 1),
  (8, 1060097, 75, 2, 92000, 0, 0, 4130020, 1, 2),
  (8, 1060098, 75, 2, 92000, 0, 0, 4130020, 1, 2),
  (8, 1060099, 75, 2, 92000, 0, 0, 4130020, 1, 2),
  (8, 1061104, 75, 2, 92000, 0, 0, 4130020, 1, 2),
  (8, 1061105, 75, 2, 92000, 0, 0, 4130020, 1, 2),
  (8, 1061106, 75, 2, 92000, 0, 0, 4130020, 1, 2),
  (8, 1060104, 85, 2, 123000, 0, 0, 4130020, 1, 2),
  (8, 1060105, 85, 2, 123000, 0, 0, 4130020, 1, 2),
  (8, 1060106, 85, 2, 123000, 0, 0, 4130020, 1, 2),
  (8, 1060107, 85, 2, 123000, 0, 0, 4130020, 1, 2),
  (8, 1061114, 85, 2, 123000, 0, 0, 4130020, 1, 2),
  (8, 1061115, 85, 2, 123000, 0, 0, 4130020, 1, 2),
  (8, 1061116, 85, 2, 123000, 0, 0, 4130020, 1, 2),
  (8, 1061117, 85, 2, 123000, 0, 0, 4130020, 1, 2),
  (8, 1050096, 95, 2, 184000, 0, 0, 4130021, 1, 2),
  (8, 1050097, 95, 2, 184000, 0, 0, 4130021, 1, 2),
  (8, 1050098, 95, 2, 184000, 0, 0, 4130021, 1, 2),
  (8, 1050099, 95, 2, 184000, 0, 0, 4130021, 1, 2),
  (8, 1051090, 95, 2, 184000, 0, 0, 4130021, 1, 2),
  (8, 1051091, 95, 2, 184000, 0, 0, 4130021, 1, 2),
  (8, 1051092, 95, 2, 184000, 0, 0, 4130021, 1, 2),
  (8, 1051093, 95, 2, 184000, 0, 0, 4130021, 1, 2),
  (8, 1052072, 105, 3, 330000, 0, 0, 4130021, 1, 3),
  (8, 1052163, 115, 3, 396000, 0, 0, 4130021, 1, 3),
  (8, 1052158, 115, 3, 396000, 0, 0, 4130021, 1, 3),
  (8, 1072128, 45, 1, 28000, 0, 0, 4130001, 1, 1),
  (8, 1072129, 45, 1, 28000, 0, 0, 4130001, 1, 1),
  (8, 1072130, 45, 1, 28000, 0, 0, 4130001, 1, 1),
  (8, 1072131, 45, 1, 28000, 0, 0, 4130001, 1, 1),
  (8, 1072150, 55, 1, 36000, 0, 0, 4130001, 1, 1),
  (8, 1072151, 55, 1, 36000, 0, 0, 4130001, 1, 1),
  (8, 1072152, 55, 1, 39000, 0, 0, 4130001, 1, 1),
  (8, 1072161, 65, 1, 50000, 0, 0, 4130001, 1, 1),
  (8, 1072162, 65, 1, 50000, 0, 0, 4130001, 1, 1),
  (8, 1072163, 65, 1, 50000, 0, 0, 4130001, 1, 1),
  (8, 1072172, 75, 2, 84000, 0, 0, 4130001, 1, 2),
  (8, 1072173, 75, 2, 84000, 0, 0, 4130001, 1, 2),
  (8, 1072174, 75, 2, 84000, 0, 0, 4130001, 1, 2),
  (8, 1072192, 85, 2, 107000, 0, 0, 4130001, 1, 2),
  (8, 1072193, 85, 2, 107000, 0, 0, 4130001, 1, 2),
  (8, 1072194, 85, 2, 107000, 0, 0, 4130001, 1, 2),
  (8, 1072195, 85, 2, 107000, 0, 0, 4130001, 1, 2),
  (8, 1072213, 95, 2, 130000, 0, 0, 4130001, 1, 2),
  (8, 1072214, 95, 2, 130000, 0, 0, 4130001, 1, 2),
  (8, 1072215, 95, 2, 130000, 0, 0, 4130001, 1, 2),
  (8, 1072216, 95, 2, 130000, 0, 0, 4130001, 1, 2),
  (8, 1072272, 105, 3, 215000, 0, 0, 4130001, 1, 3),
  (8, 1072364, 115, 3, 248000, 0, 0, 4130001, 1, 3),
  (8, 1072358, 115, 3, 248000, 0, 0, 4130001, 1, 3),
  (8, 1082065, 45, 1, 47000, 0, 0, 4130000, 1, 1),
  (8, 1082066, 45, 1, 52000, 0, 0, 4130000, 1, 1),
  (8, 1082067, 45, 1, 50000, 0, 0, 4130000, 1, 1),
  (8, 1082092, 55, 1, 60000, 0, 0, 4130000, 1, 1),
  (8, 1082093, 55, 1, 66000, 0, 0, 4130000, 1, 1),
  (8, 1082094, 55, 1, 71000, 0, 0, 4130000, 1, 1),
  (8, 1082095, 65, 1, 82000, 0, 0, 4130000, 1, 1),
  (8, 1082096, 65, 1, 88000, 0, 0, 4130000, 1, 1),
  (8, 1082097, 65, 1, 93000, 0, 0, 4130000, 1, 1),
  (8, 1082118, 75, 2, 153000, 0, 0, 4130000, 1, 2),
  (8, 1082119, 75, 2, 157000, 0, 0, 4130000, 1, 2),
  (8, 1082120, 75, 2, 161000, 0, 0, 4130000, 1, 2),
  (8, 1082142, 85, 2, 165000, 0, 0, 4130000, 1, 2),
  (8, 1082143, 85, 2, 165000, 0, 0, 4130000, 1, 2),
  (8, 1082144, 85, 2, 165000, 0, 0, 4130000, 1, 2),
  (8, 1082135, 95, 2, 199000, 0, 0, 4130000, 1, 2),
  (8, 1082136, 95, 2, 203000, 0, 0, 4130000, 1, 2),
  (8, 1082137, 95, 2, 203000, 0, 0, 4130000, 1, 2),
  (8, 1082138, 95, 2, 207000, 0, 0, 4130000, 1, 2),
  (8, 1082167, 105, 3, 330000, 0, 0, 4130000, 1, 3),
  (8, 1082242, 115, 3, 363000, 0, 0, 4130000, 1, 3),
  (8, 1082237, 115, 3, 363000, 0, 0, 4130000, 1, 3),
  (8, 1092059, 115, 3, 385000, 0, 0, 4130022, 1, 3),
  (8, 1332003, 45, 1, 121000, 0, 0, 4130014, 1, 1),
  (8, 1472018, 45, 1, 55000, 0, 0, 4130015, 1, 1),
  (8, 1472019, 45, 1, 57000, 0, 0, 4130015, 1, 1),
  (8, 1472020, 45, 1, 57000, 0, 0, 4130015, 1, 1),
  (8, 1472021, 45, 1, 60000, 0, 0, 4130015, 1, 1),
  (8, 1332016, 45, 1, 121000, 0, 0, 4130014, 1, 1),
  (8, 1332015, 55, 1, 137000, 0, 0, 4130014, 1, 1),
  (8, 1472022, 55, 1, 137000, 0, 0, 4130015, 1, 1),
  (8, 1472023, 55, 1, 140000, 0, 0, 4130015, 1, 1),
  (8, 1472024, 55, 1, 140000, 0, 0, 4130015, 1, 1),
  (8, 1472025, 55, 1, 143000, 0, 0, 4130015, 1, 1),
  (8, 1332017, 55, 1, 137000, 0, 0, 4130014, 1, 1),
  (8, 1332018, 65, 1, 154000, 0, 0, 4130014, 1, 1),
  (8, 1472026, 65, 1, 165000, 0, 0, 4130015, 1, 1),
  (8, 1472027, 65, 1, 167000, 0, 0, 4130015, 1, 1),
  (8, 1472028, 65, 1, 167000, 0, 0, 4130015, 1, 1),
  (8, 1472029, 65, 1, 170000, 0, 0, 4130015, 1, 1),
  (8, 1332019, 65, 1, 154000, 0, 0, 4130014, 1, 1),
  (8, 1472031, 75, 2, 308000, 0, 0, 4130015, 1, 2),
  (8, 1332022, 75, 2, 238000, 0, 0, 4130014, 1, 2),
  (8, 1332023, 75, 2, 238000, 0, 0, 4130014, 1, 2),
  (8, 1332027, 85, 2, 261000, 0, 0, 4130014, 1, 2),
  (8, 1472033, 85, 2, 346000, 0, 0, 4130015, 1, 2),
  (8, 1332026, 85, 2, 261000, 0, 0, 4130014, 1, 2),
  (8, 1332052, 95, 2, 308000, 0, 0, 4130014, 1, 2),
  (8, 1472053, 95, 2, 392000, 0, 0, 4130015, 1, 2),
  (8, 1332051, 95, 2, 308000, 0, 0, 4130014, 1, 2),
  (8, 1332050, 105, 3, 495000, 0, 0, 4130014, 1, 3),
  (8, 1472051, 105, 3, 627000, 0, 0, 4130015, 1, 3),
  (8, 1472052, 105, 3, 627000, 0, 0, 4130015, 1, 3),
  (8, 1332049, 105, 3, 495000, 0, 0, 4130014, 1, 3),
  (8, 1332075, 115, 3, 550000, 0, 0, 4130014, 1, 3),
  (8, 1332076, 115, 3, 550000, 0, 0, 4130014, 1, 3),
  (8, 1472071, 115, 3, 693000, 0, 0, 4130015, 1, 3),
  (8, 1332073, 115, 3, 550000, 0, 0, 4130014, 1, 3),
  (8, 1332074, 115, 3, 561000, 0, 0, 4130014, 1, 3),
  (8, 1472068, 115, 3, 693000, 0, 0, 4130015, 1, 3),
  (16, 1002631, 45, 1, 22000, 0, 0, 4130018, 1, 1),
  (16, 1002634, 55, 1, 30000, 0, 0, 4130018, 1, 1),
  (16, 1002637, 65, 1, 47000, 0, 0, 4130018, 1, 1),
  (16, 1002640, 75, 2, 77000, 0, 0, 4130018, 1, 2),
  (16, 1002643, 85, 2, 88000, 0, 0, 4130018, 1, 2),
  (16, 1002646, 95, 2, 100000, 0, 0, 4130018, 1, 2),
  (16, 1002649, 105, 3, 165000, 0, 0, 4130018, 1, 3),
  (16, 1002794, 115, 3, 187000, 0, 0, 4130018, 1, 3),
  (16, 1002780, 115, 3, 187000, 0, 0, 4130018, 1, 3),
  (16, 1052116, 45, 1, 52000, 0, 0, 4130021, 1, 1),
  (16, 1052119, 55, 1, 55000, 0, 0, 4130021, 1, 1),
  (16, 1052122, 65, 1, 63000, 0, 0, 4130021, 1, 1),
  (16, 1052125, 75, 2, 138000, 0, 0, 4130021, 1, 2),
  (16, 1052128, 85, 2, 153000, 0, 0, 4130021, 1, 2),
  (16, 1052131, 95, 2, 184000, 0, 0, 4130021, 1, 2),
  (16, 1052134, 105, 3, 330000, 0, 0, 4130021, 1, 3),
  (16, 1052164, 115, 3, 396000, 0, 0, 4130021, 1, 3),
  (16, 1052159, 115, 3, 396000, 0, 0, 4130021, 1, 3),
  (16, 1072303, 45, 1, 28000, 0, 0, 4130001, 1, 1),
  (16, 1072306, 55, 1, 36000, 0, 0, 4130001, 1, 1),
  (16, 1072309, 65, 1, 50000, 0, 0, 4130001, 1, 1),
  (16, 1072312, 75, 2, 84000, 0, 0, 4130001, 1, 2),
  (16, 1072315, 85, 2, 107000, 0, 0, 4130001, 1, 2),
  (16, 1072318, 95, 2, 130000, 0, 0, 4130001, 1, 2),
  (16, 1072321, 105, 3, 198000, 0, 0, 4130001, 1, 3),
  (16, 1072365, 115, 3, 220000, 0, 0, 4130001, 1, 3),
  (16, 1072359, 115, 3, 220000, 0, 0, 4130001, 1, 3),
  (16, 1082198, 45, 1, 47000, 0, 0, 4130000, 1, 1),
  (16, 1082201, 55, 1, 60000, 0, 0, 4130000, 1, 1),
  (16, 1082204, 65, 1, 82000, 0, 0, 4130000, 1, 1),
  (16, 1082207, 75, 2, 153000, 0, 0, 4130000, 1, 2),
  (16, 1082210, 85, 2, 176000, 0, 0, 4130000, 1, 2),
  (16, 1082213, 95, 2, 203000, 0, 0, 4130000, 1, 2),
  (16, 1082216, 105, 3, 330000, 0, 0, 4130000, 1, 3),
  (16, 1082243, 115, 3, 369000, 0, 0, 4130000, 1, 3),
  (16, 1082238, 115, 3, 369000, 0, 0, 4130000, 1, 3),
  (16, 1482007, 45, 1, 71000, 0, 0, 4130016, 1, 1),
  (16, 1492007, 45, 1, 77000, 0, 0, 4130017, 1, 1),
  (16, 1482008, 55, 1, 132000, 0, 0, 4130016, 1, 1),
  (16, 1492008, 55, 1, 137000, 0, 0, 4130017, 1, 1),
  (16, 1482009, 65, 1, 165000, 0, 0, 4130016, 1, 1),
  (16, 1492009, 65, 1, 170000, 0, 0, 4130017, 1, 1),
  (16, 1482010, 75, 2, 269000, 0, 0, 4130016, 1, 2),
  (16, 1492010, 75, 2, 269000, 0, 0, 4130017, 1, 2),
  (16, 1482011, 85, 2, 300000, 0, 0, 4130016, 1, 2),
  (16, 1492011, 85, 2, 308000, 0, 0, 4130017, 1, 2),
  (16, 1482012, 95, 2, 338000, 0, 0, 4130016, 1, 2),
  (16, 1492012, 95, 2, 346000, 0, 0, 4130017, 1, 2),
  (16, 1482013, 105, 3, 561000, 0, 0, 4130016, 1, 3),
  (16, 1492013, 105, 3, 572000, 0, 0, 4130017, 1, 3),
  (16, 1482024, 115, 3, 616000, 0, 0, 4130016, 1, 3),
  (16, 1492025, 115, 3, 627000, 0, 0, 4130017, 1, 3),
  (16, 1482023, 115, 3, 616000, 0, 0, 4130016, 1, 3),
  (16, 1492023, 115, 3, 627000, 0, 0, 4130017, 1, 3);

INSERT IGNORE INTO `makerrecipedata` (`itemid`, `req_item`, `count`) VALUES
  (4250000, 4021007, 1),
  (4250100, 4021005, 1),
  (4250200, 4021000, 1),
  (4250300, 4021004, 1),
  (4250400, 4021001, 1),
  (4250500, 4021002, 1),
  (4250600, 4021006, 1),
  (4250700, 4021003, 1),
  (4250800, 4005000, 1),
  (4250900, 4005001, 1),
  (4251000, 4005003, 1),
  (4251100, 4005002, 1),
  (4251300, 4021008, 1),
  (4251400, 4005004, 1),
  (4250001, 4250000, 10),
  (4250101, 4250100, 10),
  (4250201, 4250200, 10),
  (4250301, 4250300, 10),
  (4250401, 4250400, 10),
  (4250501, 4250500, 10),
  (4250601, 4250600, 10),
  (4250701, 4250700, 10),
  (4250801, 4250800, 10),
  (4250901, 4250900, 10),
  (4251001, 4251000, 10),
  (4251101, 4251100, 10),
  (4251301, 4251300, 10),
  (4251401, 4251400, 10),
  (4250002, 4250001, 10),
  (4250102, 4250101, 10),
  (4250202, 4250201, 10),
  (4250302, 4250301, 10),
  (4250402, 4250401, 10),
  (4250502, 4250501, 10),
  (4250602, 4250601, 10),
  (4250702, 4250701, 10),
  (4250802, 4250801, 10),
  (4250902, 4250901, 10),
  (4251002, 4251001, 10),
  (4251102, 4251101, 10),
  (4251302, 4251301, 10),
  (4251402, 4251401, 10),
  (4001174, 4031966, 1),
  (4001174, 4000155, 10),
  (4001174, 4000278, 5),
  (4001174, 4000277, 5),
  (4001175, 4031967, 1),
  (4001175, 4000048, 20),
  (4001175, 4000030, 3),
  (4001176, 4031968, 1),
  (4001176, 4000360, 30),
  (4001176, 4003001, 20),
  (4001176, 4011001, 5),
  (4001177, 4031969, 1),
  (4001177, 4007001, 10),
  (4001177, 4000052, 100),
  (4001178, 4031970, 1),
  (4001178, 4007002, 1),
  (4001178, 4000295, 25),
  (4001178, 4000286, 25),
  (4001179, 4031971, 1),
  (4001179, 4000364, 70),
  (4001179, 4000122, 7),
  (4001179, 4003000, 7),
  (4001180, 4031972, 1),
  (4001180, 4007000, 1),
  (4001180, 4000229, 30),
  (4001180, 4000074, 10),
  (4001181, 4031973, 1),
  (4001181, 4007006, 1),
  (4001181, 4000238, 30),
  (4001181, 4003005, 20),
  (4001182, 4031974, 1),
  (4001182, 4007001, 6),
  (4001182, 4000239, 12),
  (4001182, 4000240, 1),
  (4001182, 4003004, 36),
  (4001183, 4031975, 1),
  (4001183, 4007001, 3),
  (4001183, 4000285, 30),
  (4001183, 4000232, 30),
  (4001184, 4031976, 1),
  (4001184, 4000182, 30),
  (4001184, 4011001, 10),
  (4001184, 4003001, 10),
  (4001185, 4031977, 1),
  (4001185, 4000134, 30),
  (4001185, 4000081, 5),
  (4001185, 4003005, 20),
  (4031980, 4031979, 1),
  (4031980, 4011006, 6),
  (4031980, 4011001, 2),
  (4031980, 4011008, 1),
  (4001186, 4031978, 1),
  (4001186, 4003005, 30),
  (4001186, 4005001, 1),
  (4001186, 4021007, 10),
  (4001186, 4021009, 1),
  (4032334, 4032335, 1),
  (4032334, 4000268, 500),
  (4032334, 4000181, 500),
  (4032334, 4000274, 500),
  (4032312, 4005004, 1),
  (4032312, 4020007, 3),
  (4032312, 4020000, 3),
  (2041058, 4000048, 100),
  (2041058, 4000299, 10),
  (2040727, 4000159, 50),
  (2040727, 4000299, 10),
  (4260007, 4260006, 100),
  (4260007, 4001126, 5),
  (4260008, 4260007, 50),
  (4260008, 4001126, 5),
  (1002028, 4007001, 5),
  (1002028, 4260000, 5),
  (1002085, 4007002, 5),
  (1002085, 4260000, 5),
  (1002086, 4007000, 5),
  (1002086, 4260000, 5),
  (1002022, 4007001, 5),
  (1002022, 4260000, 5),
  (1002100, 4007000, 5),
  (1002100, 4260000, 5),
  (1002101, 4007003, 5),
  (1002101, 4260000, 5),
  (1002029, 4007006, 6),
  (1002029, 4260001, 6),
  (1002084, 4007002, 6),
  (1002084, 4260001, 6),
  (1002030, 4007001, 7),
  (1002030, 4260002, 7),
  (1002094, 4007000, 7),
  (1002094, 4260002, 7),
  (1002095, 4007002, 7),
  (1002095, 4260002, 7),
  (1002338, 4007006, 8),
  (1002338, 4260003, 8),
  (1002339, 4007002, 8),
  (1002339, 4260003, 8),
  (1002340, 4007007, 8),
  (1002340, 4260003, 8),
  (1002528, 4007003, 9),
  (1002528, 4260004, 9),
  (1002529, 4007002, 9),
  (1002529, 4260004, 9),
  (1002530, 4007006, 9),
  (1002530, 4260004, 9),
  (1002531, 4007001, 9),
  (1002531, 4260004, 9),
  (1002532, 4007007, 9),
  (1002532, 4260004, 9),
  (1002377, 4007003, 10),
  (1002377, 4260005, 10),
  (1002378, 4007002, 10),
  (1002378, 4260005, 10),
  (1002379, 4007007, 10),
  (1002379, 4260005, 10),
  (1002551, 4007002, 11),
  (1002551, 4260006, 11),
  (1002551, 4000244, 5),
  (1002551, 4000245, 5),
  (1002790, 4007001, 12),
  (1002790, 4260007, 8),
  (1002790, 4260008, 4),
  (1002790, 4020009, 15),
  (1002776, 4007001, 12),
  (1002776, 4260007, 2),
  (1002776, 4260008, 10),
  (1002776, 4021010, 1),
  (1040087, 4007002, 5),
  (1040087, 4260000, 5),
  (1040088, 4007004, 5),
  (1040088, 4260000, 5),
  (1040089, 4007007, 5),
  (1040089, 4260000, 5),
  (1041087, 4007006, 5),
  (1041087, 4260000, 5),
  (1041088, 4007001, 5),
  (1041088, 4260000, 5),
  (1041089, 4007007, 5),
  (1041089, 4260000, 5),
  (1040090, 4007003, 6),
  (1040090, 4260001, 6),
  (1040091, 4007006, 6),
  (1040091, 4260001, 6),
  (1040092, 4007002, 6),
  (1040092, 4260001, 6),
  (1040093, 4007007, 6),
  (1040093, 4260001, 6),
  (1041091, 4007003, 6),
  (1041091, 4260001, 6),
  (1041092, 4007006, 6),
  (1041092, 4260001, 6),
  (1041093, 4007002, 6),
  (1041093, 4260001, 6),
  (1040102, 4007000, 7),
  (1040102, 4260002, 7),
  (1040103, 4007002, 7),
  (1040103, 4260002, 7),
  (1040104, 4007005, 7),
  (1040104, 4260002, 7),
  (1041097, 4007002, 7),
  (1041097, 4260002, 7),
  (1041098, 4007005, 7),
  (1041098, 4260002, 7),
  (1041099, 4007006, 7),
  (1041099, 4260002, 7),
  (1040111, 4007003, 9),
  (1040111, 4260004, 9),
  (1040112, 4007002, 9),
  (1040112, 4260004, 9),
  (1040113, 4007007, 9),
  (1040113, 4260004, 9),
  (1041119, 4007003, 9),
  (1041119, 4260004, 9),
  (1041120, 4007005, 9),
  (1041120, 4260004, 9),
  (1041121, 4007007, 9),
  (1041121, 4260004, 9),
  (1040120, 4007003, 10),
  (1040120, 4260005, 10),
  (1040121, 4007002, 10),
  (1040121, 4260005, 10),
  (1040122, 4007007, 10),
  (1040122, 4260005, 10),
  (1041122, 4007003, 10),
  (1041122, 4260005, 10),
  (1041123, 4007005, 10),
  (1041123, 4260005, 10),
  (1041124, 4007007, 10),
  (1041124, 4260005, 10),
  (1060076, 4007002, 5),
  (1060076, 4260000, 5),
  (1060077, 4007004, 5),
  (1060077, 4260000, 5),
  (1060078, 4007007, 5),
  (1060078, 4260000, 5),
  (1061086, 4007006, 5),
  (1061086, 4260000, 5),
  (1061087, 4007001, 5),
  (1061087, 4260000, 5),
  (1061088, 4007007, 5),
  (1061088, 4260000, 5),
  (1060079, 4007003, 6),
  (1060079, 4260001, 6),
  (1060080, 4007006, 6),
  (1060080, 4260001, 6),
  (1060081, 4007002, 6),
  (1060081, 4260001, 6),
  (1060082, 4007007, 6),
  (1060082, 4260001, 6),
  (1061090, 4007003, 6),
  (1061090, 4260001, 6),
  (1061091, 4007006, 6),
  (1061091, 4260001, 6),
  (1061092, 4007002, 6),
  (1061092, 4260001, 6),
  (1060090, 4007000, 7),
  (1060090, 4260002, 7),
  (1060091, 4007002, 7),
  (1060091, 4260002, 7),
  (1060092, 4007005, 7),
  (1060092, 4260002, 7),
  (1061096, 4007002, 7),
  (1061096, 4260002, 7),
  (1061097, 4007005, 7),
  (1061097, 4260002, 7),
  (1061098, 4007006, 7),
  (1061098, 4260002, 7),
  (1060100, 4007003, 9),
  (1060100, 4260004, 9),
  (1060101, 4007002, 9),
  (1060101, 4260004, 9),
  (1060102, 4007007, 9),
  (1060102, 4260004, 9),
  (1061118, 4007003, 9),
  (1061118, 4260004, 9),
  (1061119, 4007005, 9),
  (1061119, 4260004, 9),
  (1061120, 4007006, 9),
  (1061120, 4260004, 9),
  (1060109, 4007003, 10),
  (1060109, 4260005, 10),
  (1060110, 4007002, 10),
  (1060110, 4260005, 10),
  (1060111, 4007007, 10),
  (1060111, 4260005, 10),
  (1061121, 4007003, 10),
  (1061121, 4260005, 10),
  (1061122, 4007005, 10),
  (1061122, 4260005, 10),
  (1061123, 4007007, 10),
  (1061123, 4260005, 10),
  (1050080, 4007003, 8),
  (1050080, 4260003, 16),
  (1050081, 4007006, 8),
  (1050081, 4260003, 16),
  (1050082, 4007002, 8),
  (1050082, 4260003, 16),
  (1050083, 4007007, 8),
  (1050083, 4260003, 16),
  (1051077, 4007004, 8),
  (1051077, 4260003, 16),
  (1051078, 4007006, 8),
  (1051078, 4260003, 16),
  (1051079, 4007002, 8),
  (1051079, 4260003, 16),
  (1051080, 4007007, 8),
  (1051080, 4260003, 16),
  (1052075, 4007002, 11),
  (1052075, 4260006, 22),
  (1052075, 4000244, 5),
  (1052075, 4000245, 5),
  (1052160, 4007005, 12),
  (1052160, 4260007, 16),
  (1052160, 4260008, 8),
  (1052160, 4020009, 15),
  (1052155, 4007005, 12),
  (1052155, 4260007, 4),
  (1052155, 4260008, 20),
  (1052155, 4021010, 1),
  (1072132, 4007003, 5),
  (1072132, 4260000, 5),
  (1072133, 4007002, 5),
  (1072133, 4260000, 5),
  (1072134, 4007005, 5),
  (1072134, 4260000, 5),
  (1072135, 4007004, 5),
  (1072135, 4260000, 5),
  (1072147, 4007002, 6),
  (1072147, 4260001, 6),
  (1072148, 4007005, 6),
  (1072148, 4260001, 6),
  (1072149, 4007006, 6),
  (1072149, 4260001, 6),
  (1072154, 4007002, 7),
  (1072154, 4260002, 7),
  (1072155, 4007005, 7),
  (1072155, 4260002, 7),
  (1072156, 4007007, 7),
  (1072156, 4260002, 7),
  (1072210, 4007006, 8),
  (1072210, 4260003, 8),
  (1072211, 4007002, 8),
  (1072211, 4260003, 8),
  (1072212, 4007007, 8),
  (1072212, 4260003, 8),
  (1072196, 4007003, 9),
  (1072196, 4260004, 9),
  (1072197, 4007005, 9),
  (1072197, 4260004, 9),
  (1072198, 4007007, 9),
  (1072198, 4260004, 9),
  (1072220, 4007003, 10),
  (1072220, 4260005, 10),
  (1072221, 4007002, 10),
  (1072221, 4260005, 10),
  (1072222, 4007007, 10),
  (1072222, 4260005, 10),
  (1072273, 4007002, 11),
  (1072273, 4260006, 11),
  (1072273, 4000244, 5),
  (1072273, 4000245, 5),
  (1072361, 4007007, 12),
  (1072361, 4260007, 8),
  (1072361, 4260008, 4),
  (1072361, 4020009, 15),
  (1072355, 4007007, 12),
  (1072355, 4260007, 2),
  (1072355, 4260008, 10),
  (1072355, 4021010, 1),
  (1082009, 4007001, 5),
  (1082009, 4260000, 5),
  (1082010, 4007007, 5),
  (1082010, 4260000, 5),
  (1082011, 4007004, 5),
  (1082011, 4260000, 5),
  (1082059, 4007000, 6),
  (1082059, 4260001, 6),
  (1082060, 4007002, 6),
  (1082060, 4260001, 6),
  (1082061, 4007007, 6),
  (1082061, 4260001, 6),
  (1082103, 4007000, 7),
  (1082103, 4260002, 7),
  (1082104, 4007002, 7),
  (1082104, 4260002, 7),
  (1082105, 4007007, 7),
  (1082105, 4260002, 7),
  (1082114, 4007002, 8),
  (1082114, 4260003, 8),
  (1082115, 4007003, 8),
  (1082115, 4260003, 8),
  (1082116, 4007006, 8),
  (1082116, 4260003, 8),
  (1082117, 4007007, 8),
  (1082117, 4260003, 8),
  (1082128, 4007003, 9),
  (1082128, 4260004, 9),
  (1082129, 4007005, 9),
  (1082129, 4260004, 9),
  (1082130, 4007007, 9),
  (1082130, 4260004, 9),
  (1082139, 4007003, 10),
  (1082139, 4260005, 10),
  (1082140, 4007002, 10),
  (1082140, 4260005, 10),
  (1082141, 4007007, 10),
  (1082141, 4260005, 10),
  (1082168, 4007002, 11),
  (1082168, 4260006, 11),
  (1082168, 4000244, 5),
  (1082168, 4000245, 5),
  (1082239, 4007007, 12),
  (1082239, 4260007, 8),
  (1082239, 4260008, 4),
  (1082239, 4020009, 15),
  (1082234, 4007007, 12),
  (1082234, 4260007, 2),
  (1082234, 4260008, 10),
  (1082234, 4021010, 1),
  (1092004, 4007001, 5),
  (1092004, 4260000, 5),
  (1092009, 4007000, 6),
  (1092009, 4260001, 6),
  (1092010, 4007001, 6),
  (1092010, 4260001, 6),
  (1092011, 4007004, 6),
  (1092011, 4260001, 6),
  (1092015, 4007001, 7),
  (1092015, 4260002, 7),
  (1092016, 4007001, 7),
  (1092016, 4260002, 7),
  (1092017, 4007004, 7),
  (1092017, 4260002, 7),
  (1092023, 4007001, 8),
  (1092023, 4260003, 8),
  (1092024, 4007001, 8),
  (1092024, 4260003, 8),
  (1092025, 4007004, 8),
  (1092025, 4260003, 8),
  (1092026, 4007000, 9),
  (1092026, 4260004, 9),
  (1092027, 4007001, 9),
  (1092027, 4260004, 9),
  (1092028, 4007004, 9),
  (1092028, 4260004, 9),
  (1092036, 4007003, 10),
  (1092036, 4260005, 10),
  (1092037, 4007005, 10),
  (1092037, 4260005, 10),
  (1092038, 4007002, 10),
  (1092038, 4260005, 10),
  (1092060, 4007001, 11),
  (1092060, 4260006, 11),
  (1092060, 4000244, 5),
  (1092060, 4000245, 5),
  (1092058, 4007002, 12),
  (1092058, 4260007, 2),
  (1092058, 4260008, 10),
  (1092058, 4021010, 1),
  (1302010, 4011000, 1),
  (1302010, 4260000, 20),
  (1312008, 4011000, 1),
  (1312008, 4260000, 20),
  (1322017, 4011000, 1),
  (1322017, 4260000, 20),
  (1402003, 4011000, 1),
  (1402003, 4260000, 20),
  (1412003, 4011000, 1),
  (1412003, 4260000, 20),
  (1422005, 4011000, 1),
  (1422005, 4260000, 20),
  (1432004, 4011000, 1),
  (1432004, 4260000, 20),
  (1442005, 4011000, 1),
  (1442005, 4260000, 20),
  (1302011, 4011001, 2),
  (1302011, 4260001, 22),
  (1312009, 4011001, 2),
  (1312009, 4260001, 22),
  (1322018, 4011001, 2),
  (1322018, 4260001, 22),
  (1402011, 4011001, 2),
  (1402011, 4260001, 22),
  (1412007, 4011001, 2),
  (1412007, 4260001, 22),
  (1422009, 4011001, 2),
  (1422009, 4260001, 22),
  (1432006, 4011001, 2),
  (1432006, 4260001, 22),
  (1442010, 4011001, 2),
  (1442010, 4260001, 22),
  (1302012, 4011001, 3),
  (1302012, 4260002, 24),
  (1312010, 4011001, 3),
  (1312010, 4260002, 24),
  (1322019, 4011001, 3),
  (1322019, 4260002, 24),
  (1402012, 4011001, 3),
  (1402012, 4260002, 24),
  (1412008, 4011001, 3),
  (1412008, 4260002, 24),
  (1422010, 4011001, 3),
  (1422010, 4260002, 24),
  (1432007, 4011001, 3),
  (1432007, 4260002, 24),
  (1442008, 4011001, 3),
  (1442008, 4260002, 24),
  (1322020, 4011001, 3),
  (1322020, 4260002, 24),
  (1302018, 4011002, 3),
  (1302018, 4260003, 26),
  (1312011, 4011002, 3),
  (1312011, 4260003, 26),
  (1322028, 4011002, 3),
  (1322028, 4260003, 26),
  (1402004, 4011002, 3),
  (1402004, 4260003, 26),
  (1402015, 4011002, 3),
  (1402015, 4260003, 26),
  (1412009, 4011002, 3),
  (1412009, 4260003, 26),
  (1422012, 4011002, 3),
  (1422012, 4260003, 26),
  (1432010, 4011002, 3),
  (1432010, 4260003, 26),
  (1442019, 4011002, 3),
  (1442019, 4260003, 26),
  (1302023, 4011002, 4),
  (1302023, 4260004, 28),
  (1312015, 4011002, 4),
  (1312015, 4260004, 28),
  (1322029, 4011002, 4),
  (1322029, 4260004, 28),
  (1402005, 4011002, 4),
  (1402005, 4260004, 28),
  (1402016, 4011002, 4),
  (1402016, 4260004, 28),
  (1412010, 4011002, 4),
  (1412010, 4260004, 28),
  (1422013, 4011002, 4),
  (1422013, 4260004, 28),
  (1432011, 4011002, 4),
  (1432011, 4260004, 28),
  (1442020, 4011002, 4),
  (1442020, 4260004, 28),
  (1302056, 4011003, 4),
  (1302056, 4260005, 30),
  (1312030, 4011003, 4),
  (1312030, 4260005, 30),
  (1322045, 4011003, 4),
  (1322045, 4260005, 30),
  (1402035, 4011003, 4),
  (1402035, 4260005, 30),
  (1412021, 4011003, 4),
  (1412021, 4260005, 30),
  (1422027, 4011003, 4),
  (1422027, 4260005, 30),
  (1432030, 4011003, 4),
  (1432030, 4260005, 30),
  (1442044, 4011003, 4),
  (1442044, 4260005, 30),
  (1302059, 4011003, 5),
  (1302059, 4260006, 32),
  (1302059, 4000244, 20),
  (1302059, 4000245, 20),
  (1312031, 4011003, 5),
  (1312031, 4260006, 32),
  (1312031, 4000244, 20),
  (1312031, 4000245, 20),
  (1322052, 4011003, 5),
  (1322052, 4260006, 32),
  (1322052, 4000244, 20),
  (1322052, 4000245, 20),
  (1402036, 4011003, 5),
  (1402036, 4260006, 32),
  (1402036, 4000244, 20),
  (1402036, 4000245, 20),
  (1412026, 4011003, 5),
  (1412026, 4260006, 32),
  (1412026, 4000244, 20),
  (1412026, 4000245, 20),
  (1422028, 4011003, 5),
  (1422028, 4260006, 32),
  (1422028, 4000244, 20),
  (1422028, 4000245, 20),
  (1432038, 4011003, 5),
  (1432038, 4260006, 32),
  (1432038, 4000244, 20),
  (1432038, 4000245, 20),
  (1442045, 4011003, 5),
  (1442045, 4260006, 32),
  (1442045, 4000244, 20),
  (1442045, 4000245, 20),
  (1302086, 4011005, 5),
  (1302086, 4260007, 20),
  (1302086, 4260008, 14),
  (1302086, 4020009, 45),
  (1312038, 4011005, 5),
  (1312038, 4260007, 20),
  (1312038, 4260008, 14),
  (1312038, 4020009, 45),
  (1322061, 4011005, 5),
  (1322061, 4260007, 20),
  (1322061, 4260008, 14),
  (1322061, 4020009, 45),
  (1402047, 4011005, 5),
  (1402047, 4260007, 20),
  (1402047, 4260008, 14),
  (1402047, 4020009, 45),
  (1412034, 4011005, 5),
  (1412034, 4260007, 20),
  (1412034, 4260008, 14),
  (1412034, 4020009, 45),
  (1422038, 4011005, 5),
  (1422038, 4260007, 20),
  (1422038, 4260008, 14),
  (1422038, 4020009, 45),
  (1432049, 4011005, 5),
  (1432049, 4260007, 20),
  (1432049, 4260008, 14),
  (1432049, 4020009, 45),
  (1442067, 4011005, 5),
  (1442067, 4260007, 20),
  (1442067, 4260008, 14),
  (1442067, 4020009, 45),
  (1302081, 4011005, 5),
  (1302081, 4260007, 14),
  (1302081, 4260008, 20),
  (1302081, 4021010, 3),
  (1312037, 4011005, 5),
  (1312037, 4260007, 14),
  (1312037, 4260008, 20),
  (1312037, 4021010, 3),
  (1322060, 4011005, 5),
  (1322060, 4260007, 14),
  (1322060, 4260008, 20),
  (1322060, 4021010, 3),
  (1402046, 4011005, 5),
  (1402046, 4260007, 14),
  (1402046, 4260008, 20),
  (1402046, 4021010, 3),
  (1412033, 4011005, 5),
  (1412033, 4260007, 14),
  (1412033, 4260008, 20),
  (1412033, 4021010, 3),
  (1422037, 4011005, 5),
  (1422037, 4260007, 14),
  (1422037, 4260008, 20),
  (1422037, 4021010, 3),
  (1432047, 4011005, 5),
  (1432047, 4260007, 14),
  (1432047, 4260008, 20),
  (1432047, 4021010, 3),
  (1442063, 4011005, 5),
  (1442063, 4260007, 14),
  (1442063, 4260008, 20),
  (1442063, 4021010, 3),
  (1002215, 4007006, 5),
  (1002215, 4260000, 5),
  (1002216, 4007002, 5),
  (1002216, 4260000, 5),
  (1002217, 4007004, 5),
  (1002217, 4260000, 5),
  (1002218, 4007007, 5),
  (1002218, 4260000, 5),
  (1002242, 4007006, 6),
  (1002242, 4260001, 6),
  (1002243, 4007002, 6),
  (1002243, 4260001, 6),
  (1002244, 4007003, 6),
  (1002244, 4260001, 6),
  (1002245, 4007001, 6),
  (1002245, 4260001, 6),
  (1002246, 4007007, 6),
  (1002246, 4260001, 6),
  (1002252, 4007006, 7),
  (1002252, 4260002, 7),
  (1002253, 4007002, 7),
  (1002253, 4260002, 7),
  (1002254, 4007007, 7),
  (1002254, 4260002, 7),
  (1002271, 4007003, 8),
  (1002271, 4260003, 8),
  (1002272, 4007002, 8),
  (1002272, 4260003, 8),
  (1002273, 4007005, 8),
  (1002273, 4260003, 8),
  (1002274, 4007007, 8),
  (1002274, 4260003, 8),
  (1002363, 4007003, 9),
  (1002363, 4260004, 9),
  (1002364, 4007002, 9),
  (1002364, 4260004, 9),
  (1002365, 4007006, 9),
  (1002365, 4260004, 9),
  (1002366, 4007007, 9),
  (1002366, 4260004, 9),
  (1002398, 4007003, 10),
  (1002398, 4260005, 10),
  (1002399, 4007002, 10),
  (1002399, 4260005, 10),
  (1002400, 4007006, 10),
  (1002400, 4260005, 10),
  (1002401, 4007007, 10),
  (1002401, 4260005, 10),
  (1002773, 4007004, 11),
  (1002773, 4260006, 11),
  (1002773, 4000244, 5),
  (1002773, 4000245, 5),
  (1002791, 4007002, 12),
  (1002791, 4260007, 8),
  (1002791, 4260008, 4),
  (1002791, 4020009, 15),
  (1002777, 4007002, 12),
  (1002777, 4260007, 2),
  (1002777, 4260008, 10),
  (1002777, 4021010, 1),
  (1050045, 4007002, 5),
  (1050045, 4260000, 10),
  (1050046, 4007006, 5),
  (1050046, 4260000, 10),
  (1050047, 4007004, 5),
  (1050047, 4260000, 10),
  (1050048, 4007001, 5),
  (1050048, 4260000, 10),
  (1050049, 4007007, 5),
  (1050049, 4260000, 10),
  (1051030, 4007007, 5),
  (1051030, 4260000, 10),
  (1051031, 4007001, 5),
  (1051031, 4260000, 10),
  (1051032, 4007002, 5),
  (1051032, 4260000, 10),
  (1051033, 4007006, 5),
  (1051033, 4260000, 10),
  (1051034, 4007004, 5),
  (1051034, 4260000, 10),
  (1050053, 4007002, 6),
  (1050053, 4260001, 12),
  (1050054, 4007006, 6),
  (1050054, 4260001, 12),
  (1050055, 4007001, 6),
  (1050055, 4260001, 12),
  (1050056, 4007007, 6),
  (1050056, 4260001, 12),
  (1051044, 4007002, 6),
  (1051044, 4260001, 12),
  (1051045, 4007006, 6),
  (1051045, 4260001, 12),
  (1051046, 4007001, 6),
  (1051046, 4260001, 12),
  (1051047, 4007007, 6),
  (1051047, 4260001, 12),
  (1050067, 4007002, 7),
  (1050067, 4260002, 14),
  (1050068, 4007006, 7),
  (1050068, 4260002, 14),
  (1050069, 4007000, 7),
  (1050069, 4260002, 14),
  (1050070, 4007007, 7),
  (1050070, 4260002, 14),
  (1051052, 4007002, 7),
  (1051052, 4260002, 14),
  (1051053, 4007006, 7),
  (1051053, 4260002, 14),
  (1051054, 4007000, 7),
  (1051054, 4260002, 14),
  (1051055, 4007007, 7),
  (1051055, 4260002, 14),
  (1050072, 4007003, 8),
  (1050072, 4260003, 16),
  (1050073, 4007002, 8),
  (1050073, 4260003, 16),
  (1050074, 4007007, 8),
  (1050074, 4260003, 16),
  (1051056, 4007003, 8),
  (1051056, 4260003, 16),
  (1051057, 4007005, 8),
  (1051057, 4260003, 16),
  (1051058, 4007007, 8),
  (1051058, 4260003, 16),
  (1050092, 4007003, 9),
  (1050092, 4260004, 18),
  (1050093, 4007002, 9),
  (1050093, 4260004, 18),
  (1050094, 4007006, 9),
  (1050094, 4260004, 18),
  (1050095, 4007007, 9),
  (1050095, 4260004, 18),
  (1051094, 4007003, 9),
  (1051094, 4260004, 18),
  (1051095, 4007002, 9),
  (1051095, 4260004, 18),
  (1051096, 4007006, 9),
  (1051096, 4260004, 18),
  (1051097, 4007007, 9),
  (1051097, 4260004, 18),
  (1050102, 4007003, 10),
  (1050102, 4260005, 20),
  (1050103, 4007002, 10),
  (1050103, 4260005, 20),
  (1050104, 4007006, 10),
  (1050104, 4260005, 20),
  (1050105, 4007007, 10),
  (1050105, 4260005, 20),
  (1051101, 4007003, 10),
  (1051101, 4260005, 20),
  (1051102, 4007002, 10),
  (1051102, 4260005, 20),
  (1051103, 4007006, 10),
  (1051103, 4260005, 20),
  (1051104, 4007007, 10),
  (1051104, 4260005, 20),
  (1052076, 4007007, 11),
  (1052076, 4260006, 22),
  (1052076, 4000244, 5),
  (1052076, 4000245, 5),
  (1052161, 4007002, 12),
  (1052161, 4260007, 16),
  (1052161, 4260008, 8),
  (1052161, 4020009, 15),
  (1052156, 4007002, 12),
  (1052156, 4260007, 4),
  (1052156, 4260008, 20),
  (1052156, 4021010, 1),
  (1072140, 4007001, 2),
  (1072140, 4007006, 3),
  (1072140, 4260000, 5),
  (1072141, 4007002, 5),
  (1072141, 4260000, 5),
  (1072142, 4007005, 5),
  (1072142, 4260000, 5),
  (1072143, 4007003, 5),
  (1072143, 4260000, 5),
  (1072136, 4007001, 3),
  (1072136, 4007006, 3),
  (1072136, 4260001, 6),
  (1072137, 4007003, 6),
  (1072137, 4260001, 6),
  (1072138, 4007004, 6),
  (1072138, 4260001, 6),
  (1072139, 4007002, 6),
  (1072139, 4260001, 6),
  (1072157, 4007002, 7),
  (1072157, 4260002, 7),
  (1072158, 4007006, 7),
  (1072158, 4260002, 7),
  (1072159, 4007000, 7),
  (1072159, 4260002, 7),
  (1072160, 4007004, 7),
  (1072160, 4260002, 7),
  (1072177, 4007003, 8),
  (1072177, 4260003, 8),
  (1072178, 4007005, 8),
  (1072178, 4260003, 8),
  (1072179, 4007007, 8),
  (1072179, 4260003, 8),
  (1072206, 4007002, 9),
  (1072206, 4260004, 9),
  (1072207, 4007003, 9),
  (1072207, 4260004, 9),
  (1072208, 4007006, 9),
  (1072208, 4260004, 9),
  (1072209, 4007007, 9),
  (1072209, 4260004, 9),
  (1072223, 4007003, 10),
  (1072223, 4260005, 10),
  (1072224, 4007002, 10),
  (1072224, 4260005, 10),
  (1072225, 4007006, 10),
  (1072225, 4260005, 10),
  (1072226, 4007007, 10),
  (1072226, 4260005, 10),
  (1072268, 4007002, 11),
  (1072268, 4260006, 11),
  (1072268, 4000244, 5),
  (1072268, 4000245, 5),
  (1072362, 4007004, 12),
  (1072362, 4260007, 8),
  (1072362, 4260008, 4),
  (1072362, 4020009, 15),
  (1072356, 4007004, 12),
  (1072356, 4260007, 2),
  (1072356, 4260008, 10),
  (1072356, 4021010, 1),
  (1082080, 4007007, 5),
  (1082080, 4260000, 5),
  (1082081, 4007006, 5),
  (1082081, 4260000, 5),
  (1082082, 4007002, 5),
  (1082082, 4260000, 5),
  (1082086, 4007001, 6),
  (1082086, 4260001, 6),
  (1082087, 4007004, 6),
  (1082087, 4260001, 6),
  (1082088, 4007007, 6),
  (1082088, 4260001, 6),
  (1082098, 4007000, 7),
  (1082098, 4260002, 7),
  (1082099, 4007002, 7),
  (1082099, 4260002, 7),
  (1082100, 4007007, 7),
  (1082100, 4260002, 7),
  (1082121, 4007003, 8),
  (1082121, 4260003, 8),
  (1082122, 4007002, 8),
  (1082122, 4260003, 8),
  (1082123, 4007007, 8),
  (1082123, 4260003, 8),
  (1082131, 4007002, 9),
  (1082131, 4260004, 9),
  (1082132, 4007003, 9),
  (1082132, 4260004, 9),
  (1082133, 4007006, 9),
  (1082133, 4260004, 9),
  (1082134, 4007007, 9),
  (1082134, 4260004, 9),
  (1082151, 4007003, 10),
  (1082151, 4260005, 10),
  (1082152, 4007002, 10),
  (1082152, 4260005, 10),
  (1082153, 4007006, 10),
  (1082153, 4260005, 10),
  (1082154, 4007005, 10),
  (1082154, 4260005, 10),
  (1082164, 4007002, 11),
  (1082164, 4260006, 11),
  (1082164, 4000244, 5),
  (1082164, 4000245, 5),
  (1082240, 4007002, 12),
  (1082240, 4260007, 8),
  (1082240, 4260008, 4),
  (1082240, 4020009, 15),
  (1082235, 4007002, 12),
  (1082235, 4260007, 2),
  (1082235, 4260008, 10),
  (1082235, 4021010, 1),
  (1092057, 4007004, 12),
  (1092057, 4260007, 2),
  (1092057, 4260008, 10),
  (1092057, 4021010, 1),
  (1372007, 4011000, 1),
  (1372007, 4260000, 20),
  (1382006, 4011000, 1),
  (1382006, 4260000, 20),
  (1372014, 4011001, 2),
  (1372014, 4260001, 22),
  (1382007, 4011001, 2),
  (1382007, 4260001, 22),
  (1372015, 4011001, 3),
  (1372015, 4260002, 24),
  (1382010, 4011001, 3),
  (1382010, 4260002, 24),
  (1372016, 4011002, 3),
  (1372016, 4260003, 26),
  (1382008, 4011002, 3),
  (1382008, 4260004, 26),
  (1372009, 4011002, 4),
  (1372009, 4260004, 28),
  (1382035, 4011002, 4),
  (1382035, 4260005, 28),
  (1372010, 4011003, 4),
  (1372010, 4260005, 30),
  (1372032, 4011003, 5),
  (1372032, 4260006, 32),
  (1372032, 4000244, 20),
  (1372032, 4000245, 20),
  (1382036, 4011003, 5),
  (1382036, 4260006, 32),
  (1382036, 4000244, 20),
  (1382036, 4000245, 20),
  (1372045, 4011005, 5),
  (1372045, 4260007, 20),
  (1372045, 4260008, 14),
  (1372045, 4020009, 45),
  (1382059, 4011005, 5),
  (1382059, 4260007, 20),
  (1382059, 4260008, 14),
  (1382059, 4020009, 45),
  (1372044, 4011005, 5),
  (1372044, 4260007, 14),
  (1372044, 4260008, 20),
  (1372044, 4021010, 3),
  (1382057, 4011005, 5),
  (1382057, 4260007, 14),
  (1382057, 4260008, 20),
  (1382057, 4021010, 3),
  (1002211, 4007002, 5),
  (1002211, 4260000, 5),
  (1002212, 4007006, 5),
  (1002212, 4260000, 5),
  (1002213, 4007003, 5),
  (1002213, 4260000, 5),
  (1002214, 4007007, 5),
  (1002214, 4260000, 5),
  (1002267, 4007006, 6),
  (1002267, 4260001, 6),
  (1002268, 4007000, 6),
  (1002268, 4260001, 6),
  (1002269, 4007001, 6),
  (1002269, 4260001, 6),
  (1002270, 4007007, 6),
  (1002270, 4260001, 6),
  (1002286, 4007002, 7),
  (1002286, 4260002, 7),
  (1002287, 4007001, 4),
  (1002287, 4007004, 3),
  (1002287, 4260002, 7),
  (1002288, 4007003, 7),
  (1002288, 4260002, 7),
  (1002289, 4007007, 7),
  (1002289, 4260002, 7),
  (1002275, 4007002, 8),
  (1002275, 4260003, 8),
  (1002276, 4007006, 8),
  (1002276, 4260003, 8),
  (1002277, 4007003, 8),
  (1002277, 4260003, 8),
  (1002278, 4007007, 8),
  (1002278, 4260003, 8),
  (1002402, 4007006, 9),
  (1002402, 4260004, 9),
  (1002403, 4007002, 9),
  (1002403, 4260004, 9),
  (1002404, 4007003, 9),
  (1002404, 4260004, 9),
  (1002405, 4007007, 9),
  (1002405, 4260004, 9),
  (1002406, 4007006, 10),
  (1002406, 4260005, 10),
  (1002407, 4007002, 10),
  (1002407, 4260005, 10),
  (1002408, 4007003, 10),
  (1002408, 4260005, 10),
  (1002547, 4007006, 11),
  (1002547, 4260006, 11),
  (1002547, 4000244, 5),
  (1002547, 4000245, 5),
  (1002792, 4007005, 12),
  (1002792, 4260007, 8),
  (1002792, 4260008, 4),
  (1002792, 4020009, 15),
  (1002778, 4007005, 12),
  (1002778, 4260007, 2),
  (1002778, 4260008, 10),
  (1002778, 4021010, 1),
  (1050051, 4007006, 5),
  (1050051, 4260000, 10),
  (1050052, 4007002, 5),
  (1050052, 4260000, 10),
  (1051037, 4007002, 5),
  (1051037, 4260000, 10),
  (1051038, 4007003, 5),
  (1051038, 4260000, 10),
  (1051039, 4007006, 5),
  (1051039, 4260000, 10),
  (1050058, 4007005, 6),
  (1050058, 4260001, 12),
  (1050059, 4007002, 6),
  (1050059, 4260001, 12),
  (1050060, 4007006, 6),
  (1050060, 4260001, 12),
  (1051041, 4007006, 6),
  (1051041, 4260001, 12),
  (1051042, 4007002, 6),
  (1051042, 4260001, 12),
  (1051043, 4007004, 6),
  (1051043, 4260001, 12),
  (1050061, 4007002, 7),
  (1050061, 4260002, 14),
  (1050062, 4007001, 4),
  (1050062, 4007004, 3),
  (1050062, 4260002, 14),
  (1050063, 4007003, 7),
  (1050063, 4260002, 14),
  (1050064, 4007007, 7),
  (1050064, 4260002, 14),
  (1051062, 4007002, 7),
  (1051062, 4260002, 14),
  (1051063, 4007001, 4),
  (1051063, 4007004, 3),
  (1051063, 4260002, 14),
  (1051064, 4007003, 7),
  (1051064, 4260002, 14),
  (1051065, 4007007, 7),
  (1051065, 4260002, 14),
  (1050075, 4007006, 8),
  (1050075, 4260003, 16),
  (1050076, 4007002, 8),
  (1050076, 4260003, 16),
  (1050077, 4007003, 8),
  (1050077, 4260003, 16),
  (1050078, 4007007, 8),
  (1050078, 4260003, 16),
  (1051066, 4007006, 8),
  (1051066, 4260003, 16),
  (1051067, 4007002, 8),
  (1051067, 4260003, 16),
  (1051068, 4007003, 8),
  (1051068, 4260003, 16),
  (1051069, 4007007, 8),
  (1051069, 4260003, 16),
  (1050088, 4007006, 9),
  (1050088, 4260004, 18),
  (1050089, 4007002, 9),
  (1050089, 4260004, 18),
  (1050090, 4007003, 9),
  (1050090, 4260004, 18),
  (1050091, 4007007, 9),
  (1050091, 4260004, 18),
  (1051082, 4007006, 9),
  (1051082, 4260004, 18),
  (1051083, 4007002, 9),
  (1051083, 4260004, 18),
  (1051084, 4007003, 9),
  (1051084, 4260004, 18),
  (1051085, 4007007, 9),
  (1051085, 4260004, 18),
  (1050106, 4007003, 10),
  (1050106, 4260005, 20),
  (1050107, 4007002, 10),
  (1050107, 4260005, 20),
  (1050108, 4007006, 10),
  (1050108, 4260005, 20),
  (1051105, 4007003, 10),
  (1051105, 4260005, 20),
  (1051106, 4007002, 10),
  (1051106, 4260005, 20),
  (1051107, 4007006, 10),
  (1051107, 4260005, 20),
  (1052071, 4007006, 11),
  (1052071, 4260006, 22),
  (1052071, 4000244, 5),
  (1052071, 4000245, 5),
  (1052162, 4007005, 12),
  (1052162, 4260007, 16),
  (1052162, 4260008, 8),
  (1052162, 4020009, 15),
  (1052157, 4007005, 12),
  (1052157, 4260007, 4),
  (1052157, 4260008, 20),
  (1052157, 4021010, 1),
  (1072122, 4007000, 5),
  (1072122, 4260000, 5),
  (1072123, 4007003, 5),
  (1072123, 4260000, 5),
  (1072124, 4007002, 5),
  (1072124, 4260000, 5),
  (1072125, 4007005, 5),
  (1072125, 4260000, 5),
  (1072144, 4007006, 6),
  (1072144, 4260001, 6),
  (1072145, 4007002, 6),
  (1072145, 4260001, 6),
  (1072146, 4007003, 6),
  (1072146, 4260001, 6),
  (1072164, 4007002, 7),
  (1072164, 4260002, 7),
  (1072165, 4007001, 4),
  (1072165, 4007004, 3),
  (1072165, 4260002, 7),
  (1072166, 4007003, 7),
  (1072166, 4260002, 7),
  (1072167, 4007007, 7),
  (1072167, 4260002, 7),
  (1072182, 4007002, 8),
  (1072182, 4260003, 8),
  (1072183, 4007006, 8),
  (1072183, 4260003, 8),
  (1072184, 4007003, 8),
  (1072184, 4260003, 8),
  (1072185, 4007007, 8),
  (1072185, 4260003, 8),
  (1072203, 4007006, 9),
  (1072203, 4260004, 9),
  (1072204, 4007003, 9),
  (1072204, 4260004, 9),
  (1072205, 4007007, 9),
  (1072205, 4260004, 9),
  (1072227, 4007006, 10),
  (1072227, 4260005, 10),
  (1072228, 4007002, 10),
  (1072228, 4260005, 10),
  (1072229, 4007003, 10),
  (1072229, 4260005, 10),
  (1072269, 4007006, 11),
  (1072269, 4260006, 11),
  (1072269, 4000244, 5),
  (1072269, 4000245, 5),
  (1072363, 4007004, 12),
  (1072363, 4260007, 8),
  (1072363, 4260008, 4),
  (1072363, 4020009, 15),
  (1072357, 4007005, 12),
  (1072357, 4260007, 2),
  (1072357, 4260008, 10),
  (1072357, 4021010, 1),
  (1082083, 4007007, 5),
  (1082083, 4260000, 5),
  (1082084, 4007002, 5),
  (1082084, 4260000, 5),
  (1082085, 4007006, 5),
  (1082085, 4260000, 5),
  (1082089, 4007004, 6),
  (1082089, 4260001, 6),
  (1082090, 4007006, 6),
  (1082090, 4260001, 6),
  (1082091, 4007007, 6),
  (1082091, 4260001, 6),
  (1082106, 4007002, 7),
  (1082106, 4260002, 7),
  (1082107, 4007004, 7),
  (1082107, 4260002, 7),
  (1082108, 4007007, 7),
  (1082108, 4260002, 7),
  (1082109, 4007006, 8),
  (1082109, 4260003, 8),
  (1082110, 4007002, 8),
  (1082110, 4260003, 8),
  (1082111, 4007003, 8),
  (1082111, 4260003, 8),
  (1082112, 4007007, 8),
  (1082112, 4260003, 8),
  (1082125, 4007006, 9),
  (1082125, 4260004, 9),
  (1082126, 4007003, 9),
  (1082126, 4260004, 9),
  (1082127, 4007007, 9),
  (1082127, 4260004, 9),
  (1082158, 4007006, 10),
  (1082158, 4260005, 10),
  (1082159, 4007002, 10),
  (1082159, 4260005, 10),
  (1082160, 4007003, 10),
  (1082160, 4260005, 10),
  (1082163, 4007006, 11),
  (1082163, 4260006, 11),
  (1082163, 4000244, 5),
  (1082163, 4000245, 5),
  (1082241, 4007001, 12),
  (1082241, 4260007, 8),
  (1082241, 4260008, 4),
  (1082241, 4020009, 15),
  (1082236, 4007001, 12),
  (1082236, 4260007, 2),
  (1082236, 4260008, 10),
  (1082236, 4021010, 1),
  (1452008, 4011000, 1),
  (1452008, 4260000, 20),
  (1462007, 4011000, 1),
  (1462007, 4260000, 20),
  (1452004, 4011001, 2),
  (1452004, 4260001, 22),
  (1462008, 4011001, 2),
  (1462008, 4260001, 22),
  (1452009, 4007006, 7),
  (1452009, 4011001, 3),
  (1452009, 4260002, 24),
  (1452010, 4007002, 7),
  (1452010, 4011001, 3),
  (1452010, 4260002, 24),
  (1452011, 4007004, 7),
  (1452011, 4011001, 3),
  (1452011, 4260002, 24),
  (1462009, 4011001, 3),
  (1462009, 4260002, 24),
  (1452012, 4007002, 8),
  (1452012, 4011002, 3),
  (1452012, 4260003, 26),
  (1452013, 4007006, 8),
  (1452013, 4011002, 3),
  (1452013, 4260003, 26),
  (1452014, 4007004, 8),
  (1452014, 4011002, 3),
  (1452014, 4260003, 26),
  (1452015, 4007007, 8),
  (1452015, 4011002, 3),
  (1452015, 4260003, 26),
  (1462010, 4007002, 8),
  (1462010, 4011002, 3),
  (1462010, 4260003, 26),
  (1462011, 4007006, 8),
  (1462011, 4011002, 3),
  (1462011, 4260003, 26),
  (1462012, 4007004, 8),
  (1462012, 4011002, 3),
  (1462012, 4260003, 26),
  (1462013, 4007007, 8),
  (1462013, 4011002, 3),
  (1462013, 4260003, 26),
  (1452017, 4011002, 4),
  (1452017, 4260004, 28),
  (1462018, 4011002, 4),
  (1462018, 4260004, 28),
  (1452019, 4007001, 10),
  (1452019, 4011003, 4),
  (1452019, 4260005, 30),
  (1452020, 4007004, 10),
  (1452020, 4011003, 4),
  (1452020, 4260005, 30),
  (1452021, 4007007, 10),
  (1452021, 4011003, 4),
  (1452021, 4260005, 30),
  (1462015, 4007001, 10),
  (1462015, 4011003, 4),
  (1462015, 4260005, 30),
  (1462016, 4007004, 10),
  (1462016, 4011003, 4),
  (1462016, 4260005, 30),
  (1462017, 4007007, 10),
  (1462017, 4011003, 4),
  (1462017, 4260005, 30),
  (1452044, 4011003, 5),
  (1452044, 4260006, 32),
  (1452044, 4000244, 20),
  (1452044, 4000245, 20),
  (1462039, 4011003, 5),
  (1462039, 4260006, 32),
  (1462039, 4000244, 20),
  (1462039, 4000245, 20),
  (1452059, 4011005, 5),
  (1452059, 4260007, 20),
  (1452059, 4260008, 14),
  (1452059, 4020009, 45),
  (1462051, 4011005, 5),
  (1462051, 4260007, 20),
  (1462051, 4260008, 14),
  (1462051, 4020009, 45),
  (1452057, 4011005, 5),
  (1452057, 4260007, 14),
  (1452057, 4260008, 20),
  (1452057, 4021010, 3),
  (1462050, 4011005, 5),
  (1462050, 4260007, 14),
  (1462050, 4260008, 20),
  (1462050, 4021010, 3),
  (1002207, 4007006, 5),
  (1002207, 4260000, 5),
  (1002208, 4007002, 5),
  (1002208, 4260000, 5),
  (1002209, 4007003, 5),
  (1002209, 4260000, 5),
  (1002210, 4007004, 5),
  (1002210, 4260000, 5),
  (1002247, 4007000, 6),
  (1002247, 4260001, 6),
  (1002248, 4007001, 6),
  (1002248, 4260001, 6),
  (1002249, 4007007, 6),
  (1002249, 4260001, 6),
  (1002281, 4007000, 7),
  (1002281, 4260002, 7),
  (1002282, 4007002, 7),
  (1002282, 4260002, 7),
  (1002283, 4007005, 7),
  (1002283, 4260002, 7),
  (1002284, 4007001, 7),
  (1002284, 4260002, 7),
  (1002285, 4007006, 7),
  (1002285, 4260002, 7),
  (1002327, 4007000, 8),
  (1002327, 4260003, 8),
  (1002328, 4007003, 8),
  (1002328, 4260003, 8),
  (1002329, 4007006, 8),
  (1002329, 4260003, 8),
  (1002330, 4007007, 8),
  (1002330, 4260003, 8),
  (1002323, 4007003, 9),
  (1002323, 4260004, 9),
  (1002324, 4007000, 9),
  (1002324, 4260004, 9),
  (1002325, 4007005, 9),
  (1002325, 4260004, 9),
  (1002326, 4007006, 9),
  (1002326, 4260004, 9),
  (1002380, 4007003, 10),
  (1002380, 4260005, 10),
  (1002381, 4007002, 10),
  (1002381, 4260005, 10),
  (1002382, 4007006, 10),
  (1002382, 4260005, 10),
  (1002383, 4007007, 10),
  (1002383, 4260005, 10),
  (1002550, 4007007, 11),
  (1002550, 4260006, 11),
  (1002550, 4000244, 5),
  (1002550, 4000245, 5),
  (1002793, 4007005, 12),
  (1002793, 4260007, 8),
  (1002793, 4260008, 4),
  (1002793, 4020009, 15),
  (1002779, 4007005, 12),
  (1002779, 4260007, 2),
  (1002779, 4260008, 10),
  (1002779, 4021010, 1),
  (1040094, 4007006, 5),
  (1040094, 4260000, 5),
  (1040095, 4007002, 5),
  (1040095, 4260000, 5),
  (1040096, 4007004, 5),
  (1040096, 4260000, 5),
  (1040097, 4007003, 5),
  (1040097, 4260000, 5),
  (1041077, 4007005, 5),
  (1041077, 4260000, 5),
  (1041078, 4007002, 5),
  (1041078, 4260000, 5),
  (1041079, 4007004, 5),
  (1041079, 4260000, 5),
  (1041080, 4007006, 5),
  (1041080, 4260000, 5),
  (1040098, 4007001, 6),
  (1040098, 4260001, 6),
  (1040099, 4007004, 6),
  (1040099, 4260001, 6),
  (1040100, 4007007, 6),
  (1040100, 4260001, 6),
  (1041094, 4007001, 6),
  (1041094, 4260001, 6),
  (1041095, 4007006, 6),
  (1041095, 4260001, 6),
  (1041096, 4007007, 6),
  (1041096, 4260001, 6),
  (1040105, 4007000, 7),
  (1040105, 4260002, 7),
  (1040106, 4007002, 7),
  (1040106, 4260002, 7),
  (1040107, 4007007, 7),
  (1040107, 4260002, 7),
  (1041100, 4007005, 7),
  (1041100, 4260002, 7),
  (1041101, 4007002, 7),
  (1041101, 4260002, 7),
  (1041102, 4007006, 7),
  (1041102, 4260002, 7),
  (1041103, 4007006, 7),
  (1041103, 4260002, 7),
  (1040108, 4007003, 8),
  (1040108, 4260003, 8),
  (1040109, 4007006, 8),
  (1040109, 4260003, 8),
  (1040110, 4007007, 8),
  (1040110, 4260003, 8),
  (1041105, 4007003, 8),
  (1041105, 4260003, 8),
  (1041106, 4007006, 8),
  (1041106, 4260003, 8),
  (1041107, 4007007, 8),
  (1041107, 4260003, 8),
  (1040115, 4007003, 9),
  (1040115, 4260004, 9),
  (1040116, 4007000, 9),
  (1040116, 4260004, 9),
  (1040117, 4007005, 9),
  (1040117, 4260004, 9),
  (1040118, 4007006, 9),
  (1040118, 4260004, 9),
  (1041115, 4007003, 9),
  (1041115, 4260004, 9),
  (1041116, 4007000, 9),
  (1041116, 4260004, 9),
  (1041117, 4007005, 9),
  (1041117, 4260004, 9),
  (1041118, 4007006, 9),
  (1041118, 4260004, 9),
  (1060083, 4007006, 5),
  (1060083, 4260000, 5),
  (1060084, 4007002, 5),
  (1060084, 4260000, 5),
  (1060085, 4007004, 5),
  (1060085, 4260000, 5),
  (1060086, 4007003, 5),
  (1060086, 4260000, 5),
  (1061076, 4007005, 5),
  (1061076, 4260000, 5),
  (1061077, 4007002, 5),
  (1061077, 4260000, 5),
  (1061078, 4007004, 5),
  (1061078, 4260000, 5),
  (1061079, 4007006, 5),
  (1061079, 4260000, 5),
  (1060087, 4007001, 6),
  (1060087, 4260001, 6),
  (1060088, 4007004, 6),
  (1060088, 4260001, 6),
  (1060089, 4007007, 6),
  (1060089, 4260001, 6),
  (1061093, 4007001, 6),
  (1061093, 4260001, 6),
  (1061094, 4007006, 6),
  (1061094, 4260001, 6),
  (1061095, 4007007, 6),
  (1061095, 4260001, 6),
  (1060093, 4007000, 7),
  (1060093, 4260002, 7),
  (1060094, 4007002, 7),
  (1060094, 4260002, 7),
  (1060095, 4007007, 7),
  (1060095, 4260002, 7),
  (1061099, 4007005, 7),
  (1061099, 4260002, 7),
  (1061100, 4007002, 7),
  (1061100, 4260002, 7),
  (1061101, 4007006, 7),
  (1061101, 4260002, 7),
  (1061102, 4007006, 7),
  (1061102, 4260002, 7),
  (1060097, 4007003, 8),
  (1060097, 4260003, 8),
  (1060098, 4007006, 8),
  (1060098, 4260003, 8),
  (1060099, 4007007, 8),
  (1060099, 4260003, 8),
  (1061104, 4007003, 8),
  (1061104, 4260003, 8),
  (1061105, 4007006, 8),
  (1061105, 4260003, 8),
  (1061106, 4007007, 8),
  (1061106, 4260003, 8),
  (1060104, 4007003, 9),
  (1060104, 4260004, 9),
  (1060105, 4007000, 9),
  (1060105, 4260004, 9),
  (1060106, 4007005, 9),
  (1060106, 4260004, 9),
  (1060107, 4007006, 9),
  (1060107, 4260004, 9),
  (1061114, 4007003, 9),
  (1061114, 4260004, 9),
  (1061115, 4007000, 9),
  (1061115, 4260004, 9),
  (1061116, 4007005, 9),
  (1061116, 4260004, 9),
  (1061117, 4007006, 9),
  (1061117, 4260004, 9),
  (1050096, 4007003, 10),
  (1050096, 4260005, 20),
  (1050097, 4007002, 10),
  (1050097, 4260005, 20),
  (1050098, 4007006, 10),
  (1050098, 4260005, 20),
  (1050099, 4007007, 10),
  (1050099, 4260005, 20),
  (1051090, 4007003, 10),
  (1051090, 4260005, 20),
  (1051091, 4007002, 10),
  (1051091, 4260005, 20),
  (1051092, 4007006, 10),
  (1051092, 4260005, 20),
  (1051093, 4007007, 10),
  (1051093, 4260005, 20),
  (1052072, 4007007, 11),
  (1052072, 4260006, 22),
  (1052072, 4000244, 5),
  (1052072, 4000245, 5),
  (1052163, 4007005, 12),
  (1052163, 4260007, 16),
  (1052163, 4260008, 8),
  (1052163, 4020009, 15),
  (1052158, 4007005, 12),
  (1052158, 4260007, 4),
  (1052158, 4260008, 20),
  (1052158, 4021010, 1),
  (1072128, 4007002, 5),
  (1072128, 4260000, 5),
  (1072129, 4007003, 5),
  (1072129, 4260000, 5),
  (1072130, 4007006, 5),
  (1072130, 4260000, 5),
  (1072131, 4007005, 5),
  (1072131, 4260000, 5),
  (1072150, 4007006, 6),
  (1072150, 4260001, 6),
  (1072151, 4007004, 6),
  (1072151, 4260001, 6),
  (1072152, 4007007, 6),
  (1072152, 4260001, 6),
  (1072161, 4007005, 7),
  (1072161, 4260002, 7),
  (1072162, 4007002, 7),
  (1072162, 4260002, 7),
  (1072163, 4007006, 7),
  (1072163, 4260002, 7),
  (1072172, 4007003, 8),
  (1072172, 4260003, 8),
  (1072173, 4007006, 8),
  (1072173, 4260003, 8),
  (1072174, 4007007, 8),
  (1072174, 4260003, 8),
  (1072192, 4007003, 9),
  (1072192, 4260004, 9),
  (1072193, 4007000, 9),
  (1072193, 4260004, 9),
  (1072194, 4007005, 9),
  (1072194, 4260004, 9),
  (1072195, 4007006, 9),
  (1072195, 4260004, 9),
  (1072213, 4007003, 10),
  (1072213, 4260005, 10),
  (1072214, 4007002, 10),
  (1072214, 4260005, 10),
  (1072215, 4007006, 10),
  (1072215, 4260005, 10),
  (1072216, 4007007, 10),
  (1072216, 4260005, 10),
  (1072272, 4007007, 11),
  (1072272, 4260006, 11),
  (1072272, 4000244, 5),
  (1072272, 4000245, 5),
  (1072364, 4007005, 12),
  (1072364, 4260007, 8),
  (1072364, 4260008, 4),
  (1072364, 4020009, 15),
  (1072358, 4007005, 12),
  (1072358, 4260007, 2),
  (1072358, 4260008, 10),
  (1072358, 4021010, 1),
  (1082065, 4007002, 5),
  (1082065, 4260000, 5),
  (1082066, 4007004, 5),
  (1082066, 4260000, 5),
  (1082067, 4007006, 5),
  (1082067, 4260000, 5),
  (1082092, 4007000, 6),
  (1082092, 4260001, 6),
  (1082093, 4007001, 6),
  (1082093, 4260001, 6),
  (1082094, 4007004, 6),
  (1082094, 4260001, 6),
  (1082095, 4007000, 7),
  (1082095, 4260002, 7),
  (1082096, 4007001, 7),
  (1082096, 4260002, 7),
  (1082097, 4007004, 7),
  (1082097, 4260002, 7),
  (1082118, 4007003, 8),
  (1082118, 4260003, 8),
  (1082119, 4007005, 8),
  (1082119, 4260003, 8),
  (1082120, 4007006, 8),
  (1082120, 4260003, 8),
  (1082142, 4007003, 9),
  (1082142, 4260004, 9),
  (1082143, 4007005, 9),
  (1082143, 4260004, 9),
  (1082144, 4007007, 9),
  (1082144, 4260004, 9),
  (1082135, 4007002, 10),
  (1082135, 4260005, 10),
  (1082136, 4007003, 10),
  (1082136, 4260005, 10),
  (1082137, 4007006, 10),
  (1082137, 4260005, 10),
  (1082138, 4007007, 10),
  (1082138, 4260005, 10),
  (1082167, 4007007, 11),
  (1082167, 4260006, 11),
  (1082167, 4000244, 5),
  (1082167, 4000245, 5),
  (1082242, 4007005, 12),
  (1082242, 4260007, 8),
  (1082242, 4260008, 4),
  (1082242, 4020009, 15),
  (1082237, 4007005, 12),
  (1082237, 4260007, 2),
  (1082237, 4260008, 10),
  (1082237, 4021010, 1),
  (1092059, 4007000, 12),
  (1092059, 4260007, 2),
  (1092059, 4260008, 10),
  (1092059, 4021010, 1),
  (1332003, 4011000, 1),
  (1332003, 4260000, 20),
  (1472018, 4007001, 5),
  (1472018, 4011000, 1),
  (1472018, 4260000, 20),
  (1472019, 4007006, 5),
  (1472019, 4011000, 1),
  (1472019, 4260000, 20),
  (1472020, 4007002, 5),
  (1472020, 4011000, 1),
  (1472020, 4260000, 20),
  (1472021, 4007007, 5),
  (1472021, 4011000, 1),
  (1472021, 4260000, 20),
  (1332016, 4011000, 1),
  (1332016, 4260000, 20),
  (1332015, 4011001, 2),
  (1332015, 4260001, 22),
  (1472022, 4007000, 6),
  (1472022, 4011001, 2),
  (1472022, 4260001, 22),
  (1472023, 4007006, 6),
  (1472023, 4011001, 2),
  (1472023, 4260001, 22),
  (1472024, 4007002, 6),
  (1472024, 4011001, 2),
  (1472024, 4260001, 22),
  (1472025, 4007007, 6),
  (1472025, 4011001, 2),
  (1472025, 4260001, 22),
  (1332017, 4011001, 2),
  (1332017, 4260001, 22),
  (1332018, 4011001, 3),
  (1332018, 4260002, 24),
  (1472026, 4007004, 7),
  (1472026, 4011001, 3),
  (1472026, 4260002, 24),
  (1472027, 4007003, 7),
  (1472027, 4011001, 3),
  (1472027, 4260002, 24),
  (1472028, 4007002, 7),
  (1472028, 4011001, 3),
  (1472028, 4260002, 24),
  (1472029, 4007007, 7),
  (1472029, 4011001, 3),
  (1472029, 4260002, 24),
  (1332019, 4011001, 3),
  (1332019, 4260002, 24),
  (1472031, 4011002, 3),
  (1472031, 4260003, 26),
  (1332022, 4011002, 3),
  (1332022, 4260003, 26),
  (1332023, 4011002, 3),
  (1332023, 4260003, 26),
  (1332027, 4011002, 4),
  (1332027, 4260004, 28),
  (1472033, 4011002, 4),
  (1472033, 4260004, 28),
  (1332026, 4011002, 4),
  (1332026, 4260004, 28),
  (1332052, 4011003, 4),
  (1332052, 4260005, 30),
  (1472053, 4011003, 4),
  (1472053, 4260005, 30),
  (1332051, 4011003, 4),
  (1332051, 4260005, 30),
  (1332050, 4011003, 5),
  (1332050, 4260006, 32),
  (1332050, 4000244, 20),
  (1332050, 4000245, 20),
  (1472051, 4007003, 11),
  (1472051, 4011003, 5),
  (1472051, 4260006, 32),
  (1472051, 4000244, 20),
  (1472051, 4000245, 20),
  (1472052, 4007005, 11),
  (1472052, 4011003, 5),
  (1472052, 4260006, 32),
  (1472052, 4000244, 20),
  (1472052, 4000245, 20),
  (1332049, 4011003, 5),
  (1332049, 4260006, 32),
  (1332049, 4000244, 20),
  (1332049, 4000245, 20),
  (1332075, 4011005, 5),
  (1332075, 4260007, 20),
  (1332075, 4260008, 14),
  (1332075, 4020009, 45),
  (1332076, 4011005, 5),
  (1332076, 4260007, 20),
  (1332076, 4260008, 14),
  (1332076, 4020009, 45),
  (1472071, 4011005, 5),
  (1472071, 4260007, 20),
  (1472071, 4260008, 14),
  (1472071, 4020009, 45),
  (1332073, 4011005, 5),
  (1332073, 4260007, 14),
  (1332073, 4260008, 20),
  (1332073, 4021010, 3),
  (1332074, 4011005, 5),
  (1332074, 4260007, 14),
  (1332074, 4260008, 20),
  (1332074, 4021010, 3),
  (1472068, 4011005, 5),
  (1472068, 4260007, 14),
  (1472068, 4260008, 20),
  (1472068, 4021010, 3),
  (1002631, 4007000, 5),
  (1002631, 4260000, 5),
  (1002634, 4007005, 6),
  (1002634, 4260001, 6),
  (1002637, 4007007, 7),
  (1002637, 4260002, 7),
  (1002640, 4007002, 8),
  (1002640, 4260003, 8),
  (1002643, 4007006, 9),
  (1002643, 4260004, 9),
  (1002646, 4007007, 10),
  (1002646, 4260005, 10),
  (1002649, 4007007, 11),
  (1002649, 4260006, 11),
  (1002649, 4000244, 5),
  (1002649, 4000245, 5),
  (1002794, 4007006, 12),
  (1002794, 4260007, 8),
  (1002794, 4260008, 4),
  (1002794, 4020009, 15),
  (1002780, 4007006, 12),
  (1002780, 4260007, 2),
  (1002780, 4260008, 10),
  (1002780, 4021010, 1),
  (1052116, 4007003, 5),
  (1052116, 4260000, 10),
  (1052119, 4007007, 6),
  (1052119, 4260001, 12),
  (1052122, 4007006, 7),
  (1052122, 4260002, 14),
  (1052125, 4007001, 8),
  (1052125, 4260003, 16),
  (1052128, 4007001, 9),
  (1052128, 4260004, 18),
  (1052131, 4007006, 10),
  (1052131, 4260005, 20),
  (1052134, 4007007, 11),
  (1052134, 4260006, 22),
  (1052134, 4000244, 5),
  (1052134, 4000245, 5),
  (1052164, 4007006, 12),
  (1052164, 4260007, 16),
  (1052164, 4260008, 8),
  (1052164, 4020009, 15),
  (1052159, 4007006, 12),
  (1052159, 4260007, 4),
  (1052159, 4260008, 20),
  (1052159, 4021010, 1),
  (1072303, 4007000, 5),
  (1072303, 4260000, 5),
  (1072306, 4007007, 6),
  (1072306, 4260001, 6),
  (1072309, 4007007, 7),
  (1072309, 4260002, 7),
  (1072312, 4007002, 8),
  (1072312, 4260003, 8),
  (1072315, 4007007, 9),
  (1072315, 4260004, 9),
  (1072318, 4007007, 10),
  (1072318, 4260005, 10),
  (1072321, 4007007, 11),
  (1072321, 4260006, 11),
  (1072321, 4000244, 5),
  (1072321, 4000245, 5),
  (1072365, 4007006, 12),
  (1072365, 4260007, 8),
  (1072365, 4260008, 4),
  (1072365, 4020009, 15),
  (1072359, 4007006, 12),
  (1072359, 4260007, 2),
  (1072359, 4260008, 10),
  (1072359, 4021010, 1),
  (1082198, 4007000, 5),
  (1082198, 4260000, 5),
  (1082201, 4007007, 6),
  (1082201, 4260001, 6),
  (1082204, 4007007, 7),
  (1082204, 4260002, 7),
  (1082207, 4007002, 8),
  (1082207, 4260003, 8),
  (1082210, 4007006, 9),
  (1082210, 4260004, 9),
  (1082213, 4007007, 10),
  (1082213, 4260005, 10),
  (1082216, 4007007, 11),
  (1082216, 4260006, 11),
  (1082216, 4000244, 5),
  (1082216, 4000245, 5),
  (1082243, 4007006, 12),
  (1082243, 4260007, 8),
  (1082243, 4260008, 4),
  (1082243, 4020009, 15),
  (1082238, 4007006, 12),
  (1082238, 4260007, 2),
  (1082238, 4260008, 10),
  (1082238, 4021010, 1),
  (1482007, 4011000, 1),
  (1482007, 4260000, 20),
  (1492007, 4011000, 1),
  (1492007, 4260000, 20),
  (1482008, 4011001, 2),
  (1482008, 4260001, 22),
  (1492008, 4011001, 2),
  (1492008, 4260001, 22),
  (1482009, 4011001, 3),
  (1482009, 4260002, 24),
  (1492009, 4011001, 3),
  (1492009, 4260002, 24),
  (1482010, 4011002, 3),
  (1482010, 4260003, 26),
  (1492010, 4011002, 3),
  (1492010, 4260003, 26),
  (1482011, 4011002, 4),
  (1482011, 4260004, 28),
  (1492011, 4011002, 4),
  (1492011, 4260004, 28),
  (1482012, 4011003, 4),
  (1482012, 4260005, 30),
  (1492012, 4011003, 4),
  (1492012, 4260005, 30),
  (1482013, 4011003, 5),
  (1482013, 4260006, 32),
  (1482013, 4000244, 20),
  (1482013, 4000245, 20),
  (1492013, 4011003, 5),
  (1492013, 4260006, 32),
  (1492013, 4000244, 20),
  (1492013, 4000245, 20),
  (1482024, 4011005, 5),
  (1482024, 4260007, 20),
  (1482024, 4260008, 14),
  (1482024, 4020009, 45),
  (1492025, 4011005, 5),
  (1492025, 4260007, 20),
  (1492025, 4260008, 14),
  (1492025, 4020009, 45),
  (1482023, 4011005, 5),
  (1482023, 4260007, 14),
  (1482023, 4260008, 20),
  (1482023, 4021010, 3),
  (1492023, 4011005, 5),
  (1492023, 4260007, 14),
  (1492023, 4260008, 20),
  (1492023, 4021010, 3);

INSERT IGNORE INTO `makerrewarddata` (`itemid`, `rewardid`, `quantity`, `prob`) VALUES
  (4250000, 4250000, 1, 14),
  (4250000, 4250001, 1, 5),
  (4250000, 4250002, 1, 1),
  (4250100, 4250100, 1, 14),
  (4250100, 4250101, 1, 5),
  (4250100, 4250102, 1, 1),
  (4250200, 4250200, 1, 14),
  (4250200, 4250201, 1, 5),
  (4250200, 4250202, 1, 1),
  (4250300, 4250300, 1, 14),
  (4250300, 4250301, 1, 5),
  (4250300, 4250302, 1, 1),
  (4250400, 4250400, 1, 14),
  (4250400, 4250401, 1, 5),
  (4250400, 4250402, 1, 1),
  (4250500, 4250500, 1, 14),
  (4250500, 4250501, 1, 5),
  (4250500, 4250502, 1, 1),
  (4250600, 4250600, 1, 14),
  (4250600, 4250601, 1, 5),
  (4250600, 4250602, 1, 1),
  (4250700, 4250700, 1, 14),
  (4250700, 4250701, 1, 5),
  (4250700, 4250702, 1, 1),
  (4250800, 4250800, 1, 75),
  (4250800, 4250801, 1, 24),
  (4250800, 4250802, 1, 1),
  (4250900, 4250900, 1, 75),
  (4250900, 4250901, 1, 24),
  (4250900, 4250902, 1, 1),
  (4251000, 4251000, 1, 75),
  (4251000, 4251001, 1, 24),
  (4251000, 4251002, 1, 1),
  (4251100, 4251100, 1, 75),
  (4251100, 4251101, 1, 24),
  (4251100, 4251102, 1, 1),
  (4251300, 4251300, 1, 27),
  (4251300, 4251301, 1, 12),
  (4251300, 4251302, 1, 1),
  (4251400, 4251400, 1, 27),
  (4251400, 4251401, 1, 12),
  (4251400, 4251402, 1, 1),
  (4250001, 4250001, 1, 3),
  (4250001, 4250000, 9, 2),
  (4250101, 4250101, 1, 3),
  (4250101, 4250100, 9, 2),
  (4250201, 4250201, 1, 3),
  (4250201, 4250200, 9, 2),
  (4250301, 4250301, 1, 3),
  (4250301, 4250300, 9, 2),
  (4250401, 4250401, 1, 3),
  (4250401, 4250400, 9, 2),
  (4250501, 4250501, 1, 3),
  (4250501, 4250500, 9, 2),
  (4250601, 4250601, 1, 3),
  (4250601, 4250600, 9, 2),
  (4250701, 4250701, 1, 3),
  (4250701, 4250700, 9, 2),
  (4250801, 4250801, 1, 3),
  (4250801, 4250800, 9, 2),
  (4250901, 4250901, 1, 3),
  (4250901, 4250900, 9, 2),
  (4251001, 4251001, 1, 3),
  (4251001, 4251000, 9, 2),
  (4251101, 4251101, 1, 3),
  (4251101, 4251100, 9, 2),
  (4251301, 4251301, 1, 1),
  (4251301, 4251300, 9, 1),
  (4251401, 4251401, 1, 1),
  (4251401, 4251400, 9, 1),
  (4250002, 4250002, 1, 3),
  (4250002, 4250001, 9, 7),
  (4250102, 4250102, 1, 3),
  (4250102, 4250101, 9, 7),
  (4250202, 4250202, 1, 3),
  (4250202, 4250201, 9, 7),
  (4250302, 4250302, 1, 3),
  (4250302, 4250301, 9, 7),
  (4250402, 4250402, 1, 3),
  (4250402, 4250401, 9, 7),
  (4250502, 4250502, 1, 3),
  (4250502, 4250501, 9, 7),
  (4250602, 4250602, 1, 3),
  (4250602, 4250601, 9, 7),
  (4250702, 4250702, 1, 3),
  (4250702, 4250701, 9, 7),
  (4250802, 4250802, 1, 3),
  (4250802, 4250801, 9, 7),
  (4250902, 4250902, 1, 3),
  (4250902, 4250901, 9, 7),
  (4251002, 4251002, 1, 3),
  (4251002, 4251001, 9, 7),
  (4251102, 4251102, 1, 3),
  (4251102, 4251101, 9, 7),
  (4251302, 4251302, 1, 1),
  (4251302, 4251301, 9, 4),
  (4251402, 4251402, 1, 1),
  (4251402, 4251401, 9, 4);

# generated with the MapleSkillMakerReagentIndexer feature

CREATE TABLE IF NOT EXISTS `makerreagentdata` (
  `itemid` int(11) NOT NULL,
  `stat` varchar(20) NOT NULL,
  `value` smallint(6) NOT NULL,
  PRIMARY KEY (`itemid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

INSERT IGNORE INTO `makerreagentdata` (`itemid`, `stat`, `value`) VALUES
  (4250000, "incPAD", 1),
  (4250001, "incPAD", 2),
  (4250002, "incPAD", 3),
  (4250100, "incMAD", 1),
  (4250101, "incMAD", 2),
  (4250102, "incMAD", 3),
  (4250200, "incACC", 2),
  (4250201, "incACC", 3),
  (4250202, "incACC", 5),
  (4250300, "incEVA", 2),
  (4250301, "incEVA", 3),
  (4250302, "incEVA", 5),
  (4250400, "incSpeed", 2),
  (4250401, "incSpeed", 3),
  (4250402, "incSpeed", 5),
  (4250500, "incJump", 1),
  (4250501, "incJump", 2),
  (4250502, "incJump", 3),
  (4250600, "incMaxHP", 10),
  (4250601, "incMaxHP", 20),
  (4250602, "incMaxHP", 30),
  (4250700, "incMaxMP", 10),
  (4250701, "incMaxMP", 20),
  (4250702, "incMaxMP", 30),
  (4250800, "incSTR", 2),
  (4250801, "incSTR", 3),
  (4250802, "incSTR", 5),
  (4250900, "incINT", 2),
  (4250901, "incINT", 3),
  (4250902, "incINT", 5),
  (4251000, "incLUK", 2),
  (4251001, "incLUK", 3),
  (4251002, "incLUK", 5),
  (4251100, "incDEX", 2),
  (4251101, "incDEX", 3),
  (4251102, "incDEX", 5),
  (4251200, "incReqLevel", -1),
  (4251201, "incReqLevel", -2),
  (4251202, "incReqLevel", -3),
  (4251300, "randOption", 1),
  (4251301, "randOption", 2),
  (4251302, "randOption", 3),
  (4251400, "randStat", 2),
  (4251401, "randStat", 3),
  (4251402, "randStat", 5);

CREATE TABLE IF NOT EXISTS `marriages` (
  `marriageid` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `husbandid` int(10) unsigned NOT NULL DEFAULT '0',
  `wifeid` int(10) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`marriageid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `medalmaps` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `characterid` int(11) NOT NULL,
  `queststatusid` int(11) unsigned NOT NULL,
  `mapid` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `queststatusid` (`queststatusid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `monsterbook` (
  `charid` int(11) NOT NULL,
  `cardid` int(11) NOT NULL,
  `level` int(1) NOT NULL DEFAULT '1',
  PRIMARY KEY (`charid`, `cardid`),
  CONSTRAINT `FK_monsterbook_characters` FOREIGN KEY (`charid`) REFERENCES `characters`(`id`) ON UPDATE CASCADE ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE IF NOT EXISTS `monstercarddata` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `cardid` int(11) NOT NULL DEFAULT '0',
  `mobid` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`) USING BTREE,
  UNIQUE KEY `id` (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=latin1 AUTO_INCREMENT=309 ;

INSERT INTO `monstercarddata` (`id`, `cardid`, `mobid`) VALUES
(1, 2380000, 100100),
(2, 2380001, 100101),
(3, 2380003, 130100),
(4, 2380004, 130101),
(5, 2380005, 210100),
(6, 2380006, 1210100),
(7, 2380007, 1210102),
(8, 2380008, 1110101),
(9, 2380009, 1210101),
(10, 2380010, 1120100),
(11, 2380011, 1110100),
(12, 2380012, 1210103),
(13, 2381000, 1130100),
(14, 2381001, 1140100),
(15, 2381002, 2220100),
(16, 2381003, 2300100),
(17, 2381006, 2130103),
(18, 2381007, 2110200),
(19, 2381008, 2130100),
(20, 2381009, 2230108),
(21, 2381010, 2100102),
(22, 2381011, 2230103),
(23, 2381012, 5200000),
(24, 2381013, 2230105),
(25, 2381014, 2230110),
(26, 2381015, 2100105),
(27, 2381016, 2230101),
(28, 2381017, 2230107),
(29, 2381018, 2230111),
(30, 2381019, 2100106),
(31, 2381020, 2110300),
(32, 2381021, 2230106),
(33, 2381022, 2230102),
(34, 2381023, 2100103),
(35, 2381024, 2230100),
(36, 2381025, 2100107),
(37, 2381026, 2230109),
(38, 2381027, 2230104),
(39, 2381028, 2100104),
(40, 2381029, 2230200),
(41, 2381031, 2110301),
(42, 2381032, 3000000),
(43, 2381034, 3000005),
(44, 2381035, 3000006),
(45, 2381036, 3100102),
(46, 2381037, 5200001),
(47, 2381038, 5200002),
(48, 2382000, 3230307),
(49, 2382002, 3110100),
(50, 2382004, 3110101),
(51, 2382005, 3110102),
(52, 2382006, 5300000),
(53, 2382007, 3230104),
(54, 2382009, 3110300),
(55, 2382011, 3210200),
(56, 2382012, 3210201),
(57, 2382013, 3210202),
(58, 2382014, 5300001),
(59, 2382015, 3210204),
(60, 2382016, 3210205),
(61, 2382017, 3210207),
(62, 2382018, 3230100),
(63, 2382019, 3230101),
(64, 2382020, 3230200),
(65, 2382022, 3230302),
(66, 2382023, 5400000),
(67, 2382024, 3110302),
(68, 2382025, 3210203),
(69, 2382026, 3210206),
(70, 2382027, 3210450),
(71, 2382028, 3210208),
(72, 2382029, 3210800),
(73, 2382030, 3230102),
(74, 2382031, 3230303),
(75, 2382032, 3230306),
(76, 2382033, 3230103),
(77, 2382034, 3230304),
(78, 2382035, 3230405),
(79, 2382036, 3110303),
(80, 2382037, 3230308),
(81, 2382038, 3230305),
(82, 2382039, 4230100),
(83, 2382040, 4230101),
(84, 2382041, 4230113),
(85, 2382043, 4230200),
(86, 2382044, 4230201),
(87, 2382045, 4230500),
(88, 2382047, 4230107),
(89, 2382048, 4230111),
(90, 2382049, 4230114),
(91, 2382050, 4230119),
(92, 2382051, 4230501),
(93, 2382052, 4230105),
(94, 2382053, 4230103),
(95, 2382054, 4230109),
(96, 2382056, 4230124),
(97, 2382057, 4110300),
(98, 2382058, 4230108),
(99, 2382059, 4230123),
(100, 2382060, 4230502),
(101, 2382061, 4230120),
(102, 2382062, 4230112),
(103, 2382063, 4230125),
(104, 2382064, 4230106),
(105, 2382065, 4130100),
(106, 2382066, 4230110),
(107, 2382068, 4230300),
(108, 2382069, 4230400),
(109, 2382070, 4230503),
(110, 2382071, 4230504),
(111, 2382072, 4110301),
(112, 2382076, 4250000),
(113, 2383000, 4230121),
(114, 2383001, 4130101),
(115, 2383002, 4230115),
(116, 2383003, 4130102),
(117, 2383004, 4130103),
(118, 2383006, 4230505),
(119, 2383007, 4110302),
(120, 2383008, 4230102),
(121, 2383009, 4230104),
(122, 2383010, 4230506),
(123, 2383012, 5130100),
(124, 2383013, 5100000),
(125, 2383014, 5100003),
(126, 2383015, 5120503),
(127, 2383016, 9300144),
(128, 2383017, 5100002),
(129, 2383018, 5120504),
(130, 2383019, 5130103),
(131, 2383021, 5120001),
(132, 2383022, 5120002),
(133, 2383023, 5120003),
(134, 2383024, 5100005),
(135, 2383025, 5120501),
(136, 2383026, 5120100),
(137, 2383027, 5120502),
(138, 2383028, 9300149),
(139, 2383029, 5300100),
(140, 2383030, 5130101),
(141, 2383031, 5130104),
(142, 2383032, 5120506),
(143, 2383033, 5130105),
(144, 2383035, 5120500),
(145, 2383036, 5150001),
(146, 2383037, 5130107),
(147, 2383038, 5130108),
(148, 2383039, 5130102),
(149, 2383040, 5140000),
(150, 2383041, 5120505),
(151, 2383042, 5110302),
(152, 2383043, 5150000),
(153, 2383044, 6130100),
(154, 2383045, 6130103),
(155, 2383046, 6130202),
(156, 2383047, 6130203),
(157, 2383048, 5090000),
(158, 2383049, 5090001),
(159, 2383056, 4250001),
(160, 2383057, 5250000),
(161, 2383058, 5250002),
(162, 2383059, 5250001),
(163, 2384000, 6130200),
(164, 2384001, 9400201),
(165, 2384002, 6130207),
(166, 2384003, 6230602),
(167, 2384004, 6230400),
(168, 2384006, 6230600),
(169, 2384007, 6230200),
(170, 2384008, 6130204),
(171, 2384009, 6300000),
(172, 2384010, 6090000),
(173, 2384011, 6110300),
(174, 2384012, 6230300),
(175, 2384013, 6130209),
(176, 2384014, 6230500),
(177, 2384015, 6230601),
(178, 2384016, 6400000),
(179, 2384017, 6130208),
(180, 2384018, 9300146),
(181, 2384019, 8140200),
(182, 2384020, 7130100),
(183, 2384021, 7130400),
(184, 2384022, 7130401),
(185, 2384023, 7130402),
(186, 2384024, 7130500),
(187, 2384025, 7130104),
(188, 2384026, 7130001),
(189, 2384027, 7130002),
(190, 2384028, 7130600),
(191, 2384029, 7130103),
(192, 2384032, 6300100),
(193, 2384033, 7130501),
(194, 2384035, 7130200),
(195, 2384036, 7130101),
(196, 2384037, 6090001),
(197, 2384038, 7090000),
(198, 2384039, 6090003),
(199, 2384040, 6090004),
(200, 2385000, 8140300),
(201, 2385001, 7130003),
(202, 2385002, 7130601),
(203, 2385003, 6400100),
(204, 2385004, 7130102),
(205, 2385005, 7130004),
(206, 2385006, 8140000),
(207, 2385007, 8140001),
(208, 2385008, 8110300),
(209, 2385009, 8140100),
(210, 2385011, 8140002),
(211, 2385012, 7130010),
(212, 2385013, 7130020),
(213, 2385014, 8140110),
(214, 2385016, 8140101),
(215, 2385017, 8140102),
(216, 2385018, 8140103),
(217, 2385019, 8140111),
(218, 2385020, 7130300),
(219, 2385021, 8140500),
(220, 2385022, 8140700),
(221, 2385023, 8090000),
(222, 2385025, 8200000),
(223, 2386000, 8140600),
(224, 2386001, 8140701),
(225, 2386002, 9300324),
(226, 2386003, 8141300),
(227, 2386004, 8142000),
(228, 2386005, 8140702),
(229, 2386006, 8140703),
(230, 2386007, 8142100),
(231, 2386008, 8150300),
(232, 2386009, 9500136),
(233, 2386010, 9500137),
(234, 2386011, 8150200),
(235, 2386012, 8150100),
(236, 2386013, 8150301),
(237, 2386014, 8150101),
(238, 2386015, 8150302),
(239, 2386016, 8150201),
(240, 2386017, 8190000),
(241, 2386021, 8200001),
(242, 2386022, 8200002),
(243, 2386023, 8200003),
(244, 2386024, 8200004),
(245, 2387000, 8160000),
(246, 2387001, 8170000),
(247, 2387002, 8190003),
(248, 2387003, 8190004),
(249, 2387004, 8190002),
(250, 2387006, 8200005),
(251, 2387007, 8200006),
(252, 2387008, 8200007),
(253, 2387009, 8200008),
(254, 2387010, 8200009),
(255, 2387011, 8200010),
(256, 2387012, 8200011),
(257, 2387013, 8200012),
(258, 2388000, 9300184),
(259, 2388001, 9300003),
(260, 2388002, 5220002),
(261, 2388003, 5220000),
(262, 2388004, 9300012),
(263, 2388005, 5220003),
(264, 2388006, 6130101),
(265, 2388007, 6220000),
(266, 2388008, 6300005),
(267, 2388009, 7220001),
(268, 2388010, 7220000),
(269, 2388011, 9300119),
(270, 2388012, 9300039),
(271, 2388013, 7220002),
(272, 2388014, 9300139),
(273, 2388016, 8220001),
(274, 2388017, 8150000),
(275, 2388018, 8180000),
(276, 2388019, 8180001),
(277, 2388020, 8510000),
(278, 2388021, 9300028),
(279, 2388022, 8500002),
(280, 2388025, 3220000),
(281, 2388026, 8130100),
(282, 2388028, 9500317),
(283, 2388029, 3220001),
(284, 2388030, 4220000),
(285, 2388031, 6220001),
(286, 2388033, 8220003),
(287, 2388040, 8220004),
(288, 2388041, 8220005),
(289, 2388042, 8220006),
(290, 2388043, 8820000),
(291, 2380013, 9300274),
(292, 2388055, 8830000),
(293, 2380014, 1110130),
(294, 2380015, 100130),
(295, 2380016, 100131),
(296, 2380017, 100132),
(297, 2380018, 100133),
(298, 2380019, 100134),
(299, 2381083, 2230131),
(300, 2382093, 3300001),
(301, 2382094, 3300002),
(302, 2382095, 3300003),
(303, 2382096, 3300004),
(304, 2388052, 5220004),
(305, 2388053, 8220007),
(306, 2388054, 8220009),
(307, 2388068, 3300006),
(308, 2388069, 3300007);

CREATE TABLE IF NOT EXISTS `mts_cart` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `cid` int(11) NOT NULL,
  `itemid` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `mts_items` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `tab` int(11) NOT NULL DEFAULT '0',
  `type` int(11) NOT NULL DEFAULT '0',
  `itemid` int(10) unsigned NOT NULL DEFAULT '0',
  `quantity` int(11) NOT NULL DEFAULT '1',
  `seller` int(11) NOT NULL DEFAULT '0',
  `price` int(11) NOT NULL DEFAULT '0',
  `bid_incre` int(11) DEFAULT '0',
  `buy_now` int(11) DEFAULT '0',
  `position` int(11) DEFAULT '0',
  `upgradeslots` int(11) DEFAULT '0',
  `level` int(11) DEFAULT '0',
  `itemlevel` int(11) NOT NULL DEFAULT '1',
  `itemexp` int(11) unsigned NOT NULL DEFAULT '0',
  `ringid` int(11) NOT NULL DEFAULT '-1',
  `str` int(11) DEFAULT '0',
  `dex` int(11) DEFAULT '0',
  `int` int(11) DEFAULT '0',
  `luk` int(11) DEFAULT '0',
  `hp` int(11) DEFAULT '0',
  `mp` int(11) DEFAULT '0',
  `watk` int(11) DEFAULT '0',
  `matk` int(11) DEFAULT '0',
  `wdef` int(11) DEFAULT '0',
  `mdef` int(11) DEFAULT '0',
  `acc` int(11) DEFAULT '0',
  `avoid` int(11) DEFAULT '0',
  `hands` int(11) DEFAULT '0',
  `speed` int(11) DEFAULT '0',
  `jump` int(11) DEFAULT '0',
  `locked` int(11) DEFAULT '0',
  `isequip` int(1) DEFAULT '0',
  `owner` varchar(16) DEFAULT '',
  `sellername` varchar(16) NOT NULL,
  `sell_ends` varchar(16) NOT NULL,
  `transfer` int(2) DEFAULT '0',
  `vicious` int(2) unsigned NOT NULL DEFAULT '0',
  `flag` int(2) unsigned NOT NULL DEFAULT '0',
  `expiration` bigint(20) NOT NULL DEFAULT '-1',
  `giftFrom` varchar(26) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `namechanges` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `characterid` int(11) NOT NULL,
  `old` varchar(13) NOT NULL,
  `new` varchar(13) NOT NULL,
  `requestTime` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `completionTime` timestamp NULL,
  PRIMARY KEY (`id`),
  INDEX (characterid)
) ENGINE=InnoDB  DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `newyear` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `senderid` int(10) NOT NULL DEFAULT '-1',
  `sendername` varchar(13) DEFAULT '',
  `receiverid` int(10) NOT NULL DEFAULT '-1',
  `receivername` varchar(13) DEFAULT '',
  `message` varchar(120) DEFAULT '',
  `senderdiscard` tinyint(1) NOT NULL DEFAULT '0',
  `receiverdiscard` tinyint(1) NOT NULL DEFAULT '0',
  `received` tinyint(1) NOT NULL DEFAULT '0',
  `timesent` bigint(20) unsigned NOT NULL,
  `timereceived` bigint(20) unsigned NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `notes` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `to` varchar(13) NOT NULL DEFAULT '',
  `from` varchar(13) NOT NULL DEFAULT '',
  `message` text NOT NULL,
  `timestamp` bigint(20) unsigned NOT NULL,
  `fame` int(11) NOT NULL DEFAULT '0',
  `deleted` int(2) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `nxcode` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `code` varchar(17) NOT NULL UNIQUE,
  `retriever` varchar(13) DEFAULT NULL,
  `expiration` bigint(20) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `nxcode_items` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `codeid` int(11) NOT NULL,
  `type` int(11) NOT NULL DEFAULT '5',
  `item` int(11) NOT NULL DEFAULT '4000000',
  `quantity` int(11) NOT NULL DEFAULT '1',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `nxcoupons` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `couponid` int(11) NOT NULL DEFAULT '0',
  `rate` int(11) NOT NULL DEFAULT '0',
  `activeday` int(11) NOT NULL DEFAULT '0',
  `starthour` int(11) NOT NULL DEFAULT '0',
  `endhour` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=41 ;

INSERT INTO `nxcoupons` (`id`, `couponid`, `rate`, `activeday`, `starthour`, `endhour`) VALUES
(1,5211000,2,254,18,20),
(2,5211004,2,124,7,11),
(3,5211005,2,124,10,14),
(4,5211006,2,124,13,17),
(5,5211007,2,124,16,20),
(6,5211008,2,124,19,23),
(7,5211009,2,130,7,11),
(8,5211010,2,130,10,14),
(9,5211011,2,130,13,17),
(10,5211012,2,130,16,20),
(11,5211013,2,130,19,23),
(12,5211014,2,254,7,11),
(13,5211015,2,254,10,14),
(14,5211016,2,254,13,17),
(15,5211017,2,254,16,20),
(16,5211018,2,254,19,23),
(17,5211037,2,124,0,4),
(18,5211038,2,130,0,4),
(19,5211039,2,254,0,4),
(20,5211040,2,124,3,7),
(21,5211041,2,130,3,7),
(22,5211042,2,254,3,7),
(23,5211043,2,124,6,10),
(24,5211044,2,130,6,10),
(25,5211045,2,254,6,10),
(26,5211046,2,254,0,24),
(27,5211048,2,254,0,24),
(28,5211049,2,254,0,24),
(29,5211052,3,255,0,24),
(30,5211060,3,255,0,24),
(31,5360000,2,254,0,24),
(32,5360001,2,254,7,11),
(33,5360002,2,254,10,14),
(34,5360003,2,254,13,17),
(35,5360004,2,254,16,20),
(36,5360005,2,254,19,23),
(37,5360006,2,254,0,4),
(38,5360007,2,254,3,7),
(39,5360008,2,254,6,10),
(40,5360042,2,254,0,24);

CREATE TABLE IF NOT EXISTS `pets` (
  `petid` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(13) DEFAULT NULL,
  `level` int(10) unsigned NOT NULL,
  `closeness` int(10) unsigned NOT NULL,
  `fullness` int(10) unsigned NOT NULL,
  `summoned` tinyint(1) NOT NULL DEFAULT '0',
  `flag` int(10) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`petid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;


CREATE TABLE IF NOT EXISTS `petignores` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `petid` int(11) unsigned NOT NULL ,
  `itemid` int(10) unsigned NOT NULL ,
  PRIMARY KEY (`id`),
  CONSTRAINT `fk_petignorepetid` FOREIGN KEY (`petid`) REFERENCES `pets` (`petid`) ON DELETE CASCADE    # thanks Optimist for noticing queries over petid taking too long, shavit for pointing out an improvement using foreign key
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `playerdiseases` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `charid` int(11) NOT NULL,
  `disease` int(11) NOT NULL,
  `mobskillid` int(11) NOT NULL,
  `mobskilllv` int(11) NOT NULL,
  `length` int(11) NOT NULL DEFAULT '1',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `playernpcs` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(13) NOT NULL,
  `hair` int(11) NOT NULL,
  `face` int(11) NOT NULL,
  `skin` int(11) NOT NULL,
  `gender` int(11) NOT NULL DEFAULT '0',
  `x` int(11) NOT NULL,
  `cy` int(11) NOT NULL DEFAULT '0',
  `world` int(11) NOT NULL DEFAULT '0',
  `map` int(11) NOT NULL DEFAULT '0',
  `dir` int(11) NOT NULL DEFAULT '0',
  `scriptid` int(10) unsigned NOT NULL DEFAULT '0',
  `fh` int(11) NOT NULL DEFAULT '0',
  `rx0` int(11) NOT NULL DEFAULT '0',
  `rx1` int(11) NOT NULL DEFAULT '0',
  `worldrank` int(11) NOT NULL DEFAULT '0',
  `overallrank` int(11) NOT NULL DEFAULT '0',
  `worldjobrank` int(11) NOT NULL DEFAULT '0',
  `job` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=2147000000 ;

CREATE TABLE IF NOT EXISTS `playernpcs_equip` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `npcid` int(11) NOT NULL DEFAULT '0',
  `equipid` int(11) NOT NULL,
  `type` int(11) NOT NULL DEFAULT '0',
  `equippos` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `playernpcs_field` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `world` int(11) NOT NULL,
  `map` int(11) NOT NULL,
  `step` tinyint(1) NOT NULL DEFAULT '0',
  `podium` smallint(8) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `plife` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `world` int(11) NOT NULL DEFAULT '-1',
  `map` int(11) NOT NULL DEFAULT '0',
  `life` int(11) NOT NULL DEFAULT '0',
  `type` varchar(1) NOT NULL DEFAULT 'n',
  `cy` int(11) NOT NULL DEFAULT '0',
  `f` int(11) NOT NULL DEFAULT '0',
  `fh` int(11) NOT NULL DEFAULT '0',
  `rx0` int(11) NOT NULL DEFAULT '0',
  `rx1` int(11) NOT NULL DEFAULT '0',
  `x` int(11) NOT NULL DEFAULT '0',
  `y` int(11) NOT NULL DEFAULT '0',
  `hide` int(11) NOT NULL DEFAULT '0',
  `mobtime` int(11) NOT NULL DEFAULT '0',
  `team` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `questactions` (
  `questactionid` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `questid` int(11) NOT NULL DEFAULT '0',
  `status` int(11) NOT NULL DEFAULT '0',
  `data` blob NOT NULL,
  PRIMARY KEY (`questactionid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `questprogress` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `characterid` int(11) NOT NULL,
  `queststatusid` int(10) unsigned NOT NULL DEFAULT '0',
  `progressid` int(11) NOT NULL DEFAULT '0',
  `progress` varchar(15) CHARACTER SET latin1 COLLATE latin1_german1_ci NOT NULL DEFAULT '',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `questrequirements` (
  `questrequirementid` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `questid` int(11) NOT NULL DEFAULT '0',
  `status` int(11) NOT NULL DEFAULT '0',
  `data` blob NOT NULL,
  PRIMARY KEY (`questrequirementid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `queststatus` (
  `queststatusid` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `characterid` int(11) NOT NULL DEFAULT '0',
  `quest` int(11) NOT NULL DEFAULT '0',
  `status` int(11) NOT NULL DEFAULT '0',
  `time` int(11) NOT NULL DEFAULT '0',
  `expires` bigint(20) NOT NULL DEFAULT '0',
  `forfeited` int(11) NOT NULL DEFAULT '0',
  `completed` int(11) NOT NULL DEFAULT '0',
  `info` tinyint(3) NOT NULL DEFAULT '0',
  PRIMARY KEY (`queststatusid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

# quickslot table, by Shavit
CREATE TABLE `quickslotkeymapped` (
  `accountid` INT NOT NULL,
  `keymap` BIGINT NOT NULL DEFAULT 0,
  PRIMARY KEY (`accountid`)
);

ALTER TABLE `quickslotkeymapped`
  ADD CONSTRAINT `quickslotkeymapped_accountid_fk` FOREIGN KEY (`accountid`) REFERENCES `accounts` (`id`) ON DELETE CASCADE;

CREATE TABLE IF NOT EXISTS `reactordrops` (
  `reactordropid` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `reactorid` int(11) NOT NULL,
  `itemid` int(11) NOT NULL,
  `chance` int(11) NOT NULL,
  `questid` int(5) NOT NULL DEFAULT '-1',
  PRIMARY KEY (`reactordropid`),
  KEY `reactorid` (`reactorid`)
) ENGINE=InnoDB  DEFAULT CHARSET=latin1 PACK_KEYS=1 AUTO_INCREMENT=841 ;

INSERT INTO `reactordrops` (`reactordropid`, `reactorid`, `itemid`, `chance`, `questid`) VALUES
(1, 2001, 4031161, 1, 1008),
(2, 2001, 4031162, 1, 1008),
(3, 2001, 2010009, 2, -1),
(4, 2001, 2010000, 4, -1),
(5, 2001, 2000000, 4, -1),
(6, 2001, 2000001, 7, -1),
(7, 2001, 2000002, 10, -1),
(8, 2001, 2000003, 15, -1),
(9, 1012000, 2000000, 6, -1),
(10, 1012000, 4000003, 6, -1),
(11, 1012000, 4031150, 3, -1),
(12, 1072000, 4031165, 4, -1),
(13, 1102000, 4000136, 1, -1),
(14, 1102001, 4000136, 1, -1),
(15, 1102002, 4000136, 1, -1),
(16, 2002000, 2000002, 4, -1),
(17, 2002000, 2000001, 2, -1),
(18, 2002000, 4031198, 2, 3043),
(19, 2112000, 2000004, 1, -1),
(20, 2112001, 2020001, 1, -1),
(21, 2112004, 4001016, 1, -1),
(22, 2112005, 4001015, 1, -1),
(23, 2112003, 2000005, 1, -1),
(24, 2112007, 2022001, 1, -1),
(25, 2112008, 2000004, 1, -1),
(26, 2112009, 2020001, 1, -1),
(27, 2112010, 2000005, 1, -1),
(28, 2112011, 4001016, 1, -1),
(29, 2112012, 4001015, 1, -1),
(30, 2112014, 4001018, 1, -1),
(31, 2112016, 4001113, 1, -1),
(32, 2112017, 4001114, 1, -1),
(33, 2202000, 4031094, 1, -1),
(34, 2212000, 4031142, 2, -1),
(35, 2212000, 2000002, 3, -1),
(36, 2212001, 2000002, 3, -1),
(37, 2212002, 2000002, 3, -1),
(38, 2212001, 4031141, 2, -1),
(39, 2212002, 4031143, 2, -1),
(40, 2212003, 4031107, 2, 3409),
(41, 2212004, 4031116, 2, 3419),
(42, 2212004, 2000001, 2, -1),
(43, 2212005, 4031136, 8, 3439),
(44, 2222000, 4031231, 2, 3620),
(45, 2222000, 4031258, 2, -1),
(46, 2222000, 2000002, 3, -1),
(47, 2302000, 2000001, 3, -1),
(48, 2302000, 2022040, 6, -1),
(49, 2302000, 4031274, 50, -1),
(50, 2302000, 4031275, 50, -1),
(51, 2302000, 4031276, 50, -1),
(52, 2302000, 4031277, 50, -1),
(53, 2302000, 4031278, 50, -1),
(54, 2302001, 2000002, 3, -1),
(55, 2302001, 2022040, 4, -1),
(56, 2302002, 2000001, 3, -1),
(57, 2302002, 2022040, 8, -1),
(58, 2302003, 4161017, 1, -1),
(59, 2302005, 4031508, 1, -1),
(60, 2502000, 2022116, 1, -1),
(61, 2052001, 2022116, 1, -1),
(62, 9202000, 1032033, 1, -1),
(63, 9202009, 1032033, 1, -1),
(64, 2202001, 4031092, 1, -1),
(65, 9202001, 4001025, 1, -1),
(66, 9202002, 4001037, 1, -1),
(67, 9202003, 4001029, 1, -1),
(68, 9202004, 4001030, 1, -1),
(69, 9202005, 4001031, 1, -1),
(70, 9202006, 4001032, 1, -1),
(71, 9202007, 4001033, 1, -1),
(72, 9202008, 4001034, 1, -1),
(73, 9202012, 2020014, 3, -1),
(74, 9202012, 2020015, 3, -1),
(75, 9202012, 2001001, 3, -1),
(76, 9202012, 2000004, 3, -1),
(77, 9202012, 2000005, 3, -1),
(78, 9202012, 2000001, 3, -1),
(79, 9202012, 2000002, 3, -1),
(80, 9202012, 2000006, 3, -1),
(81, 9202012, 2001002, 3, -1),
(82, 9202012, 2040504, 40, -1),
(83, 9202012, 2040501, 40, -1),
(84, 9202012, 2040513, 40, -1),
(85, 9202012, 2040516, 40, -1),
(86, 9202012, 2041007, 40, -1),
(87, 9202012, 2041010, 40, -1),
(88, 9202012, 2041004, 40, -1),
(89, 9202012, 2041001, 40, -1),
(90, 9202012, 2041019, 40, -1),
(91, 9202012, 2041022, 40, -1),
(92, 9202012, 2041013, 40, -1),
(93, 9202012, 2041016, 40, -1),
(94, 9202012, 2040301, 40, -1),
(95, 9202012, 2040704, 40, -1),
(96, 9202012, 2040707, 40, -1),
(97, 9202012, 2040701, 40, -1),
(98, 9202012, 2040804, 40, -1),
(99, 9202012, 2040801, 40, -1),
(100, 9202012, 2040004, 40, -1),
(101, 9202012, 2040001, 40, -1),
(102, 9202012, 2290009, 60, -1),
(103, 9202012, 2290031, 60, -1),
(104, 9202012, 2290039, 60, -1),
(105, 9202012, 2290033, 60, -1),
(106, 9202012, 2290045, 60, -1),
(107, 9202012, 2290081, 60, -1),
(108, 9202012, 2290083, 60, -1),
(109, 9202012, 2290087, 60, -1),
(110, 9202012, 2290060, 60, -1),
(111, 9202012, 2290073, 60, -1),
(112, 9202012, 2100000, 250, -1),
(113, 2612004, 4031703, 1, 3302),
(114, 1302000, 2010000, 30, -1),
(115, 1302000, 2010009, 30, -1),
(116, 1302000, 4032268, 1, 20013),
(117, 1302000, 4032267, 1, 20013),
(118, 1052000, 4031471, 1, 6153),
(119, 2112015, 2280000, 1, -1),
(120, 1022000, 4031452, 1, 6201),
(121, 2202003, 4001022, 1, -1),
(122, 2201001, 4001022, 1, -1),
(123, 1402000, 4032309, 1, 21013),
(124, 1402000, 4032310, 1, 21013),
(125, 1022001, 4032319, 7, 21723),
(126, 1022002, 4001340, 1, 28167),
(127, 1202000, 4001366, 1, 28194),
(128, 1202003, 4001346, 3, 28225),
(129, 1202004, 4001346, 3, 28225),
(130, 1032000, 4032362, 1, 28252),
(131, 1032000, 4032363, 1, 28252),
(132, 1202004, 4032494, 1, 28255),
(133, 1052001, 3010126, 100, -1),
(134, 1052002, 3010126, 100, -1),
(135, 1052001, 1072375, 3, -1),
(136, 1052001, 1072376, 3, -1),
(137, 1052001, 2049100, 3, -1),
(138, 1052001, 2049001, 3, -1),
(139, 1052001, 1382068, 3, -1),
(140, 1052001, 1402062, 3, -1),
(141, 1052001, 1442078, 3, -1),
(142, 1052001, 1452071, 3, -1),
(143, 1052001, 1472086, 3, -1),
(144, 1052001, 1492037, 3, -1),
(145, 1052001, 2040728, 3, -1),
(146, 1052001, 2040729, 3, -1),
(147, 1052001, 2040730, 3, -1),
(148, 1052001, 2040731, 3, -1),
(149, 1052001, 2040732, 3, -1),
(150, 1052001, 2040733, 3, -1),
(151, 1052001, 2040734, 3, -1),
(152, 1052001, 2040735, 3, -1),
(153, 1052001, 2040736, 3, -1),
(154, 1052001, 2040737, 3, -1),
(155, 1052001, 2040738, 3, -1),
(156, 1052001, 2040739, 3, -1),
(157, 1052001, 1302112, 3, -1),
(158, 1052001, 1302113, 3, -1),
(159, 1052001, 1312042, 3, -1),
(160, 1052001, 1312043, 3, -1),
(161, 1052001, 1322068, 3, -1),
(162, 1052001, 1322069, 3, -1),
(163, 1052001, 1332084, 3, -1),
(164, 1052001, 1332085, 3, -1),
(165, 1052001, 1332086, 3, -1),
(166, 1052001, 1332087, 3, -1),
(167, 1052001, 1342019, 3, -1),
(168, 1052001, 1342020, 3, -1),
(169, 1052001, 1372050, 3, -1),
(170, 1052001, 1372051, 3, -1),
(171, 1052001, 1382066, 3, -1),
(172, 1052001, 1382067, 3, -1),
(173, 1052001, 1402056, 3, -1),
(174, 1052001, 1402057, 3, -1),
(175, 1052001, 1402058, 3, -1),
(176, 1052001, 1402059, 3, -1),
(177, 1052001, 1412038, 3, -1),
(178, 1052001, 1412039, 3, -1),
(179, 1052001, 1422042, 3, -1),
(180, 1052001, 1422043, 3, -1),
(181, 1052002, 1072375, 5, -1),
(182, 1052002, 1072376, 5, -1),
(183, 1052002, 2040728, 5, -1),
(184, 1052002, 2040729, 5, -1),
(185, 1052002, 2040730, 5, -1),
(186, 1052002, 2040731, 5, -1),
(187, 1052002, 2040732, 5, -1),
(188, 1052002, 2040733, 5, -1),
(189, 1052002, 2040734, 5, -1),
(190, 1052002, 2040735, 5, -1),
(191, 1052002, 2040736, 5, -1),
(192, 1052002, 2040737, 5, -1),
(193, 1052002, 2040738, 5, -1),
(194, 1052002, 2040739, 5, -1),
(195, 1052002, 1302112, 5, -1),
(196, 1052002, 1302113, 5, -1),
(197, 1052002, 1312042, 5, -1),
(198, 1052002, 1312043, 5, -1),
(199, 1052002, 1322068, 5, -1),
(200, 1052002, 1322069, 5, -1),
(201, 1052002, 1332084, 5, -1),
(202, 1052002, 1332085, 5, -1),
(203, 1052002, 1332086, 5, -1),
(204, 1052002, 1332087, 5, -1),
(205, 1052002, 1342019, 5, -1),
(206, 1052002, 1342020, 5, -1),
(207, 1052002, 1372050, 5, -1),
(208, 1052002, 1372051, 5, -1),
(209, 1052002, 1382066, 5, -1),
(210, 1052002, 1382067, 5, -1),
(211, 1052002, 1402056, 5, -1),
(212, 1052002, 1402057, 5, -1),
(213, 1052002, 1402058, 5, -1),
(214, 1052002, 1402059, 5, -1),
(215, 1052002, 1412038, 5, -1),
(216, 1052002, 1412039, 5, -1),
(217, 1052002, 1422042, 5, -1),
(218, 1052002, 1422043, 5, -1),
(219, 1002008, 4032452, 1, 22502),
(220, 6102001, 4001260, 1, -1),
(221, 6102002, 1472051, 25, -1),
(222, 6102002, 1442056, 25, -1),
(223, 6102002, 1072228, 25, -1),
(224, 6102002, 1322062, 25, -1),
(225, 6102002, 1092061, 25, -1),
(226, 6102002, 1452019, 25, -1),
(227, 6102002, 1492012, 25, -1),
(228, 6102002, 1092050, 25, -1),
(229, 6102002, 1402005, 25, -1),
(230, 6102002, 1052131, 25, -1),
(231, 6102002, 1462016, 25, -1),
(232, 6102002, 1332051, 25, -1),
(233, 6102002, 1102043, 50, -1),
(234, 6102002, 1102206, 50, -1),
(235, 6102002, 1102260, 50, -1),
(236, 6102002, 3010010, 25, -1),
(237, 6102002, 4032015, 25, -1),
(238, 6102002, 4032016, 25, -1),
(239, 6102002, 4032017, 25, -1),
(240, 6102002, 4161018, 25, -1),
(241, 6102002, 4161021, 25, -1),
(242, 6102002, 4001107, 25, -1),
(243, 6102002, 4161015, 25, -1),
(244, 6102002, 4161016, 25, -1),
(245, 6102002, 2022121, 25, -1),
(246, 6102002, 2044803, 25, -1),
(247, 6102002, 2044903, 25, -1),
(248, 6102002, 2290071, 50, -1),
(249, 6102002, 2290027, 50, -1),
(250, 6102002, 2290111, 50, -1),
(251, 6102002, 2290118, 50, -1),
(252, 6102002, 2290103, 50, -1),
(253, 6102002, 2290047, 50, -1),
(254, 6102002, 2290091, 50, -1),
(255, 6102002, 2290053, 50, -1),
(256, 6102002, 2290061, 50, -1),
(257, 6102002, 2290011, 50, -1),
(258, 6102002, 2290089, 50, -1),
(259, 6102003, 1472051, 25, -1),
(260, 6102003, 1442056, 25, -1),
(261, 6102003, 1072228, 25, -1),
(262, 6102003, 1322062, 25, -1),
(263, 6102003, 1092061, 25, -1),
(264, 6102003, 1452019, 25, -1),
(265, 6102003, 1492012, 25, -1),
(266, 6102003, 1092050, 25, -1),
(267, 6102003, 1402005, 25, -1),
(268, 6102003, 1052131, 25, -1),
(269, 6102003, 1462016, 25, -1),
(270, 6102003, 1332051, 25, -1),
(271, 6102003, 1102043, 50, -1),
(272, 6102003, 1102206, 50, -1),
(273, 6102003, 1102260, 50, -1),
(274, 6102003, 3010010, 25, -1),
(275, 6102003, 4032015, 25, -1),
(276, 6102003, 4032016, 25, -1),
(277, 6102003, 4032017, 25, -1),
(278, 6102003, 4161018, 25, -1),
(279, 6102003, 4161021, 25, -1),
(280, 6102003, 4001107, 25, -1),
(281, 6102003, 4161015, 25, -1),
(282, 6102003, 4161016, 25, -1),
(283, 6102003, 2022121, 25, -1),
(284, 6102003, 2044803, 25, -1),
(285, 6102003, 2044903, 25, -1),
(286, 6102003, 2290071, 50, -1),
(287, 6102003, 2290027, 50, -1),
(288, 6102003, 2290111, 50, -1),
(289, 6102003, 2290118, 50, -1),
(290, 6102003, 2290103, 50, -1),
(291, 6102003, 2290047, 50, -1),
(292, 6102003, 2290091, 50, -1),
(293, 6102003, 2290053, 50, -1),
(294, 6102003, 2290061, 50, -1),
(295, 6102003, 2290011, 50, -1),
(296, 6102003, 2290089, 50, -1),
(297, 6102004, 1472051, 25, -1),
(298, 6102004, 1442056, 25, -1),
(299, 6102004, 1072228, 25, -1),
(300, 6102004, 1322062, 25, -1),
(301, 6102004, 1092061, 25, -1),
(302, 6102004, 1452019, 25, -1),
(303, 6102004, 1492012, 25, -1),
(304, 6102004, 1092050, 25, -1),
(305, 6102004, 1402005, 25, -1),
(306, 6102004, 1052131, 25, -1),
(307, 6102004, 1462016, 25, -1),
(308, 6102004, 1332051, 25, -1),
(309, 6102004, 1102043, 50, -1),
(310, 6102004, 1102206, 50, -1),
(311, 6102004, 1102260, 50, -1),
(312, 6102004, 3010010, 25, -1),
(313, 6102004, 4032015, 25, -1),
(314, 6102004, 4032016, 25, -1),
(315, 6102004, 4032017, 25, -1),
(316, 6102004, 4161018, 25, -1),
(317, 6102004, 4161021, 25, -1),
(318, 6102004, 4001107, 25, -1),
(319, 6102004, 4161015, 25, -1),
(320, 6102004, 4161016, 25, -1),
(321, 6102004, 2022121, 25, -1),
(322, 6102004, 2044803, 25, -1),
(323, 6102004, 2044903, 25, -1),
(324, 6102004, 2290071, 50, -1),
(325, 6102004, 2290027, 50, -1),
(326, 6102004, 2290111, 50, -1),
(327, 6102004, 2290118, 50, -1),
(328, 6102004, 2290103, 50, -1),
(329, 6102004, 2290047, 50, -1),
(330, 6102004, 2290091, 50, -1),
(331, 6102004, 2290053, 50, -1),
(332, 6102004, 2290061, 50, -1),
(333, 6102004, 2290011, 50, -1),
(334, 6102004, 2290089, 50, -1),
(335, 6102005, 1472051, 25, -1),
(336, 6102005, 1442056, 25, -1),
(337, 6102005, 1072228, 25, -1),
(338, 6102005, 1322062, 25, -1),
(339, 6102005, 1092061, 25, -1),
(340, 6102005, 1452019, 25, -1),
(341, 6102005, 1492012, 25, -1),
(342, 6102005, 1092050, 25, -1),
(343, 6102005, 1402005, 25, -1),
(344, 6102005, 1052131, 25, -1),
(345, 6102005, 1462016, 25, -1),
(346, 6102005, 1332051, 25, -1),
(347, 6102005, 1102043, 50, -1),
(348, 6102005, 1102206, 50, -1),
(349, 6102005, 1102260, 50, -1),
(350, 6102005, 3010010, 25, -1),
(351, 6102005, 4032015, 25, -1),
(352, 6102005, 4032016, 25, -1),
(353, 6102005, 4032017, 25, -1),
(354, 6102005, 4161018, 25, -1),
(355, 6102005, 4161021, 25, -1),
(356, 6102005, 4001107, 25, -1),
(357, 6102005, 4161015, 25, -1),
(358, 6102005, 4161016, 25, -1),
(359, 6102005, 2022121, 25, -1),
(360, 6102005, 2044803, 25, -1),
(361, 6102005, 2044903, 25, -1),
(362, 6102005, 2290071, 50, -1),
(363, 6102005, 2290027, 50, -1),
(364, 6102005, 2290111, 50, -1),
(365, 6102005, 2290118, 50, -1),
(366, 6102005, 2290103, 50, -1),
(367, 6102005, 2290047, 50, -1),
(368, 6102005, 2290091, 50, -1),
(369, 6102005, 2290053, 50, -1),
(370, 6102005, 2290061, 50, -1),
(371, 6102005, 2290011, 50, -1),
(372, 6102005, 2290089, 50, -1),
(373, 3002000, 4001162, 1, -1),
(374, 3002001, 4001163, 1, -1),
(375, 6702000, 4031595, 1, -1),
(376, 6702003, 1032043, 5, -1),
(377, 6702003, 1032044, 5, -1),
(378, 6702003, 1032045, 5, -1),
(379, 6702003, 1102099, 20, -1),
(380, 6702003, 1102100, 20, -1),
(381, 6702003, 1102101, 50, -1),
(382, 6702003, 1102102, 50, -1),
(383, 6702003, 1102103, 50, -1),
(384, 6702003, 1102104, 50, -1),
(385, 6702003, 1102105, 50, -1),
(386, 6702003, 1102106, 50, -1),
(387, 6702003, 4021007, 5, -1),
(388, 6702003, 4021008, 5, -1),
(389, 6702003, 4020007, 5, -1),
(390, 6702003, 4020007, 5, -1),
(391, 6702003, 4011006, 5, -1),
(392, 6702003, 2040759, 50, -1),
(393, 6702003, 2041035, 20, -1),
(394, 6702003, 2041037, 20, -1),
(395, 6702003, 2041039, 20, -1),
(396, 6702003, 2041041, 20, -1),
(397, 6702003, 2000005, 5, -1),
(398, 6702003, 2022179, 4, -1),
(399, 6702003, 2022180, 5, -1),
(400, 6702003, 2022181, 5, -1),
(401, 6702003, 2022182, 5, -1),
(402, 6702003, 2000005, 5, -1),
(403, 6702003, 2020010, 5, -1),
(404, 6702003, 2020013, 5, -1),
(405, 6702003, 3010011, 50, -1),
(406, 6702003, 3012000, 100, -1),
(407, 6702003, 3012005, 100, -1),
(408, 6702004, 1032043, 5, -1),
(409, 6702004, 1032044, 5, -1),
(410, 6702004, 1032045, 5, -1),
(411, 6702004, 1102099, 20, -1),
(412, 6702004, 1102100, 20, -1),
(413, 6702004, 1102101, 50, -1),
(414, 6702004, 1102102, 50, -1),
(415, 6702004, 1102103, 50, -1),
(416, 6702004, 1102104, 50, -1),
(417, 6702004, 1102105, 50, -1),
(418, 6702004, 1102106, 50, -1),
(419, 6702004, 4021007, 5, -1),
(420, 6702004, 4021008, 5, -1),
(421, 6702004, 4020007, 5, -1),
(422, 6702004, 4020007, 5, -1),
(423, 6702004, 4011006, 5, -1),
(424, 6702004, 2040759, 50, -1),
(425, 6702004, 2041035, 20, -1),
(426, 6702004, 2041037, 20, -1),
(427, 6702004, 2041039, 20, -1),
(428, 6702004, 2041041, 20, -1),
(429, 6702004, 2000005, 5, -1),
(430, 6702004, 2022179, 4, -1),
(431, 6702004, 2022180, 5, -1),
(432, 6702004, 2022181, 5, -1),
(433, 6702004, 2022182, 5, -1),
(434, 6702004, 2000005, 5, -1),
(435, 6702004, 2020010, 5, -1),
(436, 6702004, 2020013, 5, -1),
(437, 6702004, 3010011, 50, -1),
(438, 6702004, 3012000, 100, -1),
(439, 6702004, 3012005, 100, -1),
(440, 6702005, 1032043, 5, -1),
(441, 6702005, 1032044, 5, -1),
(442, 6702005, 1032045, 5, -1),
(443, 6702005, 1102099, 20, -1),
(444, 6702005, 1102100, 20, -1),
(445, 6702005, 1102101, 50, -1),
(446, 6702005, 1102102, 50, -1),
(447, 6702005, 1102103, 50, -1),
(448, 6702005, 1102104, 50, -1),
(449, 6702005, 1102105, 50, -1),
(450, 6702005, 1102106, 50, -1),
(451, 6702005, 4021007, 5, -1),
(452, 6702005, 4021008, 5, -1),
(453, 6702005, 4020007, 5, -1),
(454, 6702005, 4020007, 5, -1),
(455, 6702005, 4011006, 5, -1),
(456, 6702005, 2040759, 50, -1),
(457, 6702005, 2041035, 20, -1),
(458, 6702005, 2041037, 20, -1),
(459, 6702005, 2041039, 20, -1),
(460, 6702005, 2041041, 20, -1),
(461, 6702005, 2000005, 5, -1),
(462, 6702005, 2022179, 4, -1),
(463, 6702005, 2022180, 5, -1),
(464, 6702005, 2022181, 5, -1),
(465, 6702005, 2022182, 5, -1),
(466, 6702005, 2000005, 5, -1),
(467, 6702005, 2020010, 5, -1),
(468, 6702005, 2020013, 5, -1),
(469, 6702005, 3010011, 50, -1),
(470, 6702005, 3012000, 100, -1),
(471, 6702005, 3012005, 100, -1),
(472, 6702006, 1032043, 5, -1),
(473, 6702006, 1032044, 5, -1),
(474, 6702006, 1032045, 5, -1),
(475, 6702006, 1102099, 20, -1),
(476, 6702006, 1102100, 20, -1),
(477, 6702006, 1102101, 50, -1),
(478, 6702006, 1102102, 50, -1),
(479, 6702006, 1102103, 50, -1),
(480, 6702006, 1102104, 50, -1),
(481, 6702006, 1102105, 50, -1),
(482, 6702006, 1102106, 50, -1),
(483, 6702006, 4021007, 5, -1),
(484, 6702006, 4021008, 5, -1),
(485, 6702006, 4020007, 5, -1),
(486, 6702006, 4020007, 5, -1),
(487, 6702006, 4011006, 5, -1),
(488, 6702006, 2040759, 50, -1),
(489, 6702006, 2041035, 20, -1),
(490, 6702006, 2041037, 20, -1),
(491, 6702006, 2041039, 20, -1),
(492, 6702006, 2041041, 20, -1),
(493, 6702006, 2000005, 5, -1),
(494, 6702006, 2022179, 4, -1),
(495, 6702006, 2022180, 5, -1),
(496, 6702006, 2022181, 5, -1),
(497, 6702006, 2022182, 5, -1),
(498, 6702006, 2000005, 5, -1),
(499, 6702006, 2020010, 5, -1),
(500, 6702006, 2020013, 5, -1),
(501, 6702006, 3010011, 50, -1),
(502, 6702006, 3012000, 100, -1),
(503, 6702006, 3012005, 100, -1),
(504, 6702007, 1032043, 5, -1),
(505, 6702007, 1032044, 5, -1),
(506, 6702007, 1032045, 5, -1),
(507, 6702007, 1102099, 20, -1),
(508, 6702007, 1102100, 20, -1),
(509, 6702007, 1102101, 50, -1),
(510, 6702007, 1102102, 50, -1),
(511, 6702007, 1102103, 50, -1),
(512, 6702007, 1102104, 50, -1),
(513, 6702007, 1102105, 50, -1),
(514, 6702007, 1102106, 50, -1),
(515, 6702007, 4021007, 5, -1),
(516, 6702007, 4021008, 5, -1),
(517, 6702007, 4020007, 5, -1),
(518, 6702007, 4020007, 5, -1),
(519, 6702007, 4011006, 5, -1),
(520, 6702007, 2040759, 50, -1),
(521, 6702007, 2041035, 20, -1),
(522, 6702007, 2041037, 20, -1),
(523, 6702007, 2041039, 20, -1),
(524, 6702007, 2041041, 20, -1),
(525, 6702007, 2000005, 5, -1),
(526, 6702007, 2022179, 4, -1),
(527, 6702007, 2022180, 5, -1),
(528, 6702007, 2022181, 5, -1),
(529, 6702007, 2022182, 5, -1),
(530, 6702007, 2000005, 5, -1),
(531, 6702007, 2020010, 5, -1),
(532, 6702007, 2020013, 5, -1),
(533, 6702007, 3010011, 50, -1),
(534, 6702007, 3012000, 100, -1),
(535, 6702007, 3012005, 100, -1),
(536, 6702008, 1032043, 5, -1),
(537, 6702008, 1032044, 5, -1),
(538, 6702008, 1032045, 5, -1),
(539, 6702008, 1102099, 20, -1),
(540, 6702008, 1102100, 20, -1),
(541, 6702008, 1102101, 50, -1),
(542, 6702008, 1102102, 50, -1),
(543, 6702008, 1102103, 50, -1),
(544, 6702008, 1102104, 50, -1),
(545, 6702008, 1102105, 50, -1),
(546, 6702008, 1102106, 50, -1),
(547, 6702008, 4021007, 5, -1),
(548, 6702008, 4021008, 5, -1),
(549, 6702008, 4020007, 5, -1),
(550, 6702008, 4020007, 5, -1),
(551, 6702008, 4011006, 5, -1),
(552, 6702008, 2040759, 50, -1),
(553, 6702008, 2041035, 20, -1),
(554, 6702008, 2041037, 20, -1),
(555, 6702008, 2041039, 20, -1),
(556, 6702008, 2041041, 20, -1),
(557, 6702008, 2000005, 5, -1),
(558, 6702008, 2022179, 4, -1),
(559, 6702008, 2022180, 5, -1),
(560, 6702008, 2022181, 5, -1),
(561, 6702008, 2022182, 5, -1),
(562, 6702008, 2000005, 5, -1),
(563, 6702008, 2020010, 5, -1),
(564, 6702008, 2020013, 5, -1),
(565, 6702008, 3010011, 50, -1),
(566, 6702008, 3012000, 100, -1),
(567, 6702008, 3012005, 100, -1),
(568, 6702009, 1032043, 5, -1),
(569, 6702009, 1032044, 5, -1),
(570, 6702009, 1032045, 5, -1),
(571, 6702009, 1102099, 20, -1),
(572, 6702009, 1102100, 20, -1),
(573, 6702009, 1102101, 50, -1),
(574, 6702009, 1102102, 50, -1),
(575, 6702009, 1102103, 50, -1),
(576, 6702009, 1102104, 50, -1),
(577, 6702009, 1102105, 50, -1),
(578, 6702009, 1102106, 50, -1),
(579, 6702009, 4021007, 5, -1),
(580, 6702009, 4021008, 5, -1),
(581, 6702009, 4020007, 5, -1),
(582, 6702009, 4020007, 5, -1),
(583, 6702009, 4011006, 5, -1),
(584, 6702009, 2040759, 50, -1),
(585, 6702009, 2041035, 20, -1),
(586, 6702009, 2041037, 20, -1),
(587, 6702009, 2041039, 20, -1),
(588, 6702009, 2041041, 20, -1),
(589, 6702009, 2000005, 5, -1),
(590, 6702009, 2022179, 4, -1),
(591, 6702009, 2022180, 5, -1),
(592, 6702009, 2022181, 5, -1),
(593, 6702009, 2022182, 5, -1),
(594, 6702009, 2000005, 5, -1),
(595, 6702009, 2020010, 5, -1),
(596, 6702009, 2020013, 5, -1),
(597, 6702009, 3010011, 50, -1),
(598, 6702009, 3012000, 100, -1),
(599, 6702009, 3012005, 100, -1),
(600, 6702010, 1032043, 5, -1),
(601, 6702010, 1032044, 5, -1),
(602, 6702010, 1032045, 5, -1),
(603, 6702010, 1102099, 20, -1),
(604, 6702010, 1102100, 20, -1),
(605, 6702010, 1102101, 50, -1),
(606, 6702010, 1102102, 50, -1),
(607, 6702010, 1102103, 50, -1),
(608, 6702010, 1102104, 50, -1),
(609, 6702010, 1102105, 50, -1),
(610, 6702010, 1102106, 50, -1),
(611, 6702010, 4021007, 5, -1),
(612, 6702010, 4021008, 5, -1),
(613, 6702010, 4020007, 5, -1),
(614, 6702010, 4020007, 5, -1),
(615, 6702010, 4011006, 5, -1),
(616, 6702010, 2040759, 50, -1),
(617, 6702010, 2041035, 20, -1),
(618, 6702010, 2041037, 20, -1),
(619, 6702010, 2041039, 20, -1),
(620, 6702010, 2041041, 20, -1),
(621, 6702010, 2000005, 5, -1),
(622, 6702010, 2022179, 4, -1),
(623, 6702010, 2022180, 5, -1),
(624, 6702010, 2022181, 5, -1),
(625, 6702010, 2022182, 5, -1),
(626, 6702010, 2000005, 5, -1),
(627, 6702010, 2020010, 5, -1),
(628, 6702010, 2020013, 5, -1),
(629, 6702010, 3010011, 50, -1),
(630, 6702010, 3012000, 100, -1),
(631, 6702010, 3012005, 100, -1),
(632, 6702011, 1032043, 5, -1),
(633, 6702011, 1032044, 5, -1),
(634, 6702011, 1032045, 5, -1),
(635, 6702011, 1102099, 20, -1),
(636, 6702011, 1102100, 20, -1),
(637, 6702011, 1102101, 50, -1),
(638, 6702011, 1102102, 50, -1),
(639, 6702011, 1102103, 50, -1),
(640, 6702011, 1102104, 50, -1),
(641, 6702011, 1102105, 50, -1),
(642, 6702011, 1102106, 50, -1),
(643, 6702011, 4021007, 5, -1),
(644, 6702011, 4021008, 5, -1),
(645, 6702011, 4020007, 5, -1),
(646, 6702011, 4020007, 5, -1),
(647, 6702011, 4011006, 5, -1),
(648, 6702011, 2040759, 50, -1),
(649, 6702011, 2041035, 20, -1),
(650, 6702011, 2041037, 20, -1),
(651, 6702011, 2041039, 20, -1),
(652, 6702011, 2041041, 20, -1),
(653, 6702011, 2000005, 5, -1),
(654, 6702011, 2022179, 4, -1),
(655, 6702011, 2022180, 5, -1),
(656, 6702011, 2022181, 5, -1),
(657, 6702011, 2022182, 5, -1),
(658, 6702011, 2000005, 5, -1),
(659, 6702011, 2020010, 5, -1),
(660, 6702011, 2020013, 5, -1),
(661, 6702011, 3010011, 50, -1),
(662, 6702011, 3012000, 100, -1),
(663, 6702011, 3012005, 100, -1),
(664, 6702012, 1032043, 5, -1),
(665, 6702012, 1032044, 5, -1),
(666, 6702012, 1032045, 5, -1),
(667, 6702012, 1102099, 20, -1),
(668, 6702012, 1102100, 20, -1),
(669, 6702012, 1102101, 50, -1),
(670, 6702012, 1102102, 50, -1),
(671, 6702012, 1102103, 50, -1),
(672, 6702012, 1102104, 50, -1),
(673, 6702012, 1102105, 50, -1),
(674, 6702012, 1102106, 50, -1),
(675, 6702012, 4021007, 5, -1),
(676, 6702012, 4021008, 5, -1),
(677, 6702012, 4020007, 5, -1),
(678, 6702012, 4020007, 5, -1),
(679, 6702012, 4011006, 5, -1),
(680, 6702012, 2040759, 50, -1),
(681, 6702012, 2041035, 20, -1),
(682, 6702012, 2041037, 20, -1),
(683, 6702012, 2041039, 20, -1),
(684, 6702012, 2041041, 20, -1),
(685, 6702012, 2000005, 5, -1),
(686, 6702012, 2022179, 5, -1),
(687, 6702012, 2022180, 5, -1),
(688, 6702012, 2022181, 5, -1),
(689, 6702012, 2022182, 5, -1),
(690, 6702012, 2000005, 5, -1),
(691, 6702012, 2020010, 5, -1),
(692, 6702012, 2020013, 5, -1),
(693, 6702012, 3010011, 50, -1),
(694, 6702012, 3012000, 100, -1),
(695, 6702012, 3012005, 100, -1),
(696, 1032000, 4001363, 1, 28252),
(697, 1032000, 4001362, 1, 28252),
(698, 2512000, 2022131, 1, -1),
(699, 2512000, 2022132, 1, -1),
(700, 2612002, 4001134, 1, -1),
(701, 2612001, 4001135, 1, -1),
(754, 200002, 4010001, 1, -1),
(753, 200001, 4020001, 1, -1),
(714, 2002001, 4001063, 1, -1),
(715, 2002002, 4001052, 1, -1),
(716, 2002003, 4001055, 1, -1),
(717, 2002004, 4001056, 1, -1),
(718, 2002005, 4001057, 1, -1),
(719, 2002006, 4001058, 1, -1),
(720, 2002007, 4001059, 1, -1),
(721, 2002008, 4001060, 1, -1),
(722, 2002009, 4001061, 1, -1),
(723, 2002010, 4001062, 1, -1),
(724, 2002011, 4001046, 1, -1),
(725, 2002012, 4001047, 1, -1),
(726, 2002013, 4001049, 1, -1),
(727, 2002017, 4001158, 1, -1),
(728, 2002018, 4001158, 1, -1),
(729, 3102000, 4000276, 1, -1),
(730, 6102002, 1382060, 50, -1),
(731, 6102003, 1382060, 50, -1),
(732, 6102004, 1382060, 50, -1),
(733, 6102005, 1382060, 50, -1),
(734, 6102002, 1442068, 50, -1),
(735, 6102003, 1442068, 50, -1),
(736, 6102004, 1442068, 50, -1),
(737, 6102005, 1442068, 50, -1),
(738, 6102002, 1452060, 50, -1),
(739, 6102003, 1452060, 50, -1),
(740, 6102004, 1452060, 50, -1),
(741, 6102005, 1452060, 50, -1),
(742, 3102000, 2022712, 1, -1),
(743, 2502002, 2022252, 1, -1),
(744, 1202002, 4031843, 1, 2169),
(752, 200001, 4010005, 1, -1),
(751, 200000, 4020004, 1, -1),
(750, 200000, 4010004, 1, -1),
(755, 200002, 4020005, 1, -1),
(756, 200003, 4010000, 1, -1),
(757, 200003, 4010003, 1, -1),
(758, 200004, 4004002, 1, -1),
(759, 200004, 4010002, 1, -1),
(760, 200004, 4020003, 1, -1),
(761, 200005, 4010006, 1, -1),
(762, 200005, 4020006, 1, -1),
(763, 200006, 4020002, 1, -1),
(764, 200006, 4020007, 1, -1),
(765, 200007, 4004000, 1, -1),
(766, 200007, 4020000, 1, -1),
(767, 200008, 4004004, 1, -1),
(768, 200008, 4020008, 1, -1),
(769, 200009, 4004001, 1, -1),
(770, 200009, 4004003, 1, -1),
(771, 200009, 4010008, 1, -1),
(772, 200010, 4010008, 1, -1),
(773, 200000, 4010010, 1, -1),
(774, 200001, 4010010, 1, -1),
(775, 200002, 4010010, 1, -1),
(776, 200003, 4010010, 1, -1),
(777, 200004, 4010010, 1, -1),
(778, 200005, 4010010, 1, -1),
(779, 200006, 4010010, 1, -1),
(780, 200007, 4010010, 1, -1),
(781, 200008, 4010010, 1, -1),
(782, 200009, 4010010, 1, -1),
(783, 200011, 4010010, 1, -1),
(784, 200011, 4010010, 1, -1),
(785, 200011, 4010010, 1, -1),
(786, 200011, 4010010, 1, -1),
(787, 200011, 4010010, 1, -1),
(788, 200011, 4010010, 1, -1),
(789, 200011, 4010010, 1, -1),
(790, 200011, 4010010, 1, -1),
(791, 200011, 4010010, 1, -1),
(792, 200011, 4010010, 1, -1),
(793, 100000, 4022023, 1, -1),
(794, 100001, 4022023, 1, -1),
(795, 100002, 4022023, 1, -1),
(796, 100003, 4022023, 1, -1),
(797, 100004, 4022023, 1, -1),
(798, 100005, 4022023, 1, -1),
(799, 100006, 4022023, 1, -1),
(800, 100007, 4022023, 1, -1),
(801, 100008, 4022023, 1, -1),
(802, 100009, 4022023, 1, -1),
(803, 100011, 4022023, 1, -1),
(804, 100011, 4022023, 1, -1),
(805, 100011, 4022023, 1, -1),
(806, 100011, 4022023, 1, -1),
(807, 100011, 4022023, 1, -1),
(808, 100011, 4022023, 1, -1),
(809, 100011, 4022023, 1, -1),
(810, 100011, 4022023, 1, -1),
(811, 100011, 4022023, 1, -1),
(812, 100011, 4022023, 1, -1),
(813, 100000, 4022000, 1, -1),
(814, 100000, 4022001, 1, -1),
(815, 100001, 4022002, 1, -1),
(816, 100001, 4022003, 1, -1),
(817, 100002, 4022004, 1, -1),
(818, 100002, 4022005, 1, -1),
(819, 100003, 4022006, 1, -1),
(820, 100003, 4022007, 1, -1),
(821, 100004, 4022008, 1, -1),
(822, 100004, 4022009, 1, -1),
(823, 100005, 4022010, 1, -1),
(824, 100005, 4022011, 1, -1),
(825, 100006, 4022012, 1, -1),
(826, 100006, 4022013, 1, -1),
(827, 100007, 4022014, 1, -1),
(828, 100007, 4022015, 1, -1),
(829, 100008, 4022016, 1, -1),
(830, 100008, 4022017, 1, -1),
(831, 100009, 4022018, 1, -1),
(832, 100009, 4022019, 1, -1),
(833, 100009, 4022020, 1, -1),
(834, 100009, 4022021, 1, -1),
(835, 100010, 4022022, 1, -1),
(836, 1002009, 4031161, 1, 1008),
(837, 1002009, 4031162, 1, 1008),
(838, 1209001, 4032980, 1, 2565),
(839, 1052001, 1532022, 3, -1),
(840, 1052001, 1532023, 3, -1),
(841, 2092001, 1472063, 3, -1);

CREATE TABLE IF NOT EXISTS `reports` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `reporttime` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `reporterid` int(11) NOT NULL,
  `victimid` int(11) NOT NULL,
  `reason` tinyint(4) NOT NULL,
  `chatlog` text NOT NULL,
  `description` text NOT NULL,  # correct field name, thanks resinate
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `responses` (
  `chat` text,
  `response` text,
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `rings` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `partnerRingId` int(11) NOT NULL DEFAULT '0',
  `partnerChrId` int(11) NOT NULL DEFAULT '0',
  `itemid` int(11) NOT NULL DEFAULT '0',
  `partnername` varchar(255) NOT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `savedlocations` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `characterid` int(11) NOT NULL,
  `locationtype` enum('FREE_MARKET','WORLDTOUR','FLORINA','INTRO','SUNDAY_MARKET','MIRROR','EVENT','BOSSPQ','HAPPYVILLE','DEVELOPER','MONSTER_CARNIVAL') NOT NULL,
  `map` int(11) NOT NULL,
  `portal` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `server_queue` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `accountid` int(11) NOT NULL DEFAULT '0',
  `characterid` int(11) NOT NULL DEFAULT '0',
  `type` tinyint(2) NOT NULL DEFAULT '0',
  `value` int(10) NOT NULL DEFAULT '0',
  `message` varchar(128) NOT NULL,
  `createTime` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `shopitems` (
  `shopitemid` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `shopid` int(10) unsigned NOT NULL,
  `itemid` int(11) NOT NULL,
  `price` int(11) NOT NULL,
  `pitch` int(11) NOT NULL DEFAULT '0',
  `position` int(11) NOT NULL COMMENT 'sort is an arbitrary field designed to give leeway when modifying shops. The lowest number is 104 and it increments by 4 for each item to allow decent space for swapping/inserting/removing items.',
  PRIMARY KEY (`shopitemid`)
) ENGINE=InnoDB  DEFAULT CHARSET=latin1 AUTO_INCREMENT=20047 ;

INSERT INTO `shopitems` (`shopitemid`, `shopid`, `itemid`, `price`, `pitch`, `position`) VALUES
(1, 11000, 1332005, 500, 0, 104),
(2, 11000, 1322005, 50, 0, 108),
(3, 11000, 1312004, 50, 0, 112),
(4, 11000, 1302000, 50, 0, 116),
(5, 11100, 2010002, 50, 0, 104),
(6, 11100, 2010000, 30, 0, 108),
(7, 11100, 2000002, 320, 0, 112),
(8, 11100, 2000001, 160, 0, 116),
(9, 11100, 2000000, 50, 0, 120),
(10, 21000, 1072005, 50, 0, 104),
(11, 21000, 1072001, 50, 0, 108),
(12, 21000, 1061008, 50, 0, 112),
(13, 21000, 1061002, 50, 0, 116),
(14, 21000, 1060006, 50, 0, 120),
(15, 21000, 1060002, 50, 0, 124),
(16, 21000, 1041011, 50, 0, 128),
(17, 21000, 1041010, 50, 0, 132),
(18, 21000, 1041006, 50, 0, 136),
(19, 21000, 1041002, 50, 0, 140),
(20, 21000, 1040010, 50, 0, 144),
(21, 21000, 1040006, 50, 0, 148),
(22, 21000, 1040002, 50, 0, 152),
(23, 1001000, 1332007, 1000, 0, 104),
(24, 1001000, 1312000, 3000, 0, 108),
(25, 1001000, 1302007, 3000, 0, 112),
(26, 1001000, 1322005, 50, 0, 116),
(27, 1001000, 1312004, 50, 0, 120),
(28, 1001000, 1302000, 50, 0, 124),
(29, 1001001, 3010001, 1000, 0, 104),
(30, 1001001, 1092003, 2000, 0, 108),
(31, 1001001, 1072063, 10000, 0, 112),
(32, 1001001, 1072062, 10000, 0, 116),
(33, 1001001, 1072017, 10000, 0, 120),
(34, 1001001, 1072049, 5000, 0, 124),
(35, 1001001, 1072048, 5000, 0, 128),
(36, 1001001, 1072008, 5000, 0, 132),
(37, 1001001, 1072005, 50, 0, 136),
(38, 1001001, 1072038, 50, 0, 140),
(39, 1001001, 1072037, 50, 0, 144),
(40, 1001001, 1072001, 50, 0, 148),
(41, 1001001, 1062001, 4800, 0, 152),
(42, 1001001, 1062000, 4800, 0, 156),
(43, 1001001, 1060004, 2800, 0, 160),
(44, 1001001, 1060007, 1000, 0, 164),
(45, 1001001, 1041012, 3000, 0, 168),
(46, 1001001, 1041004, 3000, 0, 172),
(47, 1001001, 1040014, 3000, 0, 176),
(48, 1001001, 1040013, 3000, 0, 180),
(49, 1001001, 1002001, 3000, 0, 184),
(50, 1001001, 1002019, 2000, 0, 188),
(51, 1001001, 1002134, 800, 0, 192),
(52, 1001001, 1002133, 800, 0, 196),
(53, 1001001, 1002132, 800, 0, 200),
(54, 1001001, 1002069, 450, 0, 204),
(55, 1001001, 1002068, 450, 0, 208),
(56, 1001001, 1002067, 450, 0, 212),
(57, 1001001, 1002066, 450, 0, 216),
(58, 1001001, 1002014, 1000, 0, 220),
(59, 1001001, 1002008, 500, 0, 224),
(60, 1001100, 2330000, 600, 0, 104),
(61, 1001100, 2070000, 500, 0, 108),
(64, 1001100, 2061000, 1, 0, 120),
(65, 1001100, 2060000, 1, 0, 124),
(66, 1001100, 2030001, 500, 0, 128),
(67, 1001100, 2030000, 400, 0, 132),
(68, 1001100, 2020028, 3000, 0, 136),
(69, 1001100, 2010004, 310, 0, 140),
(70, 1001100, 2010003, 100, 0, 144),
(71, 1001100, 2010001, 106, 0, 148),
(72, 1001100, 2010002, 50, 0, 152),
(73, 1001100, 2010000, 30, 0, 156),
(74, 1001100, 2002005, 500, 0, 160),
(75, 1001100, 2002004, 500, 0, 164),
(76, 1001100, 2002002, 500, 0, 168),
(77, 1001100, 2002001, 400, 0, 172),
(78, 1001100, 2002000, 500, 0, 176),
(79, 1001100, 2000006, 620, 0, 180),
(80, 1001100, 2000003, 200, 0, 184),
(81, 1001100, 2000002, 320, 0, 188),
(82, 1001100, 2000001, 160, 0, 192),
(83, 1001100, 2000000, 50, 0, 196),
(84, 1011000, 1442004, 24000, 0, 104),
(85, 1011000, 1422004, 20000, 0, 108),
(86, 1011000, 1322008, 12000, 0, 112),
(87, 1011000, 1322007, 6000, 0, 116),
(88, 1011000, 1302007, 3000, 0, 120),
(89, 1011000, 1462000, 30000, 0, 124),
(90, 1011000, 1462003, 12000, 0, 128),
(91, 1011000, 1462002, 8000, 0, 132),
(92, 1011000, 1462001, 4000, 0, 136),
(93, 1011000, 1452000, 20000, 0, 140),
(94, 1011000, 1452001, 10000, 0, 144),
(95, 1011000, 1452003, 6000, 0, 148),
(96, 1011000, 1452002, 3000, 0, 152),
(97, 1011001, 1072064, 30000, 0, 104),
(98, 1011001, 1072018, 30000, 0, 108),
(99, 1011001, 1072056, 15000, 0, 112),
(100, 1011001, 1072055, 15000, 0, 116),
(101, 1011001, 1072054, 15000, 0, 120),
(102, 1011001, 1072012, 15000, 0, 124),
(103, 1011001, 1072068, 9000, 0, 128),
(104, 1011001, 1072067, 9000, 0, 132),
(105, 1011001, 1072026, 9000, 0, 136),
(106, 1011001, 1072025, 9000, 0, 140),
(107, 1011001, 1072061, 4500, 0, 144),
(108, 1011001, 1072060, 4500, 0, 148),
(109, 1011001, 1072016, 4500, 0, 152),
(110, 1011001, 1072059, 1800, 0, 156),
(111, 1011001, 1072015, 1800, 0, 160),
(112, 1011001, 1062006, 13000, 0, 164),
(113, 1011001, 1062002, 9000, 0, 168),
(114, 1011001, 1062004, 3000, 0, 172),
(115, 1011001, 1061052, 44000, 0, 176),
(116, 1011001, 1061051, 44000, 0, 180),
(117, 1011001, 1061050, 44000, 0, 184),
(118, 1011001, 1061026, 9000, 0, 188),
(119, 1011001, 1061025, 9000, 0, 192),
(120, 1011001, 1061024, 9000, 0, 196),
(121, 1011001, 1061059, 5000, 0, 200),
(122, 1011001, 1061058, 5000, 0, 204),
(123, 1011001, 1061006, 5000, 0, 208),
(124, 1011001, 1061057, 3000, 0, 212),
(125, 1011001, 1061009, 3000, 0, 216),
(126, 1011001, 1060059, 44000, 0, 220),
(127, 1011001, 1060058, 44000, 0, 224),
(128, 1011001, 1060057, 44000, 0, 228),
(129, 1011001, 1060056, 44000, 0, 232),
(130, 1011001, 1060005, 14000, 0, 236),
(131, 1011001, 1041056, 50000, 0, 240),
(132, 1011001, 1041055, 50000, 0, 244),
(133, 1011001, 1041054, 50000, 0, 248),
(134, 1011001, 1041035, 15000, 0, 252),
(135, 1011001, 1041034, 15000, 0, 256),
(136, 1011001, 1041033, 15000, 0, 260),
(137, 1011001, 1041032, 15000, 0, 264),
(138, 1011001, 1041028, 9000, 0, 268),
(139, 1011001, 1041027, 9000, 0, 272),
(140, 1011001, 1041013, 9000, 0, 276),
(141, 1011001, 1041063, 5500, 0, 280),
(142, 1011001, 1041062, 5500, 0, 284),
(143, 1011001, 1041008, 5500, 0, 288),
(144, 1011001, 1041061, 3200, 0, 292),
(145, 1011001, 1041007, 3200, 0, 296),
(146, 1011001, 1040070, 50000, 0, 300),
(147, 1011001, 1040069, 50000, 0, 304),
(148, 1011001, 1040068, 50000, 0, 308),
(149, 1011001, 1040067, 50000, 0, 312),
(150, 1011001, 1040025, 15000, 0, 316),
(151, 1011001, 1040024, 15000, 0, 320),
(152, 1011001, 1040023, 15000, 0, 324),
(153, 1011001, 1040022, 15000, 0, 328),
(154, 1011001, 1040003, 9000, 0, 332),
(155, 1011001, 1040011, 5500, 0, 336),
(156, 1011001, 1040007, 5500, 0, 340),
(157, 1011001, 1040071, 3200, 0, 344),
(158, 1011001, 1040008, 3200, 0, 348),
(159, 1011001, 1032003, 7000, 0, 352),
(160, 1011001, 1032001, 7000, 0, 356),
(161, 1011001, 1002165, 30000, 0, 360),
(162, 1011001, 1002164, 30000, 0, 364),
(163, 1011001, 1002163, 30000, 0, 368),
(164, 1011001, 1002162, 30000, 0, 372),
(165, 1011001, 1002161, 30000, 0, 376),
(166, 1011001, 1002160, 20000, 0, 380),
(167, 1011001, 1002159, 20000, 0, 384),
(168, 1011001, 1002158, 20000, 0, 388),
(169, 1011001, 1002157, 20000, 0, 392),
(170, 1011001, 1002156, 20000, 0, 396),
(171, 1011001, 1002057, 800, 0, 400),
(172, 1011001, 1002010, 800, 0, 404),
(173, 1011001, 1002121, 12000, 0, 408),
(174, 1011001, 1002120, 12000, 0, 412),
(175, 1011001, 1002119, 12000, 0, 416),
(176, 1011001, 1002118, 12000, 0, 420),
(177, 1011001, 1002117, 12000, 0, 424),
(178, 1011001, 1002116, 4000, 0, 428),
(179, 1011001, 1002115, 4000, 0, 432),
(180, 1011001, 1002114, 4000, 0, 436),
(181, 1011001, 1002113, 4000, 0, 440),
(182, 1011001, 1002112, 4000, 0, 444),
(183, 1011001, 1002063, 3000, 0, 448),
(184, 1011001, 1002062, 3000, 0, 452),
(185, 1011001, 1002061, 3000, 0, 456),
(186, 1011001, 1002060, 3000, 0, 460),
(187, 1011001, 1002012, 3000, 0, 464),
(188, 1011001, 1002033, 3000, 0, 468),
(189, 1011001, 1002008, 500, 0, 472),
(190, 1011100, 2330000, 600, 0, 104),
(191, 1011100, 2070000, 500, 0, 108),
(192, 1011100, 2050002, 300, 0, 112),
(193, 1011100, 2050001, 200, 0, 116),
(194, 1011100, 2050000, 200, 0, 120),
(197, 1011100, 2061000, 1, 0, 132),
(198, 1011100, 2060000, 1, 0, 136),
(199, 1011100, 2030004, 500, 0, 140),
(200, 1011100, 2030000, 400, 0, 144),
(201, 1011100, 2020028, 3000, 0, 148),
(202, 1011100, 2010004, 310, 0, 152),
(203, 1011100, 2010003, 100, 0, 156),
(204, 1011100, 2010001, 106, 0, 160),
(205, 1011100, 2010002, 50, 0, 164),
(206, 1011100, 2010000, 30, 0, 168),
(207, 1011100, 2002005, 500, 0, 172),
(208, 1011100, 2002004, 500, 0, 176),
(209, 1011100, 2002002, 500, 0, 180),
(210, 1011100, 2002001, 400, 0, 184),
(211, 1011100, 2002000, 500, 0, 188),
(212, 1011100, 2000006, 620, 0, 192),
(213, 1011100, 2000003, 200, 0, 196),
(214, 1011100, 2000002, 320, 0, 200),
(215, 1011100, 2000001, 160, 0, 204),
(216, 1011100, 2000000, 50, 0, 208),
(217, 1012004, 4160019, 1000, 0, 104),
(218, 1012004, 4160039, 1000, 0, 108),
(219, 1012004, 4160037, 1000, 0, 112),
(220, 1012004, 4031993, 100000, 0, 116),
(221, 1012004, 4160036, 1000, 0, 120),
(222, 1012004, 4160035, 1000, 0, 124),
(223, 1012004, 4160034, 1000, 0, 128),
(224, 1012004, 4160032, 1000, 0, 132),
(225, 1012004, 4160024, 1000, 0, 136),
(226, 1012004, 4160023, 1000, 0, 140),
(227, 1012004, 4160022, 1000, 0, 144),
(228, 1012004, 4160015, 1000, 0, 148),
(229, 1012004, 4160012, 1000, 0, 152),
(230, 1012004, 4160013, 1000, 0, 156),
(231, 1012004, 4160017, 1000, 0, 160),
(232, 1012004, 4160014, 1000, 0, 164),
(233, 1012004, 4160020, 1000, 0, 168),
(234, 1012004, 4160010, 1000, 0, 172),
(235, 1012004, 4160009, 1000, 0, 176),
(236, 1012004, 4160008, 1000, 0, 180),
(237, 1012004, 4160007, 1000, 0, 184),
(238, 1012004, 4160006, 1000, 0, 188),
(239, 1012004, 4160005, 1000, 0, 192),
(240, 1012004, 4160004, 1000, 0, 196),
(241, 1012004, 4160003, 1000, 0, 200),
(242, 1012004, 4160002, 1000, 0, 204),
(243, 1012004, 4160001, 1000, 0, 208),
(244, 1012004, 4160000, 1000, 0, 212),
(245, 1012004, 4160026, 1000, 0, 216),
(246, 1012004, 2260000, 1000, 0, 220),
(247, 1012004, 2120000, 30, 0, 224),
(248, 1021000, 1442004, 24000, 0, 104),
(249, 1021000, 1442007, 12000, 0, 108),
(250, 1021000, 1442006, 8000, 0, 112),
(251, 1021000, 1442000, 3000, 0, 116),
(252, 1021000, 1432001, 7000, 0, 120),
(253, 1021000, 1432000, 3000, 0, 124),
(254, 1021000, 1422004, 20000, 0, 128),
(255, 1021000, 1422006, 10000, 0, 132),
(256, 1021000, 1422003, 10000, 0, 136),
(257, 1021000, 1422002, 6000, 0, 140),
(258, 1021000, 1422000, 3000, 0, 144),
(259, 1021000, 1412006, 45000, 0, 148),
(260, 1021000, 1412000, 22000, 0, 152),
(261, 1021000, 1412002, 10000, 0, 156),
(262, 1021000, 1412001, 3000, 0, 160),
(263, 1021000, 1402008, 22000, 0, 164),
(264, 1021000, 1402000, 12000, 0, 168),
(265, 1021000, 1402001, 3000, 0, 172),
(266, 1021000, 1322014, 40000, 0, 176),
(267, 1021000, 1322004, 22000, 0, 180),
(268, 1021000, 1322002, 10000, 0, 184),
(269, 1021000, 1322000, 6000, 0, 188),
(270, 1021000, 1312005, 40000, 0, 192),
(271, 1021000, 1312003, 20000, 0, 196),
(272, 1021000, 1312001, 6000, 0, 200),
(273, 1021000, 1332010, 22000, 0, 204),
(274, 1021000, 1332008, 10000, 0, 208),
(275, 1021000, 1332006, 7000, 0, 212),
(276, 1021000, 1302008, 40000, 0, 216),
(277, 1021000, 1302003, 20000, 0, 220),
(278, 1021000, 1302006, 10000, 0, 224),
(279, 1021000, 1302002, 10000, 0, 228),
(280, 1021000, 1302005, 6000, 0, 232),
(281, 1021000, 1302007, 3000, 0, 236),
(282, 1021001, 1092000, 6000, 0, 104),
(283, 1021001, 1092005, 4000, 0, 108),
(284, 1021001, 1072011, 15000, 0, 112),
(285, 1021001, 1072047, 10000, 0, 116),
(286, 1021001, 1072046, 10000, 0, 120),
(287, 1021001, 1072007, 10000, 0, 124),
(288, 1021001, 1072050, 5000, 0, 128),
(289, 1021001, 1072009, 5000, 0, 132),
(290, 1021001, 1061020, 14000, 0, 136),
(291, 1021001, 1061019, 14000, 0, 140),
(292, 1021001, 1061015, 14000, 0, 144),
(293, 1021001, 1061018, 9000, 0, 148),
(294, 1021001, 1061017, 9000, 0, 152),
(295, 1021001, 1061016, 9000, 0, 156),
(296, 1021001, 1061023, 3000, 0, 160),
(297, 1021001, 1061014, 3000, 0, 164),
(298, 1021001, 1060019, 38000, 0, 168),
(299, 1021001, 1060018, 38000, 0, 172),
(300, 1021001, 1060017, 38000, 0, 176),
(301, 1021001, 1060016, 38000, 0, 180),
(302, 1021001, 1060060, 14000, 0, 184),
(303, 1021001, 1060030, 14000, 0, 188),
(304, 1021001, 1060011, 14000, 0, 192),
(305, 1021001, 1060029, 9000, 0, 196),
(306, 1021001, 1060010, 9000, 0, 200),
(307, 1021001, 1060027, 5000, 0, 204),
(308, 1021001, 1060009, 5000, 0, 208),
(309, 1021001, 1060028, 3000, 0, 212),
(310, 1021001, 1060008, 3000, 0, 216),
(311, 1021001, 1051013, 60000, 0, 220),
(312, 1021001, 1051012, 60000, 0, 224),
(313, 1021001, 1051011, 60000, 0, 228),
(314, 1021001, 1051010, 60000, 0, 232),
(315, 1021001, 1051000, 8000, 0, 236),
(316, 1021001, 1050011, 70000, 0, 240),
(317, 1021001, 1050007, 15000, 0, 244),
(318, 1021001, 1050006, 15000, 0, 248),
(319, 1021001, 1050005, 15000, 0, 252),
(320, 1021001, 1041024, 16000, 0, 256),
(321, 1021001, 1041023, 16000, 0, 260),
(322, 1021001, 1041022, 16000, 0, 264),
(323, 1021001, 1041021, 9000, 0, 268),
(324, 1021001, 1041020, 9000, 0, 272),
(325, 1021001, 1041019, 9000, 0, 276),
(326, 1021001, 1041064, 3200, 0, 280),
(327, 1021001, 1041014, 3200, 0, 284),
(328, 1021001, 1040026, 40000, 0, 288),
(329, 1021001, 1040021, 40000, 0, 292),
(330, 1021001, 1040041, 16000, 0, 296),
(331, 1021001, 1040016, 16000, 0, 300),
(332, 1021001, 1040040, 16000, 0, 304),
(333, 1021001, 1040039, 9000, 0, 308),
(334, 1021001, 1040012, 9000, 0, 312),
(335, 1021001, 1040037, 5500, 0, 316),
(336, 1021001, 1040009, 5500, 0, 320),
(337, 1021001, 1040038, 3200, 0, 324),
(338, 1021001, 1040015, 3200, 0, 328),
(339, 1021001, 1002005, 19000, 0, 332),
(340, 1021001, 1002027, 11500, 0, 336),
(341, 1021001, 1002059, 8500, 0, 340),
(342, 1021001, 1002055, 8700, 0, 344),
(343, 1021001, 1002051, 3500, 0, 348),
(344, 1021001, 1002039, 2700, 0, 352),
(345, 1021001, 1002043, 2400, 0, 356),
(346, 1021100, 2330000, 600, 0, 104),
(347, 1021100, 2070000, 500, 0, 108),
(348, 1021100, 2050002, 300, 0, 112),
(349, 1021100, 2050001, 200, 0, 116),
(350, 1021100, 2050000, 200, 0, 120),
(353, 1021100, 2061000, 1, 0, 132),
(354, 1021100, 2060000, 1, 0, 136),
(355, 1021100, 2030003, 500, 0, 140),
(356, 1021100, 2030000, 400, 0, 144),
(357, 1021100, 2010004, 310, 0, 148),
(358, 1021100, 2010003, 100, 0, 152),
(359, 1021100, 2010001, 106, 0, 156),
(360, 1021100, 2010002, 50, 0, 160),
(361, 1021100, 2010000, 30, 0, 164),
(362, 1021100, 2002005, 500, 0, 168),
(363, 1021100, 2002004, 500, 0, 172),
(364, 1021100, 2002002, 500, 0, 176),
(365, 1021100, 2002001, 400, 0, 180),
(366, 1021100, 2002000, 500, 0, 184),
(367, 1021100, 2000006, 620, 0, 188),
(368, 1021100, 2000003, 200, 0, 192),
(369, 1021100, 2000002, 320, 0, 196),
(370, 1021100, 2000001, 160, 0, 200),
(371, 1021100, 2000000, 50, 0, 204),
(372, 1031000, 1322002, 10000, 0, 104),
(373, 1031000, 1382002, 20000, 0, 108),
(374, 1031000, 1382004, 10000, 0, 112),
(375, 1031000, 1382005, 6000, 0, 116),
(376, 1031000, 1382003, 6000, 0, 120),
(377, 1031000, 1382000, 3000, 0, 124),
(378, 1031000, 1372003, 38000, 0, 128),
(379, 1031000, 1372004, 18000, 0, 132),
(380, 1031000, 1372002, 9000, 0, 136),
(381, 1031000, 1372006, 5000, 0, 140),
(382, 1031000, 1372005, 2000, 0, 144),
(383, 1031001, 1072024, 4000, 0, 104),
(384, 1031001, 1072023, 4000, 0, 108),
(385, 1031001, 1072045, 1500, 0, 112),
(386, 1031001, 1072044, 1500, 0, 116),
(387, 1031001, 1072006, 1500, 0, 120),
(388, 1031001, 1061036, 40000, 0, 124),
(389, 1031001, 1061035, 40000, 0, 128),
(390, 1031001, 1061034, 40000, 0, 132),
(391, 1031001, 1061028, 8000, 0, 136),
(392, 1031001, 1061027, 8000, 0, 140),
(393, 1031001, 1061022, 4000, 0, 144),
(394, 1031001, 1061021, 4000, 0, 148),
(395, 1031001, 1061013, 4000, 0, 152),
(396, 1031001, 1061012, 4000, 0, 156),
(397, 1031001, 1061011, 2000, 0, 160),
(398, 1031001, 1061010, 2000, 0, 164),
(399, 1031001, 1060015, 8000, 0, 168),
(400, 1031001, 1060014, 8000, 0, 172),
(401, 1031001, 1060013, 2000, 0, 176),
(402, 1031001, 1060012, 2000, 0, 180),
(403, 1031001, 1051003, 16000, 0, 184),
(404, 1031001, 1051005, 16000, 0, 188),
(405, 1031001, 1051004, 16000, 0, 192),
(406, 1031001, 1050028, 40000, 0, 196),
(407, 1031001, 1050027, 40000, 0, 200),
(408, 1031001, 1050026, 40000, 0, 204),
(409, 1031001, 1050003, 40000, 0, 208),
(410, 1031001, 1050025, 16000, 0, 212),
(411, 1031001, 1050024, 16000, 0, 216),
(412, 1031001, 1050023, 16000, 0, 220),
(413, 1031001, 1050001, 16000, 0, 224),
(414, 1031001, 1050010, 7000, 0, 228),
(415, 1031001, 1050009, 7000, 0, 232),
(416, 1031001, 1050008, 7000, 0, 236),
(417, 1031001, 1041043, 42000, 0, 240),
(418, 1031001, 1041042, 42000, 0, 244),
(419, 1031001, 1041041, 42000, 0, 248),
(420, 1031001, 1041031, 8500, 0, 252),
(421, 1031001, 1041030, 8500, 0, 256),
(422, 1031001, 1041029, 8500, 0, 260),
(423, 1031001, 1041026, 4000, 0, 264),
(424, 1031001, 1041025, 4000, 0, 268),
(425, 1031001, 1041018, 4000, 0, 272),
(426, 1031001, 1041017, 4000, 0, 276),
(427, 1031001, 1041016, 2000, 0, 280),
(428, 1031001, 1041015, 2000, 0, 284),
(429, 1031001, 1040020, 8500, 0, 288),
(430, 1031001, 1040019, 8500, 0, 292),
(431, 1031001, 1040018, 8500, 0, 296),
(432, 1031001, 1040017, 2000, 0, 300),
(433, 1031001, 1040004, 2000, 0, 304),
(434, 1031001, 1002016, 8000, 0, 308),
(435, 1031001, 1002106, 3800, 0, 312),
(436, 1031001, 1002105, 3800, 0, 316),
(437, 1031001, 1002104, 3800, 0, 320),
(438, 1031001, 1002103, 3800, 0, 324),
(439, 1031001, 1002102, 3800, 0, 328),
(440, 1031001, 1002017, 1200, 0, 332),
(441, 1031100, 2330000, 600, 0, 104),
(442, 1031100, 2070000, 500, 0, 108),
(443, 1031100, 2050003, 500, 0, 112),
(444, 1031100, 2050002, 300, 0, 116),
(445, 1031100, 2050001, 200, 0, 120),
(446, 1031100, 2050000, 200, 0, 124),
(449, 1031100, 2061000, 1, 0, 136),
(450, 1031100, 2060000, 1, 0, 140),
(451, 1031100, 2030002, 500, 0, 144),
(452, 1031100, 2030000, 400, 0, 148),
(453, 1031100, 2010004, 305, 0, 152),
(454, 1031100, 2010003, 97, 0, 156),
(455, 1031100, 2010001, 106, 0, 160),
(456, 1031100, 2010002, 50, 0, 164),
(457, 1031100, 2010000, 30, 0, 168),
(458, 1031100, 2002005, 500, 0, 172),
(459, 1031100, 2002004, 500, 0, 176),
(460, 1031100, 2002002, 500, 0, 180),
(461, 1031100, 2002001, 400, 0, 184),
(462, 1031100, 2002000, 500, 0, 188),
(463, 1031100, 2000006, 604, 0, 192),
(464, 1031100, 2000003, 192, 0, 196),
(465, 1031100, 2000002, 320, 0, 200),
(466, 1031100, 2000001, 160, 0, 204),
(467, 1031100, 2000000, 50, 0, 208),
(468, 1032103, 2044900, 70000, 0, 104),
(469, 1032103, 2044800, 70000, 0, 108),
(470, 1032103, 2043800, 70000, 0, 112),
(471, 1032103, 2043700, 70000, 0, 116),
(472, 1032103, 2044600, 70000, 0, 120),
(473, 1032103, 2044500, 70000, 0, 124),
(474, 1032103, 2040300, 35000, 0, 128),
(475, 1032103, 2040700, 35000, 0, 132),
(476, 1032103, 2040600, 35000, 0, 136),
(477, 1032103, 2040400, 35000, 0, 140),
(478, 1032103, 2040000, 35000, 0, 144),
(479, 1051000, 1472000, 3000, 0, 104),
(480, 1051000, 1442000, 3000, 0, 108),
(481, 1051000, 1432001, 7000, 0, 112),
(482, 1051000, 1432000, 3000, 0, 116),
(483, 1051000, 1422000, 3000, 0, 120),
(484, 1051000, 1412001, 3000, 0, 124),
(485, 1051000, 1402001, 3000, 0, 128),
(486, 1051000, 1322009, 20000, 0, 132),
(487, 1051000, 1332009, 42000, 0, 136),
(488, 1051000, 1332012, 40000, 0, 140),
(489, 1051000, 1332004, 38000, 0, 144),
(490, 1051000, 1332010, 22000, 0, 148),
(491, 1051000, 1332013, 15000, 0, 152),
(492, 1051000, 1332008, 10000, 0, 156),
(493, 1051000, 1332002, 8000, 0, 160),
(494, 1051000, 1332006, 7000, 0, 164),
(495, 1051000, 1332000, 4000, 0, 168),
(496, 1051000, 1302007, 3000, 0, 172),
(497, 1051001, 1072066, 9000, 0, 104),
(498, 1051001, 1072065, 9000, 0, 108),
(499, 1051001, 1072022, 9000, 0, 112),
(500, 1051001, 1072031, 4500, 0, 116),
(501, 1051001, 1072030, 4500, 0, 120),
(502, 1051001, 1072029, 4500, 0, 124),
(503, 1051001, 1072028, 4500, 0, 128),
(504, 1051001, 1072043, 2000, 0, 132),
(505, 1051001, 1072042, 2000, 0, 136),
(506, 1051001, 1072004, 2000, 0, 140),
(507, 1051001, 1072071, 1800, 0, 144),
(508, 1051001, 1072070, 1800, 0, 148),
(509, 1051001, 1061046, 40000, 0, 152),
(510, 1051001, 1061045, 40000, 0, 156),
(511, 1051001, 1061044, 40000, 0, 160),
(512, 1051001, 1061043, 40000, 0, 164),
(513, 1051001, 1061056, 18000, 0, 168),
(514, 1051001, 1061055, 18000, 0, 172),
(515, 1051001, 1061054, 18000, 0, 176),
(516, 1051001, 1061053, 18000, 0, 180),
(517, 1051001, 1061042, 12000, 0, 184),
(518, 1051001, 1061041, 12000, 0, 188),
(519, 1051001, 1061040, 12000, 0, 192),
(520, 1051001, 1061033, 8000, 0, 196),
(521, 1051001, 1061032, 8000, 0, 200),
(522, 1051001, 1061003, 8000, 0, 204),
(523, 1051001, 1061038, 4800, 0, 208),
(524, 1051001, 1061037, 4800, 0, 212),
(525, 1051001, 1061031, 2800, 0, 216),
(526, 1051001, 1061030, 2800, 0, 220),
(527, 1051001, 1061029, 2800, 0, 224),
(528, 1051001, 1060046, 40000, 0, 228),
(529, 1051001, 1060045, 40000, 0, 232),
(530, 1051001, 1060044, 40000, 0, 236),
(531, 1051001, 1060043, 40000, 0, 240),
(532, 1051001, 1060039, 19000, 0, 244),
(533, 1051001, 1060038, 19000, 0, 248),
(534, 1051001, 1060037, 19000, 0, 252),
(535, 1051001, 1060033, 8000, 0, 256),
(536, 1051001, 1060032, 8000, 0, 260),
(537, 1051001, 1060031, 8000, 0, 264),
(538, 1051001, 1060025, 4800, 0, 268),
(539, 1051001, 1060024, 4800, 0, 272),
(540, 1051001, 1060023, 2800, 0, 276),
(541, 1051001, 1060022, 2800, 0, 280),
(542, 1051001, 1060021, 2800, 0, 284),
(543, 1051001, 1041050, 45000, 0, 288),
(544, 1051001, 1041049, 45000, 0, 292),
(545, 1051001, 1041048, 45000, 0, 296),
(546, 1051001, 1041047, 45000, 0, 300),
(547, 1051001, 1041060, 18000, 0, 304),
(548, 1051001, 1041059, 18000, 0, 308),
(549, 1051001, 1041058, 18000, 0, 312),
(550, 1051001, 1041057, 18000, 0, 316),
(551, 1051001, 1041040, 9000, 0, 320),
(552, 1051001, 1041039, 9000, 0, 324),
(553, 1051001, 1041003, 9000, 0, 328),
(554, 1051001, 1041045, 5000, 0, 332),
(555, 1051001, 1041044, 5000, 0, 336),
(556, 1051001, 1041038, 3000, 0, 340),
(557, 1051001, 1041037, 3000, 0, 344),
(558, 1051001, 1041036, 3000, 0, 348),
(559, 1051001, 1040060, 45000, 0, 352),
(560, 1051001, 1040059, 45000, 0, 356),
(561, 1051001, 1040058, 45000, 0, 360),
(562, 1051001, 1040057, 45000, 0, 364),
(563, 1051001, 1040050, 16000, 0, 368),
(564, 1051001, 1040049, 16000, 0, 372),
(565, 1051001, 1040048, 16000, 0, 376),
(566, 1051001, 1040044, 9000, 0, 380),
(567, 1051001, 1040043, 9000, 0, 384),
(568, 1051001, 1040042, 9000, 0, 388),
(569, 1051001, 1040035, 5000, 0, 392),
(570, 1051001, 1040034, 5000, 0, 396),
(571, 1051001, 1040033, 3000, 0, 400),
(572, 1051001, 1040032, 3000, 0, 404),
(573, 1051001, 1040031, 3000, 0, 408),
(574, 1051001, 1002175, 30000, 0, 412),
(575, 1051001, 1002174, 30000, 0, 416),
(576, 1051001, 1002173, 30000, 0, 420),
(577, 1051001, 1002172, 30000, 0, 424),
(578, 1051001, 1002171, 30000, 0, 428),
(579, 1051001, 1002150, 20000, 0, 432),
(580, 1051001, 1002149, 20000, 0, 436),
(581, 1051001, 1002148, 20000, 0, 440),
(582, 1051001, 1002147, 20000, 0, 444),
(583, 1051001, 1002146, 20000, 0, 448),
(584, 1051001, 1002097, 7400, 0, 452),
(585, 1051001, 1002096, 7400, 0, 456),
(586, 1051001, 1002020, 7400, 0, 460),
(587, 1051001, 1002131, 12000, 0, 464),
(588, 1051001, 1002130, 12000, 0, 468),
(589, 1051001, 1002129, 12000, 0, 472),
(590, 1051001, 1002128, 12000, 0, 476),
(591, 1051001, 1002127, 12000, 0, 480),
(592, 1051001, 1002111, 4000, 0, 484),
(593, 1051001, 1002110, 4000, 0, 488),
(594, 1051001, 1002109, 4000, 0, 492),
(595, 1051001, 1002108, 4000, 0, 496),
(596, 1051001, 1002107, 4000, 0, 500),
(597, 1051001, 1002001, 3000, 0, 504),
(598, 1051001, 1002126, 900, 0, 508),
(599, 1051001, 1002125, 900, 0, 512),
(600, 1051001, 1002124, 900, 0, 516),
(601, 1051001, 1002123, 900, 0, 520),
(602, 1051001, 1002122, 900, 0, 524),
(603, 1051002, 2330000, 600, 0, 104),
(604, 1051002, 2070000, 500, 0, 108),
(605, 1051002, 2050002, 300, 0, 112),
(606, 1051002, 2050001, 200, 0, 116),
(607, 1051002, 2050000, 200, 0, 120),
(610, 1051002, 2061000, 1, 0, 132),
(611, 1051002, 2060000, 1, 0, 136),
(612, 1051002, 2030005, 500, 0, 140),
(613, 1051002, 2030000, 400, 0, 144),
(614, 1051002, 2010004, 310, 0, 148),
(615, 1051002, 2010003, 100, 0, 152),
(616, 1051002, 2010001, 106, 0, 156),
(617, 1051002, 2010002, 50, 0, 160),
(618, 1051002, 2010000, 30, 0, 164),
(619, 1051002, 2002005, 500, 0, 168),
(620, 1051002, 2002004, 500, 0, 172),
(621, 1051002, 2002002, 500, 0, 176),
(622, 1051002, 2002001, 400, 0, 180),
(623, 1051002, 2002000, 500, 0, 184),
(624, 1051002, 2000006, 620, 0, 188),
(625, 1051002, 2000003, 200, 0, 192),
(626, 1051002, 2000002, 320, 0, 196),
(627, 1051002, 2000001, 160, 0, 200),
(628, 1051002, 2000000, 50, 0, 204),
(629, 1052104, 2044700, 70000, 0, 104),
(630, 1052104, 2043300, 70000, 0, 108),
(631, 1052104, 2044400, 70000, 0, 112),
(632, 1052104, 2044300, 70000, 0, 116),
(633, 1052104, 2044200, 70000, 0, 120),
(634, 1052104, 2044100, 70000, 0, 124),
(635, 1052104, 2044000, 70000, 0, 128),
(636, 1052104, 2043200, 70000, 0, 132),
(637, 1052104, 2043100, 70000, 0, 136),
(638, 1052104, 2043000, 70000, 0, 140),
(639, 1052104, 2040703, 35000, 0, 144),
(640, 1052104, 2040700, 35000, 0, 148),
(641, 1052104, 2040600, 35000, 0, 152),
(642, 1052104, 2040500, 35000, 0, 156),
(643, 1052104, 2040003, 35000, 0, 160),
(644, 1052104, 2040000, 35000, 0, 164),
(645, 1061001, 2330000, 600, 0, 104),
(646, 1061001, 2070000, 500, 0, 108),
(647, 1061001, 2061001, 2800, 0, 112),
(648, 1061001, 2060001, 2800, 0, 116),
(649, 1061001, 2061000, 2, 0, 120),
(650, 1061001, 2060000, 2, 0, 124),
(651, 1061001, 2030000, 400, 0, 128),
(652, 1061001, 2020002, 320, 0, 132),
(653, 1061001, 2022000, 1650, 0, 136),
(654, 1061001, 2020000, 420, 0, 140),
(655, 1061001, 2022003, 1100, 0, 144),
(656, 1061001, 2020006, 530, 0, 148),
(657, 1061001, 2020004, 450, 0, 152),
(658, 1061001, 2020003, 450, 0, 156),
(659, 1061001, 2020005, 320, 0, 160),
(660, 1061001, 2020001, 220, 0, 164),
(661, 1061002, 2330000, 600, 0, 104),
(662, 1061002, 2070000, 500, 0, 108),
(665, 1061002, 2061000, 1, 0, 120),
(666, 1061002, 2060000, 1, 0, 124),
(667, 1061002, 2030006, 600, 0, 128),
(668, 1061002, 2030000, 400, 0, 132),
(669, 1061002, 2022003, 1100, 0, 136),
(670, 1061002, 2022000, 1650, 0, 140),
(671, 1061002, 2010004, 310, 0, 144),
(672, 1061002, 2010003, 100, 0, 148),
(673, 1061002, 2010001, 106, 0, 152),
(674, 1061002, 2010002, 50, 0, 156),
(675, 1061002, 2010000, 30, 0, 160),
(676, 1061002, 2000006, 620, 0, 164),
(677, 1061002, 2000003, 200, 0, 168),
(678, 1061002, 2000002, 320, 0, 172),
(679, 1061002, 2000001, 160, 0, 176),
(680, 1061002, 2000000, 50, 0, 180),
(681, 1081000, 2330000, 600, 0, 104),
(682, 1081000, 2070000, 500, 0, 108),
(683, 1081000, 2001002, 4000, 0, 112),
(684, 1081000, 2001001, 2300, 0, 116),
(685, 1081000, 2001000, 3200, 0, 120),
(686, 1081000, 2020002, 320, 0, 124),
(687, 1081000, 2022000, 1650, 0, 128),
(688, 1081000, 2020000, 420, 0, 132),
(689, 1081000, 2022003, 1100, 0, 136),
(690, 1081000, 2020006, 530, 0, 140),
(691, 1081000, 2020004, 450, 0, 144),
(692, 1081000, 2020003, 450, 0, 148),
(693, 1081000, 2020005, 320, 0, 152),
(694, 1081000, 2020001, 220, 0, 156),
(695, 1081000, 2010004, 310, 0, 160),
(696, 1081000, 2010003, 100, 0, 164),
(697, 1081000, 2010001, 106, 0, 168),
(698, 1081000, 2010002, 50, 0, 172),
(699, 1081000, 2010000, 30, 0, 176),
(700, 1081000, 2000003, 200, 0, 180),
(701, 1081000, 2000002, 320, 0, 184),
(702, 1081000, 2000001, 160, 0, 188),
(703, 1081000, 2000000, 50, 0, 192),
(704, 1091000, 1322007, 6000, 0, 104),
(705, 1091000, 1302007, 3000, 0, 108),
(706, 1091000, 1442004, 24000, 0, 112),
(707, 1091000, 1482004, 52000, 0, 116),
(708, 1091000, 1482003, 20000, 0, 120),
(709, 1091000, 1482002, 10000, 0, 124),
(710, 1091000, 1482001, 6000, 0, 128),
(711, 1091000, 1482000, 3000, 0, 132),
(712, 1091000, 1492004, 50000, 0, 136),
(713, 1091000, 1492003, 22000, 0, 140),
(714, 1091000, 1492002, 10000, 0, 144),
(715, 1091000, 1492001, 6000, 0, 148),
(716, 1091000, 1492000, 3000, 0, 152),
(717, 1091001, 1072288, 8000, 0, 104),
(718, 1091001, 1072285, 5000, 0, 108),
(719, 1091001, 1052107, 60000, 0, 112),
(720, 1091001, 1052104, 30000, 0, 116),
(721, 1091001, 1052101, 16000, 0, 120),
(722, 1091001, 1052098, 8000, 0, 124),
(723, 1091001, 1052095, 4000, 0, 128),
(724, 1091001, 1002619, 20000, 0, 132),
(725, 1091001, 1002616, 12000, 0, 136),
(726, 1091001, 1002613, 4000, 0, 140),
(727, 1091001, 1002610, 900, 0, 144),
(728, 1091002, 2330000, 600, 0, 104),
(729, 1091002, 2070000, 500, 0, 108),
(732, 1091002, 2061000, 1, 0, 120),
(733, 1091002, 2060000, 1, 0, 124),
(734, 1091002, 2030019, 500, 0, 128),
(735, 1091002, 2030000, 400, 0, 132),
(736, 1091002, 2020028, 3000, 0, 136),
(737, 1091002, 2010004, 310, 0, 140),
(738, 1091002, 2010003, 100, 0, 144),
(739, 1091002, 2010001, 106, 0, 148),
(740, 1091002, 2010002, 50, 0, 152),
(741, 1091002, 2010000, 30, 0, 156),
(742, 1091002, 2002005, 500, 0, 160),
(743, 1091002, 2002004, 500, 0, 164),
(744, 1091002, 2002002, 500, 0, 168),
(745, 1091002, 2002001, 400, 0, 172),
(746, 1091002, 2002000, 500, 0, 176),
(747, 1091002, 2000006, 620, 0, 180),
(748, 1091002, 2000003, 200, 0, 184),
(749, 1091002, 2000002, 320, 0, 188),
(750, 1091002, 2000001, 160, 0, 192),
(751, 1091002, 2000000, 50, 0, 196),
(752, 1093000, 2022258, 105, 0, 104),
(753, 1100001, 1072005, 50, 0, 104),
(754, 1100001, 1072001, 50, 0, 108),
(755, 1100001, 1061008, 50, 0, 112),
(756, 1100001, 1061002, 50, 0, 116),
(757, 1100001, 1060006, 50, 0, 120),
(758, 1100001, 1060002, 50, 0, 124),
(759, 1100001, 1041011, 50, 0, 128),
(760, 1100001, 1041010, 50, 0, 132),
(761, 1100001, 1041006, 50, 0, 136),
(762, 1100001, 1041002, 50, 0, 140),
(763, 1100001, 1040010, 50, 0, 144),
(764, 1100001, 1040006, 50, 0, 148),
(765, 1100001, 1040002, 50, 0, 152),
(766, 1100001, 1332005, 500, 0, 156),
(767, 1100001, 1322005, 50, 0, 160),
(768, 1100001, 1312004, 50, 0, 164),
(769, 1100001, 1302000, 50, 0, 168),
(770, 1100002, 2330000, 600, 0, 104),
(771, 1100002, 2070000, 500, 0, 108),
(772, 1100002, 2050002, 300, 0, 112),
(773, 1100002, 2050001, 200, 0, 116),
(774, 1100002, 2050000, 200, 0, 120),
(777, 1100002, 2061000, 1, 0, 132),
(778, 1100002, 2060000, 1, 0, 136),
(779, 1100002, 2030000, 400, 0, 140),
(780, 1100002, 2120008, 200, 0, 144),
(781, 1100002, 2010004, 310, 0, 148),
(782, 1100002, 2010003, 100, 0, 152),
(783, 1100002, 2010001, 106, 0, 156),
(784, 1100002, 2010002, 50, 0, 160),
(785, 1100002, 2010000, 30, 0, 164),
(786, 1100002, 2002005, 500, 0, 168),
(787, 1100002, 2002004, 500, 0, 172),
(788, 1100002, 2002002, 500, 0, 176),
(789, 1100002, 2002001, 400, 0, 180),
(790, 1100002, 2002000, 500, 0, 184),
(791, 1100002, 2000006, 620, 0, 188),
(792, 1100002, 2000003, 200, 0, 192),
(793, 1100002, 2000002, 320, 0, 196),
(794, 1100002, 2000001, 160, 0, 200),
(795, 1100002, 2000000, 50, 0, 204),
(796, 2010004, 4160019, 1000, 0, 104),
(797, 2010004, 4160039, 1000, 0, 108),
(798, 2010004, 4160037, 1000, 0, 112),
(799, 2010004, 4031993, 100000, 0, 116),
(800, 2010004, 4160036, 1000, 0, 120),
(801, 2010004, 4160035, 1000, 0, 124),
(802, 2010004, 4160034, 1000, 0, 128),
(803, 2010004, 4160032, 1000, 0, 132),
(804, 2010004, 4160024, 1000, 0, 136),
(805, 2010004, 4160023, 1000, 0, 140),
(806, 2010004, 4160022, 1000, 0, 144),
(807, 2010004, 4160015, 1000, 0, 148),
(808, 2010004, 4160012, 1000, 0, 152),
(809, 2010004, 4160013, 1000, 0, 156),
(810, 2010004, 4160017, 1000, 0, 160),
(811, 2010004, 4160014, 1000, 0, 164),
(812, 2010004, 4160020, 1000, 0, 168),
(813, 2010004, 4160010, 1000, 0, 172),
(814, 2010004, 4160009, 1000, 0, 176),
(815, 2010004, 4160008, 1000, 0, 180),
(816, 2010004, 4160007, 1000, 0, 184),
(817, 2010004, 4160006, 1000, 0, 188),
(818, 2010004, 4160005, 1000, 0, 192),
(819, 2010004, 4160004, 1000, 0, 196),
(820, 2010004, 4160003, 1000, 0, 200),
(821, 2010004, 4160002, 1000, 0, 204),
(822, 2010004, 4160001, 1000, 0, 208),
(823, 2010004, 4160000, 1000, 0, 212),
(824, 2010004, 4160026, 1000, 0, 216),
(825, 2010004, 2260000, 1000, 0, 220),
(826, 2010004, 2120000, 30, 0, 224),
(827, 2012003, 1492004, 75000, 0, 104),
(828, 2012003, 1482004, 75000, 0, 108),
(829, 2012003, 1472001, 20000, 0, 112),
(830, 2012003, 1462000, 30000, 0, 116),
(831, 2012003, 1452005, 150000, 0, 120),
(832, 2012003, 1442001, 60000, 0, 124),
(833, 2012003, 1432002, 60000, 0, 128),
(834, 2012003, 1422001, 45000, 0, 132),
(835, 2012003, 1412006, 45000, 0, 136),
(836, 2012003, 1402002, 150000, 0, 140),
(837, 2012003, 1382002, 20000, 0, 144),
(838, 2012003, 1372003, 38000, 0, 148),
(839, 2012003, 1332012, 40000, 0, 152),
(840, 2012003, 1332009, 42000, 0, 156),
(841, 2012003, 1322014, 40000, 0, 160),
(842, 2012003, 1312005, 40000, 0, 164),
(843, 2012003, 1302008, 40000, 0, 168),
(844, 2012004, 1052107, 90000, 0, 104),
(845, 2012004, 1002622, 40000, 0, 108),
(846, 2012004, 1061046, 40000, 0, 112),
(847, 2012004, 1061045, 40000, 0, 116),
(848, 2012004, 1061044, 40000, 0, 120),
(849, 2012004, 1061043, 40000, 0, 124),
(850, 2012004, 1060046, 40000, 0, 128),
(851, 2012004, 1060045, 40000, 0, 132),
(852, 2012004, 1060044, 40000, 0, 136),
(853, 2012004, 1060043, 40000, 0, 140),
(854, 2012004, 1041050, 45000, 0, 144),
(855, 2012004, 1041049, 45000, 0, 148),
(856, 2012004, 1041048, 45000, 0, 152),
(857, 2012004, 1041047, 45000, 0, 156),
(858, 2012004, 1040060, 45000, 0, 160),
(859, 2012004, 1040059, 45000, 0, 164),
(860, 2012004, 1040058, 45000, 0, 168),
(861, 2012004, 1040057, 45000, 0, 172),
(862, 2012004, 1002175, 30000, 0, 176),
(863, 2012004, 1002174, 30000, 0, 180),
(864, 2012004, 1002173, 30000, 0, 184),
(865, 2012004, 1002172, 30000, 0, 188),
(866, 2012004, 1002171, 30000, 0, 192),
(867, 2012004, 1061051, 44000, 0, 196),
(868, 2012004, 1061050, 44000, 0, 200),
(869, 2012004, 1061052, 44000, 0, 204),
(870, 2012004, 1060057, 44000, 0, 208),
(871, 2012004, 1060056, 44000, 0, 212),
(872, 2012004, 1060058, 44000, 0, 216),
(873, 2012004, 1060059, 44000, 0, 220),
(874, 2012004, 1041055, 50000, 0, 224),
(875, 2012004, 1041054, 50000, 0, 228),
(876, 2012004, 1041056, 50000, 0, 232),
(877, 2012004, 1040068, 50000, 0, 236),
(878, 2012004, 1040067, 50000, 0, 240),
(879, 2012004, 1040070, 50000, 0, 244),
(880, 2012004, 1040069, 50000, 0, 248),
(881, 2012004, 1002165, 30000, 0, 252),
(882, 2012004, 1002164, 30000, 0, 256),
(883, 2012004, 1002163, 30000, 0, 260),
(884, 2012004, 1002162, 30000, 0, 264),
(885, 2012004, 1002161, 30000, 0, 268),
(886, 2012004, 1061036, 40000, 0, 272),
(887, 2012004, 1061035, 40000, 0, 276),
(888, 2012004, 1061034, 40000, 0, 280),
(889, 2012004, 1050028, 40000, 0, 284),
(890, 2012004, 1050027, 40000, 0, 288),
(891, 2012004, 1050026, 40000, 0, 292),
(892, 2012004, 1050003, 40000, 0, 296),
(893, 2012004, 1041043, 42000, 0, 300),
(894, 2012004, 1041042, 42000, 0, 304),
(895, 2012004, 1041041, 42000, 0, 308),
(896, 2012004, 1002064, 40000, 0, 312),
(897, 2012004, 1092006, 60000, 0, 316),
(898, 2012004, 1060019, 38000, 0, 320),
(899, 2012004, 1060018, 38000, 0, 324),
(900, 2012004, 1060017, 38000, 0, 328),
(901, 2012004, 1060016, 38000, 0, 332),
(902, 2012004, 1051013, 60000, 0, 336),
(903, 2012004, 1051012, 60000, 0, 340),
(904, 2012004, 1051011, 60000, 0, 344),
(905, 2012004, 1051010, 60000, 0, 348),
(906, 2012004, 1040026, 40000, 0, 352),
(907, 2012004, 1040021, 40000, 0, 356),
(908, 2012004, 1002023, 120000, 0, 360),
(909, 2012005, 2330000, 600, 0, 104),
(910, 2012005, 2070000, 500, 0, 108),
(913, 2012005, 2061000, 1, 0, 120),
(914, 2012005, 2060000, 1, 0, 124),
(915, 2012005, 2030000, 400, 0, 128),
(916, 2012005, 2050003, 500, 0, 132),
(917, 2012005, 2050002, 300, 0, 136),
(918, 2012005, 2050001, 200, 0, 140),
(919, 2012005, 2050000, 200, 0, 144),
(920, 2012005, 2020028, 3000, 0, 148),
(921, 2012005, 2010004, 310, 0, 152),
(922, 2012005, 2010003, 100, 0, 156),
(923, 2012005, 2010001, 106, 0, 160),
(924, 2012005, 2010002, 50, 0, 164),
(925, 2012005, 2010000, 30, 0, 168),
(926, 2012005, 2001002, 4000, 0, 172),
(927, 2012005, 2001001, 2300, 0, 176),
(928, 2012005, 2001000, 3200, 0, 180),
(929, 2012005, 2022000, 1650, 0, 184),
(930, 2012005, 2022003, 1100, 0, 188),
(931, 2012005, 2002005, 500, 0, 192),
(932, 2012005, 2002004, 500, 0, 196),
(933, 2012005, 2002002, 500, 0, 200),
(934, 2012005, 2002001, 400, 0, 204),
(935, 2012005, 2002000, 500, 0, 208),
(936, 2012005, 2000006, 620, 0, 212),
(937, 2012005, 2000003, 200, 0, 216),
(938, 2012005, 2000002, 320, 0, 220),
(939, 2012005, 2000001, 160, 0, 224),
(940, 2012005, 2000000, 50, 0, 228),
(941, 2020001, 1492006, 160000, 0, 104),
(942, 2020001, 1492005, 100000, 0, 108),
(943, 2020001, 1482006, 150000, 0, 112),
(944, 2020001, 1482005, 100000, 0, 116),
(945, 2020001, 1472007, 60000, 0, 120),
(946, 2020001, 1472004, 30000, 0, 124),
(947, 2020001, 1462005, 250000, 0, 128),
(948, 2020001, 1462004, 200000, 0, 132),
(949, 2020001, 1452007, 375000, 0, 136),
(950, 2020001, 1452006, 250000, 0, 140),
(951, 2020001, 1442009, 300000, 0, 144),
(952, 2020001, 1442003, 175000, 0, 148),
(953, 2020001, 1432005, 225000, 0, 152),
(954, 2020001, 1432003, 175000, 0, 156),
(955, 2020001, 1422007, 250000, 0, 160),
(956, 2020001, 1422008, 200000, 0, 164),
(957, 2020001, 1412005, 250000, 0, 168),
(958, 2020001, 1412004, 200000, 0, 172),
(959, 2020001, 1402007, 450000, 0, 176),
(960, 2020001, 1402006, 350000, 0, 180),
(961, 2020001, 1372000, 400000, 0, 184),
(962, 2020001, 1372001, 175000, 0, 188),
(963, 2020001, 1332011, 425000, 0, 192),
(964, 2020001, 1332014, 375000, 0, 196),
(965, 2020001, 1332001, 200000, 0, 200),
(966, 2020001, 1322016, 175000, 0, 204),
(967, 2020001, 1322015, 100000, 0, 208),
(968, 2020001, 1312007, 175000, 0, 212),
(969, 2020001, 1312006, 100000, 0, 216),
(970, 2020001, 1302009, 225000, 0, 220),
(971, 2020001, 1302004, 100000, 0, 224),
(972, 2022000, 1002625, 75000, 0, 104),
(973, 2022000, 1052113, 120000, 0, 108),
(974, 2022000, 1052110, 100000, 0, 112),
(975, 2022000, 1061069, 160000, 0, 116),
(976, 2022000, 1061070, 160000, 0, 120),
(977, 2022000, 1060072, 160000, 0, 124),
(978, 2022000, 1060071, 160000, 0, 128),
(979, 2022000, 1060052, 108000, 0, 132),
(980, 2022000, 1060050, 108000, 0, 136),
(981, 2022000, 1060051, 108000, 0, 140),
(982, 2022000, 1051009, 111000, 0, 144),
(983, 2022000, 1051008, 111000, 0, 148),
(984, 2022000, 1051007, 111000, 0, 152),
(985, 2022000, 1041074, 180000, 0, 156),
(986, 2022000, 1041075, 180000, 0, 160),
(987, 2022000, 1040083, 180000, 0, 164),
(988, 2022000, 1040082, 180000, 0, 168),
(989, 2022000, 1040061, 114000, 0, 172),
(990, 2022000, 1040062, 114000, 0, 176),
(991, 2022000, 1040063, 114000, 0, 180),
(992, 2022000, 1002180, 100000, 0, 184),
(993, 2022000, 1002179, 100000, 0, 188),
(994, 2022000, 1002178, 100000, 0, 192),
(995, 2022000, 1002177, 100000, 0, 196),
(996, 2022000, 1002176, 100000, 0, 200),
(997, 2022000, 1061080, 160000, 0, 204),
(998, 2022000, 1061081, 160000, 0, 208),
(999, 2022000, 1061062, 108000, 0, 212),
(1000, 2022000, 1061060, 108000, 0, 216),
(1001, 2022000, 1061064, 108000, 0, 220),
(1002, 2022000, 1061061, 108000, 0, 224),
(1003, 2022000, 1060069, 160000, 0, 228),
(1004, 2022000, 1060070, 160000, 0, 232),
(1005, 2022000, 1060063, 108000, 0, 236),
(1006, 2022000, 1060061, 108000, 0, 240),
(1007, 2022000, 1060065, 108000, 0, 244),
(1008, 2022000, 1060062, 108000, 0, 248),
(1009, 2022000, 1041081, 180000, 0, 252),
(1010, 2022000, 1041082, 180000, 0, 256),
(1011, 2022000, 1041067, 114000, 0, 260),
(1012, 2022000, 1041065, 114000, 0, 264),
(1013, 2022000, 1041069, 114000, 0, 268),
(1014, 2022000, 1041066, 114000, 0, 272),
(1015, 2022000, 1040079, 180000, 0, 276),
(1016, 2022000, 1040081, 180000, 0, 280),
(1017, 2022000, 1040076, 114000, 0, 284),
(1018, 2022000, 1040074, 114000, 0, 288),
(1019, 2022000, 1040073, 114000, 0, 292),
(1020, 2022000, 1040072, 114000, 0, 296),
(1021, 2022000, 1002137, 100000, 0, 300),
(1022, 2022000, 1002135, 100000, 0, 304),
(1023, 2022000, 1002139, 100000, 0, 308),
(1024, 2022000, 1002138, 100000, 0, 312),
(1025, 2022000, 1061047, 120000, 0, 316),
(1026, 2022000, 1061048, 120000, 0, 320),
(1027, 2022000, 1051027, 450000, 0, 324),
(1028, 2022000, 1051024, 450000, 0, 328),
(1029, 2022000, 1051025, 450000, 0, 332),
(1030, 2022000, 1051023, 450000, 0, 336),
(1031, 2022000, 1050037, 450000, 0, 340),
(1032, 2022000, 1050036, 450000, 0, 344),
(1033, 2022000, 1050038, 450000, 0, 348),
(1034, 2022000, 1050035, 450000, 0, 352),
(1035, 2022000, 1050002, 300000, 0, 356),
(1036, 2022000, 1050031, 300000, 0, 360),
(1037, 2022000, 1041051, 120000, 0, 364),
(1038, 2022000, 1041052, 120000, 0, 368),
(1039, 2022000, 1002144, 96000, 0, 372),
(1040, 2022000, 1002143, 96000, 0, 376),
(1041, 2022000, 1002142, 96000, 0, 380),
(1042, 2022000, 1002141, 96000, 0, 384),
(1043, 2022000, 1092002, 200000, 0, 388),
(1044, 2022000, 1092001, 100000, 0, 392),
(1045, 2022000, 1061084, 180000, 0, 396),
(1046, 2022000, 1061083, 180000, 0, 400),
(1047, 2022000, 1060074, 180000, 0, 404),
(1048, 2022000, 1060075, 180000, 0, 408),
(1049, 2022000, 1051014, 112500, 0, 412),
(1050, 2022000, 1051001, 112500, 0, 416),
(1051, 2022000, 1050021, 112500, 0, 420),
(1052, 2022000, 1050000, 112500, 0, 424),
(1053, 2022000, 1041085, 200000, 0, 428),
(1054, 2022000, 1041084, 200000, 0, 432),
(1055, 2022000, 1040085, 200000, 0, 436),
(1056, 2022000, 1040000, 200000, 0, 440),
(1057, 2022000, 1002004, 160000, 0, 444),
(1058, 2022000, 1072338, 29000, 0, 448),
(1059, 2022000, 1072171, 29000, 0, 452),
(1060, 2022000, 1072170, 29000, 0, 456),
(1061, 2022000, 1072169, 28000, 0, 460),
(1062, 2022000, 1072168, 30000, 0, 464),
(1063, 2022001, 2330000, 600, 0, 104),
(1064, 2022001, 2070000, 500, 0, 108),
(1067, 2022001, 2061000, 1, 0, 120),
(1068, 2022001, 2060000, 1, 0, 124),
(1069, 2022001, 2030000, 400, 0, 128),
(1070, 2022001, 2050002, 300, 0, 132),
(1071, 2022001, 2050001, 200, 0, 136),
(1072, 2022001, 2050000, 200, 0, 140),
(1073, 2022001, 2020015, 10200, 0, 144),
(1074, 2022001, 2020014, 8100, 0, 148),
(1075, 2022001, 2020013, 5600, 0, 152),
(1076, 2022001, 2020012, 4500, 0, 156),
(1077, 2022001, 2001002, 4000, 0, 160),
(1078, 2022001, 2001001, 2300, 0, 164),
(1079, 2022001, 2001000, 3200, 0, 168),
(1080, 2022001, 2022000, 1650, 0, 172),
(1081, 2022001, 2022003, 1100, 0, 176),
(1082, 2022001, 2010004, 310, 0, 180),
(1083, 2022001, 2010003, 100, 0, 184),
(1084, 2022001, 2010001, 106, 0, 188),
(1085, 2022001, 2010002, 50, 0, 192),
(1086, 2022001, 2010000, 30, 0, 196),
(1087, 2022001, 2002005, 500, 0, 200),
(1088, 2022001, 2002004, 500, 0, 204),
(1089, 2022001, 2002002, 500, 0, 208),
(1090, 2022001, 2002001, 400, 0, 212),
(1091, 2022001, 2002000, 500, 0, 216),
(1092, 2022001, 2000006, 620, 0, 220),
(1093, 2022001, 2000003, 200, 0, 224),
(1094, 2022001, 2000002, 320, 0, 228),
(1095, 2022001, 2000001, 160, 0, 232),
(1096, 2022001, 2000000, 50, 0, 236),
(1097, 2022001, 2022186, 2400, 0, 240),
(1098, 2022001, 2022001, 400, 0, 244),
(1099, 2022002, 2044900, 70000, 0, 104),
(1100, 2022002, 2044800, 70000, 0, 108),
(1101, 2022002, 2044700, 70000, 0, 112),
(1102, 2022002, 2044600, 70000, 0, 116),
(1103, 2022002, 2044500, 70000, 0, 120),
(1104, 2022002, 2044400, 70000, 0, 124),
(1105, 2022002, 2044300, 70000, 0, 128),
(1106, 2022002, 2044200, 70000, 0, 132),
(1107, 2022002, 2044100, 70000, 0, 136),
(1108, 2022002, 2044000, 70000, 0, 140),
(1109, 2022002, 2043800, 70000, 0, 144),
(1110, 2022002, 2043700, 70000, 0, 148),
(1111, 2022002, 2043300, 70000, 0, 152),
(1112, 2022002, 2043200, 70000, 0, 156),
(1113, 2022002, 2043100, 70000, 0, 160),
(1114, 2022002, 2043000, 70000, 0, 164),
(1115, 2022002, 2041003, 35000, 0, 168),
(1116, 2022002, 2041000, 35000, 0, 172),
(1117, 2022002, 2040900, 35000, 0, 176),
(1118, 2022002, 2040800, 35000, 0, 180),
(1119, 2022002, 2040700, 35000, 0, 184),
(1120, 2022002, 2040600, 35000, 0, 188),
(1121, 2022002, 2040503, 35000, 0, 192),
(1122, 2022002, 2040400, 35000, 0, 196),
(1123, 2022002, 2040300, 35000, 0, 200),
(1124, 2022002, 2040003, 35000, 0, 204),
(1125, 2030009, 2330000, 600, 0, 104),
(1126, 2030009, 2070000, 500, 0, 108),
(1129, 2030009, 2061000, 1, 0, 120),
(1130, 2030009, 2060000, 1, 0, 124),
(1131, 2030009, 2030000, 400, 0, 128),
(1132, 2030009, 2020015, 10608, 0, 132),
(1133, 2030009, 2020014, 8424, 0, 136),
(1134, 2030009, 2020013, 5824, 0, 140),
(1135, 2030009, 2020012, 4680, 0, 144),
(1136, 2030009, 2022000, 1716, 0, 148),
(1137, 2030009, 2022003, 1144, 0, 152),
(1138, 2030009, 2020006, 551, 0, 156),
(1139, 2030009, 2020004, 468, 0, 160),
(1140, 2030009, 2020003, 468, 0, 164),
(1141, 2030009, 2020001, 228, 0, 168),
(1142, 2030009, 2010004, 322, 0, 172),
(1143, 2030009, 2020005, 332, 0, 176),
(1144, 2030009, 2001002, 4160, 0, 180),
(1145, 2030009, 2001001, 2392, 0, 184),
(1146, 2030009, 2001000, 3328, 0, 188),
(1147, 2030009, 2002005, 520, 0, 192),
(1148, 2030009, 2002004, 520, 0, 196),
(1149, 2030009, 2002002, 520, 0, 200),
(1150, 2030009, 2002001, 416, 0, 204),
(1151, 2030009, 2002000, 520, 0, 208),
(1152, 2030009, 2000006, 644, 0, 212),
(1153, 2030009, 2000003, 208, 0, 216),
(1154, 2030009, 2000002, 332, 0, 220),
(1155, 2030009, 2000001, 166, 0, 224),
(1156, 2040049, 2061001, 10, 0, 104),
(1157, 2040049, 2060001, 10, 0, 108),
(1160, 2040049, 2061000, 1, 0, 120),
(1161, 2040049, 2060000, 1, 0, 124),
(1162, 2040049, 2120000, 25, 0, 128),
(1163, 2040049, 2020015, 10608, 0, 132),
(1164, 2040049, 2020014, 8424, 0, 136),
(1165, 2040049, 2020013, 5824, 0, 140),
(1166, 2040049, 2020012, 4680, 0, 144),
(1167, 2040049, 2022000, 1716, 0, 148),
(1168, 2040049, 2022003, 1144, 0, 152),
(1169, 2040049, 2020006, 503, 0, 156),
(1170, 2040049, 2020005, 304, 0, 160),
(1171, 2040049, 2020004, 427, 0, 164),
(1172, 2040049, 2020003, 427, 0, 168),
(1173, 2040049, 2020002, 304, 0, 172),
(1174, 2040049, 2020001, 209, 0, 176),
(1175, 2040049, 2010002, 47, 0, 180),
(1176, 2040049, 2010001, 106, 0, 184),
(1177, 2040049, 2002010, 475, 0, 188),
(1178, 2040049, 2002009, 570, 0, 192),
(1179, 2040049, 2002008, 570, 0, 196),
(1180, 2040049, 2002007, 570, 0, 200),
(1181, 2040049, 2002006, 570, 0, 204),
(1182, 2040049, 2001002, 3800, 0, 208),
(1183, 2040049, 2001001, 2185, 0, 212),
(1184, 2040049, 2000006, 589, 0, 216),
(1185, 2040049, 2000011, 620, 0, 220),
(1186, 2040049, 2000003, 190, 0, 224),
(1187, 2040049, 2000010, 200, 0, 228),
(1188, 2040049, 2000002, 304, 0, 232),
(1189, 2040049, 2000009, 320, 0, 236),
(1190, 2040049, 2000001, 152, 0, 240),
(1191, 2040049, 2000008, 160, 0, 244),
(1192, 2040049, 2000000, 47, 0, 248),
(1193, 2040049, 2000007, 50, 0, 252),
(1194, 2040051, 2030000, 400, 0, 104),
(1195, 2040051, 2061001, 10, 0, 108),
(1196, 2040051, 2060001, 10, 0, 112),
(1199, 2040051, 2061000, 1, 0, 124),
(1200, 2040051, 2060000, 1, 0, 128),
(1201, 2040051, 2050003, 500, 0, 132),
(1202, 2040051, 2050002, 300, 0, 136),
(1203, 2040051, 2050001, 200, 0, 140),
(1204, 2040051, 2050000, 200, 0, 144),
(1205, 2040051, 2000006, 620, 0, 148),
(1206, 2040051, 2000011, 620, 0, 152),
(1207, 2040051, 2000003, 200, 0, 156),
(1208, 2040051, 2000010, 200, 0, 160),
(1209, 2040051, 2000002, 320, 0, 164),
(1210, 2040051, 2000009, 320, 0, 168),
(1211, 2040051, 2000001, 160, 0, 172),
(1212, 2040051, 2000008, 160, 0, 176),
(1213, 2040051, 2000000, 50, 0, 180),
(1214, 2040051, 2000007, 50, 0, 184),
(1215, 2040051, 2020015, 10200, 0, 188),
(1216, 2040051, 2020014, 8100, 0, 192),
(1217, 2040051, 2020013, 5824, 0, 196),
(1218, 2040051, 2020012, 4680, 0, 200),
(1219, 2040051, 2001002, 4000, 0, 204),
(1220, 2040051, 2001001, 2300, 0, 208),
(1221, 2040051, 2022000, 1650, 0, 212),
(1222, 2040051, 2022003, 1100, 0, 216),
(1223, 2040051, 2002009, 600, 0, 220),
(1224, 2040051, 2002008, 600, 0, 224),
(1225, 2040051, 2002007, 600, 0, 228),
(1226, 2040051, 2002006, 600, 0, 232),
(1227, 2040051, 2002010, 500, 0, 236),
(1228, 2041002, 1492006, 160000, 0, 104),
(1229, 2041002, 1492005, 100000, 0, 108),
(1230, 2041002, 1492004, 75000, 0, 112),
(1231, 2041002, 1482006, 150000, 0, 116),
(1232, 2041002, 1482005, 100000, 0, 120),
(1233, 2041002, 1482004, 75000, 0, 124),
(1234, 2041002, 1472007, 60000, 0, 128),
(1235, 2041002, 1472004, 30000, 0, 132),
(1236, 2041002, 1472001, 20000, 0, 136),
(1237, 2041002, 1462005, 250000, 0, 140),
(1238, 2041002, 1462004, 200000, 0, 144),
(1239, 2041002, 1462000, 30000, 0, 148),
(1240, 2041002, 1452007, 375000, 0, 152),
(1241, 2041002, 1452006, 250000, 0, 156),
(1242, 2041002, 1452005, 150000, 0, 160),
(1243, 2041002, 1442009, 300000, 0, 164),
(1244, 2041002, 1442003, 175000, 0, 168),
(1245, 2041002, 1442001, 60000, 0, 172),
(1246, 2041002, 1432005, 225000, 0, 176),
(1247, 2041002, 1432003, 175000, 0, 180),
(1248, 2041002, 1432002, 60000, 0, 184),
(1249, 2041002, 1422007, 250000, 0, 188),
(1250, 2041002, 1422008, 200000, 0, 192),
(1251, 2041002, 1422001, 45000, 0, 196),
(1252, 2041002, 1412005, 250000, 0, 200),
(1253, 2041002, 1412004, 200000, 0, 204),
(1254, 2041002, 1412006, 45000, 0, 208),
(1255, 2041002, 1402007, 450000, 0, 212),
(1256, 2041002, 1402006, 350000, 0, 216),
(1257, 2041002, 1402002, 150000, 0, 220),
(1258, 2041002, 1382002, 20000, 0, 224),
(1259, 2041002, 1372000, 400000, 0, 228),
(1260, 2041002, 1372001, 175000, 0, 232),
(1261, 2041002, 1372003, 38000, 0, 236),
(1262, 2041002, 1332011, 425000, 0, 240),
(1263, 2041002, 1332014, 375000, 0, 244),
(1264, 2041002, 1332001, 200000, 0, 248),
(1265, 2041002, 1332012, 40000, 0, 252),
(1266, 2041002, 1332009, 42000, 0, 256),
(1267, 2041002, 1322016, 175000, 0, 260),
(1268, 2041002, 1322015, 100000, 0, 264),
(1269, 2041002, 1322014, 40000, 0, 268),
(1270, 2041002, 1312007, 175000, 0, 272),
(1271, 2041002, 1312006, 100000, 0, 276),
(1272, 2041002, 1312005, 40000, 0, 280),
(1273, 2041002, 1302009, 225000, 0, 284),
(1274, 2041002, 1302004, 100000, 0, 288),
(1275, 2041002, 1302008, 40000, 0, 292),
(1276, 2041003, 1002625, 75000, 0, 104),
(1277, 2041003, 1052113, 120000, 0, 108),
(1278, 2041003, 1052110, 100000, 0, 112),
(1279, 2041003, 1061069, 160000, 0, 116),
(1280, 2041003, 1061070, 160000, 0, 120),
(1281, 2041003, 1060072, 160000, 0, 124),
(1282, 2041003, 1060071, 160000, 0, 128),
(1283, 2041003, 1060052, 108000, 0, 132),
(1284, 2041003, 1060050, 108000, 0, 136),
(1285, 2041003, 1060051, 108000, 0, 140),
(1286, 2041003, 1051009, 111000, 0, 144),
(1287, 2041003, 1051008, 111000, 0, 148),
(1288, 2041003, 1051007, 111000, 0, 152),
(1289, 2041003, 1041074, 180000, 0, 156),
(1290, 2041003, 1041075, 180000, 0, 160),
(1291, 2041003, 1040083, 180000, 0, 164),
(1292, 2041003, 1040082, 180000, 0, 168),
(1293, 2041003, 1040061, 114000, 0, 172),
(1294, 2041003, 1040062, 114000, 0, 176),
(1295, 2041003, 1040063, 114000, 0, 180),
(1296, 2041003, 1002180, 100000, 0, 184),
(1297, 2041003, 1002179, 100000, 0, 188),
(1298, 2041003, 1002178, 100000, 0, 192),
(1299, 2041003, 1002177, 100000, 0, 196),
(1300, 2041003, 1002176, 100000, 0, 200),
(1301, 2041003, 1061080, 160000, 0, 204),
(1302, 2041003, 1061081, 160000, 0, 208),
(1303, 2041003, 1061062, 108000, 0, 212),
(1304, 2041003, 1061060, 108000, 0, 216),
(1305, 2041003, 1061064, 108000, 0, 220),
(1306, 2041003, 1061061, 108000, 0, 224),
(1307, 2041003, 1060069, 160000, 0, 228),
(1308, 2041003, 1060070, 160000, 0, 232),
(1309, 2041003, 1060063, 108000, 0, 236),
(1310, 2041003, 1060061, 108000, 0, 240),
(1311, 2041003, 1060065, 108000, 0, 244),
(1312, 2041003, 1060062, 108000, 0, 248),
(1313, 2041003, 1041081, 180000, 0, 252),
(1314, 2041003, 1041082, 180000, 0, 256),
(1315, 2041003, 1041067, 114000, 0, 260),
(1316, 2041003, 1041065, 114000, 0, 264),
(1317, 2041003, 1041069, 114000, 0, 268),
(1318, 2041003, 1041066, 114000, 0, 272),
(1319, 2041003, 1040079, 180000, 0, 276),
(1320, 2041003, 1040081, 180000, 0, 280),
(1321, 2041003, 1040076, 114000, 0, 284),
(1322, 2041003, 1040074, 114000, 0, 288),
(1323, 2041003, 1040073, 114000, 0, 292),
(1324, 2041003, 1040072, 114000, 0, 296),
(1325, 2041003, 1002137, 100000, 0, 300),
(1326, 2041003, 1002135, 100000, 0, 304),
(1327, 2041003, 1002139, 100000, 0, 308),
(1328, 2041003, 1002138, 100000, 0, 312),
(1329, 2041003, 1061047, 120000, 0, 316),
(1330, 2041003, 1061048, 120000, 0, 320),
(1331, 2041003, 1051027, 450000, 0, 324),
(1332, 2041003, 1051024, 450000, 0, 328),
(1333, 2041003, 1051025, 450000, 0, 332),
(1334, 2041003, 1051023, 450000, 0, 336),
(1335, 2041003, 1050037, 450000, 0, 340),
(1336, 2041003, 1050036, 450000, 0, 344),
(1337, 2041003, 1050038, 450000, 0, 348),
(1338, 2041003, 1050035, 450000, 0, 352),
(1339, 2041003, 1050002, 300000, 0, 356),
(1340, 2041003, 1050031, 300000, 0, 360),
(1341, 2041003, 1041051, 120000, 0, 364),
(1342, 2041003, 1041052, 120000, 0, 368),
(1343, 2041003, 1002144, 96000, 0, 372),
(1344, 2041003, 1002143, 96000, 0, 376),
(1345, 2041003, 1002142, 96000, 0, 380),
(1346, 2041003, 1002141, 96000, 0, 384),
(1347, 2041003, 1092002, 200000, 0, 388),
(1348, 2041003, 1092001, 100000, 0, 392),
(1349, 2041003, 1061084, 180000, 0, 396),
(1350, 2041003, 1061083, 180000, 0, 400),
(1351, 2041003, 1060074, 180000, 0, 404),
(1352, 2041003, 1060075, 180000, 0, 408),
(1353, 2041003, 1051014, 112500, 0, 412),
(1354, 2041003, 1051001, 112500, 0, 416),
(1355, 2041003, 1050021, 112500, 0, 420),
(1356, 2041003, 1050000, 112500, 0, 424),
(1357, 2041003, 1041085, 200000, 0, 428),
(1358, 2041003, 1041084, 200000, 0, 432),
(1359, 2041003, 1040085, 200000, 0, 436),
(1360, 2041003, 1040000, 200000, 0, 440),
(1361, 2041003, 1002004, 160000, 0, 444);
INSERT INTO `shopitems` (`shopitemid`, `shopid`, `itemid`, `price`, `pitch`, `position`) VALUES
(1362, 2041006, 2330000, 600, 0, 104),
(1363, 2041006, 2070000, 500, 0, 108),
(1364, 2041006, 2061001, 10, 0, 112),
(1365, 2041006, 2060001, 10, 0, 116),
(1368, 2041006, 2061000, 1, 0, 128),
(1369, 2041006, 2060000, 1, 0, 132),
(1370, 2041006, 2030000, 400, 0, 136),
(1371, 2041006, 2020028, 2850, 0, 140),
(1372, 2041006, 2020006, 503, 0, 144),
(1373, 2041006, 2020005, 304, 0, 148),
(1374, 2041006, 2020004, 427, 0, 152),
(1375, 2041006, 2020003, 427, 0, 156),
(1376, 2041006, 2020002, 304, 0, 160),
(1377, 2041006, 2020001, 209, 0, 164),
(1378, 2041006, 2010002, 47, 0, 168),
(1379, 2041006, 2010001, 106, 0, 172),
(1380, 2041006, 2002010, 500, 0, 176),
(1381, 2041006, 2002009, 500, 0, 180),
(1382, 2041006, 2002008, 500, 0, 184),
(1383, 2041006, 2002007, 500, 0, 188),
(1384, 2041006, 2002006, 500, 0, 192),
(1385, 2041006, 2001002, 3800, 0, 196),
(1386, 2041006, 2001001, 2185, 0, 200),
(1387, 2041006, 2000006, 589, 0, 204),
(1388, 2041006, 2000011, 620, 0, 208),
(1389, 2041006, 2000003, 190, 0, 212),
(1390, 2041006, 2000010, 200, 0, 216),
(1391, 2041006, 2000002, 304, 0, 220),
(1392, 2041006, 2000009, 320, 0, 224),
(1393, 2041006, 2000001, 152, 0, 228),
(1394, 2041006, 2000008, 160, 0, 232),
(1395, 2041006, 2000000, 47, 0, 236),
(1396, 2041006, 2000007, 50, 0, 240),
(1397, 2041014, 4160019, 1000, 0, 104),
(1398, 2041014, 4160039, 1000, 0, 108),
(1399, 2041014, 4160037, 1000, 0, 112),
(1400, 2041014, 4031993, 100000, 0, 116),
(1401, 2041014, 4160036, 1000, 0, 120),
(1402, 2041014, 4160035, 1000, 0, 124),
(1403, 2041014, 4160034, 1000, 0, 128),
(1404, 2041014, 4160032, 1000, 0, 132),
(1405, 2041014, 4160024, 1000, 0, 136),
(1406, 2041014, 4160023, 1000, 0, 140),
(1407, 2041014, 4160022, 1000, 0, 144),
(1408, 2041014, 4160015, 1000, 0, 148),
(1409, 2041014, 4160012, 1000, 0, 152),
(1410, 2041014, 4160013, 1000, 0, 156),
(1411, 2041014, 4160017, 1000, 0, 160),
(1412, 2041014, 4160014, 1000, 0, 164),
(1413, 2041014, 4160020, 1000, 0, 168),
(1414, 2041014, 4160010, 1000, 0, 172),
(1415, 2041014, 4160009, 1000, 0, 176),
(1416, 2041014, 4160008, 1000, 0, 180),
(1417, 2041014, 4160007, 1000, 0, 184),
(1418, 2041014, 4160006, 1000, 0, 188),
(1419, 2041014, 4160005, 1000, 0, 192),
(1420, 2041014, 4160004, 1000, 0, 196),
(1421, 2041014, 4160003, 1000, 0, 200),
(1422, 2041014, 4160002, 1000, 0, 204),
(1423, 2041014, 4160001, 1000, 0, 208),
(1424, 2041014, 4160000, 1000, 0, 212),
(1425, 2041014, 4160026, 1000, 0, 216),
(1426, 2041014, 2260000, 1000, 0, 220),
(1427, 2041014, 2120000, 30, 0, 224),
(1428, 2041016, 4031348, 10000000, 0, 104),
(1429, 2041016, 2044900, 69000, 0, 108),
(1430, 2041016, 2044800, 69000, 0, 112),
(1431, 2041016, 2044700, 69000, 0, 116),
(1432, 2041016, 2044600, 69000, 0, 120),
(1433, 2041016, 2044500, 69000, 0, 124),
(1434, 2041016, 2043800, 69000, 0, 128),
(1435, 2041016, 2043700, 69000, 0, 132),
(1436, 2041016, 2044400, 69000, 0, 136),
(1437, 2041016, 2044300, 69000, 0, 140),
(1438, 2041016, 2044200, 69000, 0, 144),
(1439, 2041016, 2044100, 69000, 0, 148),
(1440, 2041016, 2044000, 69000, 0, 152),
(1441, 2041016, 2043300, 69000, 0, 156),
(1442, 2041016, 2043200, 69000, 0, 160),
(1443, 2041016, 2043100, 69000, 0, 164),
(1444, 2041016, 2043000, 69000, 0, 168),
(1445, 2041016, 2041003, 34000, 0, 172),
(1446, 2041016, 2041000, 34000, 0, 176),
(1447, 2041016, 2040900, 34000, 0, 180),
(1448, 2041016, 2040800, 34000, 0, 184),
(1449, 2041016, 2040706, 34000, 0, 188),
(1450, 2041016, 2040703, 34000, 0, 192),
(1451, 2041016, 2040700, 34000, 0, 196),
(1452, 2041016, 2040600, 34000, 0, 200),
(1453, 2041016, 2040503, 34000, 0, 204),
(1454, 2041016, 2040400, 34000, 0, 208),
(1455, 2041016, 2040000, 34000, 0, 212),
(1456, 2041016, 2040300, 34000, 0, 216),
(1457, 2050000, 1492006, 160000, 0, 104),
(1458, 2050000, 1492005, 100000, 0, 108),
(1459, 2050000, 1482006, 150000, 0, 112),
(1460, 2050000, 1482005, 100000, 0, 116),
(1461, 2050000, 1472007, 60000, 0, 120),
(1462, 2050000, 1472004, 30000, 0, 124),
(1463, 2050000, 1462005, 250000, 0, 128),
(1464, 2050000, 1462004, 200000, 0, 132),
(1465, 2050000, 1452007, 375000, 0, 136),
(1466, 2050000, 1452006, 250000, 0, 140),
(1467, 2050000, 1442009, 300000, 0, 144),
(1468, 2050000, 1442003, 175000, 0, 148),
(1469, 2050000, 1432005, 225000, 0, 152),
(1470, 2050000, 1432003, 175000, 0, 156),
(1471, 2050000, 1422007, 250000, 0, 160),
(1472, 2050000, 1422008, 200000, 0, 164),
(1473, 2050000, 1412005, 250000, 0, 168),
(1474, 2050000, 1412004, 200000, 0, 172),
(1475, 2050000, 1402007, 450000, 0, 176),
(1476, 2050000, 1402006, 350000, 0, 180),
(1477, 2050000, 1372000, 400000, 0, 184),
(1478, 2050000, 1372001, 175000, 0, 188),
(1479, 2050000, 1332011, 425000, 0, 192),
(1480, 2050000, 1332014, 375000, 0, 196),
(1481, 2050000, 1332001, 200000, 0, 200),
(1482, 2050000, 1322016, 175000, 0, 204),
(1483, 2050000, 1322015, 100000, 0, 208),
(1484, 2050000, 1312007, 175000, 0, 212),
(1485, 2050000, 1312006, 100000, 0, 216),
(1486, 2050000, 1302009, 225000, 0, 220),
(1487, 2050000, 1302004, 100000, 0, 224),
(1488, 2050003, 1002625, 75000, 0, 104),
(1489, 2050003, 1052113, 120000, 0, 108),
(1490, 2050003, 1052110, 100000, 0, 112),
(1491, 2050003, 1061069, 160000, 0, 116),
(1492, 2050003, 1061070, 160000, 0, 120),
(1493, 2050003, 1060072, 160000, 0, 124),
(1494, 2050003, 1060071, 160000, 0, 128),
(1495, 2050003, 1060052, 108000, 0, 132),
(1496, 2050003, 1060050, 108000, 0, 136),
(1497, 2050003, 1060051, 108000, 0, 140),
(1498, 2050003, 1051009, 111000, 0, 144),
(1499, 2050003, 1051008, 111000, 0, 148),
(1500, 2050003, 1051007, 111000, 0, 152),
(1501, 2050003, 1041074, 180000, 0, 156),
(1502, 2050003, 1041075, 180000, 0, 160),
(1503, 2050003, 1040083, 180000, 0, 164),
(1504, 2050003, 1040082, 180000, 0, 168),
(1505, 2050003, 1040061, 114000, 0, 172),
(1506, 2050003, 1040062, 114000, 0, 176),
(1507, 2050003, 1040063, 114000, 0, 180),
(1508, 2050003, 1002180, 100000, 0, 184),
(1509, 2050003, 1002179, 100000, 0, 188),
(1510, 2050003, 1002178, 100000, 0, 192),
(1511, 2050003, 1002177, 100000, 0, 196),
(1512, 2050003, 1002176, 100000, 0, 200),
(1513, 2050003, 1061080, 160000, 0, 204),
(1514, 2050003, 1061081, 160000, 0, 208),
(1515, 2050003, 1061062, 108000, 0, 212),
(1516, 2050003, 1061060, 108000, 0, 216),
(1517, 2050003, 1061064, 108000, 0, 220),
(1518, 2050003, 1061061, 108000, 0, 224),
(1519, 2050003, 1060069, 160000, 0, 228),
(1520, 2050003, 1060070, 160000, 0, 232),
(1521, 2050003, 1060063, 108000, 0, 236),
(1522, 2050003, 1060061, 108000, 0, 240),
(1523, 2050003, 1060065, 108000, 0, 244),
(1524, 2050003, 1060062, 108000, 0, 248),
(1525, 2050003, 1041081, 180000, 0, 252),
(1526, 2050003, 1041082, 180000, 0, 256),
(1527, 2050003, 1041067, 114000, 0, 260),
(1528, 2050003, 1041065, 114000, 0, 264),
(1529, 2050003, 1041069, 114000, 0, 268),
(1530, 2050003, 1041066, 114000, 0, 272),
(1531, 2050003, 1040079, 180000, 0, 276),
(1532, 2050003, 1040081, 180000, 0, 280),
(1533, 2050003, 1040076, 114000, 0, 284),
(1534, 2050003, 1040074, 114000, 0, 288),
(1535, 2050003, 1040073, 114000, 0, 292),
(1536, 2050003, 1040072, 114000, 0, 296),
(1537, 2050003, 1002137, 100000, 0, 300),
(1538, 2050003, 1002135, 100000, 0, 304),
(1539, 2050003, 1002139, 100000, 0, 308),
(1540, 2050003, 1002138, 100000, 0, 312),
(1541, 2050003, 1061047, 120000, 0, 316),
(1542, 2050003, 1061048, 120000, 0, 320),
(1543, 2050003, 1051027, 450000, 0, 324),
(1544, 2050003, 1051024, 450000, 0, 328),
(1545, 2050003, 1051025, 450000, 0, 332),
(1546, 2050003, 1051023, 450000, 0, 336),
(1547, 2050003, 1050037, 450000, 0, 340),
(1548, 2050003, 1050036, 450000, 0, 344),
(1549, 2050003, 1050038, 450000, 0, 348),
(1550, 2050003, 1050035, 450000, 0, 352),
(1551, 2050003, 1050002, 300000, 0, 356),
(1552, 2050003, 1050031, 300000, 0, 360),
(1553, 2050003, 1041051, 120000, 0, 364),
(1554, 2050003, 1041052, 120000, 0, 368),
(1555, 2050003, 1002144, 96000, 0, 372),
(1556, 2050003, 1002143, 96000, 0, 376),
(1557, 2050003, 1002142, 96000, 0, 380),
(1558, 2050003, 1002141, 96000, 0, 384),
(1559, 2050003, 1092002, 200000, 0, 388),
(1560, 2050003, 1092001, 100000, 0, 392),
(1561, 2050003, 1061084, 180000, 0, 396),
(1562, 2050003, 1061083, 180000, 0, 400),
(1563, 2050003, 1060074, 180000, 0, 404),
(1564, 2050003, 1060075, 180000, 0, 408),
(1565, 2050003, 1051014, 112500, 0, 412),
(1566, 2050003, 1051001, 112500, 0, 416),
(1567, 2050003, 1050021, 112500, 0, 420),
(1568, 2050003, 1050000, 112500, 0, 424),
(1569, 2050003, 1041085, 200000, 0, 428),
(1570, 2050003, 1041084, 200000, 0, 432),
(1571, 2050003, 1040085, 200000, 0, 436),
(1572, 2050003, 1040000, 200000, 0, 440),
(1573, 2050003, 1002004, 160000, 0, 444),
(1574, 2051000, 2330000, 600, 0, 104),
(1575, 2051000, 2070000, 500, 0, 108),
(1576, 2051000, 2061001, 10, 0, 112),
(1577, 2051000, 2060001, 10, 0, 116),
(1580, 2051000, 2061000, 1, 0, 128),
(1581, 2051000, 2060000, 1, 0, 132),
(1582, 2051000, 2030000, 400, 0, 136),
(1583, 2051000, 2022000, 1567, 0, 140),
(1584, 2051000, 2022003, 1045, 0, 144),
(1585, 2051000, 2020015, 9690, 0, 148),
(1586, 2051000, 2020014, 7695, 0, 152),
(1587, 2051000, 2020013, 5600, 0, 156),
(1588, 2051000, 2020012, 4680, 0, 160),
(1589, 2051000, 2010004, 294, 0, 164),
(1590, 2051000, 2010003, 95, 0, 168),
(1591, 2051000, 2010002, 47, 0, 172),
(1592, 2051000, 2010001, 106, 0, 176),
(1593, 2051000, 2010000, 28, 0, 180),
(1594, 2051000, 2001002, 3800, 0, 184),
(1595, 2051000, 2001001, 2185, 0, 188),
(1596, 2051000, 2001000, 3040, 0, 192),
(1597, 2051000, 2002011, 1200, 0, 196),
(1598, 2051000, 2002005, 475, 0, 200),
(1599, 2051000, 2002004, 475, 0, 204),
(1600, 2051000, 2002002, 475, 0, 208),
(1601, 2051000, 2002001, 380, 0, 212),
(1602, 2051000, 2002000, 475, 0, 216),
(1603, 2051000, 2000006, 589, 0, 220),
(1604, 2051000, 2000003, 190, 0, 224),
(1605, 2051000, 2000002, 304, 0, 228),
(1606, 2051000, 2000001, 152, 0, 232),
(1607, 2051000, 2000000, 47, 0, 236),
(1608, 2060003, 1002625, 75000, 0, 104),
(1609, 2060003, 1052113, 120000, 0, 108),
(1610, 2060003, 1052110, 100000, 0, 112),
(1611, 2060003, 1052107, 90000, 0, 116),
(1612, 2060003, 1002622, 40000, 0, 120),
(1613, 2060003, 1061070, 160000, 0, 124),
(1614, 2060003, 1061069, 160000, 0, 128),
(1615, 2060003, 1041075, 180000, 0, 132),
(1616, 2060003, 1041074, 180000, 0, 136),
(1617, 2060003, 1060072, 160000, 0, 140),
(1618, 2060003, 1060071, 160000, 0, 144),
(1619, 2060003, 1040083, 180000, 0, 148),
(1620, 2060003, 1040082, 180000, 0, 152),
(1621, 2060003, 1051009, 111000, 0, 156),
(1622, 2060003, 1051008, 111000, 0, 160),
(1623, 2060003, 1051007, 111000, 0, 164),
(1624, 2060003, 1060051, 108000, 0, 168),
(1625, 2060003, 1060050, 108000, 0, 172),
(1626, 2060003, 1040062, 114000, 0, 176),
(1627, 2060003, 1040061, 114000, 0, 180),
(1628, 2060003, 1060045, 40000, 0, 184),
(1629, 2060003, 1060043, 40000, 0, 188),
(1630, 2060003, 1040059, 45000, 0, 192),
(1631, 2060003, 1040057, 45000, 0, 196),
(1632, 2060003, 1061046, 40000, 0, 200),
(1633, 2060003, 1061045, 40000, 0, 204),
(1634, 2060003, 1061043, 40000, 0, 208),
(1635, 2060003, 1041050, 45000, 0, 212),
(1636, 2060003, 1041049, 45000, 0, 216),
(1637, 2060003, 1041047, 45000, 0, 220),
(1638, 2060003, 1061081, 160000, 0, 224),
(1639, 2060003, 1061080, 160000, 0, 228),
(1640, 2060003, 1041082, 180000, 0, 232),
(1641, 2060003, 1041081, 180000, 0, 236),
(1642, 2060003, 1060070, 160000, 0, 240),
(1643, 2060003, 1060069, 160000, 0, 244),
(1644, 2060003, 1040081, 180000, 0, 248),
(1645, 2060003, 1040079, 180000, 0, 252),
(1646, 2060003, 1060063, 108000, 0, 256),
(1647, 2060003, 1060062, 108000, 0, 260),
(1648, 2060003, 1060061, 108000, 0, 264),
(1649, 2060003, 1040074, 114000, 0, 268),
(1650, 2060003, 1040073, 114000, 0, 272),
(1651, 2060003, 1040072, 114000, 0, 276),
(1652, 2060003, 1061062, 108000, 0, 280),
(1653, 2060003, 1061061, 108000, 0, 284),
(1654, 2060003, 1061060, 108000, 0, 288),
(1655, 2060003, 1041067, 114000, 0, 292),
(1656, 2060003, 1041066, 114000, 0, 296),
(1657, 2060003, 1041065, 114000, 0, 300),
(1658, 2060003, 1060058, 44000, 0, 304),
(1659, 2060003, 1060056, 44000, 0, 308),
(1660, 2060003, 1040069, 50000, 0, 312),
(1661, 2060003, 1040067, 50000, 0, 316),
(1662, 2060003, 1061052, 44000, 0, 320),
(1663, 2060003, 1061050, 44000, 0, 324),
(1664, 2060003, 1041056, 50000, 0, 328),
(1665, 2060003, 1041054, 50000, 0, 332),
(1666, 2060003, 1050038, 450000, 0, 336),
(1667, 2060003, 1050037, 450000, 0, 340),
(1668, 2060003, 1050036, 450000, 0, 344),
(1669, 2060003, 1051025, 450000, 0, 348),
(1670, 2060003, 1051024, 450000, 0, 352),
(1671, 2060003, 1051023, 450000, 0, 356),
(1672, 2060003, 1050031, 300000, 0, 360),
(1673, 2060003, 1050030, 300000, 0, 364),
(1674, 2060003, 1050002, 300000, 0, 368),
(1675, 2060003, 1061048, 120000, 0, 372),
(1676, 2060003, 1061047, 120000, 0, 376),
(1677, 2060003, 1041052, 120000, 0, 380),
(1678, 2060003, 1041051, 120000, 0, 384),
(1679, 2060003, 1050028, 40000, 0, 388),
(1680, 2060003, 1050026, 40000, 0, 392),
(1681, 2060003, 1050003, 40000, 0, 396),
(1682, 2060003, 1061036, 40000, 0, 400),
(1683, 2060003, 1061035, 40000, 0, 404),
(1684, 2060003, 1061034, 40000, 0, 408),
(1685, 2060003, 1041043, 42000, 0, 412),
(1686, 2060003, 1041042, 42000, 0, 416),
(1687, 2060003, 1041041, 42000, 0, 420),
(1688, 2060003, 1061084, 180000, 0, 424),
(1689, 2060003, 1061083, 180000, 0, 428),
(1690, 2060003, 1060075, 180000, 0, 432),
(1691, 2060003, 1060074, 180000, 0, 436),
(1692, 2060003, 1041085, 200000, 0, 440),
(1693, 2060003, 1041084, 200000, 0, 444),
(1694, 2060003, 1040086, 200000, 0, 448),
(1695, 2060003, 1040085, 200000, 0, 452),
(1696, 2060003, 1051015, 112500, 0, 456),
(1697, 2060003, 1051014, 112500, 0, 460),
(1698, 2060003, 1051001, 112500, 0, 464),
(1699, 2060003, 1050021, 112500, 0, 468),
(1700, 2060003, 1050000, 112500, 0, 472),
(1701, 2060003, 1060017, 38000, 0, 476),
(1702, 2060003, 1060016, 38000, 0, 480),
(1703, 2060003, 1040026, 40000, 0, 484),
(1704, 2060003, 1040021, 40000, 0, 488),
(1705, 2060003, 1050011, 70000, 0, 492),
(1706, 2060003, 1051013, 60000, 0, 496),
(1707, 2060003, 1051012, 60000, 0, 500),
(1708, 2060003, 1051011, 60000, 0, 504),
(1709, 2060003, 1002177, 100000, 0, 508),
(1710, 2060003, 1002172, 60000, 0, 512),
(1711, 2060003, 1002138, 100000, 0, 516),
(1712, 2060003, 1002162, 60000, 0, 520),
(1713, 2060003, 1002142, 96000, 0, 524),
(1714, 2060003, 1002034, 60000, 0, 528),
(1715, 2060003, 1002048, 160000, 0, 532),
(1716, 2060003, 1002023, 120000, 0, 536),
(1717, 2060004, 2330000, 600, 0, 104),
(1718, 2060004, 2070000, 500, 0, 108),
(1719, 2060004, 2061001, 10, 0, 112),
(1720, 2060004, 2060001, 10, 0, 116),
(1723, 2060004, 2061000, 1, 0, 128),
(1724, 2060004, 2060000, 1, 0, 132),
(1725, 2060004, 2030000, 400, 0, 136),
(1726, 2060004, 2022000, 1650, 0, 140),
(1727, 2060004, 2022003, 1100, 0, 144),
(1728, 2060004, 2020015, 10200, 0, 148),
(1729, 2060004, 2020014, 8100, 0, 152),
(1730, 2060004, 2020013, 5600, 0, 156),
(1731, 2060004, 2020012, 4500, 0, 160),
(1732, 2060004, 2010004, 310, 0, 164),
(1733, 2060004, 2010003, 100, 0, 168),
(1734, 2060004, 2010001, 106, 0, 172),
(1735, 2060004, 2010002, 50, 0, 176),
(1736, 2060004, 2010000, 30, 0, 180),
(1737, 2060004, 2001002, 4000, 0, 184),
(1738, 2060004, 2001001, 2300, 0, 188),
(1739, 2060004, 2001000, 3200, 0, 192),
(1740, 2060004, 2022041, 1600, 0, 196),
(1741, 2060004, 2022040, 300, 0, 200),
(1742, 2060004, 2002005, 500, 0, 204),
(1743, 2060004, 2002004, 500, 0, 208),
(1744, 2060004, 2002002, 500, 0, 212),
(1745, 2060004, 2002001, 400, 0, 216),
(1746, 2060004, 2002000, 500, 0, 220),
(1747, 2060004, 2000006, 620, 0, 224),
(1748, 2060004, 2000003, 200, 0, 228),
(1749, 2060004, 2000002, 320, 0, 232),
(1750, 2060004, 2000001, 160, 0, 236),
(1751, 2060004, 2000000, 50, 0, 240),
(1752, 2060007, 1492006, 160000, 0, 104),
(1753, 2060007, 1492005, 100000, 0, 108),
(1754, 2060007, 1492004, 75000, 0, 112),
(1755, 2060007, 1482006, 150000, 0, 116),
(1756, 2060007, 1482005, 100000, 0, 120),
(1757, 2060007, 1482004, 75000, 0, 124),
(1758, 2060007, 1472007, 60000, 0, 128),
(1759, 2060007, 1462005, 250000, 0, 132),
(1760, 2060007, 1462004, 200000, 0, 136),
(1761, 2060007, 1462000, 30000, 0, 140),
(1762, 2060007, 1462003, 12000, 0, 144),
(1763, 2060007, 1452007, 375000, 0, 148),
(1764, 2060007, 1452006, 250000, 0, 152),
(1765, 2060007, 1452005, 150000, 0, 156),
(1766, 2060007, 1452000, 20000, 0, 160),
(1767, 2060007, 1442009, 300000, 0, 164),
(1768, 2060007, 1442003, 175000, 0, 168),
(1769, 2060007, 1442001, 60000, 0, 172),
(1770, 2060007, 1442004, 24000, 0, 176),
(1771, 2060007, 1432005, 225000, 0, 180),
(1772, 2060007, 1432003, 175000, 0, 184),
(1773, 2060007, 1432002, 60000, 0, 188),
(1774, 2060007, 1422007, 250000, 0, 192),
(1775, 2060007, 1422008, 200000, 0, 196),
(1776, 2060007, 1422001, 45000, 0, 200),
(1777, 2060007, 1422004, 20000, 0, 204),
(1778, 2060007, 1412005, 250000, 0, 208),
(1779, 2060007, 1412006, 45000, 0, 212),
(1780, 2060007, 1412004, 200000, 0, 216),
(1781, 2060007, 1412000, 22000, 0, 220),
(1782, 2060007, 1402007, 450000, 0, 224),
(1783, 2060007, 1402006, 350000, 0, 228),
(1784, 2060007, 1402002, 150000, 0, 232),
(1785, 2060007, 1402008, 22000, 0, 236),
(1786, 2060007, 1372000, 400000, 0, 240),
(1787, 2060007, 1372001, 175000, 0, 244),
(1788, 2060007, 1372003, 38000, 0, 248),
(1789, 2060007, 1382002, 20000, 0, 252),
(1790, 2060007, 1372004, 18000, 0, 256),
(1791, 2060007, 1332011, 425000, 0, 260),
(1792, 2060007, 1332014, 375000, 0, 264),
(1793, 2060007, 1332012, 40000, 0, 268),
(1794, 2060007, 1332004, 38000, 0, 272),
(1795, 2060007, 1322016, 175000, 0, 276),
(1796, 2060007, 1322015, 100000, 0, 280),
(1797, 2060007, 1322014, 40000, 0, 284),
(1798, 2060007, 1322004, 22000, 0, 288),
(1799, 2060007, 1312007, 175000, 0, 292),
(1800, 2060007, 1312006, 100000, 0, 296),
(1801, 2060007, 1312005, 40000, 0, 300),
(1802, 2060007, 1312003, 20000, 0, 304),
(1803, 2060007, 1302009, 225000, 0, 308),
(1804, 2060007, 1302004, 100000, 0, 312),
(1805, 2060007, 1302008, 40000, 0, 316),
(1806, 2060007, 1302003, 20000, 0, 320),
(1807, 2070001, 2330000, 600, 0, 104),
(1808, 2070001, 2070000, 500, 0, 108),
(1809, 2070001, 2061001, 10, 0, 112),
(1810, 2070001, 2060001, 10, 0, 116),
(1813, 2070001, 2061000, 1, 0, 128),
(1814, 2070001, 2060000, 1, 0, 132),
(1815, 2070001, 2030000, 400, 0, 136),
(1816, 2070001, 2022000, 1650, 0, 140),
(1817, 2070001, 2022003, 1100, 0, 144),
(1818, 2070001, 2020015, 10200, 0, 148),
(1819, 2070001, 2020014, 8100, 0, 152),
(1820, 2070001, 2020013, 5600, 0, 156),
(1821, 2070001, 2020012, 4500, 0, 160),
(1822, 2070001, 2010004, 310, 0, 164),
(1823, 2070001, 2010003, 100, 0, 168),
(1824, 2070001, 2010001, 106, 0, 172),
(1825, 2070001, 2010002, 50, 0, 176),
(1826, 2070001, 2010000, 30, 0, 180),
(1827, 2070001, 2001002, 4000, 0, 184),
(1828, 2070001, 2001001, 2300, 0, 188),
(1829, 2070001, 2001000, 3200, 0, 192),
(1830, 2070001, 2002005, 500, 0, 196),
(1831, 2070001, 2002004, 500, 0, 200),
(1832, 2070001, 2002002, 500, 0, 204),
(1833, 2070001, 2002001, 400, 0, 208),
(1834, 2070001, 2002000, 500, 0, 212),
(1835, 2070001, 2000006, 620, 0, 216),
(1836, 2070001, 2000003, 200, 0, 220),
(1837, 2070001, 2000002, 320, 0, 224),
(1838, 2070001, 2000001, 160, 0, 228),
(1839, 2070001, 2000000, 50, 0, 232),
(1840, 2070002, 1492006, 160000, 0, 104),
(1841, 2070002, 1492005, 100000, 0, 108),
(1842, 2070002, 1482006, 150000, 0, 112),
(1843, 2070002, 1482005, 100000, 0, 116),
(1844, 2070002, 1472007, 60000, 0, 120),
(1845, 2070002, 1472004, 30000, 0, 124),
(1846, 2070002, 1462005, 250000, 0, 128),
(1847, 2070002, 1462004, 200000, 0, 132),
(1848, 2070002, 1452007, 375000, 0, 136),
(1849, 2070002, 1452006, 250000, 0, 140),
(1850, 2070002, 1442009, 300000, 0, 144),
(1851, 2070002, 1442003, 175000, 0, 148),
(1852, 2070002, 1432005, 225000, 0, 152),
(1853, 2070002, 1432003, 175000, 0, 156),
(1854, 2070002, 1422007, 250000, 0, 160),
(1855, 2070002, 1422008, 200000, 0, 164),
(1856, 2070002, 1412005, 250000, 0, 168),
(1857, 2070002, 1412004, 200000, 0, 172),
(1858, 2070002, 1402007, 450000, 0, 176),
(1859, 2070002, 1402006, 350000, 0, 180),
(1860, 2070002, 1372000, 400000, 0, 184),
(1861, 2070002, 1372001, 175000, 0, 188),
(1862, 2070002, 1332011, 425000, 0, 192),
(1863, 2070002, 1332014, 375000, 0, 196),
(1864, 2070002, 1332001, 200000, 0, 200),
(1865, 2070002, 1322016, 175000, 0, 204),
(1866, 2070002, 1322015, 100000, 0, 208),
(1867, 2070002, 1312007, 175000, 0, 212),
(1868, 2070002, 1312006, 100000, 0, 216),
(1869, 2070002, 1302009, 225000, 0, 220),
(1870, 2070002, 1302004, 100000, 0, 224),
(1871, 2070003, 1002625, 75000, 0, 104),
(1872, 2070003, 1052113, 120000, 0, 108),
(1873, 2070003, 1052110, 100000, 0, 112),
(1874, 2070003, 1052107, 90000, 0, 116),
(1875, 2070003, 1061069, 160000, 0, 120),
(1876, 2070003, 1061070, 160000, 0, 124),
(1877, 2070003, 1060072, 160000, 0, 128),
(1878, 2070003, 1060071, 160000, 0, 132),
(1879, 2070003, 1060052, 108000, 0, 136),
(1880, 2070003, 1060050, 108000, 0, 140),
(1881, 2070003, 1060051, 108000, 0, 144),
(1882, 2070003, 1051009, 111000, 0, 148),
(1883, 2070003, 1051008, 111000, 0, 152),
(1884, 2070003, 1051007, 111000, 0, 156),
(1885, 2070003, 1041074, 180000, 0, 160),
(1886, 2070003, 1041075, 180000, 0, 164),
(1887, 2070003, 1040083, 180000, 0, 168),
(1888, 2070003, 1040082, 180000, 0, 172),
(1889, 2070003, 1040061, 114000, 0, 176),
(1890, 2070003, 1040062, 114000, 0, 180),
(1891, 2070003, 1040063, 114000, 0, 184),
(1892, 2070003, 1002180, 100000, 0, 188),
(1893, 2070003, 1002179, 100000, 0, 192),
(1894, 2070003, 1002178, 100000, 0, 196),
(1895, 2070003, 1002177, 100000, 0, 200),
(1896, 2070003, 1002176, 100000, 0, 204),
(1897, 2070003, 1061080, 160000, 0, 208),
(1898, 2070003, 1061081, 160000, 0, 212),
(1899, 2070003, 1061062, 108000, 0, 216),
(1900, 2070003, 1061060, 108000, 0, 220),
(1901, 2070003, 1061064, 108000, 0, 224),
(1902, 2070003, 1061061, 108000, 0, 228),
(1903, 2070003, 1060069, 160000, 0, 232),
(1904, 2070003, 1060070, 160000, 0, 236),
(1905, 2070003, 1060063, 108000, 0, 240),
(1906, 2070003, 1060061, 108000, 0, 244),
(1907, 2070003, 1060065, 108000, 0, 248),
(1908, 2070003, 1060062, 108000, 0, 252),
(1909, 2070003, 1041081, 180000, 0, 256),
(1910, 2070003, 1041082, 180000, 0, 260),
(1911, 2070003, 1041067, 114000, 0, 264),
(1912, 2070003, 1041065, 114000, 0, 268),
(1913, 2070003, 1041069, 114000, 0, 272),
(1914, 2070003, 1041066, 114000, 0, 276),
(1915, 2070003, 1040079, 180000, 0, 280),
(1916, 2070003, 1040081, 180000, 0, 284),
(1917, 2070003, 1040076, 114000, 0, 288),
(1918, 2070003, 1040074, 114000, 0, 292),
(1919, 2070003, 1040073, 114000, 0, 296),
(1920, 2070003, 1040072, 114000, 0, 300),
(1921, 2070003, 1002137, 100000, 0, 304),
(1922, 2070003, 1002135, 100000, 0, 308),
(1923, 2070003, 1002139, 100000, 0, 312),
(1924, 2070003, 1002138, 100000, 0, 316),
(1925, 2070003, 1061047, 120000, 0, 320),
(1926, 2070003, 1061048, 120000, 0, 324),
(1927, 2070003, 1051027, 450000, 0, 328),
(1928, 2070003, 1051024, 450000, 0, 332),
(1929, 2070003, 1051025, 450000, 0, 336),
(1930, 2070003, 1051023, 450000, 0, 340),
(1931, 2070003, 1050037, 450000, 0, 344),
(1932, 2070003, 1050036, 450000, 0, 348),
(1933, 2070003, 1050038, 450000, 0, 352),
(1934, 2070003, 1050035, 450000, 0, 356),
(1935, 2070003, 1050002, 300000, 0, 360),
(1936, 2070003, 1050031, 300000, 0, 364),
(1937, 2070003, 1041051, 120000, 0, 368),
(1938, 2070003, 1041052, 120000, 0, 372),
(1939, 2070003, 1002144, 96000, 0, 376),
(1940, 2070003, 1002143, 96000, 0, 380),
(1941, 2070003, 1002142, 96000, 0, 384),
(1942, 2070003, 1002141, 96000, 0, 388),
(1943, 2070003, 1092002, 200000, 0, 392),
(1944, 2070003, 1092001, 100000, 0, 396),
(1945, 2070003, 1061084, 180000, 0, 400),
(1946, 2070003, 1061083, 180000, 0, 404),
(1947, 2070003, 1060074, 180000, 0, 408),
(1948, 2070003, 1060075, 180000, 0, 412),
(1949, 2070003, 1051014, 112500, 0, 416),
(1950, 2070003, 1051001, 112500, 0, 420),
(1951, 2070003, 1050021, 112500, 0, 424),
(1952, 2070003, 1050000, 112500, 0, 428),
(1953, 2070003, 1041085, 200000, 0, 432),
(1954, 2070003, 1041084, 200000, 0, 436),
(1955, 2070003, 1040085, 200000, 0, 440),
(1956, 2070003, 1040000, 200000, 0, 444),
(1957, 2070003, 1002004, 160000, 0, 448),
(1958, 2080001, 2330000, 600, 0, 104),
(1959, 2080001, 2070000, 500, 0, 108),
(1960, 2080001, 2061001, 10, 0, 112),
(1961, 2080001, 2060001, 10, 0, 116),
(1964, 2080001, 2061000, 1, 0, 128),
(1965, 2080001, 2060000, 1, 0, 132),
(1966, 2080001, 2030000, 400, 0, 136),
(1967, 2080001, 2020015, 10200, 0, 140),
(1968, 2080001, 2020014, 8100, 0, 144),
(1969, 2080001, 2020013, 5600, 0, 148),
(1970, 2080001, 2020012, 4500, 0, 152),
(1971, 2080001, 2010004, 310, 0, 156),
(1972, 2080001, 2010003, 100, 0, 160),
(1973, 2080001, 2010001, 106, 0, 164),
(1974, 2080001, 2010002, 50, 0, 168),
(1975, 2080001, 2010000, 30, 0, 172),
(1976, 2080001, 2001002, 4000, 0, 176),
(1977, 2080001, 2001001, 2300, 0, 180),
(1978, 2080001, 2001000, 3200, 0, 184),
(1979, 2080001, 2022089, 3400, 0, 188),
(1980, 2080001, 2002005, 500, 0, 192),
(1981, 2080001, 2002004, 500, 0, 196),
(1982, 2080001, 2002002, 500, 0, 200),
(1983, 2080001, 2002001, 400, 0, 204),
(1984, 2080001, 2002000, 500, 0, 208),
(1985, 2080001, 2000006, 620, 0, 212),
(1986, 2080001, 2000003, 200, 0, 216),
(1987, 2080001, 2000002, 320, 0, 220),
(1988, 2080001, 2000001, 160, 0, 224),
(1989, 2080001, 2000000, 50, 0, 228),
(1990, 2080002, 1002625, 75000, 0, 104),
(1991, 2080002, 1052113, 120000, 0, 108),
(1992, 2080002, 1052110, 100000, 0, 112),
(1993, 2080002, 1061069, 160000, 0, 116),
(1994, 2080002, 1061070, 160000, 0, 120),
(1995, 2080002, 1060072, 160000, 0, 124),
(1996, 2080002, 1060071, 160000, 0, 128),
(1997, 2080002, 1060052, 108000, 0, 132),
(1998, 2080002, 1060050, 108000, 0, 136),
(1999, 2080002, 1060051, 108000, 0, 140),
(2000, 2080002, 1051009, 111000, 0, 144),
(2001, 2080002, 1051008, 111000, 0, 148),
(2002, 2080002, 1051007, 111000, 0, 152),
(2003, 2080002, 1041074, 180000, 0, 156),
(2004, 2080002, 1041075, 180000, 0, 160),
(2005, 2080002, 1040083, 180000, 0, 164),
(2006, 2080002, 1040082, 180000, 0, 168),
(2007, 2080002, 1040061, 114000, 0, 172),
(2008, 2080002, 1040062, 114000, 0, 176),
(2009, 2080002, 1040063, 114000, 0, 180),
(2010, 2080002, 1002180, 100000, 0, 184),
(2011, 2080002, 1002179, 100000, 0, 188),
(2012, 2080002, 1002178, 100000, 0, 192),
(2013, 2080002, 1002177, 100000, 0, 196),
(2014, 2080002, 1002176, 100000, 0, 200),
(2015, 2080002, 1061080, 160000, 0, 204),
(2016, 2080002, 1061081, 160000, 0, 208),
(2017, 2080002, 1061062, 108000, 0, 212),
(2018, 2080002, 1061060, 108000, 0, 216),
(2019, 2080002, 1061064, 108000, 0, 220),
(2020, 2080002, 1061061, 108000, 0, 224),
(2021, 2080002, 1060069, 160000, 0, 228),
(2022, 2080002, 1060070, 160000, 0, 232),
(2023, 2080002, 1060063, 108000, 0, 236),
(2024, 2080002, 1060061, 108000, 0, 240),
(2025, 2080002, 1060065, 108000, 0, 244),
(2026, 2080002, 1060062, 108000, 0, 248),
(2027, 2080002, 1041081, 180000, 0, 252),
(2028, 2080002, 1041082, 180000, 0, 256),
(2029, 2080002, 1041067, 114000, 0, 260),
(2030, 2080002, 1041065, 114000, 0, 264),
(2031, 2080002, 1041069, 114000, 0, 268),
(2032, 2080002, 1041066, 114000, 0, 272),
(2033, 2080002, 1040079, 180000, 0, 276),
(2034, 2080002, 1040081, 180000, 0, 280),
(2035, 2080002, 1040076, 114000, 0, 284),
(2036, 2080002, 1040074, 114000, 0, 288),
(2037, 2080002, 1040073, 114000, 0, 292),
(2038, 2080002, 1040072, 114000, 0, 296),
(2039, 2080002, 1002137, 100000, 0, 300),
(2040, 2080002, 1002135, 100000, 0, 304),
(2041, 2080002, 1002139, 100000, 0, 308),
(2042, 2080002, 1002138, 100000, 0, 312),
(2043, 2080002, 1061047, 120000, 0, 316),
(2044, 2080002, 1061048, 120000, 0, 320),
(2045, 2080002, 1051027, 450000, 0, 324),
(2046, 2080002, 1051024, 450000, 0, 328),
(2047, 2080002, 1051025, 450000, 0, 332),
(2048, 2080002, 1051023, 450000, 0, 336),
(2049, 2080002, 1050037, 450000, 0, 340),
(2050, 2080002, 1050036, 450000, 0, 344),
(2051, 2080002, 1050038, 450000, 0, 348),
(2052, 2080002, 1050035, 450000, 0, 352),
(2053, 2080002, 1050002, 300000, 0, 356),
(2054, 2080002, 1050031, 300000, 0, 360),
(2055, 2080002, 1041051, 120000, 0, 364),
(2056, 2080002, 1041052, 120000, 0, 368),
(2057, 2080002, 1002144, 96000, 0, 372),
(2058, 2080002, 1002143, 96000, 0, 376),
(2059, 2080002, 1002142, 96000, 0, 380),
(2060, 2080002, 1002141, 96000, 0, 384),
(2061, 2080002, 1092002, 200000, 0, 388),
(2062, 2080002, 1092001, 100000, 0, 392),
(2063, 2080002, 1061084, 180000, 0, 396),
(2064, 2080002, 1061083, 180000, 0, 400),
(2065, 2080002, 1060074, 180000, 0, 404),
(2066, 2080002, 1060075, 180000, 0, 408),
(2067, 2080002, 1051014, 112500, 0, 412),
(2068, 2080002, 1051001, 112500, 0, 416),
(2069, 2080002, 1050021, 112500, 0, 420),
(2070, 2080002, 1050000, 112500, 0, 424),
(2071, 2080002, 1041085, 200000, 0, 428),
(2072, 2080002, 1041084, 200000, 0, 432),
(2073, 2080002, 1040085, 200000, 0, 436),
(2074, 2080002, 1040000, 200000, 0, 440),
(2075, 2080002, 1002004, 160000, 0, 444),
(2076, 2080003, 2044900, 70000, 0, 104),
(2077, 2080003, 2044800, 70000, 0, 108),
(2078, 2080003, 2044700, 70000, 0, 112),
(2079, 2080003, 2044600, 70000, 0, 116),
(2080, 2080003, 2044500, 70000, 0, 120),
(2081, 2080003, 2044400, 70000, 0, 124),
(2082, 2080003, 2044300, 70000, 0, 128),
(2083, 2080003, 2044200, 70000, 0, 132),
(2084, 2080003, 2044100, 70000, 0, 136),
(2085, 2080003, 2044000, 70000, 0, 140),
(2086, 2080003, 2043800, 70000, 0, 144),
(2087, 2080003, 2043700, 70000, 0, 148),
(2088, 2080003, 2043300, 70000, 0, 152),
(2089, 2080003, 2043200, 70000, 0, 156),
(2090, 2080003, 2043100, 70000, 0, 160),
(2091, 2080003, 2043000, 70000, 0, 164),
(2092, 2080003, 2040706, 35000, 0, 168),
(2093, 2080003, 2040703, 35000, 0, 172),
(2094, 2080003, 2041003, 35000, 0, 176),
(2095, 2080003, 2041000, 35000, 0, 180),
(2096, 2080003, 2040900, 35000, 0, 184),
(2097, 2080003, 2040600, 35000, 0, 188),
(2098, 2080003, 2040400, 35000, 0, 192),
(2099, 2080003, 2040300, 35000, 0, 196),
(2100, 2080003, 2040000, 35000, 0, 200),
(2101, 2080004, 4160019, 1000, 0, 104),
(2102, 2080004, 4160039, 1000, 0, 108),
(2103, 2080004, 4160037, 1000, 0, 112),
(2104, 2080004, 4031993, 100000, 0, 116),
(2105, 2080004, 4160036, 1000, 0, 120),
(2106, 2080004, 4160035, 1000, 0, 124),
(2107, 2080004, 4160034, 1000, 0, 128),
(2108, 2080004, 4160032, 1000, 0, 132),
(2109, 2080004, 4160024, 1000, 0, 136),
(2110, 2080004, 4160023, 1000, 0, 140),
(2111, 2080004, 4160022, 1000, 0, 144),
(2112, 2080004, 4160015, 1000, 0, 148),
(2113, 2080004, 4160012, 1000, 0, 152),
(2114, 2080004, 4160013, 1000, 0, 156),
(2115, 2080004, 4160017, 1000, 0, 160),
(2116, 2080004, 4160014, 1000, 0, 164),
(2117, 2080004, 4160020, 1000, 0, 168),
(2118, 2080004, 4160010, 1000, 0, 172),
(2119, 2080004, 4160009, 1000, 0, 176),
(2120, 2080004, 4160008, 1000, 0, 180),
(2121, 2080004, 4160007, 1000, 0, 184),
(2122, 2080004, 4160006, 1000, 0, 188),
(2123, 2080004, 4160005, 1000, 0, 192),
(2124, 2080004, 4160004, 1000, 0, 196),
(2125, 2080004, 4160003, 1000, 0, 200),
(2126, 2080004, 4160002, 1000, 0, 204),
(2127, 2080004, 4160001, 1000, 0, 208),
(2128, 2080004, 4160000, 1000, 0, 212),
(2129, 2080004, 4160026, 1000, 0, 216),
(2130, 2080004, 2260000, 1000, 0, 220),
(2131, 2080004, 2120000, 30, 0, 224),
(2132, 2090001, 1492006, 160000, 0, 104),
(2133, 2090001, 1492005, 100000, 0, 108),
(2134, 2090001, 1482006, 150000, 0, 112),
(2135, 2090001, 1482005, 100000, 0, 116),
(2136, 2090001, 1472007, 60000, 0, 120),
(2137, 2090001, 1472004, 30000, 0, 124),
(2138, 2090001, 1472001, 20000, 0, 128),
(2139, 2090001, 1462005, 250000, 0, 132),
(2140, 2090001, 1462004, 200000, 0, 136),
(2141, 2090001, 1462000, 30000, 0, 140),
(2142, 2090001, 1452007, 375000, 0, 144),
(2143, 2090001, 1452006, 250000, 0, 148),
(2144, 2090001, 1452005, 150000, 0, 152),
(2145, 2090001, 1442009, 300000, 0, 156),
(2146, 2090001, 1442003, 175000, 0, 160),
(2147, 2090001, 1442001, 60000, 0, 164),
(2148, 2090001, 1432005, 225000, 0, 168),
(2149, 2090001, 1432003, 175000, 0, 172),
(2150, 2090001, 1432002, 60000, 0, 176),
(2151, 2090001, 1422007, 250000, 0, 180),
(2152, 2090001, 1422008, 200000, 0, 184),
(2153, 2090001, 1422001, 45000, 0, 188),
(2154, 2090001, 1412005, 250000, 0, 192),
(2155, 2090001, 1412004, 200000, 0, 196),
(2156, 2090001, 1412006, 45000, 0, 200),
(2157, 2090001, 1402007, 450000, 0, 204),
(2158, 2090001, 1402006, 350000, 0, 208),
(2159, 2090001, 1402002, 150000, 0, 212),
(2160, 2090001, 1382002, 20000, 0, 216),
(2161, 2090001, 1372000, 400000, 0, 220),
(2162, 2090001, 1372001, 175000, 0, 224),
(2163, 2090001, 1372003, 38000, 0, 228),
(2164, 2090001, 1332011, 425000, 0, 232),
(2165, 2090001, 1332014, 375000, 0, 236),
(2166, 2090001, 1332001, 200000, 0, 240),
(2167, 2090001, 1332012, 40000, 0, 244),
(2168, 2090001, 1332009, 42000, 0, 248),
(2169, 2090001, 1322016, 175000, 0, 252),
(2170, 2090001, 1322015, 100000, 0, 256),
(2171, 2090001, 1322014, 40000, 0, 260),
(2172, 2090001, 1312007, 175000, 0, 264),
(2173, 2090001, 1312006, 100000, 0, 268),
(2174, 2090001, 1312005, 40000, 0, 272),
(2175, 2090001, 1302009, 225000, 0, 276),
(2176, 2090001, 1302004, 100000, 0, 280),
(2177, 2090001, 1302008, 40000, 0, 284),
(2178, 2090002, 1002625, 75000, 0, 104),
(2179, 2090002, 1052113, 120000, 0, 108),
(2180, 2090002, 1052110, 100000, 0, 112),
(2181, 2090002, 1061069, 160000, 0, 116),
(2182, 2090002, 1061070, 160000, 0, 120),
(2183, 2090002, 1060072, 160000, 0, 124),
(2184, 2090002, 1060071, 160000, 0, 128),
(2185, 2090002, 1060052, 108000, 0, 132),
(2186, 2090002, 1060050, 108000, 0, 136),
(2187, 2090002, 1060051, 108000, 0, 140),
(2188, 2090002, 1051009, 111000, 0, 144),
(2189, 2090002, 1051008, 111000, 0, 148),
(2190, 2090002, 1051007, 111000, 0, 152),
(2191, 2090002, 1041074, 180000, 0, 156),
(2192, 2090002, 1041075, 180000, 0, 160),
(2193, 2090002, 1040083, 180000, 0, 164),
(2194, 2090002, 1040082, 180000, 0, 168),
(2195, 2090002, 1040061, 114000, 0, 172),
(2196, 2090002, 1040062, 114000, 0, 176),
(2197, 2090002, 1040063, 114000, 0, 180),
(2198, 2090002, 1002180, 100000, 0, 184),
(2199, 2090002, 1002179, 100000, 0, 188),
(2200, 2090002, 1002178, 100000, 0, 192),
(2201, 2090002, 1002177, 100000, 0, 196),
(2202, 2090002, 1002176, 100000, 0, 200),
(2203, 2090002, 1061080, 160000, 0, 204),
(2204, 2090002, 1061081, 160000, 0, 208),
(2205, 2090002, 1061062, 108000, 0, 212),
(2206, 2090002, 1061060, 108000, 0, 216),
(2207, 2090002, 1061064, 108000, 0, 220),
(2208, 2090002, 1061061, 108000, 0, 224),
(2209, 2090002, 1060069, 160000, 0, 228),
(2210, 2090002, 1060070, 160000, 0, 232),
(2211, 2090002, 1060063, 108000, 0, 236),
(2212, 2090002, 1060061, 108000, 0, 240),
(2213, 2090002, 1060065, 108000, 0, 244),
(2214, 2090002, 1060062, 108000, 0, 248),
(2215, 2090002, 1041081, 180000, 0, 252),
(2216, 2090002, 1041082, 180000, 0, 256),
(2217, 2090002, 1041067, 114000, 0, 260),
(2218, 2090002, 1041065, 114000, 0, 264),
(2219, 2090002, 1041069, 114000, 0, 268),
(2220, 2090002, 1041066, 114000, 0, 272),
(2221, 2090002, 1040079, 180000, 0, 276),
(2222, 2090002, 1040081, 180000, 0, 280),
(2223, 2090002, 1040076, 114000, 0, 284),
(2224, 2090002, 1040074, 114000, 0, 288),
(2225, 2090002, 1040073, 114000, 0, 292),
(2226, 2090002, 1040072, 114000, 0, 296),
(2227, 2090002, 1002137, 100000, 0, 300),
(2228, 2090002, 1002135, 100000, 0, 304),
(2229, 2090002, 1002139, 100000, 0, 308),
(2230, 2090002, 1002138, 100000, 0, 312),
(2231, 2090002, 1061047, 120000, 0, 316),
(2232, 2090002, 1061048, 120000, 0, 320),
(2233, 2090002, 1051027, 450000, 0, 324),
(2234, 2090002, 1051024, 450000, 0, 328),
(2235, 2090002, 1051025, 450000, 0, 332),
(2236, 2090002, 1051023, 450000, 0, 336),
(2237, 2090002, 1050037, 450000, 0, 340),
(2238, 2090002, 1050036, 450000, 0, 344),
(2239, 2090002, 1050038, 450000, 0, 348),
(2240, 2090002, 1050035, 450000, 0, 352),
(2241, 2090002, 1050002, 300000, 0, 356),
(2242, 2090002, 1050031, 300000, 0, 360),
(2243, 2090002, 1041051, 120000, 0, 364),
(2244, 2090002, 1041052, 120000, 0, 368),
(2245, 2090002, 1002144, 96000, 0, 372),
(2246, 2090002, 1002143, 96000, 0, 376),
(2247, 2090002, 1002142, 96000, 0, 380),
(2248, 2090002, 1002141, 96000, 0, 384),
(2249, 2090002, 1092002, 200000, 0, 388),
(2250, 2090002, 1092001, 100000, 0, 392),
(2251, 2090002, 1061084, 180000, 0, 396),
(2252, 2090002, 1061083, 180000, 0, 400),
(2253, 2090002, 1060074, 180000, 0, 404),
(2254, 2090002, 1060075, 180000, 0, 408),
(2255, 2090002, 1051014, 112500, 0, 412),
(2256, 2090002, 1051001, 112500, 0, 416),
(2257, 2090002, 1050021, 112500, 0, 420),
(2258, 2090002, 1050000, 112500, 0, 424),
(2259, 2090002, 1041085, 200000, 0, 428),
(2260, 2090002, 1041084, 200000, 0, 432),
(2261, 2090002, 1040085, 200000, 0, 436),
(2262, 2090002, 1040000, 200000, 0, 440),
(2263, 2090002, 1002004, 160000, 0, 444),
(2264, 2090003, 2330000, 600, 0, 104),
(2265, 2090003, 2070000, 500, 0, 108),
(2268, 2090003, 2061000, 1, 0, 120),
(2269, 2090003, 2060000, 1, 0, 124),
(2270, 2090003, 2030000, 400, 0, 128),
(2271, 2090003, 2050002, 300, 0, 132),
(2272, 2090003, 2050001, 200, 0, 136),
(2273, 2090003, 2050000, 200, 0, 140),
(2274, 2090003, 2020015, 10200, 0, 144),
(2275, 2090003, 2020014, 8100, 0, 148),
(2276, 2090003, 2020013, 5600, 0, 152),
(2277, 2090003, 2020012, 4500, 0, 156),
(2278, 2090003, 2001002, 4000, 0, 160),
(2279, 2090003, 2001001, 2300, 0, 164),
(2280, 2090003, 2001000, 3200, 0, 168),
(2281, 2090003, 2022000, 1650, 0, 172),
(2282, 2090003, 2022003, 1100, 0, 176),
(2283, 2090003, 2010004, 310, 0, 180),
(2284, 2090003, 2010003, 100, 0, 184),
(2285, 2090003, 2010001, 106, 0, 188),
(2286, 2090003, 2010002, 50, 0, 192),
(2287, 2090003, 2010000, 30, 0, 196),
(2288, 2090003, 2002005, 500, 0, 200),
(2289, 2090003, 2002004, 500, 0, 204),
(2290, 2090003, 2002002, 500, 0, 208),
(2291, 2090003, 2002001, 400, 0, 212),
(2292, 2090003, 2002000, 500, 0, 216),
(2293, 2090003, 2000006, 620, 0, 220),
(2294, 2090003, 2000003, 200, 0, 224),
(2295, 2090003, 2000002, 320, 0, 228),
(2296, 2090003, 2000001, 160, 0, 232),
(2297, 2090003, 2000000, 50, 0, 236),
(2298, 2090006, 4160019, 1000, 0, 104),
(2299, 2090006, 4160039, 1000, 0, 108),
(2300, 2090006, 4160037, 1000, 0, 112),
(2301, 2090006, 4031993, 100000, 0, 116),
(2302, 2090006, 4160036, 1000, 0, 120),
(2303, 2090006, 4160035, 1000, 0, 124),
(2304, 2090006, 4160034, 1000, 0, 128),
(2305, 2090006, 4160032, 1000, 0, 132),
(2306, 2090006, 4160024, 1000, 0, 136),
(2307, 2090006, 4160023, 1000, 0, 140),
(2308, 2090006, 4160022, 1000, 0, 144),
(2309, 2090006, 4160015, 1000, 0, 148),
(2310, 2090006, 4160012, 1000, 0, 152),
(2311, 2090006, 4160013, 1000, 0, 156),
(2312, 2090006, 4160017, 1000, 0, 160),
(2313, 2090006, 4160014, 1000, 0, 164),
(2314, 2090006, 4160020, 1000, 0, 168),
(2315, 2090006, 4160010, 1000, 0, 172),
(2316, 2090006, 4160009, 1000, 0, 176),
(2317, 2090006, 4160008, 1000, 0, 180),
(2318, 2090006, 4160007, 1000, 0, 184),
(2319, 2090006, 4160006, 1000, 0, 188),
(2320, 2090006, 4160005, 1000, 0, 192),
(2321, 2090006, 4160004, 1000, 0, 196),
(2322, 2090006, 4160003, 1000, 0, 200),
(2323, 2090006, 4160002, 1000, 0, 204),
(2324, 2090006, 4160001, 1000, 0, 208),
(2325, 2090006, 4160000, 1000, 0, 212),
(2326, 2090006, 4160026, 1000, 0, 216),
(2327, 2090006, 2260000, 1000, 0, 220),
(2328, 2090006, 2120000, 30, 0, 224),
(2329, 2093000, 1492004, 75000, 0, 104),
(2330, 2093000, 1482004, 75000, 0, 108),
(2331, 2093000, 1472001, 20000, 0, 112),
(2332, 2093000, 1462000, 30000, 0, 116),
(2333, 2093000, 1452005, 150000, 0, 120),
(2334, 2093000, 1442001, 60000, 0, 124),
(2335, 2093000, 1432002, 60000, 0, 128),
(2336, 2093000, 1422001, 45000, 0, 132),
(2337, 2093000, 1412006, 45000, 0, 136),
(2338, 2093000, 1402002, 150000, 0, 140),
(2339, 2093000, 1382002, 20000, 0, 144),
(2340, 2093000, 1372003, 38000, 0, 148),
(2341, 2093000, 1332012, 40000, 0, 152),
(2342, 2093000, 1332009, 42000, 0, 156),
(2343, 2093000, 1322014, 40000, 0, 160),
(2344, 2093000, 1312005, 40000, 0, 164),
(2345, 2093000, 1302008, 40000, 0, 168),
(2346, 2093001, 1052107, 90000, 0, 104),
(2347, 2093001, 1002622, 40000, 0, 108),
(2348, 2093001, 1061046, 40000, 0, 112),
(2349, 2093001, 1061045, 40000, 0, 116),
(2350, 2093001, 1061044, 40000, 0, 120),
(2351, 2093001, 1061043, 40000, 0, 124),
(2352, 2093001, 1060046, 40000, 0, 128),
(2353, 2093001, 1060045, 40000, 0, 132),
(2354, 2093001, 1060044, 40000, 0, 136),
(2355, 2093001, 1060043, 40000, 0, 140),
(2356, 2093001, 1041050, 45000, 0, 144),
(2357, 2093001, 1041049, 45000, 0, 148),
(2358, 2093001, 1041048, 45000, 0, 152),
(2359, 2093001, 1041047, 45000, 0, 156),
(2360, 2093001, 1040060, 45000, 0, 160),
(2361, 2093001, 1040059, 45000, 0, 164),
(2362, 2093001, 1040058, 45000, 0, 168),
(2363, 2093001, 1040057, 45000, 0, 172),
(2364, 2093001, 1002175, 30000, 0, 176),
(2365, 2093001, 1002174, 30000, 0, 180),
(2366, 2093001, 1002173, 30000, 0, 184),
(2367, 2093001, 1002172, 30000, 0, 188),
(2368, 2093001, 1002171, 30000, 0, 192),
(2369, 2093001, 1061051, 44000, 0, 196),
(2370, 2093001, 1061050, 44000, 0, 200),
(2371, 2093001, 1061052, 44000, 0, 204),
(2372, 2093001, 1060057, 44000, 0, 208),
(2373, 2093001, 1060056, 44000, 0, 212),
(2374, 2093001, 1060058, 44000, 0, 216),
(2375, 2093001, 1060059, 44000, 0, 220),
(2376, 2093001, 1041055, 50000, 0, 224),
(2377, 2093001, 1041054, 50000, 0, 228),
(2378, 2093001, 1041056, 50000, 0, 232),
(2379, 2093001, 1040068, 50000, 0, 236),
(2380, 2093001, 1040067, 50000, 0, 240),
(2381, 2093001, 1040070, 50000, 0, 244),
(2382, 2093001, 1040069, 50000, 0, 248),
(2383, 2093001, 1002165, 30000, 0, 252),
(2384, 2093001, 1002164, 30000, 0, 256),
(2385, 2093001, 1002163, 30000, 0, 260),
(2386, 2093001, 1002162, 30000, 0, 264),
(2387, 2093001, 1002161, 30000, 0, 268),
(2388, 2093001, 1061036, 40000, 0, 272),
(2389, 2093001, 1061035, 40000, 0, 276),
(2390, 2093001, 1061034, 40000, 0, 280),
(2391, 2093001, 1050028, 40000, 0, 284),
(2392, 2093001, 1050027, 40000, 0, 288),
(2393, 2093001, 1050026, 40000, 0, 292),
(2394, 2093001, 1050003, 40000, 0, 296),
(2395, 2093001, 1041043, 42000, 0, 300),
(2396, 2093001, 1041042, 42000, 0, 304),
(2397, 2093001, 1041041, 42000, 0, 308),
(2398, 2093001, 1002064, 40000, 0, 312),
(2399, 2093001, 1092006, 60000, 0, 316),
(2400, 2093001, 1060019, 38000, 0, 320),
(2401, 2093001, 1060018, 38000, 0, 324),
(2402, 2093001, 1060017, 38000, 0, 328),
(2403, 2093001, 1060016, 38000, 0, 332),
(2404, 2093001, 1051013, 60000, 0, 336),
(2405, 2093001, 1051012, 60000, 0, 340),
(2406, 2093001, 1051011, 60000, 0, 344),
(2407, 2093001, 1051010, 60000, 0, 348),
(2408, 2093001, 1040026, 40000, 0, 352),
(2409, 2093001, 1040021, 40000, 0, 356),
(2410, 2093001, 1002023, 120000, 0, 360),
(2411, 2093002, 2330000, 600, 0, 104),
(2412, 2093002, 2070000, 500, 0, 108),
(2415, 2093002, 2061000, 1, 0, 120),
(2416, 2093002, 2060000, 1, 0, 124),
(2417, 2093002, 2030000, 400, 0, 128),
(2418, 2093002, 2050003, 500, 0, 132),
(2419, 2093002, 2050002, 300, 0, 136),
(2420, 2093002, 2050001, 200, 0, 140),
(2421, 2093002, 2050000, 200, 0, 144),
(2422, 2093002, 2020028, 3000, 0, 148),
(2423, 2093002, 2010004, 310, 0, 152),
(2424, 2093002, 2010003, 100, 0, 156),
(2425, 2093002, 2010001, 106, 0, 160),
(2426, 2093002, 2010002, 50, 0, 164),
(2427, 2093002, 2010000, 30, 0, 168),
(2428, 2093002, 2001002, 4000, 0, 172),
(2429, 2093002, 2001001, 2300, 0, 176),
(2430, 2093002, 2001000, 3200, 0, 180),
(2431, 2093002, 2022000, 1650, 0, 184),
(2432, 2093002, 2022003, 1100, 0, 188),
(2433, 2093002, 2002005, 500, 0, 192),
(2434, 2093002, 2002004, 500, 0, 196),
(2435, 2093002, 2002002, 500, 0, 200),
(2436, 2093002, 2002001, 400, 0, 204),
(2437, 2093002, 2002000, 500, 0, 208),
(2438, 2093002, 2000006, 620, 0, 212),
(2439, 2093002, 2000003, 200, 0, 216),
(2440, 2093002, 2000002, 320, 0, 220),
(2441, 2093002, 2000001, 160, 0, 224),
(2442, 2093002, 2000000, 50, 0, 228),
(2443, 2100002, 1492004, 75000, 0, 104),
(2444, 2100002, 1482004, 75000, 0, 108),
(2445, 2100002, 1472001, 20000, 0, 112),
(2446, 2100002, 1462000, 30000, 0, 116),
(2447, 2100002, 1452005, 150000, 0, 120),
(2448, 2100002, 1442001, 60000, 0, 124),
(2449, 2100002, 1432002, 60000, 0, 128),
(2450, 2100002, 1422001, 45000, 0, 132),
(2451, 2100002, 1412006, 45000, 0, 136),
(2452, 2100002, 1402002, 150000, 0, 140),
(2453, 2100002, 1382002, 20000, 0, 144),
(2454, 2100002, 1372003, 38000, 0, 148),
(2455, 2100002, 1332012, 40000, 0, 152),
(2456, 2100002, 1332009, 42000, 0, 156),
(2457, 2100002, 1322014, 40000, 0, 160),
(2458, 2100002, 1312005, 40000, 0, 164),
(2459, 2100002, 1302008, 40000, 0, 168),
(2460, 2100003, 1052107, 90000, 0, 104),
(2461, 2100003, 1002622, 40000, 0, 108),
(2462, 2100003, 1061046, 40000, 0, 112),
(2463, 2100003, 1061045, 40000, 0, 116),
(2464, 2100003, 1061044, 40000, 0, 120),
(2465, 2100003, 1061043, 40000, 0, 124),
(2466, 2100003, 1060046, 40000, 0, 128),
(2467, 2100003, 1060045, 40000, 0, 132),
(2468, 2100003, 1060044, 40000, 0, 136),
(2469, 2100003, 1060043, 40000, 0, 140),
(2470, 2100003, 1041050, 45000, 0, 144),
(2471, 2100003, 1041049, 45000, 0, 148),
(2472, 2100003, 1041048, 45000, 0, 152),
(2473, 2100003, 1041047, 45000, 0, 156),
(2474, 2100003, 1040060, 45000, 0, 160),
(2475, 2100003, 1040059, 45000, 0, 164),
(2476, 2100003, 1040058, 45000, 0, 168),
(2477, 2100003, 1040057, 45000, 0, 172),
(2478, 2100003, 1002175, 30000, 0, 176),
(2479, 2100003, 1002174, 30000, 0, 180),
(2480, 2100003, 1002173, 30000, 0, 184),
(2481, 2100003, 1002172, 30000, 0, 188),
(2482, 2100003, 1002171, 30000, 0, 192),
(2483, 2100003, 1061051, 44000, 0, 196),
(2484, 2100003, 1061050, 44000, 0, 200),
(2485, 2100003, 1061052, 44000, 0, 204),
(2486, 2100003, 1060057, 44000, 0, 208),
(2487, 2100003, 1060056, 44000, 0, 212),
(2488, 2100003, 1060058, 44000, 0, 216),
(2489, 2100003, 1060059, 44000, 0, 220),
(2490, 2100003, 1041055, 50000, 0, 224),
(2491, 2100003, 1041054, 50000, 0, 228),
(2492, 2100003, 1041056, 50000, 0, 232),
(2493, 2100003, 1040068, 50000, 0, 236),
(2494, 2100003, 1040067, 50000, 0, 240),
(2495, 2100003, 1040070, 50000, 0, 244),
(2496, 2100003, 1040069, 50000, 0, 248),
(2497, 2100003, 1002165, 30000, 0, 252),
(2498, 2100003, 1002164, 30000, 0, 256),
(2499, 2100003, 1002163, 30000, 0, 260),
(2500, 2100003, 1002162, 30000, 0, 264),
(2501, 2100003, 1002161, 30000, 0, 268),
(2502, 2100003, 1061036, 40000, 0, 272),
(2503, 2100003, 1061035, 40000, 0, 276),
(2504, 2100003, 1061034, 40000, 0, 280),
(2505, 2100003, 1050028, 40000, 0, 284),
(2506, 2100003, 1050027, 40000, 0, 288),
(2507, 2100003, 1050026, 40000, 0, 292),
(2508, 2100003, 1050003, 40000, 0, 296),
(2509, 2100003, 1041043, 42000, 0, 300),
(2510, 2100003, 1041042, 42000, 0, 304),
(2511, 2100003, 1041041, 42000, 0, 308),
(2512, 2100003, 1002064, 40000, 0, 312),
(2513, 2100003, 1092006, 60000, 0, 316),
(2514, 2100003, 1060019, 38000, 0, 320),
(2515, 2100003, 1060018, 38000, 0, 324),
(2516, 2100003, 1060017, 38000, 0, 328),
(2517, 2100003, 1060016, 38000, 0, 332),
(2518, 2100003, 1051013, 60000, 0, 336),
(2519, 2100003, 1051012, 60000, 0, 340),
(2520, 2100003, 1051011, 60000, 0, 344),
(2521, 2100003, 1051010, 60000, 0, 348),
(2522, 2100003, 1040026, 40000, 0, 352),
(2523, 2100003, 1040021, 40000, 0, 356),
(2524, 2100003, 1002023, 120000, 0, 360),
(2525, 2100003, 1002004, 160000, 0, 364),
(2526, 2100004, 2330000, 600, 0, 104),
(2527, 2100004, 2070000, 500, 0, 108),
(2528, 2100004, 2120000, 30, 0, 112),
(2531, 2100004, 2061000, 1, 0, 124),
(2532, 2100004, 2060000, 1, 0, 128),
(2533, 2100004, 2030000, 400, 0, 132),
(2534, 2100004, 2050003, 500, 0, 136),
(2535, 2100004, 2050002, 300, 0, 140),
(2536, 2100004, 2050001, 200, 0, 144),
(2537, 2100004, 2050000, 200, 0, 148),
(2538, 2100004, 2020028, 3000, 0, 152),
(2539, 2100004, 2010004, 310, 0, 156),
(2540, 2100004, 2010003, 100, 0, 160),
(2541, 2100004, 2010001, 106, 0, 164),
(2542, 2100004, 2010002, 50, 0, 168),
(2543, 2100004, 2010000, 30, 0, 172),
(2544, 2100004, 2001002, 4000, 0, 176),
(2545, 2100004, 2001001, 2300, 0, 180),
(2546, 2100004, 2001000, 3200, 0, 184),
(2547, 2100004, 2022000, 1650, 0, 188),
(2548, 2100004, 2022003, 1100, 0, 192),
(2549, 2100004, 2002005, 500, 0, 196),
(2550, 2100004, 2002004, 500, 0, 200),
(2551, 2100004, 2002002, 500, 0, 204),
(2552, 2100004, 2002001, 400, 0, 208),
(2553, 2100004, 2002000, 500, 0, 212),
(2554, 2100004, 2000006, 620, 0, 216),
(2555, 2100004, 2000003, 200, 0, 220),
(2556, 2100004, 2000002, 320, 0, 224),
(2557, 2100004, 2000001, 160, 0, 228),
(2558, 2100004, 2000000, 50, 0, 232),
(2559, 2110001, 2330000, 600, 0, 104),
(2560, 2110001, 2070000, 500, 0, 108),
(2561, 2110001, 2120000, 30, 0, 112),
(2564, 2110001, 2061000, 1, 0, 124),
(2565, 2110001, 2060000, 1, 0, 128),
(2566, 2110001, 2030000, 400, 0, 132),
(2567, 2110001, 2050003, 500, 0, 136),
(2568, 2110001, 2050002, 300, 0, 140),
(2569, 2110001, 2050001, 200, 0, 144),
(2570, 2110001, 2050000, 200, 0, 148),
(2571, 2110001, 2020028, 3000, 0, 152),
(2572, 2110001, 2010004, 310, 0, 156),
(2573, 2110001, 2010003, 100, 0, 160),
(2574, 2110001, 2010001, 106, 0, 164),
(2575, 2110001, 2010002, 50, 0, 168),
(2576, 2110001, 2010000, 30, 0, 172),
(2577, 2110001, 2001002, 4000, 0, 176),
(2578, 2110001, 2001001, 2300, 0, 180),
(2579, 2110001, 2001000, 3200, 0, 184),
(2580, 2110001, 2022000, 1650, 0, 188),
(2581, 2110001, 2022003, 1100, 0, 192),
(2582, 2110001, 2002005, 500, 0, 196),
(2583, 2110001, 2002004, 500, 0, 200),
(2584, 2110001, 2002002, 500, 0, 204),
(2585, 2110001, 2002001, 400, 0, 208),
(2586, 2110001, 2002000, 500, 0, 212),
(2587, 2110001, 2000006, 620, 0, 216),
(2588, 2110001, 2000003, 200, 0, 220),
(2589, 2110001, 2000002, 320, 0, 224),
(2590, 2110001, 2000001, 160, 0, 228),
(2591, 2110001, 2000000, 50, 0, 232),
(2592, 2130000, 2330000, 600, 0, 104),
(2593, 2130000, 2070000, 500, 0, 108),
(2596, 2130000, 2061000, 1, 0, 120),
(2597, 2130000, 2060000, 1, 0, 124),
(2598, 2130000, 2030000, 400, 0, 128),
(2599, 2130000, 2050002, 300, 0, 132),
(2600, 2130000, 2050001, 200, 0, 136),
(2601, 2130000, 2050000, 200, 0, 140),
(2602, 2130000, 2020015, 10200, 0, 144),
(2603, 2130000, 2020014, 8100, 0, 148),
(2604, 2130000, 2020013, 5600, 0, 152),
(2605, 2130000, 2020012, 4500, 0, 156),
(2606, 2130000, 2001002, 4000, 0, 160),
(2607, 2130000, 2001001, 2300, 0, 164),
(2608, 2130000, 2001000, 3200, 0, 168),
(2609, 2130000, 2022000, 1650, 0, 172),
(2610, 2130000, 2022003, 1100, 0, 176),
(2611, 2130000, 2010004, 310, 0, 180),
(2612, 2130000, 2010003, 100, 0, 184),
(2613, 2130000, 2010001, 106, 0, 188),
(2614, 2130000, 2010002, 50, 0, 192),
(2615, 2130000, 2010000, 30, 0, 196),
(2616, 2130000, 2002005, 500, 0, 200),
(2617, 2130000, 2002004, 500, 0, 204),
(2618, 2130000, 2002002, 500, 0, 208),
(2619, 2130000, 2002001, 400, 0, 212),
(2620, 2130000, 2002000, 500, 0, 216),
(2621, 2130000, 2000006, 620, 0, 220),
(2622, 2130000, 2000003, 200, 0, 224),
(2623, 2130000, 2000002, 320, 0, 228),
(2624, 2130000, 2000001, 160, 0, 232),
(2625, 2130000, 2000000, 50, 0, 236),
(2626, 9110003, 2022022, 1300, 0, 104),
(2627, 9110003, 2022021, 550, 0, 108),
(2628, 9110004, 2022023, 1350, 0, 104),
(2629, 9110004, 2022014, 650, 0, 108),
(2630, 9110005, 2022025, 4200, 0, 104),
(2631, 9110005, 2022024, 2000, 0, 108),
(2632, 9110006, 2022027, 3800, 0, 104),
(2633, 9110006, 2022026, 1800, 0, 108),
(2634, 9110007, 2022020, 550, 0, 104),
(2635, 9110007, 2022019, 850, 0, 108),
(2636, 9110007, 2022018, 1600, 0, 112),
(2637, 9110007, 2022017, 1100, 0, 116),
(2638, 9120000, 2070000, 500, 0, 104),
(2639, 9120000, 1472008, 250000, 0, 108),
(2640, 9120000, 1312013, 100000, 0, 112),
(2641, 9120000, 1322012, 15000, 0, 116),
(2642, 9120000, 1402009, 30000, 0, 120),
(2643, 9120000, 1432008, 150000, 0, 124),
(2644, 9120000, 1402010, 150000, 0, 128),
(2645, 9120000, 1462006, 500000, 0, 132),
(2646, 9120000, 1302021, 1250000, 0, 136),
(2647, 9120000, 1302022, 80000, 0, 140),
(2648, 9120000, 1332024, 2000000, 0, 144),
(2649, 9120000, 1382011, 2000000, 0, 148),
(2650, 9120002, 2070000, 500, 0, 104),
(2651, 9120002, 2020014, 8100, 0, 108),
(2652, 9120002, 2022002, 1000, 0, 112),
(2653, 9120002, 2001002, 4000, 0, 116),
(2654, 9120002, 2000006, 620, 0, 120),
(2655, 9120002, 2000003, 200, 0, 124),
(2656, 9120002, 2020012, 4500, 0, 128),
(2657, 9120002, 2001001, 2300, 0, 132),
(2658, 9120002, 2000002, 320, 0, 136),
(2659, 9120002, 2000001, 160, 0, 140),
(2660, 9120002, 2060003, 40, 0, 100),
(2661, 9120004, 2070000, 500, 0, 104),
(2662, 9120004, 2030010, 500, 0, 108),
(2663, 9120004, 2030009, 500, 0, 112),
(2664, 9120004, 2030008, 400, 0, 116),
(2665, 9120004, 1050100, 30000, 0, 120),
(2666, 9120019, 2070000, 500, 0, 104);
INSERT INTO `shopitems` (`shopitemid`, `shopid`, `itemid`, `price`, `pitch`, `position`) VALUES
(2667, 9120019, 2030010, 500, 0, 108),
(2668, 9120019, 2030009, 500, 0, 112),
(2669, 9120019, 2030008, 400, 0, 116),
(2670, 9120019, 1051098, 30000, 0, 120),
(2671, 9201020, 1051153, 100000, 0, 104),
(2672, 9201020, 1051152, 100000, 0, 108),
(2673, 9201020, 1051151, 100000, 0, 112),
(2674, 9201020, 1051150, 100000, 0, 116),
(2675, 9201020, 1050134, 100000, 0, 120),
(2676, 9201020, 1050133, 100000, 0, 124),
(2677, 9201020, 1050132, 100000, 0, 128),
(2678, 9201020, 1050131, 100000, 0, 132),
(2679, 9201058, 1061046, 42500, 0, 104),
(2680, 9201058, 1061045, 42500, 0, 108),
(2681, 9201058, 1061044, 42500, 0, 112),
(2682, 9201058, 1061043, 42500, 0, 116),
(2683, 9201058, 1060046, 42500, 0, 120),
(2684, 9201058, 1060045, 42500, 0, 124),
(2685, 9201058, 1060044, 42500, 0, 128),
(2686, 9201058, 1060043, 42500, 0, 132),
(2687, 9201058, 1041050, 47500, 0, 136),
(2688, 9201058, 1041049, 47500, 0, 140),
(2689, 9201058, 1041048, 47500, 0, 144),
(2690, 9201058, 1041047, 47500, 0, 148),
(2691, 9201058, 1040060, 47500, 0, 152),
(2692, 9201058, 1040059, 47500, 0, 156),
(2693, 9201058, 1040058, 47500, 0, 160),
(2694, 9201058, 1040057, 47500, 0, 164),
(2695, 9201058, 1002175, 32500, 0, 168),
(2696, 9201058, 1002174, 32500, 0, 172),
(2697, 9201058, 1002173, 32500, 0, 176),
(2698, 9201058, 1002172, 32500, 0, 180),
(2699, 9201058, 1002171, 32500, 0, 184),
(2700, 9201058, 1061051, 46500, 0, 188),
(2701, 9201058, 1061050, 46500, 0, 192),
(2702, 9201058, 1061052, 46500, 0, 196),
(2703, 9201058, 1060057, 46500, 0, 200),
(2704, 9201058, 1060056, 46500, 0, 204),
(2705, 9201058, 1060058, 46500, 0, 208),
(2706, 9201058, 1060059, 46500, 0, 212),
(2707, 9201058, 1041055, 52500, 0, 216),
(2708, 9201058, 1041054, 52500, 0, 220),
(2709, 9201058, 1041056, 52500, 0, 224),
(2710, 9201058, 1040068, 52500, 0, 228),
(2711, 9201058, 1040067, 52500, 0, 232),
(2712, 9201058, 1040070, 52500, 0, 236),
(2713, 9201058, 1040069, 52500, 0, 240),
(2714, 9201058, 1002165, 32500, 0, 244),
(2715, 9201058, 1002164, 32500, 0, 248),
(2716, 9201058, 1002163, 32500, 0, 252),
(2717, 9201058, 1002162, 32500, 0, 256),
(2718, 9201058, 1002161, 32500, 0, 260),
(2719, 9201058, 1061036, 42500, 0, 264),
(2720, 9201058, 1061035, 42500, 0, 268),
(2721, 9201058, 1061034, 42500, 0, 272),
(2722, 9201058, 1050028, 42500, 0, 276),
(2723, 9201058, 1050027, 42500, 0, 280),
(2724, 9201058, 1050026, 42500, 0, 284),
(2725, 9201058, 1050003, 42500, 0, 288),
(2726, 9201058, 1041043, 44500, 0, 292),
(2727, 9201058, 1041042, 44500, 0, 296),
(2728, 9201058, 1041041, 44500, 0, 300),
(2729, 9201058, 1002064, 42500, 0, 304),
(2730, 9201058, 1092006, 62500, 0, 308),
(2731, 9201058, 1060019, 40500, 0, 312),
(2732, 9201058, 1060018, 40500, 0, 316),
(2733, 9201058, 1060017, 40500, 0, 320),
(2734, 9201058, 1060016, 40500, 0, 324),
(2735, 9201058, 1051013, 62500, 0, 328),
(2736, 9201058, 1051012, 62500, 0, 332),
(2737, 9201058, 1051011, 62500, 0, 336),
(2738, 9201058, 1051010, 62500, 0, 340),
(2739, 9201058, 1040026, 42500, 0, 344),
(2740, 9201058, 1040021, 42500, 0, 348),
(2741, 9201058, 1002023, 122500, 0, 352),
(2742, 9201059, 1472001, 22500, 0, 104),
(2743, 9201059, 1462000, 32500, 0, 108),
(2744, 9201059, 1452005, 152500, 0, 112),
(2745, 9201059, 1442001, 62500, 0, 116),
(2746, 9201059, 1432002, 62500, 0, 120),
(2747, 9201059, 1422001, 47500, 0, 124),
(2748, 9201059, 1412006, 47500, 0, 128),
(2749, 9201059, 1402002, 152500, 0, 132),
(2750, 9201059, 1382002, 22500, 0, 136),
(2751, 9201059, 1372003, 40500, 0, 140),
(2752, 9201059, 1332012, 42500, 0, 144),
(2753, 9201059, 1332009, 44500, 0, 148),
(2754, 9201059, 1322014, 42500, 0, 152),
(2755, 9201059, 1312005, 42500, 0, 156),
(2756, 9201059, 1302068, 352500, 0, 160),
(2757, 9201059, 1302008, 42500, 0, 164),
(2758, 9201060, 2010003, 100, 0, 178),
(2759, 9201060, 2061000, 1, 0, 108),
(2760, 9201060, 2060000, 1, 0, 112),
(2761, 9201060, 2030000, 400, 0, 116),
(2762, 9201060, 2022195, 15000, 0, 120),
(2763, 9201060, 2020015, 10200, 0, 124),
(2764, 9201060, 2020014, 8100, 0, 128),
(2765, 9201060, 2020013, 5600, 0, 132),
(2766, 9201060, 2020012, 4500, 0, 136),
(2767, 9201060, 2022190, 3000, 0, 140),
(2768, 9201060, 2001002, 4000, 0, 144),
(2769, 9201060, 2001001, 2300, 0, 148),
(2770, 9201060, 2001000, 3200, 0, 152),
(2771, 9201060, 2022000, 1650, 0, 156),
(2772, 9201060, 2022003, 1100, 0, 160),
(2773, 9201060, 2022192, 600, 0, 164),
(2774, 9201060, 2022191, 1000, 0, 168),
(2775, 9201060, 2022189, 1000, 0, 172),
(2776, 9201060, 2010004, 310, 0, 176),
(2777, 9201060, 2010001, 106, 0, 180),
(2778, 9201060, 2010002, 50, 0, 184),
(2779, 9201060, 2010000, 30, 0, 188),
(2780, 9201060, 2002025, 1500, 0, 192),
(2781, 9201060, 2002024, 1500, 0, 196),
(2782, 9201060, 2002023, 3800, 0, 200),
(2783, 9201060, 2002022, 2100, 0, 204),
(2784, 9201060, 2002021, 2800, 0, 208),
(2785, 9201060, 2002020, 2800, 0, 212),
(2786, 9201060, 2002019, 5000, 0, 216),
(2787, 9201060, 2002018, 5000, 0, 220),
(2788, 9201060, 2002017, 5000, 0, 224),
(2789, 9201060, 2002016, 5000, 0, 228),
(2790, 9201060, 2000006, 620, 0, 232),
(2791, 9201060, 2000003, 200, 0, 236),
(2792, 9201060, 2000002, 320, 0, 240),
(2793, 9201060, 2000001, 160, 0, 244),
(2794, 9201060, 2000000, 50, 0, 248),
(2795, 9270019, 1472007, 60000, 0, 104),
(2796, 9270019, 1472004, 30000, 0, 108),
(2797, 9270019, 1472001, 20000, 0, 112),
(2798, 9270019, 1462005, 250000, 0, 116),
(2799, 9270019, 1462004, 200000, 0, 120),
(2800, 9270019, 1462000, 30000, 0, 124),
(2801, 9270019, 1452007, 375000, 0, 128),
(2802, 9270019, 1452006, 250000, 0, 132),
(2803, 9270019, 1452005, 150000, 0, 136),
(2804, 9270019, 1442009, 300000, 0, 140),
(2805, 9270019, 1442003, 175000, 0, 144),
(2806, 9270019, 1442001, 60000, 0, 148),
(2807, 9270019, 1432005, 225000, 0, 152),
(2808, 9270019, 1432003, 175000, 0, 156),
(2809, 9270019, 1432002, 60000, 0, 160),
(2810, 9270019, 1422007, 250000, 0, 164),
(2811, 9270019, 1422008, 200000, 0, 168),
(2812, 9270019, 1422001, 45000, 0, 172),
(2813, 9270019, 1412005, 250000, 0, 176),
(2814, 9270019, 1412004, 200000, 0, 180),
(2815, 9270019, 1412006, 45000, 0, 184),
(2816, 9270019, 1402007, 450000, 0, 188),
(2817, 9270019, 1402006, 350000, 0, 192),
(2818, 9270019, 1402002, 150000, 0, 196),
(2819, 9270019, 1382002, 20000, 0, 200),
(2820, 9270019, 1372000, 400000, 0, 204),
(2821, 9270019, 1372001, 175000, 0, 208),
(2822, 9270019, 1372003, 38000, 0, 212),
(2823, 9270019, 1332011, 425000, 0, 216),
(2824, 9270019, 1332014, 375000, 0, 220),
(2825, 9270019, 1332001, 200000, 0, 224),
(2826, 9270019, 1332012, 40000, 0, 228),
(2827, 9270019, 1332009, 42000, 0, 232),
(2828, 9270019, 1322016, 175000, 0, 236),
(2829, 9270019, 1322015, 100000, 0, 240),
(2830, 9270019, 1322014, 40000, 0, 244),
(2831, 9270019, 1312007, 175000, 0, 248),
(2832, 9270019, 1312006, 100000, 0, 252),
(2833, 9270019, 1312005, 40000, 0, 256),
(2834, 9270019, 1302009, 225000, 0, 260),
(2835, 9270019, 1302004, 100000, 0, 264),
(2836, 9270019, 1302008, 40000, 0, 268),
(2837, 9270020, 1061069, 160000, 0, 104),
(2838, 9270020, 1061070, 160000, 0, 108),
(2839, 9270020, 1060072, 160000, 0, 112),
(2840, 9270020, 1060071, 160000, 0, 116),
(2841, 9270020, 1060052, 108000, 0, 120),
(2842, 9270020, 1060050, 108000, 0, 124),
(2843, 9270020, 1060051, 108000, 0, 128),
(2844, 9270020, 1051009, 111000, 0, 132),
(2845, 9270020, 1051008, 111000, 0, 136),
(2846, 9270020, 1051007, 111000, 0, 140),
(2847, 9270020, 1041074, 180000, 0, 144),
(2848, 9270020, 1041075, 180000, 0, 148),
(2849, 9270020, 1040083, 180000, 0, 152),
(2850, 9270020, 1040082, 180000, 0, 156),
(2851, 9270020, 1040061, 114000, 0, 160),
(2852, 9270020, 1040062, 114000, 0, 164),
(2853, 9270020, 1040063, 114000, 0, 168),
(2854, 9270020, 1002180, 100000, 0, 172),
(2855, 9270020, 1002179, 100000, 0, 176),
(2856, 9270020, 1002178, 100000, 0, 180),
(2857, 9270020, 1002177, 100000, 0, 184),
(2858, 9270020, 1002176, 100000, 0, 188),
(2859, 9270020, 1061080, 160000, 0, 192),
(2860, 9270020, 1061081, 160000, 0, 196),
(2861, 9270020, 1061062, 108000, 0, 200),
(2862, 9270020, 1061060, 108000, 0, 204),
(2863, 9270020, 1061064, 108000, 0, 208),
(2864, 9270020, 1061061, 108000, 0, 212),
(2865, 9270020, 1060069, 160000, 0, 216),
(2866, 9270020, 1060070, 160000, 0, 220),
(2867, 9270020, 1060063, 108000, 0, 224),
(2868, 9270020, 1060061, 108000, 0, 228),
(2869, 9270020, 1060065, 108000, 0, 232),
(2870, 9270020, 1060062, 108000, 0, 236),
(2871, 9270020, 1041081, 180000, 0, 240),
(2872, 9270020, 1041082, 180000, 0, 244),
(2873, 9270020, 1041067, 114000, 0, 248),
(2874, 9270020, 1041065, 114000, 0, 252),
(2875, 9270020, 1041069, 114000, 0, 256),
(2876, 9270020, 1041066, 114000, 0, 260),
(2877, 9270020, 1040079, 180000, 0, 264),
(2878, 9270020, 1040081, 180000, 0, 268),
(2879, 9270020, 1040076, 114000, 0, 272),
(2880, 9270020, 1040074, 114000, 0, 276),
(2881, 9270020, 1040073, 114000, 0, 280),
(2882, 9270020, 1040072, 114000, 0, 284),
(2883, 9270020, 1002137, 100000, 0, 288),
(2884, 9270020, 1002135, 100000, 0, 292),
(2885, 9270020, 1002139, 100000, 0, 296),
(2886, 9270020, 1002138, 100000, 0, 300),
(2887, 9270020, 1061047, 120000, 0, 304),
(2888, 9270020, 1061048, 120000, 0, 308),
(2889, 9270020, 1051027, 450000, 0, 312),
(2890, 9270020, 1051024, 450000, 0, 316),
(2891, 9270020, 1051025, 450000, 0, 320),
(2892, 9270020, 1051023, 450000, 0, 324),
(2893, 9270020, 1050037, 450000, 0, 328),
(2894, 9270020, 1050036, 450000, 0, 332),
(2895, 9270020, 1050038, 450000, 0, 336),
(2896, 9270020, 1050035, 450000, 0, 340),
(2897, 9270020, 1050002, 300000, 0, 344),
(2898, 9270020, 1050031, 300000, 0, 348),
(2899, 9270020, 1041051, 120000, 0, 352),
(2900, 9270020, 1041052, 120000, 0, 356),
(2901, 9270020, 1002144, 96000, 0, 360),
(2902, 9270020, 1002143, 96000, 0, 364),
(2903, 9270020, 1002142, 96000, 0, 368),
(2904, 9270020, 1002141, 96000, 0, 372),
(2905, 9270020, 1092002, 200000, 0, 376),
(2906, 9270020, 1092001, 100000, 0, 380),
(2907, 9270020, 1061084, 180000, 0, 384),
(2908, 9270020, 1061083, 180000, 0, 388),
(2909, 9270020, 1060074, 180000, 0, 392),
(2910, 9270020, 1060075, 180000, 0, 396),
(2911, 9270020, 1051014, 112500, 0, 400),
(2912, 9270020, 1051001, 112500, 0, 404),
(2913, 9270020, 1050021, 112500, 0, 408),
(2914, 9270020, 1050000, 112500, 0, 412),
(2915, 9270020, 1041085, 200000, 0, 416),
(2916, 9270020, 1041084, 200000, 0, 420),
(2917, 9270020, 1040085, 200000, 0, 424),
(2918, 9270020, 1040000, 200000, 0, 428),
(2919, 9270020, 1002004, 160000, 0, 432),
(2920, 9270021, 2070000, 500, 0, 104),
(2921, 9270021, 2022015, 12000, 0, 108),
(2922, 9270021, 2061000, 1, 0, 112),
(2923, 9270021, 2060000, 1, 0, 116),
(2924, 9270021, 2030000, 400, 0, 120),
(2925, 9270021, 2050003, 500, 0, 124),
(2926, 9270021, 2050002, 300, 0, 128),
(2927, 9270021, 2050001, 200, 0, 132),
(2928, 9270021, 2050000, 200, 0, 136),
(2929, 9270021, 2020028, 3000, 0, 140),
(2930, 9270021, 2010004, 310, 0, 144),
(2931, 9270021, 2010003, 100, 0, 148),
(2932, 9270021, 2010001, 106, 0, 152),
(2933, 9270021, 2010002, 50, 0, 156),
(2934, 9270021, 2010000, 30, 0, 160),
(2935, 9270021, 2001002, 4000, 0, 164),
(2936, 9270021, 2001001, 2300, 0, 168),
(2937, 9270021, 2001000, 3200, 0, 172),
(2938, 9270021, 2022000, 1650, 0, 176),
(2939, 9270021, 2022003, 1100, 0, 180),
(2940, 9270021, 2002005, 500, 0, 184),
(2941, 9270021, 2002004, 500, 0, 188),
(2942, 9270021, 2002002, 500, 0, 192),
(2943, 9270021, 2002001, 400, 0, 196),
(2944, 9270021, 2002000, 500, 0, 200),
(2945, 9270021, 2000006, 620, 0, 204),
(2946, 9270021, 2000003, 200, 0, 208),
(2947, 9270021, 2000002, 320, 0, 212),
(2948, 9270021, 2000001, 160, 0, 216),
(2949, 9270021, 2000000, 50, 0, 220),
(2950, 9270022, 2070000, 500, 0, 104),
(2951, 9270022, 2061000, 1, 0, 108),
(2952, 9270022, 2060000, 1, 0, 112),
(2953, 9270022, 2030000, 400, 0, 116),
(2954, 9270022, 2050003, 500, 0, 120),
(2955, 9270022, 2050002, 300, 0, 124),
(2956, 9270022, 2050001, 200, 0, 128),
(2957, 9270022, 2050000, 200, 0, 132),
(2958, 9270022, 2020028, 3000, 0, 136),
(2959, 9270022, 2010004, 310, 0, 140),
(2960, 9270022, 2010003, 100, 0, 144),
(2961, 9270022, 2010001, 106, 0, 148),
(2962, 9270022, 2010002, 50, 0, 152),
(2963, 9270022, 2010000, 30, 0, 156),
(2964, 9270022, 2001002, 4000, 0, 160),
(2965, 9270022, 2001001, 2300, 0, 164),
(2966, 9270022, 2001000, 3200, 0, 168),
(2967, 9270022, 2022000, 1650, 0, 172),
(2968, 9270022, 2022003, 1100, 0, 176),
(2969, 9270022, 2002005, 500, 0, 180),
(2970, 9270022, 2002004, 500, 0, 184),
(2971, 9270022, 2002002, 500, 0, 188),
(2972, 9270022, 2002001, 400, 0, 192),
(2973, 9270022, 2002000, 500, 0, 196),
(2974, 9270022, 2000006, 620, 0, 200),
(2975, 9270022, 2000003, 200, 0, 204),
(2976, 9270022, 2000002, 320, 0, 208),
(2977, 9270022, 2000001, 160, 0, 212),
(2978, 9270022, 2000000, 50, 0, 216),
(2979, 9270027, 2022215, 6800, 0, 112),
(2980, 9270027, 2022214, 3200, 0, 116),
(2981, 9270027, 2022211, 6400, 0, 120),
(2982, 9270027, 2022210, 3200, 0, 124),
(2983, 9270027, 2022209, 1600, 0, 128),
(2984, 9270027, 2022208, 1000, 0, 132),
(2985, 9270027, 2022207, 2600, 0, 136),
(2986, 9270027, 2022206, 2200, 0, 140),
(2987, 9270027, 2022205, 1800, 0, 144),
(2988, 9270027, 2022204, 1200, 0, 148),
(2989, 9270027, 2022203, 800, 0, 152),
(2990, 9999992, 1812006, 1, 0, 112),
(2991, 9999992, 1832000, 1, 0, 114),
(2992, 9999992, 1812005, 1, 0, 116),
(2993, 9999992, 1822000, 1, 0, 118),
(2994, 9999992, 1812004, 1, 0, 120),
(2995, 9999992, 1812003, 1, 0, 124),
(2996, 9999992, 1812002, 1, 0, 128),
(2997, 9999992, 1812001, 1, 0, 132),
(2998, 9999992, 1812000, 1, 0, 136),
(2999, 9999992, 1802100, 1, 0, 140),
(3000, 9999992, 1802055, 1, 0, 144),
(3001, 9999992, 1802053, 1, 0, 148),
(3002, 9999992, 1802052, 1, 0, 152),
(3003, 9999992, 1802051, 1, 0, 156),
(3004, 9999992, 1802050, 1, 0, 160),
(3005, 9999992, 1802049, 1, 0, 164),
(3006, 9999992, 1802048, 1, 0, 168),
(3007, 9999992, 1802047, 1, 0, 172),
(3008, 9999992, 1802045, 1, 0, 176),
(3009, 9999992, 1802044, 1, 0, 180),
(3010, 9999992, 1802042, 1, 0, 184),
(3011, 9999992, 1802038, 1, 0, 188),
(3012, 9999992, 1802037, 1, 0, 192),
(3013, 9999992, 1802036, 1, 0, 196),
(3014, 9999992, 1802035, 1, 0, 200),
(3015, 9999992, 1802034, 1, 0, 204),
(3016, 9999992, 1802033, 1, 0, 208),
(3017, 9999992, 1802032, 1, 0, 212),
(3018, 9999992, 1802031, 1, 0, 216),
(3019, 9999992, 1802030, 1, 0, 220),
(3020, 9999992, 1802029, 1, 0, 224),
(3021, 9999992, 1802028, 1, 0, 228),
(3022, 9999992, 1802027, 1, 0, 232),
(3023, 9999992, 1802026, 1, 0, 236),
(3024, 9999992, 1802025, 1, 0, 240),
(3025, 9999992, 1802024, 1, 0, 244),
(3026, 9999992, 1802023, 1, 0, 248),
(3027, 9999992, 1802022, 1, 0, 252),
(3028, 9999992, 1802021, 1, 0, 256),
(3029, 9999992, 1802020, 1, 0, 260),
(3030, 9999992, 1802019, 1, 0, 264),
(3031, 9999992, 1802018, 1, 0, 268),
(3032, 9999992, 1802017, 1, 0, 272),
(3033, 9999992, 1802016, 1, 0, 276),
(3034, 9999992, 1802015, 1, 0, 280),
(3035, 9999992, 1802014, 1, 0, 284),
(3036, 9999992, 1802013, 1, 0, 288),
(3037, 9999992, 1802012, 1, 0, 292),
(3038, 9999992, 1802011, 1, 0, 296),
(3039, 9999992, 1802010, 1, 0, 300),
(3040, 9999992, 1802009, 1, 0, 304),
(3041, 9999992, 1802008, 1, 0, 308),
(3042, 9999992, 1802007, 1, 0, 312),
(3043, 9999992, 1802006, 1, 0, 316),
(3044, 9999992, 1802005, 1, 0, 320),
(3045, 9999992, 1802004, 1, 0, 324),
(3046, 9999992, 1802003, 1, 0, 328),
(3047, 9999992, 1802002, 1, 0, 332),
(3048, 9999992, 1802001, 1, 0, 336),
(3049, 9999992, 1802000, 1, 0, 340),
(3050, 9999992, 5000045, 1, 0, 344),
(3051, 9999992, 5000044, 1, 0, 348),
(3052, 9999992, 5000041, 1, 0, 352),
(3053, 9999992, 5000039, 1, 0, 356),
(3054, 9999992, 5000037, 1, 0, 360),
(3055, 9999992, 5000036, 1, 0, 364),
(3056, 9999992, 5000034, 1, 0, 368),
(3057, 9999992, 5000025, 1, 0, 372),
(3058, 9999992, 5000024, 1, 0, 376),
(3059, 9999992, 5000023, 1, 0, 380),
(3060, 9999992, 5000022, 1, 0, 384),
(3061, 9999992, 5000020, 1, 0, 388),
(3062, 9999992, 5000017, 1, 0, 392),
(3063, 9999992, 5000015, 1, 0, 396),
(3064, 9999992, 5000014, 1, 0, 400),
(3065, 9999992, 5000013, 1, 0, 404),
(3066, 9999992, 5000012, 1, 0, 408),
(3067, 9999992, 5000011, 1, 0, 412),
(3068, 9999992, 5000010, 1, 0, 416),
(3069, 9999992, 5000009, 1, 0, 420),
(3070, 9999992, 5000008, 1, 0, 424),
(3071, 9999992, 5000007, 1, 0, 428),
(3072, 9999992, 5000006, 1, 0, 432),
(3073, 9999992, 5000005, 1, 0, 436),
(3074, 9999992, 5000004, 1, 0, 440),
(3075, 9999992, 5000003, 1, 0, 444),
(3076, 9999992, 5000002, 1, 0, 448),
(3077, 9999992, 5000001, 1, 0, 452),
(3078, 9999992, 5000000, 1, 0, 456),
(3079, 9999993, 5077000, 1, 0, 104),
(3080, 9999993, 5076000, 1, 0, 108),
(3081, 9999993, 5075000, 1, 0, 112),
(3082, 9999993, 5075001, 1, 0, 116),
(3083, 9999993, 5075002, 1, 0, 120),
(3084, 9999993, 5072000, 1, 0, 124),
(3085, 9999993, 5390000, 1, 0, 128),
(3086, 9999993, 5390001, 1, 0, 132),
(3087, 9999993, 5390002, 1, 0, 136),
(3088, 9999993, 5071000, 1, 0, 140),
(3089, 9999994, 3010041, 1, 0, 104),
(3090, 9999994, 3010040, 1, 0, 108),
(3091, 9999994, 3010028, 1, 0, 112),
(3092, 9999994, 3010026, 1, 0, 116),
(3093, 9999994, 3010025, 1, 0, 120),
(3094, 9999994, 3010024, 1, 0, 124),
(3095, 9999994, 3010023, 1, 0, 128),
(3096, 9999994, 3010022, 1, 0, 132),
(3097, 9999994, 3010019, 1, 0, 136),
(3098, 9999994, 3010018, 1, 0, 140),
(3099, 9999994, 3010017, 1, 0, 144),
(3100, 9999994, 3010016, 1, 0, 148),
(3101, 9999994, 3010015, 1, 0, 152),
(3102, 9999994, 3010014, 1, 0, 156),
(3103, 9999994, 3010013, 1, 0, 160),
(3104, 9999994, 3010012, 1, 0, 164),
(3105, 9999994, 3010011, 1, 0, 168),
(3106, 9999994, 3010010, 1, 0, 172),
(3107, 9999994, 3010009, 1, 0, 176),
(3108, 9999994, 3010008, 1, 0, 180),
(3109, 9999994, 3010007, 1, 0, 184),
(3110, 9999994, 3010006, 1, 0, 188),
(3111, 9999994, 3010005, 1, 0, 192),
(3112, 9999994, 3010004, 1, 0, 196),
(3113, 9999994, 3010003, 1, 0, 200),
(3114, 9999994, 3010002, 1, 0, 204),
(3115, 9999994, 3010001, 1, 0, 208),
(3116, 9999994, 3010000, 1, 0, 212),
(3117, 9999995, 1112230, 1, 0, 104),
(3118, 9999995, 1112229, 1, 0, 108),
(3119, 9999995, 1112228, 1, 0, 112),
(3120, 9999995, 1112227, 1, 0, 116),
(3121, 9999995, 1112226, 1, 0, 120),
(3122, 9999995, 1112225, 1, 0, 124),
(3123, 9999995, 1112224, 1, 0, 128),
(3124, 9999995, 1112223, 1, 0, 132),
(3125, 9999995, 1112222, 1, 0, 136),
(3126, 9999995, 1112221, 1, 0, 140),
(3127, 9999995, 1112220, 1, 0, 144),
(3128, 9999995, 1112219, 1, 0, 148),
(3129, 9999995, 1112218, 1, 0, 152),
(3130, 9999995, 1112217, 1, 0, 156),
(3131, 9999995, 1112216, 1, 0, 160),
(3132, 9999995, 1112215, 1, 0, 164),
(3133, 9999995, 1112214, 1, 0, 168),
(3134, 9999995, 1112213, 1, 0, 172),
(3135, 9999995, 1112212, 1, 0, 176),
(3136, 9999995, 1112211, 1, 0, 180),
(3137, 9999995, 1112210, 1, 0, 184),
(3138, 9999995, 1112209, 1, 0, 188),
(3139, 9999995, 1112208, 1, 0, 192),
(3140, 9999995, 1112207, 1, 0, 196),
(3141, 9999995, 1112206, 1, 0, 200),
(3142, 9999995, 1112205, 1, 0, 204),
(3143, 9999995, 1112204, 1, 0, 208),
(3144, 9999995, 1112203, 1, 0, 212),
(3145, 9999995, 1112202, 1, 0, 216),
(3146, 9999995, 1112201, 1, 0, 220),
(3147, 9999995, 1112200, 1, 0, 224),
(3148, 9999995, 1112120, 1, 0, 228),
(3149, 9999995, 1112119, 1, 0, 232),
(3150, 9999995, 1112118, 1, 0, 236),
(3151, 9999995, 1112117, 1, 0, 240),
(3152, 9999995, 1112116, 1, 0, 244),
(3153, 9999995, 1112115, 1, 0, 248),
(3154, 9999995, 1112114, 1, 0, 252),
(3155, 9999995, 1112113, 1, 0, 256),
(3156, 9999995, 1112112, 1, 0, 260),
(3157, 9999995, 1112111, 1, 0, 264),
(3158, 9999995, 1112110, 1, 0, 268),
(3159, 9999995, 1112109, 1, 0, 272),
(3160, 9999995, 1112108, 1, 0, 276),
(3161, 9999995, 1112107, 1, 0, 280),
(3162, 9999995, 1112106, 1, 0, 284),
(3163, 9999995, 1112105, 1, 0, 288),
(3164, 9999995, 1112104, 1, 0, 292),
(3165, 9999995, 1112103, 1, 0, 296),
(3166, 9999995, 1112102, 1, 0, 300),
(3167, 9999995, 1112101, 1, 0, 304),
(3168, 9999995, 1112100, 1, 0, 308),
(3169, 9999996, 1012010, 1, 0, 104),
(3170, 9999996, 1011002, 1, 0, 108),
(3171, 9999996, 1012000, 1, 0, 112),
(3172, 9999996, 1012024, 1, 0, 116),
(3173, 9999996, 1012074, 1, 0, 120),
(3174, 9999996, 1012083, 1, 0, 124),
(3175, 9999996, 1012055, 1, 0, 128),
(3176, 9999996, 1011003, 1, 0, 132),
(3177, 9999996, 1012028, 1, 0, 136),
(3178, 9999996, 1012006, 1, 0, 140),
(3179, 9999996, 1012027, 1, 0, 144),
(3180, 9999996, 1012032, 1, 0, 148),
(3181, 9999996, 1012031, 1, 0, 152),
(3182, 9999996, 1022007, 1, 0, 156),
(3183, 9999996, 1022006, 1, 0, 160),
(3184, 9999996, 1022044, 1, 0, 164),
(3185, 9999996, 1022033, 1, 0, 168),
(3186, 9999996, 1022019, 1, 0, 172),
(3187, 9999996, 1022020, 1, 0, 176),
(3188, 9999996, 1022005, 1, 0, 180),
(3189, 9999996, 1022004, 1, 0, 184),
(3190, 9999996, 1022003, 1, 0, 188),
(3191, 9999996, 1022002, 1, 0, 192),
(3192, 9999996, 1022001, 1, 0, 196),
(3193, 9999996, 1022000, 1, 0, 200),
(3194, 9999996, 5160014, 1, 0, 204),
(3195, 9999996, 5160013, 1, 0, 208),
(3196, 9999996, 5160012, 1, 0, 212),
(3197, 9999996, 5160011, 1, 0, 216),
(3198, 9999996, 5160009, 1, 0, 220),
(3199, 9999996, 5160008, 1, 0, 224),
(3200, 9999996, 5160007, 1, 0, 228),
(3201, 9999996, 5160006, 1, 0, 232),
(3202, 9999996, 5160005, 1, 0, 236),
(3203, 9999996, 5160004, 1, 0, 240),
(3204, 9999996, 5160003, 1, 0, 244),
(3205, 9999996, 5160002, 1, 0, 248),
(3206, 9999996, 5160001, 1, 0, 252),
(3207, 9999996, 5160000, 1, 0, 256),
(3208, 9999997, 1070002, 1, 0, 104),
(3209, 9999997, 1071008, 1, 0, 108),
(3210, 9999997, 1052049, 1, 0, 112),
(3211, 9999997, 1072234, 1, 0, 116),
(3212, 9999997, 1072325, 1, 0, 120),
(3213, 9999997, 1072326, 1, 0, 124),
(3214, 9999997, 1072235, 1, 0, 128),
(3215, 9999997, 1072189, 1, 0, 132),
(3216, 9999997, 1072257, 1, 0, 136),
(3217, 9999997, 1072186, 1, 0, 140),
(3218, 9999997, 1072258, 1, 0, 144),
(3219, 9999997, 1072260, 1, 0, 148),
(3220, 9999997, 1072279, 1, 0, 152),
(3221, 9999997, 1072276, 1, 0, 156),
(3222, 9999997, 1072153, 1, 0, 160),
(3223, 9999997, 1062003, 1, 0, 164),
(3224, 9999997, 1062018, 1, 0, 168),
(3225, 9999997, 1062040, 1, 0, 172),
(3226, 9999997, 1062032, 1, 0, 176),
(3227, 9999997, 1082102, 1, 0, 180),
(3228, 9999997, 1102156, 1, 0, 184),
(3229, 9999997, 1102039, 1, 0, 188),
(3230, 9999997, 1042013, 1, 0, 192),
(3231, 9999997, 1042018, 1, 0, 196),
(3232, 9999997, 1042012, 1, 0, 200),
(3233, 9999997, 1042036, 1, 0, 204),
(3234, 9999997, 1042037, 1, 0, 208),
(3235, 9999997, 1042099, 1, 0, 212),
(3236, 9999997, 1042043, 1, 0, 216),
(3237, 9999997, 1032054, 1, 0, 220),
(3238, 9999997, 1032053, 1, 0, 224),
(3239, 9999997, 1032052, 1, 0, 228),
(3240, 9999997, 1032024, 1, 0, 232),
(3241, 9999997, 1002294, 1, 0, 236),
(3242, 9999997, 1002342, 1, 0, 240),
(3243, 9999997, 1002485, 1, 0, 244),
(3244, 9999997, 1002343, 1, 0, 248),
(3245, 9999997, 1002667, 1, 0, 252),
(3246, 9999997, 1002234, 1, 0, 256),
(3247, 9999997, 1002186, 1, 0, 260),
(3248, 9999997, 1702136, 1, 0, 264),
(3249, 9999997, 1702121, 1, 0, 268),
(3250, 9999997, 1702179, 1, 0, 272),
(3251, 9999997, 1702187, 1, 0, 276),
(3252, 9999997, 1702185, 1, 0, 280),
(3253, 9999997, 1702184, 1, 0, 284),
(3254, 9999997, 1702183, 1, 0, 288),
(3255, 9999997, 1702180, 1, 0, 292),
(3256, 9999997, 1702120, 1, 0, 296),
(3257, 9999997, 1702119, 1, 0, 300),
(3258, 9999997, 1702118, 1, 0, 304),
(3259, 9999998, 2040026, 1, 0, 104),
(3260, 9999998, 2040016, 1, 0, 108),
(3261, 9999998, 2040031, 1, 0, 112),
(3262, 9999998, 2040920, 1, 0, 116),
(3263, 9999998, 2040915, 1, 0, 120),
(3264, 9999998, 2041057, 1, 0, 124),
(3265, 9999998, 2041053, 1, 0, 128),
(3266, 9999998, 2041055, 1, 0, 132),
(3267, 9999998, 2041051, 1, 0, 136),
(3268, 9999998, 2040529, 1, 0, 140),
(3269, 9999998, 2040527, 1, 0, 144),
(3270, 9999998, 2040506, 1, 0, 148),
(3271, 9999998, 2040534, 1, 0, 152),
(3272, 9999998, 2040710, 1, 0, 156),
(3273, 9999998, 2040709, 1, 0, 160),
(3274, 9999998, 2040806, 1, 0, 164),
(3275, 9999998, 2040323, 1, 0, 168),
(3276, 9999998, 2040303, 1, 0, 172),
(3277, 9999998, 2040318, 1, 0, 176),
(3278, 9999998, 2044902, 1, 0, 180),
(3279, 9999998, 2044802, 1, 0, 184),
(3280, 9999998, 2043703, 1, 0, 188),
(3281, 9999998, 2044203, 1, 0, 192),
(3282, 9999998, 2044103, 1, 0, 196),
(3283, 9999998, 2044003, 1, 0, 200),
(3284, 9999998, 2043803, 1, 0, 204),
(3285, 9999998, 2044303, 1, 0, 208),
(3286, 9999998, 2044403, 1, 0, 212),
(3287, 9999998, 2043203, 1, 0, 216),
(3288, 9999998, 2043103, 1, 0, 220),
(3289, 9999998, 2043003, 1, 0, 224),
(3290, 9999998, 2040807, 1, 0, 228),
(3291, 9999998, 2043303, 1, 0, 232),
(3292, 9999998, 2044603, 1, 0, 236),
(3293, 9999998, 2044703, 1, 0, 240),
(3294, 9999998, 2044503, 1, 0, 244),
(3295, 9999998, 2041200, 1, 0, 248),
(3296, 9999998, 2049100, 1, 0, 252),
(3297, 9999998, 2049002, 1, 0, 256),
(3298, 9999998, 2340000, 1, 0, 260),
(3299, 9999999, 1082150, 1, 0, 104),
(3300, 9999999, 1082148, 1, 0, 108),
(3301, 9999999, 1082147, 1, 0, 112),
(3302, 9999999, 1082146, 1, 0, 116),
(3303, 9999999, 1082145, 1, 0, 120),
(3304, 9999999, 1102103, 1, 0, 124),
(3305, 9999999, 1102102, 1, 0, 128),
(3306, 9999999, 1102101, 1, 0, 132),
(3307, 9999999, 1102106, 1, 0, 136),
(3308, 9999999, 1102105, 1, 0, 140),
(3309, 9999999, 1102104, 1, 0, 144),
(3310, 9999999, 1092022, 1, 0, 148),
(3311, 9999999, 1032032, 1, 0, 152),
(3312, 9999999, 1032031, 1, 0, 156),
(3313, 9999999, 1032030, 1, 0, 160),
(3314, 9999999, 1032028, 1, 0, 164),
(3315, 9999999, 1032027, 1, 0, 168),
(3316, 9999999, 1032026, 1, 0, 172),
(3317, 9999999, 1032048, 1, 0, 176),
(3318, 9999999, 1102042, 1, 0, 180),
(3319, 9999999, 1102041, 1, 0, 184),
(3320, 9999999, 1122001, 1, 0, 188),
(3321, 9999999, 1122000, 1, 0, 192),
(3322, 9999999, 1072344, 1, 0, 196),
(3323, 9999999, 1072239, 1, 0, 200),
(3324, 9999999, 1051140, 1, 0, 204),
(3325, 9999999, 1050127, 1, 0, 208),
(3326, 9999999, 1050100, 1, 0, 212),
(3327, 9999999, 1051098, 1, 0, 216),
(3328, 9999999, 1050018, 1, 0, 220),
(3329, 9999999, 1051017, 1, 0, 224),
(3330, 9999999, 1082149, 1, 0, 228),
(3331, 9999999, 1082223, 1, 0, 232),
(3332, 9999999, 1002518, 1, 0, 236),
(3333, 9999999, 1002357, 1, 0, 240),
(3334, 9999999, 1492013, 1, 0, 244),
(3335, 9999999, 1482023, 1, 0, 248),
(3336, 9999999, 1412033, 1, 0, 252),
(3337, 9999999, 1422037, 1, 0, 256),
(3338, 9999999, 1302081, 1, 0, 260),
(3339, 9999999, 1402046, 1, 0, 264),
(3340, 9999999, 1372040, 1, 0, 268),
(3341, 9999999, 1382050, 1, 0, 272),
(3342, 9999999, 1432038, 1, 0, 276),
(3343, 9999999, 1442045, 1, 0, 280),
(3344, 9999999, 1462039, 1, 0, 284),
(3345, 9999999, 1092049, 1, 0, 288),
(3346, 9999999, 1332050, 1, 0, 292),
(3347, 9999999, 1332049, 1, 0, 296),
(3348, 9999999, 1452044, 1, 0, 300),
(3349, 9999999, 1472052, 1, 0, 304),
(3350, 9999999, 2330005, 1, 0, 308),
(3351, 9999999, 2070018, 1, 0, 312),
(3352, 9999999, 4006001, 1, 0, 316),
(3353, 9999999, 4006000, 1, 0, 320),
(3354, 9999999, 1902002, 1, 0, 324),
(3355, 9999999, 1902001, 1, 0, 328),
(3356, 9999999, 1902000, 1, 0, 332),
(3357, 9999999, 1912000, 1, 0, 336),
(3358, 9999999, 2022283, 1, 0, 340),
(3359, 9999999, 2022282, 1, 0, 344),
(3360, 9999999, 2022273, 1, 0, 348),
(3361, 9999999, 2022179, 1, 0, 352),
(3362, 9999999, 1322013, 1, 0, 356),
(3363, 9999999, 1072200, 1, 0, 360),
(3364, 9999999, 1062007, 1, 0, 364),
(3365, 9999999, 1042003, 1, 0, 368),
(3366, 9999999, 1002140, 1, 0, 372),
(6479, 1337, 1002140, 1, 0, 1),
(6480, 1337, 1042003, 1, 0, 2),
(6481, 1337, 1062007, 1, 0, 3),
(6482, 1337, 1322013, 1, 0, 4),
(6483, 1337, 1072010, 1, 0, 5),
(6484, 1337, 2022179, 1, 0, 6),
(6485, 1337, 2022273, 1, 0, 7),
(6486, 1337, 5072000, 1, 0, 8),
(6487, 1337, 5390000, 1, 0, 9),
(6488, 1337, 5390001, 1, 0, 10),
(6489, 1337, 5390002, 1, 0, 11),
(6490, 1337, 1452044, 1, 0, 12),
(6491, 1337, 1472052, 1, 0, 13),
(6492, 1337, 1462039, 1, 0, 14),
(6493, 1337, 1332050, 1, 0, 15),
(6494, 1337, 1312031, 1, 0, 16),
(6495, 1337, 1322052, 1, 0, 17),
(6496, 1337, 1302059, 1, 0, 18),
(6497, 1337, 1442045, 1, 0, 19),
(6498, 1337, 1432038, 1, 0, 20),
(6499, 1337, 1382036, 1, 0, 21),
(6500, 1337, 1412026, 1, 0, 22),
(6501, 1337, 1422028, 1, 0, 23),
(6502, 1337, 1402036, 1, 0, 24),
(6503, 1337, 1122000, 1, 0, 25),
(6504, 1337, 2041200, 1, 0, 26),
(6505, 1337, 4006001, 1, 0, 27),
(6506, 1337, 4001017, 1, 0, 28),
(6507, 1337, 4031179, 1, 0, 29),
(6508, 1337, 1912000, 1, 0, 30),
(6509, 1337, 1902000, 1, 0, 31),
(6510, 1337, 1902001, 1, 0, 32),
(6511, 1337, 1902002, 1, 0, 33),
(6512, 1337, 2044503, 1, 0, 34),
(6513, 1337, 2044703, 1, 0, 44),
(6514, 1337, 2044603, 1, 0, 45),
(6515, 1337, 2043303, 1, 0, 46),
(6516, 1337, 2043103, 1, 0, 47),
(6517, 1337, 2043203, 1, 0, 48),
(6518, 1337, 2043003, 1, 0, 49),
(6519, 1337, 2044403, 1, 0, 50),
(6520, 1337, 2044303, 1, 0, 51),
(6521, 1337, 2043803, 1, 0, 52),
(6522, 1337, 2044103, 1, 0, 53),
(6523, 1337, 2044203, 1, 0, 54),
(6524, 1337, 2044003, 1, 0, 55),
(6525, 1337, 2043703, 1, 0, 56),
(6526, 1337, 2040807, 1, 0, 57),
(6527, 1337, 2040806, 1, 0, 58),
(6528, 1337, 2040007, 1, 0, 59),
(6529, 1337, 2040506, 1, 0, 60),
(6530, 1337, 2040710, 1, 0, 61),
(6531, 1337, 2040711, 1, 0, 62),
(6532, 1337, 2340000, 1, 0, 63),
(20020, 1337, 1082149, 1, 0, 64),
(20255, 1337, 2044503, 1, 0, 86),	# 20255~20273: thanks to ozanrijen
(20256, 1337, 2044703, 1, 0, 87),
(20257, 1337, 2044603, 1, 0, 88),
(20258, 1337, 2043303, 1, 0, 89),
(20259, 1337, 2043103, 1, 0, 90),
(20260, 1337, 2043203, 1, 0, 91),
(20261, 1337, 2043003, 1, 0, 92),
(20262, 1337, 2044403, 1, 0, 93),
(20263, 1337, 2044303, 1, 0, 94),
(20264, 1337, 2043803, 1, 0, 95),
(20265, 1337, 2044103, 1, 0, 96),
(20266, 1337, 2044203, 1, 0, 97),
(20267, 1337, 2044003, 1, 0, 98),
(20268, 1337, 2043703, 1, 0, 99),
(20269, 1337, 2040806, 1, 0, 100),
(20270, 1337, 2040007, 1, 0, 101),
(20271, 1337, 2040506, 1, 0, 102),
(20272, 1337, 2040710, 1, 0, 103),
(20273, 1337, 2040711, 1, 0, 104),
(6533, 9000069, 2022503, 0, 5, 1),
(6534, 9000069, 2000004, 0, 5, 2),
(6535, 9000069, 2022514, 0, 10, 3),
(6536, 9000069, 2000005, 0, 10, 4),
(6537, 9000069, 3010116, 0, 25, 5),
(6538, 9000069, 1122017, 0, 30, 6),
(6539, 9000069, 2049000, 0, 45, 7),
(6540, 9000069, 2049100, 0, 70, 8),
(6541, 9000069, 1003016, 0, 100, 9),
(20021, 1338, 2010003, 100, 0, 104),
(20022, 1338, 2061000, 1, 0, 108),
(20023, 1338, 2060000, 1, 0, 112),
(20024, 1338, 2030000, 400, 0, 116),
(20025, 1338, 2022195, 15000, 0, 120),
(20026, 1338, 2020015, 10200, 0, 124),
(20027, 1338, 2020014, 8100, 0, 128),
(20028, 1338, 2020013, 5600, 0, 132),
(20029, 1338, 2020012, 4500, 0, 136),
(20030, 1338, 2022190, 3000, 0, 140),
(20031, 1338, 2001002, 4000, 0, 144),
(20032, 1338, 2001001, 2300, 0, 148),
(20033, 1338, 2001000, 3200, 0, 152),
(20034, 1338, 2022000, 1650, 0, 156),
(20035, 1338, 2022003, 1100, 0, 160),
(20036, 1338, 2022192, 600, 0, 164),
(20037, 1338, 2022191, 1000, 0, 168),
(20038, 1338, 2022189, 1000, 0, 172),
(20039, 1338, 2010004, 310, 0, 176),
(20040, 1338, 2010001, 106, 0, 180),
(20041, 1338, 2010002, 50, 0, 184),
(20042, 1338, 2010000, 30, 0, 188),
(20043, 1338, 2002025, 1500, 0, 192),
(20044, 1338, 2002024, 1500, 0, 196),
(20045, 1338, 2002023, 3800, 0, 200),
(20046, 1338, 5041000, 1500000, 0, 200),
(20047, 9201099, 2030020, 400, 0, 1),
(20048, 9201099, 2022002, 1000, 0, 2),
(20049, 9201099, 2000018, 620, 0, 3),
(20050, 9201099, 2022003, 1100, 0, 4),
(20051, 9201099, 2070010, 2000, 0, 5),
(20052, 9201099, 2061004, 40, 0, 6),
(20053, 9201099, 2060004, 40, 0, 7),
(20054, 9201099, 2002017, 5000, 0, 8),
(20055, 9201099, 2022000, 1650, 0, 9),
(20056, 9201099, 2050003, 500, 0, 10),
(20057, 9201099, 2050002, 300, 0, 11),
(20058, 9201099, 2050001, 200, 0, 12),
(20059, 9201099, 2020015, 9690, 0, 13),
(20060, 9201099, 2020014, 8100, 0, 14),
(20061, 9201099, 2020013, 5000, 0, 15),
(20062, 9201099, 2020012, 4500, 0, 16),
(20063, 9201099, 2050000, 200, 0, 17),
(20064, 9201099, 2050004, 400, 0, 18),
(20065, 9270057, 2022015, 12000, 0, 1),
(20066, 9270057, 2061000, 1, 0, 2),
(20067, 9270057, 2060000, 1, 0, 3),
(20068, 9270057, 2030000, 400, 0, 5),
(20069, 9270057, 2050003, 500, 0, 6),
(20070, 9270057, 2050002, 300, 0, 7),
(20071, 9270057, 2050001, 200, 0, 8),
(20072, 9270057, 2050000, 200, 0, 9),
(20073, 9270057, 2020028, 3000, 0, 10),
(20074, 9270057, 2010004, 310, 0, 11),
(20075, 9270057, 2010003, 100, 0, 12),
(20076, 9270057, 2010001, 106, 0, 13),
(20077, 9270057, 2010002, 50, 0, 14),
(20078, 9270057, 2010000, 30, 0, 15),
(20079, 9270057, 2001002, 4000, 0, 16),
(20080, 9270057, 2001001, 2300, 0, 17),
(20081, 9270057, 2001000, 3200, 0, 18),
(20082, 9270057, 2022000, 1650, 0, 19),
(20083, 9270057, 2022003, 1100, 0, 20),
(20084, 9270057, 2002005, 500, 0, 21),
(20085, 9270057, 2002004, 500, 0, 22),
(20086, 9270057, 2002002, 500, 0, 23),
(20087, 9270057, 2002001, 400, 0, 24),
(20088, 9270057, 2002000, 500, 0, 25),
(20089, 9270057, 2000006, 620, 0, 26),
(20090, 9270057, 2000003, 200, 0, 27),
(20091, 9270057, 2000002, 320, 0, 28),
(20092, 9270057, 2000001, 160, 0, 29),
(20093, 9270057, 2000000, 50, 0, 30),
(20094, 9270055, 1492006, 160000, 0, 1), 
(20095, 9270055, 1492005, 100000, 0, 2),
(20096, 9270055, 1492004, 50000, 0, 3),
(20097, 9270055, 1492003, 22000, 0, 4),
(20098, 9270055, 1482006, 150000, 0, 5),
(20099, 9270055, 1482005, 100000, 0, 6),
(20100, 9270055, 1482004, 52000, 0, 7),
(20101, 9270055, 1482003, 20000, 0, 8),
(20102, 9270055, 1472007, 60000, 0, 9),
(20103, 9270055, 1472004, 30000, 0, 10),
(20104, 9270055, 1472001, 20000, 0, 11),
(20105, 9270055, 1462005, 250000, 0, 12),
(20106, 9270055, 1462004, 200000, 0, 13),
(20107, 9270055, 1462000, 30000, 0, 14),
(20108, 9270055, 1452007, 375000, 0, 15),
(20109, 9270055, 1452006, 250000, 0, 16),
(20110, 9270055, 1452005, 150000, 0, 17),
(20111, 9270055, 1442009, 300000, 0, 18),
(20112, 9270055, 1442003, 175000, 0, 19),
(20113, 9270055, 1442001, 60000, 0, 20),
(20114, 9270055, 1432005, 225000, 0, 21),
(20115, 9270055, 1432003, 175000, 0, 22),
(20116, 9270055, 1432002, 60000, 0, 23),
(20117, 9270055, 1422007, 250000, 0, 24),
(20118, 9270055, 1422008, 200000, 0, 25),
(20119, 9270055, 1422001, 45000, 0, 26),
(20120, 9270055, 1412005, 250000, 0, 27),
(20121, 9270055, 1412004, 200000, 0, 28),
(20122, 9270055, 1412006, 45000, 0, 29),
(20123, 9270055, 1402007, 450000, 0, 30),
(20124, 9270055, 1402006, 350000, 0, 31),
(20125, 9270055, 1402002, 150000, 0, 32),
(20126, 9270055, 1382002, 20000, 0, 33),
(20127, 9270055, 1372000, 400000, 0, 34),
(20128, 9270055, 1372001, 175000, 0, 35),
(20129, 9270055, 1372003, 38000, 0, 36),
(20130, 9270055, 1332011, 425000, 0, 37),
(20131, 9270055, 1332014, 375000, 0, 38),
(20132, 9270055, 1332001, 200000, 0, 39),
(20133, 9270055, 1332012, 40000, 0, 40),
(20134, 9270055, 1332009, 42000, 0, 41),
(20135, 9270055, 1322016, 175000, 0, 42),
(20136, 9270055, 1322015, 100000, 0, 43),
(20137, 9270055, 1322014, 40000, 0, 44),
(20138, 9270055, 1312007, 175000, 0, 45),
(20139, 9270055, 1312006, 100000, 0, 46),
(20140, 9270055, 1312005, 40000, 0, 47),
(20141, 9270055, 1302009, 225000, 0, 48),
(20142, 9270055, 1302004, 100000, 0, 49),
(20143, 9270055, 1302008, 40000, 0, 50),
(20144, 9270056, 1002625, 75000, 0, 104),
(20145, 9270056, 1052113, 120000, 0, 108),
(20146, 9270056, 1052110, 100000, 0, 112),
(20147, 9270056, 1061069, 160000, 0, 116),
(20148, 9270056, 1061070, 160000, 0, 120),
(20149, 9270056, 1060072, 160000, 0, 124),
(20150, 9270056, 1060071, 160000, 0, 128),
(20151, 9270056, 1060052, 108000, 0, 132),
(20152, 9270056, 1060050, 108000, 0, 136),
(20153, 9270056, 1060051, 108000, 0, 140),
(20154, 9270056, 1051009, 111000, 0, 144),
(20155, 9270056, 1051008, 111000, 0, 148),
(20156, 9270056, 1051007, 111000, 0, 152),
(20157, 9270056, 1041074, 180000, 0, 156),
(20158, 9270056, 1041075, 180000, 0, 160),
(20159, 9270056, 1040083, 180000, 0, 164),
(20160, 9270056, 1040082, 180000, 0, 168),
(20161, 9270056, 1040061, 114000, 0, 172),
(20162, 9270056, 1040062, 114000, 0, 176),
(20163, 9270056, 1040063, 114000, 0, 180),
(20164, 9270056, 1002180, 100000, 0, 184),
(20165, 9270056, 1002179, 100000, 0, 188),
(20166, 9270056, 1002178, 100000, 0, 192),
(20167, 9270056, 1002177, 100000, 0, 196),
(20168, 9270056, 1002176, 100000, 0, 200),
(20169, 9270056, 1061080, 160000, 0, 204),
(20170, 9270056, 1061081, 160000, 0, 208),
(20171, 9270056, 1061062, 108000, 0, 212),
(20172, 9270056, 1061060, 108000, 0, 216),
(20173, 9270056, 1061064, 108000, 0, 220),
(20174, 9270056, 1061061, 108000, 0, 224),
(20175, 9270056, 1060069, 160000, 0, 228),
(20176, 9270056, 1060070, 160000, 0, 232),
(20177, 9270056, 1060063, 108000, 0, 236),
(20178, 9270056, 1060061, 108000, 0, 240),
(20179, 9270056, 1060065, 108000, 0, 244),
(20180, 9270056, 1060062, 108000, 0, 248),
(20181, 9270056, 1041081, 180000, 0, 252),
(20182, 9270056, 1041082, 180000, 0, 256),
(20183, 9270056, 1041067, 114000, 0, 260),
(20184, 9270056, 1041065, 114000, 0, 264),
(20185, 9270056, 1041069, 114000, 0, 268),
(20186, 9270056, 1041066, 114000, 0, 272),
(20187, 9270056, 1040079, 180000, 0, 276),
(20188, 9270056, 1040081, 180000, 0, 280),
(20189, 9270056, 1040076, 114000, 0, 284),
(20190, 9270056, 1040074, 114000, 0, 288),
(20191, 9270056, 1040073, 114000, 0, 292),
(20192, 9270056, 1040072, 114000, 0, 296),
(20193, 9270056, 1002137, 100000, 0, 300),
(20194, 9270056, 1002135, 100000, 0, 304),
(20195, 9270056, 1002139, 100000, 0, 308),
(20196, 9270056, 1002138, 100000, 0, 312),
(20197, 9270056, 1061047, 120000, 0, 316),
(20198, 9270056, 1061048, 120000, 0, 320),
(20199, 9270056, 1051027, 450000, 0, 324),
(20200, 9270056, 1051024, 450000, 0, 328),
(20201, 9270056, 1051025, 450000, 0, 332),
(20202, 9270056, 1051023, 450000, 0, 336),
(20203, 9270056, 1050037, 450000, 0, 340),
(20204, 9270056, 1050036, 450000, 0, 344),
(20205, 9270056, 1050038, 450000, 0, 348),
(20206, 9270056, 1050035, 450000, 0, 352),
(20207, 9270056, 1050002, 300000, 0, 356),
(20208, 9270056, 1050031, 300000, 0, 360),
(20209, 9270056, 1041051, 120000, 0, 364),
(20210, 9270056, 1041052, 120000, 0, 368),
(20211, 9270056, 1002144, 96000, 0, 372),
(20212, 9270056, 1002143, 96000, 0, 376),
(20213, 9270056, 1002142, 96000, 0, 380),
(20214, 9270056, 1002141, 96000, 0, 384),
(20215, 9270056, 1092002, 200000, 0, 388),
(20216, 9270056, 1092001, 100000, 0, 392),
(20217, 9270056, 1061084, 180000, 0, 396),
(20218, 9270056, 1061083, 180000, 0, 400),
(20219, 9270056, 1060074, 180000, 0, 404),
(20220, 9270056, 1060075, 180000, 0, 408),
(20221, 9270056, 1051014, 112500, 0, 412),
(20222, 9270056, 1051001, 112500, 0, 416),
(20223, 9270056, 1050021, 112500, 0, 420),
(20224, 9270056, 1050000, 112500, 0, 424),
(20225, 9270056, 1041085, 200000, 0, 428),
(20226, 9270056, 1041084, 200000, 0, 432),
(20227, 9270056, 1040085, 200000, 0, 436),
(20228, 9270056, 1040000, 200000, 0, 440),
(20229, 9270056, 1002004, 160000, 0, 444),
(20230, 9270065, 2061000, 1, 0, 1),
(20231, 9270065, 2060000, 1, 0, 2),
(20232, 9270065, 2030000, 400, 0, 4),
(20233, 9270065, 2050003, 500, 0, 5),
(20234, 9270065, 2050002, 300, 0, 6),
(20235, 9270065, 2050001, 200, 0, 7),
(20236, 9270065, 2050000, 200, 0, 8),
(20237, 9270065, 2022215, 6800, 0, 9),
(20238, 9270065, 2022214, 3200, 0, 10),
(20239, 9270065, 2022213, 6800, 0, 11),
(20240, 9270065, 2022212, 3200, 0, 12),
(20241, 9270065, 2022211, 6400, 0, 13),
(20242, 9270065, 2022210, 3200, 0, 14),
(20243, 9270065, 2022209, 1600, 0, 15),
(20244, 9270065, 2022208, 1000, 0, 16),
(20245, 9270065, 2022207, 2600, 0, 17),
(20246, 9270065, 2022206, 2200, 0, 18),
(20247, 9270065, 2022205, 1800, 0, 19),
(20248, 9270065, 2022204, 1200, 0, 20),
(20249, 9270065, 2022203, 800, 0, 21),
(20250, 9270065, 2022480, 12000, 0, 22),
(20251, 9270065, 2022479, 3800, 0, 23),
(20252, 9270065, 2022478, 3200, 0, 24),
(20253, 9270065, 2022477, 9200, 0, 25),
(20254, 9270065, 2022476, 4200, 0, 26);

CREATE TABLE IF NOT EXISTS `shops` (
  `shopid` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `npcid` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`shopid`)
) ENGINE=InnoDB  DEFAULT CHARSET=latin1 AUTO_INCREMENT=10000000 ;

INSERT INTO `shops` (`shopid`, `npcid`) VALUES
(11000, 11000),
(11100, 11100),
(21000, 21000),
(1001000, 1001000),
(1001001, 1001001),
(1001100, 1001100),
(1011000, 1011000),
(1011001, 1011001),
(1011100, 1011100),
(1012004, 1012004),
(1021000, 1021000),
(1021001, 1021001),
(1021100, 1021100),
(1031000, 1031000),
(1031001, 1031001),
(1031100, 1031100),
(1032103, 1032103),
(1051000, 1051000),
(1051001, 1051001),
(1051002, 1051002),
(1052104, 1052104),
(1061001, 1061001),
(1061002, 1061002),
(1081000, 1081000),
(1091000, 1091000),
(1091001, 1091001),
(1091002, 1091002),
(1093000, 1093000),
(1100001, 1100001),
(1100002, 1100002),
(2010004, 2010004),
(2012003, 2012003),
(2012004, 2012004),
(2012005, 2012005),
(2020001, 2020001),
(2022000, 2022000),
(2022001, 2022001),
(2022002, 2022002),
(2030009, 2030009),
(2040049, 2040049),
(2040051, 2040051),
(2041002, 2041002),
(2041003, 2041003),
(2041006, 2041006),
(2041014, 2041014),
(2041016, 2041016),
(2050000, 2050000),
(2050003, 2050003),
(2051000, 2051000),
(2060003, 2060003),
(2060004, 2060004),
(2060007, 2060007),
(2070001, 2070001),
(2070002, 2070002),
(2070003, 2070003),
(2080001, 2080001),
(2080002, 2080002),
(2080003, 2080003),
(2080004, 2080004),
(2090001, 2090001),
(2090002, 2090002),
(2090003, 2090003),
(2090006, 2090006),
(2093000, 2093000),
(2093001, 2093001),
(2093002, 2093002),
(2100002, 2100002),
(2100003, 2100003),
(2100004, 2100004),
(2110001, 2110001),
(2130000, 2130000),
(9110003, 9110003),
(9110004, 9110004),
(9110005, 9110005),
(9110006, 9110006),
(9110007, 9110007),
(9120000, 9120000),
(9120002, 9120002),
(9120004, 9120004),
(9120019, 9120019),
(9201020, 9201020),
(9201058, 9201058),
(9201059, 9201059),
(9201060, 9201060),
(9201099, 9201099),
(9270019, 9270019),
(9270020, 9270020),
(9270021, 9270021),
(9270022, 9270022),
(9270027, 9270027),
(9999992, 9001002),
(9999993, 9001002),
(9999994, 9001002),
(9999995, 9001002),
(9999996, 9001002),
(9999997, 9001002),
(9999998, 9001002),
(9999999, 9001002),
(1337, 11000),
(9000069, 9000069),
(1338, 9090000),
(9270055, 9270055),
(9270056, 9270056),
(9270057, 9270057),
(9270065, 9270065);

 -- missing shops
INSERT INTO `shops` (`shopid`, `npcid`) VALUES
( 57, 2002001 ),
(1052116, 1052116),
(1301000, 1301000),
(1200001, 1200001),
(1200002, 1200002);

INSERT INTO `shopitems` ( `shopid`, `itemid`, `price`, `position`) VALUES
( 57, 3990000, 500, 1 ), 
( 57, 3990001, 500, 2 ), 
( 57, 3990002, 500, 3 ), 
( 57, 3990003, 500, 4 ), 
( 57, 3990004, 500, 5 ), 
( 57, 3990005, 500, 6 ), 
( 57, 3990006, 500, 7 ), 
( 57, 3990007, 500, 8 ), 
( 57, 3990008, 500, 9 ), 
( 57, 3990009, 500, 10), 
( 57, 3990010, 500, 11), 
( 57, 3990011, 500, 12), 
( 57, 3990012, 500, 13), 
( 57, 3990013, 500, 14), 
( 57, 3990014, 500, 15), 
( 57, 3990015, 500, 16), 
( 57, 3990016, 500, 17), 
( 57, 3990017, 500, 18), 
( 57, 3990018, 500, 19), 
( 57, 3990019, 500, 20), 
( 57, 3990020, 500, 21), 
( 57, 3990021, 500, 22), 
( 57, 3990022, 500, 23), 
( 57, 3990023, 500, 24), 
( 57, 3991000, 500, 25), 
( 57, 3991001, 500, 26), 
( 57, 3991002, 500, 27), 
( 57, 3991003, 500, 28), 
( 57, 3991004, 500, 29), 
( 57, 3991005, 500, 30), 
( 57, 3991006, 500, 31), 
( 57, 3991007, 500, 32), 
( 57, 3991008, 500, 33), 
( 57, 3991009, 500, 34), 
( 57, 3991010, 500, 35), 
( 57, 3991011, 500, 36), 
( 57, 3991012, 500, 37), 
( 57, 3991013, 500, 38), 
( 57, 3991014, 500, 39), 
( 57, 3991015, 500, 40), 
( 57, 3991016, 500, 41), 
( 57, 3991017, 500, 42), 
( 57, 3991018, 500, 43), 
( 57, 3991019, 500, 44), 
( 57, 3991020, 500, 45), 
( 57, 3991021, 500, 46), 
( 57, 3991022, 500, 47), 
( 57, 3991023, 500, 48), 
( 57, 3991024, 500, 49), 
( 57, 3991025, 500, 50), 
( 57, 3991026, 500, 51), 
( 57, 3991027, 500, 52), 
( 57, 3991028, 500, 53), 
( 57, 3991029, 500, 54), 
( 57, 3991030, 500, 55), 
( 57, 3991031, 500, 56), 
( 57, 3991032, 500, 57), 
( 57, 3991033, 500, 58), 
( 57, 3991034, 500, 59), 
( 57, 3991035, 500, 60), 
( 57, 3991036, 500, 61), 
( 57, 3991037, 500, 62), 
( 57, 3991038, 500, 63), 
( 57, 3991039, 500, 64), 
( 57, 3991040, 500, 65), 
( 57, 3991041, 500, 66), 
( 57, 3991042, 500, 67), 
( 57, 3991043, 500, 68), 
( 57, 3991044, 500, 69), 
( 57, 3991045, 500, 70), 
( 57, 3991046, 500, 71), 
( 57, 3991047, 500, 72), 
( 57, 3991048, 500, 73), 
( 57, 3991049, 500, 74), 
( 57, 3991050, 500, 75), 
( 57, 3991051, 500, 76), 
( 57, 3992000, 500, 77), 
( 57, 3992001, 500, 78), 
( 57, 3992002, 500, 79), 
( 57, 3992003, 500, 80), 
( 57, 3992004, 500, 81), 
( 57, 3992005, 500, 82), 
( 57, 3992006, 500, 83), 
( 57, 3992007, 500, 84), 
( 57, 3992008, 500, 85), 
( 57, 3992009, 500, 86), 
( 57, 3992010, 500, 87), 
( 57, 3992011, 500, 88), 
( 57, 3992012, 500, 89), 
( 57, 3992013, 500, 90), 
( 57, 3992014, 500, 91), 
( 57, 3992015, 500, 92), 
( 57, 3992016, 500, 93), 
( 57, 3992017, 500, 94), 
( 57, 3992018, 500, 95), 
( 57, 3992019, 500, 96), 
( 57, 3992020, 500, 97), 
( 57, 3992021, 500, 98), 
( 57, 3992022, 500, 99), 
( 57, 3992023, 500, 100), 
( 57, 3992024, 500, 101), 
( 57, 3992025, 500, 102), 
( 57, 3992026, 500, 103), 
( 57, 3992027, 500, 104), 
( 57, 3992028, 500, 105), 
( 57, 3992029, 500, 106), 
( 57, 3992030, 500, 107), 
( 57, 3992031, 500, 108), 
( 57, 3992032, 500, 109), 
( 57, 3992033, 500, 110), 
( 57, 3992034, 500, 111), 
( 57, 3992035, 500, 112), 
( 57, 3992036, 500, 113), 
( 57, 3992037, 500, 114), 
( 57, 3992038, 500, 115),

-- missing shop data
(9270027, 2022213, 6800, 104),
(9270027, 2022212, 3200, 108),
(1052116, 2070000, 500, 104),
(1052116, 2022015, 12000, 108),
(1052116, 2061000, 1, 112),
(1052116, 2060000, 1, 116),
(1052116, 2030000, 400, 120),
(1052116, 2050003, 500, 124),
(1052116, 2050002, 300, 128),
(1052116, 2050001, 200, 132),
(1052116, 2050000, 200, 136),
(1052116, 2020028, 3000, 140),
(1052116, 2010004, 310, 144),
(1052116, 2010003, 100, 148),
(1052116, 2010001, 106, 152),
(1052116, 2010002, 50, 156),
(1052116, 2010000, 30, 160),
(1052116, 2001002, 4000, 164),
(1052116, 2001001, 2300, 168),
(1052116, 2001000, 3200, 172),
(1052116, 2022000, 1650, 176),
(1052116, 2022003, 1100, 180),
(1052116, 2002005, 500, 184),
(1052116, 2002004, 500, 188),
(1052116, 2002002, 500, 192),
(1052116, 2002001, 400, 196),
(1052116, 2002000, 500, 200),
(1052116, 2000006, 620, 204),
(1052116, 2000003, 200, 208),
(1052116, 2000002, 320, 212),
(1052116, 2000001, 160, 216),
(1052116, 2000000, 50, 220),
(9120002, 2061003, 40, 96),
(2030009, 2022001, 700, 100),
(1337, 1912005, 1, 35),
(1337, 1902005, 1, 36),
(1337, 1902006, 1, 37),
(1337, 1902007, 1, 38),
(1337, 1912011, 1, 39),
(1337, 1902015, 1, 40),
(1337, 1902016, 1, 41),
(1337, 1902017, 1, 42),
(1337, 1902018, 1, 43);

CREATE TABLE IF NOT EXISTS `skillmacros` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `characterid` int(11) NOT NULL DEFAULT '0',
  `position` tinyint(1) NOT NULL DEFAULT '0',
  `skill1` int(11) NOT NULL DEFAULT '0',
  `skill2` int(11) NOT NULL DEFAULT '0',
  `skill3` int(11) NOT NULL DEFAULT '0',
  `name` varchar(13) DEFAULT NULL,
  `shout` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `skills` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `skillid` int(11) NOT NULL DEFAULT '0',
  `characterid` int(11) NOT NULL DEFAULT '0',
  `skilllevel` int(11) NOT NULL DEFAULT '0',
  `masterlevel` int(11) NOT NULL DEFAULT '0',
  `expiration` bigint(20) NOT NULL DEFAULT '-1',
  PRIMARY KEY (`id`),
  UNIQUE INDEX `skillpair` (`skillid`, `characterid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `specialcashitems` (
  `id` int(11) NOT NULL,
  `sn` int(11) NOT NULL,
  `modifier` int(11) NOT NULL COMMENT '1024 is add/remove',
  `info` int(1) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

INSERT INTO `specialcashitems` (`id`, `sn`, `modifier`, `info`) VALUES
(1, 10000617, 1024, 1);

CREATE TABLE IF NOT EXISTS `storages` (
  `storageid` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `accountid` int(11) NOT NULL DEFAULT '0',
  `world` int(2) NOT NULL,
  `slots` int(11) NOT NULL DEFAULT '0',
  `meso` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`storageid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `trocklocations` (
  `trockid` int(11) NOT NULL AUTO_INCREMENT,
  `characterid` int(11) NOT NULL,
  `mapid` int(11) NOT NULL,
  `vip` int(2) NOT NULL,
  PRIMARY KEY (`trockid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `wishlists` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `charid` int(11) NOT NULL,
  `sn` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `worldtransfers` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `characterid` int(11) NOT NULL,
  `from` tinyint(3) NOT NULL,
  `to` tinyint(3) NOT NULL,
  `requestTime` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `completionTime` timestamp NULL,
  PRIMARY KEY (`id`),
  INDEX (characterid)
) ENGINE=InnoDB  DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `characterexplogs` (
    `id` BIGINT NOT NULL AUTO_INCREMENT,
  	`world_exp_rate` INT,
    `exp_coupon` INT,
    `gained_exp` BIGINT,
    `current_exp` INT,
    `exp_gain_time` DATETIME,
    `charid` int(11) NOT NULL,
    PRIMARY KEY (`id`),
    FOREIGN KEY (`charid`) REFERENCES `characters`(`id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

ALTER TABLE `dueyitems`
  ADD CONSTRAINT `dueyitems_ibfk_1` FOREIGN KEY (`PackageId`) REFERENCES `dueypackages` (`PackageId`) ON DELETE CASCADE;

ALTER TABLE `famelog`
  ADD CONSTRAINT `famelog_ibfk_1` FOREIGN KEY (`characterid`) REFERENCES `characters` (`id`) ON DELETE CASCADE;
  
ALTER TABLE `family_character`
  ADD CONSTRAINT `family_character_ibfk_1` FOREIGN KEY (`cid`) REFERENCES `characters` (`id`) ON DELETE CASCADE;

ALTER TABLE `skills`
  ADD CONSTRAINT `skills_chrid_fk` FOREIGN KEY (`characterid`) REFERENCES `characters` (`id`) ON DELETE CASCADE;	# thanks Shavit

/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;